The library librsla generated in this directory supplies two bessel function
routines to replace the imsl routines: mmbskr, mmbsir. The routines start
with a set of files from the NTCC module library r8slatec. The routines from
r8slatec have endings in .F and .c. These routines are converted to .f90
routines by a Python program cvt.py which is driven by a script convert.
This conversion removes the portlib dependences and c dependences and uses
the f90 kind feature to specify the precision. This creates a much smaller
library to handle and removes the compiler restrictions that r8slatec
imposes. This directory also builds an executable which tests the range of
bessel function calls found in curray.
jcw 10/4/01

      program rfdrive
c----- Driver routine for running the CURRAY ray tracing code
c      Created by TK Mau on 08/01/2002
c
      use kind_spec
      implicit none
c
      integer, parameter :: nbwg = 24
      integer, parameter :: npdim = 10000
      integer, parameter :: nspectm = 11
      integer, parameter :: nspect1 = 21
      integer, parameter :: nspray = 3
      integer, parameter :: ntheta = 15
      integer, parameter :: nions = 6
      integer, parameter :: nxa = 38
      integer, parameter :: nza = 55
      integer, parameter :: nprofm = 131
      integer, parameter :: nfion = 10
c
      character(8) :: dat
      character(40) :: ntitle
      integer :: nin
c     real(kind=dp) smallest, largest
c
      integer :: nspec,mainsp,nprofs,ioread,idcur,
     1   iprint,igraph,nprim,nimp,nminor,kboot,nalfa,kalfa
      real(kind=dp) :: psistep,pkexpnt
      real(kind=dp):: denc,tempec,gamene,alpene,gamte,alpte,gamti,
     1   alpti,denedg,temedg,alpene1,alpte1,frcte,frcne,frcti,
     2   gamte1,gamene1
      real(kind=dp) :: epserr,epser1
      real(kind=dp),dimension(nions) :: atm,azi,tite,aconc
      real(kind=dp),dimension(nfion) :: atmf,azf,ebkev
      real(kind=dp),dimension(nprofm) :: pwe
      real(kind=dp),dimension(nprofm,nions) :: pwi
c
      integer:: isimm,nspect,nraypts,nthin,maxref,igrill,islofa,
     1   irayio,indvar,idrive,ichois,modcd,idmpsw,inc,
     2   icurdr,bmax
      integer,dimension(nspect1) :: nnkpar
      integer,dimension(nspectm) :: nnkpol
      real(kind=dp) freqcy,psi0,heigth,ptot0
      real(kind=dp),dimension(nspect1) :: anzsup,anzinf
      real(kind=dp),dimension(nspectm) :: anpsup,anpinf
      real(kind=dp),dimension(nspect1) :: powers
      real(kind=dp),dimension(nspectm) :: thgril
c
      integer :: ipestg, nxeqd, nzeqd
      real(kind=dp) :: xdimeqd, zdimeqd, reqd, redeqd, zmideqd, xma,
     1   zma, psimag,psilim, beqd, toteqd, psimx1, psimx2, xax1, xax2, 
     2   zax1, zax2,psisep, xsep, zsep
      real(kind=dp), dimension(nxa) :: feqd, presseqd, ffpeqd, ppeqd,
     1   qeqd
      real(kind=dp), dimension(nxa,nza) :: peqd
c
      external curray
c
      data nin/5/
c
      namelist /input/nprofs, psistep, pkexpnt, igraph, iprint, nspec, 
     1   epserr, epser1, idcur, nprim, nimp, nminor,
     2   atm, azi, aconc, denc, tempec, tite, denedg, frcne, gamene,
     3   alpene, gamene1, alpene1, temedg, frcte, gamte, alpte, gamte1,
     4   alpte1, atmf, azf, ebkev, kboot, nalfa, kalfa, ioread,
     5   isimm, nspect, nraypts, psi0, thgril, nthin,
     6   maxref, islofa, ptot0, freqcy, heigth, indvar, powers, nnkpar,
     7   anzinf, anzsup, nnkpol, anpsup, anpinf, idrive, ichois, modcd,
     8   igrill, bmax, idmpsw, irayio, inc, icurdr
c
c---- Read slected plasma parameters, profile info, run control
c     parameters, and wave input and physics parameters.
c
      open (nin, file='curray_in', status='old')
      read (nin,input)
      close(nin)
c
c-----Read  profile (density and temperature) and voltage data 
C     file written by trxpl.
       open(2,file='test.out')

       read(2,*) lrho   ! 'Number of grid points= ',lrho
       read(2,*) nspec  ! 'Number of species= ',nspec
c       read(2,*) 'rho= '
       read(2,'(5(1X,E19.12))')(rho(ik),ik=1,lrho)
       do ik=1,nspec
        read(2,*)' '
        read(2,*) slbl(ik)
c        read(2,'(a,i10)')'type= ',itype(ik)
        read(2,'(i10)') itype(ik)  ! type
c        read(2,'(a,f19.12)')'Z8= ',Zr8(ik)
        read(2,'(f19.12)') Zr8(ik) ! Zr8
c        read(2,'(a,f19.12)')'A8= ',Ar8(ik)
        read(2,'(f19.12)') Ar8(ik) ! Ar8
c        read(2,'(a,i10)')'Izc= ',Izc(ik)
        read(2,'(i10)') Izc(ik)    ! Izc
        read(2,*)' '
        read(2,'(5(1X,E19.12))')(zvaln(il,ik),il=1,lrho)
        read(2,*)' '
        read(2,'(5(1X,E19.12))')(zvalt(il,ik),il=1,lrho)
       enddo

       read(2,*) ' '
c       read(2,*) 'Voltage profile= '
       read(2,'(5(1X,E19.12))')(zvalv(ik),ik=1,lrho)

       close(2)

c---- Read Input equilibrium data in EFIT/GEQDSK format
c
      open (nin, file='eqdsk.hb', status='old')
      read (nin, 8190) ntitle, dat, ipestg, nxeqd, nzeqd
      if (nxeqd/=nxa .or. nzeqd/=nza) then
c        write (6, 8180) nxeqd, nzeqd
         print *, 'nxa,nza must be adjusted to eqdsk dimensions:',
     &      nxeqd,nzeqd 
         stop 40
      endif
      read (nin, 8200) xdimeqd, zdimeqd, reqd, redeqd, zmideqd
      read (nin, 8200) xma, zma, psimag, psilim, beqd
      read (nin, 8200) toteqd, psimx1, psimx2, xax1, xax2
      read (nin, 8200) zax1, zax2, psisep, xsep, zsep
      read (nin, 8200) feqd(:nxeqd)
      read (nin, 8200) presseqd(:nxeqd)
      read (nin, 8200) ffpeqd(:nxeqd)
      read (nin, 8200) ppeqd(:nxeqd)
      read (nin, 8200) peqd(:nxeqd,:nzeqd)
      read (nin, 8200, err=8280, end=8280) qeqd(:nxeqd)
 8190 format(a40,a8,3i4)
 8200 format(5e16.9)
      go to 8300
 8280 print *, 'error or no q-profile in eqdsk file'
      stop 41
 8300 continue
      close(nin)
c
c----- Call subroutine 'curray' to initiate and run ray tracing
c
      call curray (nprofs, nxeqd, nzeqd, psistep, pkexpnt, igraph,
     1   iprint, nspec, epserr, epser1, idcur, nprim, nimp, nminor,
     2   atm, azi, aconc, denc, tempec, tite, denedg, frcne, gamene,
     3   alpene, gamene1, alpene1, temedg, frcte, gamte, alpte, 
     4   gamte1, alpte1, atmf, azf, ebkev, kboot, nalfa, kalfa, 
     5   ioread, isimm, nspect, nraypts, psi0, thgril, nthin,
     6   maxref, islofa, ptot0, freqcy, heigth, indvar, powers, nnkpar,
     7   anzinf, anzsup, nnkpol, anpsup, anpinf, idrive, ichois, modcd,
     8   igrill, bmax, idmpsw, irayio, inc, icurdr, xdimeqd, zdimeqd, 
     9   reqd, redeqd, zmideqd, xma, zma, psimag, psilim, beqd, 
     &   toteqd, psimx1, psimx2, xax1, xax2, zax1, zax2, psisep, 
     1   xsep, zsep, feqd, presseqd, ffpeqd, ppeqd, qeqd, peqd)
c
      stop
      end program rfdrive

c-----------------------------------
c file: icsevu.f
c
c purpose: replaces imsl routine by same name
c
c------------------------------------
      subroutine icsevu(x, y, nold, c, kjx, xnew, ynew, nnew, ier)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nold, kjx, nnew, ier
      real(kind=dp), dimension(nold) :: x, y
      real(kind=dp), dimension(kjx,3) :: c
      real(kind=dp), dimension(nnew) :: xnew, ynew
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: k, i, jer, ker
      real(kind=dp) :: d
C-----------------------------------------------
      do k = 1, nnew
         call bcspefnd (x, nold, xnew(k), i)
         d = xnew(k) - x(i)
         ynew(k) = ((c(i,3)*d+c(i,2))*d+c(i,1))*d + y(i)
         if (xnew(k) < x(1)) jer = 33
         if (xnew(k) > x(nold)) ker = 34
      end do
      ier = max0(jer,ker)
c     if (jer > 0) call uertst (jer, 6Hicsevu)
c     if (ker > 0) call uertst (ker, 6Hicsevu)
      return 
      end subroutine icsevu

       FUNCTION DBESK0 (X)
C***BEGIN PROLOGUE  DBESK0
C***PURPOSE  Compute the modified (hyperbolic) Bessel function of the
C            third kind of order zero.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C10B1
C***TYPE      real(kind=dp) (BESK0-S, DBESK0-D)
C***KEYWORDS  FNLIB, HYPERBOLIC BESSEL FUNCTION,
C             MODIFIED BESSEL FUNCTION, ORDER ZERO, SPECIAL FUNCTIONS,
C             THIRD KIND
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DBESK0(X) calculates the double precision modified (hyperbolic)
C Bessel function of the third kind of order zero for double
C precision argument X.  The argument must be greater than zero
C but not so large that the result underflows.
C
C Series for BK0        on the interval  0.          to  4.00000E+00
C                                        with weighted error   3.08E-33
C                                         log weighted error  32.51
C                               significant figures required  32.05
C                                    decimal places required  33.11
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, DBESI0, DBSK0E, DCSEVL, INITDS, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C***END PROLOGUE  DBESK0
C============
C idecl:  explicitize implicit INTEGER declarations:
      use kind_spec

      IMPLICIT NONE
      INTEGER ntk0,initds
C============
      real(kind=dp) DBESK0
      real(kind=dp) X, BK0CS(16), XMAX, XMAXT, XSML, Y,
     1  D1MACH, DCSEVL, DBESI0, DBSK0E
      LOGICAL FIRST
      SAVE BK0CS, NTK0, XSML, XMAX, FIRST
      DATA BK0CS(  1) / -.353273932339027687201140060063153E-1_dp/

      DATA BK0CS(  2) / +.344289899924628486886344927529213E+0_dp/

      DATA BK0CS(  3) / +.359799365153615016265721303687231E-1_dp/

      DATA BK0CS(  4) / +.126461541144692592338479508673447E-2_dp/

      DATA BK0CS(  5) / +.228621210311945178608269830297585E-4_dp/

      DATA BK0CS(  6) / +.253479107902614945730790013428354E-6_dp/

      DATA BK0CS(  7) / +.190451637722020885897214059381366E-8_dp/

      DATA BK0CS(  8) / +.103496952576336245851008317853089E-10_dp/

      DATA BK0CS(  9) / +.425981614279108257652445327170133E-13_dp/

      DATA BK0CS( 10) / +.137446543588075089694238325440000E-15_dp/

      DATA BK0CS( 11) / +.357089652850837359099688597333333E-18_dp/

      DATA BK0CS( 12) / +.763164366011643737667498666666666E-21_dp/

      DATA BK0CS( 13) / +.136542498844078185908053333333333E-23_dp/

      DATA BK0CS( 14) / +.207527526690666808319999999999999E-26_dp/

      DATA BK0CS( 15) / +.271281421807298560000000000000000E-29_dp/

      DATA BK0CS( 16) / +.308259388791466666666666666666666E-32_dp/

      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DBESK0
      IF (FIRST) THEN
         NTK0 = INITDS (BK0CS, 16, 0.1E0_dp*(d1mach3))

         XSML = SQRT(4.0E0_dp*d1mach3)

         XMAXT = -LOG(d1mach1)
         XMAX = XMAXT -
     +      0.5E0_dp*XMAXT*LOG(XMAXT)/(XMAXT+0.5E0_dp)

      ENDIF
      FIRST = .FALSE.
C
      IF (X .LE. 0.E0_dp) CALL XERMSG ('SLATEC', 'DBESK0',

     +   'X IS ZERO OR NEGATIVE', 2, 2)
      IF (X.GT.2.0E0_dp) GO TO 20

C
      Y = 0.E0_dp

      IF (X.GT.XSML) Y = X*X
      DBESK0 = -LOG(0.5E0_dp*X)*DBESI0(X) -

     1   0.25E0_dp+ DCSEVL (.5E0_dp*Y-1.E0_dp,

     1   BK0CS, NTK0)
      RETURN
C
 20   DBESK0 = 0.E0_dp

      IF (X .GT. XMAX) CALL XERMSG ('SLATEC', 'DBESK0',
     +   'X SO BIG K0 UNDERFLOWS', 1, 1)
      IF (X.GT.XMAX) RETURN
C
      DBESK0 = EXP(-X) * DBSK0E(X)
C
      RETURN
      END
! 22Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 22Jun2000 fgtok
! 22Jun2000 fgtok
! 22Jun2000 fgtok

#include "fpreproc/library_names.h"
#include "fpreproc/fp_const.h"
*DECK DGAMLM
      SUBROUTINE DGAMLM (XMIN, XMAX)
C***BEGIN PROLOGUE  DGAMLM
C***PURPOSE  Compute the minimum and maximum bounds for the argument in
C            the Gamma function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A, R2
C***TYPE      REAL*8 (GAMLIM-S, DGAMLM-D)
C***KEYWORDS  COMPLETE GAMMA FUNCTION, FNLIB, LIMITS, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C Calculate the minimum and maximum legal bounds for X in gamma(X).
C XMIN and XMAX are not the only bounds, but they are the only non-
C trivial ones to calculate.
C
C             Output Arguments --
C XMIN   double precision minimum legal value of X in gamma(X).  Any
C        smaller value of X might result in underflow.
C XMAX   double precision maximum legal value of X in gamma(X).  Any
C        larger value of X might cause overflow.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C***END PROLOGUE  DGAMLM
C============
C idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER i
C============
      REAL*8 XMIN, XMAX, ALNBIG, ALNSML, XLN, XOLD, D1MACH
C***FIRST EXECUTABLE STATEMENT  DGAMLM
      ALNSML = LOG(D1MACH(1))
      XMIN = -ALNSML
      DO 10 I=1,10
        XOLD = XMIN
        XLN = LOG(XMIN)
        XMIN = XMIN - XMIN*((XMIN+CONST(0.5,0))*XLN -
     1     XMIN - CONST(0.2258,0)+ ALNSML)
     1     / (XMIN*XLN+CONST(0.5,0))
        IF (ABS(XMIN-XOLD).LT.CONST(0.005,0)) GO TO 20
 10   CONTINUE
      CALL XERMSG ('SLATEC', 'DGAMLM', 'UNABLE TO FIND XMIN', 1, 2)
C
 20   XMIN = -XMIN + CONST(0.01,0)
C
      ALNBIG = LOG (D1MACH(2))
      XMAX = ALNBIG
      DO 30 I=1,10
        XOLD = XMAX
        XLN = LOG(XMAX)
        XMAX = XMAX - XMAX*((XMAX-CONST(0.5,0))*XLN -
     1     XMAX + CONST(0.9189,0)- ALNBIG)
     1     / (XMAX*XLN-CONST(0.5,0))
        IF (ABS(XMAX-XOLD).LT.CONST(0.005,0)) GO TO 40
 30   CONTINUE
      CALL XERMSG ('SLATEC', 'DGAMLM', 'UNABLE TO FIND XMAX', 2, 2)
C
 40   XMAX = XMAX - CONST(0.01,0)
      XMIN = MAX (XMIN, -XMAX+CONST(1.,0))
C
      RETURN
      END
! 22Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 22Jun2000 fgtok
! 22Jun2000 fgtok

      subroutine uertst(ierr, isub)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer ierr
      character isub*(*)
C-----------------------------------------------
 
      write (*, 6000) ierr, isub
 6000 format(1x,'*** Terminal error',i4,' occurred in routine ',a)
      return 
      end subroutine uertst

C   IMSL ROUTINE NAME   - MMBSIR
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/DOUBLE
C
C   LATEST REVISION     - JULY 1, 1983
C
C   PURPOSE             - MODIFIED BESSEL FUNCTION OF THE FIRST KIND
C                           OF NONNEGATIVE REAL ORDER FOR REAL POSITIVE
C                           ARGUMENTS WITH EXPONENTIAL SCALING OPTION
C
C   USAGE               - CALL MMBSIR (ARG,ORDER,N,IOPT,B,IER)
C
C   ARGUMENTS    ARG    - INPUT ARGUMENT. ARG MUST BE TYPED APPRO-
C                           PRIATELY IN THE CALLING PROGRAM. (SEE THE
C                           PRECISION/HARDWARE SECTION.) ARG MUST BE
C                           GREATER THAN OR EQUAL TO ZERO. IF SCALING
C                           IS NOT DESIRED (IOPT = 1), THEN ARG MUST BE
C                           LESS THAN EXPARG. EXPARG IS APPROXIMATELY
C                           THE LARGEST ACCEPTABLE ARGUMENT FOR THE
C                           FORTRAN EXP FUNCTION. SEE THE PROGRAMMING
C                           NOTES IN THE MANUAL FOR THE EXACT VALUE OF
C                           EXPARG.
C                ORDER  - INPUT VALUE SPECIFYING THE DESIRED ORDER OF
C                           THE BESSEL FUNCTION. ORDER MUST BE TYPED
C                           APPROPRIATELY IN THE CALLING PROGRAM. (SEE
C                           THE PRECISION/HARDWARE SECTION.) ORDER MUST
C                           BE GREATER THAN OR EQUAL TO ZERO AND LESS
C                           THAN ONE.
C                N      - INPUT PARAMETER SPECIFYING THE NUMBER OF
C                           FUNCTION VALUES TO BE COMPUTED.
C                IOPT   - INPUT SCALING OPTION SWITCH.
C                           IF IOPT = 1 THEN THE BESSEL FUNCTIONS
C                           CALCULATED ARE UNSCALED.
C                           IF IOPT = 2 THEN THE BESSEL FUNCTIONS
C                           CALCULATED ARE SCALED BY EXP(-ARG).
C                B      - OUTPUT VECTOR OF LENGTH N CONTAINING THE
C                           COMPUTED FUNCTION VALUES. B MUST BE TYPED
C                           APPROPRIATELY IN THE CALLING PROGRAM. (SEE
C                           THE PRECISION/HARDWARE SECTION.) B(1) WILL
C                           CONTAIN THE COMPUTED VALUE FOR THE INPUT
C                           ORDER, B(2) WILL CONTAIN THE COMPUTED
C                           FUNCTION VALUE FOR ORDER + 1, B(3) FOR
C                           ORDER + 2, ETC.
C                IER    - ERROR PARAMETER. (OUTPUT)
C                         TERMINAL ERROR
C                           IER = 129 INDICATES THAT ONE OR MORE OF
C                             THE INPUT ARGUMENTS, ARG, ORDER, N,
C                             OR IOPT, IS OUT OF RANGE. B(I), (I=1,N)
C                             IS SET TO MACHINE INFINITY.
C                           IER = 129+J INDICATES THAT N WAS SO MUCH
C                             GREATER THAN THE LARGEST INTEGER IN ARG
C                             THAT ONLY B(I), (I=1,J) WAS CALCULATED
C                             CORRECTLY. SEE THE PROGRAMMING NOTES
C                             FOR THE ACCURACY OF THE REMAINING B(I).
C
C   PRECISION/HARDWARE  - DOUBLE/H32,H36
C                       - SINGLE/H48,H60
C
C   REQD. IMSL ROUTINES - H32,H36/MGAMAD=DGAMMA,UERTST,UGETIO
C                         H48,H60/MGAMA=GAMMA,UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MMBSIR (ARG,ORDER,N,IOPT,B,IER)
C                                  SPECIFICATIONS FOR ARGUMENTS
      INTEGER            N,IOPT,IER
      DOUBLE PRECISION   ARG,ORDER,B(1)
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      INTEGER            IDUM,NSIG,ISUM,MAGX,NCALC,NBMX,ISTEP
      INTEGER            NEND,NSTART,NN,L,I,INTEN
      DOUBLE PRECISION   P,TEST,TEMPA,TEMPB,TEMPC,EXPARG,SUM,TOVER
      DOUBLE PRECISION   PLAST,POLD,PSAVE,PSAVEL,ENTEN,ENSIG,RTNSIG
      DOUBLE PRECISION   EN,EM,EMPAL,EMP2AL,ENMTEN,STEP,STEP2,XLARGE
      DOUBLE PRECISION   HALFX,ZSIG,SMALL,XINF,XNTEN
      DOUBLE PRECISION   DGAMMA
      DATA               SMALL/2.938735878D-39/
      DATA               XLARGE /1.D+04/
      DATA               XINF/1.700000000D+38/
      DATA               ZSIG/ 16.8D0/
      DATA               EXPARG/ 88.0/
      DATA               XNTEN/ 38.D0/
C                                  FIRST EXECUTABLE STATEMENT
      NSIG = IFIX(SNGL(ZSIG))
      ISUM = -NSIG/4
      RTNSIG = 10.D0**ISUM
      IER = 0
      INTEN = XNTEN
      ENTEN = 10.D0**INTEN
      ENSIG = 10.0D0**NSIG
      ENMTEN = 4.D0*SMALL
      TEMPA = ARG
C                                  CHECK ARGUMENT RANGE
      IF((N.GT.0) .AND. (ARG.GE.0.D0).AND.(((IOPT.EQ.1) .AND.
     *  (ARG.LE.EXPARG)) .OR. ((IOPT.EQ.2) .AND. (ARG.LE.XLARGE))) .AND.
     *  (ORDER.GE.0.D0) .AND. (ORDER.LT.1.D0)) GO TO 10
      IER = 129
      NN = N
      IF(N.LE.0) NN = 1
      DO 5  I=1,NN
         B(I) = XINF
    5 CONTINUE
      GO TO 9000
C                                  USE 2-TERM ASCENDING SERIES FOR
C                                    SMALL ARG
   10 MAGX = IFIX(SNGL(TEMPA))
      NCALC = N
      IF(TEMPA.LT.RTNSIG) GO TO 115
C                                  INITIALIZE THE CALCULATION OF P*S
      NBMX = N-MAGX
      NN = MAGX+1
      ISTEP = NN + NN
      STEP = ORDER + ORDER
      EN = DBLE(FLOAT(ISTEP)) + STEP
      PLAST = 1.D0
      P = EN/TEMPA
C                                  CALCULATE GENERAL SIGNIFICANCE TEST
      TEST = ENSIG + ENSIG
      STEP = TEST * P
      IF(2*MAGX .GT. 5*NSIG) TEST = DSQRT(STEP)
      IF(2*MAGX .LE. 5*NSIG) TEST = TEST/1.585D0**MAGX
      IF(NBMX .LT. 3) GO TO 20
C                                  CALCULATE P*S UNTIL NN = N-1.
C                                    CHECK FOR POSSIBLE OVERFLOW.
      TOVER = ENTEN/ENSIG
      NSTART = MAGX + 2
      NEND = N - 1
      ISTEP = NSTART + NSTART
      STEP = ORDER + ORDER
      EN = DBLE(FLOAT(ISTEP)) - 2.D0+STEP
      DO 15  NN=NSTART,NEND
         EN = EN + 2.D0
         POLD = PLAST
         PLAST = P
         P = EN*PLAST/TEMPA+POLD
         IF(P .GT. TOVER) GO TO 25
   15 CONTINUE
      NN = NEND
      ISTEP = NN + NN
      STEP = ORDER + ORDER
      EN = DBLE(FLOAT(ISTEP)) + STEP
C                                  CALCULATE SPECIAL SIGNIFICANCE
C                                    TEST FOR NBMX .GT. 2.
      STEP = PLAST * ENSIG
      STEP2 = P + P
      STEP = DSQRT(STEP) * DSQRT(STEP2)
      TEST = DMAX1(TEST,STEP)
C                                  CALCULATE P*S UNTIL SIGNIFICANCE
C                                    TEST PASSES
   20 NN = NN + 1
      EN = EN + 2.D0
      POLD = PLAST
      PLAST = P
      P = EN*PLAST/TEMPA+POLD
      IF(P.LT.TEST) GO TO 20
      GO TO 45
C                                  TO AVOID OVERFLOW, DIVIDE P*S BY
C                                    TOVER. CALCULATE P*S UNTIL
C                                    ABS(P).GT.1.
   25 TOVER = ENTEN
      P = P/TOVER
      PLAST = PLAST/TOVER
      PSAVE = P
      PSAVEL = PLAST
      NSTART = NN + 1
   30 NN = NN + 1
      EN = EN + 2.D0
      POLD = PLAST
      PLAST = P
      P = EN*PLAST/TEMPA+POLD
      IF(P .LE. 1.D0) GO TO 30
      TEMPB = EN/TEMPA
C                                  CALCULATE BACKWARD TEST, AND FIND
C                                    NCALC, THE HIGHEST N SUCH THAT
C                                    THE TEST IS PASSED.
      TEST = POLD*PLAST*(.5D0-.5D0/(TEMPB*TEMPB))/ENSIG
      P = PLAST * TOVER
      NN = NN - 1
      EN = EN - 2.D0
      NEND = MIN0(N,NN)
      DO 35  NCALC=NSTART,NEND
         POLD = PSAVEL
         PSAVEL = PSAVE
         PSAVE = EN*PSAVEL/TEMPA+POLD
         IF(PSAVE*PSAVEL .GT. TEST) GO TO 40
   35 CONTINUE
      NCALC = NEND + 1
   40 NCALC = NCALC - 1
C                                  INITIALIZE THE BACKWARD RECURSION
C                                    AND THE NORMALIZATION SUM
   45 NN = NN + 1
      EN = EN + 2.D0
      TEMPB = 0.D0
      TEMPA = 1.D0/P
      EM = DBLE(FLOAT(NN)) - 1.D0
      EMPAL = EM + ORDER
      EMP2AL = (EM-1.D0) + (ORDER+ORDER)
      SUM = TEMPA*EMPAL*EMP2AL/EM
      NEND = NN - N
      IF(NEND) 70, 60, 50
C                                  RECUR BACKWARD VIA DIFFERENCE
C                                    EQUATION, CALCULATING (BUT
C                                    NOT STORING) B(N), UNTIL NN = N.
   50 DO 55  L=1,NEND
         NN = NN - 1
         EN = EN - 2.D0
         TEMPC = TEMPB
         TEMPB = TEMPA
         TEMPA = (EN*TEMPB)/ARG+TEMPC
         EM = EM - 1.D0
         EMP2AL = EMP2AL - 1.D0
         IF(NN .EQ. 1) GO TO 60
         IF(NN .EQ. 2) EMP2AL = 1.D0
         EMPAL = EMPAL - 1.D0
         SUM = (SUM+TEMPA*EMPAL)*EMP2AL/EM
   55 CONTINUE
C                                  STORE B(N)
   60 B(NN) = TEMPA
      IF(N .GT. 1) GO TO 65
      SUM = (SUM+SUM) + TEMPA
      GO TO 100
C                                  CALCULATE AND STORE B(N-1)
   65 NN = NN - 1
      EN = EN - 2.D0
      B(NN) = (EN*TEMPA)/ARG+TEMPB
      IF(NN .EQ. 1) GO TO 95
      EM = EM - 1.D0
      EMP2AL = EMP2AL - 1.D0
      IF(NN .EQ. 2) EMP2AL = 1.D0
      EMPAL = EMPAL - 1.D0
      SUM = (SUM+B(NN)*EMPAL)*EMP2AL/EM
      GO TO 80
C                                  NN.LT.N, SO STORE B(NN) AND SET
C                                    HIGHER ORDERS TO ZERO
   70 B(NN) = TEMPA
      NEND = -NEND
      DO 75  L=1,NEND
         B(NN+L) = 0.D0
   75 CONTINUE
   80 NEND = NN - 2
      IF(NEND .EQ. 0) GO TO 90
C                                  CALCULATE VIA DIFFERENCE EQUATION
C                                    AND STORE B(NN), UNTIL NN = 2
      DO 85  L=1,NEND
         NN = NN - 1
         EN = EN - 2.D0
         B(NN) = (EN*B(NN+1))/ARG+B(NN+2)
         EM = EM - 1.D0
         EMP2AL = EMP2AL - 1.D0
         IF(NN .EQ. 2) EMP2AL = 1.D0
         EMPAL = EMPAL - 1.D0
         SUM = (SUM+B(NN)*EMPAL)*EMP2AL/EM
   85 CONTINUE
C                                  CALCULATE B(1)
   90 B(1) = 2.D0*EMPAL*B(2)/ARG+B(3)
   95 SUM = (SUM+SUM) + B(1)
C                                  NORMALIZE. DIVIDE ALL B(NN) BY SUM
  100 IF(ORDER .EQ. 0.D0) GO TO 105
      STEP = 1.D0 + ORDER
      SUM = SUM*DGAMMA(STEP)*(ARG*.5D0)**(-ORDER)
  105 STEP = -ARG
!      IF(IOPT .EQ. 1) SUM = SUM*DEXP(STEP)
      IF(IOPT .EQ. 1) SUM = SUM*EXP(STEP)
      TEMPA = ENMTEN
      IF(SUM .GT. 1.D0) TEMPA = TEMPA*SUM
      DO 110  NN=1,N
         IF(B(NN) .LT. TEMPA) B(NN) = 0.D0
         B(NN) = B(NN)/SUM
  110 CONTINUE
      GO TO 135
C                                  TWO-TERM ASCENDING SERIES FOR SMALL A
  115 TEMPA = 1.D0
      EMPAL = 1.D0 + ORDER
      HALFX = 0.D0
      IF(ARG .GT. ENMTEN) HALFX = .5D0*ARG
      IF(ORDER .NE. 0.D0) TEMPA = HALFX**ORDER/DGAMMA(EMPAL)
      STEP = -ARG
!      IF(IOPT .EQ. 2) TEMPA = TEMPA*DEXP(STEP)
      IF(IOPT .EQ. 2) TEMPA = TEMPA*EXP(STEP)
      TEMPB = 0.D0
      IF((ARG+1.D0) .GT. 1.D0) TEMPB = HALFX*HALFX
      B(1) = TEMPA+TEMPA*TEMPB/EMPAL
      IF((ARG .NE. 0.D0) .AND. (B(1) .EQ. 0.D0)) NCALC = 0
      IF(N .EQ. 1) GO TO 135
      IF(ARG .GT. 0.D0) GO TO 125
      DO 120  NN=2,N
         B(NN) = 0.D0
  120 CONTINUE
      GO TO 9005
  125 TEMPC = HALFX
      TOVER = (ENMTEN+ENMTEN)/ARG
      IF(TEMPB .NE. 0.D0) TOVER = ENMTEN/TEMPB
      DO 130  NN=2,N
         TEMPA = TEMPA/EMPAL
         EMPAL = EMPAL + 1.D0
         TEMPA = TEMPA * TEMPC
         IF(TEMPA .LE. TOVER*EMPAL) TEMPA = 0.D0
         B(NN) = TEMPA+TEMPA*TEMPB/EMPAL
         IF((B(NN) .EQ. 0.D0) .AND. (NCALC .GT. NN)) NCALC = NN-1
  130 CONTINUE
  135 IF(NCALC .EQ. N) GO TO 9005
      IER = 129 + NCALC
 9000 CONTINUE
      CALL UERTST(IER,'MMBSIR')
 9005 RETURN
      END

C   IMSL ROUTINE NAME   - MGAMAD=DGAMMA
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/DOUBLE
C
C   LATEST REVISION     - NOVEMBER 1, 1984
C
C   PURPOSE             - EVALUATE THE GAMMA FUNCTION OF A DOUBLE
C                           PRECISION ARGUMENT
C
C   USAGE               - RESULT = DGAMMA(X)
C
C   ARGUMENTS    X      - INPUT DOUBLE PRECISION ARGUMENT.
C                           DGAMMA IS SET TO MACHINE INFINITY, WITH THE
C                           PROPER SIGN, WHENEVER
C                             X IS ZERO,
C                             X IS A NEGATIVE INTEGER,
C                             ABS(X) .LE. XMIN, OR
C                             ABS(X) .GE. XMAX.
C                             XMIN IS OF THE ORDER OF 10**(-39) AND
C                             XMAX IS AT LEAST 34.8. THE EXACT VALUES
C                             OF XMIN AND XMAX MAY ALLOW LARGER RANGES
C                             FOR X ON SOME COMPUTERS.
C                             SEE THE PROGRAMMING NOTES IN THE MANUAL
C                             FOR THE EXACT VALUES.
C                DGAMMA - OUTPUT DOUBLE PRECISION VALUE OF THE GAMMA
C                           FUNCTION. DGAMMA MUST BE TYPED DOUBLE
C                           PRECISION IN THE CALLING PROGRAM.
C
C   PRECISION/HARDWARE  - DOUBLE/H32,H36
C                       - NOT AVAILABLE/H48,H60
C                         NOTE - DGAMMA MAY NOT BE SUPPLIED BY IMSL IF
C                           IT RESIDES IN THE MATHEMATICAL SUBPROGRAM
C                           LIBRARY SUPPLIED BY THE MANUFACTURER.
C
C   REQD. IMSL ROUTINES - UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   REMARKS      AN ERROR MESSAGE PRINTED BY UERTST FROM DGAMMA SHOULD
C                BE INTERPRETED AS FOLLOWS
C                IER    - ERROR INDICATOR
C                         TERMINAL ERROR
C                           IER = 129 INDICATES THAT THE ABSOLUTE VALUE
C                             OF THE INPUT ARGUMENT X IS SPECIFIED
C                             GREATER THAN OR EQUAL TO XMAX. DGAMMA
C                             IS SET TO MACHINE INFINITY.
C                           IER = 130 INDICATES THAT THE INPUT ARGUMENT
C                             X IS SPECIFIED AS ZERO OR A NEGATIVE
C                             INTEGER OR THAT THE ABSOLUTE VALUE OF THE
C                             INPUT ARGUMENT IS LESS THAN OR EQUAL TO
C                             XMIN. DGAMMA IS SET TO MACHINE INFINITY
C                             WITH THE PROPER SIGN FOR THE DGAMMA
C                             FUNCTION. IF X IS ZERO OR AN EVEN
C                             NEGATIVE INTEGER, GAMMA HAS A NEGATIVE
C                             SIGN. OTHERWISE IT HAS A POSITIVE SIGN.
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      FUNCTION DGAMMA (X)
C                                  SPECIFICATIONS FOR ARGUMENTS
      DOUBLE PRECISION   X,DGAMMA
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      DOUBLE PRECISION   P(9),Q(8),P4(7)
      DOUBLE PRECISION   A,B,DEN,PI,T,TOP,BIG1,
     1                   XINF,XMIN,Y,SIGN,R
      INTEGER            I,IER,J
      LOGICAL            MFLAG
C                                  COEFFICIENTS FOR MINIMAX
C                                  APPROXIMATION TO GAMMA(X),
C                                  2.0 .LE. X .LE. 3.0
      DATA               P(1)/-5.966047488753637D01/,
     *                   P(2)/5.864023793062003D01/,
     *                   P(3)/-1.364106217165365D03/,
     *                   P(4)/-8.117569271425580D02/,
     *                   P(5)/-1.569414683149179D04/,
     *                   P(6)/-1.525979925758372D04/,
     *                   P(7)/-7.264059615964330D04/,
     *                   P(8)/-8.972275718101010D-01/,
     *                   P(9)/3.349618189847578D00/
      DATA               Q(1)/4.103991474182904D02/,
     *                   Q(2)/-2.262590291514875D03/,
     *                   Q(3)/2.494325576714903D03/,
     *                   Q(4)/2.362106244383048D04/,
     *                   Q(5)/-5.741873227396418D04/,
     *                   Q(6)/-7.257239715408240D04/,
     *                   Q(7)/-9.491399521686949D00/,
     *                   Q(8)/-3.255006939455704D01/
C                                  COEFFICIENTS FOR MINIMAX
C                                  APPROXIMATION TO LN(GAMMA(X)),
C                                  12.0 .LE. X
      DATA               P4(1)/8.40596949829D-04/,
     1                   P4(2)/-5.9523334141881D-04/,
     2                   P4(3)/7.9365078409227D-04/,
     *                   P4(4)/-2.777777777769526D-03/,
     *                   P4(5)/8.333333333333333D-02/,
     *                   P4(6)/9.189385332046727D-01/,
     6                   P4(7)/-1.7816839846D-03/
      DATA               PI/3.141592653589793D0/
      DATA               XINF/1.7D+38/
C                                  DGAMMA(XMIN) .APPROX. XINF
C                                  DGAMMA(BIG1) .APPROX. XINF
      DATA               XMIN/5.8775D-39/
      DATA               BIG1/34.844D0/
C                                  FIRST EXECUTABLE STATEMENT
      IER = 0
      MFLAG = .FALSE.
      T = X
      IF (DABS(T).GT.XMIN) GO TO 5
      IER = 130
      DGAMMA = XINF
      IF (T.LE.0.0D0) DGAMMA = -XINF
      GO TO 9000
    5 IF (DABS(T).LT.BIG1) GO TO 10
      IER = 129
      DGAMMA = XINF
      GO TO 9000
   10 IF (T.GT.0.0D0) GO TO 20
C                                  ARGUMENT IS NEGATIVE
      MFLAG = .TRUE.
      T = -T
      R = DINT(T)
      SIGN = 1.0D0
      IF (MOD(R,2.0D0).EQ.0.0D0) SIGN = -1.0D0
      R = T-R
      IF (R.NE.0.0D0) GO TO 15
      IER = 130
      DGAMMA = XINF
      IF (SIGN.EQ.-1.0D0) DGAMMA = -XINF
      GO TO 9000
C                                  ARGUMENT IS NOT A NEGATIVE INTEGER
   15 R = PI/DSIN(R*PI)*SIGN
      T = T+1.0D0
C                                  EVALUATE APPROXIMATION FOR DGAMMA(T)
C                                    T .GT. XMIN
   20 IF (T.GT.12.0D0) GO TO 55
      I = T
      A = 1.0D0
      IF (I.GT.2) GO TO 35
      I = I+1
      GO TO (25,30,45),I
C                                  0.0 .LT. T .LT. 1.0
   25 A = A/(T*(T+1.0D0))
      T = T+2.0D0
      GO TO 45
C                                  1.0 .LE. T .LT. 2.0
   30 A = A/T
      T = T+1.0D0
      GO TO 45
C                                  3.0 .LE. T .LE. 12.0
   35 DO 40 J=3,I
         T = T-1.0D0
         A = A*T
   40 CONTINUE
C                                  2.0 .LE. T .LE. 3.0
   45 TOP = P(8)*T+P(9)
      DEN = T+Q(8)
      DO 50 J=1,7
         TOP = TOP*T+P(J)
         DEN = DEN*T+Q(J)
   50 CONTINUE
      Y = (TOP/DEN)*A
      IF (MFLAG) Y = R/Y
      DGAMMA = Y
      GO TO 9005
C                                  T .GT. 12.0
   55 TOP = DLOG(T)
      TOP = T*(TOP-1.0D0)-.5D0*TOP
      T = 1.0D0/T
      B = T*T
      A = P4(7)
      DO 60 J = 1,5
   60 A = A*B+P4(J)
      Y = A*T+P4(6)+TOP
      Y = DEXP(Y)
      IF (MFLAG) Y = R/Y
      DGAMMA = Y
      GO TO 9005
 9000 CONTINUE
      CALL UERTST(-IER,'MGAMAD')
      CALL UERTST( IER,'DGAMMA')
 9005 RETURN
      END

      subroutine icsccu(x, y, nx, sc, ic, ierr)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nx, ic, ierr
      real*8, dimension(nx) :: x, y
      real*8, dimension(ic,3) :: sc
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, ilinx
      real*8 :: dummy
      real*8, dimension(4,nx) :: fspl
      real*8, dimension(5*nx) :: wk
      character :: isub*6 = 'icsccu'
C-----------------------------------------------
c
c--Check validity of spline coefficient row dimension.
c
      if (ic < nx - 1) go to 9000
c
c--Compute not-a-knot spline.
c
      fspl(1,:nx) = y(:nx)
      call r8cspline(x,nx,fspl,0,dummy,0,dummy,wk,5*nx,ilinx,ierr)
      if (ierr == 1) then
         ierr = 130
      else if (ierr == 2) then
         ierr = 131
      endif
      if (ierr /= 0) go to 9000
      sc(:,1) = fspl(2,:ic)
      sc(:,2) = fspl(3,:ic)
      sc(:,3) = fspl(4,:ic)
      go to 9990
c
c--Error exit.
c
 9000 continue
      call uertst (ierr, isub)
c
c--Normal exit.
c
 9990 continue
      return 
      end subroutine icsccu

#include "fpreproc/library_names.h"
#include "fpreproc/fp_const.h"
*DECK DBESK
      SUBROUTINE DBESK (X, FNU, KODE, N, Y, NZ)
C***BEGIN PROLOGUE  DBESK
C***PURPOSE  Implement forward recursion on the three term recursion
C            relation for a sequence of non-negative order Bessel
C            functions K/SUB(FNU+I-1)/(X), or scaled Bessel functions
C            EXP(X)*K/SUB(FNU+I-1)/(X), I=1,...,N for real, positive
C            X and non-negative orders FNU.
C***LIBRARY   SLATEC
C***CATEGORY  C10B3
C***TYPE      REAL*8 (BESK-S, DBESK-D)
C***KEYWORDS  K BESSEL FUNCTION, SPECIAL FUNCTIONS
C***AUTHOR  Amos, D. E., (SNLA)
C***DESCRIPTION
C
C     Abstract  **** a double precision routine ****
C         DBESK implements forward recursion on the three term
C         recursion relation for a sequence of non-negative order Bessel
C         functions K/sub(FNU+I-1)/(X), or scaled Bessel functions
C         EXP(X)*K/sub(FNU+I-1)/(X), I=1,..,N for real X .GT. 0.0D0 and
C         non-negative orders FNU.  If FNU .LT. NULIM, orders FNU and
C         FNU+1 are obtained from DBSKNU to start the recursion.  If
C         FNU .GE. NULIM, the uniform asymptotic expansion is used for
C         orders FNU and FNU+1 to start the recursion.  NULIM is 35 or
C         70 depending on whether N=1 or N .GE. 2.  Under and overflow
C         tests are made on the leading term of the asymptotic expansion
C         before any extensive computation is done.
C
C         The maximum number of significant digits obtainable
C         is the smaller of 14 and the number of digits carried in
C         double precision arithmetic.
C
C     Description of Arguments
C
C         Input      X,FNU are double precision
C           X      - X .GT. 0.0D0
C           FNU    - order of the initial K function, FNU .GE. 0.0D0
C           KODE   - a parameter to indicate the scaling option
C                    KODE=1 returns Y(I)=       K/sub(FNU+I-1)/(X),
C                                        I=1,...,N
C                    KODE=2 returns Y(I)=EXP(X)*K/sub(FNU+I-1)/(X),
C                                        I=1,...,N
C           N      - number of members in the sequence, N .GE. 1
C
C         Output     Y is double precision
C           Y      - a vector whose first N components contain values
C                    for the sequence
C                    Y(I)=       k/sub(FNU+I-1)/(X), I=1,...,N  or
C                    Y(I)=EXP(X)*K/sub(FNU+I-1)/(X), I=1,...,N
C                    depending on KODE
C           NZ     - number of components of Y set to zero due to
C                    underflow with KODE=1,
C                    NZ=0   , normal return, computation completed
C                    NZ .NE. 0, first NZ components of Y set to zero
C                             due to underflow, Y(I)=0.0D0, I=1,...,NZ
C
C     Error Conditions
C         Improper input arguments - a fatal error
C         Overflow - a fatal error
C         Underflow with KODE=1 -  a non-fatal error (NZ .NE. 0)
C
C***REFERENCES  F. W. J. Olver, Tables of Bessel Functions of Moderate
C                 or Large Orders, NPL Mathematical Tables 6, Her
C                 Majesty's Stationery Office, London, 1962.
C               N. M. Temme, On the numerical evaluation of the modified
C                 Bessel function of the third kind, Journal of
C                 Computational Physics 19, (1975), pp. 324-337.
C***ROUTINES CALLED  D1MACH, DASYIK, DBESK0, DBESK1, DBSK0E, DBSK1E,
C                    DBSKNU, J1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   790201  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DBESK
C
      IMPLICIT NONE
      INTEGER I, J, K, KODE, MZ, N, NB, ND, NN, NUD, NULIM, NZ
      INTEGER J1MACH
      REAL*8 CN,DNU,ELIM,ETX,FLGIK,FN,FNN,FNU,GLN,GNU,RTZ,
     1 S, S1, S2, T, TM, TRX, W, X, XLIM, Y, ZN
      REAL*8 DBESK0, DBESK1, DBSK1E, DBSK0E, D1MACH
      DIMENSION W(2), NULIM(2), Y(*)
      SAVE NULIM
      DATA NULIM(1),NULIM(2) / 35 , 70 /
C***FIRST EXECUTABLE STATEMENT  DBESK
      NN = -J1MACH(15)
      ELIM = CONST(2.303,0)*(NN*D1MACH(5)-CONST(3.0,0))
      XLIM = D1MACH(1)*CONST(1.0,+3)
      IF (KODE.LT.1 .OR. KODE.GT.2) GO TO 280
      IF (FNU.LT.CONST(0.0,0)) GO TO 290
      IF (X.LE.CONST(0.0,0)) GO TO 300
      IF (X.LT.XLIM) GO TO 320
      IF (N.LT.1) GO TO 310
      ETX = KODE - 1
C
C     ND IS A DUMMY VARIABLE FOR N
C     GNU IS A DUMMY VARIABLE FOR FNU
C     NZ = NUMBER OF UNDERFLOWS ON KODE=1
C
      ND = N
      NZ = 0
      NUD = INT(FNU)
      DNU = FNU - NUD
      GNU = FNU
      NN = MIN(2,ND)
      FN = FNU + N - 1
      FNN = FN
      IF (FN.LT.CONST(2.0,0)) GO TO 150
C
C     OVERFLOW TEST  (LEADING EXPONENTIAL OF ASYMPTOTIC EXPANSION)
C     FOR THE LAST ORDER, FNU+N-1.GE.NULIM
C
      ZN = X/FN
      IF (ZN.EQ.CONST(0.0,0)) GO TO 320
      RTZ = SQRT(CONST(1.0,0)+ZN*ZN)
      GLN = LOG((CONST(1.0,0)+RTZ)/ZN)
      T = RTZ*(CONST(1.0,0)-ETX) + ETX/(ZN+RTZ)
      CN = -FN*(T-GLN)
      IF (CN.GT.ELIM) GO TO 320
      IF (NUD.LT.NULIM(NN)) GO TO 30
      IF (NN.EQ.1) GO TO 20
   10 CONTINUE
C
C     UNDERFLOW TEST (LEADING EXPONENTIAL OF ASYMPTOTIC EXPANSION)
C     FOR THE FIRST ORDER, FNU.GE.NULIM
C
      FN = GNU
      ZN = X/FN
      RTZ = SQRT(CONST(1.0,0)+ZN*ZN)
      GLN = LOG((CONST(1.0,0)+RTZ)/ZN)
      T = RTZ*(CONST(1.0,0)-ETX) + ETX/(ZN+RTZ)
      CN = -FN*(T-GLN)
   20 CONTINUE
      IF (CN.LT.-ELIM) GO TO 230
C
C     ASYMPTOTIC EXPANSION FOR ORDERS FNU AND FNU+1.GE.NULIM
C
      FLGIK = -CONST(1.0,0)
      CALL DASYIK(X,GNU,KODE,FLGIK,RTZ,CN,NN,Y)
      IF (NN.EQ.1) GO TO 240
      TRX = CONST(2.0,0)/X
      TM = (GNU+GNU+CONST(2.0,0))/X
      GO TO 130
C
   30 CONTINUE
      IF (KODE.EQ.2) GO TO 40
C
C     UNDERFLOW TEST (LEADING EXPONENTIAL OF ASYMPTOTIC EXPANSION IN X)
C     FOR ORDER DNU
C
      IF (X.GT.ELIM) GO TO 230
   40 CONTINUE
      IF (DNU.NE.CONST(0.0,0)) GO TO 80
      IF (KODE.EQ.2) GO TO 50
      S1 = DBESK0(X)
      GO TO 60
   50 S1 = DBSK0E(X)
   60 CONTINUE
      IF (NUD.EQ.0 .AND. ND.EQ.1) GO TO 120
      IF (KODE.EQ.2) GO TO 70
      S2 = DBESK1(X)
      GO TO 90
   70 S2 = DBSK1E(X)
      GO TO 90
   80 CONTINUE
      NB = 2
      IF (NUD.EQ.0 .AND. ND.EQ.1) NB = 1
      CALL DBSKNU(X, DNU, KODE, NB, W, NZ)
      S1 = W(1)
      IF (NB.EQ.1) GO TO 120
      S2 = W(2)
   90 CONTINUE
      TRX = CONST(2.0,0)/X
      TM = (DNU+DNU+CONST(2.0,0))/X
C     FORWARD RECUR FROM DNU TO FNU+1 TO GET Y(1) AND Y(2)
      IF (ND.EQ.1) NUD = NUD - 1
      IF (NUD.GT.0) GO TO 100
      IF (ND.GT.1) GO TO 120
      S1 = S2
      GO TO 120
  100 CONTINUE
      DO 110 I=1,NUD
        S = S2
        S2 = TM*S2 + S1
        S1 = S
        TM = TM + TRX
  110 CONTINUE
      IF (ND.EQ.1) S1 = S2
  120 CONTINUE
      Y(1) = S1
      IF (ND.EQ.1) GO TO 240
      Y(2) = S2
  130 CONTINUE
      IF (ND.EQ.2) GO TO 240
C     FORWARD RECUR FROM FNU+2 TO FNU+N-1
      DO 140 I=3,ND
        Y(I) = TM*Y(I-1) + Y(I-2)
        TM = TM + TRX
  140 CONTINUE
      GO TO 240
C
  150 CONTINUE
C     UNDERFLOW TEST FOR KODE=1
      IF (KODE.EQ.2) GO TO 160
      IF (X.GT.ELIM) GO TO 230
  160 CONTINUE
C     OVERFLOW TEST
      IF (FN.LE.CONST(1.0,0)) GO TO 170
      IF (-FN*(LOG(X)-CONST(0.693,0)).GT.ELIM) GO TO 320
  170 CONTINUE
      IF (DNU.EQ.CONST(0.0,0)) GO TO 180
      CALL DBSKNU(X, FNU, KODE, ND, Y, MZ)
      GO TO 240
  180 CONTINUE
      J = NUD
      IF (J.EQ.1) GO TO 210
      J = J + 1
      IF (KODE.EQ.2) GO TO 190
      Y(J) = DBESK0(X)
      GO TO 200
  190 Y(J) = DBSK0E(X)
  200 IF (ND.EQ.1) GO TO 240
      J = J + 1
  210 IF (KODE.EQ.2) GO TO 220
      Y(J) = DBESK1(X)
      GO TO 240
  220 Y(J) = DBSK1E(X)
      GO TO 240
C
C     UPDATE PARAMETERS ON UNDERFLOW
C
  230 CONTINUE
      NUD = NUD + 1
      ND = ND - 1
      IF (ND.EQ.0) GO TO 240
      NN = MIN(2,ND)
      GNU = GNU + CONST(1.0,0)
      IF (FNN.LT.CONST(2.0,0)) GO TO 230
      IF (NUD.LT.NULIM(NN)) GO TO 230
      GO TO 10
  240 CONTINUE
      NZ = N - ND
      IF (NZ.EQ.0) RETURN
      IF (ND.EQ.0) GO TO 260
      DO 250 I=1,ND
        J = N - I + 1
        K = ND - I + 1
        Y(J) = Y(K)
  250 CONTINUE
  260 CONTINUE
      DO 270 I=1,NZ
        Y(I) = CONST(0.0,0)
  270 CONTINUE
      RETURN
C
C
C
  280 CONTINUE
      CALL XERMSG ('SLATEC', 'DBESK',
     +   'SCALING OPTION, KODE, NOT 1 OR 2', 2, 1)
      RETURN
  290 CONTINUE
      CALL XERMSG ('SLATEC', 'DBESK', 'ORDER, FNU, LESS THAN ZERO', 2,
     +   1)
      RETURN
  300 CONTINUE
      CALL XERMSG ('SLATEC', 'DBESK', 'X LESS THAN OR EQUAL TO ZERO',
     +   2, 1)
      RETURN
  310 CONTINUE
      CALL XERMSG ('SLATEC', 'DBESK', 'N LESS THAN ONE', 2, 1)
      RETURN
  320 CONTINUE
      CALL XERMSG ('SLATEC', 'DBESK',
     +   'OVERFLOW, FNU OR N TOO LARGE OR X TOO SMALL', 6, 1)
      RETURN
      END
! 22Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 22Jun2000 fgtok
! 22Jun2000 fgtok

C   IMSL ROUTINE NAME   - USPKD
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - NOVEMBER 1, 1984
C
C   PURPOSE             - NUCLEUS CALLED BY IMSL ROUTINES THAT HAVE
C                           CHARACTER STRING ARGUMENTS
C
C   USAGE               - CALL USPKD  (PACKED,NCHARS,UNPAKD,NCHMTB)
C
C   ARGUMENTS    PACKED - CHARACTER STRING TO BE UNPACKED.(INPUT)
C                NCHARS - LENGTH OF PACKED. (INPUT)  SEE REMARKS.
C                UNPAKD - INTEGER ARRAY TO RECEIVE THE UNPACKED
C                         REPRESENTATION OF THE STRING. (OUTPUT)
C                NCHMTB - NCHARS MINUS TRAILING BLANKS. (OUTPUT)
C
C   PRECISION/HARDWARE  - SINGLE/ALL
C
C   REQD. IMSL ROUTINES - NONE
C
C   REMARKS  1.  USPKD UNPACKS A CHARACTER STRING INTO AN INTEGER ARRAY
C                IN (A1) FORMAT.
C            2.  UP TO 129 CHARACTERS MAY BE USED.  ANY IN EXCESS OF
C                THAT ARE IGNORED.
C
C   COPYRIGHT           - 1984 BY IMSL, INC.  ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE.  NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
      SUBROUTINE USPKD  (PACKED,NCHARS,UNPAKD,NCHMTB)
C                                  SPECIFICATIONS FOR ARGUMENTS
      INTEGER            NC,NCHARS,NCHMTB
C
      INTEGER            UNPAKD(1),IBLANK
      CHARACTER(LEN=*)   PACKED ! (1)
      DATA               IBLANK /' '/
C                                  INITIALIZE NCHMTB
      NCHMTB = 0
C                                  RETURN IF NCHARS IS LE ZERO
      IF(NCHARS.LE.0) RETURN
C                                  SET NC=NUMBER OF CHARS TO BE DECODED
      NC = MIN0(129,NCHARS)
C      DECODE (NC,150,PACKED) (UNPAKD(I),I=1,NC)
      READ (UNIT=PACKED,FMT=150) (UNPAKD(I),I=1,NC)
  150 FORMAT (129A1)
C                                  CHECK UNPAKD ARRAY AND SET NCHMTB
C                                  BASED ON TRAILING BLANKS FOUND
      DO 200 N = 1,NC
         NN = NC - N + 1
         IF(UNPAKD(NN) .NE. IBLANK) GO TO 210
  200 CONTINUE
      NN = 0
  210 NCHMTB = NN
      RETURN
      END

      module Vceqdsk
C...Created by Pacific-Sierra Research VAST-90 2.06G2  12:29:44   5/18/01  
      use Vparam, only: nxa, nza, nptsdm, nprofm, nza2,
     1                  inoperm, nprofm2, lrza, nions
      character(8) :: codeid, dat
      character(40) :: ntitle
      integer   nlim, nlimiter, lrz, nprim, nimp, nion, nti
      integer   iounit1, inoperm1, nptsdm1, nptsd
      integer   ieqdsk
      integer   ipestg, nxeqd, nzeqd
      integer   imodeq, liw, lw, ifail
      integer, dimension(nprofm) :: ncontr
      integer, dimension(4) :: iw
      real   psiadj
      real   funcmin
      real   xxx, zzz
      real   dpolflx, psieqd
      real   tpsisav, dang, bperr, arcl
      real   xdimeqd, zdimeqd, reqd, redeqd, zmideqd, xma, zma, psimag, 
     1   psilim, beqd, toteqd, psimx1, psimx2, xax1, xax2, zax1, zax2, 
     2   psisep, xsep, zsep
      real, dimension(nxa) :: feqd, presseqd, ffpeqd, ppeqd
      real, dimension(nxa,nza) :: peqd
      real, dimension(nxa) :: qeqd
      real, dimension(nxa) :: xeqd
      real, dimension(nza) :: zeqd
      real, dimension(2) :: bl, bu, psith
      real, dimension(40) :: work
      real, dimension(nxa) :: tpsieqd, tpsifeqd
      real, dimension(nxa) :: torflux
      real, dimension(nprofm) :: ra
      real, dimension(nprofm,4) :: psifra
      real, dimension(nprofm) :: dpsifra
      real, dimension(nprofm,4) :: fra, fra1
      real, dimension(2,nxa,nza2) :: cspln
      real, dimension(6) :: pds
      real, dimension(inoperm) :: wnoperm
      real, dimension(nprofm) :: pprime, vprime, chipsi
      real, dimension(nptsdm) :: thet, anglex
      real, dimension(2,nptsdm,nprofm2) :: csplnx, csplnz
      real, dimension(6) :: pdsx, pdsz
      real, dimension(nptsdm) :: rlim, zlim, rlimiter, zlimiter
      real, dimension(lrza,nions) :: zi
      real, dimension(lrza) :: zeffz, r, raeqd, psifeqd, te
      real, dimension(lrza,nions) :: ti
      real, dimension(lrza) :: ti1, ene
      real, dimension(lrza,nions) :: enp
      real, dimension(nxa,nza) :: bmod
      real, dimension(2*nprofm - 1) :: rmd, btmd, bpmd, btpmd
      real, dimension(nprofm) :: roa
      real, dimension(nptsdm,nprofm) :: xcontr, zcontr, bpcontr, btcontr
     1   , dstarp, b_fld, jacob
      end module Vceqdsk

C   IMSL ROUTINE NAME   - LUREFN
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JUNE 1, 1982
C
C   PURPOSE             - NUCLEUS CALLED ONLY BY IMSL SUBROUTINE LEQT2F
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - SINGLE/LUELMN,UERTST,UGETIO
C                       - DOUBLE/LUELMN,UERTST,UGETIO,VXADD,VXMUL,
C                           VXSTO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE LUREFN (A,IA,N,UL,IUL,B,IDGT,APVT,X,RES,DX,IER)
C
      DIMENSION          A(IA,1),UL(IUL,1),B(1),X(1),RES(1),DX(1)
      DIMENSION          APVT(1)
      DOUBLE PRECISION   SUM
      DATA               ITMAX/50/,ZERO/0.0/
C                                  FIRST EXECUTABLE STATEMENT
      IER=0
      XNORM = ZERO
      DO 10 I=1,N
         XNORM = AMAX1(XNORM,ABS(X(I)))
   10 CONTINUE
      IF (XNORM .NE. ZERO) GO TO 20
      IDGT = 50
      GO TO 9005
   20 DO 45 ITER=1,ITMAX
         DO 30 I=1,N
            SUM = DBLE(B(I))
            DO 25 J=1,N
               SUM = SUM - DBLE(A(I,J)) * DBLE(X(J))
   25       CONTINUE
            RES(I) = SUM
   30    CONTINUE
         CALL LUELMN (UL,IUL,N,RES,APVT,DX)
         DXNORM = ZERO
         XNORM = ZERO
         DO 35 I=1,N
            X(I) = X(I) + DX(I)
            DXNORM = AMAX1(DXNORM,ABS(DX(I)))
            XNORM = AMAX1(XNORM,ABS(X(I)))
   35    CONTINUE
         IF (ITER .NE. 1) GO TO 40
         IDGT = 50
!         IF (DXNORM .NE. ZERO) IDGT = -LOG10(DXNORM/XNORM)
   40    IF (XNORM+DXNORM .EQ. XNORM) GO TO 9005
   45 CONTINUE
C                                  ITERATION DID NOT CONVERGE
      IER = 129
 9000 CONTINUE
      CALL UERTST(IER,'LUREFN')
 9005 RETURN
      END

c
c  This module contains subroutines from adj
c
c----------------------------------------------------------

      function current (du, ua, c, nmax, dth0, th0a, imax, imax1,
     1   fm, chi, cur)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real(kind=dp) current
      integer nmax, imax, imax1
      real(kind=dp) du, c, dth0
      real(kind=dp), dimension(0:nmax - 1) :: ua
      real(kind=dp), dimension(0:imax - 1) :: th0a
      real(kind=dp), dimension(0:nmax - 1) :: fm
      real(kind=dp), dimension(0:imax1 - 1,0:nmax - 1) :: chi
      real(kind=dp), dimension(0:imax - 1) :: cur
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n, i
      real(kind=dp) :: pi
C-----------------------------------------------

      pi = 4*atan(1.0E0)
      cur(:imax-1) = 0

      do n = 0, nmax - 1
         cur(:imax-1) = cur(:imax-1) + chi(:imax-1,n)*fm(n)*ua(n)**3/
     1      sqrt(1 + (ua(n)/c)**2)
      end do

      current = dot_product(sin(th0a(:imax-1))*cos(th0a(:imax-1)),cur(:
     1   imax-1))

      current = 4*pi*du*dth0*current

      return
      end function current


      subroutine decomp(chi, nmax, nmax1, imax, imax1, lmaxa, lmaxa1,
     1   th0a, dth0, legp, chil)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, nmax1, imax, imax1, lmaxa, lmaxa1
      real(kind=dp) dth0
      real(kind=dp), dimension(0:imax1 - 1,0:nmax - 1) :: chi
      real(kind=dp), dimension(0:imax - 1) :: th0a
      real(kind=dp), dimension(0:imax1 - 1,lmaxa1) :: legp
      real(kind=dp), dimension(0:nmax1 - 1,lmaxa1) :: chil
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: la, l, n, i
      real(kind=dp) :: sn
C-----------------------------------------------

      do la = 1, lmaxa
         l = max(2*la - 1,0)

         chil(:nmax-1,la) = 0

         do i = 0, imax - 1
            sn = sin(th0a(i))*legp(i,la)
            chil(:nmax-1,la) = chil(:nmax-1,la) + chi(i,:nmax-1)*sn
         end do

         chil(:nmax-1,la) = (2*l + 1)*dth0*chil(:nmax-1,la)

      end do

      return
      end subroutine decomp


      function deltab (phi, eps)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real(kind=dp) phi, eps
      real(kind=dp) deltab
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
C-----------------------------------------------

      deltab = 2*eps*sin(phi/2)**2/(1 + eps*cos(phi))

      return
      end function deltab

      subroutine error(du, ua, umax, nmax, dth0, th0a, th0max, imax,
     1   imax1, resid, chi, abserr, relerr, aerr, rerr)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, imax, imax1
      real(kind=dp) du, umax, dth0, th0max, abserr, relerr
      real(kind=dp), dimension(0:nmax - 1) :: ua
      real(kind=dp), dimension(0:imax - 1) :: th0a
      real(kind=dp), dimension(0:imax1 - 1,0:nmax - 1) :: resid, chi
      real(kind=dp), dimension(0:imax - 1) :: aerr, rerr
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, n
C-----------------------------------------------

      aerr(:imax-1) = 0
      rerr(:imax-1) = 0

      do n = 0, nmax - 1
         aerr(:imax-1) = aerr(:imax-1) + resid(:imax-1,n)**2*(ua(n)**2)
         rerr(:imax-1) =rerr(:imax-1)+(resid(:imax-1,n)/max(1.0E-16_dp,
     1      abs(chi(:imax-1,n))))**2*(ua(n)**2)
      end do

      abserr = dot_product(sin(th0a(:imax-1)),aerr(:imax-1))
      relerr = dot_product(sin(th0a(:imax-1)),rerr(:imax-1))

      abserr = sqrt(abserr*du*dth0/(umax**3/3*(1 - cos(th0max))))
      relerr = sqrt(relerr*du*dth0/(umax**3/3*(1 - cos(th0max))))

      return
      end subroutine error


      subroutine hinit(eps, kmax, lmaxa1, harr, garr, dthp, dl, bb)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer kmax, lmaxa1
      real(kind=dp) eps, dthp
      real(kind=dp), dimension(((lmaxa1 - 1)
     1 *lmaxa1*(2*lmaxa1-1))/6+(lmaxa1- 1)*lmaxa1+lmaxa1):: harr
      real(kind=dp),dimension((((lmaxa1+3)-1)*
     1   (lmaxa1+3))/2+(lmaxa1+1))::garr
      real(kind=dp), dimension(0:kmax - 1) :: dl, bb
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: k, la, la1, la2, l, l1
      real(kind=dp) :: b, pi
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real(kind=dp) , EXTERNAL :: deltab
C-----------------------------------------------

      pi = 4*atan(1.0E0)

C
C  Initialize |harr| and set the edge values of |garr| to zero.
C
      do la = 1, lmaxa1
         do la1 = 1, la
            harr((la-1)*la*(2*la-1)/6+(la1-1)*la+1:la*(la*(2*(la-1)-1)+1
     1         )/6+la1*la) = 0
         end do
      end do

      do la = -2, lmaxa1 - 1
         garr((((la+3)-1)*(la+3))/2+(0+1)) = 0
      end do
      do la = -1, lmaxa1 - 1
         garr((((la+3)-1)*(la+3))/2+(la+1+1)) = 0
         garr((((la+3)-1)*(la+3))/2+(la+2+1)) = 0
      end do
      garr((((1+3)-1)*(1+3))/2+(1+1)) = 1

      do k = 0, kmax - 1
c     phi=2*pi*(k+0.25e0)/kmax
         b = bb(k)
C
C  Use the recursion relation for 'g' to fill garr
C
         do la = 2, lmaxa1
            l = max(2*la - 1,0)
            do la1 = 1, la
               l1 = max(2*la1 - 1,0)
               garr((((la+3)-1)*(la+3))/2+(la1+1)) = (2*(2*l - 3)*(l**2
     1             - 3*l + 1)*garr((((la-1+3)-1)*(la-1+3))/2+(la1+1))-(l
     2            -3)*(l-2)*(2*l-1)*garr((((la-2+3)-1)*(la-2+3))/2+(la1+
     3            1)))/(l*(l - 1)*(2*l - 5)) + (2*l - 3)*(2*l - 1)*b*((
     4            l1 + 1)*(l1 + 2)*garr((((la-1+3)-1)*(la-1+3))/2+(la1+1
     5            +1))/((2*l1+3)*(2*l1+5))-2*(l1**2+l1-1)*garr((((la-1+3
     6            )-1)*(la-1+3))/2+(la1+1))/((2*l1-1)*(2*l1+3))+l1*(l1-1
     7            )*garr((((la-1+3)-1)*(la-1+3))/2+(la1-1+1))/((2*l1-3)*
     8            (2*l1-1)))/(l*(l - 1))
            end do
         end do

         do la = 1, lmaxa1
            do la1 = 1, la
               harr((la-1)*la*(2*la-1)/6+(la1-1)*la+1:la*(la*(2*(la-1)-1
     1            )+1)/6+la1*la) = harr((la-1)*la*(2*la-1)/6+(la1-1)*la+
     2            1:la*(la*(2*(la-1)-1)+1)/6+la1*la) + b*garr(((la+3)*(
     3            la+3)-3-la)/2+la1+1)*garr((la*(la+5)+6)/2+2:la+1+(la*(
     4            la+5)+6)/2)*dl(k)
            end do
         end do
      end do

      do la = 1, lmaxa1
         do la1 = 1, la
            do la2 = 1, la
               harr(((la-1)*la*(2*la-1))/6+(la1-1)*la+la2) = (2*max(2*la
     1             - 1,0) + 1)/real(2*max(2*la2 - 1,0) + 1)*harr(((la-1)
     2            *la*(2*la-1))/6+(la1-1)*la+la2)
            end do
         end do
      end do

      return
      end subroutine hinit


      subroutine initjy(ua, c, nmax, nmax1, lmaxa, lmaxa1, legjy, jarray
     1   , djarray, lmax1)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, nmax1, lmaxa, lmaxa1, lmax1
      real(kind=dp) c
      real(kind=dp), dimension(0:nmax - 1) :: ua
      real(kind=dp), dimension(0:nmax1 - 1,0:6,0:3,0:lmaxa1) :: legjy
      real(kind=dp), dimension((-lmax1) - 1:lmax1,
     1   0:6) :: jarray, djarray
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n, mult, la, l, a
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      EXTERNAL legjn
C-----------------------------------------------

      do n = 0, nmax - 1
         call legjn(ua(n),c,max(2*lmaxa-1,0),jarray,djarray,lmax1)
         do la = 0, lmaxa
            l = max(2*la - 1,0,0)
            mult = (-1)**(l + 1)
            legjy(n,:6,0,la) = jarray(l,:6)
            legjy(n,:6,1,la) = mult*jarray((-l)-1,:6)
            legjy(n,:6,2,la) = djarray(l,:6)
            legjy(n,:6,3,la) = mult*djarray((-l)-1,:6)
         end do
      end do

      return
      end subroutine initjy


      subroutine initp(x, imax, imax1, lmaxa, lmaxa1, legp, leg0)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer imax, imax1, lmaxa, lmaxa1
      real(kind=dp), dimension(0:imax - 1) :: x
      real(kind=dp), dimension(0:imax1 - 1,lmaxa1) :: legp
      real(kind=dp), dimension(0:imax - 1) :: leg0
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, l, la
C-----------------------------------------------

      if (lmaxa < 1) return

      la = 1
      leg0(:imax-1) = 1
      legp(:imax-1,la) = x(:imax-1)

      do la = 2, lmaxa
         l = max(2*la - 1,0)
         leg0(:imax-1) = (((2*l) - 3)*x(:imax-1)*legp(:imax-1,la-1)-(l-2
     1      )*leg0(:imax-1))/(l - 1)
         legp(:imax-1,la) = (((2*l) - 1)*x(:imax-1)*leg0(:imax-1)-(l-1)*
     1      legp(:imax-1,la-1))/l
      end do

      return
      end subroutine initp


      subroutine isotrop(ua, du, c, fm, chil, nmax, nmax1, legjy, psid,
     1   ze, zi, duug, fu, dtt, work)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, nmax1
      real(kind=dp) du, c, ze, zi
      real(kind=dp), dimension(0:nmax - 1) :: ua, fm, chil
      real(kind=dp), dimension(0:nmax1 - 1,0:6,0:3) :: legjy
      real(kind=dp), dimension(0:nmax1 - 1,0:4,0:1) :: psid
      real(kind=dp), dimension(0:nmax) :: duug
      real(kind=dp), dimension(0:nmax - 1) :: fu, dtt
      real(kind=dp), dimension(0:nmax + (nmax1 + 1)*7*2 - 1) :: work
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
      integer, parameter :: p0 = 0
      integer, parameter :: p02 = 1
      integer, parameter :: p022 = 2
      integer, parameter :: p1 = 3
      integer, parameter :: p11 = 4
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n
      real(kind=dp) :: pi, g, u
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      EXTERNAL pot
C-----------------------------------------------

      call pot (ua, du, c, fm, chil, nmax, nmax1, legjy, psid, work(0),
     1   work(nmax))

      pi = 4*atan(1.0E0)
      do n = 0, nmax - 1
         u = ua(n)
         g = sqrt(1 + (u/c)**2)
         duug(n) = ze*4*pi*g/u*(2*g**2*psid(n,p02,1)-u*psid(n,p0,0)-8*g
     1      **2/c**2*psid(n,p022,1)+8*u/c**4*psid(n,p022,0))
         dtt(n) = ze*4*pi/(g*u)*((-g**2*psid(n,p02,1))-u/c**2*psid(n,p02
     1      ,0)+4*g**2/c**2*psid(n,p022,1)-4*u/c**4*psid(n,p022,0)) + zi
     2      *g/(2*u)
         fu(n) = ze*4*pi*g*((-psid(n,p1,1))+2/c**2*psid(n,p11,1))
      end do



      duug(nmax) = (3*duug(nmax-1)-duug(nmax-2))/2
      duug(nmax-1:1:(-1)) = (duug(nmax-1:1:(-1))+duug(nmax-2:0:(-1)))/2
      duug(0) = duug(0)

      return
      end subroutine isotrop


      function lam1 (eps, th0, kmax, dthp, dl, b)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real(kind=dp) lam1
      integer kmax
      real(kind=dp) eps, th0, dthp
      real(kind=dp), dimension(0:kmax - 1) :: dl, b
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: k
      real(kind=dp) :: deltabv, sum, costh
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real(kind=dp) , EXTERNAL :: deltab
C-----------------------------------------------

c     pi=4*atan(1.0e0)
      sum = 0
      do k = 0, kmax - 1
c     phi=2*pi*(k+0.25e0)/kmax
         deltabv = b(k) - 1.
         costh = sqrt(1 - min(1.0E0_dp,deltabv*tan(th0)**2))
         sum = sum + 1/costh*dl(k)
      end do
      lam1 = sum

      return
      end function lam1


      function lam2 (eps, th0, kmax, dthp, dl, b)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real(kind=dp) lam2
      integer kmax
      real(kind=dp) eps, th0, dthp
      real(kind=dp), dimension(0:kmax - 1) :: dl, b
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: k
      real(kind=dp) :: deltabv, sum, costh
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real(kind=dp) , EXTERNAL :: deltab
C-----------------------------------------------

c     pi=4*atan(1.0e0)
      sum = 0
      do k = 0, kmax - 1
c     phi=2*pi*(k+0.25e0)/kmax
         deltabv = b(k) - 1.
         costh = sqrt(1 - min(1.0E0_dp,deltabv*tan(th0)**2))
         sum = sum + costh/(1 + deltabv)*dl(k)/b(k)
      end do
      lam2 = sum

      return
      end function lam2


      subroutine legjn(u, c, lmax, jarray, djarray, lmax1)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer lmax, lmax1
      real(kind=dp) u, c
      real(kind=dp), dimension((-lmax1) - 1:lmax1,
     1   0:6) :: jarray, djarray
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
      integer, parameter :: j0 = 0
      integer, parameter :: j1 = 1
      integer, parameter :: j2 = 2
      integer, parameter :: j02 = 3
      integer, parameter :: j11 = 4
      integer, parameter :: j22 = 5
      integer, parameter :: j022 = 6
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: l, a, amax
      real(kind=dp) :: scale, g
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      EXTERNAL legjs
C-----------------------------------------------

      amax = 2
      call legjs (u/c, lmax + 2, amax, jarray, lmax1)

      scale = 1
      do l = 1, lmax + 2
         scale = scale*u/(2*l + 1)
         jarray(l,:amax) = scale*jarray(l,:amax)
      end do

      scale = 1
      do l = -1, (-lmax) - 2, -1
         scale = scale/u*(2*l + 3)
         jarray(l,:amax) = scale*jarray(l,:amax)
      end do

      do l = (-lmax) - 2, lmax
         jarray(l,j02) = u/2*jarray(l+1,1)
         jarray(l,j11) = u/2*jarray(l+1,0)
         jarray(l,j22) = u/2*jarray(l+1,1) + (u/c)**2/2*jarray(l+2,0)
         jarray(l,j022) = u**2/8*jarray(l+2,0)
      end do

      g = sqrt(1 + (u/c)**2)
      do a = 0, 6
         do l = (-lmax) - 1, lmax
            djarray(l,a) = jarray(l-1,a)/g - (l + 1)/u*jarray(l,a)
         end do
      end do

      return
      end subroutine legjn


      subroutine legjs(z, lmax, amax, jarray, lmax1)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer lmax, amax, lmax1
      real(kind=dp) z
      real(kind=dp), dimension((-lmax1) - 1:lmax1,0:amax) :: jarray
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: l, a, lstart
      real(kind=dp) :: z2, g, ja0, ja1, ja2, ratio, sigma
C-----------------------------------------------

      if (amax<0 .or. lmax<0) return
      if (lmax > lmax1) return

      z2 = z**2
      g = sqrt(1 + z2)

      do a = 1, amax
C**************a=0 is excluded
         ja2 = 1
C********ja(a-1,a)
         ja1 = g
C**********ja(a-2,a)
         do l = a - 3, lmax - 1, -1
C
C   Get things started by iterating down to $|lmax|-1$ if need be.
C   This is from equation (A29)
C
            ja0=g*ja1-z2*(l-a+2)*(l+a+2)*ja2/((2*l+3)*(2*l+5))
            ja2 = ja1
            ja1 = ja0
         end do
         l = min(lmax,a - 1)
         jarray(l,a) = ja2
         l = l - 1
         jarray(l,a) = ja1
         do l = min(lmax,a - 1) - 2, max((-a),(-lmax) - 1), -1
            jarray(l,a) = g*jarray(l+1,a) - z2*(l - a + 2)*(l + a + 2)*
     1         jarray(l+2,a)/((2*l + 3)*(2*l + 5))
         end do
      end do

C
C   Calculate the scaled Legendre functions for the other easy case, namely
C   $l<-a$.
C
      do a = 0, min(amax,lmax)
         l = (-a) - 1
         jarray(l,a) = 1
         l = l - 1
         if (l >= (-lmax) - 1) jarray(l,a) = g
         do l = (-a) - 3, (-lmax) - 1, -1
            jarray(l,a) = g*jarray(l+1,a) - z2*(l - a + 2)*(l + a + 2)*
     1         jarray(l+2,a)/((2*l + 3)*(2*l + 5))
         end do
      end do

C
C  Calculate scaled Legendre functions for -a.<= l <=a
C
C
C   Calculate $\ja{l\ge0,0}$.  Depending on the magnitude of the argument we
C  either use backwards recursion (for $z \le |lmax|+1$) or forwards
C  recursion using $\ja{-1,0}=1$ and $\ja{0,0} = (\sinh^{-1} z)/z$.
C
      a = 0
      if (abs(z) <= lmax + 1) then
C
C  Estimate where to start the recursion.  The 10 is a extra guard.
C
         lstart=lmax+log(1.0E-16)/(2*log((1.0E-16+abs(z))/(g+1)))+10
         ratio = 2/(g + 1)
         do l = lstart, lmax - 1, -1
            ratio=1/(g-z2*(l-a+2)*(l+a+2)*ratio/((2*l+3)*(2*l+5)))
C***At this point, |ratio| is approximation for $\ja{l+1,a}/\ja{l,a}$. **
         end do
         jarray(lmax,a) = ratio
         ja0 = 1
         do l = lmax - 2, -1, -1
            jarray(l+1,a) = ja0
            ja0 = g*jarray(l+1,a) - z2*(l - a + 2)*(l + a + 2)*jarray(l+
     1         2,a)/((2*l + 3)*(2*l + 5))
         end do
         ja0 = 1/ja0
         jarray(0:lmax,a) = ja0*jarray(0:lmax,a)
      else
C********** Use forward recurrence for $z>|lmax|+1$. **
         sigma = log(g + abs(z))
C******$\sinh^{-1}(\abs z)$ **
         l = 0
         jarray(l,a) = sigma/abs(z)
C********* Starting value.  We assume
C            that $\ja{-1,0}$ has already been set to $1$. */


         do l = 1, lmax
C***********Equation (A29)***************
            jarray(l,a) = (g*jarray(l-1,a)-jarray(l-2,a))*(2*l - 1)*(2*l
     1          + 1)/(z2*(l - a)*(l + a))
         end do
      endif
C
C   Do the other cases, i.e., $a>0$, $l\ge a$.
C
C  < Do the other cases, i.e., $a>0$, $l\ge a$ @>=
C
      do a = 1, min(lmax,amax)
         l = lmax
         jarray(l,a) = ((2*l + 1)*jarray(l-1,a-1)-(l+1-a)*g*jarray(l,a-1
     1      ))/(l + a)
         l = lmax - 1
         if (l == 0) then
C
C    implies that a=1. Use ja(-1,0)=1
C
            ja0 = ((2*l + 1) - (l + 1 - a)*g*jarray(l,a-1))/(l + a)
         else
            ja0=((2*l+1)*jarray(l-1,a-1)-(l+1-a)*g*jarray(l,a-1))/(l+a)
         endif
         do l = lmax - 2, a - 1, -1
            jarray(l+1,a) = ja0
            ja0 = g*jarray(l+1,a) - z2*(l - a + 2)*(l + a + 2)*jarray(l+
     1         2,a)/((2*l + 3)*(2*l + 5))
         end do
         ja0 = 1/ja0
         jarray(a:lmax,a) = ja0*jarray(a:lmax,a)
      end do

      return
      end subroutine legjs


      subroutine matinit(du, ua, ug, nmax, nmax1, dth0, th0a, th0g, imax
     1   , imax1, duug, fu, dtt, lam1a, lam2g, uinv, th0inv, rho)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, nmax1, imax, imax1
      real(kind=dp) du, dth0, rho
      real(kind=dp), dimension(0:nmax - 1) :: ua
      real(kind=dp), dimension(0:nmax) :: ug
      real(kind=dp), dimension(0:imax - 1) :: th0a
      real(kind=dp), dimension(0:imax) :: th0g
      real(kind=dp), dimension(0:nmax) :: duug
      real(kind=dp), dimension(0:nmax - 1) :: fu, dtt
      real(kind=dp), dimension(0:imax - 1) :: lam1a
      real(kind=dp), dimension(0:imax) :: lam2g
      real(kind=dp), dimension(0:nmax1 - 1,-1:1) :: uinv
      real(kind=dp), dimension(0:imax1 - 1,-1:1) :: th0inv
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n, i
C-----------------------------------------------
C
C  Define matrices for inversion of diffusion and friction operator.  These
C  are one-dimensional because the operator is independent of $\theta_0$.
C
      uinv(:nmax-1,-1) = ug(:nmax-1)**2*duug(:nmax-1)/((ua(:nmax-1)**2)*
     1   (du**2))
      uinv(:nmax-1,1) = ug(1:nmax)**2*duug(1:nmax)/((ua(:nmax-1)**2)*(du
     1   **2))
      uinv(:nmax-1,0) = (-uinv(:nmax-1,-1)) - uinv(:nmax-1,1)
      uinv(:nmax-1,-1) = uinv(:nmax-1,-1) - fu(:nmax-1)/(2*du)
      uinv(:nmax-1,1) = uinv(:nmax-1,1) + fu(:nmax-1)/(2*du)
      n = 0
      uinv(n,0) = uinv(n,0) - uinv(n,-1)
      uinv(n,-1) = 0
      n = nmax - 1
      uinv(n,-1) = uinv(n,-1) - rho*uinv(n,1)
      uinv(n,0) = uinv(n,0) + (1 + rho)*uinv(n,1)
      uinv(n,1) = 0

      uinv(:nmax-1,-1) = uinv(:nmax-1,-1)*(ua(:nmax-1)**2)/dtt(:nmax-1)
      uinv(:nmax-1,0) = uinv(:nmax-1,0)*(ua(:nmax-1)**2)/dtt(:nmax-1)
      uinv(:nmax-1,1) = uinv(:nmax-1,1)*(ua(:nmax-1)**2)/dtt(:nmax-1)
C
C   Define matrices for inversion of pitch-angle scattering operator.  These
C  are one-dimensional because, after divided out $D_{\theta\theta,0}/u^2$,
C  the operator is independent of $u$.
C
      th0inv(:imax-1,-1) = sin(th0g(:imax-1))*lam2g(:imax-1)/((lam1a(:
     1   imax-1)*(sin(th0a(:imax-1))))*(dth0**2))
      th0inv(:imax-1,1) = sin(th0g(1:imax))*lam2g(1:imax)/((lam1a(:imax-
     1   1)*(sin(th0a(:imax-1))))*(dth0**2))
      th0inv(:imax-1,0) = (-th0inv(:imax-1,-1)) - th0inv(:imax-1,1)
      i = 0
      i = imax - 1
      th0inv(i,0) = th0inv(i,0) - th0inv(i,1)
      th0inv(i,1) = 0


C* :86 *
*line 1805 "adj.web"


      return
      end subroutine matinit



      subroutine maxwel(ua, du, c, nmax, fm, t)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax
      real(kind=dp) du, c, t
      real(kind=dp), dimension(0:nmax - 1) :: ua, fm
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n
      real(kind=dp) :: sum, pi
C-----------------------------------------------

      fm(:nmax-1) = exp((-ua(:nmax-1)**2/(sqrt(1+(ua(:nmax-1)/c)**2)+1)/
     1   t))
      sum = dot_product(ua(:nmax-1)**2,fm(:nmax-1))
      pi = 4*atan(1.0E0)
      sum = 4*pi*du*sum
      fm(:nmax-1) = fm(:nmax-1)/sum

      return
      end subroutine maxwel

      subroutine operinit
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
C-----------------------------------------------

      open(unit=20, file='adjout', form='unformatted', status='unknown')
      open(unit=29, file='adjinp', form='unformatted', status='old')

      return
      end subroutine operinit


      subroutine pot(ua,du,c,fm,chil,nmax,nmax1,legjy,psid,fla,ijy)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, nmax1
      real(kind=dp) du, c
      real(kind=dp), dimension(0:nmax - 1) :: ua, fm, chil
      real(kind=dp), dimension(0:nmax1 - 1,0:6,0:3) :: legjy
      real(kind=dp), dimension(0:nmax1 - 1,0:4,0:1) :: psid
      real(kind=dp), dimension(0:nmax - 1) :: fla
      real(kind=dp), dimension(0:nmax1,0:6,0:1) :: ijy
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
      integer, parameter :: p0 = 0
      integer, parameter :: p02 = 1
      integer, parameter :: p022 = 2
      integer, parameter :: p1 = 3
      integer, parameter :: p11 = 4
      integer, parameter :: j0 = 0
      integer, parameter :: j1 = 1
      integer, parameter :: j2 = 2
      integer, parameter :: j02 = 3
      integer, parameter :: j11 = 4
      integer, parameter :: j22 = 5
      integer, parameter :: j022 = 6
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n, a
C-----------------------------------------------


C   Define various indefinite integrals needed in the definition of the
C  potentials.  First do the integration to cell edges and then interpolate
C  to the cell centers.

      fla(:nmax-1) = fm(:nmax-1)*chil(:nmax-1)*ua(:nmax-1)**2/sqrt(1 + (
     1   ua(:nmax-1)/c)**2)*du/2

      do a = 0, 6
         ijy(1:nmax,a,0) = fla(:nmax-1)*legjy(:nmax-1,a,0)
         ijy(:nmax-1,a,1) = fla(:nmax-1)*legjy(:nmax-1,a,1)
         ijy(0,a,0) = 0
         ijy(nmax,a,1) = 0
      end do

      do n = 1, nmax
         ijy(n,:6,0) = ijy(n-1,:6,0) + ijy(n,:6,0)
      end do
      do n = nmax - 1, 0, -1
         ijy(n,:6,1) = ijy(n+1,:6,1) + ijy(n,:6,1)
      end do

      ijy(:nmax-1,:6,0) = ijy(:nmax-1,:6,0) + ijy(1:nmax,:6,0)
      ijy(:nmax-1,:6,1) = ijy(:nmax-1,:6,1) + ijy(1:nmax,:6,1)
C
C  Define various indefinite integrals needed in the definition of
C   the potentials. First do the integration to cell edges and then
C   interpolate to the cell centers.
C
      psid(:nmax-1,p0,0) = legjy(:nmax-1,j0,1)*ijy(:nmax-1,j0,0) + ijy(:
     1   nmax-1,j0,1)*legjy(:nmax-1,j0,0)
      psid(:nmax-1,p02,0) = legjy(:nmax-1,j0,1)*ijy(:nmax-1,j02,0) +
     1   legjy(:nmax-1,j02,1)*ijy(:nmax-1,j2,0) + ijy(:nmax-1,j0,1)*
     2   legjy(:nmax-1,j02,0) + ijy(:nmax-1,j02,1)*legjy(:nmax-1,j2,0)
      psid(:nmax-1,p022,0) = legjy(:nmax-1,j0,1)*ijy(:nmax-1,j022,0) +
     1   legjy(:nmax-1,j02,1)*ijy(:nmax-1,j22,0) + legjy(:nmax-1,j022,1)
     2   *ijy(:nmax-1,j2,0) + ijy(:nmax-1,j0,1)*legjy(:nmax-1,j022,0) +
     3   ijy(:nmax-1,j02,1)*legjy(:nmax-1,j22,0) + ijy(:nmax-1,j022,1)*
     4   legjy(:nmax-1,j2,0)
      psid(:nmax-1,p1,0) = legjy(:nmax-1,j1,1)*ijy(:nmax-1,j1,0) + ijy(:
     1   nmax-1,j1,1)*legjy(:nmax-1,j1,0)
      psid(:nmax-1,p11,0) = legjy(:nmax-1,j1,1)*ijy(:nmax-1,j11,0) +
     1   legjy(:nmax-1,j11,1)*ijy(:nmax-1,j1,0) + ijy(:nmax-1,j1,1)*
     2   legjy(:nmax-1,j11,0) + ijy(:nmax-1,j11,1)*legjy(:nmax-1,j1,0)

      psid(:nmax-1,p0,1) = legjy(:nmax-1,j0,3)*ijy(:nmax-1,j0,0) + ijy(:
     1   nmax-1,j0,1)*legjy(:nmax-1,j0,2)
      psid(:nmax-1,p02,1) = legjy(:nmax-1,j0,3)*ijy(:nmax-1,j02,0) +
     1   legjy(:nmax-1,j02,3)*ijy(:nmax-1,j2,0) + ijy(:nmax-1,j0,1)*
     2   legjy(:nmax-1,j02,2) + ijy(:nmax-1,j02,1)*legjy(:nmax-1,j2,2)
      psid(:nmax-1,p022,1) = legjy(:nmax-1,j0,3)*ijy(:nmax-1,j022,0) +
     1   legjy(:nmax-1,j02,3)*ijy(:nmax-1,j22,0) + legjy(:nmax-1,j022,3)
     2   *ijy(:nmax-1,j2,0) + ijy(:nmax-1,j0,1)*legjy(:nmax-1,j022,2) +
     3   ijy(:nmax-1,j02,1)*legjy(:nmax-1,j22,2) + ijy(:nmax-1,j022,1)*
     4   legjy(:nmax-1,j2,2)
      psid(:nmax-1,p1,1) = legjy(:nmax-1,j1,3)*ijy(:nmax-1,j1,0) + ijy(:
     1   nmax-1,j1,1)*legjy(:nmax-1,j1,2)
      psid(:nmax-1,p11,1) = legjy(:nmax-1,j1,3)*ijy(:nmax-1,j11,0) +
     1   legjy(:nmax-1,j11,3)*ijy(:nmax-1,j1,0) + ijy(:nmax-1,j1,1)*
     2   legjy(:nmax-1,j11,2) + ijy(:nmax-1,j11,1)*legjy(:nmax-1,j1,2)

      return
      end subroutine pot


      subroutine reactall(ua, du, c, fm, t, chil, nmax, nmax1, imax,
     1   imax1, lam1a, legjy, psid, legp, harr, ze, lmaxa, lmaxa1, react
     2   , reactl, chila, work)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, nmax1, imax, imax1, lmaxa, lmaxa1
      real(kind=dp) du, c, t, ze
      real(kind=dp), dimension(0:nmax - 1) :: ua, fm
      real(kind=dp), dimension(0:nmax1 - 1,lmaxa1) :: chil
      real(kind=dp), dimension(0:imax - 1) :: lam1a
      real(kind=dp), dimension(0:nmax1 - 1,0:6,0:3,lmaxa1) :: legjy
      real(kind=dp), dimension(0:nmax1 - 1,0:4,0:1) :: psid
      real(kind=dp), dimension(0:imax1 - 1,lmaxa1) :: legp
      real(kind=dp), dimension(((lmaxa1 - 1)*
     1  lmaxa1*(2*lmaxa1-1))/6+(lmaxa1-1)*lmaxa1+lmaxa1):: harr
      real(kind=dp), dimension(0:imax1 - 1,0:nmax - 1) :: react
      real(kind=dp), dimension(0:nmax - 1) :: reactl, chila
      real(kind=dp), dimension(0:nmax + (nmax1 + 1)*7*2 - 1) :: work
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: la, la1, la2, n, i
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      EXTERNAL reaction
C-----------------------------------------------

      react(:imax-1,:nmax-1) = 0

      do la1 = 1, lmaxa
         reactl(:nmax-1) = 0
         do la = la1, lmaxa
            chila(:nmax-1) = 0
            do la2 = 1, la
               chila(:nmax-1) = chila(:nmax-1) + harr(((la-1)*la*(2*la-1
     1            ))/6+(la1-1)*la+la2)*chil(:nmax-1,la2)
            end do
            call reaction (ua, du, c, fm, t, chila, nmax, nmax1, legjy(0
     1         ,0,0,la), psid, ze, reactl, max(2*la - 1,0), work)
         end do

         do n = 0, nmax - 1
            react(:imax-1,n) = react(:imax-1,n) + reactl(n)*legp(:imax-1
     1         ,la1)
         end do
      end do

      do n = 0, nmax - 1
         react(:imax-1,n) = react(:imax-1,n)/lam1a(:imax-1)
      end do

      return
      end subroutine reactall


      subroutine reaction(ua, du, c, fm, t, chil, nmax, nmax1, legjy,
     1   psid, ze, reactl, l, work)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, nmax1, l
      real(kind=dp) du, c, t, ze
      real(kind=dp), dimension(0:nmax - 1) :: ua, fm, chil
      real(kind=dp), dimension(0:nmax1 - 1,0:6,0:3) :: legjy
      real(kind=dp), dimension(0:nmax1 - 1,0:4,0:1) :: psid
      real(kind=dp), dimension(0:nmax - 1) :: reactl
      real(kind=dp), dimension(0:nmax + (nmax1 + 1)*7*2 - 1) :: work
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
      integer, parameter :: p0 = 0
      integer, parameter :: p02 = 1
      integer, parameter :: p022 = 2
      integer, parameter :: p1 = 3
      integer, parameter :: p11 = 4
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n
      real(kind=dp) :: pi, u, g
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      EXTERNAL pot
C-----------------------------------------------

      call pot (ua, du, c, fm, chil, nmax, nmax1, legjy, psid, work(0),
     1   work(nmax))

      pi = 4*atan(1.0E0)
      do n = 0, nmax - 1
         u = ua(n)
         g = sqrt(1 + (u/c)**2)
         reactl(n) = reactl(n) + ze*4*pi*(fm(n)*chil(n)/g-u/t*psid(n,p1,
     1      1)-2/(c**2*g)*psid(n,p1,0)+2*u/(c**2*t)*psid(n,p11,1)+u/t*
     2      psid(n,p0,1)-(u**2/(g*t**2)-1/t)*psid(n,p0,0)+(2*g*u/t**2-2*
     3      u/(c**2*t))*psid(n,p02,1)-(l*(l+1)/(g*t**2)-2/(c**2*t))*psid
     4      (n,p02,0)-8*g*u/(c**2*t**2)*psid(n,p022,1)+4*((l+2)*(l-1)/g+
     5      2*g)/(c**2*t**2)*psid(n,p022,0))
      end do

      return
      end subroutine reaction


      subroutine residue(ua, nmax, nmax1, csth0a, imax, imax1, chi, dtt
     1   , c, lam1a, uinv, th0inv, resid)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, nmax1, imax, imax1
      real(kind=dp) c
      real(kind=dp), dimension(0:nmax - 1) :: ua
      real(kind=dp), dimension(0:imax - 1) :: csth0a
      real(kind=dp), dimension(0:imax1 - 1,0:nmax - 1) :: chi
      real(kind=dp), dimension(0:nmax - 1) :: dtt
      real(kind=dp), dimension(0:imax - 1) :: lam1a
      real(kind=dp), dimension(0:nmax1 - 1,-1:1) :: uinv
      real(kind=dp), dimension(0:imax1 - 1,-1:1) :: th0inv
      real(kind=dp), dimension(0:imax1 - 1,0:nmax - 1) :: resid
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n, i
C-----------------------------------------------
C   Add in electric field term
C  $$\frac{v \cos\theta_0}{\lambda_1}. $$
C
      do n = 0, nmax - 1
         resid(:imax-1,n) = resid(:imax-1,n) + csth0a(:imax-1)/lam1a(:
     1      imax-1)*ua(n)/sqrt(1 + (ua(n)/c)**2)
      end do
C
C   Normalize to pitch-angle diffusion coefficient and add in
C   differential terms.
C
      do n = 0, nmax - 1
         resid(:imax-1,n) = resid(:imax-1,n)*ua(n)**2/dtt(n) + chi(:imax
     1      -1,n-1)*uinv(n,-1) + chi(:imax-1,n)*uinv(n,0) + chi(:imax-1,
     2      n+1)*uinv(n,1) + chi(-1:imax-2,n)*th0inv(:imax-1,-1) + chi(:
     3      imax-1,n)*th0inv(:imax-1,0) + chi(1:imax,n)*th0inv(:imax-1,1
     4      )
      end do

      return
      end subroutine residue


      subroutine runa(t, c2, ze, zi, eps, nmax, umax, imax, kmax, dt,
     1   tmax, alpha, rho, lmax, tskip, npsi0, dla, ba, alenb, thetps,
     2   thetpe, psimx, psimn, iout3, iout4, iout5, iout7, iout8, iswchi
     3   , aerrmx, rerrmx)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
C
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, imax, kmax, tmax, lmax, tskip, npsi0, iout3, iout4,
     1   iout5, iout7, iout8, iswchi
      real(kind=dp) t, c2, ze, zi, eps, umax, dt, alpha, rho, psimx,
     1    psimn,
     1   aerrmx, rerrmx
      real(kind=dp), dimension(0:kmax - 1) :: dla, ba
      real(kind=dp), dimension(npsi0) :: alenb
      real(kind=dp), dimension(0:kmax) :: thetps
      real(kind=dp), dimension(0:kmax - 1) :: thetpe
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n, np, nmax1, imax1, lmaxa, lmaxa1, worksize, pwork,
     1   pua, pug, pth0a, pth0g, pcsth0a, pchi, plegjy, pchil, plegp,
     2   pduug, pfu, pdtt, pfm, ppsid, plam1a, plam2g, pharr, puinv,
     3   pth0inv, presid, presida, ierc, ierd, memsize
      real(kind=dp), dimension(npsi0) :: bmax, bmin, psis
      real(kind=dp) :: dene, teme
      real(kind=dp), allocatable, save, dimension(:) :: memory
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      EXTERNAL runb
C-----------------------------------------------
c
c   Common block for Comdynray
c

C
C
C
C  indices for ua,ug,th0a,th0g,csth0a,chi,legjy,chil,legp,duug,
C               fu,dtt,fm,psid,lam1a,lam2g,harr,uinv,th0inv,resid,
C               resida







C
C  allocate memory
C


      nmax1 = nmax
      imax1 = imax
      if (mod(nmax1,2) == 1) nmax1 = nmax1 + 1
      if (mod(imax1,2) == 0) imax1 = imax1 + 1

C  |nmax1| and |imax1| are the allocated dimensions for two-dimensional
C  arrays.These might differ from |nmax| and |imax| on the Crays, where
C   strides are inefficiently handled.
C   To avoid memory conflicts on the Crays
C   Make even for accessing
C              |ijy(0:nmaxa1,0:6,0:1)| by row in |potential|
C    Make odd for accessing
C        |chi(0:imax1-1,0:nmax-1)| by row in |decomp|


C |lmaxa1| is the allocated dimension for the |la| index.  This is
C  usually |lmaxa| but must be at least $1$ to ensure that dimension
C  specifications such as |1:lmaxa1| are legal.  Also $H_{1,1,1}$ is needed
C        even when |lmaxa=0|.


C  Round |lmax| down to an odd number
C  |lmaxa1| needs to be at least 1
C
      if (mod(lmax,2) == 0) lmax = lmax - 1
      lmaxa = (lmax + 1)/2
      lmaxa1 = lmaxa
      if (lmaxa1 == 0) lmaxa1 = 1

C  count memory size
C
      memsize = 0
      worksize = 0
C
      pua = memsize
      memsize = memsize + nmax
C
      pug = memsize
      memsize = memsize + nmax + 1
C
      pth0a = memsize
      memsize = memsize + imax
C
      pth0g = memsize
      memsize = memsize + imax + 1
C
      pcsth0a = memsize
      memsize = memsize + imax
C
      pchi = memsize
      memsize = memsize + imax1*nmax
C
      plegjy = memsize
      memsize = memsize + nmax1*7*4*(lmaxa1 + 1)
C
C Figure the workspace for |initjy| (|jarray| and |djarray|).
C
      worksize = max(worksize,2*(max(2*lmaxa - 1,0) + 2 + 1)*7*2)
C
C   Workspace for |potential| (|fla| and |ijy|)
C
      worksize = max(worksize,nmax + (nmax1 + 1)*7*2)
C
C  indices for chil, legp
C
      pchil = memsize
      memsize = memsize + nmax1*lmaxa1

      plegp = memsize
      memsize = memsize + imax1*lmaxa1
C
C  Workspace for |initp|  (|leg0|).
C
      worksize = max(worksize,imax)
C
C  Indices for duug,fu,dtt,fm,psid

      pduug = memsize
      memsize = memsize + nmax + 1

      pfu = memsize
      memsize = memsize + nmax

      pdtt = memsize
      memsize = memsize + nmax

      pfm = memsize
      memsize = memsize + nmax

      ppsid = memsize
      memsize = memsize + nmax1*5*2
C
C  Workspace for |reactall| (|reactl| and |chila|) and for |potential|
C  (|fla| and |ijy|).
C
      worksize = max(worksize,nmax*2 + nmax + (nmax1 + 1)*7*2)
C
C  Indices of lam1a,lam2g,harr
C
      plam1a = memsize
      memsize = memsize + imax

      plam2g = memsize
      memsize = memsize + imax + 1

      pharr = memsize
      memsize = memsize + (((lmaxa1 - 1)*lmaxa1*(2*lmaxa1 - 1))/6 + (
     1   lmaxa1 - 1)*lmaxa1 + lmaxa1)
C
C  Workspace for |hinit| (|garr|).
C
      worksize = max(worksize,(((lmaxa1 + 3) - 1)*(lmaxa1 + 3))/2 + (
     1   lmaxa1 + 1))
C
C  Workspace for |error| (|aerr| and |rerr|).
C
      worksize = max(worksize,2*imax)
C
C  Indices for uinv,th0inv,resid,resida
C
      puinv = memsize
      memsize = memsize + nmax1*3

      pth0inv = memsize
      memsize = memsize + imax1*3

      presid = memsize
      memsize = memsize + imax1*nmax

      presida = memsize
      memsize = memsize + imax1*nmax
C
C  Workspace for |current| (|cur|).
C
      worksize = max(worksize,imax)
C
C  Sum memsize and worksize
C
      pwork = memsize
      memsize = memsize + worksize
C
C  allocate memory
C
c      call hpalloc(memptr,memsize,ierc,1)
      if (.not.allocated(memory)) then
         ALLOCATE(memory(memsize),stat=ierc)
         if (ierc /= 0) then
            print *, 'memory could not be allocated in runa'
            return
         endif
      endif
c      call bcast (memory, memsize)
      memory = 0.
      read (iout3, 2020) thetps
      read (iout3, 2020) thetpe
      do np = 1, npsi0
         read (iout3, 2010) psis(np)
         read (iout3, 2020) dla
         read (iout3, 2020) ba
         read (iout3, 2010) alenb(np), bmax(np), bmin(np)
c
         call subpar (psis(np), dene, teme, zi)
         write (iout5, 3000) psis(np), dene, teme
c
c   teme in Kev
c
         c2 = 511.925/teme
c
         call runb (t, c2, ze, zi, eps, nmax, umax, imax, kmax, dt, tmax
     1      , alpha, rho, lmax, tskip, nmax1, imax1, lmaxa, lmaxa1,
     2      worksize, memory(pua), memory(pug), memory(pth0a), memory(
     3      pth0g), memory(pcsth0a), memory(pchi), memory(plegjy),
     4      memory(pchil), memory(plegp), memory(pduug), memory(pfu),
     5      memory(pdtt), memory(pfm), memory(ppsid), memory(plam1a),
     6      memory(plam2g), memory(pharr), memory(puinv), memory(pth0inv
     7      ), memory(presid), memory(presida), memory(pwork), npsi0,
     8      dla, ba, alenb, thetps, thetpe, np, bmax, bmin, iout3, iout4
     9      , iout5, iout7, iout8, iswchi, aerrmx, rerrmx)
C
C  Deallocate memory
C
      end do
c      call hpdeallc(memptr,ierc,0)
c     if (allocated(memory)) then
c        print *, 'memory still allocated'
c        DEALLOCATE(memory, stat=ierd)
c        print *, 'ierd=', ierd
c     endif
c     print *, 'memory deallocated'
c-----------------------------
 2010 format(4(2x,e20.12))
 2020 format(5(2x,e20.12))
 3000 format(4(2x,e20.12))

      return
      end subroutine runa

      subroutine runb(t, c2, ze, zi, eps, nmax, umax, imax, kmax, dt,
     1   tmax, alpha, rho, lmax, tskip, nmax1, imax1, lmaxa, lmaxa1,
     2   worksize, ua, ug, th0a, th0g, csth0a, chi, legjy, chil, legp,
     3   duug, fu, dtt, fm, psid, lam1a, lam2g, harr, uinv, th0inv,
     4   resid, resida, work, npsi0, dla, ba, alenb, thetps, thetpe, np
     5   , bmax, bmin, iout3, iout4, iout5, iout7, iout8, iswchi, aerrmx
     6   , rerrmx)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
C
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, imax, kmax, tmax, lmax, tskip, nmax1, imax1, lmaxa,
     1   lmaxa1, worksize, npsi0, np, iout3, iout4, iout5, iout7, iout8
     2   , iswchi
      real(kind=dp) t, c2, ze, zi, eps, umax, dt, alpha, rho,
     1    aerrmx, rerrmx
      real(kind=dp), dimension(0:nmax - 1) :: ua
      real(kind=dp), dimension(0:nmax) :: ug
      real(kind=dp), dimension(0:imax - 1) :: th0a
      real(kind=dp), dimension(0:imax) :: th0g
      real(kind=dp), dimension(0:imax - 1) :: csth0a
      real(kind=dp), dimension(0:imax1 - 1,0:nmax - 1) :: chi
      real(kind=dp), dimension(0:nmax1 - 1,0:6,0:3,0:lmaxa1) :: legjy
      real(kind=dp), dimension(0:nmax1 - 1,lmaxa1) :: chil
      real(kind=dp), dimension(0:imax1 - 1,lmaxa1) :: legp
      real(kind=dp), dimension(0:nmax) :: duug
      real(kind=dp), dimension(0:nmax - 1) :: fu, dtt, fm
      real(kind=dp), dimension(0:nmax1 - 1,0:4,0:1) :: psid
      real(kind=dp), dimension(0:imax - 1) :: lam1a
      real(kind=dp), dimension(0:imax) :: lam2g
      real(kind=dp), dimension(((lmaxa1 - 1)*lmaxa1
     1  *(2*lmaxa1 - 1))/6+(lmaxa1-1)*lmaxa1+lmaxa1):: harr
      real(kind=dp), dimension(0:nmax1 - 1,-1:1) :: uinv
      real(kind=dp), dimension(0:imax1 - 1,-1:1) :: th0inv
      real(kind=dp), dimension(0:imax1 - 1,0:nmax - 1) :: resid, resida
      real(kind=dp), dimension(0:worksize - 1) :: work
      real(kind=dp), dimension(0:kmax - 1) :: dla, ba
      real(kind=dp), dimension(npsi0) :: alenb
      real(kind=dp), dimension(0:kmax) :: thetps
      real(kind=dp), dimension(0:kmax - 1) :: thetpe
      real(kind=dp), dimension(npsi0) :: bmax, bmin
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: itim, n, i, time
      real(kind=dp)::dthp,du,dth0,th0max,pi,c,deltb,abserr,relerr,curv,
     1   cond,e
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real(kind=dp) , EXTERNAL :: deltab, lam1, lam2, current
      EXTERNAL initjy, initp, maxwel, isotrop, hinit, matinit, decomp,
     1   reactall, residue, error, solve
C-----------------------------------------------
C
C  Velocity space meshes
C

C
C   Array holding Legendre functions
C
C
C  Legendre decomposition of chi
C
C
C

C
C
C   Arrays to hold various flux averaged quantities.
C
C
C  Matrices for inversion
C
C
C  Time advancement;  residues
C
C
C   Current and conductivity
C  The conductivity is define as $J_{0\parallel}/E_{0\parallel}$ where
C    $$E_{0\parallel} = B_0\frac{\int E_{\parallel} dl}{\int B\,dl}.$$
C    Substituting $E_\parallel = (B_\zeta/B) \Phi/(2\pi R)$ and
C    $\Phi=TQ/L$ gives $E_\parallel = T/\int b \,dl/L$.
C

C
C
C  Initialize velocity meshes, chi etc.
C
      du = umax/nmax
      do n = 0, nmax - 1
         ua(n) = (n + 0.5E0)*du
         ug(n) = n*du
      end do
      ug(nmax) = umax

      pi = 4*atan(1.0E0)
      deltb = (bmax(np)-bmin(np))/bmin(np)
      th0max = atan2(1.0E0_dp,sqrt(deltb))
      eps = deltb/(2. + deltb)
      dth0 = th0max/imax
      do i = 0, imax - 1
         th0a(i) = (i + 0.5E0)*dth0
         csth0a(i) = cos(th0a(i))
         th0g(i) = i*dth0
      end do
      th0g(imax) = th0max

C
C  Set up trial chi-function
C
      if (np == 1) then
         if (iswchi == 0) then
            chi(:imax-1,:nmax-1) = 0
         else
            read (iout7, 3030) ((chi(i,n),i=0,imax - 1),n=0,nmax - 1)
         endif
      endif
C
C   Fill the arrays
C
      c = sqrt(c2)
      lmaxa = (lmax + 1)/2
      call initjy (ua, c, nmax, nmax1, lmaxa, lmaxa1, legjy, work(0),
     1   work(2*(max(2*lmaxa-1,0)+2+1)*7), max(2*lmaxa - 1,0) + 2)
C
C  Initialize legp
C
      call initp (csth0a, imax, imax1, lmaxa, lmaxa1, legp, work)
C
C  Initialize isotropic terms.
C
      call maxwel (ua, du, c, nmax, fm, t)

      chil(:nmax-1,1) = 1

      call isotrop (ua, du, c, fm, chil(0,1), nmax, nmax1, legjy(0,0,0,0
     1   ), psid, ze, zi, duug, fu, dtt, work)
C
C  Initialize lam1a,lam2g,harr
C
      dthp = thetpe(1) - thetpe(0)
      do i = 0, imax - 1
         lam1a(i) = lam1(eps,th0a(i),kmax,dthp,dla(0),ba(0))
      end do

      do i = 0, imax
         lam2g(i) = lam2(eps,th0g(i),kmax,dthp,dla(0),ba(0))
      end do

      call hinit (eps, kmax, lmaxa1, harr, work, dthp, dla(0), ba(0))
C
C  Initialize matrices for inversion.
C
      call matinit (du, ua, ug, nmax, nmax1, dth0, th0a, th0g, imax,
     1   imax1, duug, fu, dtt, lam1a, lam2g, uinv, th0inv, rho)
C
C  time evolution of solution
C
      itim = 0
      do time = 0, tmax
         if (itim /= 1) then
C
C  Calculate reaction term.
C
            call decomp (chi, nmax, nmax1, imax, imax1, lmaxa, lmaxa1,
     1         th0a, dth0, legp, chil)
            call reactall (ua, du, c, fm, t, chil, nmax, nmax1, imax,
     1         imax1, lam1a, legjy(0,0,0,1), psid, legp, harr, ze, lmaxa
     2         , lmaxa1, resid, work(0), work(nmax), work(2*nmax))
C
C  Calculate residue and its norm
C
            call residue (ua, nmax, nmax1, csth0a, imax, imax1, chi, dtt
     1         , c, lam1a, uinv, th0inv, resid)
            if (mod(time,tskip) == 0) call error (du, ua, umax, nmax,
     1         dth0, th0a, th0max, imax, imax1, resid, chi, abserr,
     2         relerr, work(0), work(imax))
C
C  Advance chi
C
            call solve (resida, imax1, nmax, 1, imax, uinv(0,-1), uinv(0
     1         ,0), uinv(0,1), resid, dt, alpha)
            call solve (resid, 1, imax, imax1, nmax, th0inv(0,-1),
     1         th0inv(0,0), th0inv(0,1), resida, dt, alpha)

            chi(:imax-1,:nmax-1) = chi(:imax-1,:nmax-1) + dt*resid(:imax
     1         -1,:nmax-1)
C
C  compute current and conductivity.
C
            if (mod(time,tskip) == 0) then
               curv = current(du,ua,c,nmax,dth0,th0a,imax,imax1,fm,chi,
     1            work)
               e = t/harr(((1-1)*1*(2*1-1))/6+(1-1)*1+1)
               cond = curv*zi/(t*sqrt(t)*e)
               write (iout4, 4020) time, cond, abserr, relerr
 4020          format(2x,i5,3x,e20.12,2x,e16.8,2x,e16.8)
            endif
            if (abserr<aerrmx .and. relerr<rerrmx) itim = 1
         endif
      end do
C
C  Write out results.
C
      write (iout5, 3010) nmax, imax, kmax, lmax
      write (iout5, 3020) t, c2, ze, zi, eps
      write(iout5,3020)umax,th0max,du,dth0,rho,deltb,bmin(np),bmax(np)
      write (iout5, 3040) dt, tmax, alpha
      write (iout5, 3020) cond, abserr, relerr
      write (iout5, 3030) ua
      write (iout5, 3030) ug
      write (iout5, 3030) th0a
      write (iout5, 3030) th0g
      write (iout5, 3030) lam1a
      write (iout5, 3030) fm
      write (iout5, 3030) ((chi(i,n),i=0,imax - 1),n=0,nmax - 1)
      if(np==1)write(iout8,3030)((chi(i,n),i=0,imax-1),n=0,nmax-1)
c-----------------------------
c
 3010 format(1x,4i8)
 3020 format(4(1x,e20.12))
 3030 format(5(1x,e20.12))
 3040 format(1x,e20.12,2x,i8,2x,e20.12)
C
      return
      end subroutine runb


      subroutine solve(x, ns, n, ms, m, a, b, c, z, dt, alpha)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
C
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer ns, n, ms, m
      real(kind=dp) dt, alpha
      real(kind=dp), dimension(0:ms - 1,0:*) :: x
      real(kind=dp), dimension(0:n - 1) :: a, b, c
      real(kind=dp), dimension(0:ms - 1,0:*) :: z
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, k
      real(kind=dp) :: dt2, den
C-----------------------------------------------

      dt2 = -alpha*dt

      i = 0
      den = 1 + dt2*b(i)
      x(ns*i,:m-1) = z(ns*i,:m-1)/den
      z(ns*i,:m-1) = -dt2*c(i)/den

      do i = 1, n - 2
         do k = 0, m - 1
            den = 1 + dt2*(b(i)+a(i)*z(ns*(i-1),k))
            x(ns*i,k) = (z(ns*i,k)-dt2*a(i)*x(ns*(i-1),k))/den
            z(ns*i,k) = -dt2*c(i)/den
         end do
      end do

      i = n - 1
      do k = 0, m - 1
         den = 1 + dt2*(b(i)+a(i)*z(ns*(i-1),k))
         x(ns*i,k) = (z(ns*i,k)-dt2*a(i)*x(ns*(i-1),k))/den
         z(ns*i,k) = 0
      end do





      do i = n - 2, 0, -1
         x(ns*i,:m-1) = z(ns*i,:m-1)*x(ns*(i+1),:m-1) + x(ns*i,:m-1)
      end do

      return
      end subroutine solve
      subroutine subadj(zef1, nmax, umax, imax, nthp0, dt, tmax, alpha,
     1   rho, lmax, iout3, iout5, iout4, iout7, iout8, iswchi, aerrmx,
     2   rerrmx)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
C
C  calculates the Spitzer function chi(theta,ua) and output to adjout
C
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, imax, nthp0, tmax, lmax, iout3, iout5, iout4, iout7
     1   , iout8, iswchi
      real(kind=dp) zef1, umax, dt, alpha, rho, aerrmx, rerrmx
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer::tskip, dlaptr, baptr, alnptr, ndum
      integer::thsptr, theptr, ii, npsi0, iercd
      real(kind=dp) :: psimx, psimn, t, c2, ze, zi, eps, cpu, cpu0
      real(kind=dp),allocatable,save, dimension(:) :: dum
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      EXTERNAL runa
C-----------------------------------------------
c
c   Common block for Comdynray
c
c     pointer(dumptr,dum(1))
C
C
      read (iout3, 2000) nthp0, npsi0
      read (iout3, 2010) psimx, psimn
      ii = 1
      dlaptr = ii
      ii = ii + nthp0
      baptr = ii
      ii = ii + nthp0
      alnptr = ii
      ii = ii + npsi0
      thsptr = ii
      ii = ii + nthp0 + 1
      theptr = ii
      ii = ii + nthp0
      ndum = ii
c      call hpalloc(dumptr,ndum,iercd,1)
      if (.not.allocated(dum)) then
         ALLOCATE(dum(ndum),stat=iercd)
         if (iercd /= 0) then
            print *, 'dum could not be allocated in subadj'
            return
         endif
      endif
      write (iout5, 2000) nthp0, npsi0
      write (iout5, 2010) psimx, psimn
      t = 1.E0
      ze = 1.E0
      dt = 1
c     tmax=250
      alpha = 0.55
      rho = 1
C     lmax=21
C     nmax=100
C     umax=10
C     imax=200
C
      tskip = 10
!      call second (cpu0)
      call runa (t, c2, ze, zi, eps, nmax, umax, imax, nthp0, dt, tmax,
     1   alpha, rho, lmax, tskip, npsi0, dum(dlaptr), dum(baptr), dum(
     2   alnptr), dum(thsptr), dum(theptr), psimx, psimn, iout3, iout4,
     3   iout5, iout7, iout8, iswchi, aerrmx, rerrmx)
!      call second (cpu)
!      write (iout4, 4030) cpu - cpu0
c      call hpdeallc(dumptr,iercd,0)
      DEALLOCATE(dum)
 4030 format(1x,'adj CPU time: ',f8.4,' secs.')
c----------------------
 2000 format(1x,2i8)
 2010 format(4(2x,e20.12))
      return
      end subroutine subadj
      subroutine xtrema(imx, xmx, ymx, dymx, nwk, wkt, wk, wk1, ier)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01
C...Switches: -p4 -yb
C
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer imx, nwk, ier
      real(kind=dp) xmx, ymx, dymx
      real(kind=dp), dimension(nwk) :: wkt, wk
      real(kind=dp), dimension(nwk,3) :: wk1
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: it
      real(kind=dp), dimension(1) :: x0, y0, dy0, x1, y1, dy1
      real(kind=dp) :: h, dx
C-----------------------------------------------
      x0(1) = wkt(imx)
      y0(1) = wk(imx)
      h = wkt(2) - wkt(1)
      call mcsevu1 (h, wkt(1), wk, nwk, wk1, nwk, 1, dy0, x0, ier)
      dx = 0.5*h
      it = 0
      ier = 0
   50 continue
      x1(1) = x0(1) + dx
      call mcsevu (h, wkt(1), wk, nwk, wk1, nwk, 1, y1, x1, ier)
      call mcsevu1 (h, wkt(1), wk, nwk, wk1, nwk, 1, dy1, x1, ier)
      dx = (x1(1)-x0(1))*dy1(1)/(dy0(1)-dy1(1))
      x0(1) = x1(1)
      y0(1) = y1(1)
      dy0(1) = dy1(1)
      it = it + 1
      if (it > 50) then
         ier = 19
         return
      endif
      if (abs(dx)<1.E-8*h .or. abs(dy0(1))<1.E-8) go to 100
      go to 50
  100 continue
      xmx = x0(1)
      ymx = y0(1)
      dymx = dy0(1)
      return
      end subroutine xtrema

      subroutine cntour(xaxd, yaxd, psivl, xemin, xemax, yemin, yemax, 
     1   yxmin, yxmax, xymin, xymax, dang, arcl, bperr, dx, dy, xmin, 
     2   xmax, ymin, ymax, iauto, iautoc, xc, yc, ipts, x, nw, y, nh, 
     3   cspln, n2cspln, nh2, itty, iptsm, ierr, bpmag, iconvg)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:58:46   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer iauto, iautoc, ipts, nw, nh, n2cspln, nh2, itty, iptsm, 
     1   ierr, iconvg
      real xaxd, yaxd, psivl, xemin, xemax, yemin, yemax, yxmin, yxmax, 
     1   xymin, xymax, dang, arcl, bperr, dx, dy, xmin, xmax, ymin, ymax
      real, dimension(1) :: xc, yc
      real, dimension(nw) :: x
      real, dimension(nh) :: y
      real, dimension(n2cspln,nw,nh2) :: cspln
      real, dimension(1) :: bpmag
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: nitr8, iprint, itry, ier, isgn, iflg, newti, ihalf
      real, dimension(6) :: pds
      real :: pi, piov2, piov4, fpiov4, spiov4, twopi, tpiov4, tpiov2, 
     1   psiin, bperrsav, dbperr, psiaxd, thet, dthet0, dthet1, dthet, 
     2   dxx, dyy, dxmin, serrt, derrt, a, bincp, thet1, x1, y1, cost, 
     3   sint, psi1, x2, y2, psi2, dpsi, xn, yn, dpsids, serr, delx, 
     4   dely, bp2, bp1, rad1, psivln, psiout, psivl0, dapsi
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real , EXTERNAL :: write
C-----------------------------------------------
c-----------------------------------------------------------------------
c    this routine uses the bicubic spline representation of psi to get
c    psi values at an arbitrary point on the mhd grid. the spline
c    coefficients must exist (in cspln) before this subroutine is called.
c     given (xaxd,yaxd) and a psi value, psivl, generate a contour of
c     ordered points,(xc(i),yc(i)), i=1,ipts, which has (xaxd,yaxd) as
c     as an interior point. the contour must fully encircle (xaxd,yaxd).
c     the search is limited to a rectangle specified by (xmin,xmax,ymin
c     ymax).  dx and dy determine the basic increment in x and y for
c     the coarse grid search.  they should be picked so that over the
c     distance dx or dy, psi is single valued.  a sliding interval
c     search rather than a binary search is used for the coarse grid so
c     that non-monotonic psi can be handled.  dx and dy are in meters.
c     dx=dy=0.01 is suggested.  dang is angular step for the rays which
c     emmanate from (xaxd,yaxd) in degrees.  dang should be set
c     according to shape of equilibrium.  if dang is too small, many
c     unnecessary points will be generated in (xc,yc).  if dang is too
c     large for bperr(see below), the routine wastes computation time
c     reducing the magnitude of dang.  dang=10 deg. near psilim and
c     dang=30 deg. near psimax is suggested.  for highly elongated
c     plasmas control with dang is difficult to set for all contours.
c     therefore arcl may be used to set dang internally.  arcl is the
c     arclength in meters taken from the current point to get to the
c     next point.  set arcl to a large number (e.g. 10 meters) to
c     overide this option and use dang only.  the angle increment will
c     be the minimum of (arcl/rad,dang).  bperr is relative change in
c     poloidal b field between (xc(i),yc(i)) and (xc(i+1),yc(i+1)).
c     if the number of elements (xc,yc) exceeds the limit
c     bperr is relaxed (up to twice) by a constant increment
c     dbperr before an error exit is taken.
c     bperr=0.03 is suggested.  note: if dang yields bperr(computed)<
c     bperr(input), then dang is used.  otherwise dang is successively
c     reduced by 0.5 until this condition is meet.  (xemin,xemax,yemin,
c     yemax) are min and max values of contour.  (yxmin,yxmax), are y
c     values at x=xemin and x=xemax respectively.  (xymin,xymax) are x
c     values at y=yemin and y=yemax respectively.  iauto is used as an
c     "error recovery switch".  that is, if a flux surface is found to
c     pass outside the search box an error exit is taken by way of label
c     1000, if iauto=0.  if iauto=1, the input value of psi, psivl, is
c     increased toward the value of psi at (xaxd,yaxd) until a closed
c     surface inside the search box is found.  obviously this option
c     makes sense only for the limiter flux surface.  it could be used
c     to find the plasma boundary if an appopriate search box were
c     defined.  however its primary use here is to slightly modify
c     psilim so that a closed limiter flux surface is found.  the option
c     is necessary due to the fact some codes generate eqdsks
c     using linear interpolation, which differs from the bicubic inter-
c     polation used here.  the user is informed that psivl was changed
c     by returning iautoc=1.  if no change occured iautoc=0.
c    if no error ocurred ierr=0 is returned. if an error ocurred then
c    ierr=1 is returned and the results of this calculation are not valid.
c---input (see description above)
c  xaxd
c  yaxd
c  psivl   psi value for which contour is desired
c  dang
c  arcl
c  bperr   dang,arcl,bperr control point density on contour returned
c  dx
c  dy      defines step length taken
c          input dx and dy as 0.0 to set step length in this subroutine
c  xmin
c  xmax
c  ymin
c  ymax    define the search box
c             NOTE: the search box could be defined as the entire
c                   mhd grid (ie xmin=x(1),xmax=x(nw),ymin=y(1),
c                   ymax=y(nh)) However this will normally not work
c                   satisfactorily because there are local minima and
c                   maxima around the f coils which would confuse the
c                   contour tracing and require many more calculations.
c                   (these additional calculations are not done here!)
c                   The best way to define the search box is to set it
c                   equal to a rectangle,within which the plasma must
c                   reside under all circumstances. The only such
c                   rectangle to suggest itself is the one defined by
c                   the extremes of the limiter. Hence it is suggested
c                   that xmin be set to the min x value of the limiter
c                   points vector,xmax the max x value of limiter points
c                   vector and similarly for ymin,ymax.
c  iaouto  =1 automatic error recovery,=0 no recovery
c             (iauto may be set to 0 in this subroutine
c              if a failure occurs)
c  x(1..nw)
c  y(1..nh)   the mhd grid vectors
c  cspln(n2cspln,nw,nh2)  bicubic spline coefficient array
c  itty      iounit for diagnostic messages. set to 0 to suppress.
c  iptsm     max allowed number of points to be returned in
c            vectors xc,yc
c---output:
c  xemin
c  xemax
c  yemin
c  yemax
c  yxmin
c  yxmax
c  xymax
c  xymin    limits of contour (see above)
c  xc(1,..ipts)
c  yc(1,..ipts)   the ipts contour points found
c  bpmag(1,..ipts)    magnitude of poloidal bfield at xc,yc
c  ipts
c  ierr   error flag,=0 no error,=1 error,output not useable.
c             if ierr .gt. 1 then ierr equals the number of points found
c             on the contour up to this point. Since this number will
c             be exceeded if the code continues,the subroutine must
c             stop. The error condition on bperr has allready been relaxed
c             before this condition causes the subroutine to terminate.
c             Hence in order to continue this subroutine could be called
c             again with a larger value of arcl. (Note: in practice we have
c             not found this to be a problem,provided that iptsm is large
c             enough to begin with toi give an reasonable representation
c             of the contour).
c--------------------------------------------------------------------hsj
      data pi, piov2, piov4, fpiov4, spiov4/3.141592654, 1.570796327, 
     1   0.7853981634, 3.926990818, 5.497787145/
      data twopi, tpiov4, tpiov2, nitr8/6.283185307, 2.356194491, 
     1   4.712388904, 20/
c
c
      iprint = 0
      itry = 0
      psiin = 0.0
      ierr = 0
      iautoc = 0
      bperrsav = bperr
      dbperr = bperr/2.
c---get psi at (xaxd,yaxd)
      call dbcevl1 (x, nw, y, nh, cspln, nw, xaxd, yaxd, pds, ier, 1)
      if (ier /= 0) stop 'cnt1'
      psiaxd = pds(1)
c     if(psiaxd.lt.psivl)stop 'psiax'
    5 continue
      xemin = 1.E10
      xemax = -1.E10
      yemin = 1.E10
      yemax = -1.E10
      xymin = 0.0
      xymax = 0.0
      yxmin = 0.0
      yxmax = 0.0
      ipts = 0
      thet = 0.0
      dthet0 = twopi*dang/360.
      dthet1 = dthet0
      dthet = 0.0
      dxx = dx
      dyy = dy
      if (dxx == 0.0) dxx = x(3) - x(1)    ! 2. times grid spacing is ok
      if (dyy == 0.0) dyy = y(3) - y(1)
      dxmin = .25*(x(2)-x(1))       !sub stops if dxx becomes .lt. dxmin
      serrt = 3.5E-06
      derrt = 0.5E-07
c---serrt is absolute error convergence criteria for newtons method below.
c---
c---
c---loop over theta from 0 to twopi
c---
   10 continue
      thet = thet + dthet
      thet = amin1(thet,twopi)
      if (thet == twopi) go to 200
c---
c---get equation of ray emanating from (xaxd,yaxd)
      if (piov4<=thet .and. thet<=tpiov4) go to 20
      if (fpiov4<=thet .and. thet<=spiov4) go to 20
c---
c---y as a function of x            y=a*x+bincp
c---
      isgn = -1
      if (thet<piov4 .or. thet>spiov4) isgn = 1
      a = tan(thet)
      iflg = 0
      bincp = yaxd - a*xaxd
      go to 30
c---
c---x as a function of y            x=a*y+bincp
   20 continue
      isgn = 1
      if (thet > pi) isgn = -1
      if (isgn /= (-1)) then
         thet1 = piov2 - thet
         if (thet > piov2) thet1 = twopi - abs(thet1)
      else
         thet1 = tpiov2 - thet
         if (thet > tpiov2) thet1 = pi - abs(thet1)
      endif
      a = tan(thet1)
      iflg = 1
      bincp = xaxd - a*yaxd
   30 continue
c---
c---now have y=a*x+bincp    (iflg=0)   or
c---x=a*y+bincp             (iflg=1)
c---
      x1 = xaxd
      y1 = yaxd
      cost = cos(thet)
      sint = sin(thet)
      psi1 = psiaxd
c---sliding interval search. max width of interval ~1.41*(dx or dy)
   40 continue
      if (iflg /= 1) then
c---search in x
         x2 = x1 + isgn*dxx                      ! increment x
         y2 = a*x2 + bincp                ! get corresponding value of y
      else
c---search in y
         y2 = y1 + isgn*dyy
         x2 = a*y2 + bincp                ! get corresponding value of x
c  60 if((x2.lt.xmin).or.(x2.gt.xmax))go to 1000
c     if((y2.lt.ymin).or.(y2.gt.ymax))go to 1000
      endif
      x2 = amax1(x2,xmin)
      x2 = amin1(x2,xmax)
      y2 = amax1(y2,ymin)
      y2 = amin1(y2,ymax)
c                                                !error exit
      if(x2==xmin.and.x1==xmin.or.x2==xmax.and.x1==xmax)go to1000
c                                                !error exit
      if(y2==ymin.and.y1==ymin.or.y2==ymax.and.y1==ymax)go to1000
      call dbcevl1 (x, nw, y, nh, cspln, nw, x2, y2, pds, ier, 1)
      if (ier /= 0) stop 'cntour'
      psi2 = pds(1)
      dpsi = (psivl - psi1)*(psivl - psi2)
      if (dpsi <= 0.0) go to 70
      x1 = x2
      y1 = y2
      psi1 = psi2
      go to 40
c---
c---now have psivl between psi1 and psi2,converge using newton-raphson
c---
   70 continue
      newti = 0
      if (iflg /= 1) then
         xn = x1 + isgn*dxx*0.5
         yn = a*xn + bincp
      else
         yn = y1 + isgn*dyy*0.5
         xn = a*yn + bincp
      endif
   80 continue
      call dbcevl1 (x, nw, y, nh, cspln, nw, xn, yn, pds, ier, 3)
      if (ier /= 0) then
         newti = nitr8
         go to 76
      endif
      dpsids = pds(2)*cost + pds(3)*sint
      dpsi = pds(1) - psivl
      serr = -dpsi/dpsids
      if (abs(serr) < serrt) go to 90
      if (psivl==0 .and. abs(dpsi)<derrt) go to 90
      if (psivl /= 0.) then
         if (abs(dpsi/psivl) < derrt) go to 90
      endif
      delx = serr*cost
      dely = serr*sint
      xn = xn + delx
      yn = yn + dely
      newti = newti + 1
   76 continue
      if (newti >= nitr8) then
         if (dxx <= dxmin) stop 'newti'
         dxx = 0.5*dxx
         dyy = 0.5*dyy
         go to 30
      endif
      go to 80
c---end of newton iteration
c---check for sufficient accuracy in point spacing as determined by thet
c---accuracy test is based on a relative error in poloidal b field of bperr
   90 continue
      bp2 = (1./xn)*sqrt(pds(2)**2+pds(3)**2)
      if (thet == 0.0) go to 100
      dthet1 = 2.*dthet
      if (abs((bp2 - bp1)/amax1(bp2,bp1)) < bperr) go to 100
c---avoid accumulation at x points
      ihalf = ihalf + 1
c     if(ihalf.gt.4)go to 100
      if (ihalf > 8) go to 100
c---spacing too large for grad psi. decrease theta and try again
      thet = thet - dthet
      dthet = dthet*0.5
      dthet1 = dthet
      go to 10
  100 continue
      bp1 = bp2
      ipts = ipts + 1
      if (ipts > iptsm - 1) then
         if (bperr - bperrsav >= 2.*dbperr) go to 110
         bperr = bperr + dbperr
         go to 5
  110    continue
         if (itty /= 0) then
            write (itty, 1040) iptsm
 1040       format(2x,'code has to stop because more points on plasma ',
     1         /,2x,
     2'boundary were found than dimension of xcontr,ycontr allows',/,2x,
     3         'allowed number = ',i5)
         endif
         ierr = ipts
         return 
      endif
      xc(ipts) = xn
      yc(ipts) = yn
      bpmag(ipts) = bp2
      xemin = amin1(xemin,xn)
      xemax = amax1(xemax,xn)
      if (xemax == xn) yxmax = yn
      if (xemin == xn) yxmin = yn
      yemin = amin1(yemin,yn)
      yemax = amax1(yemax,yn)
      if (yemax == yn) xymax = xn
      if (yemin == yn) xymin = xn
c---limit angle increment to approximately arcl meters per step
      rad1 = sqrt((xn - xaxd)**2 + (yn - yaxd)**2)
      dthet = amin1(dthet0,arcl/rad1,dthet1)
      ihalf = 0
      go to 10
c---
c---close contour
c---
  200 continue
      if (abs(((xc(ipts)-xc(1))**2+(yc(ipts)-yc(1))**2)/(xc(1)**2+yc(1)
     1   **2)) >= 1.E-8) then
         ipts = ipts + 1
         xc(ipts) = xc(1)
         yc(ipts) = yc(1)
         bpmag(ipts) = bpmag(1)
c
         bperr = bperrsav
      endif
      if (itry/=0 .and. iconvg==1) then
         psiin = psivl
         psivln = 0.5*(psiout + psiin)
         if(abs(psivln-psivl)<1.E-06.and.itty/=0)write(itty,1045)psivln
 1045    format(2x,'final converged value of psi =',1pe16.8)
         if (abs(psivln - psivl) < 1.E-06) return 
         psivl = psivln
         go to 5
      endif
      return 
c---
c---errors
c---
c1000 if(itty.ne.0.and.iprint.eq.0)
 1000 continue
      if (itty/=0 .and. iprint<=0) write (itty, 1010) x(1), x(nw), x2, y
     1   (1), y(nh), y2
 1010 format(1x,'open contour in cntour',/,'x(1),x(nw),x = ',3(2x,e16.8)
     1   ,/,1x,'y(1),y(nh),y = ',3(2x,e16.8))
      if (iauto /= 1) then
         ierr = 1
         return 
      endif
      psivl0 = psivl
      psiout = psivl
      dapsi = psiaxd - psivl0
      psivl = psivl0 + dapsi*0.0005
      if(itry>1.and.psiin/=0.0.and.iconvg==1)psivl=0.5*(psiin+psiout)
      iautoc = 1
c     if(itty.ne.0.and.iprint.eq.0)
      if (itty/=0 .and. iprint<=0) write (itty, 1020) psivl0, psivl
 1020 format(2x,'boundary search, will change psilim from',/,e16.8,
     1   '  to  ',e16.8,'  and try again')
      itry = itry + 1
      iprint = 1
      if (itry > 20) then
         iprint = 0
         iauto = 0
         go to 1000                              !cant do it,quit
      endif
      go to 5                                    !go back and try again
      end subroutine cntour

c
      subroutine ckboot(nsp2, xmass, xchg, xt, xn, xtp, xnp, xeps, ftp, 
     1   rmajx, qloc, fmag, rnustare, xjboot)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:52:22   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nsp2
      real xeps, ftp, rmajx, qloc, fmag, rnustare, xjboot
      real, dimension(10) :: xmass, xchg, xt, xn, xtp, xnp
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: j, k, l, ia, idgt, ifail
      integer, dimension(20) :: ipiv
      real, dimension(15) :: wf, zf
      real, dimension(10) :: xint1, xint2, xint3,
     1                  xk11, xk12, xk21, xk22,
     2                  xmu1, xmu2, xmu3, xvth, xnuz, xnux,
     3                  xpr, xprp, xtau, tforce, udotb
      real, dimension(10,10) :: xsum11, xsum12, xsum22
      real, dimension(20,20) :: fmat, tmat
      real, dimension(500) :: wkspce
      real, dimension(10,10) :: xsum21
      real :: chg, pi, xeps0, xclog, ftrap, sumf1, sumf2, sumf3, fint1, 
     1   fint2, fint3, facl, sum11, sum12, sum22, xab, sum
C-----------------------------------------------
c
c
c...This subroutine is to evaluate the bootstrap parallel current
c...density on a local flux surface.
c...It returns the quantity <j.B> in MKS units.
c...The bootstrap model is the full Hirshman-Sigmar model using the
c...viscosity expression continuously valid throughout collisonality
c...space.  This subroutine calls vnt which evaluates the function
c...in the velocity space integrals.
c...C. Kessel  PPPL  1994; modified by T.K. Mau for CURRAY.
c
c... List of input arguments:
c
c    *     nsp2          =         number of species including electrons
c                                  (electron is the last species)
c    *     xmass(j)      =         mass of specie j (kg)
c    *     xchg(j)       =         charge of specie j (Coulombs)
c          xt(j)         =         temperature of specie j (eV)
c          xn(j)         =         density of specie j (m-3)
c          xtp(j)        =         dT/dpsi of specie j
c          xnp(j)        =         dn/dpsi of specie j
c          xeps          =         local inverse aspect ratio
c    *     ftp           =         ratio of trapped to passing particles
c          rmajx         =         major radius of flux surface (m)
c          qloc          =         local safety factor
c          fmag          =         diamagnetism (T-m)
c
c... List of output arguments:
c
c          rnustare      =        electron collisionality
c          xjboot        =        bootstrap current density on flux surface
c                                 in the form of <j.B> (A-T/m**2)
c
c... List of useful defined quantities:
c
c          ftrap         =         trapped particle fraction
c          xpre(j)       =         presuure of species j
c          xprp(j)       =         dp/dpsi of species j
c          xtau(j)       =         collision time of specie j
c          xnux(j)       =         collisionality of specie j
c          xnuz(j)       =         plateau colisionality of specie j
c          xmu1
c          xmu2          =         viscosity coefficients
c          xmu3
c          xsum11
c          xsum12        =         friction coefficients
c          xsum21
c          xsum22
c          tforce(j)     =        thermodynamic force of specie j
c          udotb(j)      =        flows for specie j
c
c    * means that these variables are passed into this subroutine
c      through a common and are not directly available from the
c      subroutine call argument list or the local dimension statement
c      SO YOU MUST SUPPLY THESE QUANTITIES
c
c
c
      data wf/.218234885940, .342210177923, .263027577942, .126425818106
     1   , .0402068649210, .00856387780361, .00121243614721, 
     2   .000111674392344, .00000645992676202, .000000222631690710, 
     3   .00000000422743038498, .0000000000392189726704, 
     4   .000000000000145651526407, .000000000000000148302705111, 
     5   .0000000000000000000160059490621/
      data zf/.093307812017, .492691740302, 1.215595412071, 
     1   2.269949526204, 3.667622721751, 5.425336627414, 7.565916226613
     2   , 10.120228568019, 13.130282482176, 16.654407708330, 
     3   20.776478899449, 25.623894226729, 31.407519169754, 
     4   38.530683306486, 48.026085572686/
      data chg/1.6022E-19/
      data pi/3.14159265/
      data xeps0/8.854E-12/
      data xclog/17.0/
c
      ftrap = ftp/(1. + ftp)
c
c...determine the temperature, density and pressure for each specie
c...on the flux surface in proper units
c
      xchg(:nsp2) = chg*xchg(:nsp2)
      xt(:nsp2) = chg*xt(:nsp2)
      xpr(:nsp2) = xt(:nsp2)*xn(:nsp2)
      xtp(:nsp2) = chg*xtp(:nsp2)
      xprp(:nsp2) = xt(:nsp2)*xnp(:nsp2) + xtp(:nsp2)*xn(:nsp2)
c
c...calculate required parameters like inverse aspect ratio, thermal
c...velocity, collision time, and collisionality
c
      xvth(:nsp2) = sqrt(2.0*xt(:nsp2)/xmass(:nsp2))
      xtau(:nsp2) = (12.0*pi**1.5*xeps0**2*xmass(:nsp2)**2*xvth(:nsp2)**
     1   3)/(4.0*xn(:nsp2)*xchg(:nsp2)**4*xclog)
      xnux(:nsp2) = (rmajx*qloc)/((xtau(:nsp2)*xvth(:nsp2))*(xeps**1.5))
      xnuz(:nsp2) = 2.48*qloc*rmajx/((xtau(:nsp2)*xvth(:nsp2))*(xeps**
     1   1.5))
      rnustare = xnuz(nsp2)
c
c...determine the viscosity coefficients to be used in the matrix
c...multiplying the flow vector and the thermodynamic force vector,
c...using Gauss-Laguerre quadrature for the velocity space integrals
c
      do j = 1, nsp2
         sumf1 = 0.0
         sumf2 = 0.0
         sumf3 = 0.0
         do k = 1, 15
            call vnt (j, zf(k), xn, xt, xvth, xchg, xnuz, xnux, xeps, 
     1         nsp2, fint1, fint2, fint3)
            sumf1 = sumf1 + wf(k)*fint1
            sumf2 = sumf2 + wf(k)*fint2
            sumf3 = sumf3 + wf(k)*fint3
         end do
         xint1(j) = sumf1
         xint2(j) = sumf2
         xint3(j) = sumf3
         xk11(j) = (xn(j)*xmass(j)*ftrap*xint1(j))/(xtau(j)*(1.0-ftrap))
         xk12(j) = (xn(j)*xmass(j)*ftrap*xint2(j))/(xtau(j)*(1.0-ftrap))
         xk21(j) = xk12(j)
         xk22(j) = (xn(j)*xmass(j)*ftrap*xint3(j))/(xtau(j)*(1.0-ftrap))
         xmu1(j) = xk11(j)
         xmu2(j) = xk12(j) - 2.5*xk11(j)
         xmu3(j) = xk22(j) - 5.0*xk12(j) + 6.25*xk11(j)
      end do
c
c...calculate the friction coefficients in the matrix that multiplies
c...the flow vector
c
      do j = 1, nsp2
         facl = xn(j)*xmass(j)/xtau(j)
         do k = 1, nsp2
            sum11 = 0.0
            sum12 = 0.0
            sum22 = 0.0
            if (k == j) then
               do l = 1, nsp2
                  xab = xvth(l)/xvth(j)
                  sum11 = sum11 + ((xn(l)*xchg(l)**2)/(xn(j)*xchg(j)**2)
     1               )*(-(1.0 + xmass(j)/xmass(l))/(1.0+xab**2)**1.5)
                  sum12 = sum12 + ((xn(l)*xchg(l)**2)/(xn(j)*xchg(j)**2)
     1               )*(-1.5*(1.0 + xmass(j)/xmass(l))/(1.0+xab**2)**2.5
     2               )
                  sum22 = sum22 + ((xn(l)*xchg(l)**2)/(xn(j)*xchg(j)**2)
     1               )*(-(3.25 + 4.0*xab**2 + 7.5*xab**4)/(1.0 + xab**2)
     2               **2.5)
               end do
            endif
            xab = xvth(k)/xvth(j)
            xsum11(j,k) = sum11 + ((xn(k)*xchg(k)**2)/(xn(j)*xchg(j)**2)
     1         )*((1.0 + xmass(j)/xmass(k))/(1.0+xab**2)**1.5)
            xsum12(j,k) = sum12 + ((xn(k)*xchg(k)**2)/(xn(j)*xchg(j)**2)
     1         )*(1.5*(xt(j)/xt(k))*(1.0/xab)*(1.0+xmass(k)/xmass(j))/(
     2         1.0+(1.0/xab)**2)**2.5)
            xsum21(j,k) = sum12 + ((xn(k)*xchg(k)**2)/(xn(j)*xchg(j)**2)
     1         )*(1.5*(1.0 + xmass(j)/xmass(k))/(1.0+xab**2)**2.5)
            xsum22(j,k) = sum22 + ((xn(k)*xchg(k)**2)/(xn(j)*xchg(j)**2)
     1         )*(6.75*(xt(j)/xt(k))*xab**2/(1.0+xab**2)**2.5)
            xsum11(j,k) = facl*xsum11(j,k)
            xsum12(j,k) = facl*xsum12(j,k)
            xsum21(j,k) = facl*xsum21(j,k)
            xsum22(j,k) = facl*xsum22(j,k)
         end do
      end do
c
c...load matrices according to quadrants
c
c...upper left quadrants
c
      do j = 1, nsp2
         do k = 1, nsp2
            fmat(j,k) = xsum11(j,k)
            tmat(j,k) = 0.0
            if (k == j) then
               fmat(j,k) = fmat(j,k) - xmu1(j)
               tmat(j,k) = -xmu1(j)
            endif
         end do
      end do
c
c...upper right quadrants
c
      do j = 1, nsp2
         do k = 1, nsp2
            fmat(j,k+nsp2) = -xsum12(j,k)
            tmat(j,k+nsp2) = 0.0
            if (k == j) then
               fmat(j,k+nsp2) = fmat(j,k+nsp2) - xmu2(j)
               tmat(j,k+nsp2) = -xmu2(j)
            endif
         end do
      end do
c
c...lower left quadrants
c
      do j = 1, nsp2
         do k = 1, nsp2
            fmat(j+nsp2,k) = -xsum21(j,k)
            tmat(j+nsp2,k) = 0.0
            if (k == j) then
               fmat(j+nsp2,k) = fmat(j+nsp2,k) - xmu2(j)
               tmat(j+nsp2,k) = -xmu2(j)
            endif
         end do
      end do
c
c...lower right quadrants
c
      do j = 1, nsp2
         do k = 1, nsp2
            fmat(j+nsp2,k+nsp2) = xsum22(j,k)
            tmat(j+nsp2,k+nsp2) = 0.0
            if (k == j) then
               fmat(j+nsp2,k+nsp2) = fmat(j+nsp2,k+nsp2) - xmu3(j)
               tmat(j+nsp2,k+nsp2) = -xmu3(j)
            endif
         end do
      end do
c
c...invert matrix multiplying the flow vector onto the matrix multiplying
c...the thermodynamic force vector using NAG library routine
c
c $$$$  TKM    8/98
      ia = 20
      idgt = 0
c     ib=20
c     ic=20
c     iaa=20
c     ibb=20
c     ifail=0
c     call f04aee(fmat,ia,tmat,ib,2*nsp2,2*nsp2,smat,ic,
c    +wkspce,aa,iaa,bb,ibb,ifail)
!      call leqt2f(fmat, 2*nsp2, 2*nsp2, ia, tmat, idgt, wkspce, ifail)
      call dgesv(2*nsp2, 2*nsp2, fmat, 20, ipiv, tmat, 20, ifail)
c $$$$$$$$$$$$$$$$$$
c
c...calculate thermodynamic forces
c
      tforce(:nsp2) = -((xt(:nsp2)*fmag)/xchg(:nsp2))*(xprp(:nsp2)/xpr(:
     1   nsp2))
      tforce(1+nsp2:nsp2*2) = -((xt(:nsp2)*fmag)/xchg(:nsp2))*(xtp(:nsp2
     1   )/xt(:nsp2))
c
c...calculate resulting flows
c
      do j = 1, nsp2
         sum = 0.0
         do k = 1, 2*nsp2
c $$$$      TKM    8/98
c     sum=sum+smat(j,k)*tforce(k)
            sum = sum + tmat(j,k)*tforce(k)
c $$$$$$$$$$$$$$$$$
         end do
         udotb(j) = sum
      end do
c
c...calculate bootstrap current density on the flux surface
c
      sum = 0.0
      sum = dot_product(xchg(:nsp2)*xn(:nsp2),udotb(:nsp2))
c
      xchg(:nsp2) = xchg(:nsp2)/chg
      xt(:nsp2) = xt(:nsp2)/chg
      xtp(:nsp2) = xtp(:nsp2)/chg
      xjboot = sum
c
      return 
      end subroutine ckboot
c
c
c
c     ==================== vnt ============================
c
      subroutine vnt(nspx, arg, xn, xt, xvth, xchg, xnuz, xnux, xeps, 
     1   nsp2, fint1, fint2, fint3)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:52:22   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nspx, nsp2
      real arg, xeps, fint1, fint2, fint3
      real, dimension(10) :: xn, xt, xvth, xchg, xnuz, xnux
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: j, ifail
      real :: sqpi, xnud, xnus, xnup, xnue, xnut, zab, sarg, zarg, xfac
     1   , xerf, xdenom1, xdenom2
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real , EXTERNAL :: derf
C-----------------------------------------------
c
c
      data sqpi/1.77245385/
c
      xnud = 0.0
      xnus = 0.0
      xnup = 0.0
      xnue = 0.0
      xnut = 0.0
      fint1 = 0.0
      fint2 = 0.0
      fint3 = 0.0
      do j = 1, nsp2
         ifail = 0
         zab = xvth(nspx)/xvth(j)
         sarg = sqrt(arg)
         zarg = sqrt(arg)*zab
         xfac = (3.0*sqpi*xn(j)*xchg(j)**2)/(4.0*xn(nspx)*xchg(nspx)**2)
c     xerf=s15aee(zarg,ifail)
c $$$$     TKM   8/98
         xerf = derf(zarg)
c $$$$$$$$$$$
c
         xnud = xnud + xfac*(xerf/sarg**3 - xerf/(2.0*sarg**3*zarg**2)
     1       + (2.0/sqpi)*zarg*exp((-zarg**2))/(2.0*sarg**3*zarg**2))
c
         xnus = xnus + xfac*(2.0*(xt(nspx)/xt(j)+zab**2)*(xerf/(2.0*sarg
     1      *zarg**2)-(2.0/sqpi)*zarg*exp((-zarg**2))/(2.0*sarg*zarg**2)
     2      ))
c
         xnup = xnup + xfac*(2.0*(xerf/(2.0*sarg**3*zarg**2) - (2.0/sqpi
     1      )*zarg*exp((-zarg**2))/(2.0*sarg**3*zarg**2)))
c
      end do
c
      xnue = 2.0*xnus - 2.0*xnud - xnup
c
      xnut = 3.0*xnud + xnue
c
      xdenom1 = 1.0 + xnuz(nspx)*xnud/sarg
      xdenom2 = 1.0 + 1.96*xnux(nspx)*xnut*xeps**1.5/sarg
c     xdenom1=1.0
c     xdenom2=1.0
c
      fint1 = (8.0/(3.0*sqpi))*xnud*sarg**4/(xdenom1*xdenom2)/(2.0*sarg)
      fint2 = (8.0/(3.0*sqpi))*xnud*sarg**6/(xdenom1*xdenom2)/(2.0*sarg)
      fint3 = (8.0/(3.0*sqpi))*xnud*sarg**8/(xdenom1*xdenom2)/(2.0*sarg)
c
      return 
      end subroutine vnt
c
c
      subroutine cadj1(iadj, nthp0, npsi0, psimx, psimn, nmax, umax, 
     1   imax, lmax, psis, eden, etem, zefi, jop, nwp, wpmx, wpmn, dwp, 
     2   wp, nthp1, thetp, iout4, iout5, nimx, ua, ug, th0a, th0g, fm, 
     3   chi, chixi, dchixi, dchiw, xi, gamr, delb, bfld, wr2, wr, wk, 
     4   chir, dchir, wk1, wk2, wk3, wk4, wk5, wk6, wtab, dchiwr, dchixr
     5   , mwr, iswr, lam1a)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:52:22   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer iadj, nthp0, npsi0, nmax, imax, lmax, nwp, nthp1, iout4, 
     1   iout5, nimx
      real psimx, psimn, umax, wpmx, wpmn, dwp
      integer, dimension(nimx) :: mwr, iswr
      real, dimension(npsi0) :: psis, eden, etem, zefi
      real, dimension(nwp,nthp1,npsi0) :: jop
      real, dimension(nwp) :: wp
      real, dimension(nthp1) :: thetp
      real, dimension(0:nmax - 1) :: ua
      real, dimension(0:nmax) :: ug
      real, dimension(0:imax - 1) :: th0a
      real, dimension(0:imax) :: th0g
      real, dimension(0:nmax - 1) :: fm
      real, dimension(0:imax - 1,0:nmax - 1) :: chi
      real, dimension(0:imax,0:nmax - 1) :: chixi, dchixi, dchiw
      real, dimension(0:imax) :: xi
      real, dimension(nimx) :: gamr
      real, dimension(nthp1) :: delb, bfld
      real, dimension(nimx) :: wr2, wr, wk, chir, dchir, wk1, wk2, wk3, 
     1   wk4, wk5, wk6
      real, dimension(nimx,5) :: wtab
      real, dimension(nimx) :: dchiwr, dchixr
      real, dimension(0:imax - 1) :: lam1a
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: tmax, imax1, nmax1, i, np, jnmax, jimax, jkmax, jlmax, 
     1   n, nnp, nnnp, j, k, iv, it, iu, k1, ia, iiia, jj, jjjja, i1, 
     2   imax2, iw
      real :: one, half, pi, dthp1, u12, t, c2, ze, epsa, umax1, th0max
     1   , du, dth0, rho, dbmx, bmin, bmax, dt, alpha, cond, abserr, 
     2   relerr, hu, hth, clite, x1, deta, sintg, cth0a, xit, bee, rtb, 
     3   deltb, wp2, gamp2, vp2, gamp, vp, alphr, alphi, ck0, alp1, alp2
     4   , rgamp2, wpt2, wpt, sum, pj
C-----------------------------------------------
c---------------------------
c   calculate a j/p table with independent variables wp
c     (wp=gammap*vp, resonant electron momentum/m), psi(flux-surface),
c     thetap(poloidal-angle), lamda(T/mc**2, only at lamda=0 and lamda=0.1
c     and linear interpolate)
c   nthp0=No. of poloidal theta points for line integrals;
c   npsi0=No. of psi-grid points;
c   psimx,psimn=max. and min. psi;
c   nmax=No. of points in u-grid; umax=max. u; imax=No. points in pitch-ang.
c   lmax=No. of Lengendre harmonics; nwp=No. point in wave-phase wp;
c   wpmx=maximum wp;
c    nthp1=No. of poloidal theta points for j/p calculations;
c
c  Output:
c   wp(1:nwp)=wave-phase momentum/me;
c   jop(nwp,nthp1,npsi0)=j/p
c   thetp(nthp1) = grid points of poloidal angles
c   npsi0 values of density (eden),temperature (etem),zeffective(zefi),
c              psi-values(psis).
c
c----------------------------
 
c
c
      imax1 = imax + 1
      nmax1 = nmax + 1
      one = 1.0E0
      half = 0.5E0
      pi = 4*atan(1.0E0)
      dthp1 = 2.*pi/(nthp1 - 1)
      do i = 1, nthp1
         thetp(i) = (i - 1)*dthp1
      end do
c     dwp=(wpmx-wpmn)/(nwp-1)
c     do i=1,nwp
c       wp(i)=wpmn+(i-1.e0)*dwp
c     enddo
      u12 = umax**2
 
C
C   Start looping over psi-grid
C
      do np = 1, npsi0
         read (iout5, 3000) psis(np), eden(np), etem(np)
         read (iout5, 3010) jnmax, jimax, jkmax, jlmax
         read (iout5, 3020) t, c2, ze, zefi(np), epsa
         read(iout5,3020)umax1,th0max,du,dth0,rho,dbmx,bmin,bmax
c----------------
c  dbmx is deltb at bmax; gives bmax/bmin
c-------------------------
         read (iout5, 3040) dt, tmax, alpha
         read (iout5, 3020) cond, abserr, relerr
         read (iout5, 3030) ua
         read (iout5, 3030) ug
         read (iout5, 3030) th0a
         read (iout5, 3030) th0g
         read (iout5, 3030) lam1a
         read (iout5, 3030) fm
         read (iout5, 3030) chi
c--------------------
c   map chi from th0a-grid to xi-grid ( get chixi)
c
 
c       hth=th0a(1)-th0a(0)
c       hu=ua(1)-ua(0)
         hu = du
         hth = dth0
c---------------------
c   Hardwire dwp and wpmn; so input of dwp,wpmx,wpmn are obsolete;
c     only nwp is needed. jop on axis is simplified.
c-----------------------
         dwp = hu
         wpmn = ua(0)
         do i = 1, nwp
            wp(i) = wpmn + (i - 1.E0)*dwp
         end do
         nnp = np/5
         nnp = nnp*5
         if (nnp /= np) then
         else
            nnnp = nnp
         endif
         clite = sqrt(c2)
         xi(:imax) = cos(th0g(:imax))
         xi(imax) = amax1(0.0_dp,xi(imax))
c-------------------
c  map chi from th0a-grid to th0g-grid
c-------------------
         chixi(imax,:nmax-1) = 0.
         wtab(:nmax,:4) = transpose(chi(:3,:nmax-1))
         do iv = 0, 1
            x1 = th0a(0)
            call intrv (wk, th0g(iv), wtab, hth, x1, nmax, nimx)
            chixi(iv,:nmax-1) = wk(:nmax)
         end do
         wtab(:nmax,:4) = transpose(chi(imax-4:imax-1,:nmax-1))
         do iv = imax - 1, imax
            x1 = th0a(imax-4)
            call intrv (wk, th0g(iv), wtab, hth, x1, nmax, nimx)
            chixi(iv,:nmax-1) = wk(:nmax)
         end do
         do iv = 2, imax - 2
            x1 = th0a(iv-2)
            wtab(:nmax,:4) = transpose(chi(iv-2:1+iv,:nmax-1))
            call intrv (wk, th0g(iv), wtab, hth, x1, nmax, nimx)
            chixi(iv,:nmax-1) = wk(:nmax)
         end do
c---------------
c   find dchixi=dchixi/dxi
c---------------
         deta = xi(1) - xi(0)
         dchixi(0,:nmax-1) = (chixi(1,:nmax-1)-chixi(0,:nmax-1))/deta
         wtab(:nmax,:) = transpose(chixi(:4,:nmax-1))
         call der4v (2, hth, wtab, wk, nmax, nimx)
         dchixi(1,:nmax-1) = wk(:nmax)
         wtab(:nmax,:) = transpose(chixi(imax-4:imax,:nmax-1))
         do it = 4, 5
            call der4v (it, hth, wtab, wk, nmax, nimx)
            dchixi(imax-5+it,:nmax-1) = wk(:nmax)
         end do
         do it = 2, imax - 2
            wtab(:nmax,:) = transpose(chixi(it-2:2+it,:nmax-1))
            call der4v (3, hth, wtab, wk, nmax, nimx)
            dchixi(it,:nmax-1) = wk(:nmax)
         end do
         do it = 1, imax
            sintg = sin(th0g(it))
            dchixi(it,:nmax-1) = -dchixi(it,:nmax-1)/sintg
         end do
c----------------------
c  find dchiw=dchixi/dw
c----------------------
         dchiw(imax,:nmax-1) = 0.
         wtab(:imax,:) = chixi(:imax-1,:4)
         do iu = 1, 2
            call der4v (iu, hu, wtab, wk, imax, nimx)
            dchiw(:imax-1,iu-1) = wk(:imax)
         end do
         wtab(:imax,:) = chixi(:imax-1,nmax-5:nmax-1)
         do iu = 4, 5
            call der4v (iu, hu, wtab, wk, imax, nimx)
            dchiw(:imax-1,nmax-6+iu) = wk(:imax)
         end do
         do k = 2, nmax - 3
            wtab(:imax,:) = chixi(:imax-1,k-2:2+k)
            call der4v (3, hu, wtab, wk, imax, nimx)
            dchiw(:imax-1,k) = wk(:imax)
         end do
c  -----------------------
c   ignore eps effect when epsa.lt.2.e-3 and assume chi is
c     proportional to P(1)
c  --------------------------
c  wk6 is dchi/dxi, wk5 is dchi/dw/xi
c---------------------------------
         if (epsa < 2.E-3) then
            cth0a = cos(th0a(0))
            wk6(:nmax) = chi(0,:nmax-1)/cth0a
            wk(:5) = wk6(:5)
            do iv = 1, 2
               call deriv4 (iv, hu, wk, wk5(iv))
            end do
            wk(:5) = wk6(nmax-4:nmax)
            do iv = 4, 5
               call deriv4 (iv, hu, wk, wk5(nmax+iv-5))
            end do
            do iv = 3, nmax - 2
               wk(:5) = wk6(iv-2:2+iv)
               call deriv4 (3, hu, wk, wk5(iv))
            end do
         endif
 
c**************************************
 
 
         do i = 1, nthp1
            call bfield (psis(np), thetp(i), bfld(i))
         end do
         xit = xi(imax)
         do i = 1, nthp1
            bee = bfld(i)/bmin
            bee = amax1(one,bee)
            rtb = sqrt(bee)
            ia = i/10
            ia = ia*10
            if (ia /= i) then
            else
               iiia = ia
            endif
            deltb = bee - one
            delb(i) = deltb
            do j = 1, nwp
               jj = j/10
               jj = jj*10
               if (jj /= j) then
               else
                  jjjja = jj
               endif
               wp2 = wp(j)*wp(j)
               gamp2 = one + wp2/c2
               vp2 = wp2/gamp2
c           fac1=one-bee*gamp2*bmin/bmax
c           fac2=wp2/u12-fac1
c           wpt2=cvmgp(u12,wp2/fac1,fac2)
               gamp = sqrt(gamp2)
               vp = sqrt(vp2)
               select case (iadj) 
               case (0) 
                  call diel1l (psis(np), thetp(i), vp, clite, alphr, 
     1               alphi, ck0)
c------low beta
c
               case (1) 
                  call diel1h (psis(np), thetp(i), vp, clite, alphr, 
     1               alphi, ck0)
c---------high beta
c
               case (2) 
                  alphr = 1.E9
                  alphi = 0.
                  ck0 = 1.
c-----Landau limit
c
               case (3) 
                  alphr = 0.
                  alphi = 0.
                  ck0 = 1.
c------Alfven limit
c
               end select
               alp1 = alphr - 1
               alp2 = alp1*alp1 + alphi*alphi
               rgamp2 = one/gamp2
               wpt2=vp2/amax1(rgamp2-bee*(one-xi(imax)**2),1.E-3*vp2)
               wpt = sqrt(wpt2)
               if (epsa >= 2.E-3) then
c           if (abs(wpt-umax).lt.1.e-10) wpt=umax
                  wr2(:imax1) = vp2/amax1(rgamp2 - bee*(one - xi(:imax1-
     1               1)**2),1.E-3*vp2)
                  gamr(:imax1) = sqrt(one + wr2(:imax1)/c2)
                  wr(:imax1) = sqrt(wr2(:imax1))
                  mwr(:imax1) = (wr(:imax1)+0.5*hu)/hu
                  iswr(:imax1) = isign(1,nmax - mwr(:imax1))
c--------------------------
c  wr(1:imax1) are resonant momentum at th0g(0:imax)
c   wr(1:imax2) are less than umax
c--------------------------
                  imax2 = 0
                  do i1 = 1, imax1
                     imax2 = imax2 + iswr(i1)
                  end do
                  imax2 = (imax1 + imax2)/2
                  iswr(:imax2) = max0(0,mwr(:imax2)-2)
                  iswr(:imax2) = min0(iswr(:imax2),nmax-4)
                  wk(:imax2) = ua(iswr(:imax2))
                  do k = 1, 4
                     do i1 = 1, imax2
                        wtab(i1,k) = dchiw(i1,iswr(i1)+k-1)
                     end do
                  end do
                  call intrv1 (dchiwr, wr, wtab, hu, wk, imax2, nimx, 
     1               wk1, wk2, wk3, wk4)
                  do k = 1, 4
                     do i1 = 1, imax2
                        wtab(i1,k) = dchixi(i1,iswr(i1)+k-1)
                     end do
                  end do
                  call intrv1 (dchixr, wr, wtab, hu, wk, imax2, nimx, 
     1               wk1, wk2, wk3, wk4)
                  wk6(imax2+1:imax1) = 0.
                  wr(imax2+1:imax1) = wpmx
                  wk(:imax2) = one - gamr(:imax2)**2*vp2/wr2(:imax2)
                  wk1(:imax2) = dchiwr(:imax2) + dchixr(:imax2)*wk(:
     1               imax2)/(bee*wr(:imax2)*xi(:imax2-1))
c             wk1(k)=wk1(k)*exp(-c2*(gamr(k)-gamp))/gamr(k)
c             wk6(k)=wk1(k)*((half*wr2(k)*wk(k)+alp1)**2
c    1            +alphi**2)
                  wk1(:imax2) = wk1(:imax2)*exp((-c2*(gamr(:imax2)-gamp)
     1               ))
                  wk6(:imax2) = wk1(:imax2)*((ck0*half*wr2(:imax2)*wk(:
     1               imax2)+gamr(:imax2)*alp1)**2+(gamr(:imax2)*alphi)**
     2               2)
                  sum = 0.
                  do k = 1, imax
                     sum = sum + half*(wr(k+1)-wr(k))*(wk6(k)+wk6(k+1))
                  end do
               else
                  wr(:nmax) = ua(:nmax-1)
                  wr2(:nmax) = wr(:nmax)*wr(:nmax)
                  wk2(:nmax) = one + wr2(:nmax)/c2
                  gamr(:nmax) = sqrt(wk2(:nmax))
                  wk(:nmax) = one - wk2(:nmax)*vp2/wr2(:nmax)
                  wk1(:nmax) = vp*wk5(:nmax)/wr(:nmax) + wk(:nmax)*wk6(:
     1               nmax)/wk2(:nmax)/vp
                  wk1(:nmax) = wk1(:nmax)*exp((-c2*(gamr(:nmax)-gamp)))*
     1               gamr(:nmax)
                  wk3(:nmax) = wk1(:nmax)*((ck0*half*wr2(:nmax)*wk(:nmax
     1               )+gamr(:nmax)*alp1)**2+(gamr(:nmax)*alphi)**2)
c-------------------------
c  This part is simplified by hardwiring dwp and wpmn
c
c           iw=(wp(j)-wr(1))/hu
c           iw=iw+2
                  iw = j
                  sum = 0.
                  do k = iw, nmax - 1
                     sum = sum + half*hu*(wk3(k)+wk3(k+1))
                  end do
c           iw=iw-2
c           x1=wr(iw)
c           do k=1,4
c             wtab(1,k)=wk6(iw+k-1)
c           enddo
c           call intrv(wk4,wp(j),wtab,hu,x1,1,nimx)
c           gwk6=wk4(1)
c           do k=1,4
c             wtab(1,k)=wk5(iw+k-1)
c           enddo
c           call intrv(wk4,wp(j),wtab,hu,x1,1,nimx)
c           gwk5=wk4(1)
c           gwk=one-gamp2*vp2/wp2
c           gwk1=vp*gwk5/wp(j)+gwk*gwk6/gamp2/vp
c           gwk3=gwk1*((half*wp2*gwk-alp1)**2+alphi**2)
c           sum=sum+half*(wr(iw+2)-wp(j))*(wk3(iw+2)+gwk3)
 
               endif
 
c*****************************************************
               jop(j,i,np) = sum
c           cwk=c2*gamp
c           if (cwk.lt.19.) then
c             pj=0.25*(6.+cwk*(6.+cwk*(3.+cwk)))/cwk/cwk/gamp2
c    1           -(half*c2-alp1)*(cwk+one)/cwk/gamp
c    2          +((half*c2-alp1)**2+alphi**2)*(E1(cwk)*exp(cwk))
c             pj=pj*c2
c           else
c             pj=2./gamp2/gamp+alp1*(one+one/gamp)/gamp+alp2/gamp
c    1           -(2.*alp1/gamp+alp2)/c2/gamp2
c    2           +(6./gamp2+6.*alp1/gamp+2.*alp2)/c2/c2/gamp2/gamp
c           endif
               pj = alp2*gamp2 + 2.*alp1*ck0 + 2.*ck0*ck0/gamp2 + (2.*
     1            alp2*gamp + 6.*ck0*alp1/gamp + 6.*ck0*ck0/gamp/gamp2)/
     2            c2 + (2.*alp2 + 6.*ck0*alp1/gamp2 + 6.*ck0*ck0/gamp2/
     3            gamp2)/c2/c2
               jop(j,i,np) = jop(j,i,np)/pj
            end do
         end do
      end do
 
c---------------------------
 3000 format(4(2x,e20.12))
 3010 format(1x,4i8)
 3020 format(4(1x,e20.12))
 3030 format(5(1x,e20.12))
 3040 format(1x,e20.12,2x,i8,2x,e20.12)
 
      return 
      end subroutine cadj1
c
c  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c   Added by T.K. Mau on July 30, 1991.
c   To calculate local driven current density by RF waves.
c
      subroutine cdcur(ientry)
      use Vdynamic
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:52:22   6/14/01  
C...Switches: -p4 -yb
c
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vcraylh
      use Vcmnew, ONLY: wpi1c, wpi2c, wci1c, wci2c, wpi2, wci2, wci, 
     1   conci, aziomi, rtzom, ay2, ay1, trate, tratte, ttle, concte, 
     2   trati, tratti, ttli, concti, vdrfte, vdrfti, infi, gprm, cxet, 
     3   czt, cztp, czetai, czi, czip, czetat, czti, cztip, cth, npar, 
     4   nper, upar, uper, umax, dsfe, dsfi, fper2, fpar2, fpp2, intg, 
     5   inc, incf, tnmaxe, tnmaxi, idrive, binb, boutb, boutbrd, 
     6   binbrd, epsl, binbd, epsil, dlob, wte, eta0, eta, rprof, 
     7   amprof, cprof, xjop, vloop, kboot, mboot, btbsp, ftbsps, pde, 
     8   pdec, pdi, pdf, pwce, pwcm, pwcf, pwc, pwc1, pwc2, pwct, 
     9   pwct1, pwct2, pwc0, pwcray, pwc1ray, pwc2ray, pweray, pwiray, 
     .   pwfray, currf, currfe, currf1, currf2, curay, curay1, curay2, 
     1   fpwray, fpowe, fpowf, fpowi, pwte0, pwti0, effcd, effcdt, 
     2   ptot, ftpowe, ftpowi, ftpowf, ftpi, ftpf, ftedge, pwedge, 
     3   wfrac, pwxwl, frpowi, frpowf, frpow, pwit, pwft, ptedge, 
     4   ptot0, fpowt, tpowi, tpowf, wfrac0, ebkev, bmpwr, azf, atmf, 
     5   densa, kalfa, nalfa, nharm0, pnfi, pnf, zetab, tnf, ecrit, 
     6   taua0, wca, gamal, gamat, ibeam, abeam, dbeam, aneb, enbeam, 
     7   wbeam, temsa, ptfi, ttf, wpf2c, wpf2, wcf2c, wcf1c, wcf2, wcf, 
     8   cxc, czc, cy, denfa, eav, tausd, tau0, paf, sordt, ecrita, 
     9   betaf, wce, adxy
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang, 
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec, 
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3, 
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti, 
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin, 
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril, 
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref, 
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep, 
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr, 
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite, 
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1, 
     1   gamene1, presfr, iout, btsign
      use Vdynamic
      USE Vblkcof
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer ientry
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: lthet, jwp, ithp, lpsi, n1, n2, l, ll, i, ii, j1, j
      real, dimension(3) :: awrk, awrk1, awrk2, cs2
      real, dimension(18) :: cs
      real, dimension(7,3) :: dc
      real, dimension(4) :: anm
      real :: rt2, twopi, pi, one, two, cov2, arg1, algame, alpr, alpi, 
     1   alp0, akcd, c0cd, amcd, ccd, acd, alt2s, alt2, alt1, ytt, arg, 
     2   fact, awt, aci, aci2, gloop, eloop, floop, vph, rgamp2, gamp2, 
     3   gamp, wph, thetac, wwk
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
!      integer , EXTERNAL :: ifix
      real , EXTERNAL :: valspl
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1
 
 
c******      TKM   03/97, 09/99, 04/00, 06/00
c********************
 
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
      data rt2/1.414213562/
      data twopi/6.283185308/
      data pi/3.14159265/
      data one/1.E0/
      data two/2.E0/
      data cs2/0.92, 0.08, 0./
      data cs/1.5, -20., 0., 0., 1.225, -3.5, 1.5, -4., 0.45, 8., 0.63, 
     1   2., -0.39, -2.1, -0.50, 1.0, 0.8, 0.0/
      data dc/3.70, -5.7, 7.5, 4.5, 25.0, 43.0, -2.0, 0., 0., 0., 0., 0.
     1   , 0., 0., 300., -300., 0., 0., 0., 0., 0./
      data anm/0.8475, 0.1125, -0.04, 0./
c
      cov2 = 511.925/tempe
      arg1 = 1.E-3/tempe*sqrt(dense)
      algame = 24. - alog(arg1)
      go to (100,200,300) ientry
c---------------------
c  ientry = 1   Ehst-Karney model
c  ientry = 2   Chiu et. al. model
c  ientry = 3   direct adj integration
c----------------------
  100 continue
      pwce = 0.
      alpr = -cov2*wce*adxy*eps3r/(aeps32*ssmnp2)
      alpi = eps3i/eps3r*alpr
      alpr = alpr*(1. + del0)
      alpi = alpi*(1. + del0)
      alp0 = 1. + alpr*alpr + alpi*alpi
c $$$$$$$$$$$$$
      if (islofa == (-1)) then
         alp0 = 1.
         alpr = 0.
         alpi = 0.
         akcd = 11.91/(0.678 + zeff)
         c0cd = 4.13/zeff**0.707
         amcd = 1.38 + 1.10/alp0
         ccd = 0.389 - 0.2903/alp0
         acd = 12.3/alp0
      else
         akcd = 3./zeff
         c0cd = 3.83/zeff**0.707
         amcd = 1.38
         ccd = 0.389
         acd = 0.
      endif
c
!      left = ifix(psi/dpsi) + 1
      left = int(psi/dpsi) + 1
      hh = psi - tpsi(left)
      if (left > nprof) then
         left = nprof
         hh = 0.0
      endif
      epsil = valspl(hh,epsl,nprofn,left,0)
      binbrd = valspl(hh,binbd,nprofn,left,0)
      alt2s = 1. - btot/binbrd
      alt2 = abs(alt2s)
      alt1 = sqrt(alt2)
      wte = 1.414*xe
      ytt = (1. - alt2)*wte**2/alt2
      rprof=1.-(epsil**0.77*sqrt(12.25+wte**2))/(3.5*epsil**0.77+wte)
      arg = (ccd*ytt)**amcd
      cprof = 1. - exp((-arg))
      amprof = 1. + acd*(alt1/wte)**3
c
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c  Added by T.K. Mau on Oct. 9, 1991.
c
c  modcd  = 0 : Use Ehst's model for j/p w/o trapped effect
c    otherwise : Use Chiu's model for j/p w/o trapped effect
c
c--------------------------------------
c $$$$$  added by TK Mau on 11/21/91
      if (modcd == 0) then
         eta0 = akcd/abs(wte) + c0cd + 4.*wte**2/(5. + zeff)
      else
c-----------------SCC 3/13/92
c $$$$$$  added by TK Mau on 11/21/91
c $$$$$$$$$$$$$
         fact = exp((-zxe2))
c     eta0 = fact*2.1213/(zeff+0.6667*alp0)*(1.+3.*(1.+alpr)/alp0)/wte
c    &   +(1.-fact)*(4.*wte*wte/(5.+zeff)+6.*(6.+zeff)/(5.+zeff)/(3.+zeff)
c    &       +6.*(2.*alpr+2.-alpi*alpi)/(alp0*(5.+zeff))+
c    &       60./((2.+zeff)*(1.+zeff)*wte))
c-----------------SCC 3/12/92
         awt = abs(wte)
         aci = 4.*awt**2/(5. + zeff) + 6.*(6. + zeff)/((5. + zeff)*(3.
     1       + zeff)) + 6.*(2.*alpr + 2. - alpi**2)/((5. + zeff)*alp0)
     2       + 42./(awt*(2. + zeff)*(1. + zeff))
         aci2 = 3.759942*(1. - 2.*alpr/alp0)/zeff + (16.8465/(0.32922 + 
     1      zeff))*(alpr - 1.)/alp0 + (110.85/(0.62879 + zeff))/(4.*alp0
     2      ) + awt**2*((11.5 - 1.5/alp0) + (7.5 + 4.5/alp0)*zeff)/((2.
     3       + zeff)*(1. + zeff)) - awt**4*8.*alpr/(4. + zeff)/alp0 + 
     4      awt**2*55.*alpi**2/(45. + zeff)/alp0
         aci2 = aci2/awt
         eta0 = fact*aci2 + (1. - fact)*aci
      endif
      gloop = 2./(zeff + 5.)*(1. + 2./(zeff + 3.))*wte**4 + 4./(zeff + 
     1   5.)*wte**2*(2. + 4.*(alpr + 1.)/alp0 + (2.*zeff + 9. + 24./(3.*
     2   zeff + 7.))/(zeff + 3.))
      eloop = 1.5915E-3*vloop/urhs*ukzero
      floop = 1. - 3.828E15*tempe/(dense*algame)*eloop*gloop/eta0
c    eloop : loop electric field in v/cm
      eta = cprof*amprof*eta0*rprof*floop
c $$$$$$$$$$$$$$$$$$$$$$$$
      xjop = 3.81E15/algame*tempe/dense*eta
c
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c     pwce = -sign(1.0_dp,pkpar)*abs(btor/btot)*btsign*pde*xjop
      pwce = -sign(1.0_dp,pkpar)*abs(btor/btot)*pde*xjop
      pwce = pwce*btsign
c-------------------
      return 
  300 continue
      pwce = 0.
      vph = rt2*xe
      rgamp2 = 1. - 1./pkpar2
      if (rgamp2 <= 0.) then
         xjop = 0.
      else
         gamp2 = 1./rgamp2
         gamp = sqrt(gamp2)
         wph = gamp*vph
         if (wph >= wpmx) go to 100
         if (wph <= wpmn) go to 100
         if (psi > psimx) go to 100
         if (psi < psimn) go to 100
         lthet = theta/twopi
         thetac = theta - lthet*twopi
         if (thetac < 0.) thetac = twopi + thetac
         jwp = (wph - wpmn)/dwp + 1
         ithp = (thetac - thetp(1))/dthp1 + 1
         lpsi = (psi - psis(1))/dpsis + 1
         if (jwp >= nwp1) jwp = nwp2
         if (ithp >= nthp11) ithp = nthp12
         if (lpsi >= npsi01) lpsi = npsi02
c       mthwp=nthp1*nwp
         n1 = (lpsi - 1)*mthwp
         n2 = (ithp - 1)*nwp
         do l = 1, 3
            ll = n1 + (l - 1)*mthwp
            do i = 1, 3
               ii = n2 + (i - 1)*nwp
               j1 = ll + ii + jwp
               do j = 1, 3
                  awrk(j) = sjop(j1+j-1)
               end do
               call inter3 (wwk, wph, awrk, wp(jwp), dwp)
               awrk1(i) = wwk
            end do
            call inter3 (wwk, thetac, awrk1, thetp(ithp), dthp1)
            awrk2(l) = wwk
         end do
         call inter3 (wwk, psi, awrk2, psis(lpsi), dpsis)
         eta = wwk
      endif
      xjop = 3.81E15/algame*tempe/dense*eta
      pwce = -sign(1.0_dp,pkpar)*abs(btor/btot)*pde*xjop
      pwce = pwce*btsign
c     if (abs(pwce).gt.1.e50) then
c       write(iout,1550) irec,nzeik,pwce
c1550    format(/5x,'irec:',i5,2x,'nzeik:',i4,2x,'pwce:',e14.6/)
c     endif
      return 
c
c
  200 continue
c $$$$$$$$$$$$$
      write (iout, 1560)
 1560 format(2x,'****This option is not working yet.***'//)
      stop 
c-------------------
c
      end subroutine cdcur
c
      subroutine curadj(nthp0, npsi0, psimx, psimn, nmax, umax, imax, 
     1   lmax, psis, eden, etem, zefi, jop, nwp, wpmx, wpmn, dwp, wp, 
     2   nthp1, thetp, iout4, iout5, iadj, wk5, wk6, npoint)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:52:22   6/14/01  
C...Switches: -p4 -yb
c---------------------------
c   calculate a j/p table with independent variables wp
c     (wp=gammap*vp, resonant electron momentum/m), psi(flux-surface),
c     thetap(poloidal-angle), lamda(T/mc**2, only at lamda=0 and lamda=0.1
c     and linear interpolate)
c   nthp0=No. of poloidal theta points for line integrals;
c   npsi0=No. of psi-grid points;
c   psimx,psimn=max. and min. psi;
c   nmax=No. of points in u-grid; umax=max. u; imax=No. points in pitch-ang.
c   lmax=No. of Lengendre harmonics; nwp=No. point in wave-phase wp;
c   wpmx=maximum wp;
c    nthp1=No. of poloidal theta points for j/p calculations;
c   iadj=0 : low beta j/p; iadj=1 : high beta j/p;
c
c  Output:
c   wp(1:nwp)=wave-phase momentum/me;
c   jop(nwp,nthp1,npsi0)=j/p
c   thetp(nthp1) = grid points of poloidal angles
c   npsi0 values of density (eden),temperature (etem),zeffective(zefi),
c              psi-values(psis).
c
c----------------------------
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
!      use Vcraylh
!      use Vcmnew
!      use Viorlh
       implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nthp0, npsi0, nmax, imax, lmax, nwp, nthp1, iout4, iout5, 
     1   iadj, npoint
      real psimx, psimn, umax, wpmx, wpmn, dwp
      real, dimension(npsi0) :: psis, eden, etem, zefi
      real, dimension(nwp,nthp1,npsi0) :: jop
      real, dimension(nwp) :: wp
      real, dimension(nthp1) :: thetp
      real, dimension(npoint) :: wk5, wk6
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: uaptr, ugptr, thaptr, thgptr, fmptr, chiptr, chxptr, 
     1   dchxpt, dchwpt, xiptr, gamrpt, dbptr, bfdptr, wr2ptr, wrptr, 
     2   wkptr, chirpt, dchirp, wk1ptr, wk2ptr, wk3ptr, wk4ptr, wk5ptr, 
     3   wk6ptr, wtabpt, mwrptr, iswrpt, dchwrp, dchxrp, lam1p
      integer, allocatable, dimension(:) :: intdum
      integer :: jthp0, jpsi0, jdthp, jdpsi, j1, ier, nimx, ii, lam1pt, 
     1   iercj, ierci, i, ndum, ndumi
      real, allocatable, dimension(:) :: dum
      real :: psimax, psimin, dpsimx, dpsimn, dpsim, stat
C-----------------------------------------------
c
c   Common block for Comdynray
c
 
      read (iout5, 2000) jthp0, jpsi0
      read (iout5, 2010) psimax, psimin
      jdthp = nthp0 - jthp0
      jdpsi = npsi0 - jpsi0
      dpsimx = psimx - psimax
      dpsimn = psimn - psimin
      j1 = iabs(jdthp) + iabs(jdpsi)
      dpsim = abs(dpsimx) + abs(dpsimn)
      if (j1/=0 .or. dpsim>1.E-13) then
         ier = 99
         write (iout4, 4000) ier
         write (iout4, 4010)
 4010    format(1x,'psi-thetap grids disagree.')
 4000    format(1x,'error in curadj, ier=',i8)
         stop 
      endif
c------------------------------------------------------
c  allocate memory
c------------------------------------------------------
      nimx = max0(nmax + 3,imax + 3)
      ii = 1
      uaptr = ii
      ii = ii + nmax
      ugptr = ii
      ii = ii + nmax + 1
      thaptr = ii
      ii = ii + imax
      thgptr = ii
      ii = ii + imax + 1
      lam1pt = ii
      ii = ii + imax
      fmptr = ii
      ii = ii + nmax
      chiptr = ii
      ii = ii + imax*nmax
      chxptr = ii
      ii = ii + (imax + 1)*nmax
      dchxpt = ii
      ii = ii + (imax + 1)*nmax
      dchwpt = ii
      ii = ii + (imax + 1)*nmax
      xiptr = ii
      ii = ii + imax + 1
      gamrpt = ii
      ii = ii + nimx
      dbptr = ii
      ii = ii + nthp1
      bfdptr = ii
      ii = ii + nthp1
      wr2ptr = ii
      ii = ii + nimx
      wrptr = ii
      ii = ii + nimx
      wkptr = ii
      ii = ii + nimx
      chirpt = ii
      ii = ii + nimx
      dchirp = ii
      ii = ii + nimx
      wk1ptr = ii
      ii = ii + nimx
      wk2ptr = ii
      ii = ii + nimx
      wk3ptr = ii
      ii = ii + nimx
      wk4ptr = ii
      ii = ii + nimx
      wk5ptr = ii
      ii = ii + nimx
      wk6ptr = ii
      ii = ii + nimx
      wtabpt = ii
      ii = ii + 5*nimx
      dchwrp = ii
      ii = ii + nimx
      dchxrp = ii
      ndum = ii + nimx - 1
c      call hpalloc(dumptr,ndum,iercj,1)
      if (.not.allocated(dum)) then
         ALLOCATE(dum(ndum),stat=iercj)
         if (iercj /= 0) then
            print *, 'dum could not be allocated in curadj'
            return 
         endif
      endif
      ii = 1
      mwrptr = ii
      ii = ii + nimx
      iswrpt = ii
      ndumi = ii + nimx - 1
c      call hpalloc(intdumpr,ndumi,ierci,1)
      if (.not.allocated(intdum)) then
         ALLOCATE(intdum(ndumi),stat=ierci)
         if (ierci /= 0) then
            print *, 'intdum could not be allocated in curadj'
            return 
         endif
      endif
c
      call cadj1 (iadj, nthp0, npsi0, psimx, psimn, nmax, umax, imax, 
     1   lmax, psis, eden, etem, zefi, jop, nwp, wpmx, wpmn, dwp, wp, 
     2   nthp1, thetp, iout4, iout5, nimx, dum(uaptr), dum(ugptr), dum(
     3   thaptr), dum(thgptr), dum(fmptr), dum(chiptr), dum(chxptr), dum
     4   (dchxpt), dum(dchwpt), dum(xiptr), dum(gamrpt), dum(dbptr), dum
     5   (bfdptr), dum(wr2ptr), dum(wrptr), dum(wkptr), dum(chirpt), dum
     6   (dchirp), dum(wk1ptr), dum(wk2ptr), dum(wk3ptr), dum(wk4ptr), 
     7   dum(wk5ptr), dum(wk6ptr), dum(wtabpt), dum(dchwrp), dum(dchxrp)
     8   , intdum(mwrptr), intdum(iswrpt), dum(lam1pt))
      wk5(:nwp) = dum(wk5ptr:nwp-1+wk5ptr)
      wk6(:nwp) = dum(wk6ptr:nwp-1+wk6ptr)
 
c      call hpdeallc(dumptr,iercj,0)
c      call hpdeallc(intdumpr,ierci,0)
      DEALLOCATE(dum, intdum)
 2000 format(1x,2i8)
 2010 format(4(2x,e20.12))
      return 
      end subroutine curadj
      subroutine subcof(akz, bkz, az, bz)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:52:22   6/14/01  
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
      use Vparam
      use Vcraylh
      use Vcmnew
      use Viorlh
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real, dimension(6,3) :: akz, bkz
      real, dimension(6,3,3) :: az, bz
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, j, k, i1, j1, ier, l
      integer, dimension(20) :: ipiv
      real, dimension(6,6) :: g
      real, dimension(6,3,3) :: a, b
      real, dimension(6,6,3) :: c
      real, dimension(54) :: work
      real, dimension(6) :: wk
      real, dimension(3,3) :: ga, gb
      real, dimension(3) :: wka
      real :: c1, c2, c3, c4, d1, d2, d3, d4, z
C-----------------------------------------------
c------------------
c   Expansion of integrals I_i, SI_i as series of sqrt(eps) and 1/lamda
c    and 1/(Z+c)
c------------------------
c-------------------------
c  a(i,j,k) i=1,6, j=1,3 (I_j(Z_k)), k=1,3, Z_1=1,Z_2=2,Z_3=4
c  b(i,j,k) i=1,6, j=1,3 (SI_j(Z_k)), """""""
c   i=1,2,3 (eps=0.,.1,.2, lamda=infinity); i=4,5,6 (eps=0.,.1,.2, lamda=20.4)
c--------------------------
      g = 0.
      c = 0.
      a = 0.
      b = 0.
      c1 = sqrt(1.E-1)
      c2 = sqrt(2.E-1)
      c3 = .1
      c4 = .2
      d1 = c1/20.4
      d2 = c2/20.4
      d3 = c3/20.4
      d4 = c4/20.4
      g(:,1) = 1.E0
      g(4:6,4) = 1.E0/20.4
      do i = 2, 3
         i1 = i + 3
         g(i,2) = sqrt(1.E-1*(i - 1.E0))
         g(i1,2) = sqrt(1.E-1*(i - 1.E0))
         g(i,3) = 1.E-1*(i - 1.E0)
         g(i1,3) = 1.E-1*(i - 1.E0)
         g(i1,5) = g(i1,2)/20.4
         g(i1,6) = g(i1,3)/20.4
      end do
      c(1,1,1) = 0.5914
      c(2,1,1) = 0.3609
      c(3,1,1) = 0.2839
      c(4,1,1) = 0.4362
      c(5,1,1) = 0.2556
      c(6,1,1) = 0.1978
      c(1,2,1) = 1.0900
      c(2,2,1) = 0.7456
      c(3,2,1) = 0.6150
      c(4,2,1) = 0.8005
      c(5,2,1) = 0.5284
      c(6,2,1) = 0.4300
      c(1,3,1) = 1.3490
      c(2,3,1) = 0.8501
      c(3,3,1) = 0.6782
      c(4,3,1) = 1.2114
      c(5,3,1) = 0.7437
      c(6,3,1) = 0.5880
      c(1,4,1) = 3.7619
      c(2,4,1) = 1.9924
      c(3,4,1) = 1.4785
      c(4,4,1) = 4.1202
      c(5,4,1) = 2.1646
      c(6,4,1) = 1.6040
      c(1,5,1) = 12.644
      c(2,5,1) = 7.4390
      c(3,5,1) = 5.7523
      c(4,5,1) = 13.7668
      c(5,5,1) = 7.9627
      c(6,5,1) = 6.1369
      c(1,6,1) = 67.921
      c(2,6,1) = 42.731
      c(3,6,1) = 34.0572
      c(4,6,1) = 70.6398
      c(5,6,1) = 43.3395
      c(6,6,1) = 34.2480
      c(1,1,2) = 0.3484
      c(2,1,2) = 0.2302
      c(3,1,2) = 0.1847
      c(4,1,2) = 0.2474
      c(5,1,2) = 0.1585
      c(6,1,2) = 0.1256
      c(1,2,2) = 0.7268
      c(2,2,2) = 0.5215
      c(3,2,2) = 0.4332
      c(4,2,2) = 0.5174
      c(5,2,2) = 0.3622
      c(6,2,2) = 0.2979
      c(1,3,2) = 0.8230
      c(2,3,2) = 0.5574
      c(3,3,2) = 0.4522
      c(4,3,2) = 0.7234
      c(5,3,2) = 0.4815
      c(6,3,2) = 0.3880
      c(1,4,2) = 1.8805
      c(2,4,2) = 1.1195
      c(3,4,2) = 0.8611
      c(4,4,2) = 2.0586
      c(5,4,2) = 1.2200
      c(6,4,2) = 0.9376
      c(1,5,2) = 7.1483
      c(2,5,2) = 4.5932
      c(3,5,2) = 3.6432
      c(4,5,2) = 7.6954
      c(5,5,2) = 4.8914
      c(6,5,2) = 3.8663
      c(1,6,2) = 41.373
      c(2,6,2) = 27.972
      c(3,6,2) = 22.6690
      c(4,6,2) = 42.1644
      c(5,6,2) = 28.0322
      c(6,6,2) = 22.5795
      c(1,1,3) = 0.1995
      c(2,1,3) = 0.1364
      c(3,1,3) = 0.1105
      c(4,1,3) = 0.1369
      c(5,1,3) = 0.0916
      c(6,1,3) = 0.0735
      c(1,2,3) = 0.4609
      c(2,2,3) = 0.3338
      c(3,2,3) = 0.2767
      c(4,2,3) = 0.3197
      c(5,2,3) = 0.2278
      c(6,2,3) = 0.1875
      c(1,3,3) = 0.4861
      c(2,3,3) = 0.3387
      c(3,3,3) = 0.2763
      c(4,3,3) = 0.4198
      c(5,3,3) = 0.2892
      c(6,3,3) = 0.2349
      c(1,4,3) = 0.9401
      c(2,4,3) = 0.5989
      c(3,4,3) = 0.4714
      c(4,4,3) = 1.0288
      c(5,4,3) = 0.6538
      c(6,4,3) = 0.5144
      c(1,5,3) = 3.9507
      c(2,5,3) = 2.6496
      c(3,5,3) = 2.1279
      c(4,5,3) = 4.2146
      c(5,5,3) = 2.8079
      c(6,5,3) = 2.2500
      c(1,6,3) = 24.385
      c(2,6,3) = 16.960
      c(3,6,3) = 13.8260
      c(4,6,3) = 24.4418
      c(5,6,3) = 16.8149
      c(6,6,3) = 13.6510
c--------------------
c  Determine a(i,j,k), b(i,j,k)
c  I(j,k)=a(1,j,k)+sqrt(eps)*a(2,j,k) +eps*a(3,j,k)
c         +(a(4,j,k)+sqrt(eps)*a(5,j,k) +eps*a(6,j,k))/lamda
c  SI(j,k)= (a  ----> b)
c----------------------------
      do j = 1, 3
         j1 = j + 3
         do k = 1, 3
            wk = c(:,j,k)
!            call leqt2f(g, 1, 6, 6, wk, 8, work, ier)
             call dgesv(6, 1, g, 6, ipiv, wk, 6, ier)
            a(:,j,k) = wk
            wk = c(:,j1,k)
!            call leqt2f (g, 1, 6, 6, wk, 8, work, ier)
             call dgesv(6, 1, g, 6, ipiv, wk, 6, ier)
            b(:,j,k) = wk
         end do
      end do
      akz = 0.
      bkz = 0.
      akz(1,1) = 0.5E0
      akz(4,1) = 1.E0
      akz(5,1) = 0.5E0
      akz(6,1) = 0.5E0
      akz(1,2) = 1.E0
      akz(2,2) = 0.5E0
      akz(3,2) = 0.5E0
      akz(4,2) = 0.50E0
      akz(5,2) = 0.00E0
      akz(6,2) = 0.50E0
      akz(1,3) = 0.5E0
      akz(4,3) = 0.50E0
      akz(5,3) = 0.50E0
      akz(6,3) = 0.50E0
      bkz(4,1) = 0.5E0
      bkz(1,2) = 0.5E0
      bkz(4,2) = 1.E0
      bkz(5,2) = 0.5E0
      bkz(6,2) = 0.5E0
      bkz(1,3) = 0.5E0
      bkz(4,3) = 0.50E0
      bkz(5,3) = 0.00E0
      bkz(6,3) = 0.0E0
      do i = 1, 6
         do j = 1, 3
            wka = a(i,j,:)
            do k = 1, 3
               z = 2.**(k - 1)
               do l = 1, 3
                  ga(k,l) = 1./(z + akz(i,j))**l
                  gb(k,l) = 1./(z + bkz(i,j))**l
               end do
            end do
!            call leqt2f(ga, 1, 3, 3, wka, 8, work, ier)
             call dgesv(3, 1, ga, 3, ipiv, wka, 3, ier)
            az(i,j,:) = wka
            wka = b(i,j,:)
!            call leqt2f(gb, 1, 3, 3, wka, 8, work, ier)
             call dgesv(3, 1, gb, 3, ipiv, wka, 3, ier)
            bz(i,j,:) = wka
         end do
      end do
      bz(1,1,2) = 0.
      bz(1,1,3) = 0.
 
      return 
      end subroutine subcof

      subroutine uertst (ierr, isub)
C*******************************************************************************
C*                                                                             *
C*    ROUTINE NAME:  UERTST                                                    *
C*                                                                             *
C*    PURPOSE:  prints error number and name of calling routine                *
C*                                                                             *
C*    AUTHOR:   Steve Reid - 9 September 1999                                  *
C*              S & E Computing                                                *
C*                                                                             *
C*    INPUTS:   ierr - error number to be printed                              *
C*              isub - name of calling subroutine to be printed                *
C*                                                                             *
C*    OUTPUTS:  none                                                           *
C*                                                                             *
C*    ROUTINES CALLED:  none                                                   *
C*                                                                             *
C*    LIMITATIONS:  none                                                       *
C*                                                                             *
C*******************************************************************************
      implicit none
      integer ierr
      character*(*) isub

      write (*, 6000)  ierr, isub
 6000 format (1x, '*** Terminal error', i4, ' occurred in routine ', a)
      return
      end

      subroutine curray (nprofs_c, nxeqd_c, nzeqd_c, psistep_c, 
     &   pkexpnt_c, 
     1   igraph_c, iprint_c, nspec_c, epserr_c, epser1_c, idcur_c, 
     2   nprim_c, nimp_c, nminor_c, atm_c, azi_c, aconc_c, denc_c, 
     3   tempec_c, tite_c, denedg_c, frcne_c, gamene_c,
     4   alpene_c, gamene1_c, alpene1_c, temedg_c, frcte_c, gamte_c, 
     5   alpte_c, gamte1_c, alpte1_c, atmf_c, azf_c, ebkev_c, kboot_c, 
     6   nalfa_c, kalfa_c, ioread_c, isimm_c, nspect_c, 
     7   nraypts_c, psi0_c, thgril_c, nthin_c, maxref_c, islofa_c, 
     8   ptot0_c, freqcy_c, heigth_c, indvar_c, powers_c, nnkpar_c,
     9   anzinf_c, anzsup_c, nnkpol_c, anpsup_c, anpinf_c, idrive_c, 
     &   ichois_c, modcd_c, igrill_c, bmax_c, idmpsw_c, irayio_c, inc_c, 
     1   icurdr_c, nrho_c, xrho_c, ne_c, te_c, ni_c, ti_c, elp_c,
     &   xdimeqd_c, zdimeqd_c, reqd_c, redeqd_c, zmideqd_c, 
     2   xma_c, zma_c, psimag_c, psilim_c, beqd_c, toteqd_c, psimx1_c, 
     3   psimx2_c, xax1_c, xax2_c, zax1_c, zax2_c, psisep_c,
     4   xsep_c, zsep_c, feqd_c, presseqd_c, ffpeqd_c, ppeqd_c, qeqd_c,
     5   peqd_c, iounit_c, ppsi_c, pwe_c, pwit_c, pwct_c)
c
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:32   6/14/01
C...Switches: -p4 -yb
C
C   Calling subroutine for CURRAY, version 8/1/02
C   Converted from main program 'aamaincur'
C
C
C       -----------------------------
C        Multiple ray case
C        -----------------------------
C
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
      use Vparam
      use Vsizes
      use Vceqdsk, ONLY: ntitle, dat, ipestg, nxeqd, nzeqd, xdimeqd,
     1   zdimeqd, reqd, redeqd, zmideqd, xma, zma, psimag, psilim,
     2   beqd, toteqd, psimx1, psimx2, xax1, xax2, zax1, zax2, psisep,
     3   xsep, zsep, feqd, presseqd, ffpeqd, ppeqd, peqd, qeqd, xeqd,
     4   zeqd, psiadj, dpolflx, psieqd, tpsieqd, tpsifeqd, iounit1,
     5   inoperm1, nptsdm1, nptsd, torflux, tpsisav, ra, psifra,
     6   dpsifra, fra, fra1, cspln, pds, wnoperm, xcontr, zcontr,
     7   bpcontr, btcontr, dstarp, b_fld, jacob, pprime, vprime,
     8   chipsi, ncontr, dang, bperr, arcl, thet, anglex, csplnx,
     9   csplnz, pdsx, pdsz, nlim, rlim, zlim, nlimiter, rlimiter,
     .   zlimiter, lrz, nprim, nimp, nion, nti, zi, zeffz, r, raeqd,
     1   psifeqd, te, ti, ti1, ene, enp, bmod, rmd, btmd, bpmd, btpmd,
     2   roa, ieqdsk
      use Vcfdamp, ONLY: ifbilin, us, thets, coss, sinn, f, fxx, fyy,
     1   fxxyy, ftemp, ibd, wk, sint, tempx, tempy, dus, dthets,
     2   dudthets, usp, thetsp, bes0, bes1, dbes, ifirstb, nbes, cnstb,
     3   besdel, inf, bmax
      use Vchpcsd, ONLY: irec, rec0, rec1, rec2, rec3, rec4, rec5,
     1   rec6, rec7, rec8, rec9, rec10, rec11, rec12, rec13, rec14,
     2   rec15
      use Vcmnew
      use Vcraylh
      use Vcgraphs, ONLY: seikon, spsi, sxu, szu, skp, skpar, spower,
     1   sdpwri, sphi, stheta, spol, sdkpar, scepx, scepy, scepz,
     2   sztpol, sbtot, sene, salphac, salphal, sjslofa, serrors,
     3   spkpsi, sakpsi, sakth, swkve, jjslofa, sne, ste, sqr, spw,
     4   sxh, sqte, sni, sti, sdeqs, spwer, spwmax, srtor, srplas,
     5   sdenc, stec, sqc, sqa, sbaxis, scurr, sfreq, satm, sazi,
     6   sconc, stic, sxpage, sypage, slenx, sleny, sdelx, sfirtx,
     7   sdely, sfirty, symax, symin, skth, skphi, skpsi, sxx, jslofas,
     8   nurefls, keiks, jpes, jpis, istarts, iprmt5, jhlfs, isimpl,
     9   isimpl0, ngr, nps, nspie, kgraph, kprof, newgra, jksym,
     .   lintyp, nxvarb, nyvarb, kwfr, initlh, nraypts
      use Viogrl
      use Viorlh
      use Vctransp
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: numrf, nin, nin1, nrf, ijk, kion
      real(kind=dp) :: tinit, tfinl, trun, file, status
      integer :: nspec_c,mainsp_c,nprofs_c,ioread_c,idcur_c,
     1   iprint_c,igraph_c,nprim_c,nimp_c,nminor_c,kboot_c,
     2   nalfa_c,kalfa_c
      integer, dimension(30) :: iounit_c
      real(kind=dp) :: psistep_c,pkexpnt_c
      real(kind=dp):: denc_c,tempec_c,gamene_c,alpene_c,gamte_c,alpte_c,
     1   gamti_c,alpti_c,denedg_c,temedg_c,alpene1_c,alpte1_c,frcte_c,
     2   frcne_c,frcti_c,gamte1_c,gamene1_c
      real(kind=dp) :: epserr_c,epser1_c
      real(kind=dp),dimension(nions) :: atm_c,azi_c,tite_c,aconc_c
      real(kind=dp),dimension(nfion) :: atmf_c,azf_c,ebkev_c
c
      integer :: isimm_c,nspect_c,nraypts_c,nthin_c,maxref_c,igrill_c,
     1   islofa_c,irayio_c,indvar_c,idrive_c,ichois_c,modcd_c,
     2   idmpsw_c,inc_c,icurdr_c,bmax_c
      integer,dimension(nspect1) :: nnkpar_c
      integer,dimension(nspectm) :: nnkpol_c
      real(kind=dp) :: freqcy_c,psi0_c,heigth_c,ptot0_c
      real(kind=dp),dimension(nspect1) :: anzsup_c,anzinf_c
      real(kind=dp),dimension(nspectm) :: anpsup_c,anpinf_c
      real(kind=dp),dimension(nspect1) :: powers_c
      real(kind=dp),dimension(nspectm) :: thgril_c
c
      integer :: nrho_c
      real(kind=dp),dimension(nprofm) :: xrho_c, ne_c, te_c, elp_c
      real(kind=dp),dimension(nprofm,nions) :: ni_c, ti_c
c
      integer :: ipestg_c, nxeqd_c, nzeqd_c
      real(kind=dp) :: xdimeqd_c, zdimeqd_c, reqd_c, redeqd_c, 
     &   zmideqd_c, 
     1   xma_c, zma_c, psimag_c,psilim_c, beqd_c, toteqd_c, psimx1_c, 
     2   psimx2_c, xax1_c, xax2_c, zax1_c, zax2_c,psisep_c, xsep_c, 
     3   zsep_c
      real(kind=dp), dimension(nxa) :: feqd_c, presseqd_c, 
     1   ffpeqd_c, ppeqd_c, qeqd_c
      real(kind=dp), dimension(nxa,nza) :: peqd_c
c
      real(kind=dp),dimension(nprofm) :: ppsi_c, pwe_c, pwct_c,
     &   pwit_c
c     real(kind=dp),dimension(nprofm,nions) :: pwi_c
c
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real(kind=dp),EXTERNAL::furmaj,furrho,futria,fuelon
      real(kind=dp),EXTERNAL::prone,prote,proti
!      real,EXTERNAL::secnds
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i

c
c  Comfdamp
c
c
c
c   Comhpcsd
c
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1


c******      TKM   03/97, 09/99, 04/00, 06/00
c********************

c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95

c----------------------------
c   common blocks of Cmgraphs
c

c    2   ,sqti(nprofm)
c------------ --------------
c   common blocks of Comiogrl
c---------------------------
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c     character*16 specfl(1),outfl(1),rayfl(1)
c     dimension hedin1(10), hedin2(10)
c
c      call seconds(tinit)
c
      smallest = tiny(bperr)*1.0e+10
      largest = huge(bperr)*1.0e-10
c     print *,' Smallest real(kind=dp) number = ', smallest
c     print *,' Largest real(kind=dp) number  = ', largest
c
c
      call setdflt
      call op_file(0)
c      open(iout0, file='zf1r.ou', status='old')
c      call zfinit
      iedge = 0
      numrf = 1
c     open(nin, file='curray.in', status='old')
c**********************************
c   Preliminary initialization of variables
c   Identify mode of activation by 'ioread'
c   set number of RF sources by 'numrf'
c   (for now, set numrf = 1 ) (numrf gt.1 is not working yet;
c  for onetwo with more than one FW source, call xcurrayf more
c  than once)
c   Identify names of spectral inputfiles by specfl(1:numrf)
c   Identify names of summary outputfiles by outfl(1:numrf)
c   (currayout files)
c   Identify names of ray_data files by rayfl(1:numrf)
c     (rayop files)
c************************************
      call bram
c     read (nin,1001) (hedin1(i),i=1,10),(hedin2(i),i=1,10)
 1001 format(10a8)
c     read (nin, input)
      nprofs = nprofs_c
      nxeqd = nxeqd_c
      nzeqd = nzeqd_c
      psistep = psistep_c
      pkexpnt = pkexpnt_c 
      igraph = igraph_c
      iprint = iprint_c
      nspec = nspec_c
      epserr = epserr_c
      epser1 = epser1_c
      idcur = idcur_c 
      nprim = nprim_c
      nimp = nimp_c
      nminor = nminor_c
      atm(:nspec) = atm_c(:nspec)
      azi(:nspec) = azi_c(:nspec)
      aconc(:nspec) = aconc_c(:nspec)
      denc = denc_c 
      tempec = tempec_c
      tite(:nspec) = tite_c(:nspec)
      denedg = denedg_c
      frcne = frcne_c
      gamene = gamene_c
      alpene = alpene_c
      gamene1 = gamene1_c
      alpene1 = alpene1_c
      temedg = temedg_c
      frcte = frcte_c
      gamte = gamte_c 
      alpte = alpte_c
      gamte1 = gamte1_c
      alpte1 = alpte1_c
      atmf(1) = atmf_c(1)
      azf(1) = azf_c(1)
      ebkev(1) = ebkev_c(1)
      kboot = kboot_c 
      nalfa = nalfa_c
      kalfa = kalfa_c
      ioread = ioread_c
      isimm = isimm_c
      nspect = nspect_c
      nraypts = nraypts_c
      psi0 = psi0_c
      thgril(:isimm) = thgril_c(:isimm)
      nthin = nthin_c
      maxref = maxref_c
      islofa = islofa_c 
      ptot0 = ptot0_c
      freqcy = freqcy_c
      heigth = heigth_c
      indvar = indvar_c
      powers(:isimm) = powers_c(:isimm)
      nnkpar(:isimm) = nnkpar_c(:isimm)
      anzinf(:isimm) = anzinf_c(:isimm)
      anzsup(:isimm) = anzsup_c(:isimm)
      nnkpol(:isimm) = nnkpol_c(:isimm)
      anpsup(:isimm) = anpsup_c(:isimm)
      anpinf(:isimm) = anpinf_c(:isimm)
      idrive = idrive_c 
      ichois = ichois_c
      modcd = modcd_c
      igrill = igrill_c
      bmax = bmax_c
      idmpsw = idmpsw_c
      irayio = irayio_c
      inc = inc_c 
      icurdr = icurdr_c
      nrho_tr = nrho_c
      xrho_tr(:nrho_tr) = xrho_c(:nrho_tr)
      ne_tr(:nrho_tr) = ne_c(:nrho_tr)
      te_tr(:nrho_tr) = te_c(:nrho_tr)
      ni_tr(:nrho_tr,:nspec) = ni_c(:nrho_tr,:nspec)
      ti_tr(:nrho_tr,:nspec) = ti_c(:nrho_tr,:nspec)
      elp_tr(:nrho_tr) = elp_c(:nrho_tr)
      xdimeqd = xdimeqd_c
      zdimeqd = zdimeqd_c
      reqd = reqd_c
      redeqd = redeqd_c
      zmideqd = zmideqd_c 
      xma = xma_c
      zma = zma_c
      psimag = psimag_c
      psilim = psilim_c
      beqd = beqd_c 
      toteqd = toteqd_c
      psimx1 = psimx1_c 
      psimx2 = psimx2_c
      xax1 = xax1_c
      xax2 = xax2_c
      zax1 = zax1_c
      zax2 = zax2_c
      psisep = psisep_c
      xsep = xsep_c 
      zsep = zsep_c
      feqd(:nxeqd) = feqd_c(:nxeqd)
      presseqd(:nxeqd) = presseqd_c(:nxeqd)
      ffpeqd(:nxeqd) = ffpeqd_c(:nxeqd)
      ppeqd(:nxeqd) = ppeqd_c(:nxeqd)
      qeqd(:nxeqd) = qeqd_c(:nxeqd)
      peqd(:nxeqd,:nzeqd) = peqd_c(:nxeqd,:nzeqd)
      iounit(:30) = iounit_c(:30)
c
      nprof = nprofs
C
C
      call tmpdata(1)
      nrf = 1
c     open(nin1, file='specfl.in', status='old')
      call op_file(1)
c     open(iout, file='currayout', status='unknown')
c     read (nin1, input1)
c----------------------------------
c  if 'curray' is activated by ONETWO, set ioread=1 in /input/
c
      if (ioread == 1) then
         open(iout1, file='raytrin', status='old')
         call rtinout(1)
         close(iout1)
      endif
c     if (ieqdsk == 0) read (nin, inpeq)
c-------------------------------------
C    Input spectral information:
C*************************************
C powers(i) is power in MW in i-th n-phi bin
C freqcy in Hertz,
C nraypts=maxmum No. of steps in ray-marching
C (Note: nraypts should be large enough so that the actual absorption
C is greater than 50%, and preferrably more than 70%.)
C nnkpar(i) is number of n-phi values to be taken in each n-phi bin
C anzinf(i) is the lower bound value of n-phi for ith bin
C anzsup(i) is the upper bound value of n-phi for ith bin
C nthin=No. of poloidal positions to start a ray,
C total No. of rays is sum(i=1,nspect) of nnkpar(i)*nthin
C maxref= maximum No. of reflections for each ray
C islofa=-1 for fast wave, islofa=1 for slow wave.
C isimm=nspect=no. of n-phi spectrum bins
C Normal input: igrill (defined later)=-3; nnkpar(i)=1
C The following three arrays are only used when igrill=-3 and nnkpar(i)=1:
C nnkpol(i) is number of n-poloidal values to be taken in each n-phi bin
C anpinf(i) is lower bound value of n-pol for the ith-bin
C anpsup(i) is upper bound value of n-pol for the ith-bin
C normally, set nnkpol(i)=1 and anpsup(i)=anpinf(i)
C ptot0 is total rf-power in MW
C********************************
C Note: Run time is roughly proportional to nraypts and total No. of rays.
C*************************
      nspect = isimm
      call tmpdata(4)
C
C   set workarea to zero and renormalize spectal powers to ptot0

C**************************
C tmpdata sums absorption and current density profiles of all RF sources.
C tmpdata(ientry): ientry=1  zero out working areas
C                        =2  add contribution of RF-source to work-areas
C                        =3  add absorption and current of all previous
C                            RF-source to the current RF-source
C                        =4  renormalize spectral powers to total power
C                            specified by ptot0
C                        =6  output profiles and total absorption etc.
C                            to output file (called only if there are
C                            more than one RF-source)
C
C****************************************************************
C
C  Basic control parameters for xcurray are:
C  initlh  0  calc rays
C          1  read in ray data from rayop and extend as appropriate
C  nraypts    max number of ray elements for which calc performed.
C  ieqdsk  0  use Brambilla flux surface specification.
C          1  from Brambilla representation, generate and write an eqdsk,
C             then use it; (not working)
C          2  from Brambilla representation, generate and write an eqdsk,
C             then exit; (not working)
C          3  read eqdsk to get equilibrium data.
C          4  read extended eqdsk to get equilibrium data and plasma
C             profiles.
C
C ieqdsk set by rtinout(1) to 0 for codeid='onedee', 4 otherwise.
C
C****************************************************************
C
C
C dang : angular increment for contour search
C nptsd : no. of points in theta grid in contour nptsd=360/dang+1
C nxeqd : eqdsk x-array dimension, default is 33
C nzeqd :  "     z-"      "          "         65
C specfac :  used in pwicpl for spectrum weight;default=0.5
C New statements added by TK Mau  8/8/91
C thgril :  in degrees
C delthe :  inradians
C idrive : >0  do current drive calculations
C*******************
C ichois=1: Use high frequency dispersion (for LH)
C       =2: Use ICRF dispersion (for FW)
C***************************
C modcd =0:  Ehst model for j/p
C       =1:  Chiu's model
C wfrac0: wall attenuation factor per reflection
C phase: in degrees (not relevant)
C---------------------
C igrill =-1,Analytic fitted power spectrum
C        =-2, read in power spectrum and starting n-phi
C                  (not working)
C        =-3:  Read in poloidal and toroidal spectrum
C------------------------------
C
C deykpr :  step along ray for saving data, in phase periods.
C psistep :if.ne.0.,  then adjust deykpr at each step so that
C           the step in psi is approx. psistep
C pkexpnt: Further adjust deykpr so that the step in psi is
C        approx psistep/abs(pkpar)**pkexpnt
C igraph:0 suppresses graphical output; 1 for normal graphical output
C iprint =0  output suppressed
C          =1  normal output
C          =2  more detailed output
C          =3  determine output at each call of output1(x)
C bmax: Maximum in the bessel function table
C scatd: Pi/2-k_perp-scattering depth of edge plasma.
C iscat0 : If .eq.0, no scatttering as ray leaves antenna.
C solrfl: Scrapeoff layer position for reflection.
C accur: default 1.e-5

C*****************************************************************
C  Input parameters for bi-Maxwellian description of electron and
C    ion distribution functions
C  This section is relevant only if inf=-1 and/or infi<=0.
C  For explanation, please see file CURRAY.V
C  nspec=3
C  trate=1.;  tratte=1.;  ttle=5.;  concte=0.0
C  trati(1)=1.;  tratti(1)=1.;  ttli(1)=5.;  concti(1)=0.0
C  trati(2)=1.;  tratti(2)=1.;  ttli(2)=5.;  concti(2)=0.0
C  trati(3)=1.;  tratti(3)=1.;  ttli(3)=5.;  concti(3)=0.0
C  vdrfte=0.;  vdrfti(1)=0.;  infi(1)=0; vdrfti(2)=0.; infi(2)=0
C         vdrfti(3)=0.; infi(3)=0
C
C****************************************************************
C  Reset plasma equilibrium quantities if ieqdsk.eq.0:
C  (Else equilibrium data obtained from an existing eqdsk.)

      select case (ieqdsk)
      case (0)

C******************
C  for analytical MHDEQ
C*******************
C           open(iounit1,file='aneqfl',status='old')
C           read(iounit1,inpeq)
C rshift:shift of flux surfaces
C dtrian:triangularity
         dpsimhd = 1./float(nmhd - 1)
         do ijk = 1, nmhd
            psimhd(ijk) = float(ijk - 1)*dpsimhd
            rmaj(ijk) = furmaj(psimhd(ijk))
            rrho(ijk) = furrho(psimhd(ijk))
            triang(ijk) = futria(psimhd(ijk))
            elong(ijk) = fuelon(psimhd(ijk))
         end do
         do ijk = 1, nprofs
            psi = float(ijk - 1)/float(nprofs - 1)
            ppsi(ijk) = psi
            pne(ijk) = prone(psi)
            pte(ijk) = prote(psi)
            pjavg(ijk) = pte(ijk)**1.5
            do kion = 1, nspec
               pti(ijk,nspec) = proti(psi)
            end do
         end do
      case (3)
c
c    ipropt=1   n-T calculated from prontp
c          =0       read in from eqdskex
         ipropt = 1
c        open(iounit1, file='eqdsk.hb', status='old')
      case (4)
         ipropt = 0
!         call link('unit59=terminal//')
         write (6, 901)
  901    format('opening eqdsk')
         open(iounit1, file='eqdskex', status='old')
      case (5)
c
c  Bob Miller's equilibrium disk
c
         ipropt = 1
         open(iounit1, file='dskbal', status='old')
c           open(iounit1,file='eqdskex',status='old')
      end select
C  Set edge treatment flag. (Calc edge region parameters
C  below if ieqdsk.eq.0; else, in fiteqdsk).
C  Number of flux surface pts including plasma edge region.
C****************************************************************
C  Set nequip to nraypts
      nequip = nraypts
C
C for first call of inital use ientry=1
C
C  for more than one call of inital use ientry=2 for later calls.
      if (initlh == 0) call inital
C
C  epserr:first error limit
C  epser1:second error limit: epser1 should be about 4 to 5 times smaller than epser
C
C
C  idmpsw=0  ion damping not calculated
C        =1  ion damping calculated.
C
C
C  rayop-file output option
C  irayio =0   output current and absorption profiles plus ray data
C         =1   no current and absorption profiles in rayop
C              for CQL3D rayop files, use =1 option
C
      if (icurdr == 1) then
         call op_file(3)
         call op_file(4)
         call op_file(5)
         call op_file(6)
c        open(iout3, file='adjinp', status='unknown')
c        open(iout4, file='scrach', status='unknown')
c        open(iout5, file='adjout', status='unknown')
c        open(iout6, file='joptab', status='unknown')
         call master (1)
      endif
      if (icurdr/=1 .and. idcur==3) then
         call op_file(3)
         call op_file(4)
         call op_file(5)
         call op_file(6)
c        open(iout3, file='adjinp', status='old')
c        open(iout4, file='scrach', status='unknown')
c        open(iout5, file='adjout', status='old')
c        open(iout6, file='joptab', status='unknown')
         call master (2)
      endif
c     if (icurdr/=1 .and. idcur/=3) then
c        open(iout3, file='adjinp', status='unknown')
c        open(iout4, file='scrach', status='unknown')
c        call master(4)
c     endif
c
c
      call op_file(2)
c     open(iout2, file='rayop', status='unknown')
      call master(3)
      if (initlh==1 .and. inf>=0) call dodamp
C
C****************************************************************
C   Output the ray data
C files with the following names should be moved or erased
      if (nrf /= numrf) then
         call tmpdata(2)
      else
         call tmpdata(3)
         call tmpdata(6)
      endif
      close(iout1)
!        close(iout)
      close(iounit1)
c100   continue
C****************************************************************
C
C  output heating and current drive data for ONETWO
      if(ioread==1) then 
         open(iout1, file='raytrout', status='unknown')
         call rtinout(2)
         close(iout1)
       endif
!      call secnds(tfinl)
!      trun = tfinl - tinit
!      write (iout, '(/"  Runtime = ",e12.3," seconds")') trun
      close(iout)
c
c---- Write output quantities as arguments of subroutine
c
      ppsi_c(:nprofs) = ppsi(:nprofs)
      pwe_c(:nprofs) = pwe(:nprofs)
      pwit_c(:nprofs) = pwit(:nprofs)
c     pwi_c(:nprofs,:nspec) = pwi(:nprofs,:nspec)
      pwct_c(:nprofs) = pwct(:nprofs)
c
      return
      end subroutine curray
C
C****************************************************************
c

! 07Jun1999 fgtok -impno -s r8_precision.sub r8_names.table "r8con.csh conversion"
c
c  bcspeval -- eval bicubic spline function and/or derivatives
c
      subroutine r8bcspeval(xget,yget,iselect,fval,
     >                    x,nx,y,ny,ilinx,iliny,f,inf3,ier)
c
      IMPLICIT NONE
      integer iselect(6)
      integer ilinx,iliny,nx,ny,inf3,ier
c
      REAL*8 xget,yget
      REAL*8 fval(6)
      REAL*8 x(nx),y(ny),f(4,4,inf3,ny)
c
c  modification -- dmc 11 Jan 1999 -- remove SAVE stmts; break routine
C    into these parts:
C
C    bcspevxy -- find grid cell of target pt.
C    bcspevfn -- evaluate function using output of bcpsevxy
C
C    in cases where multiple functions are defined on the same grid,
C    time can be saved by using bcspevxy once and then bcspevfn
C    multiple times.
c
c  input:
c     (xget,yget)   location where interpolated value is desired
c                   x(1).le.xget.le.x(nx) expected
c                   y(1).le.yget.le.y(ny) expected
c
c     iselect       select desired output
c
c                     iselect(1)=1 -- want function value (f) itself
c                     iselect(2)=1 -- want  df/dx
c                     iselect(3)=1 -- want  df/dy
c                     iselect(4)=1 -- want  d2f/dx2
c                     iselect(5)=1 -- want  d2f/dy2
c                     iselect(6)=1 -- want  d2f/dxdy
c
c              example:  iselect(1)=iselect(2)=iselect(3)=1
c                            f, df/dx, and df/dy all evaluated
c                        iselect(4)=iselect(5)=iselect(6)=0
c                            2nd derivatives not evaluated.
c
c                   see fval (output) description.
c
c     x(1...nx)     independent coordinate x, strict ascending
c     y(1...ny)     independent coordinate y, strict ascending
c
c     ilinx  --  =1: flag that x is linearly spaced (avoid search for speed)
c     iliny  --  =1: flag that y is linearly spaced (avoid search for speed)
c
c  **CAUTION** actual even spacing of x, y is NOT CHECKED HERE!
c
c
c     f             the function values (at grid points) and spline coefs
c
c  evaluation formula:  for point x btw x(i) and x(i+1), dx=x-x(i)
c                             and y btw y(j) and y(j+1), dy=y-y(j),
c
c      spline value =
c        f(1,1,i,j) + dx*f(2,1,i,j) + dx**2*f(3,1,i,j) + dx**3*f(4,1,i,j)
c   +dy*(f(1,2,i,j) + dx*f(2,2,i,j) + dx**2*f(3,2,i,j) + dx**3*f(4,2,i,j))
c   +d2*(f(1,3,i,j) + dx*f(2,3,i,j) + dx**2*f(3,3,i,j) + dx**3*f(4,3,i,j))
c   +d3*(f(1,4,i,j) + dx*f(2,4,i,j) + dx**2*f(3,4,i,j) + dx**3*f(4,4,i,j))
c
c      where d2=dy**2 and d3=dy**3.
c
c  output:
c      up to 6 elements of fval, ordered as follows:
c        fval(1)=function value or lowest order derivative requested
c        fval(2)=next order derivative
c             etc
c        the ordering is a subset of the sequence given under the "iselect"
c        description.
c
c      ier = 0 -- successful completion; = 1 -- an error occurred.
c
c-------------------------------------------------------------------
c  local
c
      integer i,j
c
      REAL*8 dx,dy
c
c--------------------------
c
      call r8bcspevxy(xget,yget,x,nx,y,ny,ilinx,iliny,
     >   i,j,dx,dy,ier)
      if(ier.ne.0) return
c
      call r8bcspevfn(iselect,1,1,fval,i,j,dx,dy,f,inf3,ny)
c
      return
      end
c
c-------------------------------------------------------------------------
c  bcspevxy -- look up x-y zone
c
c  this is the "first part" of bcspeval, see comments, above.
c
      subroutine r8bcspevxy(xget,yget,x,nx,y,ny,ilinx,iliny,
     >   i,j,dx,dy,ier)
c
      IMPLICIT NONE
C============
C idecl:  explicitize implicit INTEGER declarations:
      INTEGER nxm,nym,ii,jj
C============
C idecl:  explicitize implicit REAL declarations:
      REAL*8 zxget,zyget,zxtol,zytol
C============
      integer nx,ny                     ! array dimensions
c
      REAL*8 xget,yget                    ! target point
      REAL*8 x(nx),y(ny)                  ! indep. coords.
c
      integer ilinx                     ! =1:  assume x evenly spaced
      integer iliny                     ! =1:  assume y evenly spaced
c
c  output of bcspevxy
c
      integer i,j                       ! index to cell containing target pt
      REAL*8 dx,dy                        ! displacement of target pt w/in cell
                                        ! dx=x-x(i)  dy=y-y(j)
C
      integer ier                       ! return ier.ne.0 on error
c
c------------------------------------
c
      ier=0
c
c  range check
c
      zxget=xget
      zyget=yget
 
      if((xget.lt.x(1)).or.(xget.gt.x(nx))) then
         zxtol=4.0D-7*max(abs(x(1)),abs(x(nx)))
         if((xget.lt.x(1)-zxtol).or.(xget.gt.x(nx)+zxtol)) then
            ier=1
            write(6,1001) xget,x(1),x(nx)
 1001       format(' ?bcspeval:  xget=',1pe11.4,' out of range ',
     >         1pe11.4,' to ',1pe11.4)
         else
            if((xget.lt.x(1)-0.5D0*zxtol).or.
     >         (xget.gt.x(nx)+0.5D0*zxtol))
     >      write(6,1011) xget,x(1),x(nx)
 1011       format(' %bcspeval:  xget=',1pe15.8,' beyond range ',
     >         1pe15.8,' to ',1pe15.8,' (fixup applied)')
            if(xget.lt.x(1)) then
               zxget=x(1)
            else
               zxget=x(nx)
            endif
         endif
      endif
      if((yget.lt.y(1)).or.(yget.gt.y(ny))) then
         zytol=4.0D-7*max(abs(y(1)),abs(y(ny)))
         if((yget.lt.y(1)-zytol).or.(yget.gt.y(ny)+zytol)) then
            ier=1
            write(6,1002) yget,y(1),y(ny)
 1002       format(' ?bcspeval:  yget=',1pe11.4,' out of range ',
     >         1pe11.4,' to ',1pe11.4)
         else
         if((yget.lt.y(1)-0.5D0*zytol).or.(yget.gt.y(ny)+0.5D0*zytol))
     >      write(6,1012) yget,y(1),y(ny)
 1012       format(' %bcspeval:  yget=',1pe15.8,' beyond range ',
     >         1pe15.8,' to ',1pe15.8,' (fixup applied)')
            if(yget.lt.y(1)) then
               zyget=y(1)
            else
               zyget=y(ny)
            endif
         endif
      endif
      if(ier.ne.0) return
c
c  now find interval in which target point lies..
c
      nxm=nx-1
      nym=ny-1
c
      if(ilinx.eq.1) then
         ii=1+nxm*(zxget-x(1))/(x(nx)-x(1))
         i=min(nxm, ii)
      else
         if((1.le.i).and.(i.lt.nxm)) then
            if((x(i).le.zxget).and.(zxget.le.x(i+1))) then
               continue  ! already have the zone
            else
               call r8bcspefnd(x,nx,zxget,i)
            endif
         else
            call r8bcspefnd(x,nx,zxget,i)
         endif
      endif
c
      if(iliny.eq.1) then
         jj=1+nym*(zyget-y(1))/(y(ny)-y(1))
         j=min(nym, jj)
      else
         if((1.le.j).and.(j.lt.nym)) then
            if((y(j).le.zyget).and.(zyget.le.y(j+1))) then
               continue  ! already have the zone
            else
               call r8bcspefnd(y,ny,zyget,j)
            endif
         else
            call r8bcspefnd(y,ny,zyget,j)
         endif
      endif
c
      dx=zxget-x(i)
      dy=zyget-y(j)
c
      return
      end
c------------------------------------------------------------------------
c  bcspevfn -- OK now evaluate the bicubic spline
c
      subroutine r8bcspevfn(ict,ivec,ivd,fval,iv,jv,dxv,dyv,f,inf3,ny)
c
c  input:
      IMPLICIT NONE
C============
C idecl:  explicitize implicit INTEGER declarations:
      INTEGER ny,iaval,i,j
C============
C idecl:  explicitize implicit REAL declarations:
      REAL*8 dx,dy
C============
      integer ict(6)                    ! selector:
c        ict(1)=1 for f      (don't evaluate f if ict(1)=0)
c        ict(2)=1 for df/dx   ""
c        ict(3)=1 for df/dy   ""
c        ict(4)=1 for d2f/dx2
c        ict(5)=1 for d2f/dy2
c        ict(6)=1 for d2f/dxdy
c
c    note:  if ict(1)=-1, evaluate f,d2f/dx2,d2f/dy2,d4f/dx2dy2
c
      integer ivec,ivd                  ! vector dimensioning
c
c    ivec-- number of vector pts (spline values to look up)
c    ivd -- 1st dimension of fval, .ge.ivec
c
c output:
      REAL*8 fval(ivd,6)                 ! output array
c
c    v = index to element in vector;
c  fval(v,1) = first item requested by ict(...),
c  fval(v,2) = 2nd item requested,  ...etc...
c
c  input:
      integer iv(ivec),jv(ivec)         ! grid cell indices -- vectors
      REAL*8 dxv(ivec),dyv(ivec)          ! displacements w/in cell -- vectors
c
      integer inf3                      ! 3rd dimension of f -- .ge. nx
      REAL*8 f(4,4,inf3,ny)               ! bicubic fcn spline coeffs array
c
c  usage example:
c
c  1.  for each element (xx(v),yy(v)) in a vector of (x,y) pairs,
c    find the x and y zone indices and displacements with respect
c    to the "lower left corner" of the zone; store these in vectors
c    iv,jv and dxv,dyv.
c
c  2.  set ict(1)=0, ict(2)=1, ict(3)=1, the rest zero -- get only
c      the 1st derivatives.
c
c  3.  ivec is the length of the vector; ivd is the 1st dimension
c      of the array fval to receive the output
c
c      real fval(ivd,6)
c      real xv(ivd),yv(ivd)
c      integer iv(ivd),jv(ivd)
c      real dxv(ivd),dyv(ivd)
c      integer ict(6)
c
c      real fspline(4,4,nx,ny)  ! spline coeffs
c      data ict/0,1,1,0,0,0/    ! this call:  want 1st derivatives
c                               ! only ... these will be output to
c                               ! fval(*,1) fval(*,2)
c      ...
c      do iv=1,ivec
c        ...                    ! find indices and displacements
c      enddo
c      call bcspevfn(ict,ivec,ivd,fval,iv,jv,dxv,dyv,fspline,nx,ny)
c
c-------------------------------------------------------------------
c  local:
c
      integer v                         ! vector element index
c
c  OK can now do evaluations
c
      iaval=0  ! fval addressing
c
      if((ict(1).gt.0).or.(ict(1).eq.-1)) then
c  evaluate f
         iaval=iaval+1
         do v=1,ivec
            i=iv(v)
            j=jv(v)
            dx=dxv(v)
            dy=dyv(v)
            fval(v,iaval)=
     >       f(1,1,i,j)+dy*(f(1,2,i,j)+dy*(f(1,3,i,j)+dy*f(1,4,i,j)))
     >  +dx*(f(2,1,i,j)+dy*(f(2,2,i,j)+dy*(f(2,3,i,j)+dy*f(2,4,i,j)))
     >  +dx*(f(3,1,i,j)+dy*(f(3,2,i,j)+dy*(f(3,3,i,j)+dy*f(3,4,i,j)))
     >  +dx*(f(4,1,i,j)+dy*(f(4,2,i,j)+dy*(f(4,3,i,j)+dy*f(4,4,i,j))))))
         enddo
      endif
c
      if((ict(2).gt.0).and.(ict(1).ne.-1)) then
c  evaluate df/dx
         iaval=iaval+1
         do v=1,ivec
            i=iv(v)
            j=jv(v)
            dx=dxv(v)
            dy=dyv(v)
            fval(v,iaval)=
     >         f(2,1,i,j)+dy*(f(2,2,i,j)+dy*(f(2,3,i,j)+dy*f(2,4,i,j)))
     >       +2.0D0*dx*(
     >         f(3,1,i,j)+dy*(f(3,2,i,j)+dy*(f(3,3,i,j)+dy*f(3,4,i,j)))
     >       +1.5D0*dx*(
     >         f(4,1,i,j)+dy*(f(4,2,i,j)+dy*(f(4,3,i,j)+dy*f(4,4,i,j)))
     >         ))
         enddo
      endif
c
      if((ict(3).gt.0).and.(ict(1).ne.-1)) then
c  evaluate df/dy
         iaval=iaval+1
         do v=1,ivec
            i=iv(v)
            j=jv(v)
            dx=dxv(v)
            dy=dyv(v)
            fval(v,iaval)=
     >         f(1,2,i,j)+dy*(2.0D0*f(1,3,i,j)+dy*3.0D0*f(1,4,i,j))
     >         +dx*(f(2,2,i,j)+dy*(2.0D0*f(2,3,i,j)+dy*3.0D0*f(2,4,i,j))
     >         +dx*(f(3,2,i,j)+dy*(2.0D0*f(3,3,i,j)+dy*3.0D0*f(3,4,i,j))
     >         +dx*(f(4,2,i,j)+dy*(2.0D0*f(4,3,i,j)+dy*3.0D0*f(4,4,i,j))
     >         )))
         enddo
      endif
c
      if((ict(4).gt.0).or.(ict(1).eq.-1)) then
c  evaluate d2f/dx2
         iaval=iaval+1
         do v=1,ivec
            i=iv(v)
            j=jv(v)
            dx=dxv(v)
            dy=dyv(v)
            fval(v,iaval)=
     >        2.0D0*(
     >         f(3,1,i,j)+dy*(f(3,2,i,j)+dy*(f(3,3,i,j)+dy*f(3,4,i,j))))
     >       +6.0D0*dx*(
     >         f(4,1,i,j)+dy*(f(4,2,i,j)+dy*(f(4,3,i,j)+dy*f(4,4,i,j))))
         enddo
      endif
c
      if((ict(5).gt.0).or.(ict(1).eq.-1)) then
c  evaluate d2f/dy2
         iaval=iaval+1
         do v=1,ivec
            i=iv(v)
            j=jv(v)
            dx=dxv(v)
            dy=dyv(v)
            fval(v,iaval)=
     >         2.0D0*f(1,3,i,j)+6.0D0*dy*f(1,4,i,j)
     >         +dx*(2.0D0*f(2,3,i,j)+6.0D0*dy*f(2,4,i,j)
     >         +dx*(2.0D0*f(3,3,i,j)+6.0D0*dy*f(3,4,i,j)
     >         +dx*(2.0D0*f(4,3,i,j)+6.0D0*dy*f(4,4,i,j))))
         enddo
      endif
c
      if((ict(6).gt.0).and.(ict(1).ne.-1)) then
c  evaluate d2f/dxdy
         iaval=iaval+1
         do v=1,ivec
            i=iv(v)
            j=jv(v)
            dx=dxv(v)
            dy=dyv(v)
            fval(v,iaval)=
     >         f(2,2,i,j)+dy*(2.0D0*f(2,3,i,j)+dy*3.0D0*f(2,4,i,j))
     >  +2.D0*dx*(f(3,2,i,j)+dy*(2.0D0*f(3,3,i,j)+dy*3.0D0*f(3,4,i,j))
     > +1.5D0*dx*(f(4,2,i,j)+dy*(2.0D0*f(4,3,i,j)+dy*3.0D0*f(4,4,i,j))))
         enddo
      endif
c
      if(ict(1).eq.-1) then
         iaval=iaval+1
         do v=1,ivec
            i=iv(v)
            j=jv(v)
            dx=dxv(v)
            dy=dyv(v)
            fval(v,iaval)=
     >         4.0D0*f(3,3,i,j)+12.0D0*dy*f(3,4,i,j)
     >         +dx*(12.0D0*f(4,3,i,j)+36.0D0*dy*f(4,4,i,j))
         enddo
      endif
c
      return
      end
c----------------------

      PROGRAM sample_psgbsv_call
*
*  -- ScaLAPACK example code --
*
*     Written by Xiaoye S. Li, 6-4-97 (xiaoye@nersc.gov)
*
*     This program shows how to set the matrix descriptors and call
*     the general band linear equation solver PSGBSV.
*
*     To run the program, type the following command:
*        mpprun -n 2 sample_psgbsv_call
*     ..
*     .. Data layout ..
* 
*     8 x 8 matrix A is partitioned into 1 x 2 blocks, each of size 8 x 4.
*     The 2 processes are arranged as 1 x 2 process grid.
*     The 1-dimensional block-column distribution gives the following mapping 
*     between process grid and the global matrix.
*
*                P0    |   P1
*            ---------------------
*            [4 1  1   |         ]    bwl = 1  lower bandwidth
*            [1 4  1 1 |         ]    BWU = 2  upper bandwidth
*            [  1  4 1 |1        ]
*            [     1 4 |1 1      ]
*            [       1 |4 1  1   ]
*            [         |1 4  1 1 ]
*            [         |  1  4 1 ]
*            [         |     1 4 ]
*            ---------------------
*     
*     Mapping of the local arrays (in compact storage) is given below.
*     "F" is a position for potential fill-in due to partial pivoting.
*
*                P0    |   P1
*            ---------------------
*            [F F  F F |F F  F F ]
*            [F F  F F |F F  F F ]    Number of rows = 2*(bwl+bwu)+1
*            [F F  F F |F F  F F ]
*            [* *  1 1 |1 1  1 1 ]
*            [* 1  1 1 |1 1  1 1 ]
*            [4 4  4 4 |4 4  4 4 ]
*            [1 1  1 1 |1 1  1 * ]
*            ---------------------
*
*     For a complete description of the compact storage schemes for band
*     matrices, refer to ScaLAPACK Users' Guide Section 4.4 "In-Core Narrow
*     Band and Tridiagonal Matrices".
*
*     The RHS B is a vector of all 1's. The correct solution vector is 
*
*            0.18092206366630079
*            0.13145993413830953
*            0.14485181119648735
*            0.14838638858397366
*            0.14074643249176727
*            0.12085620197585072
*            0.16777167947310648
*            0.20805708013172339
*
*
      implicit none
*     ..
*     .. Parameters ..
* Entries associated with the distributed array descriptors
      INTEGER            BLOCK_CYCLIC_2D, CSRC_, CTXT_, DLEN_, DTYPE_,
     $                   LLD_, MB_, M_, NB_, N_, RSRC_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                     CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                     RSRC_ = 7, CSRC_ = 8, LLD_ = 9 )
*
      real   ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
      integer LWORK
      PARAMETER          ( LWORK = 2000 )
*     ..
*     .. Local Scalars ..
      INTEGER            IAM, ICTXT, INFO, MYCOL, MYROW, M, N, NB, NRHS,
     $                   MYRHS_SIZE, NPCOL, NPROCS, NPROW,
     $                   bwl, bwu, lda, i
*     ..
*     .. Local Arrays ..
      INTEGER            DESCA( 7 ), DESCB( 7 ), ipiv(8)
      REAL               A(200), B(200), WORK(LWORK)
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   DESCINIT, PSGBSV
*     ..
*     .. External Functions ..
      INTEGER            NUMROC
      EXTERNAL           NUMROC
*     ..
*     .. Executable Statements ..
*
*     Get starting information
*
      CALL BLACS_PINFO( IAM, NPROCS )
      M = 8
      N = M
      bwl = 1
      bwu = 2
      NB = 4
      nrhs = 1
      NPROW = 1
      NPCOL = 2
*
*     Define process grid
*
      CALL BLACS_GET( -1, 0, ICTXT )
      CALL BLACS_GRIDINIT( ICTXT, 'Row-major', NPROW, NPCOL )
*
*     Go to bottom of process grid loop if this case doesn't use my
*     process
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
      IF( MYROW.LT.0 .OR. MYCOL.LT.0 ) THEN
         GO TO 50
      ENDIF
*
*
*     Initialize Array Descriptor for matrix A
*
      DESCA( 1 ) = 501
      DESCA( 2 ) = ICTXT
      DESCA( 3 ) = N
      DESCA( 4 ) = NB
      DESCA( 5 ) = 0
      DESCA( 6 ) = 2*(bwl+bwu)+1
      DESCA( 7 ) = 0
*
*     Initialize Array Descriptor for rhs
*     
      DESCB( 1 ) = 502
      DESCB( 2 ) = ICTXT
      DESCB( 3 ) = N
      DESCB( 4 ) = NB
      DESCB( 5 ) = 0
      DESCB( 6 ) = NB
      DESCB( 7 ) = 0
*
*     Generate matrix A
*
      lda = 2*(bwl+bwu)+1
      if ( iam .eq. 0 ) then
         A(6) = 4
         A(7) = 1
         A(5 + lda) = 1
         A(6 + lda) = 4
         A(7 + lda) = 1
         A(4 + 2*lda) = 1
         A(5 + 2*lda) = 1
         A(6 + 2*lda) = 4
         A(7 + 2*lda) = 1
         A(4 + 3*lda) = 1
         A(5 + 3*lda) = 1
         A(6 + 3*lda) = 4
         A(7 + 3*lda) = 1
      endif
      if ( iam .eq. 1 ) then
         A(4) = 1
         A(5) = 1
         A(6) = 4
         A(7) = 1
         A(4 + lda) = 1
         A(5 + lda) = 1
         A(6 + lda) = 4
         A(7 + lda) = 1
         A(4 + 2*lda) = 1
         A(5 + 2*lda) = 1
         A(6 + 2*lda) = 4
         A(7 + 2*lda) = 1
         A(4 + 3*lda) = 1
         A(5 + 3*lda) = 1
         A(6 + 3*lda) = 4
      endif
*
*     Generate RHS
*
      MYRHS_SIZE = NUMROC( N, NB, MYCOL, 0, NPCOL )
      do i = 1, myrhs_size
         B(i) = 1
      enddo
*
*     Solve the linear system
*
      CALL PSGBSV( N, BWL, BWU, NRHS, A, 1, DESCA, IPIV, B, 1,
     $             DESCB, WORK, LWORK, INFO )
*
*     Print the solution vector
*
      print *,'IAM = ',IAM
      IF( IAM.EQ.0 ) THEN
         print*, (B(i), i=1,MYRHS_SIZE)
      END IF
      CALL BLACS_BARRIER( ICTXT, 'All' )
      IF( IAM.EQ.1 ) THEN
         print*, (B(i), i=1,MYRHS_SIZE)
      END IF
*
      CALL BLACS_GRIDEXIT( ICTXT )
*
 50   continue
*
      CALL BLACS_EXIT( 0 )
*
      STOP
*
*     End of sample_psgbsv_call
*
      END

      FUNCTION D9LGMC (X)
C***BEGIN PROLOGUE  D9LGMC
C***SUBSIDIARY
C***PURPOSE  Compute the log Gamma correction factor so that
C            LOG(DGAMMA(X)) = LOG(SQRT(2*PI)) + (X-5.)*LOG(X) - X
C            + D9LGMC(X).
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7E
C***TYPE      real(kind=dp) (R9LGMC-S, D9LGMC-D, C9LGMC-C)
C***KEYWORDS  COMPLETE GAMMA FUNCTION, CORRECTION TERM, FNLIB,
C             LOG GAMMA, LOGARITHM, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C Compute the log gamma correction factor for X .GE. 10. so that
C LOG (DGAMMA(X)) = LOG(SQRT(2*PI)) + (X-.5)*LOG(X) - X + D9lGMC(X)
C
C Series for ALGM       on the interval  0.          to  1.00000E-02
C                                        with weighted error   1.28E-31
C                                         log weighted error  30.89
C                               significant figures required  29.81
C                                    decimal places required  31.48
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, DCSEVL, INITDS, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900720  Routine changed from user-callable to subsidiary.  (WRB)
C***END PROLOGUE  D9LGMC
C============
C idecl:  explicitize implicit INTEGER declarations:
      use kind_spec

      IMPLICIT NONE
      INTEGER nalgm,initds
C============
      real(kind=dp) D9LGMC
      real(kind=dp) X, ALGMCS(15), XBIG, XMAX, DCSEVL, D1MACH
      LOGICAL FIRST
      SAVE ALGMCS, NALGM, XBIG, XMAX, FIRST
      DATA ALGMCS(  1) / +.1666389480451863247205729650822E+0_dp/

      DATA ALGMCS(  2) / -.1384948176067563840732986059135E-4_dp/

      DATA ALGMCS(  3) / +.9810825646924729426157171547487E-8_dp/

      DATA ALGMCS(  4) / -.1809129475572494194263306266719E-10_dp/

      DATA ALGMCS(  5) / +.6221098041892605227126015543416E-13_dp/

      DATA ALGMCS(  6) / -.3399615005417721944303330599666E-15_dp/

      DATA ALGMCS(  7) / +.2683181998482698748957538846666E-17_dp/

      DATA ALGMCS(  8) / -.2868042435334643284144622399999E-19_dp/

      DATA ALGMCS(  9) / +.3962837061046434803679306666666E-21_dp/

      DATA ALGMCS( 10) / -.6831888753985766870111999999999E-23_dp/

      DATA ALGMCS( 11) / +.1429227355942498147573333333333E-24_dp/

      DATA ALGMCS( 12) / -.3547598158101070547199999999999E-26_dp/

      DATA ALGMCS( 13) / +.1025680058010470912000000000000E-27_dp/

      DATA ALGMCS( 14) / -.3401102254316748799999999999999E-29_dp/

      DATA ALGMCS( 15) / +.1276642195630062933333333333333E-30_dp/

      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  D9LGMC
      IF (FIRST) THEN
         NALGM = INITDS (ALGMCS, 15, (d1mach3) )
         XBIG = 1.0E0_dp/SQRT(d1mach3)

         XMAX = EXP (MIN(LOG(d1mach2/12.E0_dp),

     >      -LOG(12.E0_dp*d1mach1)))

      ENDIF
      FIRST = .FALSE.
C
      IF (X .LT. 10.E0_dp) CALL XERMSG ('SLATEC', 'D9LGMC',

     +   'X MUST BE GE 10', 1, 2)
      IF (X.GE.XMAX) GO TO 20
C
      D9LGMC = 1.E0_dp/(12.E0_dp*X)

      IF (X.LT.XBIG) D9LGMC =
     1   DCSEVL (2.0E0_dp*(10.E0_dp/X)**2-1.E0_dp, ALGMCS,

     1   NALGM) / X
      RETURN
C
 20   D9LGMC = 0.E0_dp

      CALL XERMSG ('SLATEC', 'D9LGMC', 'X SO BIG D9LGMC UNDERFLOWS', 2,
     +   1)
      RETURN
C
      END
! 22Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 22Jun2000 fgtok
! 22Jun2000 fgtok
! 22Jun2000 fgtok

      module Vcraylh
C...Created by Pacific-Sierra Research VAST-90 2.06G2  12:29:44   5/18/01  
      use Vparam, only: nprofm, nions, ntheta, nspectm, nbitab, nli,
     1             npsis, npnta, mpnta, npdim, ndim20, ndim30
      character   jopid*40
      integer   ndim3, ndim2
      integer   numkpar, nstppic
      integer   iscat0
      integer   ichois, istop, istart, indgr, isxz, nrayno, left, nnztot
     1   , nurefl, isign, light, jslofa, imcon, keik, jpe, jpi, idmpsw
      integer   icurdr, iout0, iout3, iout4, iout5, iout6, iout7, iout8
     1   , iswchi, nthp0, npsi0, nmax, imax, lmax, nwp, tmax, nthp1, 
     2   nthp11, nthp12, npsi01, npsi02, nwp1, nwp2, joplg, idcur, iadj
     3   , modcd, mthwp, npnt, mpnt, npsig, nthpg, numg
      integer, dimension(61) :: jss
      integer, dimension(npdim) :: jmcon
      integer, dimension(nprofm,2) :: kparmx, kparmn
      real   hzf
      real   del0, delxp, del1
      real   dense, derdne, tempe, derte, btor, bpol, btot
      real   xpc, y2c, xp, y2, heta, zeff, xe
      real   dkpsip,dkpsit,dkhep,dkhet,dkpzp,dkpzt, dkp2p, dkp2t
      real   ukzero,urplas,uraxmag,raxmag,xmin,xmax,baxis,dpolas
      real   zxmin,zxe2,zc1,eps3r,eps3i,aeps32,ssmnp2,emod,dd,ss
      real   disph,dhkp2,dhkz,dhne,dhte,dhom,ha,hb,hc,alfa,dsperr
      real   pkmax, pkmin, facpwr, raypic
      real   sjopptr, sjopcptr, sjopdptr, aspinptr, wpptr, thetpptr
      real   aerrmx,rerrmx,psimx,psimn,umax1,wpmx,wpmn,dwp,dthp1,dpsis
      real, dimension(ndim30,ndim20)::rayx,rayz,raypol,raykpar, 
     1   raykper, raypwr, raypsi, rayphi, raycpz
      real accur,dsteph,dpsi,akrini,dkdrin,amime,powold,pwconf
     1   , eikref, hh
      real  xx,eikon,psi,theta,ux,uz,urhs,xu,zu,acosth,asinth
     1   , acostq, asintq, phi, phi0, pwx, dpwri, dpwrf
      real  aj,antau,ag,dxpsi,dxth,dzpsi,dzth,djp,djt,dgp, dgt
     1   , dntaup, dntaut, dompsi, domth, dqpsi, dqth
      real   akpsi,akth,anphi,pkpsi,pktau,pkphi,pkheta,pkx,pkz, 
     1   pkpar, pkpar2, pkp, pkp2, pkp2x, pk
      real gamit,game,gamce,gamma,alphac,alphal,poyntn,pwtote, 
     1   epx, epy, epz, ztx, ztz, ztpsi, zttau, zpwabs, scatd, alpha1, 
     2   alpha2, solrfl, eprat, almi
      real, dimension(nprofm,4) :: tne, tte, tqr
      real, dimension(nprofm) :: tpsi, zsurf, zlamb, zqfac, zcurr
      real, dimension(nprofm,4) :: tpsif, tqfac
      real, dimension(nprofm,4,nions) :: tti, tni
      real, dimension(nprofm,4) :: tzeff
      real, dimension(nprofm,4,nions) :: tconc
      real, dimension(nprofm) :: torflx
      real, dimension(nprofm,4) :: ttani
      real, dimension(nprofm,4) :: bx0, bx1, bx2, bz0
      real, dimension(nprofm) :: volume
      real, dimension(nprofm,4) :: pqr, ppra
      real, dimension(nions) :: xxi, xi, atpi
      real, dimension(nprofm,4) :: ppra1

      real, dimension(nions) ::densi,derdni,aconc,tempi,derti
      real, dimension(nions) :: dhni, dhti
      real, dimension(nions) :: gami, pwtoti
      real, dimension(3) :: pwtotf
      real, dimension(ntheta) :: fpwth
      real, dimension(ntheta,nspectm) :: thstrt
      real, dimension(nions) :: gamip, gamir
      real, dimension(10) :: precdy
      real, dimension(nbitab,0:nli - 1) :: bsir
      real, dimension(nbitab) :: xin
      real, dimension(3) :: ari, agi
      real, dimension(nions) :: vti
      real, dimension(npnta) :: gwk1, gwk2, gwk3
      real, dimension(npnta,mpnta) :: gvk, gwk, gxk
      real, dimension(201) :: pkpara
      real, dimension(200) :: pkmid
      real, dimension(nprofm) :: psimid
      real, dimension(0:301) :: pwrk, pwkk
      real, dimension(0:nprofm) :: pwrr, pwkr
      real, dimension(nprofm)::ajtb,bttra,bttra2,ajbs,ajbsb,ajtar
     1   , ajpar, ftrp
      real, dimension(nprofm)::volpla,ajtor,ajbst,dbt1,dbt2,ajtrb
     1   , ajdrv, ajdit, ajrfb, aisdt
      real, dimension(npsis)::epsr,epsb,epsx,btr,btr1,psis,eden
     1   , etem, zefi, bbar, akapa, akapa1
      complex   delm
      complex   ceps3, cxe, cz, czp, cepx, cepy, cepz, cei, crot
      end module Vcraylh

      FUNCTION DBESI0 (X)
C***BEGIN PROLOGUE  DBESI0
C***PURPOSE  Compute the hyperbolic Bessel function of the first kind
C            of order zero.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C10B1
C***TYPE      real(kind=dp) (BESI0-S, DBESI0-D)
C***KEYWORDS  FIRST KIND, FNLIB, HYPERBOLIC BESSEL FUNCTION,
C             MODIFIED BESSEL FUNCTION, ORDER ZERO, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DBESI0(X) calculates the double precision modified (hyperbolic)
C Bessel function of the first kind of order zero and double
C precision argument X.
C
C Series for BI0        on the interval  0.          to  9.00000E+00
C                                        with weighted error   9.51E-34
C                                         log weighted error  33.02
C                               significant figures required  33.31
C                                    decimal places required  33.65
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, DBSI0E, DCSEVL, INITDS, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C***END PROLOGUE  DBESI0
C============
C idecl:  explicitize implicit INTEGER declarations:
      use kind_spec

      IMPLICIT NONE
      INTEGER nti0,initds
C============
      real(kind=dp) DBESI0
      real(kind=dp) X, BI0CS(18), XMAX, XSML, Y, D1MACH,
     1  DCSEVL, DBSI0E
      LOGICAL FIRST
      SAVE BI0CS, NTI0, XSML, XMAX, FIRST
      DATA BI0CS(  1) / -.7660547252839144951081894976243285E-1_dp/

      DATA BI0CS(  2) / +.1927337953993808269952408750881196E+1_dp/

      DATA BI0CS(  3) / +.2282644586920301338937029292330415E+0_dp/

      DATA BI0CS(  4) / +.1304891466707290428079334210691888E-1_dp/

      DATA BI0CS(  5) / +.4344270900816487451378682681026107E-3_dp/

      DATA BI0CS(  6) / +.9422657686001934663923171744118766E-5_dp/

      DATA BI0CS(  7) / +.1434006289510691079962091878179957E-6_dp/

      DATA BI0CS(  8) / +.1613849069661749069915419719994611E-8_dp/

      DATA BI0CS(  9) / +.1396650044535669699495092708142522E-10_dp/

      DATA BI0CS( 10) / +.9579451725505445344627523171893333E-13_dp/

      DATA BI0CS( 11) / +.5333981859862502131015107744000000E-15_dp/

      DATA BI0CS( 12) / +.2458716088437470774696785919999999E-17_dp/

      DATA BI0CS( 13) / +.9535680890248770026944341333333333E-20_dp/

      DATA BI0CS( 14) / +.3154382039721427336789333333333333E-22_dp/

      DATA BI0CS( 15) / +.9004564101094637431466666666666666E-25_dp/

      DATA BI0CS( 16) / +.2240647369123670016000000000000000E-27_dp/

      DATA BI0CS( 17) / +.4903034603242837333333333333333333E-30_dp/

      DATA BI0CS( 18) / +.9508172606122666666666666666666666E-33_dp/

      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DBESI0
      IF (FIRST) THEN
         NTI0 = INITDS (BI0CS, 18, 0.1E0_dp*(d1mach3))

         XSML = SQRT(4.5E0_dp*d1mach3)

         XMAX = LOG (d1mach2)
      ENDIF
      FIRST = .FALSE.
C
      Y = ABS(X)
      IF (Y.GT.3.0E0_dp) GO TO 20

C
      DBESI0 = 1.0E0_dp

      IF (Y.GT.XSML) DBESI0 = 2.75E0_dp+

     1   DCSEVL (Y*Y/4.5E0_dp-1.E0_dp, BI0CS,

     1   NTI0)
      RETURN
C
 20   IF (Y .GT. XMAX) CALL XERMSG ('SLATEC', 'DBESI0',
     +   'ABS(X) SO BIG I0 OVERFLOWS', 2, 2)
C
      DBESI0 = EXP(Y) * DBSI0E(X)
C
      RETURN
      END
! 22Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 22Jun2000 fgtok
! 22Jun2000 fgtok
! 22Jun2000 fgtok

      module Vgrnout
      use kind_spec

C...Created by Pacific-Sierra Research VAST-90 2.06G2  15:15:56   5/18/01
      integer   nwguid, nmod, nphase, isimm, ndim0, ndim1
      real(kind=dp)   freqcy,width,dwall,heigth,dnedge,dndx,dxpl,
     1   phmin,phmax
      end module Vgrnout

! 07Jun1999 fgtok -impno -s r8_precision.sub r8_names.table "r8con.csh conversion"
c  bcspline -- dmc 30 May 1996
c
c  set up coefficients for bicubic spline with following BC's:
c  FULL BC CONTROL at all bdys
c
c  algorithm note -- handling of y & z explicit BC's while maintaining
c  full C2 differentiability is delicate.  Basic method:  use a fully
c  C2 method based on the "not-a-knot" BC, and then, correct to meet
c  each user BC by calculating a C2 spline that is zero at all grid
c  points but satisfies a BC which is the difference btw the user spec
c  and the not-a-knot result; add the coeffs of this into the original.
c
c  for this more workspace is needed: nwk .ge. 4*inx*inth +5*max(inx,inth)
c
c
      subroutine r8bcspline(x,inx,th,inth,fspl,inf3,
     >                    ibcxmin,bcxmin,ibcxmax,bcxmax,
     >                    ibcthmin,bcthmin,ibcthmax,bcthmax,
     >                    wk,nwk,ilinx,ilinth,ier)
c
      IMPLICIT NONE
C============
C idecl:  explicitize implicit INTEGER declarations:
      INTEGER inx,inth,inf3,nwk,iflg2,ibcthmin,ix,ibcthmax,ier,itest,
     > ibcxmin,ibcxmax,ilinx,ierx,ilinth,ierth,ia1,ia2,ia3,ia4,ia5,ith,
     > iadr,ibcxmina,ibcxmaxa,ic,ibcthmina,ibcthmaxa,iasc,iinc,iawk,jx,
     > jth,ii,idum,ia,ia1w,ia2w,ia3w,ia4w,ia5w,iaspl,iaxsp,iaxsp1
C============
C idecl:  explicitize implicit REAL declarations:
      REAL*8 xo2,xo6,zhxn,zhth,zcur,zdiff1,zdiff2
C============
      REAL*8 x(inx),th(inth),fspl(4,4,inf3,inth),wk(nwk)
      REAL*8 bcxmin(inth),bcxmax(inth)
      REAL*8 bcthmin(inx),bcthmax(inx)
c
c  input:
c    x(1...inx) -- abscissae, first dimension of data
c   th(1...inth) -- abscissae, second (periodic) dimension of data
c   fspl(1,1,1..inx,1..inth) -- function values
c   inf3 -- fspl dimensioning, inf3.ge.inx required.
c
c  boundary conditions input:
c   ibcxmin -- indicator for boundary condition at x(1):
c    bcxmin(...) -- boundary condition data
c     =-1 -- periodic boundary condition
c     =0 -- use "not a knot", bcxmin(...) ignored
c     =1 -- match slope, specified at x(1),th(ith) by bcxmin(ith)
c     =2 -- match 2nd derivative, specified at x(1),th(ith) by bcxmin(ith)
c     =3 -- boundary condition is slope=0 (df/dx=0) at x(1), all th(j)
c     =4 -- boundary condition is d2f/dx2=0 at x(1), all th(j)
c   NOTE bcxmin(...) referenced ONLY if ibcxmin=1 or ibcxmin=2
c
c   ibcxmax -- indicator for boundary condition at x(nx):
c    bcxmax(...) -- boundary condition data
c     (interpretation as with ibcxmin, bcxmin)
c   NOTE:  if ibcxmin=-1, ibcxmax is ignored! ...and the BC is periodic.
c
c   ibcthmin -- indicator for boundary condition at th(1):
c    bcthmin(...) -- boundary condition data
c     (interpretation as with ibcxmin, bcxmin)
c   ibcthmax -- indicator for boundary condition at th(inth):
c    bcthmax(...) -- boundary condition data
c     (interpretation as with ibcxmin, bcxmin)
c   NOTE:  if ibcthmin=-1, ibcthmax is ignored! ...and the BC is periodic.
c
c   NOTE the bcxmin,bcxmax,bcthmin,bcthmax arrays are only used if the
c     corresponding boundary condition flags are set to 1 or 2.
c     Carefully note the dimensioning of these arrays!
c
c  output:
c   fspl(*,*,1..inx,1..inth) -- bicubic spline coeffs (4x4)
c   ...fspl(1,1,*,*) is not replaced.
c
c   ilinx -- =1 on output if x(inx) pts are nearly evenly spaced (tol=1e-3)
c   ilinth-- =1 on output if th(inth) evenly spaced (tol=1e-3)
c
c   ier -- completion code, 0 for normal
c
c  workspace:
c   wk -- must be at least 5*max(inx,inth) large
c                          5*max(inx,inth) + 4*inx*inth large
c                          if explicit non-zero d/dth or d2/dth2 BC's
c                          are supplied.
c  nwk -- size of workspace of workspace provided
c
c---------------------------------
c  compute bicubic spline of 2d function, given values at the grid
c  grid crossing points, f(1,1,i,j)=f(x(i),th(j)).
c
c  on evaluation:  for point x btw x(i) and x(i+1), dx=x-x(i)
c                       and th btw th(j) and th(j+1), dt=th-th(j),
c
c      spline =
c        f(1,1,i,j) + dx*f(2,1,i,j) + dx**2*f(3,1,i,j) + dx**3*f(4,1,i,j)
c   +dt*(f(1,2,i,j) + dx*f(2,2,i,j) + dx**2*f(3,2,i,j) + dx**3*f(4,2,i,j))
c   +d2*(f(1,3,i,j) + dx*f(2,3,i,j) + dx**2*f(3,3,i,j) + dx**3*f(4,3,i,j))
c   +d3*(f(1,4,i,j) + dx*f(2,4,i,j) + dx**2*f(3,4,i,j) + dx**3*f(4,4,i,j))
c
c      where d2=dt**2 and d3=dt**3.
c
      integer iselect1(10)
      integer iselect2(10)
c
c---------------------------------
c
c  see if 2nd pass is needed due to "non-linear" d/dth bdy cond.
c
      iflg2=0
      if(ibcthmin.ne.-1) then
         if((ibcthmin.eq.1).or.(ibcthmin.eq.2)) then
            do ix=1,inx
               if (bcthmin(ix).ne.0.0D0) iflg2=1
            enddo
         endif
         if((ibcthmax.eq.1).or.(ibcthmax.eq.2)) then
            do ix=1,inx
               if (bcthmax(ix).ne.0.0D0) iflg2=1
            enddo
         endif
      endif
c
      ier=0
      itest=5*max(inx,inth)
      if(iflg2.eq.1) then
         itest=itest +4*inx*inth
      endif
c
      if(nwk.lt.itest) then
         write(6,9901) nwk,itest
 9901    format(' ?bcspline:  workspace too small:'/
     >          '  user supplied:  nwk=',i6,'; need at least:  ',i6/
     >          '  nwk=4*nx*ny +5*max(nx,ny) will work for any user'/
     >          '  choice of bdy conditions.')
         ier=1
      endif
      if(inx.lt.4) then
         write(6,'('' ?bcspline:  at least 4 x points required.'')')
         ier=1
      endif
      if(inth.lt.4) then
         write(6,'('' ?bcspline:  need at least 4 theta points.'')')
         ier=1
      endif
c
      call ibc_ck(ibcxmin,'bcspline','xmin',-1,4,ier)
      if(ibcxmin.ge.0) call ibc_ck(ibcxmax,'bcspline','xmax',0,4,ier)
      call ibc_ck(ibcthmin,'bcspline','thmin',-1,4,ier)
      if(ibcthmin.ge.0) call ibc_ck(ibcthmax,'bcspline','thmax',0,4,ier)
c
c  check ilinx & x vector
c
      call r8splinck(x,inx,ilinx,1.0D-3,ierx)
      if(ierx.ne.0) ier=2
c
      if(ier.eq.2) then
         write(6,'('' ?bcspline:  x axis not strict ascending'')')
      endif
c
c  check ilinth & th vector
c
      call r8splinck(th,inth,ilinth,1.0D-3,ierth)
      if(ierth.ne.0) ier=3
c
      if(ier.eq.3) then
         write(6,'('' ?bcspline:  th axis not strict ascending'')')
      endif
c
      if(ier.ne.0) return
c
c------------------------------------
c
      xo2=0.5D0
      xo6=1.0D0/6.0D0
c
c  spline in x direction
c
c  workspace address offsets (for pspline)
c
      if(ibcxmin.eq.-1) then
         ia1=1
         ia2=ia1+inx
         ia3=ia2+inx
         ia4=ia3+inx
         ia5=ia4+inx
      endif
c
      do ith=1,inth
c
c  copy the function in
c
         if(ibcxmin.eq.-1) then
c
c  copy ordinates in
c
            do ix=1,inx
               wk(ia1-1+ix)=fspl(1,1,ix,ith)
            enddo
c
            call r8pspline(inx,x,wk(ia1),
     >                           wk(ia2),wk(ia3),wk(ia4),wk(ia5))
c
c  copy coeffs out
c
            do ix=1,inx-1
               fspl(2,1,ix,ith)=wk(ia2-1+ix)
               fspl(3,1,ix,ith)=wk(ia3-1+ix)
               fspl(4,1,ix,ith)=wk(ia4-1+ix)
            enddo
c
         else
c
c  copy ordinates in
            do ix=1,inx
               iadr=1+(ix-1)*4
               wk(iadr)=fspl(1,1,ix,ith)
            enddo
c
            ibcxmina=ibcxmin
            if((ibcxmin.eq.1).or.(ibcxmin.eq.2)) then
               wk(2)=bcxmin(ith)
            else if(ibcxmin.gt.2) then
               wk(2)=0.0D0
               ibcxmina=ibcxmin-2
            endif
c
            ibcxmaxa=ibcxmax
            if((ibcxmax.eq.1).or.(ibcxmax.eq.2)) then
               wk(iadr+1)=bcxmax(ith)
            else if(ibcxmax.gt.2) then
               wk(iadr+1)=0.0D0
               ibcxmaxa=ibcxmax-2
            endif
c
            call r8cubsplb(x,wk,inx,ibcxmina,ibcxmaxa)
c
c  copy the coefficients out
c
            do ix=1,inx-1
               fspl(2,1,ix,ith)=wk((ix-1)*4+2)
               fspl(3,1,ix,ith)=wk((ix-1)*4+3)*xo2
               fspl(4,1,ix,ith)=wk((ix-1)*4+4)*xo6
            enddo
         endif
c
      enddo
c
c-----------------------------------
c
c  spline in theta direction
c
c  workspace address offsets
c
      if(ibcthmin.eq.-1) then
         ia1=1
         ia2=ia1+inth
         ia3=ia2+inth
         ia4=ia3+inth
         ia5=ia4+inth
      endif
c
      do ix=1,inx-1
c
c  spline each x coeff
c
         do ic=1,4
c
            if(ibcthmin.eq.-1) then
c
c  copy ordinates in
c
               do ith=1,inth
                  wk(ia1-1+ith)=fspl(ic,1,ix,ith)
               enddo
c
               call r8pspline(inth,th,wk(ia1),
     >                           wk(ia2),wk(ia3),wk(ia4),wk(ia5))
c
c  copy coeffs out
c
               do ith=1,inth-1
                  fspl(ic,2,ix,ith)=wk(ia2-1+ith)
                  fspl(ic,3,ix,ith)=wk(ia3-1+ith)
                  fspl(ic,4,ix,ith)=wk(ia4-1+ith)
               enddo
c
            else
c
c  first pass:  use "not-a-knot" -- if flag indicates BC correction
c  will be needed
c
               if(iflg2.eq.1) then
                  ibcthmina=0
                  ibcthmaxa=0
               else
                  if(ibcthmin.gt.2) then
                     ibcthmina=ibcthmin-2
                  else
                     ibcthmina=ibcthmin
                  endif
                  if(ibcthmax.gt.2) then
                     ibcthmaxa=ibcthmax-2
                  else
                     ibcthmaxa=ibcthmax
                  endif
               endif
c
c  copy ordinates in
               do ith=1,inth
                  iadr=1+(ith-1)*4
                  wk(iadr)=fspl(ic,1,ix,ith)
               enddo
               wk(2)=0.0D0
               wk(iadr+1)=0.0D0
c
               call r8cubsplb(th,wk,inth,ibcthmina,ibcthmaxa)
c
c  copy the coefficients out
c
               do ith=1,inth-1
                  fspl(ic,2,ix,ith)=wk((ith-1)*4+2)
                  fspl(ic,3,ix,ith)=wk((ith-1)*4+3)*xo2
                  fspl(ic,4,ix,ith)=wk((ith-1)*4+4)*xo6
               enddo
c
            endif
c
         enddo
c
      enddo
c
c  now make correction for user BC's if needed
c
      if(iflg2.eq.1) then
c
         iasc=1                         ! wk addr for correction splines
         iinc=4*inth                    ! spacing btw correction splines
         iawk=iasc+4*inth*inx
c
c  last grid zone widths
c
         zhxn=x(inx)-x(inx-1)
         jx=inx-1
         zhth=th(inth)-th(inth-1)
         jth=inth-1
c
         do ii=1,10
            iselect1(ii)=0
            iselect2(ii)=0
         enddo
         if(ibcthmin.eq.1) iselect1(3)=1
         if(ibcthmin.eq.2) iselect1(5)=1
         if(ibcthmax.eq.1) iselect2(3)=1
         if(ibcthmax.eq.2) iselect2(5)=1
c
c  loop over BC's
c
         do ix=1,inx
c
c  (a) d/dth @ th(1) difference btw current BC and user request
c
            if(ibcthmin.eq.1) then
               if(ix.lt.inx) then
                  zcur=fspl(1,2,ix,1)   ! 1st deriv.
               else
                  zcur=fspl(1,2,jx,1)+zhxn*(fspl(2,2,jx,1)+zhxn*
     >               (fspl(3,2,jx,1)+zhxn*fspl(4,2,jx,1)))
               endif
            else if(ibcthmin.eq.2) then
               if(ix.lt.inx) then
                  zcur=2.0D0*fspl(1,3,ix,1) ! 2nd deriv.
               else
                  zcur=2.0D0*(fspl(1,3,jx,1)+zhxn*(fspl(2,3,jx,1)+zhxn*
     >               (fspl(3,3,jx,1)+zhxn*fspl(4,3,jx,1))))
               endif
            else
               zcur=bcthmin(ix)
            endif
            zdiff1=bcthmin(ix)-zcur
c
c  (b) d/dth @ th(inth) difference btw current BC and user request
c
            if(ibcthmax.eq.1) then
               if(ix.lt.inx) then
c  1st deriv.
                  zcur=fspl(1,2,ix,jth)+zhth*(2.0D0*fspl(1,3,ix,jth)+
     >               zhth*3.0D0*fspl(1,4,ix,jth))
               else
                  call r8bcspeval(x(inx),th(inth),iselect2,  zcur,
     >               x,inx,th,inth,ilinx,ilinth,fspl,inf3,ier)
                  if(ier.ne.0) return
               endif
            else if(ibcthmax.eq.2) then
               if(ix.lt.inx) then
c  2nd deriv.
                  zcur=2.0D0*fspl(1,3,ix,jth)+
     >               6.0D0*zhth*fspl(1,4,ix,jth)
               else
                  call r8bcspeval(x(inx),th(inth),iselect2,  zcur,
     >               x,inx,th,inth,ilinx,ilinth,fspl,inf3,ier)
                  if(ier.ne.0) return
               endif
            else
               zcur=bcthmax(ix)
            endif
            zdiff2=bcthmax(ix)-zcur
c
c  ok compute the theta spline with BC's to span the difference(s)
c  these theta "correction splines" are zero at all the grid points
c  but have at least one non-zero 1st or 2nd derivative BC
c
            iadr=iasc+(ix-1)*iinc
            do ith=1,inth
               wk(iadr+(ith-1)*4)=0.0D0
            enddo
c
            if(ibcthmin.gt.2) then
               ibcthmina=ibcthmin-2
            else
               ibcthmina=ibcthmin
            endif
c
            if(ibcthmax.gt.2) then
               ibcthmaxa=ibcthmax-2
            else
               ibcthmaxa=ibcthmax
            endif
c
            call r8cspline(th,inth,wk(iadr),
     >         ibcthmina,zdiff1,ibcthmaxa,zdiff2,wk(iawk),5*inth,idum,
     >         ier)
            if(ier.ne.0) return
         enddo
c
c  add in results to main array
c
         do ix=1,inx-1
            iadr=iasc+(ix-1)*iinc
            do ith=1,inth-1
               do ic=2,4
                  ia=iadr+(ith-1)*4 -1
                  fspl(1,ic,ix,ith)=fspl(1,ic,ix,ith)+wk(ia+ic)
               enddo
            enddo
         enddo
c
c  compute the x splines of the th spline correction coeffs
c
         if(ibcxmin.eq.-1) then
            ia1w=iawk
            ia2w=ia1w+inx
            ia3w=ia2w+inx
            ia4w=ia3w+inx
            ia5w=ia4w+inx
         endif
c
         do ith=1,inth-1
            if(ibcxmin.eq.-1) then
               do ic=2,4
                  do ix=1,inx
                     iaspl=iasc+iinc*(ix-1)+4*(ith-1)
                     wk(ia1w+ix-1)=wk(iaspl+ic-1)
                  enddo
c
c  periodic spline of correction spline higher coeffs (1st coeffs are
c  all zero by defn of the correction spline
c
                  call r8pspline(inx,x,wk(ia1w),
     >               wk(ia2w),wk(ia3w),wk(ia4w),wk(ia5w))
c
                  do ix=1,inx-1
                     fspl(2,ic,ix,ith)=fspl(2,ic,ix,ith)+wk(ia2w+ix-1)
                     fspl(3,ic,ix,ith)=fspl(3,ic,ix,ith)+wk(ia3w+ix-1)
                     fspl(4,ic,ix,ith)=fspl(4,ic,ix,ith)+wk(ia4w+ix-1)
                  enddo
               enddo
c
            else
c
c  non-periodic BC in x direction -- specify zero on BC of coeff splines
c  so as not to affect the main array x BC.
c
               do ic=2,4
                  do ix=1,inx
                     iaspl=iasc+iinc*(ix-1)+4*(ith-1)
                     iaxsp=iawk+4*(ix-1)
                     wk(iaxsp)=wk(iaspl+ic-1)
                  enddo
                  wk(iawk+1)=0.0D0
                  wk(iaxsp+1)=0.0D0
c
                  call r8cubsplb(x,wk(iawk),inx,ibcxmina,ibcxmaxa)
c
                  do ix=1,inx-1
                     iaxsp1=iawk+4*(ix-1)-1
                     fspl(2,ic,ix,ith)=fspl(2,ic,ix,ith)+wk(iaxsp1+2)
                     fspl(3,ic,ix,ith)=fspl(3,ic,ix,ith)+
     >                  wk(iaxsp1+3)*xo2
                     fspl(4,ic,ix,ith)=fspl(4,ic,ix,ith)+
     >                  wk(iaxsp1+4)*xo6
                  enddo
               enddo
c
            endif                       ! periodic / non-periodic
c
         enddo                          ! ith
c
      endif                             ! BC correction needs test
c
      return
      end

      SUBROUTINE DBSKNU (X, FNU, KODE, N, Y, NZ)
C***BEGIN PROLOGUE  DBSKNU
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DBESK
C***LIBRARY   SLATEC
C***TYPE      real(kind=dp) (BESKNU-S, DBSKNU-D)
C***AUTHOR  Amos, D. E., (SNLA)
C***DESCRIPTION
C
C     Abstract  **** A real(kind=dp) routine ****
C         DBSKNU computes N member sequences of K Bessel functions
C         K/SUB(FNU+I-1)/(X), I=1,N for non-negative orders FNU and
C         positive X. Equations of the references are implemented on
C         small orders DNU for K/SUB(DNU)/(X) and K/SUB(DNU+1)/(X).
C         Forward recursion with the three term recursion relation
C         generates higher orders FNU+I-1, I=1,...,N. The parameter
C         KODE permits K/SUB(FNU+I-1)/(X) values or scaled values
C         EXP(X)*K/SUB(FNU+I-1)/(X), I=1,N to be returned.
C
C         To start the recursion FNU is normalized to the interval
C         -0.5.LE.DNU.LT.0.5. A special form of the power series is
C         implemented on 0.LT.X.LE.X1 while the Miller algorithm for the
C         K Bessel function in terms of the confluent hypergeometric
C         function U(FNU+0.5,2*FNU+1,X) is implemented on X1.LT.X.LE.X2.
C         For X.GT.X2, the asymptotic expansion for large X is used.
C         When FNU is a half odd integer, a special formula for
C         DNU=-0.5 and DNU+1.0=0.5 is used to start the recursion.
C
C         The maximum number of significant digits obtainable
C         is the smaller of 14 and the number of digits carried in
C         real(kind=dp) arithmetic.
C
C         DBSKNU assumes that a significant digit SINH function is
C         available.
C
C     Description of Arguments
C
C         INPUT      X,FNU are real(kind=dp)
C           X      - X.GT.0.0D0
C           FNU    - Order of initial K function, FNU.GE.0.0D0
C           N      - Number of members of the sequence, N.GE.1
C           KODE   - A parameter to indicate the scaling option
C                    KODE= 1  returns
C                             Y(I)=       K/SUB(FNU+I-1)/(X)
C                                  I=1,...,N
C                        = 2  returns
C                             Y(I)=EXP(X)*K/SUB(FNU+I-1)/(X)
C                                  I=1,...,N
C
C         OUTPUT     Y is real(kind=dp)
C           Y      - A vector whose first N components contain values
C                    for the sequence
C                    Y(I)=       K/SUB(FNU+I-1)/(X), I=1,...,N or
C                    Y(I)=EXP(X)*K/SUB(FNU+I-1)/(X), I=1,...,N
C                    depending on KODE
C           NZ     - Number of components set to zero due to
C                    underflow,
C                    NZ= 0   , normal return
C                    NZ.NE.0 , first NZ components of Y set to zero
C                              due to underflow, Y(I)=0.0D0,I=1,...,NZ
C
C     Error Conditions
C         Improper input arguments - a fatal error
C         Overflow - a fatal error
C         Underflow with KODE=1 - a non-fatal error (NZ.NE.0)
C
C***SEE ALSO  DBESK
C***REFERENCES  N. M. Temme, On the numerical evaluation of the modified
C                 Bessel function of the third kind, Journal of
C                 Computational Physics 19, (1975), pp. 324-337.
C***ROUTINES CALLED  D1MACH, DGAMMA, J1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   790201  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   900328  Added TYPE section.  (WRB)
C   900727  Added EXTERNAL statement.  (WRB)
C   910408  Updated the AUTHOR and REFERENCES sections.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DBSKNU
C
      use kind_spec

      IMPLICIT NONE
      INTEGER I, IFLAG, INU, J, K, KK, KODE, KODED, N, NN, NZ
      INTEGER J1MACH
      real(kind=dp) A,AK,A1,A2,B,BK,CC,CK,COEF,CX,DK,DNU,DNU2,ELIM,
     1 ETEST, EX, F, FC, FHS, FK, FKS, FLRX, FMU, FNU, G1, G2, P, PI,
     2 PT, P1, P2, Q, RTHPI, RX, S, SMU, SQK, ST, S1, S2, TM, TOL, T1,
     3 T2, X, X1, X2, Y
      DIMENSION A(160), B(160), Y(*), CC(8)
      real(kind=dp) DGAMMA, D1MACH
      EXTERNAL DGAMMA
      SAVE X1, X2, PI, RTHPI, CC
      DATA X1, X2 / 2.0E0_dp, 17.0E0_dp/

      DATA PI,RTHPI        / 3.14159265358979E+00_dp,

     1   1.25331413731550E+00_dp/

      DATA CC(1), CC(2), CC(3), CC(4), CC(5), CC(6), CC(7), CC(8)
     1  / 5.77215664901533E-01_dp,-4.20026350340952E-02_dp,

     2   -4.21977345555443E-02_dp, 7.21894324666300E-03_dp,

     3   -2.15241674114900E-04_dp,-2.01348547807000E-05_dp,

     4    1.13302723200000E-06_dp, 6.11609500000000E-09_dp/

C***FIRST EXECUTABLE STATEMENT  DBSKNU
      KK = -j1mach15
      ELIM = 2.303E0_dp*(KK*d1mach5-3.0E0_dp)

      AK = d1mach3
      TOL = MAX(AK,1.0E-15_dp)

      IF (X.LE.0.0E0_dp) GO TO 350

      IF (FNU.LT.0.0E0_dp) GO TO 360

      IF (KODE.LT.1 .OR. KODE.GT.2) GO TO 370
      IF (N.LT.1) GO TO 380
      NZ = 0
      IFLAG = 0
      KODED = KODE
      RX = 2.0E0_dp/X

      INU = INT(FNU+0.5E0_dp)

      DNU = FNU - INU
      IF (ABS(DNU).EQ.0.5E0_dp) GO TO 120

      DNU2 = 0.0E0_dp

      IF (ABS(DNU).LT.TOL) GO TO 10
      DNU2 = DNU*DNU
   10 CONTINUE
      IF (X.GT.X1) GO TO 120
C
C     SERIES FOR X.LE.X1
C
      A1 = 1.0E0_dp- DNU

      A2 = 1.0E0_dp+ DNU

      T1 = 1.0E0_dp/DGAMMA(A1)

      T2 = 1.0E0_dp/DGAMMA(A2)

      IF (ABS(DNU).GT.0.1E0_dp) GO TO 40

C     SERIES FOR F0 TO RESOLVE INDETERMINACY FOR SMALL ABS(DNU)
      S = CC(1)
      AK = 1.0E0_dp

      DO 20 K=2,8
        AK = AK*DNU2
        TM = CC(K)*AK
        S = S + TM
        IF (ABS(TM).LT.TOL) GO TO 30
   20 CONTINUE
   30 G1 = -S
      GO TO 50
   40 CONTINUE
      G1 = (T1-T2)/(DNU+DNU)
   50 CONTINUE
      G2 = (T1+T2)*0.5E0_dp

      SMU = 1.0E0_dp

      FC = 1.0E0_dp

      FLRX = LOG(RX)
      FMU = DNU*FLRX
      IF (DNU.EQ.0.0E0_dp) GO TO 60

      FC = DNU*PI
      FC = FC/SIN(FC)
      IF (FMU.NE.0.0E0_dp) SMU = SINH(FMU)/FMU

   60 CONTINUE
      F = FC*(G1*COSH(FMU)+G2*FLRX*SMU)
      FC = EXP(FMU)
      P = 0.5E0_dp*FC/T2

      Q = 0.5E0_dp/(FC*T1)

      AK = 1.0E0_dp

      CK = 1.0E0_dp

      BK = 1.0E0_dp

      S1 = F
      S2 = P
      IF (INU.GT.0 .OR. N.GT.1) GO TO 90
      IF (X.LT.TOL) GO TO 80
      CX = X*X*0.25E0_dp

   70 CONTINUE
      F = (AK*F+P+Q)/(BK-DNU2)
      P = P/(AK-DNU)
      Q = Q/(AK+DNU)
      CK = CK*CX/AK
      T1 = CK*F
      S1 = S1 + T1
      BK = BK + AK + AK + 1.0E0_dp

      AK = AK + 1.0E0_dp

      S = ABS(T1)/(1.0E0_dp+ABS(S1))

      IF (S.GT.TOL) GO TO 70
   80 CONTINUE
      Y(1) = S1
      IF (KODED.EQ.1) RETURN
      Y(1) = S1*EXP(X)
      RETURN
   90 CONTINUE
      IF (X.LT.TOL) GO TO 110
      CX = X*X*0.25E0_dp

  100 CONTINUE
      F = (AK*F+P+Q)/(BK-DNU2)
      P = P/(AK-DNU)
      Q = Q/(AK+DNU)
      CK = CK*CX/AK
      T1 = CK*F
      S1 = S1 + T1
      T2 = CK*(P-AK*F)
      S2 = S2 + T2
      BK = BK + AK + AK + 1.0E0_dp

      AK = AK + 1.0E0_dp

      S = ABS(T1)/(1.0E0_dp+ABS(S1)) +

     >   ABS(T2)/(1.0E0_dp+ABS(S2))

      IF (S.GT.TOL) GO TO 100
  110 CONTINUE
      S2 = S2*RX
      IF (KODED.EQ.1) GO TO 170
      F = EXP(X)
      S1 = S1*F
      S2 = S2*F
      GO TO 170
  120 CONTINUE
      COEF = RTHPI/SQRT(X)
      IF (KODED.EQ.2) GO TO 130
      IF (X.GT.ELIM) GO TO 330
      COEF = COEF*EXP(-X)
  130 CONTINUE
      IF (ABS(DNU).EQ.0.5E0_dp) GO TO 340

      IF (X.GT.X2) GO TO 280
C
C     MILLER ALGORITHM FOR X1.LT.X.LE.X2
C
      ETEST = COS(PI*DNU)/(PI*X*TOL)
      FKS = 1.0E0_dp

      FHS = 0.25E0_dp

      FK = 0.0E0_dp

      CK = X + X + 2.0E0_dp

      P1 = 0.0E0_dp

      P2 = 1.0E0_dp

      K = 0
  140 CONTINUE
      K = K + 1
      FK = FK + 1.0E0_dp

      AK = (FHS-DNU2)/(FKS+FK)
      BK = CK/(FK+1.0E0_dp)

      PT = P2
      P2 = BK*P2 - AK*P1
      P1 = PT
      A(K) = AK
      B(K) = BK
      CK = CK + 2.0E0_dp

      FKS = FKS + FK + FK + 1.0E0_dp

      FHS = FHS + FK + FK
      IF (ETEST.GT.FK*P1) GO TO 140
      KK = K
      S = 1.0E0_dp

      P1 = 0.0E0_dp

      P2 = 1.0E0_dp

      DO 150 I=1,K
        PT = P2
        P2 = (B(KK)*P2-P1)/A(KK)
        P1 = PT
        S = S + P2
        KK = KK - 1
  150 CONTINUE
      S1 = COEF*(P2/S)
      IF (INU.GT.0 .OR. N.GT.1) GO TO 160
      GO TO 200
  160 CONTINUE
      S2 = S1*(X+DNU+0.5E0_dp-P1/P2)/X

C
C     FORWARD RECURSION ON THE THREE TERM RECURSION RELATION
C
  170 CONTINUE
      CK = (DNU+DNU+2.0E0_dp)/X

      IF (N.EQ.1) INU = INU - 1
      IF (INU.GT.0) GO TO 180
      IF (N.GT.1) GO TO 200
      S1 = S2
      GO TO 200
  180 CONTINUE
      DO 190 I=1,INU
        ST = S2
        S2 = CK*S2 + S1
        S1 = ST
        CK = CK + RX
  190 CONTINUE
      IF (N.EQ.1) S1 = S2
  200 CONTINUE
      IF (IFLAG.EQ.1) GO TO 220
      Y(1) = S1
      IF (N.EQ.1) RETURN
      Y(2) = S2
      IF (N.EQ.2) RETURN
      DO 210 I=3,N
        Y(I) = CK*Y(I-1) + Y(I-2)
        CK = CK + RX
  210 CONTINUE
      RETURN
C     IFLAG=1 CASES
  220 CONTINUE
      S = -X + LOG(S1)
      Y(1) = 0.0E0_dp

      NZ = 1
      IF (S.LT.-ELIM) GO TO 230
      Y(1) = EXP(S)
      NZ = 0
  230 CONTINUE
      IF (N.EQ.1) RETURN
      S = -X + LOG(S2)
      Y(2) = 0.0E0_dp

      NZ = NZ + 1
      IF (S.LT.-ELIM) GO TO 240
      NZ = NZ - 1
      Y(2) = EXP(S)
  240 CONTINUE
      IF (N.EQ.2) RETURN
      KK = 2
      IF (NZ.LT.2) GO TO 260
      DO 250 I=3,N
        KK = I
        ST = S2
        S2 = CK*S2 + S1
        S1 = ST
        CK = CK + RX
        S = -X + LOG(S2)
        NZ = NZ + 1
        Y(I) = 0.0E0_dp

        IF (S.LT.-ELIM) GO TO 250
        Y(I) = EXP(S)
        NZ = NZ - 1
        GO TO 260
  250 CONTINUE
      RETURN
  260 CONTINUE
      IF (KK.EQ.N) RETURN
      S2 = S2*CK + S1
      CK = CK + RX
      KK = KK + 1
      Y(KK) = EXP(-X+LOG(S2))
      IF (KK.EQ.N) RETURN
      KK = KK + 1
      DO 270 I=KK,N
        Y(I) = CK*Y(I-1) + Y(I-2)
        CK = CK + RX
  270 CONTINUE
      RETURN
C
C     ASYMPTOTIC EXPANSION FOR LARGE X, X.GT.X2
C
C     IFLAG=0 MEANS NO UNDERFLOW OCCURRED
C     IFLAG=1 MEANS AN UNDERFLOW OCCURRED- COMPUTATION PROCEEDS WITH
C     KODED=2 AND A TEST FOR ON SCALE VALUES IS MADE DURING FORWARD
C     RECURSION
  280 CONTINUE
      NN = 2
      IF (INU.EQ.0 .AND. N.EQ.1) NN = 1
      DNU2 = DNU + DNU
      FMU = 0.0E0_dp

      IF (ABS(DNU2).LT.TOL) GO TO 290
      FMU = DNU2*DNU2
  290 CONTINUE
      EX = X*8.0E0_dp

      S2 = 0.0E0_dp

      DO 320 K=1,NN
        S1 = S2
        S = 1.0E0_dp

        AK = 0.0E0_dp

        CK = 1.0E0_dp

        SQK = 1.0E0_dp

        DK = EX
        DO 300 J=1,30
          CK = CK*(FMU-SQK)/DK
          S = S + CK
          DK = DK + EX
          AK = AK + 8.0E0_dp

          SQK = SQK + AK
          IF (ABS(CK).LT.TOL) GO TO 310
  300   CONTINUE
  310   S2 = S*COEF
        FMU = FMU + 8.0E0_dp*DNU + 4.0E0_dp

  320 CONTINUE
      IF (NN.GT.1) GO TO 170
      S1 = S2
      GO TO 200
  330 CONTINUE
      KODED = 2
      IFLAG = 1
      GO TO 120
C
C     FNU=HALF ODD INTEGER CASE
C
  340 CONTINUE
      S1 = COEF
      S2 = COEF
      GO TO 170
C
C
  350 CALL XERMSG ('SLATEC', 'DBSKNU', 'X NOT GREATER THAN ZERO', 2, 1)
      RETURN
  360 CALL XERMSG ('SLATEC', 'DBSKNU', 'FNU NOT ZERO OR POSITIVE', 2,
     +   1)
      RETURN
  370 CALL XERMSG ('SLATEC', 'DBSKNU', 'KODE NOT 1 OR 2', 2, 1)
      RETURN
  380 CALL XERMSG ('SLATEC', 'DBSKNU', 'N NOT GREATER THAN 0', 2, 1)
      RETURN
      END
! 22Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 22Jun2000 fgtok
! 22Jun2000 fgtok

      module Vchpcsd
      use kind_spec

C...Created by Pacific-Sierra Research VAST-90 2.06G2  12:29:44   5/18/01
      use Vparam, only: nraym, nplus
      integer   irec
      integer   ndim, jhlf, ind, mcnt, klim, irecmx
      real(kind=dp)   dy6o, hlast, serror, psilast, h
      real(kind=dp), dimension(6) :: prmt
      real(kind=dp), dimension(10) :: y, dy, yin, dyin
      real(kind=dp), dimension(nraym) :: rec0, rec1, rec2, rec3,
     1    rec4, rec5
      real(kind=dp), dimension(nplus) :: rec6
      real(kind=dp), dimension(nraym) :: rec7, rec8, rec9, rec10,
     1    rec11, rec12,
     1   rec13, rec14, rec15
      end module Vchpcsd

c---------------------------------------
c-
c- file: icsicu.f
c-
c- purpose: replaces imsl routine icsicu
c-
c----------------------------------------
      subroutine icsicu(x, y, nx, bpar, c, ic, ier)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nx, ic, ier
      real(kind=dp), dimension(nx) :: x, y
      real(kind=dp), dimension(4) :: bpar
      real(kind=dp), dimension(ic,3) :: c
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: j, i, nxm1
      real(kind=dp) :: dxj, dyj, dxjp1, dyjp1, dxp, dx, yppa, yppb, 
     1   pj
C-----------------------------------------------
      ier = 0
      nxm1 = nx - 1
c--- test that x values are ordered and input sane
      do j = 2, nxm1
         if (x(j+1) <= x(j)) ier = 133
      end do
      if (nx < 2) ier = 130
      if (ic < nxm1) ier = 129
      if (ier /= 0) then
         call uertst (ier, 6Hicsicu)
         return 
      endif
c--- if nx bigger than 2, setup tridiagonal matrix
      if (nx > 2) then
         dxj = x(2) - x(1)
         dyj = y(2) - y(1)
         do j = 2, nxm1
            dxjp1 = x(j+1) - x(j)
            dyjp1 = y(j+1) - y(j)
            dxp = dxj + dxjp1
            c(j,1) = dxjp1/dxp
            c(j,2) = 1.0 - c(j,1)
            c(j,3) = 6.0*(dyjp1/dxjp1 - dyj/dxj)/dxp
            dxj = dxjp1
            dyj = dyjp1
         end do
      endif
c--- solve
      c(1,1) = -bpar(1)*0.5
      c(1,2) = bpar(2)*0.5
      if (nx > 2) then
         do j = 2, nxm1
            pj = c(j,2)*c(j-1,1) + 2.0
            c(j,1) = -c(j,1)/pj
            c(j,2) = (c(j,3)-c(j,2)*c(j-1,2))/pj
         end do
      endif
c--- back substitution
      yppb = (bpar(4)-bpar(3)*c(nxm1,2))/(bpar(3)*c(nxm1,1)+2.0)
      do i = 1, nxm1
         j = nx - i
         yppa = c(j,1)*yppb + c(j,2)
         dx = x(j+1) - x(j)
         c(j,3) = (yppb - yppa)/(6.0*dx)
         c(j,2) = 0.5*yppa
         c(j,1) = (y(j+1)-y(j))/dx - (c(j,2)+c(j,3)*dx)*dx
         yppb = yppa
      end do
      return 
      end subroutine icsicu

       FUNCTION DLNGAM (X)
C***BEGIN PROLOGUE  DLNGAM
C***PURPOSE  Compute the logarithm of the absolute value of the Gamma
C            function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A
C***TYPE      real(kind=dp) (ALNGAM-S, DLNGAM-D, CLNGAM-C)
C***KEYWORDS  ABSOLUTE VALUE, COMPLETE GAMMA FUNCTION, FNLIB, LOGARITHM,
C             SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DLNGAM(X) calculates the double precision logarithm of the
C absolute value of the Gamma function for double precision
C argument X.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, D9LGMC, DGAMMA, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900727  Added EXTERNAL statement.  (WRB)
C***END PROLOGUE  DLNGAM
      use kind_spec

      IMPLICIT NONE
      real(kind=dp) DLNGAM
      real(kind=dp) X, DXREL, PI, SINPIY, SQPI2L, SQ2PIL, XMAX,
     1  Y, DGAMMA, D9LGMC, D1MACH, TEMP
      LOGICAL FIRST
      EXTERNAL DGAMMA
      SAVE SQ2PIL, SQPI2L, PI, XMAX, DXREL, FIRST
      DATA SQ2PIL / 0.91893853320467274178032973640562E0_dp/

      DATA SQPI2L / +.225791352644727432363097614947441E+0_dp/

      DATA PI / 3.14159265358979323846264338327950E0_dp/

      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DLNGAM
      IF (FIRST) THEN
         TEMP = 1.E0_dp/LOG(d1mach2)

         XMAX = TEMP*d1mach2
         DXREL = SQRT(d1mach4)
      ENDIF
      FIRST = .FALSE.
C
      Y = ABS (X)
      IF (Y.GT.10.E0_dp) GO TO 20

C
C LOG (ABS (DGAMMA(X)) ) FOR ABS(X) .LE. 10.0
C
      DLNGAM = LOG (ABS (DGAMMA(X)) )
      RETURN
C
C LOG ( ABS (DGAMMA(X)) ) FOR ABS(X) .GT. 10.0
C
 20   IF (Y .GT. XMAX) CALL XERMSG ('SLATEC', 'DLNGAM',
     +   'ABS(X) SO BIG DLNGAM OVERFLOWS', 2, 2)
C
      IF (X.GT.0.E0_dp) DLNGAM = SQ2PIL +

     >   (X-0.5E0_dp)*LOG(X) - X + D9LGMC(Y)

      IF (X.GT.0.E0_dp) RETURN

C
      SINPIY = ABS (SIN(PI*Y))
      IF (SINPIY .EQ. 0.E0_dp) CALL XERMSG ('SLATEC', 'DLNGAM',

     +   'X IS A NEGATIVE INTEGER', 3, 2)
C
      IF (ABS((X-AINT(X-0.5E0_dp))/X) .LT. DXREL)

     +   CALL XERMSG ('SLATEC', 'DLNGAM',
     +   'ANSWER LT HALF PRECISION BECAUSE X TOO NEAR NEGATIVE INTEGER',
     +   1, 1)
C
      DLNGAM = SQPI2L + (X-0.5E0_dp)*LOG(Y) - X -

     >   LOG(SINPIY) - D9LGMC(Y)
      RETURN
C
      END
! 22Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 22Jun2000 fgtok
! 22Jun2000 fgtok

#include "fpreproc/library_names.h"
#include "fpreproc/f77_dcomplx.h"
#include "fpreproc/fp_const.h"
*DECK DERF
       FUNCTION DERF (X)
C***BEGIN PROLOGUE  DERF
C***PURPOSE  Compute the error function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C8A, L5A1E
C***TYPE      REAL*8 (ERF-S, DERF-D)
C***KEYWORDS  ERF, ERROR FUNCTION, FNLIB, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DERF(X) calculates the double precision error function for double
C precision argument X.
C
C Series for ERF        on the interval  0.          to  1.00000E+00
C                                        with weighted error   1.28E-32
C                                         log weighted error  31.89
C                               significant figures required  31.05
C                                    decimal places required  32.55
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, DCSEVL, DERFC, INITDS
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900727  Added EXTERNAL statement.  (WRB)
C   920618  Removed space from variable name.  (RWC, WRB)
C***END PROLOGUE  DERF
C============
C idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER nterf,initds
C============
      REAL*8 X, ERFCS(21), SQEPS, SQRTPI, XBIG, Y, D1MACH,
     1  DCSEVL, DERFC
      REAL*8 DERF
      LOGICAL FIRST
      EXTERNAL DERFC
      SAVE ERFCS, SQRTPI, NTERF, XBIG, SQEPS, FIRST
      DATA ERFCS(  1) / -CONST(.49046121234691808039984544033376,-1)/
      DATA ERFCS(  2) / -CONST(.14226120510371364237824741899631,+0)/
      DATA ERFCS(  3) / +CONST(.10035582187599795575754676712933,-1)/
      DATA ERFCS(  4) / -CONST(.57687646997674847650827025509167,-3)/
      DATA ERFCS(  5) / +CONST(.27419931252196061034422160791471,-4)/
      DATA ERFCS(  6) / -CONST(.11043175507344507604135381295905,-5)/
      DATA ERFCS(  7) / +CONST(.38488755420345036949961311498174,-7)/
      DATA ERFCS(  8) / -CONST(.11808582533875466969631751801581,-8)/
      DATA ERFCS(  9) / +CONST(.32334215826050909646402930953354,-10)/
      DATA ERFCS( 10) / -CONST(.79910159470045487581607374708595,-12)/
      DATA ERFCS( 11) / +CONST(.17990725113961455611967245486634,-13)/
      DATA ERFCS( 12) / -CONST(.37186354878186926382316828209493,-15)/
      DATA ERFCS( 13) / +CONST(.71035990037142529711689908394666,-17)/
      DATA ERFCS( 14) / -CONST(.12612455119155225832495424853333,-18)/
      DATA ERFCS( 15) / +CONST(.20916406941769294369170500266666,-20)/
      DATA ERFCS( 16) / -CONST(.32539731029314072982364160000000,-22)/
      DATA ERFCS( 17) / +CONST(.47668672097976748332373333333333,-24)/
      DATA ERFCS( 18) / -CONST(.65980120782851343155199999999999,-26)/
      DATA ERFCS( 19) / +CONST(.86550114699637626197333333333333,-28)/
      DATA ERFCS( 20) / -CONST(.10788925177498064213333333333333,-29)/
      DATA ERFCS( 21) / +CONST(.12811883993017002666666666666666,-31)/
      DATA SQRTPI / CONST(1.77245385090551602729816748334115,0)/
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DERF
      IF (FIRST) THEN
         NTERF = INITDS (ERFCS, 21, CONST(0.1,0)*AREAL(D1MACH(3)))
         XBIG = SQRT(-LOG(SQRTPI*D1MACH(3)))
         SQEPS = SQRT(CONST(2.0,0)*D1MACH(3))
      ENDIF
      FIRST = .FALSE.
C
      Y = ABS(X)
      IF (Y.GT.CONST(1.,0)) GO TO 20
C
C ERF(X) = 1.0 - ERFC(X)  FOR  -1.0 .LE. X .LE. 1.0
C
      IF (Y.LE.SQEPS) DERF = CONST(2.0,0)*X*X/SQRTPI
      IF (Y.GT.SQEPS) DERF = X*(CONST(1.0,0)+
     1   DCSEVL (CONST(2.,0)*X*X-CONST(1.,0),
     1   ERFCS, NTERF))
      RETURN
C
C ERF(X) = 1.0 - ERFC(X) FOR ABS(X) .GT. 1.0
C
 20   IF (Y.LE.XBIG) DERF = SIGN (CONST(1.0,0)-DERFC(Y), X)
      IF (Y.GT.XBIG) DERF = SIGN (CONST(1.0,0), X)
C
      RETURN
      END
! 22Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 22Jun2000 fgtok
! 22Jun2000 fgtok
! 22Jun2000 fgtok

      subroutine dcsevu(x, y, nx, sc, ic, u, ds, m1, dds, m2, ierr)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nx, ic, m1, m2, ierr
      real(kind=dp), dimension(nx) :: x, y
      real(kind=dp), dimension(ic,3) :: sc
      real(kind=dp), dimension(m1) :: u, ds
      real(kind=dp), dimension(m2) :: dds
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, j, mmax
      real(kind=dp) :: d
      character :: isub*6 = 'dcsevu'
C-----------------------------------------------
c
c--Validate that the desired points are within range.
c
      ierr = 0
      i = 1
      do while(ierr==0 .and. i<=m1)
         if (u(i) < x(1)) then
            ierr = 33
         else if (u(i) > x(nx)) then
            ierr = 34
         else
            i = i + 1
         endif
      end do
      if (ierr /= 0) go to 9000
      mmax = max(m1,m2)
      do i = 1, mmax
c
c--find j such that x(j) <= u(i) < x(j + 1).
c
         j = 1
         do while(j<nx .and. u(i)>x(j+1))
            j = j + 1
         end do
         if (u(i) > x(nx-1)) j = nx - 1
         d = u(i) - x(j)                    ! offset from lower boundary
         if (i <= m1) ds(i) = (3.0*sc(j,3)*d+2.0*sc(j,2))*d + sc(j,1)
         if (i <= m2) dds(i) = 6.0*sc(j,3)*d + 2.0*sc(j,2)
      end do
      go to 9990
c
c--Error exit.
c
 9000 continue
      call uertst (ierr, isub)
c
c--Normal exit.
c
 9990 continue
      return 
      end subroutine dcsevu

#include "fpreproc/f77_dcomplx.h"
#include "fpreproc/fp_const.h"
*DECK INITDS
      FUNCTION INITDS (OS, NOS, ETA)
C***BEGIN PROLOGUE  INITDS
C***PURPOSE  Determine the number of terms needed in an orthogonal
C            polynomial series so that it meets a specified accuracy.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C3A2
C***TYPE      REAL*8 (INITS-S, INITDS-D)
C***KEYWORDS  CHEBYSHEV, FNLIB, INITIALIZE, ORTHOGONAL POLYNOMIAL,
C             ORTHOGONAL SERIES, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C  Initialize the orthogonal series, represented by the array OS, so
C  that INITDS is the number of terms needed to insure the error is no
C  larger than ETA.  Ordinarily, ETA will be chosen to be one-tenth
C  machine precision.
C
C             Input Arguments --
C   OS     double precision array of NOS coefficients in an orthogonal
C          series.
C   NOS    number of coefficients in OS.
C   ETA    single precision scalar containing requested accuracy of
C          series.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891115  Modified error message.  (WRB)
C   891115  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C***END PROLOGUE  INITDS
C============
C idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER nos,initds,ii,i
C============
C idecl:  explicitize implicit REAL declarations:
      REAL*8 err,eta
C============
      REAL*8 OS(*)
C***FIRST EXECUTABLE STATEMENT  INITDS
      IF (NOS .LT. 1) CALL XERMSG ('SLATEC', 'INITDS',
     +   'Number of coefficients is less than 1', 2, 1)
C
      ERR = CONST(0.,0)
      DO 10 II = 1,NOS
        I = NOS + 1 - II
        ERR = ERR + ABS(AREAL(OS(I)))
        IF (ERR.GT.ETA) GO TO 20
   10 CONTINUE
C
   20 IF (I .EQ. NOS) CALL XERMSG ('SLATEC', 'INITDS',
     +   'Chebyshev series too short for specified accuracy', 1, 1)
      INITDS = I
C
      RETURN
      END
! 22Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 22Jun2000 fgtok
! 22Jun2000 fgtok

      module Viorlh
C...Created by Pacific-Sierra Research VAST-90 2.06G2  12:29:44   5/18/01  
      use Vparam,only: nprofm,nions,nspectm,nspray,
     1                  nspect1,nwka,nthp00,nprofn
      character   versid*40
      integer   nmhd
      integer   icoll
      integer   nspec,mainsp
      integer   nprofs,nprof,iedge,ipropt
      integer   iout,iout1,iout2,nharm,nequil,isafa
      integer   nspect,nthin,maxref,igrill,islofa,irayio,ioread,nraypic
      integer   nequip,iprint,indvar,igraph,iplopr,jwfr
      integer,dimension(2,nions) :: iploxy
      integer,dimension(nspect1) :: nnkpar
      integer,dimension(nspectm) :: nnkpol
      real   dpsimhd
      real   fdia,powrq,denlav
      real   deykpr,psistep,pkexpnt
      real   omega,specfac,power,delthe,phase,rgrill,poldk
      real   denc,tempec,pavtne,pavtte,
     1 pavtti,pavpp,beta,betap,ali3
      real   gamene,alpene,gamte,alpte,gamti,
     1       alpti,denedg,temedg,tiedg
      real   wsol,fdened,fzefed,fteed,ftied,fcoll
      real   ffast,alpene1,alpte1,frcte,frcne,frcti,
     1  gamte1,gamti1,alpti1,gamene1,presfr
      real   epserr,epser1,epspfw,epspsw,epsray,rzero,rplasm,
     1   bzero,btsign,tcurr,fbsc,rshift,dtrian,qsaf0,qsafa
      real,dimension(10) :: aiseed
      real,dimension(2) :: polasp
      real,dimension(nprofm) :: psimhd,rmaj,rrho,triang,elong
      real,dimension(nions) :: atm,azi
      real,dimension(nprofm,nions) :: conc
      real,dimension(nions) :: tempic
      real,dimension(nprofm) :: ppsi,pjavg,pne,pte
      real,dimension(nprofm,nions) :: pni,pti
      real,dimension(nprofm) :: psinm,tani
      real,dimension(nspectm,nspray) :: anzin
      real,dimension(nspect1) :: anzsup,anzinf
      real,dimension(nspectm,nspray) :: anplin
      real,dimension(nspectm) :: anpsup,anpinf
      real,dimension(nspectm,nspray) :: pwcpl,pwtra
      real,dimension(nspect1) :: powers
      real,dimension(nspectm) :: thgril
      real,dimension(nprofm) :: pwe,pwe0
      real,dimension(nprofm,nions) :: pwi,pwii0
      real,dimension(0:nprofm) :: pwev
      real,dimension(0:nprofm,nions) :: pwiv
      real,dimension(nprofm,nwka) :: wkarea
      real,dimension(nprofm,3) :: pwal
      real,dimension(nions) :: tite
      end module Viorlh

      module Vparam
      use kind_spec

C...Created by Pacific-Sierra Research VAST-90 2.06G2  12:29:44   5/18/01
      integer, parameter :: nbwg = 24
      integer, parameter :: npdim = 10000
      integer, parameter :: nspectm = 11
      integer, parameter :: nspect1 = 21
      integer, parameter :: nspray = 3
      integer, parameter :: ntheta = 15
      integer, parameter :: ngdim = nspray*nspectm*ntheta
      integer, parameter :: nions = 6
      integer, parameter :: nions1 = nions
      integer, parameter :: nbesa = 201
      integer, parameter :: nuam = 65
      integer, parameter :: ntam = 65
      integer, parameter :: nwk = 1 + 3*ntam
      integer, parameter :: imaxu = nuam
      integer, parameter :: jmax = ntam
      integer, parameter :: irmax = 21
      integer, parameter :: nxa = 80
      integer, parameter :: nza = 80
      integer, parameter :: nza2 = 2*nza
      integer, parameter :: nprofm = 131
      integer, parameter :: nprofn = nprofm
      integer, parameter :: nptsdm = 263
      integer, parameter :: inoperm = 2*nptsdm*nprofm + 2*nptsdm
      integer, parameter :: lrza = 51
      integer, parameter :: nraym = 5000
      integer, parameter :: nplus = 5000
      integer, parameter :: nbitab = 10001
      integer, parameter :: nli = 101
      integer, parameter :: nwka = 2*nions + 6
      integer, parameter :: nprofm2 = 2*nprofm
      integer, parameter :: nwp0 = 50
      integer, parameter :: nthp11a = 61
      integer, parameter :: nthp00 = 1001
      integer, parameter :: npsis = 26
      integer, parameter :: npnta = 101
      integer, parameter :: mpnta = npsis
      integer, parameter :: ndim30 = npdim
      integer, parameter :: ndim20 = 10
      integer, parameter :: nfion = 10
      integer, parameter :: lmx = 51
      integer, parameter :: lmn = 0
      integer, parameter :: lbes = lmx - lmn + 1
      integer, parameter :: nbsx = 5001
      end module Vparam

      subroutine tableintrp (xx, n, x, jlo)
c
      implicit none
c
c ----------------------------------------------------------------------
c --- correlated table search routine. use jlo from previous call to
c --- get jlo for current value of x. if jlo from previous call is
c --- no good(jlo=0 or jlo=n) then do a binary search.
c --- this routine returns jlo so that
c   xx(jlo) .le. x .le. xx(jlo+1) if jlo = 1
c   xx(jlo) .lt. x .le. xx(jlo+1) if jlo =2,3...n-1
c   it is assumed that xx(j),j = 1,2..n is monotonically
c   increasing; this is NOT checked for.
c   this is a modified version of the Numerical Recipes subroutine HUNT
c ------------------------------------------------------------------ HSJ
c
      integer  n, jlo, jhi, jmid, inc
      real*8   x, xx(n)
c
      if      (x .lt. xx(1)) then
        jlo = 0                     ! indicates out of range below xx(1)
      else if (x .le. xx(2)) then
        jlo = 1                     ! xx(1) .le. x .le. xx(2)
      else if (x .le. xx(n)) then   ! xx(2) .lt. x .le. xx(n)
c
c       check if jlo from previous call is usable:
c
        if (jlo .eq. 0 .or. jlo .eq. n) then
          jlo = 2
          jhi = n
          go to 15           ! no correlation go directly to bisection
        else                 ! 1 .le. jlo .lt. n
c
c         bracket x, then use bisection:
c         start with  jlo  from previous call:
c
          inc = 1
          if (x .gt. xx(jlo)) then    ! search up
    4       jhi = jlo + inc
            if (jhi .ge. n) then
              jhi = n
            else if (x .gt. xx(jhi)) then
              inc = inc + inc
              jlo = jhi
              go to 4
            end if
          else
    5       jhi = jlo
            jlo = jlo-inc
            if (jlo .le. 1) then
              jlo = 1
            else if (x .le. xx(jlo)) then
              inc = inc + inc
              go to 5
            end if
          end if
        end if
c
c         bisection:
c
   10     if (jhi-jlo .eq. 1)  return
   15     jmid = (jhi + jlo) / 2
          if (x .gt. xx(jmid)) then
            jlo = jmid
          else           ! x .le. xx(jmid)
            jhi = jmid
          end if
          go to 10
c
      else               ! x .gt. xx(n)
        jlo = n
      end if
c
      return
c
      end

ME(d1mach)(int *i)
{
       switch(*i){
         case 1: return DBL_MIN;
         case 2: return DBL_MAX;
         case 3: return DBL_EPSILON/FLT_RADIX;
         case 4: return DBL_EPSILON;
         case 5: return log10((double)FLT_RADIX);
         }
       fprintf(stderr, "invalid argument: d1mach(%ld)\n", *i);
       exit(1); return 0; /* some compilers demand return values */
}
      use kind_spec
      real, kind(dp) function d1mach(int i)
      if( i == 1 ) d1mach = DBL_MIN
      else if( i == 2) d1mach = DBL_MAX
      else if( i == 3) d1mach = DBL_EPSILON/FLT_RADIX
      else if( i == 4) d1mach = log10(FLT_RADIX)
      return
      end function dimach
    

      module Vgrnout
C...Created by Pacific-Sierra Research VAST-90 2.06G2  15:15:56   5/18/01  
      integer   nwguid, nmod, nphase, isimm, ndim0, ndim1
      real   freqcy,width,dwall,heigth,dnedge,dndx,dxpl,phmin,phmax
      end module Vgrnout

      subroutine leqt3f(a, m, n, np, b, idgt, wkarea, ier)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  17:20:10   6/12/01  
C...Switches: -p4 -yb
C   Changed the name from leqt2f (IMSL routine)
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer m, n, np, idgt, ier
      real, dimension(np,np) :: a
      real, dimension(np) :: b
      real, dimension(1) :: wkarea
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
      integer, parameter :: ndl = 900
      integer, parameter :: nd = ndl + 1
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer, dimension(nd) :: indx
      integer :: jk, kl, npp, ll2, mm
      real :: sum, tmpmx, btmp, tmp, err
      double precision, dimension(nd,nd) :: ao
      double precision, dimension(nd) :: bo
      double precision, dimension(nd,nd) :: an
      double precision, dimension(nd) :: bn
      double precision :: d
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real , EXTERNAL :: write
C-----------------------------------------------
c
c      real ao(901,901),bo(901)
c      real an(901,901),bn(901)
c
c     n had better be less than nd
c
      bo(:n) = b(:n)
      bn(:n) = b(:n)
      an(:n,:n) = a(:n,:n)
      ao(:n,:n) = a(:n,:n)
c
      npp = nd
      call ludcmp (an, n, npp, indx, d,)
      npp = nd
      call lubksb (an, n, npp, indx, bn)
      npp = nd
      call mprove (ao, an, n, npp, indx, bo, bn)
c
      do jk = 1, n
c         if (bn(jk) < 1.D-36) bn(jk) = 0.
c         if (bn(jk) > 1.D+36) bn(jk) = 1.E+36
         b(jk) = bn(jk)
      end do
c
      return 
      end subroutine leqt3f
 

c-----------------------------------
c file: icsevu.f
c 
c purpose: replaces imsl routine by same name
c
c------------------------------------
      subroutine icsevu(x, y, nold, c, kjx, xnew, ynew, nnew, ier)
c
c x(nx) - nx x values ordered x(i) < x(i+1)
c y(nx) - nx y values that were used to generate c
c c(nx-1, 3) - matrix of spline coefficients
c kjx - row dimension of c, note kjx >= nx-1
c xnew(nnew) - nnew x values were spline is to be evaluated
c ynew(nnew) - nnew y values
c nnew - number of spline evaluations
c ier - error codes:
c  ier = 0, no error detected
c  ier = 33 a xnew is < x(1)
c  ier = 34 a xnew is > x(nold)
      implicit none
      integer k, i, jer, ker, nnew, kjx, nold, ier
      real*8 x(nold), y(nold), c(kjx, 3), xnew(nnew), ynew(nnew)
      real*8 d
      do k=1,nnew
        call bcspefnd(x, nold, xnew(k), i)
	d = xnew(k) - x(i)
	ynew(k) = ((c(i,3)*d+c(i,2))*d+c(i,1))*d+y(i)
        if(xnew(k) .lt. x(1))    jer = 33
        if(xnew(k) .gt. x(nold)) ker = 34
      end do
      ier = max0(jer, ker)
      if(jer.gt.0) then
        call uertst(jer, 6hicsevu)
      end if
      if(ker.gt.0) then
        call uertst(ker, 6hicsevu)
      end if
      return
      end

      subroutine raytr
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:51:36   6/14/01
C...Switches: -p4 -yb
c
c ************ ************ ************ ************ ************
c
c  main subroutine for ray tracing implementation
c    This is normal version
c
c ************ ************ ************ ************ ************
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang,
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec,
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3,
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti,
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin,
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril,
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref,
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep,
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr,
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite,
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1,
     1   gamene1, presfr, iout, epsray, epspsw, epspfw, aiseed, powrq
      use Vcraylh
      use Vceqdsk, ONLY: ntitle, dat, ipestg, nxeqd, nzeqd, xdimeqd,
     1   zdimeqd, reqd, redeqd, zmideqd, xma, zma, psimag, psilim,
     2   beqd, toteqd, psimx1, psimx2, xax1, xax2, zax1, zax2, psisep,
     3   xsep, zsep, feqd, presseqd, ffpeqd, ppeqd, peqd, qeqd, xeqd,
     4   zeqd, psiadj, dpolflx, psieqd, tpsieqd, tpsifeqd, iounit1,
     5   inoperm1, nptsdm1, nptsd, torflux, tpsisav, ra, psifra,
     6   dpsifra, fra, fra1, cspln, pds, wnoperm, xcontr, zcontr,
     7   bpcontr, btcontr, dstarp, b_fld, jacob, pprime, vprime,
     8   chipsi, ncontr, dang, bperr, arcl, thet, anglex, csplnx,
     9   csplnz, pdsx, pdsz, nlim, rlim, zlim, nlimiter, rlimiter,
     .   zlimiter, lrz, nprim, nimp, nion, nti, zi, zeffz, r, raeqd,
     1   psifeqd, te, ti, ti1, ene, enp, bmod, rmd, btmd, bpmd, btpmd,
     2   roa
      use Vchpcsd
      use Viogrl, ONLY: calfa, px, sumpx, bk, refl, rtot, trans,
     1   aksupw, ddk, nnk, joutrf, ireout, jumpw, jtest, ispec, ngra,
     2   itrans, radius, isimm
      use Vcgraphs, ONLY: seikon, spsi, sxu, szu, skp, skpar, spower,
     1   sdpwri, sphi, stheta, spol, sdkpar, scepx, scepy, scepz,
     2   sztpol, sbtot, sene, salphac, salphal, sjslofa, serrors,
     3   spkpsi, sakpsi, sakth, swkve, jjslofa, sne, ste, sqr, spw,
     4   sxh, sqte, sni, sti, sdeqs, spwer, spwmax, srtor, srplas,
     5   sdenc, stec, sqc, sqa, sbaxis, scurr, sfreq, satm, sazi,
     6   sconc, stic, sxpage, sypage, slenx, sleny, sdelx, sfirtx,
     7   sdely, sfirty, symax, symin, skth, skphi, skpsi, sxx, jslofas,
     8   nurefls, keiks, jpes, jpis, istarts, iprmt5, jhlfs, isimpl,
     9   isimpl0, ngr, nps, nspie, kgraph, kprof, newgra, jksym,
     .   lintyp, nxvarb, nyvarb, kwfr, initlh
      use Vcmnew, ONLY: wpi1c, wpi2c, wci1c, wci2c, wpi2, wci2, wci,
     1   conci, aziomi, rtzom, ay2, ay1, trate, tratte, ttle, concte,
     2   trati, tratti, ttli, concti, vdrfte, vdrfti, infi, gprm, cxet,
     3   czt, cztp, czetai, czi, czip, czetat, czti, cztip, cth, npar,
     4   nper, upar, uper, umax, dsfe, dsfi, fper2, fpar2, fpp2, intg,
     5   inc, incf, tnmaxe, tnmaxi, idrive, binb, boutb, boutbrd,
     6   binbrd, epsl, binbd, epsil, dlob, wte, eta0, eta, rprof,
     7   amprof, cprof, xjop, vloop, kboot, mboot, btbsp, ftbsps, pde,
     8   pdec, pdi, pdf, pwce, pwcm, pwcf, pwc, pwc1, pwc2, pwct,
     9   pwct1, pwct2, pwc0, pwcray, pwc1ray, pwc2ray, pweray, pwiray,
     .   pwfray, currf, currfe, currf1, currf2, curay, curay1, curay2,
     1   fpwray, fpowe, fpowf, fpowi, pwte0, pwti0, effcd, effcdt,
     2   ptot, ftpowe, ftpowi, ftpowf, ftpi, ftpf, ftedge, pwedge,
     3   wfrac, pwxwl, frpowi, frpowf, frpow, pwit, pwft, ptedge,
     4   ptot0, fpowt, tpowi, tpowf, wfrac0, ebkev, bmpwr, azf, atmf,
     5   densa, kalfa, nalfa, nharm0, pnfi, pnf, zetab, tnf, ecrit,
     6   taua0, wca, gamal, gamat, ibeam, abeam, dbeam, aneb, enbeam,
     7   wbeam, temsa, ptfi, ttf, wpf2c, wpf2, wcf2c, wcf1c, wcf2, wcf,
     8   cxc, czc, cy, denfa, eav, tausd, tau0, paf, sordt, ecrita,
     9   betaf, nfion, nminor, nsp1
      use Vcfdamp, only: inf
      use Vbesblk
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: nbk, n, nzth, mstart, nrpt, isp, ip, neik, nzeik, ii,
     1   nzk, kkk, kk1, kk2, ind1, kmcon, ind2, ier5, isx1, jmcind,
     2   iermc, nslofa, imode, iter, ier, ih, insp, k, ien, ik, ij, l,
     3   iray, i1, i2, ir, k1, iu
      real(kind=dp), dimension(6) :: ypv
      real(kind=dp), dimension(nprofm,nions) :: pwc10
      real(kind=dp), dimension(nprofm,nfion) :: pwc20, pwff0
      real(kind=dp), dimension(nfion) :: pwtf0
      real(kind=dp), dimension(lmx + 1) :: wk1, wk2
      real(kind=dp) :: zpi, tzpi, zkpar, zkpol, theta0, x, cst1, cst2,
     1    cst3,
     1   deykpp, psistepp, anphpv, discr, pkp20, pkp21, pkp22, pkp23,
     2   disck2, a2k, pkpsi2, ss1, disp1, ddisp1, ss2, disp2, ddisp2
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
       external output1, deriv
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c------------ --------------
c   common blocks of Comiogrl
c---------------------------
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c
c   Comhpcsd
c
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95

c
c----------------------------
c   common blocks of Cmgraphs
c

c    2   ,sqti(nprofm)
c
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i

c
c
c
c $$$$$$$ Added by T.K. Mau on 10/10/91
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1


c******      TKM   03/97, 09/99, 04/00, 06/00
c********************

c $$$$$$$$$$$$$$$$
c ************ ************ ************ ************ ************
c
c-----------------SCC  7/24/95
c     dimension ypv(6)
c   TKMau   9/20/94
!      parameter (lmx=51,lmn=0)
!      parameter (lbes=lmx-lmn+1,nbsx=5001)
c     for vectorized bessel function subroutine besselj
c
c ************ ************ ************ ************ ************
c
      data zpi/3.14159265359/
      data tzpi/6.283185308/
c
c ************ ************ ************ ************ ************
c   loop over the initial value of n parallel
c ************ ************ ************ ************ ************
c
c--------------------SCC  6/15/95
      epsray = 2.E-3
      if (islofa == 1) epsray = epspsw
      if (islofa == (-1)) epsray = epspfw
c----------------------SCC 2/7/95  3/7/95
      psilast = (1. - solrfl)*ppsi(nprofs) + 0.5*solrfl*ppsi(nprof)
      call cbesin
      if(kalfa>0)call bestab(lmx,lmn,nbsx,0.01,0.,bestb,wk1,wk2)
c*******************************SCC 12/21/95
c  calculate total no. of rays in curray go or read in from input-file
c  temperarily store in indgr, which will later on end up the same number.
c  write number of rays, nharm(for cql3d),freqcy (and nprof)
      indgr = 0
      do isign = 1, isimm
         if (igrill == (-3)) then
            nbk = nnkpol(isign)
         else
            nbk = nnkpar(isign)
         endif
         indgr = indgr + nbk*nthin
      end do
      call rayinout (1)
c***************************************************
c---------------------------------

      indgr = 0
      do isign = 1, isimm
         if (igrill == (-3)) then
            nbk = nnkpol(isign)
         else
            nbk = nnkpar(isign)
         endif
         if (nbk > 0) then
            do n = 1, nbk
               zkpar = anzin(isign,n)
               if (igrill == (-3)) zkpol = anplin(isign,n)
               if (abs(zkpar)>1. .or. islofa/=1) then
                  write (iout, 1010) zkpar
c
c ************ ************ ************ ************ ************
c   loop over the initial value of theta
c ************ ************ ************ ************ ************
c
                  do nzth = 1, nthin
c*********************************SCC  12/21/95
c     zero out the ray-data variable to rayop
                     call zeros
c***********************************************
                     indgr = indgr + 1
c $$$$$  Added by TK Mau on 11/18/91
                     irec = 0
c $$$$$ Added by TK Mau and SC Chiu on 10/16/91
                     pwedge(indgr) = 0.
c $$$$$$$$$$$$$$$$$$$$$$$$$
                     write (iout, 1000)
c
c ************ ************ ************ ************ ************
c  initialization for hpcsd (integrating subroutine)
c ************ ************ ************ ************ ************
c
                     mstart = 0
  120                continue
                     mstart = mstart + 1
                     write (iout, 2099) mstart, prmt(5), y(2)
 2099                format('$$ mstart=',i3,5x,'prmt(5)=',f4.0,
     1                  5x,'psi =',e12.4)
c******************* Change 2 to 3   SCC  5/5/95
                     if (mstart > 3) then
                        write (iout, 2001)
 2001                   format(1x,
     1'*****Ray terminated after failure of restart.'/1x,
     2                     '*****Need a different delthe')
                        go to 101
                     endif
c----------------7/5/95
                     spkpsi(:npdim) = 0.
                     sakpsi(:npdim) = 0.
                     sakth(:npdim) = 0.
                     jmcon(:npdim) = 0
c---------------------
                     if (initlh == 0) then
                        istart = 1
                        isxz = 0
                        jslofa = islofa
                        eikon = 0.
                        theta = zpi*thstrt(nzth,isign)/180.
c-------------SCC  6/16/95
                        if (mstart > 1) then
                           theta = zpi*thstrt(nzth,isign)/180. + delthe*
     1                        (mstart - 1)
                           pwtote = pwte0
                           pwtoti(:nspec) = pwti0(:nspec)
                           pwe(:nprof) = pwe0(:nprof)
                           pwc(:nprof) = pwc0(:nprof)
                           pwi(:nprof,:nspec) = pwii0(:nprof,:nspec)
                        endif
c----------------------------
c*******************************SCC   5/5/95  Changed above restart condition
                        phi = phi0
c $$$$  Altered by TK Mau on 11/20/91  SCCHiu 1/26/94
                        if (igrill == (-3)) then
                           pkphi = zkpar
                           pktau = zkpol
                        else
                           if (igrill == (-2)) then
                              pkphi = zkpar
                           else
                              pkpar = zkpar
                           endif
                        endif
c $$$$$$$$$$$$$$$$$$$$$$$$
                        pwx = pwcpl(isign,n)*fpwth(nzth)
                        jpe = 0
                        jpi = 0
c
                        call iniwfr
                        if (scatd/=0.0 .and. iscat0/=0) then
                           call scatperp
                           y(1) = akpsi
                           y(3) = akth
                        endif
                        theta0 = theta*180./zpi
                        write (iout, 2010) pkphi, pktau, psi, theta0
 2010                   format(1x,'Initial pkphi=',e14.6,2x,
     1                     '; initial pktau=',e14.6/1x,'Initial psi=',
     2                     e14.6,2x,';  initial theta=',e14.6,1x,
     3                     'degrees')
c
                     else
c--------------------SCC  12/21/95
c   work is incomplete here. Need to call rayinout(4) and then rayinout(5)
c   to read in ray by ray
c   Need a different channel and different name for ray-data file
c   Label ray number by nrayno=indgr in rayinout
c--------------------------------
                        isxz = isimpl(indgr)
                        jslofa = jslofas(indgr)
                        eikon = seikon(isxz)
                        psi = spsi(isxz)
                        theta = atan2(szu(isxz)-zma,sxu(isxz))
                        if (mstart > 1) go to 101
c--------------------
c  ray is not restarted if data is read in from 'rayop'
c----------------------
                        phi = tzpi*sphi(isxz)
                        pkpar = skpar(isxz)
                        pkpar2 = pkpar*pkpar
                        pwx = spower(isxz)
                        y(1) = skpsi(indgr)
                        y(2) = psi
                        y(3) = skth(indgr)
                        y(4) = theta
                        y(5) = phi
                        y(6) = -100.
                        if (pwx > exp(-15.)) then
                           if(istarts(indgr)==(-1))istarts(indgr)=1
!                           y(6) = alog(pwx)
                           y(6) = log(pwx)
                        endif
                        istart = istarts(indgr)
                        jpe = jpes(indgr)
                        jpi = jpis(indgr)
                        isxz = isxz - 1
                        call coords
                        call profix
                        call disper (0)
                        anphi = skphi(indgr)
                     endif
c
c
c  istart: 0(no good start), 1(ok start), -1(absorbed).
                     if (istart > 0) then
c
                        if (initlh == 0) then
                           x = 0.
                           call deriv (x)
                           if (psistep /= 0.) then
                              cst1 = max(abs(pkpar)**pkexpnt,0.5_dp)
                              cst2 = min(abs(psistep/dy(2)/cst1),tzpi)
                              cst3 = 2.*deykpr
                          cst2 = min(0.25_dp*deykpr+0.75_dp*cst2,cst3)
                              deykpr = min(tzpi,cst2)
                           endif
                           keik = 1
                           eikref = deykpr
                           powold = pwx
                           nurefl = 0
                        else
                           x = sxx(indgr)
                           call deriv (x)
                           if (psistep /= 0.) then
                              cst1 = max(abs(pkpar)**pkexpnt,0.5_dp)
                              cst2 = min(abs(psistep/dy(2)/cst1),tzpi)
                              cst3 = 2.*deykpr
                         cst2 = min(0.25_dp*deykpr+0.75_dp*cst2,cst3)
                              deykpr = min(tzpi,cst2)
                           endif
                           keik = keiks(indgr)
                           eikref = x + deykpr
                           powold = pwx
                           nurefl = nurefls(indgr)
                        endif
c
   10                   continue
                        call deriv (x)
c
                        dkdrin = dy(2)/abs(dy(2))
                        akrini = y(1)
                        neik = keik
                        if (neik>nequip .and. nequip>0) stop 30
                        hlast = 0.5*dsteph
   12                   continue
                        if (abs(x - eikref) <= 1.E-6*abs(deykpr)) eikref
     1                      = eikref + deykpr
                        neik = keik
c
c ************ ************ ************ ************ ************
c  loop over equiphase surfaces
c ************ ************ ************ ************ ************
c
                        do nzeik = neik, nequip
                           deykpp = deykpr
                           psistepp = psistep
                           anphpv = anphi
                           ypv = y(:6)
                           keik = nzeik
                           prmt(1) = x
                           prmt(2) = eikref
                           prmt(3) = 2.*hlast
                           prmt(4) = accur
                           prmt(6) = 0.
c*********************SCC 10/20/94
c**************************************
                           dy(:6) = precdy(:6)
c******************
c
                           kkk = nzeik/30
                           kk1 = nzeik/100
                           kk2 = nzeik/5
                           call hpcsd (deriv, output1)
c
c     Record rays stopped for reasons other than that the
c     interval is completed, in istarts
                           if (prmt(5) <= (-2.)) go to 120
                           if (prmt(5)>0. .and. isxz<nps) then
                              if (pwx <= epsray*power/float(nnztot*nthin
     1                           )) then
                                 istarts(indgr) = -1
                              else
                                 istarts(indgr) = 0
                              endif
                           endif
c#########################
c  SCC  7/24/95    This section was re-written
c  mode conversion of LH-waves are allowed now.
c
                           if (jhlf >= 21) istarts(indgr) = 0
                           if (prmt(5) == (-1.)) then
                              jmcon(isxz) = -1
                              go to 89
                           endif
                           if (abs(y(2)-ypv(2))<=1.E-10 .and. abs(y(4)-
     1                        ypv(4))<=1.E-10) then
                              prmt(5) = 1
                              go to 101
                           endif
c-------------------
c  check for evanescence and/or mode-conversion;
c---------------------
   89                      continue
                           call disper (0)
                           call sub3d (discr, ind1, ichois)
c------------
c  if ind1=1, go back one step and do m-conversion.
c-------------
                           if (ind1 == 1) then
   80                         continue
                              kmcon = 1
                              call stpbak (kmcon, ind1, ind2, pkp20)
                              x = xx
c------------
c  update y(1),y(3) for mode-conversion
c----------
                              call sub5 (pkp20, ier5)
                              if (ier5 == 99) then
                                 isxz = isx1
                                 go to 80
                              endif
                              kmcon = 0
                              nurefl = nurefl + 1
                              if (nurefl > maxref) go to 101
                              call disper (1)
                              call coutgr
                              psistep = psistepp
                              deykpr = deykpp
                              eikref = x
                              istarts(indgr) = 1
                              go to 12
                           else
c-------------
c if ind1=0, first check if there were mode-conversion in previous
c five steps
c then check if close to evanescence
c if neither, then continue
c--------------
                              call chkpmc (jmcon, npdim, isxz, jmcind)
                              kmcon = 0
                              if (jmcind /= 1) then
                                 call sub4 (pkp21, pkp22, pkp23, ind2,
     1                              jslofa, ichois, kmcon, pkp20, iermc
     2                              , disck2, a2k, nslofa, imode
     3                              , tempe, xe, zxe2, cz, czp)
                                 if (iermc /= 0) then
                                    isx1 = isxz - 1
                                    jmcon(isx1) = 1
                                    jmcon(isxz) = 0
                                    sjslofa(isxz) = nslofa
                                    jslofa = nslofa
                                    kmcon = 0
                                    go to 32
                                 endif
c--------
c  Check if near m-c
c--------
                                 call subkmc (pkp21, pkp22, pkp23, ind2
     1                              , jslofa, ichois, kmcon, pkp20,
     2                              iermc, disck2, a2k, nslofa, imode)
                                 if (kmcon == 0) then
                                    if (abs(y(2)-ypv(2))<=1.E-6 .and.
     1                                 abs(y(4)-ypv(4))<=1.E-6) kmcon =
     2                                 -1
                                 endif
                                 jmcon(isxz) = kmcon
                                 select case (kmcon)
                                 case (0)
                                    go to 32
                                 case (-1)
                                    prmt(5) = -1.
                                    pkpsi2 = pkp20 - pkheta**2
                                    if (pkpsi2 < 0.) then
   85                               continue
                                    call stpbak (kmcon, ind1, ind2,
     1                                 pkp20)
                                    x = xx
                                    call sub5 (pkp20, ier5)
                                    if (ier5 == 99) then
                                    isxz = isxz - 1
                                    go to 85
                                    endif
                                    else
                                    call sub5 (pkp20, ier5)
                                    endif
                                    kmcon = 0
                                    nurefl = nurefl + 1
                                    if (nurefl > maxref) go to 101
                                    call disper (1)
                                    call coutgr
                                    psistep = psistepp
                                    deykpr = deykpp
                                    eikref = x
                                    istarts(indgr) = 1
                                    pkpsi = -pkpsi
                                    y(1) = (aj*pkpsi + ag*pktau)/antau
                                    akpsi = y(1)
                                    pwx = exp(y(6))
                                    call wloss
                                    pwxwl = (1. - wfrac)*pwx
                                    pwedge(indgr) = pwedge(indgr) +
     1                                 pwxwl
                                    pwx = wfrac*pwx
!                                    y(6) = alog(pwx)
                                    y(6) = log(pwx)
                                    powold = powold - pwxwl
                                    if (scatd /= 0.) then
                                    call scatperp
                                    y(1) = akpsi
                                    y(3) = akth
                                    endif
                                    go to 10
                                 case (1)
                                    pkpsi2 = pkp20 - pkheta**2
                                    if (pkpsi2 < 0.) then
   87                               continue
                                    call stpbak (kmcon, ind1, ind2,
     1                                 pkp20)
                                    x = xx
                                    call sub5 (pkp20, ier5)
                                    if (ier5 == 99) then
                                    isxz = isxz - 1
                                    go to 87
                                    endif
                                    else
                                    call sub5 (pkp20, ier5)
                                    endif
                                    kmcon = 0
                                    nurefl = nurefl + 1
                                    if (nurefl > maxref) go to 101
                                    call disper (1)
                                    call coutgr
                                    psistep = psistepp
                                    deykpr = deykpp
                                    eikref = x
                                    istarts(indgr) = 1
                                    go to 12
                                 end select
                              endif
c---------------------
c*****************10/10/91 SCC refreshing process
c  refreshing process involves mltiplying akpsi and akth by a factor
c  ss2 which is determined by the Newton-Raphson method so that the
c  new k-vector satisfy the dispersion relation. akphi is kept constant
c  in the process.
c*******************************
                           endif
   32                      continue
                           if (prmt(6) >= 1.) then
                              call disper (0)
c----------------SCC   7/26/95
                              call sub4 (pkp21, pkp22, pkp23, ind2,
     1                           jslofa, ichois, kmcon, pkp20, iermc,
     2                           disck2, a2k, nslofa, imode,
     3                           tempe, xe, zxe2, cz, czp)
                              if (abs(disck2/a2k) <= 1.E-1) go to 88
                              ss1 = 1.00
                              call sub2 (ss1, disp1, ddisp1, ichois)
                              iter = 0
   26                         continue
                              ss2 = ss1 - disp1/ddisp1
                              if (ss2<=1.2 .and. ss2>=0.8) then
                                 if (abs(ss2 - ss1) > 1.E-6) then
                                    iter = iter + 1
c----------SCC  6/29/95
                                    if (iter > 100) then
                                    write (iout, 1112) iter, indgr
 1112                               format(2x,'no convergence in',i5,
     1                                 'iterations,abandon ray',i5)
                                    prmt(5) = 1.
                                    go to 101
                                    endif
                                    if (iter == 51) then
c-------------------
                                    write (59, 1111) iter, indgr
 1111                               format(2x,'no convergence in',i5,
     1                                 'iterations,continue ',
     2                                 'refreshing',i5)
                                    endif
   88                               continue
                                    ier = 0
                                    call precrt (ss1, ss2, ier, ichois)
                                    if (ier == 19) then
                                    write (iout, 1114) indgr, isxz, psi
     1                                 , theta
 1114                               format(2x,'ray no.=',i5,2x,
     1                                 'step no.=',i5,'psi=',e16.6,2x,
     2                                 'theta=',e16.6/2x,
     3'no solution of dispersion close to raypoint.')
                                    go to 101
                                    endif
                                    go to 91
                                 endif
c----------------SCC  6/29/95
                                 call sub2 (ss2, disp2, ddisp2, ichois)
c-----------------------
                                 ss1 = ss2
                                 disp1 = disp2
                                 ddisp1 = ddisp2
                                 go to 26
                              endif
                              if (abs(ss2 - 1.) > 0.5) then
                                 prmt(5) = 1.
                                 write(iout,1113)indgr,isxz,psi,theta
 1113                            format(2x,'Ray no.:',i5,3x,'step no.:',
     1                              i5,';  at psi=',e16.6,2x,
     2                              'and theta=',e16.6/2x,
     3'ray marching error too            large.')
                                 go to 101
                              endif
   91                         continue
                              akpsi = akpsi*ss2
                              akth = akth*ss2
                              y(1) = akpsi
                              y(3) = akth
                              call sub1
                              call deriv (x)
                           endif
c*********end refreshing
c#######################################################
c
                           x = tzpi*eikon
                           xx = x
c     Adjust step if psistep.ne.0.
                           if (psistep /= 0.) then
                              cst1 = max(abs(pkpar)**pkexpnt,0.5_dp)
c       cst0=abs(psilast-y(2)+0.002)
c       cst0=amin1(psistep,cst0)
                              cst2 = min(abs(psistep/dy(2)/cst1),tzpi)
                              cst3 = 2.*deykpr
                        cst2 = min(0.25_dp*deykpr+0.75_dp*cst2,cst3)
                              deykpr = min(tzpi,cst2)
                           endif
                           if (prmt(5) < 0.) go to 40
                           if (prmt(5) > 0.) go to 101
                           eikref = x + deykpr
                        end do
c
c ************ ************ ************ ************ ************
c  end of loop over equiphase surfaces
c ************ ************ ************ ************ ************
c
                        go to 101
c
c ************ ************ ************ ************ ************
c  specular reflection at the edge
c ************ ************ ************ ************ ************
c
   40                   continue
                        pkpsi = -pkpsi
                        y(1) = (aj*pkpsi + ag*pktau)/antau
                        akpsi = y(1)
                        nurefl = nurefl + 1
c $$$$$$$$ Added by TK Mau and SC Chiu on 10/16/91
c     To account for wall losses at each reflection
                        if (nurefl > maxref) go to 101
                        call wloss
                        pwx = exp(y(6))
                        pwxwl = (1. - wfrac)*pwx
                        pwedge(indgr) = pwedge(indgr) + pwxwl
                        pwx = wfrac*pwx
!                        y(6) = alog(pwx)
                        y(6) = log(pwx)
                        powold = powold - pwxwl
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

c ************ ************ ************ ************ ************
c   angular scattering of perp wavevector according to
c   optical depth for the process scatd:
c ************ ************ ************ ************ ************
                        if (scatd /= 0.) then
                           call scatperp
                           y(1) = akpsi
                           y(3) = akth
                        endif
                        keik = isxz + 1

                        go to 10
c
c ************ ************ ************ ************ ************
c  ray ended
c ************ ************ ************ ************ ************
c
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c   Added by T.K. Mau on Oct. 9, 991.
c  Modified by TK Mau  on 4/19/94
c    pweray : electron power deposition profile for each ray
c    pwcray : driven current density profile for each ray
c    curay : driven current (MA) for each ray
c    curay1 : driven minority current profile (A/cm**2)
c    curay2 : driven fast ion current profile (A/cm**2)
c    currfe : driven electron current (MA)
c    currf1 : driven minority current (MA)
c    currf2 : driven fast ion current (MA)
c    currf  : total current driven
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c
                     endif
  101                continue
c-----------------SCC  7/26/95
                     if (inf /= (-2)) then
c--------------
                        if (indgr == 1) then
c-------SCC  3/27/91
                           pwc10(:nprof,:nspec) = 0.
                           pwii0(:nprof,:nspec) = 0.
c---------------------------.
                           pwe0(:nprof) = 0.
                           pwc0(:nprof) = 0.
c----- Modified 10/16/91.
                           pwte0 = 0.
                           pwti0(:nspec) = 0.
                           if (kalfa > 0) then
                              pwtf0(:nalfa) = 0.
                              pwff0(:nprof,:nalfa) = 0.
                              pwc20(:nprof,:nalfa) = 0.
                           endif
c-------------------------
                        endif
                        curay(indgr) = 0.
c--------- SCC  3/27/92
                        pwiray(:nprof,:nspec,indgr) = pwi(:nprof,:nspec)
     1                      - pwii0(:nprof,:nspec)
                        pwii0(:nprof,:nspec) = pwi(:nprof,:nspec)
                        pwc1ray(:nprof,:nspec,indgr) = pwc1(:nprof,:
     1                     nspec) - pwc10(:nprof,:nspec)
                        pwc10(:nprof,:nspec) = pwc1(:nprof,:nspec)
c----------------------------
                        pweray(:nprof,indgr)=pwe(:nprof)-pwe0(:nprof)
                        pwcray(:nprof,indgr)=pwc(:nprof)-pwc0(:nprof)
                        pwe0(:nprof) = pwe(:nprof)
                        pwc0(:nprof) = pwc(:nprof)
                        if (kalfa > 0) then
                           pwfray(:nprof,:nalfa,indgr) = pwal(:nprof,:
     1                        nalfa) - pwff0(:nprof,:nalfa)
                           pwff0(:nprof,:nalfa) = pwal(:nprof,:nalfa)
                           pwc2ray(:nprof,:nalfa,indgr) = pwc2(:nprof,:
     1                        nalfa) - pwc20(:nprof,:nalfa)
                           pwc20(:nprof,:nalfa) = pwc2(:nprof,:nalfa)
                        endif
c---------Modified 0n 10/16/91.
                        fpwray(indgr) = (spower(1)-pwx)/spower(1)
                        if (fpwray(indgr) >= 1.E-12) then
                           fpowe(indgr) = (pwtote - pwte0)/(spower(1)-
     1                        pwx)
                           frpowi(indgr) = 0.
                           fpowi(:nspec,indgr) = (pwtoti(:nspec)-pwti0(:
     1                        nspec))/(spower(1)-pwx)
                           frpowi(indgr) = frpowi(indgr) + sum(fpowi(:
     1                        nspec,indgr))
                           if (kalfa > 0) then
                              frpowf(indgr) = 0.
                              fpowf(:nalfa,indgr) = (pwtotf(:nalfa)-
     1                           pwtf0(:nalfa))/(spower(1)-pwx)
                              frpowf(indgr) = frpowf(indgr) + sum(fpowf(
     1                           :nalfa,indgr))
                           endif
                           frpow(indgr) = fpowe(indgr) + frpowi(indgr)
     1                         + frpowf(indgr)
                           if (frpow(indgr) >= 1.E-14) then
c     if(fpowe(indgr).lt.1.e-14) go to 56
                              pweray(:nprof,indgr) = pweray(:nprof,indgr
     1                           )/fpwray(indgr)
                              pwcray(:nprof,indgr) = pwcray(:nprof,indgr
     1                           )/fpwray(indgr)
c--------------         SCC  3/27/92
                              pwiray(:nprof,:nspec,indgr) = pwiray(:
     1                           nprof,:nspec,indgr)/fpwray(indgr)
                              pwc1ray(:nprof,:nspec,indgr) = pwc1ray(:
     1                           nprof,:nspec,indgr)/fpwray(indgr)
c---------------------------.
                              if (kalfa > 0) then
                                 pwc2ray(:nprof,:nalfa,indgr) = pwc2ray(
     1                              :nprof,:nalfa,indgr)/fpwray(indgr)
                                 pwfray(:nprof,:nalfa,indgr) = pwfray(:
     1                              nprof,:nalfa,indgr)/fpwray(indgr)
                              endif
                           endif
                        endif
c-----------------------------------
c$$$$$$$$$$$$$$$   TK MAU  9/3/92
c--------Driven current (MA) for each ray for 100% absorption

c     dra = 1./float(nprof-1)
c     ajold = tzpi*pqr(1,1)*pwcray(1,indgr)*bttra(1)
c    1 /bttra2(1)*dpsifra(1)
c     do 51 ij = 2,nprof
c     ajnew = tzpi*pqr(ij,1)*pwcray(ij,indgr)*bttra(ij)/
c    2 bttra2(ij)*dpsifra(ij)
c     curay(indgr) = curay(indgr)+0.5e-2*(ajnew+ajold)*dra
c     ajold = ajnew
c51    continue
                        curay(indgr) = curay(indgr) + sum(0.5*(pwcray(2:
     1                     nprof,indgr)*zsurf(2:nprof)+pwcray(:nprof-1,
     2                     indgr)*zsurf(:nprof-1))*1.E-2)
c-----Modified on 10/16/91.
                        effcd(indgr) = curay(indgr)/spower(1)
                        pwte0 = pwtote
                        pwti0(:nspec) = pwtoti(:nspec)
                        pwtf0(:nalfa) = pwtotf(:nalfa)
c $$$$$$$$$$$$$$$$$$$$$$$$$
                        pwtra(isign,n) = pwtra(isign,n) + pwx
c $$$$$  Added by TK Mau on 11/18/91
                        if (iprint < 0) call outrun (3)
c $$$$$$$$$$$$$$$$$$$$
c*****************************SCC  12/21/95
                        call rayinout (2)
c********************************************
                     endif
                  end do
c  Should check on restart operation of pwtra (091289:bh)
c
               endif
            end do
c
         endif
      end do
c
c $$$$$$$$$$Added by T.K. Mau on Oct. 10, 1991.
c---------------SCC 3/27/92
      pwe(:nprof) = 0.
      pwc(:nprof) = 0.
      pwi(:nprof,:nspec) = 0.
      do iray = 1, indgr
         pwe(:nprof) = pwe(:nprof) + pweray(:nprof,iray)
      end do
      do iray = 1, indgr
         pwc(:nprof) = pwc(:nprof) + pwcray(:nprof,iray)
      end do
      do iray = 1, indgr
         pwi(:nprof,:nspec) = pwi(:nprof,:nspec) + pwiray(:nprof,:nspec,
     1      iray)
      end do
c----------------------------
c ---- Do minority and fast ion current accounting;  TK Mau  4/19/94
      currf1 = 0.
      currf2 = 0.
      if (nminor > 0) then
         do k = nsp1 + 1, nspec
            curay1(k) = 0.
            do ip = 1, nprof
               pwc1(ip,k) = 0.
               pwc1(ip,k) = pwc1(ip,k) + sum(pwc1ray(ip,k,:indgr))
               if (ip /= 1) curay1(k) = curay1(k) + 0.5E-2*(pwc1(ip,k)*
     1            zsurf(ip)+pwc1(ip-1,k)*zsurf(ip-1))
            end do
            currf1 = currf1 + curay1(k)
         end do
         do i1 = 1, nprof
            pwct1(i1) = 0.
            pwct1(i1) = pwct1(i1) + sum(pwc1(i1,nsp1+1:nspec))
         end do
      endif
      if (kalfa > 0) then
         do k = 1, nalfa
            curay2(k) = 0.
            do ip = 1, nprof
               pwal(ip,k) = 0.
               pwc2(ip,k) = 0.
               pwal(ip,k) = pwal(ip,k) + sum(pwfray(ip,k,:indgr))
               pwc2(ip,k) = pwc2(ip,k) + sum(pwc2ray(ip,k,:indgr))
               if (ip /= 1) curay2(k) = curay2(k) + 0.5E-2*(pwc2(ip,k)*
     1            zsurf(ip)+pwc2(ip-1,k)*zsurf(ip-1))
            end do
            currf2 = currf2 + curay2(k)
         end do
         do i2 = 1, nprof
            pwct2(i2) = 0.
            pwct2(i2) = pwct2(i2) + sum(pwc2(i2,:nalfa))
         end do
      endif
c----------------------------
      do ip = 1, nprof
         pwit(ip) = 0.
         pwit(ip) = pwit(ip) + sum(pwi(ip,:nspec))
         pwft(ip) = 0.
         pwft(ip) = pwft(ip) + sum(pwal(ip,:nalfa))
      end do
      ptedge = 0.
      currfe = 0.
      currfe = sum(curay(:indgr))
      ptedge = sum(pwedge(:indgr))
c $$$$$ Added by T.K. Mau on 10/16/91.
      tpowi = 0.
      tpowi = sum(pwtoti(:nspec))
      tpowf = 0.
      tpowf = sum(pwtotf(:nalfa))
      ptot0 = 0.
      ptot = pwtote + tpowi + tpowf + ptedge
      isign = 1
      if (isimm > 0) then
         ptot0 = sum(powers(:isimm))
         isign = isimm + 1
      endif
      if (inf == (-2)) return
      ftpowe = pwtote/ptot
      ftpowi(:nspec) = pwtoti(:nspec)/ptot
      ftpowf(:nalfa) = pwtotf(:nalfa)/ptot
      ftpf = tpowf/ptot
      ftpi = tpowi/ptot
      ftedge = ptedge/ptot
      fpowt = ptot/ptot0
c $$$$$  TK Mau   4/19/94
c     Total driven current for 100% absorption
      do ir = 1, nprof
         pwct(ir) = pwc(ir)
         if (nminor > 0) then
            pwct(ir) = pwct(ir) + sum(pwc1(ir,nsp1+1:nspec))
         endif
         if (kalfa > 0) then
            pwct(ir) = pwct(ir) + sum(pwc2(ir,:nalfa))
         endif
      end do
      currf = currfe + currf1 + currf2
      effcdt = currf/ptot0
c $$$$$  Added by TK Mau on 10/29/91.
c     Total driven current for 100% absorption
c     do 65 ir = 1,nprof
c     pwct(ir) = 0.
c     do 65 iq = 1,indgr
c  65 pwct(ir) = pwct(ir)+pwcray(ir,iq)
c************************SCC 4/13/95
c $$$$$  Altered by TK Mau on 05/95
c     Total driven current profile for 100% absorption
c ---- Calculate <j.B>_cd and <j_tor>_cd
c                                                ! A-T/m**2
      ajrfb(:nprof) = 1.E4*pwct(:nprof)*dbt1(:nprof)
c     pwct(ir) = ajrfb(ir)*bttra(ir)/dbt2(ir)   ! A/m**2
      pwiv(0,:nspec) = 0.
      pwev(0) = 0.
      do ip = 1, nprof
         pwev(ip) = pwev(ip-1) + pwe(ip)*volume(ip)
         pwiv(ip,:nspec) = pwiv(ip-1,:nspec) + pwi(ip,:nspec)*volume(ip)
      end do
c ----  TKM   05/02
      go to 555
c $$$$     TKM   06/97     for ARIES study
c     Calculate power reqd. for driving forward seed current on axis.
      if (irayio <= 0) then
         if (ioread <= 0) then
            if (islofa < 0) then
               powrq = abs(aiseed(1)/effcdt)
            else
               powrq = abs(aiseed(1)/effcdt)
            endif
c     Recalculate RF absorbed power and driven current profiles
            pwe(:nprof) = (powrq/ptot0)*pwe(:nprof)
            pwit(:nprof) = (powrq/ptot0)*pwit(:nprof)
            pwct(:nprof) = (powrq/ptot0)*pwct(:nprof)
            pwft(:nprof) = (powrq/ptot0)*pwft(:nprof)
            ajrfb(:nprof) = (powrq/ptot0)*ajrfb(:nprof)
            ajdrv(:nprof) = ajbst(:nprof) + pwct(:nprof)
         endif
      endif
c $$$$$$$$$$$$$$$$$$$$$$$
 555  continue
c ----  05/02
c*********************************SCC  12/21/95
      call rayinout (3)
c**********************************************
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      return
c ************ ************ ************ ************ ************
 1000 format('0',
     1   "===========================================================")
 1010 format('0',/,45x,"------- n parallel =",f9.4," -------",/)
c ************ ************ ************ ************ ************
      end subroutine raytr

      subroutine zeros
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:58:46   6/14/01
C...Switches: -p4 -yb
c
c  zero out the s-variables
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
      use Vparam
      use Vcgraphs, ONLY: seikon, spsi, sxu, szu, skp, skpar, spower,
     1   sdpwri, sphi, stheta, spol, sdkpar, scepx, scepy, scepz,
     2   sztpol, sbtot, sene, salphac, salphal, sjslofa, serrors,
     3   spkpsi, sakpsi, sakth, swkve, jjslofa, sne, ste, sqr, spw,
     4   sxh, sqte, sni, sti, sdeqs, spwer, spwmax, srtor, srplas,
     5   sdenc, stec, sqc, sqa, sbaxis, scurr, sfreq, satm, sazi,
     6   sconc, stic, sxpage, sypage, slenx, sleny, sdelx, sfirtx,
     7   sdely, sfirty, symax, symin, skth, skphi, skpsi, sxx, jslofas,
     8   nurefls, keiks, jpes, jpis, istarts, iprmt5, jhlfs, isimpl,
     9   isimpl0, ngr, nps, nspie, kgraph, kprof, newgra, jksym,
     .   lintyp, nxvarb, nyvarb, kwfr
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------

      seikon = 0
      spsi = 0
      sxu = 0
      szu = 0
      skp = 0
      skpar = 0
      stheta = 0
      sphi = 0
      spower = 0
      sbtot = 0
      sene = 0
      salphac = 0
      salphal = 0
      sdpwri = 0
      spol = 0
      sdkpar = 0
      scepx = 0
      scepy = 0
      scepz = 0
      sztpol = 0
      sjslofa = 0
      serrors = 0
      return
      end subroutine zeros

      subroutine setdflt
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:02:43   6/14/01  
C...Switches: -p4 -yb
c--------------------------
c  set default values of variables
c----------------------------
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
      use Vparam
      use Vsizes
      use Vceqdsk
      use Vcfdamp
      use Vchpcsd
      use Vcmnew
      use Vcraylh
      use Vcgraphs
      use Viogrl
      use Viorlh
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: nspi0
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i
 
c
c  Comfdamp
c
c
c
c   Comhpcsd
c
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1
 
 
c******      TKM   03/97, 09/99, 04/00, 06/00
c********************
 
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c----------------------------
c   common blocks of Cmgraphs
c
 
c    2   ,sqti(nprofm)
c------------ --------------
c   common blocks of Comiogrl
c---------------------------
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
      integer j1
c
c Comeqdsk
      ieqdsk = 0
      dat = '120996'
      ipestg = 3
      nxeqd = 33
      nzeqd = 65
      psiadj = 0.
      imodeq = 1
      liw = 4
      lw = 40
      ifail = 1
      nptsd = 181
      dang = 4.
      bperr = largest  ! was 1.e100 See notes at beginning of miscl.f
      arcl = largest   ! was 1.e100 See notes at beginning of miscl.f
      nti = 1
      inoperm1 = inoperm
      nptsdm1 = nptsdm
c
c  Comfdamp
      inf = 0
      enorm = 300.
      nint = 100
      nmax1 = 0
      bmax = 10.
      rtail = 0.
      r1t = 0.1
      r2t = 0.2
      ttail = 20.
      rhot = 0.
      r1h = 0.1
      r2h = 0.2
      thotpar = 5.
      thotper = 5.
      hotexp = 5.
      hotmnpar = 0.
      hotmxpar = largest                         ! was 1.e100
      hotmnper = 0.
      hotmxper = largest                         ! was 1.e100
      rbeam = 0.
      r1b = 0.1
      r2b = 0.2
      tbeam = 0.06
      ebeam = 1.
      thbeam = 30.
      inname = 'dskout'
      ifbilin = 1
      ifirstb = 1
      besdel = 1.E-4
c
c  Comhpcsd
c
      klim = 1000
      irecmx = 100000
c
c  Comnew
c
      npar = 101
      nper = 101
      intg = 501
      tnmaxe = 20.
      tnmaxi = 20.
      vloop = 0.
      kboot = 0
c
c   Comraylh
c
      phi0 = 0.
      dpwri = 0.
      dpwrf = 0.
      idmpsw = 0
      scatd = 0.
      iscat0 = 0
      alpha1 = 0.
      alpha2 = 0.
      solrfl = 0.5
      accur = 1.E-5
      psimn = 1.E-4
      psimx = 0.9001
      nspi0 = 10
      nthp0 = 1000
      nmax = 100
      imax = 100
      lmax = 5
      nwp = 51
      umax1 = 10.
      tmax = 700
      wpmx = 5.05E0
      wpmn = 0.5E-1
      nthp1 = 61
      iswchi = 0
      aerrmx = 1.E-5
      rerrmx = 2.E-6
      icurdr = 0
      idcur = 2
c
c   Cmgraphs
c
      nraypts = 500
c
c   Comiogrl
c
      ndim0 = 1000
      ndim1 = 999
      itrans = 0
c
c   Comiorlh
c
      versid = '120996'
      epser1 = 0.025
      epspfw = 1.E-6
      epspsw = 1.E-6
      nharm = 0
      isafa = 0
      qsaf0 = 1.05
      qsafa = 5.5
!      nprofn = nprofm
      nprofs = 20
      nprof = 20
      iedge = 0
      nspect = 1
      specfac = 0.5
      irayio = 0
      psistep = 0.
      pkexpnt = 0.
      nequip = 50
      indvar = 1
      gamene = 2.
      alpene = 0.5
      gamte = 2.
      alpte = 2.
      gamti = 2.
      alpti = 2.
c************    TKM   2/97
      presfr = 1.
      ffast = 0.
      frcne = 1.
      frcte = 1.
      frcti = 1.
      gamene1 = 1.
      alpene1 = 1.
      gamte1 = 1.
      alpte1 = 1.
      gamti1 = 1.
      alpti1 = 1.
c*************************************
c
c   cmnew
c
      npar = 101
      nper = 101
      intg = 501
      inc = 1
      incf = 1
      tnmaxe = 20.
      tnmaxi = 20.
      vloop = 0.
      btbsp = 1.0
      ftbsps = 1.0
c
      trate = 1.
      tratte = 1.
      ttle = 5.
      trati(:3) = 1.
      tratti(:3) = 1.
      ttli(:3) = 5.
      return 
      end subroutine setdflt

      subroutine hpcsd(funct, output)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:38:46   6/15/01
C...Switches: -p4 -yb
c
c *********************************************************************

c      This subroutine appears to be a modified version of an
c      ibm subroutine hpcs.

c
c     description of parameters
c           prmt(1)    - lower bound of the interval (input).
c           prmt(2)    - upper bound of the interval (input).
c           prmt(3)    - initial increment of the independent variable
c                        (input).
c           prmt(4)    - upper error bound (input). if absolute error
c                        is greater than prmt(4), increment gets halved
c                        if increment is less than prmt(3) and absolute
c                        error less than prmt(4)/50, increment gets
c                        doubled. the user may change prmt(4) by means
c                        of his output subroutine
c           prmt(5)    - no input parameter. subroutine hpcsd initiali-
c                        zes prmt(5) to zero. if the user wants to ter-
c                        minate subroutine hpcsd at any output point he
c                        has to change prmt(5) to non-zero by means of
c                        subroutine output.
c                        =-1   ray reflected
c                        =-2   ray hitting axis
c                        = 1   ray terminated
c           prmt(6)    - = 1   ray refreshed
c                        =-1   ray initial increment h halved
c           y          - input vector of initial values (destroyed).
c                        later on y is the resulting vector of depen-
c                        dent variables y computed at the intermediate
c                        points x.
c           dy         - input vector of error weights (destroyed),
c                        the sum of its components must be equal to 1.
c                        (The weights could be chosen proportional to
c                         typical values of the dependent variable.  Bob H).
c                        later on dy is the vector of the derivatives
c                        which belong to function values y at point x.
c           hlast      - output containing the current value of the
c                        indep. variable step
c           ndim       - an input value which specifies the number of
c                        equations in the system.
c           jhlf       - an output value which specifies the number of
c                        bisections of the initial increment. if jhlf
c                        gets greater than 20, subroutine hpcsd returns
c                        with error message jhlf=21 to main program.
c                        error message jhlf=22 or jhlf=23 appears in
c                        case prmt(3)=0 or in case sign(prmt(3)).ne.
c                        sign(prmt(2)-prmt(1)) respectively.
c           ind        - if ind >= 0 test is made on absolute error
c                        if ind < 0 test is made on relative error
c                        (I believe ind >=0 indicates relative error.
c                         See line 175 ff.  BobH 050791).
c           funct      - the name of an external subroutine used. it
c                        computes the right hand side dy of the system
c                        to given values of x and y. its parameter list
c                        is x. furthermore it must contain the labeled
c                        common/chpcsd/prmt(5),y(*),dy(*),w(16,*),ndim
c                        ,jhlf. this subroutine should not destroy:
c                        x,y,w,ndim,jhlf.
c           output     - the name of an external output subroutine used
c                        its parameter list is x. furthermore it must
c                        contain the labeled common/chpcsd/prmt(5),y(*)
c                        ,dy(*),w(16,*),ndim,jhlf. none of these para-
c                        meters (except prmt(4), prmt(5), if necessa-
c                        ry) should be changed by subroutine output. if
c                        prmt(5) is changed to non-zero, subroutine
c                        hpcsd is terminated
c
c
c     remarks
c           the procedure terminates and returns to calling program if
c           1) more than 20 bisections of the initial increment are
c              necessary to get satisfactory accuracy (error message
c              jhlf=21).
c           2) initial increment is equal to zero or has wrong sign
c              (error messages jhlf=22 or 23 respectively).
c           3) the whole integration interval is worked through.
c           4) subroutine output has changed prmt(5) to non-zero.
c
c
c *********************************************************************
c  SCC 10/20/94      2/7/95
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
      use Vsizes
      use Vchpcsd
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
C-----------------------------------------------
C   C o m m o n   B l o c k s
C-----------------------------------------------
C...  /chpcsd/
!      common /chpcsd/ prmt(6), y(10), dy(10), dy6o, hlast, ndim, jhlf,
!     1   ind, serror, psilast, yin(10), dyin(10), mcnt, h, klim, irecmx
!      integer   ndim, jhlf, ind, mcnt, klim, irecmx
!      real   prmt, y, dy, dy6o, hlast, serror, psilast, yin, dyin, h
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: k0, n, k1, jsw, k2, k3, k4, k5, k6, k7, kcnt, k8, k9,
     1   l0, icnt, l1, l2, l3, l4, jstep, l6, l5, l7, l8, l9, m0, l10,
     2   jmod, m1, m2, m3, m4, l11
      real(kind=dp), dimension(40) :: ck
      real(kind=dp), dimension(16,10) :: w
      real(kind=dp), dimension(6) :: y0
      real(kind=dp) :: hlim, x, delta, q, ynorm, x0, t, qdelta, q1, q2
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
C      EXTERNAL funct, output
C-----------------------------------------------
c--------yin & dyin store initial y's and dy's
c----------SCC 3/2/95    5/5/95    add h,klim,irecmx
c
c    +              hlast,          ndim,           jhlf,
c *********************************************************************
c
c
c *********************************************************************
c
      data ck/.0E0, .5E0, .66666666666667E0, .375E0, .79166666666667E0,
     1   .20833333333333E0, .41666666666667E-1, .33333333333333E0, .4E0
     2   , .29697760924775E0, .15875964497103E0, .45573725421879E0,
     3   .21810038822592E0, .30509651486929E1, .38328647604670E1,
     4   .17476028226269E0, .55148066287873E0, .12055355993965E1,
     5   .17118478121952E0, .13333333333333E1, .92561983471074E0, .125E0
     6   , .9E1, .3E1, .74380165289256E-1, .01E0, .2E-1,
     7   .89629629629630E1, .33611111111111E1, .390625E-2, .8E2, .135E3
     8   , .4E2, .1171875E0, .6E1, .2E1, .12E2, .108E3, .234375E-1,
     9   .18E2/
c
c *********************************************************************
c
      mcnt = 0
      yin(:ndim+1) = y(:ndim+1)
      dyin(:ndim+1) = dy(:ndim+1)
c-------------SCC 5/5/95
      hlim = abs(prmt(2)-prmt(1))/klim
c---------------------
  400 continue
      mcnt = mcnt + 1
      y(:ndim+1) = yin(:ndim+1)
      dy(:ndim+1) = dyin(:ndim+1)
      n = 1
      jhlf = 0
      x = prmt(1)
      h = prmt(3)/2.**(mcnt - 1)
      prmt(5) = ck(1)
      prmt(6) = ck(1)
      w(16,:ndim) = ck(1)
      w(15,:ndim) = dy(:ndim)
      w(1,:ndim) = y(:ndim)
      if (h*(prmt(2)-x) >= 0.) then
         if (h*(prmt(2)-x) > 0.) go to 3
         jhlf = 22
         go to 3
      endif
      jhlf = 23
c
c           computation of dy for starting values
c           -------------------------------------
    3 continue
      call funct (x)
c********************SCC  10/20/94
      dy6o = dy(6)
c**********************************
c
c           recording of starting values
c           ----------------------------
      call output (x)
      if (prmt(5) == 0.) then
         if (jhlf <= 0) go to 6
      endif
    5 continue
      return
c     <><><>
    6 continue
      w(8,:ndim) = dy(:ndim)
c
c           computation of w(2,k2)
c           ----------------------
c************************SCC  1/16/95
      if (h*(x + 3.*h - prmt(2)) > 0.) h = (prmt(2)-x)/
     1   3.99999999999999999
c**********************************
      jsw = 1
      go to 21
    7 continue
      x = x + h
      w(2,:ndim) = y(:ndim)
c
c           increment is tested by means of bisection
c           -----------------------------------------
    8 continue
      jhlf = jhlf + 1
      x = x - h
      w(4,:ndim) = w(2,:ndim)
      h = h*ck(2)
      hlast = h
      n = 1
      jsw = 2
      go to 21
    9 continue
      x = x + h
      call funct (x)
      n = 2
      w(2,:ndim) = y(:ndim)
      w(9,:ndim) = dy(:ndim)
      jsw = 3
      go to 21
c
c           computation of test value delta.
c           --------------------------------
c           q is an auxiliary storage location.
   10 continue
      delta = ck(1)
      do k5 = 1, ndim
         q = y(k5) - w(4,k5)

c     There can be a problem when a dependent variable is near zero.
c     y(k5) may become smaller in proportion to reduction of the
c     step size, and the relative error will not become smaller
c     (may become constant) as the step size is halved.
c     This is accounted for in the following modification, by
c     the indicated replacement:

c                        if(ind.gt.0.and.y(k5).ne.ck(1)) q=q/y(k5)

         if (w(15,k5) == 0.0) then
            ynorm = largest                      ! was 1.e100
         else
            ynorm = abs(prmt(4)/w(15,k5))
         endif
         ynorm = max(ynorm,abs(y(k5)))
         if (ind>0 .and. y(k5)/=ck(1)) q = q/ynorm
         if (q <= ck(1)) q = -q
         delta = delta + w(15,k5)*q
      end do
      delta = delta*ck(3)
      if (delta - prmt(4) <= 0.) go to 14
      if (jhlf - 20 < 0) go to 8
      jhlf = 21
      x = x + h
      go to 3
c
c           there is satisfactory accuracy after < 11 bisections
c           ----------------------------------------------------
   14 continue
      x = x + h
      call funct (x)
      w(3,:ndim) = y(:ndim)
      w(10,:ndim) = dy(:ndim)
      n = 3
      jsw = 4
      go to 21
   15 continue
      n = 1
      x = x + h
      call funct (x)
      x = prmt(1)
      w(11,:ndim) = dy(:ndim)
      y(:ndim) = w(1,:ndim) + h*(ck(4)*w(8,:ndim)+ck(5)*w(9,:ndim)-ck(6)
     1   *w(10,:ndim)+ck(7)*dy(:ndim))
      if (y(2) <= 5.E-4) prmt(5) = -2.
      if (prmt(5) /= 0.) go to 5
   16 continue
      x = x + h
      n = n + 1
      call funct (x)
c*****************************SCC 10/20/94
      y(6) = y(6) + h*(dy6o + dy(6))/2.
      dy6o = dy(6)
c****************************  SCC  5/5/95
      kcnt = 0
c*************************
      call output (x)
      if (prmt(6) > 0.) go to 5
      if (prmt(6) < 0.) go to 400
      if (prmt(5) /= 0.) go to 5
      if (n - 4 >= 0) go to 22
      w(n,:ndim) = y(:ndim)
      w(n+7,:ndim) = dy(:ndim)
      if (n - 3 > 0) go to 22
      if (n - 3 == 0) go to 20
      do k9 = 1, ndim
         delta = w(9,k9) + w(9,k9)
         delta = delta + delta
         y(k9) = w(1,k9) + ck(8)*h*(w(8,k9)+delta+w(10,k9))
      end do
      if (y(2) <= 5.E-4) prmt(5) = -2.
      if (prmt(5) == 0.) go to 16
      go to 5
c                        go to 16
   20 continue
      do l0 = 1, ndim
         delta = w(9,l0) + w(10,l0)
         delta = delta + delta + delta
         y(l0) = w(1,l0) + ck(4)*h*(w(8,l0)+delta+w(11,l0))
      end do
      if (y(2) <= 5.E-4) prmt(5) = -2.
      if (prmt(5) == 0.) go to 16
      go to 5
c                        go to 16
c
c     the following part of the subroutine hpcsd computes by means of
c     a runge-kutta method starting values for the not self-starting
c     predictor-corrector method. t is an auxiliary storage location.
c
c**********************SCC 2/17/95
   21 continue
      icnt = 0
   64 continue
      icnt = icnt + 1
      x0 = x
      y0(:ndim) = y(:ndim)
      do l1 = 1, ndim
         t = h*w(n+7,l1)
         w(5,l1) = t
         y(l1) = w(n,l1) + ck(9)*t
      end do
      if (y(2) <= 5.E-4) prmt(5) = -2.
      if (prmt(5) /= 0.) go to 5
      if (y(2) < psilast) then
         t = x + ck(9)*h
         call funct (t)
         do l2 = 1, ndim
            t = h*dy(l2)
            w(6,l2) = t
            y(l2) = w(n,l2) + ck(10)*w(5,l2) + ck(11)*t
         end do
         if (y(2) <= 5.E-4) prmt(5) = -2.
         if (prmt(5) /= 0.) go to 5
         if (y(2) < psilast) then
            t = x + ck(12)*h
            call funct (t)
            do l3 = 1, ndim
               t = h*dy(l3)
               w(7,l3) = t
               y(l3)=w(n,l3)+ck(13)*w(5,l3)-ck(14)*w(6,l3)+ck(15)*t
            end do
            if (y(2) <= 5.E-4) prmt(5) = -2.
            if (prmt(5) /= 0.) go to 5
            if (y(2) < psilast) then
               t = x + h
               call funct (t)
               y(:ndim) = w(n,:ndim) + ck(16)*w(5,:ndim) - ck(17)*w(6,:
     1            ndim) + ck(18)*w(7,:ndim) + ck(19)*h*dy(:ndim)
            endif
         endif
      endif
      if (y(2)>=psilast .or. icnt>=2) then
         if (icnt>=3 .or. abs(y(2)-psilast)<1.E-3) go to 63
         h = (psilast - y0(2))*h/(y(2)-y0(2))
         y(:ndim) = y0(:ndim)
         call funct (x0)
         x = x0
         go to 64
   63    continue
         prmt(5) = -1
      endif
c
c           possible break-point for linkage
c           --------------------------------
      if (y(2) <= 5.E-4) prmt(5) = -2.
      if (prmt(5) /= 0.) go to 5
      go to (7,9,10,15,41) jsw
c
c********************************
c
c
c     starting values are computed. now starts hamming"s modified
c     -----------------------------------------------------------
c     predictor-corrector method.
c     ---------------------------
   22 continue
      jstep = 3
   23 continue
      if (h*(x + h - prmt(2)) < 0.) then
         if (n - 8 == 0) then
            w(:6,:ndim) = w(2:7,:ndim)
            w(8:13,:ndim) = w(9:14,:ndim)
            n = 7
c
c           n<8 causes n+1 to get n
c           -----------------------
         endif
         n = n + 1
c
c           computation of next vector y
c           ----------------------------
         w(n-1,:ndim) = y(:ndim)
         w(n+6,:ndim) = dy(:ndim)
         x = x + h
   26    continue
         jstep = jstep + 1
         do l8 = 1, ndim
            delta = w(n-4,l8) + ck(20)*h*(w(n+6,l8)+w(n+6,l8)-w(n+5,l8)+
     1         w(n+4,l8)+w(n+4,l8))
            y(l8) = delta - ck(21)*w(16,l8)
            w(16,l8) = delta
         end do
c
c           predictor is now generated in row 16 of w, modified predic-
c           tor is generated in y. delta means an auxiliary location.
c           the derivatives of the modified predictor will now be gene-
c           rated in dy.
         if (y(2) <= 5.E-4) prmt(5) = -2.
         if (prmt(5) /= 0.) go to 5
         call funct (x)
         do l9 = 1, ndim
            delta = ck(22)*(ck(23)*w(n-1,l9)-w(n-3,l9)+ck(24)*h*(dy(l9)+
     1         w(n+6,l9)+w(n+6,l9)-w(n+5,l9)))
            w(16,l9) = w(16,l9) - delta
            y(l9) = delta + ck(25)*w(16,l9)
         end do
c
c           test whether h must be halved or doubled
c           ----------------------------------------
         if (y(2) <= 5.E-4) prmt(5) = -2.
         if (prmt(5) /= 0.) go to 5
         delta = ck(1)
         do m0 = 1, ndim
            q = w(16,m0)
c                        if(ind.gt.0.and.y(m0).ne.ck(1)) q=q/y(m0)

            if (w(15,m0) == 0.0) then
               ynorm = largest                   ! was 1.e100
            else
               ynorm = abs(prmt(4)/w(15,m0))
            endif
            ynorm = max(ynorm,abs(y(m0)))
            if (ind>0 .and. y(m0)/=ck(1)) q = q/ynorm

            if (q < ck(1)) q = -q
            delta = delta + w(15,m0)*q
         end do
         if (delta - prmt(4) >= 0.) go to 38
   27    continue
         call funct (x)
c*****************************SCC 10/20/94
         y(6) = y(6) + h*(dy6o + dy(6))/2.
         dy6o = dy(6)
c****************************
         call output (x)
c******************SCC  5/5/95
         if (abs(h) < hlim) then
            kcnt = kcnt + 1
            if (kcnt > klim) prmt(5) = -3
         endif
c**************************
c               if (y(2).lt.0.98)         call mflag(6)
         if (prmt(6) /= 0.) go to 5
         if (prmt(5) /= 0.) go to 5
         if (jhlf - 21 >= 0) go to 5
         go to 30
   29    continue
         qdelta = (x - prmt(2))/h
         if (abs(qdelta) > ck(26)) go to 40
         y(:ndim) = y(:ndim) + qdelta*(w(n-1,:ndim)-y(:ndim))
         if (y(2) <= 5.E-4) prmt(5) = -2.
         if (prmt(5) /= 0.) go to 5
         x = x - h*qdelta
         call funct (x)
c*****************************SCC 10/20/94
         y(6) = y(6) + h*(dy6o + dy(6))/2.
         dy6o = dy(6)
c****************************
         call output (x)
         return
   30    continue
         if (h*(x - prmt(2)) >= 0.) go to 29
         q1 = x - prmt(2)
         if (q1 < ck(1)) q1 = -q1
         q2 = h
         if (q2 < ck(1)) q2 = -q2
         if (q1 - ck(26)*q2 < 0.) go to 29
         if (delta - ck(27)*prmt(4) > 0.) go to 23
         if (jhlf <= 0) go to 23
         if (n - 7 < 0) go to 23
         if (jstep - 4 < 0) go to 23
         jmod = jstep/2
         if (jstep - jmod - jmod /= 0) go to 23
         h = h + h
         hlast = h
         jhlf = jhlf - 1
         jstep = 0
         do m1 = 1, ndim
            w(n-1,m1) = w(n-2,m1)
            w(n-2,m1) = w(n-4,m1)
            w(n-3,m1) = w(n-6,m1)
            w(n+6,m1) = w(n+5,m1)
            w(n+5,m1) = w(n+3,m1)
            w(n+4,m1) = w(n+1,m1)
            delta = w(n+6,m1) + w(n+5,m1)
            delta = delta + delta + delta
            w(16,m1) = ck(28)*(y(m1)-w(n-3,m1)) - ck(29)*(dy(m1)+delta+w
     1         (n+4,m1))*h
         end do
         go to 23
c
c           h must be halved
c           ----------------
   38    continue
         jhlf = jhlf + 1
         if (jhlf - 20 > 0) go to 27
         h = ck(2)*h
         hlast = h
         jstep = 0
         y(:ndim) = ck(30)*(ck(31)*w(n-1,:ndim)+(ck(32)*w(n-2,:ndim))+ck
     1      (33)*w(n-3,:ndim)+w(n-4,:ndim)) - ck(34)*h*(w(n+6,:ndim)-ck(
     2      35)*w(n+5,:ndim)-w(n+4,:ndim))
         w(n-4,:ndim) = ck(30)*(ck(37)*w(n-1,:ndim)+(ck(32)*w(n-2,:ndim)
     1      )+ck(38)*w(n-3,:ndim)+w(n-4,:ndim)) - ck(39)*(w(n+6,:ndim)+
     2      ck(40)*w(n+5,:ndim)-ck(23)*w(n+4,:ndim))*h
         w(n-3,:ndim) = w(n-2,:ndim)
         w(n+4,:ndim) = w(n+5,:ndim)
         if (y(2) <= 5.E-4) prmt(5) = -2.
         if (prmt(5) /= 0.) go to 5
         x = x - h
         delta = x - (h + h)
         call funct (delta)
         w(n-2,:ndim) = y(:ndim)
         w(n+5,:ndim) = dy(:ndim)
         y(:ndim) = w(n-4,:ndim)
         if (y(2) <= 5.E-4) prmt(5) = -2.
         if (prmt(5) /= 0.) go to 5
         delta = delta - (h + h)
         call funct (delta)
         do m4 = 1, ndim
            delta = w(n+5,m4) + w(n+4,m4)
            delta = delta + delta + delta
            w(16,m4) = ck(28)*(w(n-1,m4)-y(m4)) - ck(29)*(w(n+6,m4)+
     1         delta+dy(m4))*h
            w(n+3,m4) = dy(m4)
         end do
         go to 26
      endif
   40 continue
      jsw = 5
      h = prmt(2) - x
      w(1,:ndim) = y(:ndim)
      w(8,:ndim) = dy(:ndim)
      n = 1
      go to 21
   41 continue
      x = x + h
      call funct (x)
c*****************************SCC 10/20/94
      y(6) = y(6) + h*(dy6o + dy(6))/2.
      dy6o = dy(6)
c****************************
      call output (x)
      return
      end subroutine hpcsd

      subroutine mflag(n)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:38:46   6/15/01
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
      use Vsizes
!      USE Vcwavec
      use Vchpcsd
      use Vcraylh, only: akpsi, akth, anphi, pkpsi, pktau, pkphi,
     1    pkheta, pkx, pkz, pkpar, pkpar2, pkp, pkp2, pkp2x, pk
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer n
C-----------------------------------------------
C   C o m m o n   B l o c k s
C-----------------------------------------------
C...  /chpcsd/
!      common /chpcsd/ prmt(6), y(10), dy(10), dy6o, serror, psilast, yin
!     1   (10), dyin(10), hlast, ndim, jhlf, ind, mcnt, h, klim, irecmx
!      integer   ndim, jhlf, ind, mcnt, klim, irecmx
!      real   prmt, y, dy, dy6o, serror, psilast, yin, dyin, hlast, h
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
C-----------------------------------------------
c--------------------------
c  subroutine to set up flags to direct routing of the marching
c  routine. The flags are prmt(5:6)
c---------------------------
!      common/chpcsd/ prmt(6), y(10),dy(10),dy6o,hlast,
!     1               ndim,jhlf,ind,serror,psilast,yin(10),
!     2               dyin(10),mcnt,h,klim,irecmx
c
c
      select case (n)
      case default
         if (mcnt <= 12) then
            prmt(6) = -1.
         else
            prmt(5) = 1.
         endif
         return
      case (2)
         prmt(5) = -1.
         return
      case (3)
         prmt(5) = 1.
         return
      case (4)
         prmt(5) = 2.
         return
      case (5)
         prmt(6) = 1.
         return
      case (6)
c
c  Wake up ray
c
         if (abs(h) > 1.E-4) return
         if (abs(pkpsi)>0.1 .or. abs(pkheta)>0.1) then
            prmt(6) = 1.
            hlast = max(prmt(3)/2.0_dp,1.E-3_dp)
         else
            if (h*dy(2) > 0.) then
               prmt(5) = -1.
            else
               prmt(6) = 1.
               hlast = max(prmt(3)/2.0_dp,1.E-3_dp)
            endif
         endif
         return
      end select
      end subroutine mflag
      subroutine precrt(ss1, ss2, ier, kchois)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:38:46   6/15/01
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
      use Vsizes
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer ier, kchois
      real(kind=dp) ss1, ss2
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer, dimension(51) :: jss
      integer :: j, indic, jss0, js, jcnt
      real(kind=dp), dimension(101) :: ss3, dsp
      real(kind=dp) :: ddisp1, psign, dss0, dss3, disp1, disp2, ddisp2,
     1    ss0,
     1   disp0, ddisp0
C-----------------------------------------------
c-----------------------
c  root finding by bisection
c-----------------------
c
      do j = 1, 51
         ss3(j) = 0.90 + 0.004*j
         call sub2 (ss3(j), dsp(j), ddisp1, kchois)
      end do
      indic = 0
      do j = 1, 50
         psign = dsp(j)*dsp(j+1)
c------------------SCC   6/29/95
         if (psign <= 0.) then
            indic = indic + 1
            jss(indic) = j
         endif
c--------------------------
      end do
      if (indic == 0) then
         ier = 19
      else
c----------------------SCC   6/29/95
         jss0 = jss(1)
         dss0 = abs(1. - ss3(jss(1)))
         do js = 2, indic
            dss3 = abs(1. - ss3(jss(js)))
            if (dss3 < dss0) then
               jss0 = jss(js)
               dss0 = dss3
            endif
         end do
         ss1 = ss3(jss0)
         call sub2 (ss1, disp1, ddisp1, kchois)
         ss2 = ss3(jss0+1)
         call sub2 (ss2, disp2, ddisp2, kchois)
         do jcnt = 1, 20
            ss0 = 0.5*(ss1 + ss2)
            call sub2 (ss0, disp0, ddisp0, kchois)
            if (disp0*disp1 <= 0.) then
               ss2 = ss0
               disp2 = disp0
               ddisp2 = ddisp0
            else
               ss1 = ss0
               disp1 = disp0
               ddisp1 = ddisp0
            endif
         end do
      endif
      return
      end subroutine precrt

      subroutine sub4(pkp21, pkp22, pkp23, ind2, kslofa, jchois, kmcon,
     1   pkp20, iermc, disck2, a2k, nslofa, imode, tempe, xe,
     2   zxe2, cz, czp)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:38:46   6/15/01
C...Switches: -p4 -yb
c
c ************ ************ ************ ************ ************
c
c  check exact pkp2 for evanescence
c  jchois=1  high freq. dispersion
c        =2  cold plasma dispersion
c  kslofa: designates mode of current step; -1 cold FW, 1 cold SW, 2 WPW
c  nslofa designates the mode closest to the current branch;
c  nslofa is determined in sub4, while kslofa is input
c  if nslofa ne. kslofa, mode conversion has already taken place
c
c  pkp21: k-perp**2 of odd real root (zero if jchois=2)
c  pkp22,pkp23: paired k-perp**2 (mode conversion)
c  assumed all roots are real
c  ind2=0--fw-sw m-c; =1--sw-wp m-c
c  kmcon=0 no m-c in current step
c       =1 m-c in current step
c  pkp20: exact k-perp**2 of current step
c  if kmcon=1, pkp20 is set to appropriate mode-converted branch
c  if kmcon=0, pkp20 is set to current step
c  iermc: error flag to indicate wrong assignment of ind2 or kslofa
c        = n indicates error at kslofa=n
c        = 0 means no error
c  imode identifies mode# of pkp20 with (pkp21,2,3)
c---------------------------------
c-------July 5,1995.
c---------------------------
c
c ************ ************ ************ ************ ************
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
      use Vsizes
      use Vdissub
      use Vcmnew, only: wpe2, apzz, asxy, adxy, asxye, asxy1, adxy1
      use Vcraylh, only: akpsi, akth, anphi, pkpsi, pktau, pkphi,
     1    pkheta, pkx, pkz, pkpar, pkpar2, pkp, pkp2, pkp2x, pk,
     2    nions,  del0, delxp, del1, dhni, dhti, delm,
     3    disph, dhkp2, dhkz, dhne, dhte, dhom, ha, hb, hc, alfa,
     4    xx, eikon, psi, theta, ux, uz, urhs, xu, zu, acosth, asinth,
     5    acostq, asintq, phi, phi0, pwx, dpwri, dpwrf, dsperr


      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer ind2, kslofa, jchois, kmcon, iermc, nslofa, imode
      real(kind=dp) pkp21, pkp22, pkp23, pkp20, disck2, a2k, tempe, xe,
     1    zxe2, hzf
      complex cz, czp
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer, dimension(3) :: imd
      integer :: j, iout0
      real(kind=dp), dimension(5) :: cwork
      real(kind=dp), dimension(6) :: wrk
      real(kind=dp), dimension(3) :: wrk1
      real(kind=dp) :: zpi, zdsqpi, zcalf, rt3o2, pkpr11, pkpr21,
     1    zxmin, eps3r,
     1   eps3i, ceps3, aeps32, vte, pk2ms, wrk5, wrk9, wrk2, wrk3, wrk4
     2   , wrk6, a4, a2, a0, discr, dk22, dk23, cwork2, a6, bb0, bb1,
     3   bb2, qu1, rq1, ak2mx, ak2mn, dk2mn
      complex, dimension(6) :: cwrk
      complex :: cai
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c ********************************************************************
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c  7/10/91   T.K. Mau
c  Complex and real array declaration for ICRF damping
c

c
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c
c ************ ************ ************ ************ ************
c
      data zpi/3.14159265359/
      data zdsqpi/1.77245385/
      data zcalf/3.198E-6/
      data rt3o2/0.86602540/
      data cai/(0.,1.)/
c
c ************ ************ ************ ************ ************
c
c-----------------------------
c  6/25/91

      iermc = 0
      imd = 0
      pkpr11 = pktau*asintq + pkphi*acostq
      pkpr21 = pkpr11*pkpr11

      select case (jchois)
      case default
         xe = 15.984/(abs(pkpr11)*sqrt(tempe))
         zxmin = abs(xe)
         zxe2 = xe*xe
c         call zfun(0,xe,cz,czp,zfn,zfc,xzz,nptzf,nptzfa,hzf,iout0)
         call zfun(xe, cz, czp)
         eps3r = 2.*wpe2*zxe2*(1. + xe*real(cz))
         eps3i = 2.*wpe2*zxe2*xe*aimag(cz)
         ceps3 = 2.*wpe2*zxe2*(1. + xe*cz)
         aeps32 = eps3r*eps3r + eps3i*eps3i
         vte = 0.0625*sqrt(tempe)
         del1 = pkpr11*delxp
         delm = asxye*vte**2*xe*cz
         pk2ms = pkpr21 - asxy1
         wrk5 = real(delm)
         wrk9 = real((1. - wrk5)/ceps3)
         wrk2 = real(1./ceps3)
         wrk3 = 1. + del0
         wrk4 = pkpr21*wrk3*wrk3 - pk2ms
         wrk6 = adxy1*adxy1 - pk2ms*pk2ms + pkpr21*wrk3*wrk3*pk2ms
         a4 = wrk4*wrk9
         a2 = pk2ms*(1. + del1*del1*eps3r - wrk5) - 2.*pkpr11*del1*wrk3*
     1      adxy1 + wrk6*wrk2
         a0 = pk2ms**2 - adxy1**2
         discr = a2**2 - 4.*a4*a0
         disck2 = sqrt(discr)/2./a4
         a2k = -a2/2./a4
         wrk(2) = a2k + disck2
         wrk(3) = a2k - disck2
         if (abs(wrk(2)) < abs(wrk(3))) then
            wrk(4) = wrk(2)
            wrk(2) = wrk(3)
            wrk(3) = wrk(4)
         endif
         pkp21 = 0.
         pkp22 = wrk(2)
         pkp23 = wrk(3)
         ind2 = 0
         dk22 = abs(pkp2 - pkp22)
         dk23 = abs(pkp2 - pkp23)
         if (dk22 < dk23) then
            nslofa = 1
            pkp20 = pkp22
            imode = 2
         else
            nslofa = -1
            pkp20 = pkp23
            imode = 3
         endif
         if (nslofa /= kslofa) iermc = kslofa
         if (iermc /= 0) then
c----------
c m-c already has taken place
c------------
            kmcon = 1
            return
         endif
         if (kmcon == 1) then
            if (kslofa == 1) then
               pkp20 = wrk(3)
               nslofa = -1
               imode = 3
            else
               pkp20 = wrk(2)
               nslofa = 1
               imode = 2
            endif
c         kslofa=-kslofa
c     else
c       if (kslofa.eq.1) then
c         pkp20=wrk(2)
c         imode=2
c       else
c         pkp20=wrk(3)
c         imode=3
c       endif
         endif
         return
c
      case (1)
         cwork(1) = asxy - pkpr21
         cwork(2) = apzz + cwork(1)
         cwork(3) = alfa*cwork(2)
         cwork(4) = apzz*cwork(1)
         cwork(5) = alfa*cwork(4)
         a2 = (-(asxy + apzz)*cwork(1)) + adxy**2
         cwork2 = cwork(1)**2 - adxy**2
         a0 = apzz*cwork2
         a2 = a2 - cwork(5)
         a4 = asxy + cwork(3)
         a6 = -alfa
c---------------SCC  6/29/95
         bb0 = a0/a6
         bb1 = a2/a6
         bb2 = a4/a6
         qu1 = bb1/3. - bb2**2/9.
         rq1 = (bb1*bb2 - 3.*bb0)/6. - bb2**3/27.
         discr = qu1**3 + rq1**2
         cwrk(6) = cmplx(discr,0.)
         cwrk(5) = csqrt(cwrk(6))
         cwrk(1) = rq1 + cwrk(5)
         cwrk(2) = rq1 - cwrk(5)
         wrk(:2) = cabs(cwrk(:2))
         where (abs(wrk(:2)) <= 1.E-15)
            cwrk(5:6) = (0.,0.)
         elsewhere
            cwrk(5:6) = cwrk(:2)**(1./3.)
         end where
         wrk(6) = bb2/3.
         cwrk(4) = cwrk(5) + cwrk(6)
         cwrk(5) = cwrk(5) - cwrk(6)
         cwrk(1) = cwrk(4) - wrk(6)
         cwrk(2) = (-0.5*cwrk(4)) - wrk(6)
         cwrk(6) = cai*rt3o2*cwrk(5)
         disck2 = cabs(cwrk(6))
         a2k = cabs(cwrk(2))
         cwrk(3) = cwrk(2) - cwrk(6)
         cwrk(2) = cwrk(2) + cwrk(6)
c------roots are cwrk(1:3)
c------identify the branch of the current step: assume roots are real
         wrk(:3) = real(cwrk(:3))
         if (abs(wrk(2)) < abs(wrk(3))) then
            wrk(4) = wrk(2)
            wrk(2) = wrk(3)
            wrk(3) = wrk(4)
         endif
         if (abs(wrk(1)) > abs(wrk(2))) then
            ind2 = 0
         else
            ind2 = 1
         endif
         pkp21 = wrk(1)
         pkp22 = wrk(2)
         pkp23 = wrk(3)
c---------------
         wrk1 = abs(wrk(:3))
         ak2mx = max(wrk1(1),wrk1(2),wrk1(3))
         ak2mx = ak2mx - 1.E-10
         ak2mn = min(wrk1(1),wrk1(2),wrk1(3))
         ak2mn = ak2mn + 1.E-10
         where (wrk1 >= ak2mx) imd = 2
         where (wrk1 <= ak2mn) imd = -1
         where (imd == 0) imd = 1
         wrk1 = abs(pkp2 - wrk(:3))
         dk2mn = min(wrk1(1),wrk1(2),wrk1(3))
         dk2mn = dk2mn + 1.E-10
         nslofa = imd(1)
         dk2mn = wrk1(1)
         imode = 1
         do j = 2, 3
            if (wrk1(j) < dk2mn) then
               dk2mn = wrk1(j)
               nslofa = imd(j)
               imode = j
            endif
         end do
         pkp20 = wrk(imode)
         if (nslofa /= kslofa) iermc = kslofa
         if (iermc /= 0) then
c----------
c m-c already has taken place
c------------
            kmcon = 1
            return
         endif
c-----------------
         if (kmcon == 1) then
            if (kslofa == (-1)) then
c          if (ind2.eq.1) iermc=-1
               pkp20 = wrk(2)
               nslofa = -kslofa
               imode = 2
            else if (kslofa == 2) then
c          if (ind2.eq.0) iermc=2
               pkp20 = wrk(3)
               nslofa = 1
               imode = 3
            else if (ind2 == 0) then
c          if (kslofa.ne.1) iermc=1
               pkp20 = wrk(3)
               nslofa = -1
               imode = 3
            else if (ind2 == 1) then
c          if (kslofa.ne.1) iermc=1
               pkp20 = wrk(2)
               nslofa = 2
               imode = 2
            endif
c     else
c       pkp20=0.
         endif
c------------------------------
         return
      end select
      end subroutine sub4

      subroutine sub5(pkp22, ier)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:38:46   6/15/01
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
      use Vsizes
      use Vchpcsd
      use Vcraylh, only: akpsi, akth, anphi, pkpsi, pktau, pkphi,
     1    pkheta, pkx, pkz, pkpar, pkpar2, pkp, pkp2, pkp2x, pk,
     2    aj, antau, ag, dxpsi, dxth, dzpsi, dzth, djp, djt, dgp,
     3    dgt, dntaup, dntaut, dompsi, domth, dqpsi, dqth
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer ier
      real(kind=dp) pkp22
C-----------------------------------------------
C   C o m m o n   B l o c k s
C-----------------------------------------------
C...  /chpcsd/
!      common /chpcsd/ prmt(6), y(10), dy(10), dy6o, hlast, ndim, jhlf,
!     1   ind, serror, psilast, yin(10), dyin(10), mcnt, h, klim, irecmx
!      integer   ndim, jhlf, ind, mcnt, klim, irecmx
!      real   prmt, y, dy, dy6o, hlast, serror, psilast, yin, dyin, h
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      real(kind=dp) :: sigkps, pkpsi2
C-----------------------------------------------
c-----------July 5,1995   SCC
c  update y(1),y(3) in backstep procedure
c  pkp22 is pkp2 of step isxz
c----------------------
c
c
c
      ier = 0
      call wavect
      sigkps = pkpsi/abs(pkpsi)
      pkpsi2 = pkp22 - pkheta**2
      if (pkpsi2 < 0.) then
         ier = 99
         return
      endif
      pkpsi = sqrt(pkpsi2)*sigkps
      akpsi = (aj*pkpsi + ag*pktau)/antau
      akth = antau*pktau
      y(1) = akpsi
      y(3) = akth
      call wavect
      return
      end subroutine sub5

C   IMSL ROUTINE NAME   - IBCDCU
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JUNE 1, 1982
C
C   PURPOSE             - NUCLEUS CALLED ONLY BY IMSL SUBROUTINE IBCCCU
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - NONE REQUIRED
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE IBCDCU (TAU,GTAU,N,M,W,VS,IC1,IC2,IER)
C                                  SPECIFICATIONS FOR ARGUMENTS
      INTEGER            N,M,IC1,IC2,IER
      REAL               TAU(N),GTAU(IC1,1),W(N,2),VS(IC2,2,2)
C Note last dim of VS changed to 2 to avoid compiler error, jcw 9/25/01
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      INTEGER            I,JJ,JM1,JP1,J,K,LIM,LL,LP1,NM1
      REAL               AA,BB,C1,C2,CC,DD,DTAU,G,H,RATIO,U,XILIM
C                                  FIRST EXECUTABLE STATEMENT
      LIM = N-3
      NM1 = N-1
      LP1 = LIM+1
      IER = 132
      W(2,1) = TAU(3)-TAU(1)
      IF (W(2,1).LE.0.0) RETURN
      DO 5 K=1,M
         VS(K,1,1) = GTAU(1,K)
    5 CONTINUE
      XILIM = TAU(1)
      IF (LIM.LT.2) GO TO 20
      XILIM = TAU(N-2)
      DO 15 I=2,LIM
         J = I+1
         W(J,1) = TAU(I+2)-TAU(J)
         IF (W(J,1).LE.0.0) RETURN
         DO 10 K=1,M
   10    VS(K,1,I) = GTAU(J,K)
   15 CONTINUE
   20 W(LP1,1) = TAU(N)-XILIM
      IF (W(LP1,1).LE.0.0) RETURN
      DO 25 K=1,M
   25 VS(K,1,LP1) = GTAU(N,K)
      DO 35 I=2,LP1
         DO 30 K=1,M
   30    VS(K,2,I) = (VS(K,1,I)-VS(K,1,I-1))/W(I,1)
   35 CONTINUE
      DTAU = TAU(2)-TAU(1)
      RATIO = DTAU/W(2,1)
      W(1,2) = (RATIO-1.)**2
      W(1,1) = RATIO*(RATIO-1.)
      C1 = RATIO*(2.*RATIO-3.)
      DO 40 K=1,M
   40 VS(K,2,1) = (GTAU(2,K)-GTAU(1,K))/DTAU+VS(K,2,2)*C1
      IF (LIM.LT.2) GO TO 55
      DO 50 I=2,LIM
         J = I+1
         JJ = I-1
         G = -W(J,1)/W(JJ,2)
         C1 = 3.*W(I,1)
         C2 = 3.*W(J,1)
         DO 45 K=1,M
   45    VS(K,2,I) = G*VS(K,2,JJ)+C1*VS(K,2,J)+C2*VS(K,2,I)
         W(I,2) = G*W(JJ,1)+2.*(W(I,1)+W(J,1))
   50 CONTINUE
   55 DTAU = TAU(N-1)-XILIM
      RATIO = DTAU/W(LP1,1)
      G = -(RATIO-1.)**2/W(LIM,2)
      W(LP1,2) = RATIO*(RATIO-1.)
      C1 = RATIO*(2.*RATIO-3.)
      DO 60 K=1,M
   60 VS(K,2,LP1) = (GTAU(N-1,K)-VS(K,1,LIM))/DTAU+VS(K,2,LP1)*C1
      W(LP1,2) = G*W(LIM,1)+W(LP1,2)
      DO 65 K=1,M
   65 VS(K,2,LP1) = (G*VS(K,2,LIM)+VS(K,2,LP1))/W(LP1,2)
      J = LIM
   70 DO 75 K=1,M
   75 VS(K,2,J) = (VS(K,2,J)-W(J,1)*VS(K,2,J+1))/W(J,2)
      J = J-1
      IF (J.GT.0) GO TO 70
      DO 95 K=1,M
         DO 85 JJ=1,N
            J = N+1-JJ
            JM1 = J-1
            IF (J.EQ.N) JM1 = J-2
            IF (J.EQ.1) JM1 = J
            DO 80 LL=1,2
               VS(K,LL,J) = VS(K,LL,JM1)
   80       CONTINUE
   85    CONTINUE
         DO 90 J=2,NM1,LIM
            JM1 = J-1
            JP1 = J+1
            IF (JM1.EQ.2) JM1 = 1
            IF (JP1.EQ.NM1) JP1 = N
            H = TAU(JP1)-TAU(JM1)
            U = TAU(J)-TAU(JM1)
            AA = VS(K,1,JM1)
            BB = VS(K,2,JM1)
            CC = (3.*(VS(K,1,JP1)-VS(K,1,JM1))/H-(VS(K,2,JP1)+
     *      2.*VS(K,2,JM1)))/H
            DD = (2.*(VS(K,1,JM1)-VS(K,1,JP1))/H+(VS(K,2,JP1)+
     *      VS(K,2,JM1)))/H**2
            VS(K,1,J) = AA+U*(BB+U*(CC+DD*U))
            VS(K,2,J) = BB+U*(2.*CC+3.*DD*U)
   90    CONTINUE
   95 CONTINUE
      IER = 0
      RETURN
      END

      subroutine dcsevu (x, y, nx, sc, ic, u, ds, m1, dds, m2, ierr)
C*******************************************************************************
C*                                                                             *
C*    ROUTINE NAME:  DCSEVU                                                    *
C*                                                                             *
C*    PURPOSE:  computes first and second derivitives for a bicubic spline     *
C*                                                                             *
C*    AUTHOR:   Steve Reid - 26 August 1999                                    *
C*              S & E Computing                                                *
C*                                                                             *
C*    INPUTS:   x   - vector of length nx                                      *
C*              y   - vector of length nx                                      *
C*              nx  - number of elements in vectors x and y, where nx >= 2     *
C*              sc  - spline coefficient array dimensioned (nx - 1, 3)=(ic, 3) *
C*              ic  - row dimension of sc array as dimensioned in the calling  *
C*                    program                                                  *
C*              u   - vector of length max (m1, m2) containing abcissae of the *
C*                    points at which the first and/or second derivitives of   *
C*                    the cubic spline is to be evaluated                      *
C*              m1  - number of elements in vector ds                          *
C*              m2  - number of elements in vector dds                         *
C*                                                                             *
C*    OUTPUTS:  ds   - vector of length m1, containing the first derivitive    *
C*                     of the spline approximation at each u(i)                *
C*              dds  - vector of length m2, containing the second derivitive   *
C*                     of the spline approximation at each u(i)                *
C*              ierr - error code (point out of bounds warnings)               *
C*                       33 = u(i) < x(1)                                      *
C*                       34 = u(i) > x(nx)                                     *
C*                                                                             *
C*    ROUTINE CALLED:  uertst                                                  *
C*                                                                             *
C*    LIMITATIONS:  The elements of input vectors x and y are assumed to be    *
C*                  pre-sorted into ascending order.  The input ic must be     *
C*                  greater than or equal to nx.                               *
C*                                                                             *
C*******************************************************************************
      implicit none
      integer i, ic, ierr, j, m1, m2, mmax, nx 
      real*8 d, dds(m2), ds(m1), sc(ic, 3), u(m1), x(nx), y(nx)
      character*6 isub /'dcsevu'/
c
c--Validate that the desired points are within range.
c
      ierr = 0
      i    = 1
      dowhile (ierr .eq. 0 .and. i .le. m1)
         if (u(i) .lt. x(1)) then
            ierr = 33
         elseif (u(i) .gt. x(nx)) then
            ierr = 34
         else
            i = i + 1
         endif
      enddo
      if (ierr .ne. 0) go to 9000
      mmax = max (m1, m2)
      do i = 1, mmax
c
c--find j such that x(j) <= u(i) < x(j + 1).
c
         j = 1
         dowhile (j .lt. nx .and. u(i) .gt. x(j + 1))
            j = j + 1
         enddo
         if (u(i) .gt. x(nx - 1)) then
            j = nx - 1
         endif
         d = u(i) - x(j)     ! offset from lower boundary
c
c--Compute the first derivitive.
c
         if (i .le. m1) then
            ds(i) = (3.0 * sc(j, 3) * d + 2.0 * sc(j, 2)) * d
     &              + sc(j, 1)
         endif
c
c--Compute the second derivitive.
c
         if (i .le. m2) then
            dds(i) = 6.0 * sc(j, 3) * d + 2.0 * sc(j, 2)
         endif
      enddo
      go to 9990
c
c--Error exit.
c
 9000 continue
      call uertst (ierr, isub)
c
c--Normal exit.
c
 9990 continue
      return
      end

c
c  This module contains orbit-averaging routines
c--------------------------------------
c
c
      subroutine bavorb1(thetas, dla, ba, thetae, wk, wk1, wkt, nthpp0)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:19   6/14/01  
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
c      use Vparam
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang, 
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec, 
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3, 
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti, 
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin, 
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril, 
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref, 
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep, 
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr, 
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite, 
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1, 
     1   gamene1, presfr 
      use Vcraylh
      use Vceqdsk, ONLY: ntitle, dat, ipestg, nxeqd, nzeqd, xdimeqd, 
     1   zdimeqd, reqd, redeqd, zmideqd, xma, zma, psimag, psilim, 
     2   beqd, toteqd, psimx1, psimx2, xax1, xax2, zax1, zax2, psisep, 
     3   xsep, zsep, feqd, presseqd, ffpeqd, ppeqd, peqd, qeqd, xeqd, 
     4   zeqd, psiadj, dpolflx, psieqd, tpsieqd, tpsifeqd, iounit1, 
     5   inoperm1, nptsdm1, nptsd, torflux, tpsisav, ra, psifra, 
     6   dpsifra, fra, fra1, cspln, pds, wnoperm, xcontr, zcontr, 
     7   bpcontr, btcontr, dstarp, b_fld, jacob, pprime, vprime, 
     8   chipsi, ncontr, dang, bperr, arcl, thet, anglex, csplnx, 
     9   csplnz, pdsx, pdsz, nlim, rlim, zlim, nlimiter, rlimiter, 
     .   zlimiter, lrz, nprim, nimp, nion, nti, zi, zeffz, r, raeqd, 
     1   psifeqd, te, ti, ti1, ene, enp, bmod, rmd, btmd, bpmd, btpmd, 
     2   roa
      use Vcmnew, only: cxc, czc
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nthpp0
      real, dimension(nthpp0 + 1) :: thetas
      real, dimension(0:nthpp0 - 1) :: dla, ba, thetae
      real, dimension(nthpp0 + 4) :: wk
      real, dimension(nthpp0 + 4,3) :: wk1
      real, dimension(nthpp0 + 4) :: wkt
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: nth, n, np, imn, imx, nt, it, ier
      real::pi,dthet,beq0,alenb,xmn,ymn,dymn,xmx,ymx,dymx,bmax,bmin
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i
 
c
c  given nthp0,npsi0,psimx,psimn
c  find dl(1:nthp0)=dl/L line elements along field line
c    and bb(1:nthp0)=B(l)/B(0)
c  (for the bounce average integrals in adj)
c  typically npsi0=26,nthp0=60
c
C     integer ppsis,pthets,pdla,pba,pthete,dumptr
c
c  check if nthp0 is smaller than nthp00 and npsi0 is smaller than npsis
c
      pi = 4*atan(1.0E0)
      dpsis = (psimx - psimn)/(npsi0 - 1)
      dthet = 2*pi/nthp0
      write (iout3, 2000) nthp0, npsi0
      write (iout3, 2010) psimx, psimn
      do nth = 1, nthp0 + 1
         thetas(nth) = (nth - 1.25E0)*dthet
      end do
      do nth = 0, nthp0 - 1
         thetae(nth) = (nth + 0.25E0)*dthet
      end do
      write (iout3, 2020) (thetas(n),n=1,nthp0 + 1)
      write (iout3, 2020) (thetae(n),n=0,nthp0 - 1)
      do np = 1, npsi0
         psis(np) = psimn + dpsis*(np - 1)
         psi = psis(np)
         call subpar (psi, eden(np), etem(np), zefi(np))
         if (psi == 1.) psi = 1. - 1.E-5
         write (iout3, 2010) psi
         do nth = 1, nthp0 + 1
            theta = thetas(nth)
            call coords
            call profix
            cxc(nth,np) = xu + raxmag
            czc(nth,np) = zu
         end do
         theta = 0.
         call coords
         call profix
         beq0 = abs(btot)
         do nth = 0, nthp0 - 1
            theta = thetae(nth)
            call coords
            call profix
            ba(nth) = abs(btot/beq0)
            dla(nth) = sqrt((cxc(nth+2,np)-cxc(nth+1,np))**2+(czc(nth+2,
     1         np)-czc(nth+1,np))**2)*btot/bpol
         end do
         alenb = 0.
         alenb = sum(dla(:nthp0-1))
         dla(:nthp0-1) = dla(:nthp0-1)/alenb
C
C   determine bmax,bmin
C
         imn = 3
         imx = 3
         wk(:nthp0) = abs(ba(:nthp0-1))
         wkt(:nthp0) = thetae(:nthp0-1)
         do nt = 0, 3
            it = nthp0 + nt + 1
            wk(it) = abs(ba(nt))
            wkt(it) = thetae(nt) + 2.*pi
         end do
         do nt = 4, nthp0 + 2
            if (wk(nt) >= wk(imx)) imx = nt
            if (wk(nt) <= wk(imn)) imn = nt
         end do
         call icsccu (wkt, wk, nthp0 + 4, wk1, nthp0 + 4, ier)
         call xtrema (imn, xmn, ymn, dymn, nthp0 + 4, wkt, wk, wk1, ier)
         if (ier == 19) then
            write (iout4, 1001) ier
 1001       format(1x,'error-message 1: ',i3,
     1         ', xtrema failed to converge.')
            return                               ! stop
         endif
         call xtrema (imx, xmx, ymx, dymx, nthp0 + 4, wkt, wk, wk1, ier)
         if (ier == 19) then
            write (iout4, 1002) ier
 1002       format(1x,'error-message 2: ',i3,
     1         ', xtrema failed to converge.')
            return                               ! stop
         endif
         bmax = ymx*beq0
         bmin = ymn*beq0
         bbar(np) = 0.
         ba(:nthp0-1) = ba(:nthp0-1)/ymn
         bbar(np) = bbar(np) + sum(ba(:nthp0-1)*dla(:nthp0-1))
c          aspin(np)=(bmax-bmin)/(bmax+bmin) ! Apparently never used
         write (iout3, 2020) (dla(n),n=0,nthp0 - 1)
         write (iout3, 2020) (ba(n),n=0,nthp0 - 1)
         write (iout3, 2010) alenb, bmax, bmin
      end do
c
c---------------------------
c
 2000 format(1x,2i8)
 2010 format(4(2x,e20.12))
 2020 format(5(2x,e20.12))
      return 
      end subroutine bavorb1
      subroutine bavorbt
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:19   6/14/01  
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
c      use Vparam
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang, 
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec, 
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3, 
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti, 
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin, 
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril, 
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref, 
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep, 
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr, 
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite, 
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1, 
     1   gamene1, presfr, nthp00
      use Vcraylh
      use Vceqdsk, ONLY: ntitle, dat, ipestg, nxeqd, nzeqd, xdimeqd, 
     1   zdimeqd, reqd, redeqd, zmideqd, xma, zma, psimag, psilim, 
     2   beqd, toteqd, psimx1, psimx2, xax1, xax2, zax1, zax2, psisep, 
     3   xsep, zsep, feqd, presseqd, ffpeqd, ppeqd, peqd, qeqd, xeqd, 
     4   zeqd, psiadj, dpolflx, psieqd, tpsieqd, tpsifeqd, iounit1, 
     5   inoperm1, nptsdm1, nptsd, torflux, tpsisav, ra, psifra, 
     6   dpsifra, fra, fra1, cspln, pds, wnoperm, xcontr, zcontr, 
     7   bpcontr, btcontr, dstarp, b_fld, jacob, pprime, vprime, 
     8   chipsi, ncontr, dang, bperr, arcl, thet, anglex, csplnx, 
     9   csplnz, pdsx, pdsz, nlim, rlim, zlim, nlimiter, rlimiter, 
     .   zlimiter, lrz, nprim, nimp, nion, nti, zi, zeffz, r, raeqd, 
     1   psifeqd, te, ti, ti1, ene, enp, bmod, rmd, btmd, bpmd, btpmd, 
     2   roa
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer:: pthets,pdla,pba,pthete,ndum
      integer:: pwk,pwk1,pwkt,ii,ierr,i,nthpp0
      real, allocatable, dimension(:) :: dum
      real :: stat
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i
 
c
c   Common block for Comdynray
c
c
c  given nthp0,npsi0,psimx,psimn
c  find dl(1:nthp0)=dl/L line elements along field line
c    and bb(1:nthp0)=B(l)/B(0)
c  (for the bounce average integrals in adj)
c  typically npsi0=26,nthp0=60
c
c     pointer(dumptr,dum(1))
c     pointer(pthets,thetas(1:nthp0+1))
c     pointer(pdla,dla(0:nthp0-1))
c     pointer(pba,ba(0:nthp0-1))
c     pointer(pthete,thetae(0:nthp0-1))
c     pointer(pwk,wk(1:nthp0+4))
c     pointer(pwk1,wk1(1:nthp0+4,3))
c     pointer(pwkt,wkt(1:nthp0+4))
c
c  check if nthp0 is smaller than nthp00 and npsi0 is smaller than npsis
c
      if (npsi0>npsis .or. nthp0>nthp00-1) then
         write (iout4, *) 'npsi0 or nthp0 is too large in bavorbt'
         write (iout4, *) npsi0, nthp0
         write (iout4, *) npsis, nthp00
         stop 
      endif
      ii = 1
      pthets = ii
      ii = ii + nthp0 + 1
      pdla = ii
      ii = ii + nthp0
      pba = ii
      ii = ii + nthp0
      pthete = ii
      ii = ii + nthp0
      pwk = ii
      ii = ii + nthp0 + 4
      pwk1 = ii
      ii = ii + (nthp0 + 4)*3
      pwkt = ii
      ndum = ii + nthp0 + 4 - 1
c      call hpalloc(dumptr,ndum,ierr,1)
      if (.not.allocated(dum)) then
         ALLOCATE(dum(ndum),stat=ierr)
         if (ierr /= 0) then
            print *, 'dum could not be allocated in bavorbt'
            return 
         endif
      endif
      dum(:ndum) = 0.
      nthpp0 = nthp0
      call bavorb1 (dum(pthets), dum(pdla), dum(pba), dum(pthete), 
     1                 dum(pwk), dum(pwk1), dum(pwkt), nthpp0)
c      call hpdeallc(dumptr,ierr,0)
      DEALLOCATE(dum)
      return 
      end subroutine bavorbt
      subroutine vbak
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:19   6/14/01  
C...Switches: -p4 -yb
c-----------------
c  subroutine to calculate an array of b_ave=bbar as a function of psi
c  and akapa1(1:npsi0), akapa(1:npsi0); these are later used in j/p formula.
c--------------------
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
      use Vparam
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang, 
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec, 
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3, 
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti, 
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin, 
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril, 
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref, 
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep, 
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr, 
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite, 
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1, 
     1   gamene1, presfr
      use Vcraylh
      use Vceqdsk
      use Vcmnew, ONLY: wpi1c, wpi2c, wci1c, wci2c, wpi2, wci2, wci, 
     1   conci, aziomi, rtzom, ay2, ay1, trate, tratte, ttle, concte, 
     2   trati, tratti, ttli, concti, vdrfte, vdrfti, infi, gprm, cxet, 
     3   czt, cztp, czetai, czi, czip, czetat, czti, cztip, cth, npar, 
     4   nper, upar, uper, umax, dsfe, dsfi, fper2, fpar2, fpp2, intg, 
     5   inc, incf, tnmaxe, tnmaxi, idrive, binb, boutb, boutbrd, 
     6   binbrd, epsl, binbd, epsil, dlob, wte, eta0, eta, rprof, 
     7   amprof, cprof, xjop, vloop, kboot, mboot, btbsp, ftbsps, pde, 
     8   pdec, pdi, pdf, pwce, pwcm, pwcf, pwc, pwc1, pwc2, pwct, 
     9   pwct1, pwct2, pwc0, pwcray, pwc1ray, pwc2ray, pweray, pwiray, 
     .   pwfray, currf, currfe, currf1, currf2, curay, curay1, curay2, 
     1   fpwray, fpowe, fpowf, fpowi, pwte0, pwti0, effcd, effcdt, 
     2   ptot, ftpowe, ftpowi, ftpowf, ftpi, ftpf, ftedge, pwedge, 
     3   wfrac, pwxwl, frpowi, frpowf, frpow, pwit, pwft, ptedge, 
     4   ptot0, fpowt, tpowi, tpowf, wfrac0, ebkev, bmpwr, azf, atmf, 
     5   densa, kalfa, nalfa, nharm0, pnfi, pnf, zetab, tnf, ecrit, 
     6   taua0, wca, gamal, gamat, ibeam, abeam, dbeam, aneb, enbeam, 
     7   wbeam, temsa, ptfi, ttf, wpf2c, wpf2, wcf2c, wcf1c, wcf2, wcf, 
     8   cxc, czc, cy, denfa, eav, tausd, tau0, paf, sordt, ecrita, 
     9   betaf
      USE Vblkcof
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: np, ier
      real, dimension(3) :: bke
      real :: c2
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1
 
 
c******      TKM   03/97, 09/99, 04/00, 06/00
c********************
 
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c----------------------
c  input:  npsi0=# of psi-values for tabulation, the psi-values are in
c                the array psis(1:npsi0)
c          nthp0=# of poloidal theta values for averaging
c         temperatures in array etem(1:npsi0)
c $$$$    TKM    8/98
c----------------------
      do np = 1, npsi0
         c2 = 511.925/etem(np)
         if (c2 < 1.E3) then
c            call bskes(0.,c2,3,bke)
c            call mmbskr (c2, 0., 3, bke, ier)
            call dbesk(c2, 0., 2, 3, bke, ier)
            akapa1(np) = bke(2)/bke(3)
            akapa(np) = bke(1)/bke(2)
         else
            akapa1(np) = 1.
            akapa(np) = 1.
         endif
      end do
      call subcof (akz, bkz, az, bz)
      return 
      end subroutine vbak

      subroutine dbcevl (x, nx, y, ny, sc, ic, xp, yp, pds, ierr)
C*******************************************************************************
C*                                                                             *
C*    ROUTINE NAME:  DBCEVL                                                    *
C*                                                                             *
C*    PURPOSE:  computes partial derivitives for a bicubic spline              *
C*                                                                             *
C*    AUTHOR:   Steve Reid - 18 August 1999                                    *
C*              S & E Computing                                                *
C*                                                                             *
C*    INPUTS:   x   - vector of length nx                                      *
C*              nx  - number of elements in vector x                           *
C*              y   - vector of length ny                                      *
C*              ny  - number of elements in vector y                           *
C*              sc  - spline coefficient array dimensioned (2, ic, 2 * ny)     *
C*              ic  - second dimension of sc array                             *
C*              xp  - x-coordinate of point at which mixed partial derivitives *
C*                    are to be calculated                                     *
C*              yp  - y-coordinate of point at which mixed partial derivitives *
C*                    are to be calculated                                     *
C*                                                                             *
C*    OUTPUTS:  pds - vector containing spline value at the point in question  *
C*                    and five derivitives; i.e.                               *
C*                      pds(1) = s(xp, yp)                                     *
C*                      pds(2) = ds/dx                                         *
C*                      pds(3) = ds/dy                                         *
C*                      pds(4) = d(ds/dx)/dy                                   *
C*                      pds(5) = d(ds/dx)/dx                                   *
C*                      pds(6) = d(ds/dy)/dy                                   *
C*                                                                             *
C*              ierr - error code (point out of bounds warnings)               *
C*                      33 = xp < x(1)                                         *
C*                      34 = yp < y(1)                                         *
C*                      35 = xp > x(nx)                                        *
C*                      36 = yp > y(ny)                                        *
C*                                                                             *
C*    ROUTINES CALLED:  tableintrp, uertst                                     *
C*                                                                             *
C*    LIMITATIONS:  The elements of input vectors x and y are assumed to be    *
C*                  pre-sorted into ascending order.  The input ic must be     *
C*                  greater than or equal to nx.                               *
C*                                                                             *
C*******************************************************************************
      implicit none
      integer i, ic, ierr, j, k, km1, kp1, kp2, l, lxp1, lxpl, lx, ly,
     &        nx, ny
      real*8  d, h, hx, hy, pds(6), sc(2, ic, *), s0, sh, sp0, sph,
     &        spln0, spln1, spln2, su(2), sux(2), suy(2), sv(2), svx(2),
     &        sxy(2), u, v, x(*), xp, y(*), yp
      character*6 isub /'dbcevl'/
      data    lx, ly /2 * 0/
c
c--Statement functions
c
      spln0 (s0,sh,sp0,sph,h,d) = s0+d*(h*sp0+d*(3.0*(sh-s0)-
     & (sph+2.0*sp0)*h+d*(2.0*(s0-sh)+(sph+sp0)*h)))
c
      spln1 (s0,sh,sp0,sph,h,d) = sp0+d*(6.0 * (sh-s0)/h-2.0*
     & (sph+2.0*sp0)+3.0*d*(2.0*(s0-sh)/h+(sph+sp0)))
c
      spln2 (s0,sh,sp0,sph,h,d) = 6.0 * (sh-s0)/h**2-2.0*
     & (sph+2.0*sp0)/h+d*(2.0*(s0-sh)/h**2+(sph+sp0)/h)*6.
c
c--Correlated table search for xp
c
      ierr = 0
      call tableintrp (x, nx, xp, lx)
      if (lx .eq. 0) then
         ierr = 33
         go to 9000
      elseif (lx .eq. nx) then
         ierr = 35
         go to 9000
      endif
c
c--Correlated table search for yp
c
      call tableintrp (y, ny, yp, ly)
      if (ly .eq. 0) then
         ierr = 34
         go to 9000
      elseif (ly .eq. ny) then
         ierr = 36
         go to 9000
      endif
c
      lxp1 = lx + 1
      hx   = x(lxp1) - x(lx)
      hy   = y(ly + 1) - y(ly)
      u    = (xp - x(lx)) / hx
      v    = (yp - y(ly)) / hy
      k    = 2 * ly
      kp1  = k + 1
      kp2  = k + 2
      km1  = k - 1
c
      do l = 1, 2
         lxpl   = lx - 1 + l
         i      = 2 * (ly - 1 + l)
         j      = i - 1
         sv(l)  = spln0 (sc(1, lxpl, km1), sc(1, lxpl, kp1),
     &                   sc(1, lxpl, k), sc(1, lxpl, kp2), hy, v)
         svx(l) = spln0 (sc(2, lxpl, km1), sc(2, lxpl, kp1),
     &                   sc(2, lxpl, k), sc(2, lxpl, kp2), hy, v)
         su(l)  = spln0 (sc(1, lx, j), sc(1, lxp1, j), sc(2, lx, j),
     &                   sc(2, lxp1, j), hx, u)
         suy(l) = spln0 (sc(1, lx, i), sc(1, lxp1, i), sc(2, lx, i),
     &                   sc(2, lxp1, i), hx, u)
         sux(l) = spln1 (sc(1, lx, j), sc(1, lxp1, j), sc(2, lx, j),
     &                   sc(2, lxp1, j), hx, u)
         sxy(l) = spln1 (sc(1, lx, i), sc(1, lxp1, i), sc(2, lx, i),
     &                   sc(2, lxp1, i), hx, u)
      enddo
c
      pds(1) = spln0 (sv(1), sv(2), svx(1), svx(2), hx, u)
      pds(2) = spln1 (sv(1), sv(2), svx(1), svx(2), hx, u)
      pds(3) = spln1 (su(1), su(2), suy(1), suy(2), hy, v)
      pds(4) = spln1 (sux(1), sux(2), sxy(1), sxy(2), hy, v)
      pds(5) = spln2 (sv(1), sv(2), svx(1), svx(2), hx, u)
      pds(6) = spln2 (su(1), su(2), suy(1), suy(2), hy, v)
      go to 9990
c
c--Error exit.
c
 9000 continue
      call uertst (ierr, isub)
c
c--Normal exit.
c
 9990 continue
      return
      end

      module Vcgraphs
      use kind_spec

C...Created by Pacific-Sierra Research VAST-90 2.06G2  12:29:44   5/18/01
      use Vparam, only: nprofm, nions, npdim, nspray, nspectm,
     1                  ntheta, ngdim
      integer   initlh, nraypts
      integer, dimension(npdim) :: jjslofa
      integer, dimension(ngdim) :: jslofas, nurefls, keiks, jpes, jpis,
     1   istarts, iprmt5, jhlfs, isimpl, isimpl0
      integer   ngr, nps, nspie, kgraph, kprof, newgra, jksym, lintyp,
     1   nxvarb, nyvarb, kwfr
      real(kind=dp), dimension(nprofm) :: sne, ste, sqr
      real(kind=dp), dimension(nprofm,9) :: spw
      real(kind=dp), dimension(nprofm) :: sxh, sqte
      real(kind=dp), dimension(nprofm,nions) :: sni, sti
      real(kind=dp), dimension(nions) :: satm, sazi, sconc, stic
      real(kind=dp)  sdeqs, spwer, spwmax, srtor, srplas,
     1 sdenc, stec, sqc, sqa, sbaxis, scurr, sfreq
      real(kind=dp), dimension(ngdim) :: skth, skphi, skpsi, sxx
      real(kind=dp)  sxpage, sypage, slenx, sleny, sdelx,
     1 sfirtx, sdely, sfirty, symax, symin
      real(kind=dp), dimension(npdim)::seikon,spsi,sxu,szu,skp,skpar,
     1   spower, sdpwri, sphi, stheta, spol, sdkpar, sztpol, sbtot, sene
     2   , salphac, salphal, sjslofa, serrors, spkpsi, sakpsi, sakth,
     3   swkve
      complex, dimension(npdim) :: scepx, scepy, scepz
C      equivalence (stabx, seikon)
      end module Vcgraphs

c----------------------
! 07Jun1999 fgtok -impno -s r8_precision.sub r8_names.table "r8con.csh conversion"
c  bcspline -- dmc 30 May 1996
c
c  set up coefficients for bicubic spline with following BC's:
c  FULL BC CONTROL at all bdys
c
c  algorithm note -- handling of y & z explicit BC's while maintaining
c  full C2 differentiability is delicate.  Basic method:  use a fully
c  C2 method based on the "not-a-knot" BC, and then, correct to meet
c  each user BC by calculating a C2 spline that is zero at all grid
c  points but satisfies a BC which is the difference btw the user spec
c  and the not-a-knot result; add the coeffs of this into the original.
c
c  for this more workspace is needed: nwk .ge. 4*inx*inth +5*max(inx,inth)
c
c
      subroutine r8bcspline(x, inx, th, inth, fspl, inf3, ibcxmin, 
     1   bcxmin, ibcxmax, bcxmax, ibcthmin, bcthmin, ibcthmax, bcthmax, 
     2   wk, nwk, ilinx, ilinth, ier)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer inx, inth, inf3, ibcxmin, ibcxmax, ibcthmin, ibcthmax, nwk
     1   , ilinx, ilinth, ier
      real*8, dimension(inx) :: x
      real*8, dimension(inth) :: th
      real*8, dimension(4,4,inf3,inth) :: fspl
      real*8, dimension(inth) :: bcxmin, bcxmax
      real*8, dimension(inx) :: bcthmin, bcthmax
      real*8, dimension(nwk) :: wk
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: iflg2, ix, itest, ierx, ierth, ia1, ia2, ia3, ia4, ia5
     1   , ith, iadr, ibcxmina, ibcxmaxa, ic, ibcthmina, ibcthmaxa, iasc
     2   , iinc, iawk, jx, jth, ii, idum, ia, ia1w, ia2w, ia3w, ia4w, 
     3   ia5w, iaspl, iaxsp, iaxsp1
      integer, dimension(10) :: iselect1, iselect2
      real*8 :: xo2, xo6, zhxn, zhth, zcur, zdiff1, zdiff2
C-----------------------------------------------
C============
C idecl:  explicitize implicit INTEGER declarations:
C============
C idecl:  explicitize implicit REAL declarations:
C============
c
c  input:
c    x(1...inx) -- abscissae, first dimension of data
c   th(1...inth) -- abscissae, second (periodic) dimension of data
c   fspl(1,1,1..inx,1..inth) -- function values
c   inf3 -- fspl dimensioning, inf3.ge.inx required.
c
c  boundary conditions input:
c   ibcxmin -- indicator for boundary condition at x(1):
c    bcxmin(...) -- boundary condition data
c     =-1 -- periodic boundary condition
c     =0 -- use "not a knot", bcxmin(...) ignored
c     =1 -- match slope, specified at x(1),th(ith) by bcxmin(ith)
c     =2 -- match 2nd derivative, specified at x(1),th(ith) by bcxmin(ith)
c     =3 -- boundary condition is slope=0 (df/dx=0) at x(1), all th(j)
c     =4 -- boundary condition is d2f/dx2=0 at x(1), all th(j)
c   NOTE bcxmin(...) referenced ONLY if ibcxmin=1 or ibcxmin=2
c
c   ibcxmax -- indicator for boundary condition at x(nx):
c    bcxmax(...) -- boundary condition data
c     (interpretation as with ibcxmin, bcxmin)
c   NOTE:  if ibcxmin=-1, ibcxmax is ignored! ...and the BC is periodic.
c
c   ibcthmin -- indicator for boundary condition at th(1):
c    bcthmin(...) -- boundary condition data
c     (interpretation as with ibcxmin, bcxmin)
c   ibcthmax -- indicator for boundary condition at th(inth):
c    bcthmax(...) -- boundary condition data
c     (interpretation as with ibcxmin, bcxmin)
c   NOTE:  if ibcthmin=-1, ibcthmax is ignored! ...and the BC is periodic.
c
c   NOTE the bcxmin,bcxmax,bcthmin,bcthmax arrays are only used if the
c     corresponding boundary condition flags are set to 1 or 2.
c     Carefully note the dimensioning of these arrays!
c
c  output:
c   fspl(*,*,1..inx,1..inth) -- bicubic spline coeffs (4x4)
c   ...fspl(1,1,*,*) is not replaced.
c
c   ilinx -- =1 on output if x(inx) pts are nearly evenly spaced (tol=1e-3)
c   ilinth-- =1 on output if th(inth) evenly spaced (tol=1e-3)
c
c   ier -- completion code, 0 for normal
c
c  workspace:
c   wk -- must be at least 5*max(inx,inth) large
c                          5*max(inx,inth) + 4*inx*inth large
c                          if explicit non-zero d/dth or d2/dth2 BC's
c                          are supplied.
c  nwk -- size of workspace of workspace provided
c
c---------------------------------
c  compute bicubic spline of 2d function, given values at the grid
c  grid crossing points, f(1,1,i,j)=f(x(i),th(j)).
c
c  on evaluation:  for point x btw x(i) and x(i+1), dx=x-x(i)
c                       and th btw th(j) and th(j+1), dt=th-th(j),
c
c      spline =
c        f(1,1,i,j) + dx*f(2,1,i,j) + dx**2*f(3,1,i,j) + dx**3*f(4,1,i,j)
c   +dt*(f(1,2,i,j) + dx*f(2,2,i,j) + dx**2*f(3,2,i,j) + dx**3*f(4,2,i,j))
c   +d2*(f(1,3,i,j) + dx*f(2,3,i,j) + dx**2*f(3,3,i,j) + dx**3*f(4,3,i,j))
c   +d3*(f(1,4,i,j) + dx*f(2,4,i,j) + dx**2*f(3,4,i,j) + dx**3*f(4,4,i,j))
c
c      where d2=dt**2 and d3=dt**3.
c
c
c---------------------------------
c
c  see if 2nd pass is needed due to "non-linear" d/dth bdy cond.
c
      iflg2 = 0
      if (ibcthmin /= (-1)) then
         if (ibcthmin==1 .or. ibcthmin==2) then
            do ix = 1, inx
               if (bcthmin(ix) /= 0.0D0) iflg2 = 1
            end do
         endif
         if (ibcthmax==1 .or. ibcthmax==2) then
            do ix = 1, inx
               if (bcthmax(ix) /= 0.0D0) iflg2 = 1
            end do
         endif
      endif
c
      ier = 0
      itest = 5*max(inx,inth)
      if (iflg2 == 1) itest = itest + 4*inx*inth
c
      if (nwk < itest) then
         write (6, 9901) nwk, itest
 9901    format(' ?bcspline:  workspace too small:'/
     1      '  user supplied:  nwk=',i6,'; need at least:  ',i6/
     2      '  nwk=4*nx*ny +5*max(nx,ny) will work for any user'/
     3      '  choice of bdy conditions.')
         ier = 1
      endif
      if (inx < 4) then
         write (6, '('' ?bcspline:  at least 4 x points required.'')')
         ier = 1
      endif
      if (inth < 4) then
         write (6, '('' ?bcspline:  need at least 4 theta points.'')')
         ier = 1
      endif
c
      call ibc_ck (ibcxmin, 'bcspline', 'xmin', -1, 4, ier)
      if (ibcxmin >= 0) call ibc_ck (ibcxmax, 'bcspline', 'xmax', 0, 4, 
     1   ier)
      call ibc_ck (ibcthmin, 'bcspline', 'thmin', -1, 4, ier)
      if (ibcthmin >= 0) call ibc_ck (ibcthmax, 'bcspline', 'thmax', 0, 
     1   4, ier)
c
c  check ilinx & x vector
c
      call r8splinck (x, inx, ilinx, 1.0D-3, ierx)
      if (ierx /= 0) ier = 2
      if (ier == 2) write (6, 
     1   '('' ?bcspline:  x axis not strict ascending'')')
c
c  check ilinth & th vector
c
      call r8splinck (th, inth, ilinth, 1.0D-3, ierth)
      if (ierth /= 0) ier = 3
      if (ier == 3) write (6, 
     1   '('' ?bcspline:  th axis not strict ascending'')')
c
      if (ier /= 0) return 
c
c------------------------------------
c
      xo2 = 0.5D0
      xo6 = 1.0D0/6.0D0
c
c  spline in x direction
c
c  workspace address offsets (for pspline)
c
      if (ibcxmin == (-1)) then
         ia1 = 1
         ia2 = ia1 + inx
         ia3 = ia2 + inx
         ia4 = ia3 + inx
         ia5 = ia4 + inx
      endif
c
      do ith = 1, inth
c
c  copy the function in
c
         if (ibcxmin == (-1)) then
c
c  copy ordinates in
c
            wk(ia1:inx-1+ia1) = fspl(1,1,:inx,ith)
c
            call r8pspline (inx, x, wk(ia1), wk(ia2), wk(ia3), wk(ia4), 
     1         wk(ia5))
c
c  copy coeffs out
c
            fspl(2,1,:inx-1,ith) = wk(ia2:inx-2+ia2)
            fspl(3,1,:inx-1,ith) = wk(ia3:inx-2+ia3)
            fspl(4,1,:inx-1,ith) = wk(ia4:inx-2+ia4)
c
         else
c
c  copy ordinates in
            do ix = 1, inx
               iadr = 1 + (ix - 1)*4
               wk(iadr) = fspl(1,1,ix,ith)
            end do
c
            ibcxmina = ibcxmin
            if (ibcxmin==1 .or. ibcxmin==2) then
               wk(2) = bcxmin(ith)
            else if (ibcxmin > 2) then
               wk(2) = 0.0D0
               ibcxmina = ibcxmin - 2
            endif
c
            ibcxmaxa = ibcxmax
            if (ibcxmax==1 .or. ibcxmax==2) then
               wk(iadr+1) = bcxmax(ith)
            else if (ibcxmax > 2) then
               wk(iadr+1) = 0.0D0
               ibcxmaxa = ibcxmax - 2
            endif
c
            call r8cubsplb (x, wk, inx, ibcxmina, ibcxmaxa)
c
c  copy the coefficients out
c
            fspl(2,1,:inx-1,ith) = wk(2:inx*4-6:4)
            fspl(3,1,:inx-1,ith) = wk(3:inx*4-5:4)*xo2
            fspl(4,1,:inx-1,ith) = wk(4:(inx-1)*4:4)*xo6
         endif
c
      end do
c
c-----------------------------------
c
c  spline in theta direction
c
c  workspace address offsets
c
      if (ibcthmin == (-1)) then
         ia1 = 1
         ia2 = ia1 + inth
         ia3 = ia2 + inth
         ia4 = ia3 + inth
         ia5 = ia4 + inth
      endif
c
      do ix = 1, inx - 1
c
c  spline each x coeff
c
         do ic = 1, 4
c
            if (ibcthmin == (-1)) then
c
c  copy ordinates in
c
               wk(ia1:inth-1+ia1) = fspl(ic,1,ix,:inth)
c
               call r8pspline (inth, th, wk(ia1), wk(ia2), wk(ia3), wk(
     1            ia4), wk(ia5))
c
c  copy coeffs out
c
               fspl(ic,2,ix,:inth-1) = wk(ia2:inth-2+ia2)
               fspl(ic,3,ix,:inth-1) = wk(ia3:inth-2+ia3)
               fspl(ic,4,ix,:inth-1) = wk(ia4:inth-2+ia4)
c
            else
c
c  first pass:  use "not-a-knot" -- if flag indicates BC correction
c  will be needed
c
               if (iflg2 == 1) then
                  ibcthmina = 0
                  ibcthmaxa = 0
               else
                  if (ibcthmin > 2) then
                     ibcthmina = ibcthmin - 2
                  else
                     ibcthmina = ibcthmin
                  endif
                  if (ibcthmax > 2) then
                     ibcthmaxa = ibcthmax - 2
                  else
                     ibcthmaxa = ibcthmax
                  endif
               endif
c
c  copy ordinates in
               do ith = 1, inth
                  iadr = 1 + (ith - 1)*4
                  wk(iadr) = fspl(ic,1,ix,ith)
               end do
               wk(2) = 0.0D0
               wk(iadr+1) = 0.0D0
c
               call r8cubsplb (th, wk, inth, ibcthmina, ibcthmaxa)
c
c  copy the coefficients out
c
               fspl(ic,2,ix,:inth-1) = wk(2:inth*4-6:4)
               fspl(ic,3,ix,:inth-1) = wk(3:inth*4-5:4)*xo2
               fspl(ic,4,ix,:inth-1) = wk(4:(inth-1)*4:4)*xo6
c
            endif
c
         end do
c
      end do
c
c  now make correction for user BC's if needed
c
      if (iflg2 == 1) then
c
         iasc = 1                       ! wk addr for correction splines
         iinc = 4*inth                  ! spacing btw correction splines
         iawk = iasc + 4*inth*inx
c
c  last grid zone widths
c
         zhxn = x(inx) - x(inx-1)
         jx = inx - 1
         zhth = th(inth) - th(inth-1)
         jth = inth - 1
c
         iselect1 = 0
         iselect2 = 0
         if (ibcthmin == 1) iselect1(3) = 1
         if (ibcthmin == 2) iselect1(5) = 1
         if (ibcthmax == 1) iselect2(3) = 1
         if (ibcthmax == 2) iselect2(5) = 1
c
c  loop over BC's
c
         do ix = 1, inx
c
c  (a) d/dth @ th(1) difference btw current BC and user request
c
            if (ibcthmin == 1) then
               if (ix < inx) then
                  zcur = fspl(1,2,ix,1)          ! 1st deriv.
               else
                  zcur = fspl(1,2,jx,1) + zhxn*(fspl(2,2,jx,1)+zhxn*(
     1               fspl(3,2,jx,1)+zhxn*fspl(4,2,jx,1)))
               endif
            else if (ibcthmin == 2) then
               if (ix < inx) then
                  zcur = 2.0D0*fspl(1,3,ix,1)    ! 2nd deriv.
               else
                  zcur = 2.0D0*(fspl(1,3,jx,1)+zhxn*(fspl(2,3,jx,1)+zhxn
     1               *(fspl(3,3,jx,1)+zhxn*fspl(4,3,jx,1))))
               endif
            else
               zcur = bcthmin(ix)
            endif
            zdiff1 = bcthmin(ix) - zcur
c
c  (b) d/dth @ th(inth) difference btw current BC and user request
c
            if (ibcthmax == 1) then
               if (ix < inx) then
c  1st deriv.
                  zcur = fspl(1,2,ix,jth) + zhth*(2.0D0*fspl(1,3,ix,jth)
     1               +zhth*3.0D0*fspl(1,4,ix,jth))
               else
                  call r8bcspeval (x(inx), th(inth), iselect2, zcur, x, 
     1               inx, th, inth, ilinx, ilinth, fspl, inf3, ier)
                  if (ier /= 0) return 
               endif
            else if (ibcthmax == 2) then
               if (ix < inx) then
c  2nd deriv.
                  zcur = 2.0D0*fspl(1,3,ix,jth) + 6.0D0*zhth*fspl(1,4,ix
     1               ,jth)
               else
                  call r8bcspeval (x(inx), th(inth), iselect2, zcur, x, 
     1               inx, th, inth, ilinx, ilinth, fspl, inf3, ier)
                  if (ier /= 0) return 
               endif
            else
               zcur = bcthmax(ix)
            endif
            zdiff2 = bcthmax(ix) - zcur
c
c  ok compute the theta spline with BC's to span the difference(s)
c  these theta "correction splines" are zero at all the grid points
c  but have at least one non-zero 1st or 2nd derivative BC
c
            iadr = iasc + (ix - 1)*iinc
            wk(iadr:(inth-1)*4+iadr:4) = 0.0D0
c
            if (ibcthmin > 2) then
               ibcthmina = ibcthmin - 2
            else
               ibcthmina = ibcthmin
            endif
c
            if (ibcthmax > 2) then
               ibcthmaxa = ibcthmax - 2
            else
               ibcthmaxa = ibcthmax
            endif
c
            call r8cspline (th, inth, wk(iadr), ibcthmina, zdiff1, 
     1         ibcthmaxa, zdiff2, wk(iawk), 5*inth, idum, ier)
            if (ier /= 0) return 
         end do
c
c  add in results to main array
c
         do ix = 1, inx - 1
            iadr = iasc + (ix - 1)*iinc
            do ith = 1, inth - 1
               ia = iadr + (ith - 1)*4 - 1
               fspl(1,2:4,ix,ith) = fspl(1,2:4,ix,ith) + wk(ia+2:4+ia)
            end do
         end do
c
c  compute the x splines of the th spline correction coeffs
c
         if (ibcxmin == (-1)) then
            ia1w = iawk
            ia2w = ia1w + inx
            ia3w = ia2w + inx
            ia4w = ia3w + inx
            ia5w = ia4w + inx
         endif
c
         do ith = 1, inth - 1
            if (ibcxmin == (-1)) then
               do ic = 2, 4
                  do ix = 1, inx
                     iaspl = iasc + iinc*(ix - 1) + 4*(ith - 1)
                     wk(ia1w+ix-1) = wk(iaspl+ic-1)
                  end do
c
c  periodic spline of correction spline higher coeffs (1st coeffs are
c  all zero by defn of the correction spline
c
                  call r8pspline (inx, x, wk(ia1w), wk(ia2w), wk(ia3w), 
     1               wk(ia4w), wk(ia5w))
c
                  fspl(2,ic,:inx-1,ith) = fspl(2,ic,:inx-1,ith) + wk(
     1               ia2w:inx-2+ia2w)
                  fspl(3,ic,:inx-1,ith) = fspl(3,ic,:inx-1,ith) + wk(
     1               ia3w:inx-2+ia3w)
                  fspl(4,ic,:inx-1,ith) = fspl(4,ic,:inx-1,ith) + wk(
     1               ia4w:inx-2+ia4w)
               end do
c
            else
c
c  non-periodic BC in x direction -- specify zero on BC of coeff splines
c  so as not to affect the main array x BC.
c
               do ic = 2, 4
                  do ix = 1, inx
                     iaspl = iasc + iinc*(ix - 1) + 4*(ith - 1)
                     iaxsp = iawk + 4*(ix - 1)
                     wk(iaxsp) = wk(iaspl+ic-1)
                  end do
                  wk(iawk+1) = 0.0D0
                  wk(iaxsp+1) = 0.0D0
c
                  call r8cubsplb (x, wk(iawk), inx, ibcxmina, ibcxmaxa)
c
                  do ix = 1, inx - 1
                     iaxsp1 = iawk + 4*(ix - 1) - 1
                     fspl(2,ic,ix,ith) = fspl(2,ic,ix,ith) + wk(iaxsp1+2
     1                  )
                     fspl(3,ic,ix,ith) = fspl(3,ic,ix,ith) + wk(iaxsp1+3
     1                  )*xo2
                     fspl(4,ic,ix,ith) = fspl(4,ic,ix,ith) + wk(iaxsp1+4
     1                  )*xo6
                  end do
               end do
c
            endif                              ! periodic / non-periodic
c
         end do                                  ! ith
c
      endif                                   ! BC correction needs test
c
      return 
      end subroutine r8bcspline

      SUBROUTINE DGAMLM (XMIN, XMAX)
C***BEGIN PROLOGUE  DGAMLM
C***PURPOSE  Compute the minimum and maximum bounds for the argument in
C            the Gamma function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A, R2
C***TYPE      real(kind=dp) (GAMLIM-S, DGAMLM-D)
C***KEYWORDS  COMPLETE GAMMA FUNCTION, FNLIB, LIMITS, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C Calculate the minimum and maximum legal bounds for X in gamma(X).
C XMIN and XMAX are not the only bounds, but they are the only non-
C trivial ones to calculate.
C
C             Output Arguments --
C XMIN   double precision minimum legal value of X in gamma(X).  Any
C        smaller value of X might result in underflow.
C XMAX   double precision maximum legal value of X in gamma(X).  Any
C        larger value of X might cause overflow.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C***END PROLOGUE  DGAMLM
C============
C idecl:  explicitize implicit INTEGER declarations:
      use kind_spec

      IMPLICIT NONE
      INTEGER i
C============
      real(kind=dp) XMIN, XMAX, ALNBIG, ALNSML, XLN, XOLD, D1MACH
C***FIRST EXECUTABLE STATEMENT  DGAMLM
      ALNSML = LOG(d1mach1)
      XMIN = -ALNSML
      DO 10 I=1,10
        XOLD = XMIN
        XLN = LOG(XMIN)
        XMIN = XMIN - XMIN*((XMIN+0.5E0_dp)*XLN -

     1     XMIN - 0.2258E0_dp+ ALNSML)

     1     / (XMIN*XLN+0.5E0_dp)

        IF (ABS(XMIN-XOLD).LT.0.005E0_dp) GO TO 20

 10   CONTINUE
      CALL XERMSG ('SLATEC', 'DGAMLM', 'UNABLE TO FIND XMIN', 1, 2)
C
 20   XMIN = -XMIN + 0.01E0_dp

C
      ALNBIG = LOG (d1mach2)
      XMAX = ALNBIG
      DO 30 I=1,10
        XOLD = XMAX
        XLN = LOG(XMAX)
        XMAX = XMAX - XMAX*((XMAX-0.5E0_dp)*XLN -

     1     XMAX + 0.9189E0_dp- ALNBIG)

     1     / (XMAX*XLN-0.5E0_dp)

        IF (ABS(XMAX-XOLD).LT.0.005E0_dp) GO TO 40

 30   CONTINUE
      CALL XERMSG ('SLATEC', 'DGAMLM', 'UNABLE TO FIND XMAX', 2, 2)
C
 40   XMAX = XMAX - 0.01E0_dp

      XMIN = MAX (XMIN, -XMAX+1.E0_dp)

C
      RETURN
      END
! 22Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 22Jun2000 fgtok
! 22Jun2000 fgtok

c
c  bcspeval -- eval bicubic spline function and/or derivatives
c
      subroutine bcspeval(xget, yget, iselect, fval, x, nx, y, ny, ilinx
     1   , iliny, f, inf3, ier)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nx, ny, ilinx, iliny, inf3, ier
      real xget, yget
      integer, dimension(6) :: iselect
      real, dimension(6) :: fval
      real, dimension(nx) :: x
      real, dimension(ny) :: y
      real, dimension(4,4,inf3,ny) :: f
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, j
      real :: dx, dy
C-----------------------------------------------
c
c
c
c  modification -- dmc 11 Jan 1999 -- remove SAVE stmts; break routine
C    into these parts:
C
C    bcspevxy -- find grid cell of target pt.
C    bcspevfn -- evaluate function using output of bcpsevxy
C
C    in cases where multiple functions are defined on the same grid,
C    time can be saved by using bcspevxy once and then bcspevfn
C    multiple times.
c
c  input:
c     (xget,yget)   location where interpolated value is desired
c                   x(1).le.xget.le.x(nx) expected
c                   y(1).le.yget.le.y(ny) expected
c
c     iselect       select desired output
c
c                     iselect(1)=1 -- want function value (f) itself
c                     iselect(2)=1 -- want  df/dx
c                     iselect(3)=1 -- want  df/dy
c                     iselect(4)=1 -- want  d2f/dx2
c                     iselect(5)=1 -- want  d2f/dy2
c                     iselect(6)=1 -- want  d2f/dxdy
c
c              example:  iselect(1)=iselect(2)=iselect(3)=1
c                            f, df/dx, and df/dy all evaluated
c                        iselect(4)=iselect(5)=iselect(6)=0
c                            2nd derivatives not evaluated.
c
c                   see fval (output) description.
c
c     x(1...nx)     independent coordinate x, strict ascending
c     y(1...ny)     independent coordinate y, strict ascending
c
c     ilinx  --  =1: flag that x is linearly spaced (avoid search for speed)
c     iliny  --  =1: flag that y is linearly spaced (avoid search for speed)
c
c  **CAUTION** actual even spacing of x, y is NOT CHECKED HERE!
c
c
c     f             the function values (at grid points) and spline coefs
c
c  evaluation formula:  for point x btw x(i) and x(i+1), dx=x-x(i)
c                             and y btw y(j) and y(j+1), dy=y-y(j),
c
c      spline value =
c        f(1,1,i,j) + dx*f(2,1,i,j) + dx**2*f(3,1,i,j) + dx**3*f(4,1,i,j)
c   +dy*(f(1,2,i,j) + dx*f(2,2,i,j) + dx**2*f(3,2,i,j) + dx**3*f(4,2,i,j))
c   +d2*(f(1,3,i,j) + dx*f(2,3,i,j) + dx**2*f(3,3,i,j) + dx**3*f(4,3,i,j))
c   +d3*(f(1,4,i,j) + dx*f(2,4,i,j) + dx**2*f(3,4,i,j) + dx**3*f(4,4,i,j))
c
c      where d2=dy**2 and d3=dy**3.
c
c  output:
c      up to 6 elements of fval, ordered as follows:
c        fval(1)=function value or lowest order derivative requested
c        fval(2)=next order derivative
c             etc
c        the ordering is a subset of the sequence given under the "iselect"
c        description.
c
c      ier = 0 -- successful completion; = 1 -- an error occurred.
c
c-------------------------------------------------------------------
c  local
c
c
c
c--------------------------
c
      call bcspevxy(xget,yget,x,nx,y,ny,ilinx,iliny,i,j,dx,dy,ier)
      if (ier /= 0) return 
c
      call bcspevfn (iselect, 1, 1, fval, i, j, dx, dy, f, inf3, ny)
c
      return 
      end subroutine bcspeval
c
c-------------------------------------------------------------------------
c  bcspevxy -- look up x-y zone
c
c  this is the "first part" of bcspeval, see comments, above.
c
      subroutine bcspevxy(xget, yget, x, nx, y, ny, ilinx, iliny, i, j, 
     1   dx, dy, ier)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nx, ny, ilinx, iliny, i, j, ier
      real xget, yget, dx, dy
      real, dimension(nx) :: x
      real, dimension(ny) :: y
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: nxm, nym, ii, jj
      real :: zxget, zyget, zxtol, zytol
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real , EXTERNAL :: write
C-----------------------------------------------
c
c
c
c
c  output of bcspevxy
c
                                        ! dx=x-x(i)  dy=y-y(j)
C
c
c------------------------------------
c
      ier = 0
c
c  range check
c
      zxget = xget
      zyget = yget
 
      if (xget<x(1) .or. xget>x(nx)) then
         zxtol = 4.0E-7*max(abs(x(1)),abs(x(nx)))
         if (xget<x(1) - zxtol .or. xget>x(nx)+zxtol) then
            ier = 1
            write (6, 1001) xget, x(1), x(nx)
 1001       format(' ?bcspeval:  xget=',1pe11.4,' out of range ',1pe11.4
     1         ,' to ',1pe11.4)
         else
            if (xget<x(1) - 0.5*zxtol .or. xget>x(nx)+0.5*zxtol) write (
     1         6, 1011) xget, x(1), x(nx)
 1011       format(' %bcspeval:  xget=',1pe15.8,' beyond range ',1pe15.8
     1         ,' to ',1pe15.8,' (fixup applied)')
            if (xget < x(1)) then
               zxget = x(1)
            else
               zxget = x(nx)
            endif
         endif
      endif
      if (yget<y(1) .or. yget>y(ny)) then
         zytol = 4.0E-7*max(abs(y(1)),abs(y(ny)))
         if (yget<y(1) - zytol .or. yget>y(ny)+zytol) then
            ier = 1
            write (6, 1002) yget, y(1), y(ny)
 1002       format(' ?bcspeval:  yget=',1pe11.4,' out of range ',1pe11.4
     1         ,' to ',1pe11.4)
         else
            if (yget<y(1) - 0.5*zytol .or. yget>y(ny)+0.5*zytol) write (
     1         6, 1012) yget, y(1), y(ny)
 1012       format(' %bcspeval:  yget=',1pe15.8,' beyond range ',1pe15.8
     1         ,' to ',1pe15.8,' (fixup applied)')
            if (yget < y(1)) then
               zyget = y(1)
            else
               zyget = y(ny)
            endif
         endif
      endif
      if (ier /= 0) return 
c
c  now find interval in which target point lies..
c
      nxm = nx - 1
      nym = ny - 1
c
      if (ilinx == 1) then
         ii = 1 + nxm*(zxget - x(1))/(x(nx)-x(1))
         i = min(nxm,ii)
      else
         if (1<=i .and. i<nxm) then
            if (x(i)<=zxget .and. zxget<=x(i+1)) then
            else
               call bcspefnd (x, nx, zxget, i)
            endif
         else
            call bcspefnd (x, nx, zxget, i)
         endif
      endif
c
      if (iliny == 1) then
         jj = 1 + nym*(zyget - y(1))/(y(ny)-y(1))
         j = min(nym,jj)
      else
         if (1<=j .and. j<nym) then
            if (y(j)<=zyget .and. zyget<=y(j+1)) then
            else
               call bcspefnd (y, ny, zyget, j)
            endif
         else
            call bcspefnd (y, ny, zyget, j)
         endif
      endif
c
      dx = zxget - x(i)
      dy = zyget - y(j)
c
      return 
      end subroutine bcspevxy
c------------------------------------------------------------------------
c  bcspevfn -- OK now evaluate the bicubic spline
c
      subroutine bcspevfn(ict,ivec,ivd,fval,iv,jv,dxv,dyv,f,inf3,ny)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer ivec, ivd, inf3, ny
      integer, dimension(6) :: ict
      integer, dimension(ivec) :: iv, jv
      real, dimension(ivd,6) :: fval
      real, dimension(ivec) :: dxv, dyv
      real, dimension(4,4,inf3,ny) :: f
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: v, iaval, i, j
      real :: dx, dy
C-----------------------------------------------
c
c  input:
c        ict(1)=1 for f      (don't evaluate f if ict(1)=0)
c        ict(2)=1 for df/dx   ""
c        ict(3)=1 for df/dy   ""
c        ict(4)=1 for d2f/dx2
c        ict(5)=1 for d2f/dy2
c        ict(6)=1 for d2f/dxdy
c
c    note:  if ict(1)=-1, evaluate f,d2f/dx2,d2f/dy2,d4f/dx2dy2
c
c
c    ivec-- number of vector pts (spline values to look up)
c    ivd -- 1st dimension of fval, .ge.ivec
c
c output:
c
c    v = index to element in vector;
c  fval(v,1) = first item requested by ict(...),
c  fval(v,2) = 2nd item requested,  ...etc...
c
c  input:
c
c
c  usage example:
c
c  1.  for each element (xx(v),yy(v)) in a vector of (x,y) pairs,
c    find the x and y zone indices and displacements with respect
c    to the "lower left corner" of the zone; store these in vectors
c    iv,jv and dxv,dyv.
c
c  2.  set ict(1)=0, ict(2)=1, ict(3)=1, the rest zero -- get only
c      the 1st derivatives.
c
c  3.  ivec is the length of the vector; ivd is the 1st dimension
c      of the array fval to receive the output
c
c      real fval(ivd,6)
c      real xv(ivd),yv(ivd)
c      integer iv(ivd),jv(ivd)
c      real dxv(ivd),dyv(ivd)
c      integer ict(6)
c
c      real fspline(4,4,nx,ny)  ! spline coeffs
c      data ict/0,1,1,0,0,0/    ! this call:  want 1st derivatives
c                               ! only ... these will be output to
c                               ! fval(*,1) fval(*,2)
c      ...
c      do iv=1,ivec
c        ...                    ! find indices and displacements
c      enddo
c      call bcspevfn(ict,ivec,ivd,fval,iv,jv,dxv,dyv,fspline,nx,ny)
c
c-------------------------------------------------------------------
c  local:
c
c
c  OK can now do evaluations
c
      iaval = 0                                  ! fval addressing
c
      if (ict(1)>0 .or. ict(1)==(-1)) then
c  evaluate f
         iaval = iaval + 1
         do v = 1, ivec
            i = iv(v)
            j = jv(v)
            dx = dxv(v)
            dy = dyv(v)
            fval(v,iaval) = f(1,1,i,j) + dy*(f(1,2,i,j)+dy*(f(1,3,i,j)+
     1         dy*f(1,4,i,j))) + dx*(f(2,1,i,j)+dy*(f(2,2,i,j)+dy*(f(2,3
     2         ,i,j)+dy*f(2,4,i,j)))+dx*(f(3,1,i,j)+dy*(f(3,2,i,j)+dy*(f
     3         (3,3,i,j)+dy*f(3,4,i,j)))+dx*(f(4,1,i,j)+dy*(f(4,2,i,j)+
     4         dy*(f(4,3,i,j)+dy*f(4,4,i,j))))))
         end do
      endif
c
      if (ict(2)>0 .and. ict(1)/=(-1)) then
c  evaluate df/dx
         iaval = iaval + 1
         do v = 1, ivec
            i = iv(v)
            j = jv(v)
            dx = dxv(v)
            dy = dyv(v)
            fval(v,iaval) = f(2,1,i,j) + dy*(f(2,2,i,j)+dy*(f(2,3,i,j)+
     1         dy*f(2,4,i,j))) + 2.0*dx*(f(3,1,i,j)+dy*(f(3,2,i,j)+dy*(f
     2         (3,3,i,j)+dy*f(3,4,i,j)))+1.5*dx*(f(4,1,i,j)+dy*(f(4,2,i,
     3         j)+dy*(f(4,3,i,j)+dy*f(4,4,i,j)))))
         end do
      endif
c
      if (ict(3)>0 .and. ict(1)/=(-1)) then
c  evaluate df/dy
         iaval = iaval + 1
         do v = 1, ivec
            i = iv(v)
            j = jv(v)
            dx = dxv(v)
            dy = dyv(v)
            fval(v,iaval) = f(1,2,i,j) + dy*(2.0*f(1,3,i,j)+dy*3.0*f(1,4
     1         ,i,j)) + dx*(f(2,2,i,j)+dy*(2.0*f(2,3,i,j)+dy*3.0*f(2,4,i
     2         ,j))+dx*(f(3,2,i,j)+dy*(2.0*f(3,3,i,j)+dy*3.0*f(3,4,i,j))
     3         +dx*(f(4,2,i,j)+dy*(2.0*f(4,3,i,j)+dy*3.0*f(4,4,i,j)))))
         end do
      endif
c
      if (ict(4)>0 .or. ict(1)==(-1)) then
c  evaluate d2f/dx2
         iaval = iaval + 1
         do v = 1, ivec
            i = iv(v)
            j = jv(v)
            dx = dxv(v)
            dy = dyv(v)
            fval(v,iaval) = 2.0*(f(3,1,i,j)+dy*(f(3,2,i,j)+dy*(f(3,3,i,j
     1         )+dy*f(3,4,i,j)))) + 6.0*dx*(f(4,1,i,j)+dy*(f(4,2,i,j)+dy
     2         *(f(4,3,i,j)+dy*f(4,4,i,j))))
         end do
      endif
c
      if (ict(5)>0 .or. ict(1)==(-1)) then
c  evaluate d2f/dy2
         iaval = iaval + 1
         do v = 1, ivec
            i = iv(v)
            j = jv(v)
            dx = dxv(v)
            dy = dyv(v)
            fval(v,iaval) = 2.0*f(1,3,i,j) + 6.0*dy*f(1,4,i,j) + dx*(2.0
     1         *f(2,3,i,j)+6.0*dy*f(2,4,i,j)+dx*(2.0*f(3,3,i,j)+6.0*dy*f
     2         (3,4,i,j)+dx*(2.0*f(4,3,i,j)+6.0*dy*f(4,4,i,j))))
         end do
      endif
c
      if (ict(6)>0 .and. ict(1)/=(-1)) then
c  evaluate d2f/dxdy
         iaval = iaval + 1
         do v = 1, ivec
            i = iv(v)
            j = jv(v)
            dx = dxv(v)
            dy = dyv(v)
            fval(v,iaval) = f(2,2,i,j) + dy*(2.0*f(2,3,i,j)+dy*3.0*f(2,4
     1         ,i,j)) + 2.*dx*(f(3,2,i,j)+dy*(2.0*f(3,3,i,j)+dy*3.0*f(3,
     2         4,i,j))+1.5*dx*(f(4,2,i,j)+dy*(2.0*f(4,3,i,j)+dy*3.0*f(4,
     3         4,i,j))))
         end do
      endif
c
      if (ict(1) == (-1)) then
         iaval = iaval + 1
         do v = 1, ivec
            i = iv(v)
            j = jv(v)
            dx = dxv(v)
            dy = dyv(v)
            fval(v,iaval) = 4.0*f(3,3,i,j) + 12.0*dy*f(3,4,i,j) + dx*(
     1         12.0*f(4,3,i,j)+36.0*dy*f(4,4,i,j))
         end do
      endif
c
      return 
      end subroutine bcspevfn

       FUNCTION DERF (X)
C***BEGIN PROLOGUE  DERF
C***PURPOSE  Compute the error function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C8A, L5A1E
C***TYPE      real(kind=dp) (ERF-S, DERF-D)
C***KEYWORDS  ERF, ERROR FUNCTION, FNLIB, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DERF(X) calculates the double precision error function for double
C precision argument X.
C
C Series for ERF        on the interval  0.          to  1.00000E+00
C                                        with weighted error   1.28E-32
C                                         log weighted error  31.89
C                               significant figures required  31.05
C                                    decimal places required  32.55
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, DCSEVL, DERFC, INITDS
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900727  Added EXTERNAL statement.  (WRB)
C   920618  Removed space from variable name.  (RWC, WRB)
C***END PROLOGUE  DERF
C============
C idecl:  explicitize implicit INTEGER declarations:
      use kind_spec

      IMPLICIT NONE
      INTEGER nterf,initds
C============
      real(kind=dp) X, ERFCS(21), SQEPS, SQRTPI, XBIG, Y, D1MACH,
     1  DCSEVL, DERFC
      real(kind=dp) DERF
      LOGICAL FIRST
      EXTERNAL DERFC
      SAVE ERFCS, SQRTPI, NTERF, XBIG, SQEPS, FIRST
      DATA ERFCS(  1) / -.49046121234691808039984544033376E-1_dp/

      DATA ERFCS(  2) / -.14226120510371364237824741899631E+0_dp/

      DATA ERFCS(  3) / +.10035582187599795575754676712933E-1_dp/

      DATA ERFCS(  4) / -.57687646997674847650827025509167E-3_dp/

      DATA ERFCS(  5) / +.27419931252196061034422160791471E-4_dp/

      DATA ERFCS(  6) / -.11043175507344507604135381295905E-5_dp/

      DATA ERFCS(  7) / +.38488755420345036949961311498174E-7_dp/

      DATA ERFCS(  8) / -.11808582533875466969631751801581E-8_dp/

      DATA ERFCS(  9) / +.32334215826050909646402930953354E-10_dp/

      DATA ERFCS( 10) / -.79910159470045487581607374708595E-12_dp/

      DATA ERFCS( 11) / +.17990725113961455611967245486634E-13_dp/

      DATA ERFCS( 12) / -.37186354878186926382316828209493E-15_dp/

      DATA ERFCS( 13) / +.71035990037142529711689908394666E-17_dp/

      DATA ERFCS( 14) / -.12612455119155225832495424853333E-18_dp/

      DATA ERFCS( 15) / +.20916406941769294369170500266666E-20_dp/

      DATA ERFCS( 16) / -.32539731029314072982364160000000E-22_dp/

      DATA ERFCS( 17) / +.47668672097976748332373333333333E-24_dp/

      DATA ERFCS( 18) / -.65980120782851343155199999999999E-26_dp/

      DATA ERFCS( 19) / +.86550114699637626197333333333333E-28_dp/

      DATA ERFCS( 20) / -.10788925177498064213333333333333E-29_dp/

      DATA ERFCS( 21) / +.12811883993017002666666666666666E-31_dp/

      DATA SQRTPI / 1.77245385090551602729816748334115E0_dp/

      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DERF
      IF (FIRST) THEN
         NTERF = INITDS (ERFCS, 21, 0.1E0_dp*(d1mach3))

         XBIG = SQRT(-LOG(SQRTPI*d1mach3))
         SQEPS = SQRT(2.0E0_dp*d1mach3)

      ENDIF
      FIRST = .FALSE.
C
      Y = ABS(X)
      IF (Y.GT.1.E0_dp) GO TO 20

C
C ERF(X) = 1.0 - ERFC(X)  FOR  -1.0 .LE. X .LE. 1.0
C
      IF (Y.LE.SQEPS) DERF = 2.0E0_dp*X*X/SQRTPI

      IF (Y.GT.SQEPS) DERF = X*(1.0E0_dp+

     1   DCSEVL (2.E0_dp*X*X-1.E0_dp,

     1   ERFCS, NTERF))
      RETURN
C
C ERF(X) = 1.0 - ERFC(X) FOR ABS(X) .GT. 1.0
C
 20   IF (Y.LE.XBIG) DERF = SIGN (1.0E0_dp-DERFC(Y), X)

      IF (Y.GT.XBIG) DERF = SIGN (1.0E0_dp, X)

C
      RETURN
      END
! 22Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 22Jun2000 fgtok
! 22Jun2000 fgtok
! 22Jun2000 fgtok

 
      subroutine dbcevl1(x, nx, y, ny, c, ic, xl, yl, pds, ier, icalc)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nx, ny, ic, ier, icalc
      real(kind=dp) xl, yl
      real(kind=dp), dimension(*) :: x, y
      real(kind=dp), dimension(2,ic,*) :: c
      real(kind=dp), dimension(6) :: pds
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, j, k, km1, kp1, kp2, lxpl, lx, ly, l, lxp1
      real(kind=dp) :: hx, hy
      real(kind=dp), dimension(2) :: sux, suy, su, svx, sv, sxy
      real(kind=dp) :: u, v, s0, sh, sp0, sph, h, d
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real(kind=dp) spln0, spln1, spln2
C-----------------------------------------------
c
c --- this is a special version of dbcevl, used by the ONETWO suite
c --- of subroutines. It differs from the IMSL version in the calling
c --- arguments and the calculations below are reordered for efficiency
c --- That is, many times we don't need all of the pds array. This
c --- version returns only those values of pds specifically requested
c --- using the argument icalc. This leads to about at 50% improvement
c --- in execution time. --- HSJ
c
c
      data lx, ly/0, 0/
c
      ier = 0
c
c --- correlated table search for xl
c
      call tableintrp (x, nx, xl, lx)
      if (lx == 0) ier = 33
      if (lx == nx) ier = 35
      if (ier == 0) then
c
c --- correlated table search for yl
c
         call tableintrp (y, ny, yl, ly)
         if (ly == 0) ier = 34
         if (ly == ny) ier = 36
         if (ier == 0) then
c
c --- replaces the following linear search
c
****  if (xl .lt. x(1))  ier = 33
****  do 5 i=2,nx
****     lx = i-1
****     if (xl .le. x(i))  go to 10
****5 continue
****  ier = 35
***10 if (yl .lt. y(1))  ier = 34
****  do 15 j=2,ny
****     ly = j-1
****     if (yl .le. y(j))  go to 20
***15 continue
****  ier = 36
***20 if (ier .ne. 0)  go to 100
c
            lxp1 = lx + 1
            hx = x(lxp1) - x(lx)
            hy = y(ly+1) - y(ly)
            u = (xl - x(lx))/hx
            v = (yl - y(ly))/hy
            k = 2*ly
            kp1 = k + 1
            kp2 = k + 2
            km1 = k - 1
c
            do l = 1, 2
               lxpl = lx - 1 + l
               i = 2*(ly - 1 + l)
               j = i - 1
               sv(l) = spln0(c(1,lxpl,km1),c(1,lxpl,kp1),c(1,lxpl,k),c(1
     1            ,lxpl,kp2),hy,v)
               svx(l) = spln0(c(2,lxpl,km1),c(2,lxpl,kp1),c(2,lxpl,k),c(
     1            2,lxpl,kp2),hy,v)
               if (icalc >= 3) then              ! rearranged by HSJ
                  su(l) = spln0(c(1,lx,j),c(1,lxp1,j),c(2,lx,j),c(2,lxp1
     1               ,j),hx,u)
                  suy(l) = spln0(c(1,lx,i),c(1,lxp1,i),c(2,lx,i),c(2,
     1               lxp1,i),hx,u)
                  if (icalc >= 4) then
                     sux(l) = spln1(c(1,lx,j),c(1,lxp1,j),c(2,lx,j),c(2,
     1                  lxp1,j),hx,u)
                     sxy(l) = spln1(c(1,lx,i),c(1,lxp1,i),c(2,lx,i),c(2,
     1                  lxp1,i),hx,u)
                  endif
               endif
            end do
c
            pds(1) = spln0(sv(1),sv(2),svx(1),svx(2),hx,u)
c                               ! special routine only calculates pds(1)
            if (icalc == 1) return 
            pds(2) = spln1(sv(1),sv(2),svx(1),svx(2),hx,u)
            if (icalc == 2) return 
            pds(3) = spln1(su(1),su(2),suy(1),suy(2),hy,v)
            if (icalc == 3) return 
            pds(4) = spln1(sux(1),sux(2),sxy(1),sxy(2),hy,v)
            if (icalc == 4) return 
            pds(5) = spln2(sv(1),sv(2),svx(1),svx(2),hx,u)
            if (icalc == 5) return 
            pds(6) = spln2(su(1),su(2),suy(1),suy(2),hy,v)
         endif
      endif
      return 
      contains
      real(kind=dp) function spln0 (s0, sh, sp0, sph, h, d)
      real(kind=dp) s0
      real(kind=dp) sh
      real(kind=dp) sp0
      real(kind=dp) sph
      real(kind=dp) h
      real(kind=dp) d
      spln0 = s0 + d*(h*sp0 + d*(3.0*(sh - s0) - (sph + 2.0*sp0)*h + d*(
     1   2.0*(s0 - sh) + (sph + sp0)*h)))
      return 
      end function spln0
      real(kind=dp) function spln1 (s0, sh, sp0, sph, h, d)
      real(kind=dp) s0
      real(kind=dp) sh
      real(kind=dp) sp0
      real(kind=dp) sph
      real(kind=dp) h
      real(kind=dp) d
      spln1 = sp0 + d*(6.0*(sh - s0)/h - 2.0*(sph + 2.0*sp0) + 3.0*d*(
     1   2.0*(s0 - sh)/h + (sph + sp0)))
      return 
      end function spln1
      real(kind=dp) function spln2 (s0, sh, sp0, sph, h, d)
      real(kind=dp) s0
      real(kind=dp) sh
      real(kind=dp) sp0
      real(kind=dp) sph
      real(kind=dp) h
      real(kind=dp) d
      spln2 = 6.0*(sh - s0)/h**2 - 2.0*(sph + 2.0*sp0)/h + d*(2.0*(s0 - 
     1   sh)/h**2 + (sph + sp0)/h)*6.
      return 
      end function spln2
c
      end subroutine dbcevl1

      module Vcfdamp
      use kind_spec

C...Created by Pacific-Sierra Research VAST-90 2.06G2  12:29:44   5/18/01
      use Vparam, only: nbesa, nuam, ntam, irmax, nwk, imaxu, jmax
      character   inname*10
      integer   inf
      integer   ifbilin
      integer   nint, nmax1
      integer   ifirstb, nbes
      integer, dimension(4) :: ibd
      real(kind=dp)   enorm, unorm, bmax
      real(kind=dp)   dus, dthets, dudthets
      real(kind=dp)   dbes, cnstb, besdel
      real(kind=dp)   rtail, r1t, r2t, ttail, rhot, r1h, r2h, thotpar,
     1    thotper,
     1   hotexp, hotmnpar, hotmxpar, hotmnper, hotmxper, rbeam, r1b, r2b
     2   , tbeam, ebeam, thbeam
      real(kind=dp), dimension(nuam) :: us
      real(kind=dp), dimension(ntam) :: thets, coss, sinn
      real(kind=dp), dimension(nuam,ntam,irmax) :: f, fxx, fyy, fxxyy
      real(kind=dp), dimension(nuam,ntam) :: ftemp
      real(kind=dp), dimension(nwk) :: wk
      real(kind=dp), dimension(ntam) :: sint
      real(kind=dp), dimension(nuam,ntam) :: tempx, tempy
      real(kind=dp), dimension(nuam) :: usp
      real(kind=dp), dimension(ntam) :: thetsp
      real(kind=dp), dimension(nbesa) :: bes0, bes1
      end module Vcfdamp

C   IMSL ROUTINE NAME   - LUELMN
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JUNE 1, 1982
C
C   PURPOSE             - NUCLEUS CALLED ONLY BY IMSL SUBROUTINE LEQT2F
C
C   REQD. IMSL ROUTINES - NONE REQUIRED
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE LUELMN (A,IA,N,B,APVT,X)
C
      DIMENSION          A(IA,1),B(1),APVT(1),X(1)
C                                  FIRST EXECUTABLE STATEMENT
C                                  SOLVE LY = B FOR Y
      DO 5 I=1,N
    5 X(I) = B(I)
      IW = 0
      DO 20 I=1,N
         IP = APVT(I)
         SUM = X(IP)
         X(IP) = X(I)
         IF (IW .EQ. 0) GO TO 15
         IM1 = I-1
         DO 10 J=IW,IM1
            SUM = SUM-A(I,J)*X(J)
   10    CONTINUE
         GO TO 20
   15    IF (SUM .NE. 0.) IW = I
   20 X(I) = SUM
C                                  SOLVE UX = Y FOR X
      DO 30 IB=1,N
         I = N+1-IB
         IP1 = I+1
         SUM = X(I)
         IF (IP1 .GT. N) GO TO 30
         DO 25 J=IP1,N
            SUM = SUM-A(I,J)*X(J)
   25   CONTINUE
   30 X(I) = SUM/A(I,I)
      RETURN
      END

      subroutine icsccu (x, y, nx, sc, ic, ierr)
C*******************************************************************************
C*                                                                             *
C*    ROUTINE NAME:  ICSCCU                                                    *
C*                                                                             *
C*    PURPOSE:  performs a one-dimensional cubic spline interpolation          *
C*                                                                             *
C*    AUTHOR:   Steve Reid - 19 October 1999                                   *
C*              S & E Computing                                                *
C*                                                                             *
C*    INPUTS:   x    - vector containing nx ascending abcissae                 *
C*              y    - vector containing nx ordinates                          *
C*              nx   - number of elements in vectors x and y (must be >= 4)    *
C*              ic   - second dimension of sc array                            *
C*                                                                             *
C*    OUTPUTS:  sc   - spline coefficient array dimensioned (nx - 1, 3)        *
C*              ierr - error code (terminal error)                             *
C*                      129 = ic < (nx - 1)                                    *
C*                      130 = nx < 4                                           *
C*                      131 = abcissae not in ascending order                  *
C*                                                                             *
C*    ROUTINES CALLED:  r8cspline, uertst                                      *
C*                                                                             *
C*    LIMITATION:   This version of icsccu requires that nx > 3, whereas the   *
C*                  previous constraint was nx > 1.                            *
C*                                                                             *
C*******************************************************************************
      implicit none
      integer i, ic, ierr, ilinx, nx
      real*8 dummy, fspl(4, nx), sc(ic, 3), wk(5 * nx), x(nx), y(nx)
      character*6 isub /'icsccu'/
c
c--Check validity of spline coefficient row dimension.
c
      if (ic .lt. nx - 1) go to 9000
c
c--Compute not-a-knot spline.
c
      do i = 1, nx
         fspl(1, i) = y(i)
      enddo
      call r8cspline (x, nx, fspl, 0, dummy, 0, dummy, wk, 5 * nx,
     &              ilinx, ierr)
      if (ierr .eq. 1) then
         ierr = 130
      elseif (ierr .eq. 2) then
         ierr = 131
      endif
      if (ierr .ne. 0) go to 9000
      do i = 1, ic
         sc(i, 1) = fspl(2, i)
         sc(i, 2) = fspl(3, i)
         sc(i, 3) = fspl(4, i)
      enddo
      go to 9990
c
c--Error exit.
c
 9000 continue
      call uertst (ierr, isub)
c
c--Normal exit.
c
 9990 continue
      return
      end

      subroutine ibc_ck(ibc,slbl,xlbl,imin,imax,ier)
c
c  check that spline routine ibc flag is in range
c
      integer ibc                       ! input -- flag value
      character*(*) slbl                ! input -- subroutine name
      character*(*) xlbl                ! input -- axis label
c
      integer imin                      ! input -- min allowed value
      integer imax                      ! input -- max allowed value
c
      integer ier                       ! output -- set =1 if error detected
c
c----------------------
c
      if((ibc.lt.imin).or.(ibc.gt.imax)) then
         ier=1
         write(6,1001) slbl,xlbl,ibc,imin,imax
 1001    format(' ?',a,' -- ibc',a,' = ',i9,' out of range ',
     >      i2,' to ',i2)
      endif
c
      return
      end

! 07Jun1999 fgtok -impno -s r8_precision.sub r8_names.table "r8con.csh conversion"
      subroutine r8cubsplb(tau, c, n, ibcbeg, ibcend)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer n, ibcbeg, ibcend
      real(kind=dp), dimension(n) :: tau
      real(kind=dp), dimension(4,n) :: c
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: j1, j2, i, j, l, m
      real(kind=dp) :: divdf1, divdf3, dtau, g
C-----------------------------------------------
c
c
c****** a tridiagonal linear system for the unknown slopes s(i) of
c  f  at tau(i), i=1,...,n, is generated and then solved by gauss elim-
c  ination, with s(i) ending up in c(2,i), all i.
c     c(3,.) and c(4,.) are used initially for temporary storage.
      l = n - 1
compute first differences of tau sequence and store in c(3,.). also,
compute first divided difference of data and store in c(4,.).
      c(3,2:n) = tau(2:n) - tau(:n-1)
      c(4,2:n) = (c(1,2:n)-c(1,:n-1))/c(3,2:n)
construct first equation from the boundary condition, of the form
c             c(4,1)*s(1) + c(3,1)*s(2) = c(2,1)
      if (ibcbeg - 1 <= 0) then
         if (ibcbeg - 1 /= 0) then
            if (n <= 2) then
c     no condition at left end and n = 2.
               c(4,1) = 1.E0_dp
               c(3,1) = 1.E0_dp
               c(2,1) = 2.E0_dp*c(4,2)
               go to 25
c     not-a-knot condition at left end and n .gt. 2.
            endif
            c(4,1) = c(3,3)
            c(3,1) = c(3,2) + c(3,3)
            c(2,1) = ((c(3,2)+2.E0_dp*c(3,1))*c(4,2)*c(3,3)
     1         +c(3,2)**2*c(4,3))/c(3,1)
            go to 19
c     slope prescribed at left end.
         endif
         c(4,1) = 1.E0_dp
         c(3,1) = 0.E0_dp
      else
c     second derivative prescribed at left end.
         c(4,1) = 2.E0_dp
         c(3,1) = 1.E0_dp
         c(2,1) = 3.E0_dp*c(4,2) - c(3,2)/2.E0_dp*c(2,1)
      endif
      if (n == 2) go to 25
c  if there are interior knots, generate the corresp. equations and car-
c  ry out the forward pass of gauss elimination, after which the m-th
c  equation reads    c(4,m)*s(m) + c(3,m)*s(m+1) = c(2,m).
   19 continue
      do m = 2, l
         g = -c(3,m+1)/c(4,m-1)
         c(2,m) = g*c(2,m-1) + 3.E0_dp*(c(3,m)*c(4,m+1)+c(3,m+1)*c(4,m))
         c(4,m) = g*c(3,m-1) + 2.E0_dp*(c(3,m)+c(3,m+1))
      end do
construct last equation from the second boundary condition, of the form
c           (-g*c(4,n-1))*s(n-1) + c(4,n)*s(n) = c(2,n)
c     if slope is prescribed at right end, one can go directly to back-
c     substitution, since c array happens to be set up just right for it
c     at this point.
      if (ibcend - 1 > 0) go to 24
      if (ibcend - 1 == 0) go to 30
      if (n==3 .and. ibcbeg==0) go to 22
c     not-a-knot and n .ge. 3, and either n.gt.3 or  also not-a-knot at
c     left end point.
      g = c(3,n-1) + c(3,n)
      c(2,n) = ((c(3,n)+2.E0_dp*g)*c(4,n)*c(3,n-1)
     1 +c(3,n)**2*(c(1,n-1)-c(1,n-2))/c(3,n-1))/g
      g = -g/c(4,n-1)
      c(4,n) = c(3,n-1)
      go to 29
c     either (n=3 and not-a-knot also at left) or (n=2 and not not-a-
c     knot at left end point).
   22 continue
      c(2,n) = 2.E0_dp*c(4,n)
      c(4,n) = 1.E0_dp
      go to 28
c     second derivative prescribed at right endpoint.
   24 continue
      c(2,n) = 3.E0_dp*c(4,n) + c(3,n)/2.E0_dp*c(2,n)
      c(4,n) = 2.E0_dp
      go to 28
   25 continue
      if (ibcend - 1 > 0) go to 24
      if (ibcend - 1 == 0) go to 30
      if (ibcbeg > 0) go to 22
c     not-a-knot at right endpoint and at left endpoint and n = 2.
      c(2,n) = c(4,n)
      go to 30
   28 continue
      g = -1.E0_dp/c(4,n-1)
complete forward pass of gauss elimination.
   29 continue
      c(4,n) = g*c(3,n-1) + c(4,n)
      c(2,n) = (g*c(2,n-1)+c(2,n))/c(4,n)
carry out back substitution
   30 continue
      j = l
      j1 = j
      j2 = min0(1,j1)
      do j = j1, j2, -1
         c(2,j) = (c(2,j)-c(3,j)*c(2,j+1))/c(4,j)
      end do
c****** generate cubic coefficients in each interval, i.e., the deriv.s
c  at its left endpoint, from value and slope at its endpoints.
      do i = 2, n
         dtau = c(3,i)
         divdf1 = (c(1,i)-c(1,i-1))/dtau
         divdf3 = c(2,i-1) + c(2,i) - 2.E0_dp*divdf1
         c(3,i-1) = 2.E0_dp*(divdf1 - c(2,i-1)-divdf3)/dtau
         c(4,i-1) = (divdf3/dtau)*(6.E0_dp/dtau)
      end do
c
      return 
      end subroutine r8cubsplb

! 07Jun1999 fgtok -impno -s r8_precision.sub r8_names.table "r8con.csh conversion"
C  PSPLINE -- modified from SPLINE.FOR -- dmc 3 Oct 1995
C
C     THE CODES (SPLINE & SEVAL) ARE TAKEN FROM:
C     FORSYTHE,MALCOLM AND MOLER, "COMPUTER METHODS FOR
C     MATHEMATICAL COMPUTATIONS",PRENTICE-HALL, 1977.
c
c  PSPLINE -- periodic spline -- adaptation of SPLINE.FOR by D. McCune
c  October 1995:  The function to be splined is taken as having periodic
C  derivatives (it need not be periodic itself), so that
c  the interpolating function satisfies
c            y'(x(1))=y'(x(N))
c           y''(x(1))=y''(x(N))
c  this results in a fully specified system (no addl BC assumptions
c  required); it is not a tridiagonal system but a modified NM1xNM1
c  tridiagonal system with non-zero offdiagonal corner (1,NM1), (NM1,1)
c  elements.  It remains symmetric & diagonally dominant, and is
c  solved by Gaussian elimination w/o pivoting.  NM1=N-1.
c
      SUBROUTINE R8PSPLINE(N, X, Y, B, C, D, WK)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      IMPLICIT NONE
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      INTEGER N
      real*8, DIMENSION(N) :: X, Y, B, C, D, WK
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      INTEGER :: NM1, NM2, IB, I
      real*8 :: Q, T
C-----------------------------------------------
C============
C idecl:  explicitize implicit REAL declarations:
C============
C
C  THE COEFFICIENTS B(I), C(I), AND D(I), I=1,2,...,N ARE COMPUTED
C  FOR A periodic CUBIC INTERPOLATING SPLINE
C
C    S(X) = Y(I) + B(I)*(X-X(I)) + C(I)*(X-X(I))**2 + D(I)*(X-X(I))**3
C
C    FOR  X(I) .LE. X .LE. X(I+1)
C
C    WK(...) is used as a workspace during the Guassian elimination.
C    it represents the rightmost column of the array
C
C    note B(N),C(N),D(N) give coeffs for a periodic continuation into
C    the next period, up to X(N)+(X(2)-X(1)) only.
C
C    SEVAL can be used to evaluate the spline, but, it is up to the
C    SEVAL caller to bring the argument into the normal range X(1) to X(N).
C
C  INPUT..
C
C    N = THE NUMBER OF DATA POINTS OR KNOTS (N.GE.2)
C        includes a complete period of the data, the last point being
C        a repeat of the first point.
C    X = THE ABSCISSAS OF THE KNOTS IN STRICTLY INCREASING ORDER
C        X(N)-X(1) is the period of the periodic function represented.
C    Y = THE ORDINATES OF THE KNOTS
C
C  OUTPUT..
C
C    B, C, D  = ARRAYS OF SPLINE COEFFICIENTS AS DEFINED ABOVE.
C
C  USING  P  TO DENOTE DIFFERENTIATION,
C
C    Y(I) = S(X(I))
C    B(I) = SP(X(I))
C    C(I) = SPP(X(I))/2
C    D(I) = SPPP(X(I))/6  (DERIVATIVE FROM THE RIGHT)
C
CCCCCCCCCCCCCCC
C  THE ACCOMPANYING FUNCTION SUBPROGRAM  SEVAL  CAN BE USED
C  TO EVALUATE THE SPLINE.
C
C
C
C-------------------------------------
C
      NM1 = N - 1
      NM2 = NM1 - 1
C
      IF (N < 4) THEN
         WRITE (6, 9901)
 9901    FORMAT(/
     1      ' ?PSPLINE -- at least 4 pts required for periodic spline.')
         RETURN 
      ENDIF
C
C  SET UP MODIFIED NM1 x NM1 TRIDIAGONAL SYSTEM:
C  B = DIAGONAL, D = OFFDIAGONAL, C = RIGHT HAND SIDE.
C  WK(1:NM2) = rightmost column above diagonal
C  WK(NM1)   = lower left corner element
C
      D(1) = X(2) - X(1)
      D(NM1) = X(N) - X(NM1)
      B(1) = 2.0D0*(D(1)+D(NM1))
      C(1) = (Y(N)-Y(NM1))/D(NM1)
      C(2) = (Y(2)-Y(1))/D(1)
      C(1) = C(2) - C(1)
      WK(1) = D(NM1)
      D(2:NM1) = X(3:NM1+1) - X(2:NM1)
      B(2:NM1) = 2.D0*(D(:NM1-1)+D(2:NM1))
      C(3:NM1+1) = (Y(3:NM1+1)-Y(2:NM1))/D(2:NM1)
      C(2:NM1) = C(3:NM1+1) - C(2:NM1)
      WK(2:NM1) = 0.0D0
      WK(NM2) = D(NM2)
      WK(NM1) = D(NM1)
C
C  END CONDITIONS -- implied by periodicity
C     C(1)=C(N)  B(1)=B(N)  D(1)=D(N) -- no additional assumption needed.
C
C  FORWARD ELIMINATION
C   WK(1)--WK(NM2) represent the rightmost column above the
C   diagonal; WK(NM1) represents the non-zero lower left corner element
C   which in each step is moved one column to the right.
C
      DO I = 2, NM2
         T = D(I-1)/B(I-1)
         B(I) = B(I) - T*D(I-1)
         C(I) = C(I) - T*C(I-1)
         WK(I) = WK(I) - T*WK(I-1)
         Q = WK(NM1)/B(I-1)
         WK(NM1) = -Q*D(I-1)
         B(NM1) = B(NM1) - Q*WK(I-1)
         C(NM1) = C(NM1) - Q*C(I-1)
      END DO
C
C  correct the (NM1,NM2) element
C
      WK(NM1) = WK(NM1) + D(NM2)
C
C  complete the forward elimination:  now WK(NM1) and WK(NM2) are
C  the off diagonal elements of the 2x2 at the lower right hand corner
C
      T = WK(NM1)/B(NM2)
      B(NM1) = B(NM1) - T*WK(NM2)
      C(NM1) = C(NM1) - T*C(NM2)
C
C  BACK SUBSTITUTION
C
      C(NM1) = C(NM1)/B(NM1)
      C(NM2) = (C(NM2)-WK(NM2)*C(NM1))/B(NM2)
C
      DO IB = 3, NM1
         I = N - IB
         C(I) = (C(I)-D(I)*C(I+1)-WK(I)*C(NM1))/B(I)
      END DO
C
C  PERIODICITY:
C
      C(N) = C(1)
C
C  C(I) IS NOW THE SIGMA(I) OF THE TEXT
C
C  COMPUTE POLYNOMIAL COEFFICIENTS
C
      B(:NM1) = (Y(2:NM1+1)-Y(:NM1))/D(:NM1) - D(:NM1)*(C(2:NM1+1)
     1   + 2.D0*C(:NM1))
      D(:NM1) = (C(2:NM1+1)-C(:NM1))/D(:NM1)
      C(:NM1) = 3.D0*C(:NM1)
C periodic continuation...
      B(N) = B(1)
      C(N) = C(1)
      D(N) = D(1)
C
      RETURN 
      END SUBROUTINE R8PSPLINE

      subroutine dbcevl1 (x, nx, y, ny, c, ic, xl, yl, pds, ier, icalc)
c
      implicit  integer (i-n), real*8 (a-h, o-z)
c
c --- this is a special version of dbcevl, used by the ONETWO suite
c --- of subroutines. It differs from the IMSL version in the calling
c --- arguments and the calculations below are reordered for efficiency
c --- That is, many times we don't need all of the pds array. This
c --- version returns only those values of pds specifically requested
c --- using the argument icalc. This leads to about at 50% improvement
c --- in execution time. --- HSJ
c
      integer  nx,ny,ic,ier,i,j,k,km1,kp1,kp2,lxpl,lx,ly,l,lxp1
      real*8   x(*),y(*),c(2,ic,*),xl,yl,pds(6),
     .         hx,hy,sux(2),suy(2),su(2),svx(2),sv(2),sxy(2),
     .         u,v,spln0,spln1,spln2,s0,sh,sp0,sph,h,d
c
      spln0(s0,sh,sp0,sph,h,d) = s0+d*(h*sp0+d*(3.0*(sh-s0)-
     . (sph+2.0*sp0)*h+d*(2.0*(s0-sh)+(sph+sp0)*h)))
c
      spln1(s0,sh,sp0,sph,h,d) = sp0+d*(6.0 * (sh-s0)/h-2.0*
     . (sph+2.0*sp0)+3.0*d*(2.0*(s0-sh)/h+(sph+sp0)))
c
      spln2(s0,sh,sp0,sph,h,d) = 6.0 * (sh-s0)/h**2-2.0*
     . (sph+2.0*sp0)/h+d*(2.0*(s0-sh)/h**2+(sph+sp0)/h)*6.
c
      data  lx, ly /0, 0/
c
      ier = 0
c
c --- correlated table search for xl
c
      call tableintrp (x, nx, xl, lx)
      if (lx  .eq. 0 )  ier = 33
      if (lx  .eq. nx)  ier = 35
      if (ier .ne. 0 )  go to 100
c
c --- correlated table search for yl
c
      call tableintrp (y, ny, yl, ly)
      if ( ly .eq. 0 )  ier = 34
      if ( ly .eq. ny)  ier = 36
      if (ier .ne. 0 )  go to 100
c
c --- replaces the following linear search
c
****  if (xl .lt. x(1))  ier = 33
****  do 5 i=2,nx
****     lx = i-1
****     if (xl .le. x(i))  go to 10
****5 continue
****  ier = 35
***10 if (yl .lt. y(1))  ier = 34
****  do 15 j=2,ny
****     ly = j-1
****     if (yl .le. y(j))  go to 20
***15 continue
****  ier = 36
***20 if (ier .ne. 0)  go to 100
c
      lxp1 = lx+1
      hx   = x(lxp1)-x(lx)
      hy   = y(ly+1)-y(ly)
      u    = (xl-x(lx))/hx
      v    = (yl-y(ly))/hy
      k    = 2*ly
      kp1  = k+1
      kp2  = k+2
      km1  = k-1
c
      do 25 l=1,2
         lxpl = lx-1+l
         i    = 2*(ly-1+l)
         j    = i-1
         sv(l) = spln0(c(1,lxpl,km1),c(1,lxpl,kp1),c(1,lxpl,k),
     .   c(1,lxpl,kp2),hy,v)
         svx(l) = spln0(c(2,lxpl,km1),c(2,lxpl,kp1),c(2,lxpl,k),
     .   c(2,lxpl,kp2),hy,v)
      if (icalc .lt. 3)  go to 25                    ! rearranged by HSJ
         su(l) = spln0(c(1,lx,j),c(1,lxp1,j),c(2,lx,j),
     .   c(2,lxp1,j),hx,u)
         suy(l) = spln0(c(1,lx,i),c(1,lxp1,i),c(2,lx,i),
     .   c(2,lxp1,i),hx,u)
      if (icalc .lt. 4)  go to 25
         sux(l) = spln1(c(1,lx,j),c(1,lxp1,j),c(2,lx,j),
     .   c(2,lxp1,j),hx,u)
         sxy(l) = spln1(c(1,lx,i),c(1,lxp1,i),c(2,lx,i),
     .   c(2,lxp1,i),hx,u)
   25 continue
c
      pds(1) = spln0(sv(1),sv(2),svx(1),svx(2),hx,u)
      if (icalc .eq. 1)  return ! special routine only calculates pds(1)
      pds(2) = spln1(sv(1),sv(2),svx(1),svx(2),hx,u)
      if (icalc .eq. 2)  return
      pds(3) = spln1(su(1),su(2),suy(1),suy(2),hy,v)
      if (icalc .eq. 3)  return
      pds(4) = spln1(sux(1),sux(2),sxy(1),sxy(2),hy,v)
      if (icalc .eq. 4)  return
      pds(5) = spln2(sv(1),sv(2),svx(1),svx(2),hx,u)
      if (icalc .eq. 5)  return
      pds(6) = spln2(su(1),su(2),suy(1),suy(2),hy,v)
  100 if (ier .gt. 0) then
****    call uertst1 (ier, 'dbcevl')
      end if
      return
c
      end

      module Vcmnew
      use kind_spec

C...Created by Pacific-Sierra Research VAST-90 2.06G2  12:29:44   5/18/01
      use Vparam,only: nthp00,npsis,nprofm,nions,nfion,nspray,
     1             nspectm,ntheta,nuam,ntam,lrza,ngdim,nions1
      integer   kalfa,nalfa,nharm0,ibeam
      integer   idrive,kboot,mboot
      integer   ichkmc,nminor,nsp1
      integer   npar,nper,intg,inc,incf
      integer,dimension(nions) :: infi
      real(kind=dp)   betaf
      real(kind=dp)   gamat,abeam,dbeam,aneb
      real(kind=dp) trate,tratte,ttle,concte,vdrfte,umax,tnmaxe,tnmaxi
      real(kind=dp),dimension(nions) :: trati,tratti,ttli,concti,vdrfti
      real(kind=dp),dimension(nuam) :: upar
      real(kind=dp),dimension(ntam) :: uper
      real(kind=dp),dimension(nuam,ntam) :: dsfe,dsfi,fper2,fpar2,fpp2
      real(kind=dp),dimension(nprofm,4) :: epsl,binbd
      real(kind=dp),dimension(nprofm) :: dlob
      real(kind=dp),dimension(nions) :: pdi
      real(kind=dp),dimension(nfion,100) :: pdf
      real(kind=dp),dimension(nions) :: pwcm
      real(kind=dp),dimension(nfion) :: pwcf
      real(kind=dp),dimension(nprofm) :: pwc
      real(kind=dp),dimension(nprofm,nions) :: pwc1
      real(kind=dp),dimension(nprofm,nfion) :: pwc2
      real(kind=dp),dimension(nprofm) :: pwct,pwct1,pwct2,pwc0
      real(kind=dp),dimension(nprofm,ngdim) :: pwcray
      real(kind=dp),dimension(nprofm,nions,ngdim) :: pwc1ray
      real(kind=dp),dimension(nprofm,nfion,ngdim) :: pwc2ray
      real(kind=dp),dimension(nprofm,ngdim) :: pweray
      real(kind=dp),dimension(nprofm,nions,ngdim) :: pwiray
      real(kind=dp),dimension(nprofm,3,ngdim) :: pwfray
      real(kind=dp),dimension(ngdim) :: curay
      real(kind=dp),dimension(nions) :: curay1
      real(kind=dp),dimension(nfion) :: curay2
      real(kind=dp),dimension(ngdim) :: fpwray,fpowe
      real(kind=dp),dimension(nfion,ngdim) :: fpowf
      real(kind=dp),dimension(nions,ngdim) :: fpowi
      real(kind=dp),dimension(nions) :: pwti0
      real(kind=dp),dimension(ngdim) :: effcd
      real(kind=dp),dimension(nions) :: ftpowi
      real(kind=dp),dimension(nfion) :: ftpowf
      real(kind=dp),dimension(ngdim) :: pwedge,frpowi,frpowf,frpow
      real(kind=dp),dimension(nprofm) :: pwit,pwft
      real(kind=dp),dimension(nfion) :: ebkev,bmpwr,azf,atmf,densa
      real(kind=dp),dimension(nfion,nprofm) :: pnfi
      real(kind=dp),dimension(lrza,nfion) :: pnf,zetab
      real(kind=dp),dimension(nfion,nprofm,4) :: tnf
      real(kind=dp),dimension(nfion) :: ecrit,taua0,wca
      real(kind=dp),dimension(nfion,100) :: gamal
      real(kind=dp),dimension(nprofm) :: enbeam,wbeam
      real(kind=dp),dimension(nfion) :: temsa
      real(kind=dp),dimension(nfion,nprofm) :: ptfi
      real(kind=dp),dimension(nfion,nprofm,4) :: ttf
      real(kind=dp),dimension(nfion) :: wpf2c,wpf2,wcf2c,wcf1c,wcf2,wcf
      real(kind=dp),dimension(nthp00,npsis) :: cxc,czc,cy
      real(kind=dp),dimension(nprofm)::denfa,eav,tausd,tau0,paf,
     1   sordt,ecrita
      real(kind=dp),dimension(nions)::denied,tied,cwwk,cwwk1,cwwk2
      real(kind=dp),dimension(nions) ::  zalfai,cwork,deli,da4ti
      real(kind=dp),dimension(nions) ::  da2ti,da4ni,da2ni,da0ni
      real(kind=dp),dimension(nions)::wpi1c,wpi2c,wci1c,wci2c,wpi2,
     1   wci2,
     1   wci,conci,aziomi,rtzom,ay2,ay1
      real(kind=dp)   psi0,rtmime,y1c,yhc,yh,wpe1c,wpe2c,wce1c,wce2c,
     1   wpe2,wce2,wce,apzz,asxy,asxy1,asxye,adxy,adxy1,afour,
     2   atwo,azero,ar1,al1,atwoz,azeroz,a4b,a2b,a0b,a4n,a2n,
     3   a0n
      real(kind=dp)   binb,boutb,boutbrd,binbrd,epsil,wte,eta0,
     1   eta,rprof
     1   ,amprof,cprof,xjop,vloop,btbsp,ftbsps,pde,pdec,pwce,
     2   currf,currfe,currf1,currf2,pwte0,effcdt,ptot,ftpowe,
     3   ftpi,ftpf,ftedge,wfrac,pwxwl,ptedge,ptot0,fpowt,tpowi,
     4   tpowf,wfrac0
      complex gprm,cxet,czt,cztp,czetai,czi,czip,czetat,czti,cztip,cth
      end module Vcmnew

      module Vblkcof
C...Created by Pacific-Sierra Research VAST-90 2.06G2  15:06:19   5/18/01  
      real, dimension(6,3,3) :: az, bz
      real, dimension(6,3) :: akz, bkz
      end module Vblkcof

      SUBROUTINE IBCCCU(F, X, NX, Y, NY, C, IC, WK, IER)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      IMPLICIT NONE
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      INTEGER NX, NY, IC, IER
      REAL, DIMENSION(IC,1) :: F
      REAL, DIMENSION(NX) :: X
      REAL, DIMENSION(NY) :: Y
      REAL, DIMENSION(2,IC,1) :: C
      REAL, DIMENSION(2*NX*NY+2*MAX(NX,NY)) :: WK
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      INTEGER :: IWK
C-----------------------------------------------
C                                  SPECIFICATIONS FOR ARGUMENTS
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
C                                  FIRST EXECUTABLE STATEMENT
      IER = 129
      IF (IC < NX) GO TO 9000
      IER = 130
      IF (NX < 4) GO TO 9000
      IER = 131
      IF (NY < 4) GO TO 9000
      IWK = 2*NY*NX
      CALL IBCDCU (X, F, NX, NY, WK(IWK+1), WK, IC, NY, IER)
      IF (IER > 0) GO TO 9000
      CALL IBCDCU (Y, WK, NY, 2*NX, WK(IWK+1), C, NY, 2*IC, IER)
 9000 continue
      if(ier /= 0) then
        call uertst(ier, 'IBCCCU')
      end if
      RETURN 
      END SUBROUTINE IBCCCU

      module Vcombes
C...Created by Pacific-Sierra Research VAST-90 2.06G2  15:10:23   5/18/01  
      use Vparam, only: nbitab, nli
!      integer, parameter :: nbitab = 10001
!      integer, parameter :: nli = 101
      real, dimension(nbitab,0:nli - 1) :: bsir
      real, dimension(nbitab) :: xin
      end module Vcombes

      module Vbesblk
      use kind_spec

C...Created by Pacific-Sierra Research VAST-90 2.06G2  15:04:22   5/18/01
      use Vparam, only: lmx, lmn, lbes, nbsx
      real(kind=dp), dimension(nbsx,lbes) :: bestb
      end module Vbesblk

! 07Jun1999 fgtok -impno -s r8_precision.sub r8_names.table "r8con.csh conversion"
c  cspline -- dmc 15 Feb 1999
c
c  a standard interface to various 1d spline setup routines
c
      subroutine r8cspline(x, nx, fspl, ibcxmin, bcxmin, ibcxmax, bcxmax
     1   , wk, iwk, ilinx, ier)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nx, ibcxmin, ibcxmax, iwk, ilinx, ier
      real(kind=dp) bcxmin, bcxmax
      real(kind=dp), dimension(nx) :: x
      real(kind=dp), dimension(4,nx) :: fspl
      real(kind=dp), dimension(iwk) :: wk
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: ierx, inum, ix
      real(kind=dp) :: xo2, xo6
C-----------------------------------------------
C============
C idecl:  explicitize implicit INTEGER declarations:
C============
C idecl:  explicitize implicit real(kind=dp) declarations:
C============
c
c  ** note wk(...) array is not used unless ibcxmin=-1 (periodic spline
c  evaluation)
c
c  this routine computes spline coefficients for a 1d spline --
c  evaluation of the spline can be done by cspeval.for subroutines
c  or directly by inline code.
c
c  the input x axis x(1...nx) must be strictly ascending, i.e.
c  x(i+1).gt.x(i) is required for i=1 to nx-1.  This is checked and
c  ier=1 is set and the routine exits if the test is not satisfied.
c
c  on output, ilinx=1 is set if, to a reasonably close tolerance,
c  all grid spacings x(i+1)-x(i) are equal.  This allows a speedier
c  grid lookup algorithm on evaluation of the spline.  If on output
c  ilinx=2, this means the spline x axis is not evenly spaced.
c
c  the input data for the spline are given in f[j] = fspl(1,j).  The
c  output data are the spline coefficients fspl(2,j),fspl(3,j), and
c  fspl(4,j), j=1 to nx.  The result is a spline s(x) satisfying the
c  boundary conditions and with the properties
c
c     s(x(j)) = f(1,j)
c     s'(x) is continuous even at the grid points x(j)
c     s''(x) is continuous even at the grid points x(j)
c
c  the formula for evaluation of s(x) is:
c
c     let dx = x-x(i), where x(i).le.x.le.x(i+1).  Then,
c     s(x)=f(1,i) + dx*(f(2,i) +dx*(f(3,i) + dx*f(4,i)))
c
c  ==>boundary conditions.  Complete specification of a 1d spline
c  requires specification of boundary conditions at x(1) and x(nx).
c
c  this routine provides 4 options:
c
c  ibcxmin=-1  --  periodic boundary condition.  This means the
c    boundary conditions s'(x(1))=s'(x(nx)) and s''(x(1))=s''(x(nx))
c    are imposed.  Note that s(x(1))=s(x(nx)) (i.e. f(1,1)=f(1,nx))
c    is not required -- that is determined by the f array input data.
c    The periodic boundary condition is to be preferred for periodic
c    data.  When splining periodic data f(x) with period P, the relation
c    x(nx)=x(1)+n*P, n = the number of periods (usually 1), should hold.
c    (ibcxmax, bcxmin, bcxmax are ignored).
c
c  if a periodic boundary condition is set, this covers both boundaries.
c  for the other types of boundary conditions, the type of condition
c  chosen for the x(1) boundary need not be the same as the type chosen
c  for the x(nx) boundary.
c
c  ibcxmin=0 | ibcxmax=0 -- this specifies a "not a knot" boundary
c    condition -- see cubsplb.for.  This is a common way for inferring
c    a "good" spline boundary condition automatically from data in the
c    vicinity of the boundary.  (bcxmin | bcxmax are ignored).
c
c  ibcxmin=1 | ibcxmax=1 -- boundary condition is to have s'(x(1)) |
c    s'(x(nx)) match the passed value (bcxmin | bcxmax).
c
c  ibcxmin=2 | ibcxmax=2 -- boundary condition is to have s''(x(1)) |
c    s''(x(nx)) match the passed value (bcxmin | bcxmax).
c
c---------------------------------------------------------------------
c  error checks
c
      ier = 0
      if (nx < 4) then
         write (6, '('' ?cspline:  at least 4 x points required.'')')
         ier = 1
      endif
      call ibc_ck (ibcxmin, 'cspline', 'xmin', -1, 2, ier)
      if (ibcxmin >= 0) call ibc_ck (ibcxmax, 'cspline', 'xmax', 0, 2, 
     1   ier)
c
c  x axis check
c
      call r8splinck (x, nx, ilinx, 0.001, ierx)
      if (ierx /= 0) ier = 2
      if (ier == 2) write (6, 
     1   '('' ?cspline:  x axis not strict ascending'')')
c
      if (ibcxmin == (-1)) then
         inum = 5*nx
         if (iwk < inum) then
            write (6, 1009) inum, iwk, nx
 1009       format(' ?cspline:  workspace too small.  need:  ',i6,
     1         ' got:  ',i6/'  (need = 5*nx, nx=',i6)
            ier = 3
         endif
      endif
c
      if (ier /= 0) return 
c
c  OK -- evaluate spline
c
      if (ibcxmin == (-1)) then
         call r8cpspline (x, nx, fspl, wk)       ! periodic spline
      else
         xo2 = 0.5E0_dp
         xo6 = 1.0E0_dp/6.0E0_dp
c  use cubsplb, then fix coefficients as
         fspl(2,1) = bcxmin
         fspl(2,nx) = bcxmax
         call r8cubsplb (x, fspl, nx, ibcxmin, ibcxmax)
         fspl(3,:nx) = fspl(3,:nx)*xo2
         fspl(4,:nx) = fspl(4,:nx)*xo6
      endif
C
      return 
      end subroutine r8cspline
c--------------------------
c  interface to pspline -- periodic spline
c
      subroutine r8cpspline(x, nx, fspl, wk)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nx
      real(kind=dp), dimension(nx) :: x
      real(kind=dp), dimension(4,nx) :: fspl
      real(kind=dp), dimension(nx,5) :: wk
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: ix
C-----------------------------------------------
C============
C idecl:  explicitize implicit INTEGER declarations:
C============
c
c  the coding is tricky, because the caller wants the spline coefficients
c  contigously packed, but pspline wants the data contiguously packed.
c
      wk(:nx,1) = fspl(1,:nx)
c
      call r8pspline (nx, x, wk(1,1), wk(1,2), wk(1,3), wk(1,4), wk(1,5)
     1   )
c
c  ok move stuff back into place
c
      fspl(2,:nx) = wk(:nx,2)
      fspl(3,:nx) = wk(:nx,3)
      fspl(4,:nx) = wk(:nx,4)
c
      return 
      end subroutine r8cpspline

C   IMSL ROUTINE NAME   - ICSCCU
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JUNE 1, 1980
C
C   PURPOSE             - CUBIC SPLINE INTERPOLATION
C                           (EASY-TO-USE VERSION)
C
C   USAGE               - CALL ICSCCU (X,Y,NX,C,IC,IER)
C
C   ARGUMENTS    X      - VECTOR OF LENGTH NX CONTAINING THE ABSCISSAE
C                           OF THE NX DATA POINTS (X(I),Y(I)) I=1,...,
C                           NX. (INPUT) X MUST BE ORDERED SO THAT
C                           X(I) .LT. X(I+1).
C                Y      - VECTOR OF LENGTH NX CONTAINING THE ORDINATES
C                           (OR FUNCTION VALUES) OF THE NX DATA POINTS.
C                           (INPUT)
C                NX     - NUMBER OF ELEMENTS IN X AND Y. (INPUT) NX
C                           MUST BE .GE. 2.
C                C      - SPLINE COEFFICIENTS. (OUTPUT) C IS AN NX-1 BY
C                           3 MATRIX. THE VALUE OF THE SPLINE
C                           APPROXIMATION AT T IS
C                           S(T) = ((C(I,3)*D+C(I,2))*D+C(I,1))*D+Y(I)
C                           WHERE X(I) .LE. T .LT. X(I+1) AND
C                           D = T-X(I).
C                IC     - ROW DIMENSION OF MATRIX C EXACTLY AS
C                           SPECIFIED IN THE DIMENSION STATEMENT IN
C                           THE CALLING PROGRAM. (INPUT)
C                IER    - ERROR PARAMETER. (OUTPUT)
C                         TERMINAL ERROR
C                           IER = 129, IC IS LESS THAN NX-1.
C                           IER = 130, NX IS LESS THAN 2.
C                           IER = 131, INPUT ABSCISSA ARE NOT ORDERED
C                             SO THAT X(1) .LT. X(2) ... .LT. X(NX).
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1980 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE ICSCCU (X,Y,NX,C,IC,IER)
C                                  SPECIFICATIONS FOR ARGUMENTS
      INTEGER            NX,IC,IER
      REAL               X(NX),Y(NX),C(IC,3)
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      INTEGER            IM1,I,JJ,J,MM1,MP1,M,NM1,NM2
      REAL               DIVDF1,DIVDF3,DTAU,G,CNX(3)
C                                  FIRST EXECUTABLE STATEMENT
      NM1 = NX-1
      IER = 129
      IF (IC .LT. NM1) GO TO 9000
      IER = 130
      IF (NX .LT. 2) GO TO 9000
      IER = 131
      IF (NX .EQ. 2) GO TO 45
C                                  COMPUTE NOT-A-KNOT SPLINE
      DO 5 M = 2,NM1
         MM1=M-1
         C(M,2) = X(M)-X(MM1)
         IF (C(M,2).LE.0.0) GO TO 9000
         C(M,3) = (Y(M)-Y(MM1))/C(M,2)
    5 CONTINUE
      CNX(2) = X(NX)-X(NM1)
      IF (CNX(2).LE.0.0) GO TO 9000
      CNX(3) = (Y(NX)-Y(NM1))/CNX(2)
      IER = 0
      NM2 = NX-2
      IF (NX .GT. 3) GO TO 10
      C(1,3) = CNX(2)
      C(1,2) = C(2,2)+CNX(2)
      C(1,1) = ((C(2,2)+2.*C(1,2))*C(2,3)*CNX(2)+C(2,2)**2*CNX(3))
     1/C(1,2)
      GO TO 20
   10 C(1,3) = C(3,2)
      C(1,2) = C(2,2)+C(3,2)
      C(1,1) = ((C(2,2)+2.*C(1,2))*C(2,3)*C(3,2)+C(2,2)**2*C(3,3))
     1/C(1,2)
      DO 15 M=2,NM2
         MP1=M+1
         MM1=M-1
         G = -C(MP1,2)/C(MM1,3)
         C(M,1) = G*C(MM1,1)+3.*C(M,2)*C(MP1,3)+3.*C(MP1,2)*C(M,3)
         C(M,3) = G*C(MM1,2)+2.*C(M,2)+2.*C(MP1,2)
   15 CONTINUE
   20 G = -CNX(2)/C(NM2,3)
      C(NM1,1) = G*C(NM2,1)+3.*C(NM1,2)*CNX(3)+3.*CNX(2)*C(NM1,3)
      C(NM1,3) = G*C(NM2,2)+2.*C(NM1,2)+2.*CNX(2)
      IF (NX.GT.3) GO TO 25
      CNX(1)=2.*CNX(3)
      CNX(3)=1.
      G=-1./C(NM1,3)
      GO TO 30
   25 G = C(NM1,2)+CNX(2)
      CNX(1) = ((CNX(2)+2.*G)*CNX(3)*C(NM1,2)+CNX(2)**2*
     1(Y(NM1)-Y(NX-2))/C(NM1,2))/G
      G = -G/C(NM1,3)
      CNX(3) = C(NM1,2)
   30 CNX(3) = G*C(NM1,2)+CNX(3)
      CNX(1) = (G*C(NM1,1)+CNX(1))/CNX(3)
      C(NM1,1) = (C(NM1,1)-C(NM1,2)*CNX(1))/C(NM1,3)
      DO 35 JJ=1,NM2
         J = NM1-JJ
         C(J,1) = (C(J,1)-C(J,2)*C(J+1,1))/C(J,3)
   35 CONTINUE
      DO 40 I=2,NM1
         IM1 = I-1
         DTAU = C(I,2)
         DIVDF1 = (Y(I)-Y(IM1))/DTAU
         DIVDF3 = C(IM1,1)+C(I,1)-2.*DIVDF1
         C(IM1,2) = (DIVDF1-C(IM1,1)-DIVDF3)/DTAU
         C(IM1,3) = DIVDF3/DTAU**2
   40 CONTINUE
      DTAU = CNX(2)
      DIVDF1 = (Y(NX)-Y(NM1))/DTAU
      DIVDF3 = C(NM1,1)+CNX(1)-2.*DIVDF1
      C(NM1,2) = (DIVDF1-C(NM1,1)-DIVDF3)/DTAU
      C(NM1,3) = DIVDF3/DTAU**2
      GO TO 9005
   45 IF (X(1) .GE. X(2)) GO TO 9000
      IER = 0
      C(1,1) = (Y(2)-Y(1))/(X(2)-X(1))
      C(1,2) = 0.0
      C(1,3) = 0.0
      GO TO 9005
 9000 CONTINUE
      CALL UERTST(IER,'ICSCCU')
 9005 RETURN
      END

! 07Jun1999 fgtok -impno -s r8_precision.sub r8_names.table "r8con.csh conversion"
      subroutine r8splinck(x,inx,ilinx,ztol,ier)
C
C  check if a grid is strictly ascending and if it is evenly spaced
C  to w/in ztol
C
      IMPLICIT NONE
C============
C idecl:  explicitize implicit INTEGER declarations:
      INTEGER inx,ix
C============
C idecl:  explicitize implicit REAL declarations:
      REAL*8 dxavg,zeps,zdiffx,zdiff
C============
      REAL*8 x(inx)                       ! input -- grid to check
C
      integer ilinx                     ! output -- =1 if evenly spaced =2 O.W.
C
      REAL*8 ztol                         ! input -- spacing check tolerance
C
      integer ier                       ! output -- =0 if OK
C
C  ier=1 is returned if x(1...inx) is NOT STRICTLY ASCENDING...
C
C-------------------------------
C
      ier=0
      ilinx=1
      if(inx.le.1) return
c
      dxavg=(x(inx)-x(1))/(inx-1)
      zeps=abs(ztol*dxavg)
c
      do ix=2,inx
         zdiffx=(x(ix)-x(ix-1))
         if(zdiffx.le.0.0D0) ier=2
         zdiff=zdiffx-dxavg
         if(abs(zdiff).gt.zeps) then
            ilinx=2
         endif
      enddo
 10   continue
c
      return
      end

      module Vrealterp
      implicit none
c
      contains
      function terp (g1, g2, g3, g4)
      use Vterppars, only: a12, a13, a14, a23, a24, a34
      implicit none
      real terp
      real :: g1,g2,g3,g4
      terp = (1./a12 + 1./a13 + 1./a14)*g1 - a13*a14/(a12*a23*a24)*g2 + 
     1   a12*a14/(a13*a23*a34)*g3 - a12*a13/(a14*a24*a34)*g4
      return 
      end function terp
c      
      end module Vrealterp

C   IMSL ROUTINE NAME   - UGETIO
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JUNE 1, 1981
C
C   PURPOSE             - TO RETRIEVE CURRENT VALUES AND TO SET NEW
C                           VALUES FOR INPUT AND OUTPUT UNIT
C                           IDENTIFIERS.
C
C   USAGE               - CALL UGETIO(IOPT,NIN,NOUT)
C
C   ARGUMENTS    IOPT   - OPTION PARAMETER. (INPUT)
C                           IF IOPT=1, THE CURRENT INPUT AND OUTPUT
C                           UNIT IDENTIFIER VALUES ARE RETURNED IN NIN
C                           AND NOUT, RESPECTIVELY.
C                           IF IOPT=2, THE INTERNAL VALUE OF NIN IS
C                           RESET FOR SUBSEQUENT USE.
C                           IF IOPT=3, THE INTERNAL VALUE OF NOUT IS
C                           RESET FOR SUBSEQUENT USE.
C                NIN    - INPUT UNIT IDENTIFIER.
C                           OUTPUT IF IOPT=1, INPUT IF IOPT=2.
C                NOUT   - OUTPUT UNIT IDENTIFIER.
C                           OUTPUT IF IOPT=1, INPUT IF IOPT=3.
C
C   PRECISION/HARDWARE  - SINGLE/ALL
C
C   REQD. IMSL ROUTINES - NONE REQUIRED
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   REMARKS      EACH IMSL ROUTINE THAT PERFORMS INPUT AND/OR OUTPUT
C                OPERATIONS CALLS UGETIO TO OBTAIN THE CURRENT UNIT
C                IDENTIFIER VALUES. IF UGETIO IS CALLED WITH IOPT=2 OR
C                IOPT=3, NEW UNIT IDENTIFIER VALUES ARE ESTABLISHED.
C                SUBSEQUENT INPUT/OUTPUT IS PERFORMED ON THE NEW UNITS.
C
C   COPYRIGHT           - 1978 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE UGETIO(IOPT,NIN,NOUT)
C                                  SPECIFICATIONS FOR ARGUMENTS
      INTEGER            IOPT,NIN,NOUT
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      INTEGER            NIND,NOUTD
      DATA               NIND/1/,NOUTD/2/
C                                  FIRST EXECUTABLE STATEMENT
      IF (IOPT.EQ.3) GO TO 10
      IF (IOPT.EQ.2) GO TO 5
      IF (IOPT.NE.1) GO TO 9005
      NIN = NIND
      NOUT = NOUTD
      GO TO 9005
    5 NIND = NIN
      GO TO 9005
   10 NOUTD = NOUT
 9005 RETURN
      END

c
c  This module contains controlling routines
c
c---------------------------------------------------
      subroutine adjint(ientry)
      use Vdynamic
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:51:36   6/14/01  
C...Switches: -p4 -yb
c--------------------
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vdynamic
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang, 
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec, 
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3, 
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti, 
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin, 
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril, 
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref, 
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep, 
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr, 
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite, 
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1, 
     1   gamene1, presfr
      use Vcraylh
      use Vceqdsk, ONLY: ntitle, dat, ipestg, nxeqd, nzeqd, xdimeqd, 
     1   zdimeqd, reqd, redeqd, zmideqd, xma, zma, psimag, psilim, 
     2   beqd, toteqd, psimx1, psimx2, xax1, xax2, zax1, zax2, psisep, 
     3   xsep, zsep, feqd, presseqd, ffpeqd, ppeqd, peqd, qeqd, xeqd, 
     4   zeqd, psiadj, dpolflx, psieqd, tpsieqd, tpsifeqd, iounit1, 
     5   inoperm1, nptsdm1, nptsd, torflux, tpsisav, ra, psifra, 
     6   dpsifra, fra, fra1, cspln, pds, wnoperm, xcontr, zcontr, 
     7   bpcontr, btcontr, dstarp, b_fld, jacob, pprime, vprime, 
     8   chipsi, ncontr, dang, bperr, arcl, thet, anglex, csplnx, 
     9   csplnz, pdsx, pdsz, nlim, rlim, zlim, nlimiter, rlimiter, 
     .   zlimiter, lrz, nprim, nimp, nion, nti, zi, zeffz, r, raeqd, 
     1   psifeqd, te, ti, ti1, ene, enp, bmod, rmd, btmd, bpmd, btpmd, 
     2   roa
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer ientry
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: nw, nthp, ns, js, jp, jps
      real :: zef1, dt, alpha, rho
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i
 
c-------------------------
c  inputs from Comraylh:  nthp0,npsi0,psimx,psimn (bavorbt)
c                         nmax,umax1,imax,lmax,tmax     (subadj)
c                         nthp0,npsi0,psimx,psimn,nmax,umax,imax,
c                         lmax,nwp,wpmx,nthp1      (curadj)
c  open-close I/O channels: (i) iout3 (adjinp) (bavorbt,subadj)
c                           (ii)iout4 (scrach) (bavorbt,subadj,curadj)
c                          (iii)iout5 (adjout) (subadj,curadj)
c                           (v) iout6 (joptab)  (curint)
c                       (v)  iout7  (scrach1)  (runb: input chi-trial)
c                       (vi) iout8  (scrach2)  (runb: output chi-trial)
c
c outputs to Comraylh: If ientry=3, output jop(nwp,nthp1,npsi0),psis(npsi0),
c                        eden(npsi0),etem(npsi0),zefi(npsi0),
c                        thetp(nthp1),wp(nwp)
c                       use high beta approximation;
c                     (also outputs these to 'joptabh')
c
c----------------------------------
c------------------    1/22/96
c   set nwp,nthp1,npsi0
c
      select case (ientry) 
      case default
c----------------
c  assume nthp0,npsi0,psimx,psimn already known
c
         call bavorbt
c     fclose(iout3)
         return 
      case (2) 
c----------------
c  get Spitzer-function table
c
         call subadj (zef1, nmax, umax1, imax, nthp0, dt, tmax, alpha, 
     1      rho, lmax, iout3, iout5, iout4, iout7, iout8, iswchi, aerrmx
     2      , rerrmx)
c     fclose(iout3)
c     fclose(iout5)
         return 
      case (3) 
c--------------------------
c  get j/p table
c
         iadj = 1
         call curadj (nthp0, npsi0, psimx, psimn, nmax, umax1, imax, 
     1      lmax, psis(1), eden(1), etem(1), zefi(1), sjop(1), nwp, wpmx
     2      , wpmn, dwp, wp(1), nthp1, thetp(1), iout4, iout5, iadj, 
     3      gwk2, gwk3, npnta)
         write (iout6, 1000) jopid
         write (iout6, 1010) nwp, nthp0, npsi0, nthp1
         write (iout6, 1020) psimx, psimn, wpmx, wpmn, dwp
         write (iout6, 1030) (wp(nw),nw=1,nwp)
         write (iout6, 1030) (thetp(nthp),nthp=1,nthp1)
         write (iout6, 1030) (psis(ns),ns=1,npsi0)
         write (iout6, 1030) (eden(ns),ns=1,npsi0)
         write (iout6, 1030) (etem(ns),ns=1,npsi0)
         write (iout6, 1030) (zefi(ns),ns=1,npsi0)
         do js = 1, npsi0
            do jp = 1, nthp1
               jps = (js - 1)*nthp1*nwp + (jp - 1)*nwp + 1
               write (iout6, 1030) (sjop(nw),nw=jps,jps + nwp - 1)
            end do
         end do
c--------------------------------
 1000    format(1x,1a40)
 1010    format(1x,4i8)
 1020    format(5(1x,e18.10))
 1030    format(5(1x,e18.10))
c------------------------
         return 
      end select
      end subroutine adjint
      subroutine master(ientry)
      use Vdynamic
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:51:36   6/14/01  
C...Switches: -p4 -yb
c
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vdynamic
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang, 
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec, 
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3, 
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti, 
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin, 
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril, 
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref, 
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep, 
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr, 
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite, 
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1, 
     1   gamene1, presfr
      use Vcraylh
      use Vceqdsk
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer ientry
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: iercg, iercn, iercm, iercl, ierch
      real :: stat
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c
c
c ************ ************ ************ ************ ************
c
c   plasma parameters and initialisation
c
c ************ ************ ************ ************
c
c     Commented out: May 7,1991 (bh).  Put call in br_go, before call master.
c           if (initlh.ne.1)  call inital
c
      select case (ientry) 
      case default
c      call hpalloc(aspinptr,npsi0,iercg,1)
         if (.not.allocated(aspin)) then
            ALLOCATE(aspin(npsi0),stat=iercg)
            if (iercg /= 0) then
               print *, 'aspin could not be allocated in master'
               return 
            endif
         endif
         call adjint (1)
         call vbak
         rewind iout3
         if (idcur == 3) then
            call adjint (2)
            rewind iout3
            rewind iout5
            joplg = nwp*nthp1*npsi0
c        call hpalloc(sjopptr,joplg,iercn,1)
            if (.not.allocated(sjop)) then
               ALLOCATE(sjop(joplg),stat=iercn)
               if (iercn /= 0) then
                  print *, 'sjop could not be allocated in master'
                  return 
               endif
            endif
c        call hpalloc(aspinptr,npsi0,iercm,1)
            if (.not.allocated(aspin)) then
               ALLOCATE(aspin(npsi0),stat=iercm)
               if (iercm /= 0) then
                  print *, 'aspin could not be allocated in master'
                  return 
               endif
            endif
c        call hpalloc(wpptr,nwp,iercl,1)
            if (.not.allocated(wp)) then
               ALLOCATE(wp(nwp),stat=iercl)
               if (iercl /= 0) then
                  print *, 'wp could not be allocated in master'
                  return 
               endif
            endif
c        call hpalloc(thetpptr,nthp1,ierch,1)
            if (.not.allocated(thetp)) then
               ALLOCATE(thetp(nthp1),stat=ierch)
               if (ierch /= 0) then
                  print *, 'thetp could not be allocated in master'
                  return 
               endif
            endif
            call adjint (3)
            rewind iout4
            rewind iout5
c        rewind iout6
         endif
         return 
      case (2) 
         joplg = nwp*nthp1*npsi0
c        call hpalloc(sjopptr,joplg,iercn,1)
         if (.not.allocated(sjop)) then
            ALLOCATE(sjop(joplg),stat=iercn)
            if (iercn /= 0) then
               print *, 'sjop could not be allocated in master'
               return 
            endif
         endif
c        call hpalloc(aspinptr,npsi0,iercm,1)
         if (.not.allocated(aspin)) then
            ALLOCATE(aspin(npsi0),stat=iercm)
            if (iercm /= 0) then
               print *, 'aspin could not be allocated in master'
               return 
            endif
         endif
c        call hpalloc(wpptr,nwp,iercl,1)
         if (.not.allocated(wp)) then
            ALLOCATE(wp(nwp),stat=iercl)
            if (iercl /= 0) then
               print *, 'wp could not be allocated in master'
               return 
            endif
         endif
c        call hpalloc(thetpptr,nthp1,ierch,1)
         if (.not.allocated(thetp)) then
            ALLOCATE(thetp(nthp1),stat=ierch)
            if (ierch /= 0) then
               print *, 'thetp could not be allocated in master'
               return 
            endif
         endif
         call adjint (3)
         rewind iout4
         rewind iout5
         return 
      case (3) 
         if (istop /= 0) go to 9000
c***************************************
c   SCC  5/20/96  for tabulation
c
         if (idcur == 3) then
            dpsis = (psimx - psimn)/(npsi0 - 1)
            dwp = (wpmx - wpmn)/(nwp - 1)
            dthp1 = 8.E0*atan(1.E0)/(nthp1 - 1)
            mthwp = nthp1*nwp
            nthp11 = nthp1 - 1
            nthp12 = nthp1 - 2
            npsi01 = npsi0 - 1
            npsi02 = npsi0 - 2
            nwp1 = nwp - 1
            nwp2 = nwp - 2
         endif
c----------------------
c    idcur=1    Ehst-Karney model
c         =2    not working
c         =3    direct adj integration
c------------------------
c
c ************ ************ ************ ************
c
c   printout of the run parameters
c
c ************ ************ ************ ************
c
         call outrun (1)
c
         if (igraph /= 0) call outgra(1)
         call pwicpl
c
c ************ ************ ************ ************
c
c   main ray tracing subroutine
c
c ************ ************ ************ ************
c
         call raytr
c
c ************ ************ ************ ************
c
c   print out of the power deposition profiles and
c             graphical output
c
c ************ ************ ************ ************
c
         call outrun (2)
c
         if (igraph == 0) return 
c
         call outgra(3)
c
         return 
      case (4) 
c        call hpalloc (aspinptr, npsi0, iercg, 1)
c        call hpalloc(thetpptr,nthp1,ierch,1)
         if (.not.allocated(aspin)) then
            ALLOCATE(aspin(npsi0),stat=ierch)
            if (ierch /= 0) then
               print *, 'aspin could not be allocated in master'
               return 
            endif
         endif
         call adjint (1)
         call vbak
         rewind iout3
         return 
      end select
c
c ************ ************ ************ ************
c
c   break point in case of inconsistent data
c
c ************ ************ ************ ************
c
 9000 continue
      stop 
c
c ************ ************ ************ ************
c
      end subroutine master
c
      subroutine output1(x)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:51:36   6/14/01  
C...Switches: -p4 -yb
c
c ************ ************ ************ ************ ************
c
c         Revised by S.C.Chiu July 10,1991.
c         test for modified F-S-wave turning point
c         provision for IBW-FW mode conversion reserved in FWIBMC
c     Normal version
C--------------------------------
c   output of the integrating subroutine
c   tests for confluence,lin. turning point, absorption
c
c ************ ************ ************ ************ ************
c
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang, 
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec, 
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3, 
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti, 
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin, 
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril, 
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref, 
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep, 
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr, 
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite, 
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1, 
     1   gamene1, presfr, epserr, epser1, epsray, iout
      use Vcraylh
      use Vceqdsk
      use Vchpcsd
      use Vcmnew
      use Vcgraphs, only: initlh, nraypts
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real x
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, ly
      real, dimension(nions) :: zgami
      real :: zpi, znpol, zntor, zconf, error, thg, phg, zgame
C-----------------------------------------------
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
c      real , EXTERNAL :: exp, alog
c      real :: exp, alog
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c
c   Comhpcsd
c
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c
c ************ ************ ************ ************ ************
c
c
c ************ ************ ************ ************ ************
c
      data zpi/3.14159265359/
c
c ************ ************ ************ ************ ************
c  phase and position in m
c ************ ************ ************ ************
      eikon = x/(2.*zpi)
      pwx = y(6)
      pwx = exp(y(6))
      znpol = theta/(2.*zpi)
      zntor = phi/(2.*zpi)
c $$$$$$$$$$$$ Added by TK Mau, 8/28/91.
      irec = irec + 1
      if (irec < nraym) then
         rec0(irec) = psi
c     rec1(irec) = znpol
         rec1(irec) = gami(2)
c     rec2(irec) = zntor
         rec2(irec) = gamip(2)
         rec3(irec) = serror
         rec4(irec) = pkpar
         rec5(irec) = pkp2
         rec6(irec) = pwx
         rec7(irec) = game
         rec8(irec) = gamit
         rec12(irec) = 1./wci(1)
         rec13(irec) = dense*1.E-13
         rec14(irec) = tempe
         rec15(irec) = xe
      else
         if (irec < nplus) rec6(irec) = pwx
      endif
c $$$$$$$$$$$$
c ************ ************ ************ ************
c   failure to maintain the required accuracy
c ************ ************ ************ ************
      zconf = amax1(abs(hc),abs(hb*pkp2))
      error = abs(disph/zconf)
      serror = error
      if (error>=epser1 .and. error<=epserr) call mflag (5)
      if (jhlf>20 .or. error>epserr) then
         call mflag (1)
c     if(abs(dy(2)/dy(4)).lt.0.001)  go to 60
         write (iout, 9010) znpol, zntor, psi, error, hlast, jhlf
c ************ ************ ************ ************
c   power deposited since the last step
c ************ ************ ************ ************
c
      endif
      call absorb
c******************SCC  5/5/95
      if (irec > irecmx) call mflag (3)
c******************************
c####################################
c  July 8,1991
      if (ichois == 1) then
c####################################
c
         if (iprint /= 3) then
            if (x > prmt(2) + 0.001*hlast) return 
c ************ ************ ************ ************
c   the ray reaches the wall
c ************ ************ ************ ************
c**************2/14/95  SCC
         endif
         if (y(2) < psilast) go to 30
         if (dy(2) <= 0.) go to 30
         write (iout, 1150) eikon, znpol, zntor, psi
         call mflag (2)
c        nurefl =nurefl+1
c     if(nurefl.ge.maxref)  call mflag(3)
         go to 100
c ************ ************ ************ ************
c  tests for radial reflection
c ************ ************ ************ ************
   30    continue
         if (dy(2)/dkdrin <= 0.) then
            dkdrin = -dkdrin
c ************ ************ ************ ************
c  wispering gallery reflection
c ************ ************ ************ ************
c     if(pkpsi*akrini.gt.0.) go to 60
            if (pkpsi*akrini <= 0.) then
               akrini = -akrini
               if (dkdrin >= 0.) then
c  internal
                  write (iout, 1110) eikon, znpol, zntor, psi
               else
c  at cutoff
                  write (iout, 1115) eikon, znpol, zntor, psi
                  nurefl = nurefl + 1
                  if (nurefl >= maxref) call mflag (3)
c ************ ************ ************ ************
c   test on the kind of confluence (eliminated 7/17/95)
c ************ ************ ************ ************
c##############  SCC 6/01/92  7/17/95
c 60      if (ichois.eq.1) then
c        twoqu = ha/(3.*alfa) - pkp2
c         else
c          twoqu = atwo**2 - 4.*asxy1*azero
c         endif
c######################
c     if(twoqu)  70,70,80
c ************ ************ ************ ************
c   linear turning point
c ************ ************ ************ ************
c  70 write(iout,1120)  eikon,znpol,zntor,psi
c         call mflag(4)
c
c           call absorb
c
c     go to 100
c ************ ************ ************ ************
c   confluence slow-fast wave
c ************ ************ ************ ************
c  80 write(iout,1130)  eikon,znpol,zntor,psi
c        jslofa = -jslofa
c ************ ************ ************ ************
c   is the power completely absorbed
c ************ ************ ************ ************
c---------------SCC  6/15/95
               endif
            endif
         endif
         if (pwx > epsray*power/float(nnztot*nthin)) go to 100
c--------------------
         call mflag (3)
         write (iout, 1140) eikon, znpol, zntor, psi
         go to 100
c############################################
c  July 8,1991
      endif
      if (iprint /= 3) then
         if (x > prmt(2) + 0.001*hlast) return 
c ************ ************ ************ ************
c   the ray reaches the wall
c ************ ************ ************ ************
c*****************SCC  2/16/95
      endif
      if (y(2) < psilast) go to 230
      if (dy(2) <= 0.) go to 230
      write (iout, 1150) eikon, znpol, zntor, psi
      call mflag (2)
c         nurefl = nurefl+1
c     if(nurefl.ge.maxref)  call mflag(3)
      go to 100
c ************ ************ ************ ************
c  tests for radial reflection
c ************ ************ ************ ************
  230 continue
      if (dy(2)/dkdrin <= 0.) then
         dkdrin = -dkdrin
c ************ ************ ************ ************
c  wispering gallery reflection
c ************ ************ ************ ************
c     if(pkpsi*akrini.gt.0.) go to 260
         if (pkpsi*akrini <= 0.) then
            akrini = -akrini
            if (dkdrin >= 0.) then
c  internal
               write (iout, 1110) eikon, znpol, zntor, psi
            else
c  at cutoff
               write (iout, 1115) eikon, znpol, zntor, psi
               nurefl = nurefl + 1
               call wloss
               pwx = exp(y(6))
               pwxwl = (1. - wfrac)*pwx
               pwedge(indgr) = pwedge(indgr) + pwxwl
               pwx = wfrac*pwx
!               y(6) = alog(pwx)
               y(6) =  log(pwx)
               powold = powold - pwxwl
               if (nurefl >= maxref) call mflag (3)
c ************ ************ ************ ************
c   test on the kind of confluence
c ************ ************ ************ ************
c260      continue
c        if (ichkmc.eq.1) then
c ************ ************ ************ ************
c   check for
c   linear turning point
c ************ ************ ************ ************
c     call FWIBMC(iflg)
c     if (iflg.eq.1) then
c 270 write(iout,1120)  eikon,znpol,zntor,psi
c         call mflag(4)
c
c           call absorb
c             endif
c
c     go to 100
c      else
c        twoqu=pkp2-0.5*atwo/asxy1
c        if (twoqu.ge.0.) then
c ************ ************ ************ ************
c   confluence slow-fast wave
c ************ ************ ************ ************
c 280 write(iout,1130)  eikon,znpol,zntor,psi
c        jslofa = -jslofa
c        endif
c     endif
c ************ ************ ************ ************
c   is the power completely absorbed
c ************ ************ ************ ************
c-------------SCC  6/15/95
            endif
         endif
      endif
      if (pwx <= epsray*power/float(nnztot*nthin)) then
c----------------------
         call mflag (3)
         write (iout, 1140) eikon, znpol, zntor, psi
c#########################################
c **************************************************
c  printout control
c ************ ************ ************ ************
      endif
  100 continue
      xu = ux/ukzero
      zu = uz/ukzero
      if (prmt(5)/=0. .or. x==0.) go to 120
      if (iprint > 2) go to 120
      if (x > prmt(1)) return 
c 110 if(iprint.eq.0)  go to 170
      if (iprint <= 0) go to 170
c ************ ************ ************ ************
c   normal output
c ************ ************ ************ ************
  120 continue
      thg = theta*180./zpi
      phg = phi*180./zpi
      write (iout, 1010) eikon, psi, thg, phg, xu, zu
      write (iout, 1030) pkpar, pkp, pkpsi, pktau, pwx
      if (iprint > 1) then
         write (iout, 1040) pkheta, pkx, pkz, pkp2
         write (iout, 1020) dense, tempe, tempi(mainsp), btor, bpol
c 130 if(iprint.eq.0.or.gamma.eq.0.) go to 160
      endif
      if (iprint>0 .and. gamma/=0.) then
         if (game /= 0.) then
            zgame = game/gamma
            write (iout, 1050) xe, zgame
         endif
         do i = 1, nspec
            if (gami(i) /= 0.) then
               zgami(i) = gami(i)/gamma
               write (iout, 1060) i, xi(i), zgami(i)
            endif
         end do
c ************ ************ ************ ************
c   detailed output
c ************ ************ ************ ************
         if (iprint <= 1) go to 170
         write (iout, 1240) epx, epy, epz, poyntn
      endif
      if (iprint > 1) then
         write (iout, 1210) xp, y2
         write (iout, 1220) alfa, ha, hb, hc
         write (iout, 1230) (dy(ly),ly=1,ndim)
         write (iout, 1250) disph, error, hlast
c ************ ************ ************ ************
c   storage for graphical output
c ************ ************ ************ ************
      endif
  170 continue
      if (prmt(5) /= 0.) return 
      if (igraph == 0) return 
      isxz = isxz + 1
c
      call outgra(2)
c
c ************ ************ ************ ************
 1010 format('0',"phase  =",f10.2,3x,"psi    =",f10.4,3x,"theta  =",
     1   f10.2,3x,"phi    =",f10.2,3x,"x      =",f10.3,3x,"z      =",
     2   f10.3)
 1020 format(' ',21x,"ne   =",1pe11.3,3x,"te     =",0pf10.3,3x,
     1   "ti     =",f10.3,3x,"b tor. =",f10.3,3x,"b pol. =",f10.3)
 1030 format(' ',21x,"n par  =",f10.2,3x,"n perp =",f10.2,3x,"n psi  =",
     1   f10.2,3x,"n tau  =",f10.2,3x,"power  =",f10.3)
 1040 format(' ',21x,"n xhi  =",f10.3,3x,"n x    =",f10.3,3x,"n z    =",
     1   f10.3,3x,"n p2   =",1pe11.3)
 1050 format(' ',21x,"electrons:  xe  =",e15.5,3x,"power (fract) =",
     1   e15.3)
 1060 format(' ',21x,"species",i2,":  xi =",1pe15.3,4x,"power(i) =",
     1   e15.3)
c ************ ************ ************ ************
 1110 format(' ',5x,"wispering gallery reflection , phase =",f9.3,
     1   "  n pol =",f9.3,"  n tor =",f9.3,"  psi =",f9.3)
 1115 format(' ',5x,"near wall cut off            , phase =",f9.3,
     1   "  n pol =",f9.3,"  n tor =",f9.3,"  psi =",f9.3)
 1120 format(' ',5x,"linear turning point         , phase =",f9.3,
     1   "  n pol =",f9.3,"  n tor =",f9.3,"  psi =",f9.3)
 1130 format(' ',5x,"confluence point             , phase =",f9.3,
     1   "  n pol =",f9.3,"  n tor =",f9.3,"  psi =",f9.3)
 1140 format(' ',5x,"absorption complete          , phase =",f9.3,
     1   "  n pol =",f9.3,"  n tor =",f9.3,"  psi =",f9.3)
 1150 format(' ',5x,"the ray is reaching the wall , phase =",f9.3,
     1   "  n pol =",f9.3,"  n tor =",f9.3,"  psi =",f9.3)
c ************ ************ ************ ************
 1210 format(' ',21x,"xp     =",1pe15.4,"  y2     =",e15.4)
 1220 format(' ',21x,"alfa   =",1pe13.4,2x,"a      =",e13.4,2x,
     1   "b      =",e13.4,2x,"c      =",e13.4)
 1230 format(' ',21x,"dy =",6e13.4)
 1240 format(' ',21x,"pol. vect =",3e13.4," poyntn =",e13.4)
 1250 format(' ',21x,"disph  =",1pe11.3," error  =",e11.3," step   =",
     1   e11.3)
c ************ ************ ************ ************ ************
 9010 format(' ',5x,"integration failed,","  n pol =",f9.3,"  n tor =",
     1   f9.3,"  psi =",f9.3/20x,"error =",e13.4," step =",e13.4,
     2   " jhlf =",i4)
c ************ ************ ************ ************ ************
c
      return 
c
      end subroutine output1

c----------------------
      subroutine dbcevl(x, nx, y, ny, sc, ic, xp, yp, pds, ierr)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nx, ny, ic, ierr
      real*8 xp, yp
      real*8, dimension(*) :: x, y
      real*8, dimension(2,ic,*) :: sc
      real*8, dimension(6) :: pds
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, j, k, km1, kp1, kp2, l, lxp1, lxpl, lx, ly
      real*8 :: d, h, hx, hy, s0, sh, sp0, sph
      real*8, dimension(2) :: su, sux, suy, sv, svx, sxy
      real*8 :: u, v
      character :: isub*6 = 'dbcevl'
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real*8 spln0, spln1, spln2
C-----------------------------------------------
      data lx, ly/2*0/
c
c
c--Correlated table search for xp
c
      ierr = 0
      call tableintrp (x, nx, xp, lx)
      if (lx == 0) then
         ierr = 33
         go to 9000
      else if (lx == nx) then
         ierr = 35
         go to 9000
      endif
c
c--Correlated table search for yp
c
      call tableintrp (y, ny, yp, ly)
      if (ly == 0) then
         ierr = 34
         go to 9000
      else if (ly == ny) then
         ierr = 36
         go to 9000
      endif
c
      lxp1 = lx + 1
      hx = x(lxp1) - x(lx)
      hy = y(ly+1) - y(ly)
      u = (xp - x(lx))/hx
      v = (yp - y(ly))/hy
      k = 2*ly
      kp1 = k + 1
      kp2 = k + 2
      km1 = k - 1
c
      do l = 1, 2
         lxpl = lx - 1 + l
         i = 2*(ly - 1 + l)
         j = i - 1
         sv(l) = spln0(sc(1,lxpl,km1),sc(1,lxpl,kp1),sc(1,lxpl,k),sc(1,
     1      lxpl,kp2),hy,v)
         svx(l) = spln0(sc(2,lxpl,km1),sc(2,lxpl,kp1),sc(2,lxpl,k),sc(2,
     1      lxpl,kp2),hy,v)
         su(l) = spln0(sc(1,lx,j),sc(1,lxp1,j),sc(2,lx,j),sc(2,lxp1,j),
     1      hx,u)
         suy(l) = spln0(sc(1,lx,i),sc(1,lxp1,i),sc(2,lx,i),sc(2,lxp1,i),
     1      hx,u)
         sux(l) = spln1(sc(1,lx,j),sc(1,lxp1,j),sc(2,lx,j),sc(2,lxp1,j),
     1      hx,u)
         sxy(l) = spln1(sc(1,lx,i),sc(1,lxp1,i),sc(2,lx,i),sc(2,lxp1,i),
     1      hx,u)
      end do
c
      pds(1) = spln0(sv(1),sv(2),svx(1),svx(2),hx,u)
      pds(2) = spln1(sv(1),sv(2),svx(1),svx(2),hx,u)
      pds(3) = spln1(su(1),su(2),suy(1),suy(2),hy,v)
      pds(4) = spln1(sux(1),sux(2),sxy(1),sxy(2),hy,v)
      pds(5) = spln2(sv(1),sv(2),svx(1),svx(2),hx,u)
      pds(6) = spln2(su(1),su(2),suy(1),suy(2),hy,v)
      go to 9990
c
c--Error exit.
c
 9000 continue
      call uertst (ierr, isub)
c
c--Normal exit.
c
 9990 continue
      return 
      contains
      real*8 function spln0 (s0, sh, sp0, sph, h, d)
      real*8 s0
      real*8 sh
      real*8 sp0
      real*8 sph
      real*8 h
      real*8 d
      spln0 = s0 + d*(h*sp0 + d*(3.0*(sh - s0) - (sph + 2.0*sp0)*h + d*(
     1   2.0*(s0 - sh) + (sph + sp0)*h)))
      return 
      end function spln0
      real*8 function spln1 (s0, sh, sp0, sph, h, d)
      real*8 s0
      real*8 sh
      real*8 sp0
      real*8 sph
      real*8 h
      real*8 d
      spln1 = sp0 + d*(6.0*(sh - s0)/h - 2.0*(sph + 2.0*sp0) + 3.0*d*(
     1   2.0*(s0 - sh)/h + (sph + sp0)))
      return 
      end function spln1
      real*8 function spln2 (s0, sh, sp0, sph, h, d)
      real*8 s0
      real*8 sh
      real*8 sp0
      real*8 sph
      real*8 h
      real*8 d
      spln2 = 6.0*(sh - s0)/h**2 - 2.0*(sph + 2.0*sp0)/h + d*(2.0*(s0 - 
     1   sh)/h**2 + (sph + sp0)/h)*6.
      return 
      end function spln2
      end subroutine dbcevl

      subroutine bcspefnd(x, nx, zxget, i)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nx, i
      real zxget
      real, dimension(nx) :: x
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: nxm, i1, i2, ij, ii
      real :: dx
C-----------------------------------------------
c
c
c  find index i such that x(i).le.zxget.le.x(i+1)
c
c  x(1...nx) is strict increasing and x(1).le.zxget.le.x(nx)
c  (this is assumed to already have been checked -- no check here!)
c
      nxm = nx - 1
      if (i<1 .or. i>nxm) then
         i1 = 1
         i2 = nx - 1
         go to 10
      endif
c
      if (x(i) > zxget) then
c  look down
         dx = x(i+1) - x(i)
         if (x(i) - zxget > 4*dx) then
            i1 = 1
            i2 = i - 1
            go to 10
         else
            i2 = i - 1
            do ij = i2, 1, -1
               if (x(ij)<=zxget .and. zxget<=x(ij+1)) then
                  i = ij
                  return 
               endif
            end do
            i = 1
            return 
         endif
      else if (x(i+1) < zxget) then
c  look up
         dx = x(i+1) - x(i)
         if (zxget - x(i+1) > 4*dx) then
            i1 = i + 1
            i2 = nxm
            go to 10
         else
            i2 = i + 1
            do ij = i2, nxm
               if (x(ij)<=zxget .and. zxget<=x(ij+1)) then
                  i = ij
                  return 
               endif
            end do
            ij = nxm
            return 
         endif
      else
c  already there...
         return 
      endif
c
c---------------------------
c  binary search
c
   10 continue
c
      if (i1 == i2) then
c found by proc. of elimination
         i = i1
         return 
      endif
c
      ii = (i1 + i2)/2
c
      if (zxget < x(ii)) then
         i2 = ii - 1
      else if (zxget > x(ii+1)) then
         i1 = ii + 1
      else
c found
         i = ii
         return 
      endif
c
      go to 10
c
      end subroutine bcspefnd

 
c
c  This module contains wave-physics routines
c
c------------------------------------------------
c
c
      subroutine fwibmc(iflg)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:03:04   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer iflg
C-----------------------------------------------
      iflg = 0
      return 
      end subroutine fwibmc
      subroutine absorb
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:03:04   6/14/01  
C...Switches: -p4 -yb
c
c ************ ************ ************ ************ ************
c
c  this module attributes the power absortbed along the ray
c     to the charged particle species
c  modified for fast ion, multi-species, collisional absorption
c
c   normal version
c
c ************ ************ ************ ************ ************
c
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vsizes
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang, 
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec, 
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3, 
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti, 
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin, 
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril, 
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref, 
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep, 
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr, 
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite, 
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1, 
     1   gamene1, presfr
      use Vcmnew, ONLY: wpi1c, wpi2c, wci1c, wci2c, wpi2, wci2, wci, 
     1   conci, aziomi, rtzom, ay2, ay1, trate, tratte, ttle, concte, 
     2   trati, tratti, ttli, concti, vdrfte, vdrfti, infi, gprm, cxet, 
     3   czt, cztp, czetai, czi, czip, czetat, czti, cztip, cth, npar, 
     4   nper, upar, uper, umax, dsfe, dsfi, fper2, fpar2, fpp2, intg, 
     5   inc, incf, tnmaxe, tnmaxi, idrive, binb, boutb, boutbrd, 
     6   binbrd, epsl, binbd, epsil, dlob, wte, eta0, eta, rprof, 
     7   amprof, cprof, xjop, vloop, kboot, mboot, btbsp, ftbsps, pde, 
     8   pdec, pdi, pdf, pwce, pwcm, pwcf, pwc, pwc1, pwc2, pwct, 
     9   pwct1, pwct2, pwc0, pwcray, pwc1ray, pwc2ray, pweray, pwiray, 
     .   pwfray, currf, currfe, currf1, currf2, curay, curay1, curay2, 
     1   fpwray, fpowe, fpowf, fpowi, pwte0, pwti0, effcd, effcdt, 
     2   ptot, ftpowe, ftpowi, ftpowf, ftpi, ftpf, ftedge, pwedge, 
     3   wfrac, pwxwl, frpowi, frpowf, frpow, pwit, pwft, ptedge, 
     4   ptot0, fpowt, tpowi, tpowf, wfrac0, ebkev, bmpwr, azf, atmf, 
     5   densa, kalfa, nalfa, nharm0, pnfi, pnf, zetab, tnf, ecrit, 
     6   taua0, wca, gamal, gamat, ibeam, abeam, dbeam, aneb, enbeam, 
     7   wbeam, temsa, ptfi, ttf, wpf2c, wpf2, wcf2c, wcf1c, wcf2, wcf, 
     8   cxc, czc, cy, denfa, eav, tausd, tau0, paf, sordt, ecrita, 
     9   betaf, nminor, nsp1
      use Vchpcsd
!                , ONLY: irec, rec0, rec1, rec2, rec3, rec4, rec5, 
!     1   rec6, rec7, rec8, rec9, rec10, rec11, rec12, rec13, rec14, 
!     2   rec15, prmt, nraym
      use Vcraylh
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, n, l, k
      real :: zgame, zgamce, zgami, zgamf
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
!      integer , EXTERNAL :: ifix, min0
      real , EXTERNAL :: valspl  !  , cabs
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1
 
 
c******      TKM   03/97, 09/99, 04/00, 06/00
c********************
 
c
c   Comhpcsd
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c
c
c ************ ************ ************ ************ ************
c
c $$$$  TK Mau   10/3/94
c     Calculate epsilon, B_max, and B_min locally.
!      left = ifix(psi/dpsi) + 1
      left = int(psi/dpsi) + 1
      hh = psi - tpsi(left)
      if (left > nprof) then
         left = nprof
         hh = 0.0
      endif
      epsil = valspl(hh,epsl,nprofn,left,0)
      binbrd = valspl(hh,binbd,nprofn,left,0)
      boutbrd = binbrd*(1. - epsil)/(epsil + 1.)
c $$$$$$$$$$$$$$$$$$$$$
      if (prmt(5) /= 2.) then
c
         if (gamma == 0.) return 
c
         zpwabs = powold - pwx
c
      else
c
         gamma = 1.
         game = 0.
         gami(:nspec) = 0.
         gami(light) = 1.
c $$$$    TK Mau    4/6/94
         if (nalfa > 0) then
            do i = 1, nalfa
               gamal(i,:nharm0) = 0.
               gamal(light,:nharm0) = 1.
            end do
         endif
c $$$$$$
         zpwabs = powold
         pwx = 0.
c
      endif
      l = left
      if (hh > 0.5*dpsi) l = left + 1
      l = min(nprofs,l)
c
c  electrons
c
      zgame = zpwabs*game/gamma
      zgamce = zpwabs*gamce/gamma
      pwtote = pwtote + zgame + zgamce
      pde = zgame/volume(l)
      pdec = zgamce/volume(l)
      pwe(l) = pwe(l) + pde + pdec
c
c  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c
      if (idmpsw /= 0) then
c
c  ions
c
         do i = 1, nspec
            zgami = zpwabs*gami(i)/gamma
            dpwri = dpwri + zgami
            pwtoti(i) = pwtoti(i) + zgami
            pdi(i) = zgami/volume(l)
            pwi(l,i) = pwi(l,i) + pdi(i)
         end do
c
c $$$$    TK Mau    4/6/94
c   energetic ions
c
         if (kalfa > 0) then
            do k = 1, nalfa
               do n = 1, nharm0
                  zgamf = zpwabs*gamal(k,n)/gamma
                  dpwrf = dpwrf + zgamf
                  pwtotf(k) = pwtotf(k) + zgamf
                  pdf(k,n) = zgamf/volume(l)
                  pwal(l,k) = pwal(l,k) + pdf(k,n)
               end do
            end do
         endif
      endif
c $$$$$$$$$$$$$
      powold = pwx
c
c  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c   Modified by T.K. Mau on July 30, 1991.
c   Calculate current driven from electron absorbed power.
c     pwe : electron-absorbed power density (MW/m**3)
c     pwc : driven electron current density (A/m**2)
c
c     pwc1: driven minority current density (A/m**2)
c     pwc2: driven fast ion current density (A/m**2)
c     pwce, pwcm, and pwcf are incremental driven current densities
c
      if (idrive /= 0) then
         call cdcur (idcur)
c     if (abs(pwce).gt.1.e50) then
c       write(iout,1500) irec,nzeik,l,psi,theta,pwc(l),pwce
c1500    format(1x,'irec:',i5,2x,'nzeik:',i4,2x,'l-fluxsfce:',
c    1         i4/2x,'psi:',e14.6,'theta:',e14.6/
c    2         2x,'pwc(l):',e14.6,2x,'pwce:',e14.6)
c     endif
         pwc(l) = pwc(l) + pwce
         if (abs(pwc(l)) > largest) then         ! was 1.e50
c       write(iout,1501) irec,nzeik,l,pwc(l)
 1501       format(1x,'irec:',i5,3x,'nzeik:',i4,3x,'l-fluxsfce:',i4/2x,
     1         'pwc(l):',e14.6)
            stop 
         endif
         if (nminor /= 0) then
            pwc1(l,nsp1+1:nspec) = pwc1(l,nsp1+1:nspec) + pwcm(nsp1+1:
     1         nspec)
         endif
         if (kalfa /= 0) then
            pwc2(l,:nalfa) = pwc2(l,:nalfa) + pwcf(:nalfa)
c $$$$$$$$$$$$$$$$$$$$$$$$$$Added by TK Mau, 8/28/91.
         endif
         if (irec < nraym) then
            rec10(irec) = pde
            rec11(irec) = pwce
         endif
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      endif
c
c  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c
c
c  ions
c
c     do 525  i=1,nspec
c        zgami = zpwabs*gami(i)/gamma
c     dpwri = dpwri + zgami
c        pwtoti(i) = pwtoti(i) + zgami
c 525    pwi(l,i) = pwi(l,i) + zgami/volume(l)
c
c        powold = pwx
c
      return 
      end subroutine absorb
c
c
      subroutine alfadamp(imod)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:03:04   6/14/01  
C...Switches: -p4 -yb
c*****Calculates damping decrements due to energetic ion components
c***** All velocities are initially normalized to speed of light.
c      imod=1    : magnetized orbit model
c           2    : straight (unmagnetized) orbit model
c           else : no damping
c    Note: imod=1 is not working becuase of Bessel function table.
c $$$$   Added by TK Mau on 4/6/94
c $$$$   SCChiu  5/10/94   vectorized version
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vsizes
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang, 
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec, 
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3, 
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti, 
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin, 
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril, 
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref, 
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep, 
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr, 
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite, 
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1, 
     1   gamene1, presfr
      use Vcmnew, ONLY: wpi1c, wpi2c, wci1c, wci2c, wpi2, wci2, wci, 
     1   conci, aziomi, rtzom, ay2, ay1, trate, tratte, ttle, concte, 
     2   trati, tratti, ttli, concti, vdrfte, vdrfti, infi, gprm, cxet, 
     3   czt, cztp, czetai, czi, czip, czetat, czti, cztip, cth, npar, 
     4   nper, upar, uper, umax, dsfe, dsfi, fper2, fpar2, fpp2, intg, 
     5   inc, incf, tnmaxe, tnmaxi, idrive, binb, boutb, boutbrd, 
     6   binbrd, epsl, binbd, epsil, dlob, wte, eta0, eta, rprof, 
     7   amprof, cprof, xjop, vloop, kboot, mboot, btbsp, ftbsps, pde, 
     8   pdec, pdi, pdf, pwce, pwcm, pwcf, pwc, pwc1, pwc2, pwct, 
     9   pwct1, pwct2, pwc0, pwcray, pwc1ray, pwc2ray, pweray, pwiray, 
     .   pwfray, currf, currfe, currf1, currf2, curay, curay1, curay2, 
     1   fpwray, fpowe, fpowf, fpowi, pwte0, pwti0, effcd, effcdt, 
     2   ptot, ftpowe, ftpowi, ftpowf, ftpi, ftpf, ftedge, pwedge, 
     3   wfrac, pwxwl, frpowi, frpowf, frpow, pwit, pwft, ptedge, 
     4   ptot0, fpowt, tpowi, tpowf, wfrac0, ebkev, bmpwr, azf, atmf, 
     5   densa, kalfa, nalfa, nharm0, pnfi, pnf, zetab, tnf, ecrit, 
     6   taua0, wca, gamal, gamat, ibeam, abeam, dbeam, aneb, enbeam, 
     7   wbeam, temsa, ptfi, ttf, wpf2c, wpf2, wcf2c, wcf1c, wcf2, wcf, 
     8   cxc, czc, cy, denfa, eav, tausd, tau0, paf, sordt, ecrita, 
     9   betaf, nfion
      use Vchpcsd
      use Vcraylh
      USE Vgrnout
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer imod
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
      integer, parameter :: nv = 127
      integer, parameter :: nl1 = 50
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer, dimension(nv) :: mx
      integer :: i, k, nu, nl, i1, j1, j2
      real, dimension(nions) :: egami
      real, dimension(nv) :: fung, fung1
      real, dimension(nl1) :: palf
      real, dimension(nfion) :: vth, wpa
      real, dimension(nv,nl1) :: besjf
      real, dimension(nv) :: vp, allam, th2, vtt, work
      real, dimension(nv,0:6) :: wk
      real :: clight, zpi, x1, y1, x2, dnot, egame, eb1, dnot1, eb2, 
     1   vcrit, valf0, vt1, vt3, vc3, alamda, wpa02, vpmax, acyc, vres, 
     2   vu, vl, dv, pktot, pnp, pnpar, const, xkl, xkt, xk11, xk22, 
     3   xk33, xk13
      complex :: cepxy, cepzy
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real , EXTERNAL :: simp  !  , cabs
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
c  New common added for FWCD
c  Storage related to FWCD:
c  Subroutines displh inital use Comnew1
 
 
c******      TKM   03/97, 09/99, 04/00, 06/00
c********************
 
c      parameter (nv=127,nl1=50)
      data clight/2.9979E10/
      data zpi/3.14159265/
c
      if (imod<1 .or. imod>2) return 
      cepxy = cepx/cepy
      x1 = real(cepxy)
      y1 = aimag(cepxy)
      cepzy = cepz/cepy
      x2 = real(cepzy)
      y2 = aimag(cepzy)
      dnot = 1./tempe
      dnot = dnot + sum(azi(:nspec)*azi(:nspec)*aconc(:nspec)/tempi(:
     1   nspec))
      egame = sqrt(2.9E27*tempe/(dense*dnot))
      do k = 1, nalfa
         if (densa(k) >= 1.E8) then
            vth(k) = 1.035E-3*sqrt(tempi(1)/atmf(k))
            wpa(k) = 2.10E2*azf(k)*sqrt(densa(k)/atmf(k))/freqcy
            wca(k) = 1.52E7*azf(k)*btot/(atmf(k)*freqcy)
            taua0(k) = 6.67E12*atmf(k)/azf(k)**2*tempe**1.5/(dense*alog(
     1         egame))
c **** Assume ave. ion energy is 1/4 of birth energy.
            eb1 = 0.25*ebkev(k)
            dnot1 = 0.
            where (eb1 >= 25.*(azi(:nspec)*azf(k))**2*atmf(k)) 
               egami(:nspec) = sqrt(5.34E30*eb1*atmf(k)/(dense*dnot))*
     1            atm(:nspec)/(atm(:nspec)+atmf(k))
            elsewhere
               egami(:nspec) = sqrt(2.09E29/(dense*dnot))*azi(:nspec)*
     1            eb1/((azi(:nspec)*azf(k))*(atm(:nspec)+atmf(k)))
            end where
            dnot1 = sum(azi(:nspec)**2*aconc(:nspec)*alog(egami(:nspec))
     1         /atm(:nspec))
            ecrit(k) = 14.8*tempe*atmf(k)*(dnot1/alog(egame))**0.667
            vcrit = 1.035E-3*sqrt(ecrit(k)/atmf(k))
            valf0 = 1.035E-3*sqrt(ebkev(k)/atmf(k))
c***** Normalize velocities to energetic ion birth speed
            vt1 = vth(k)/valf0
            vt3 = vt1**3
            vc3 = (vcrit/valf0)**3
            alamda = 0.3333333333*alog((1. + vc3)/(vt3 + vc3))
            if (irayio == 0) then
               wpa02 = wpa(k)**2/alamda
            else
               wpa02 = wpa(k)**2*taua0(k)
            endif
 
c***** Setting up velocity integral
            select case (imod) 
 
            case default
               vpmax = 1.0
               acyc = 1./wca(k)
               nu = acyc + incf
               nl = acyc - incf
               if (nl <= 0) nl = 1
               if (nu <= 0) nu = 1
               do i1 = nl, nu
                  vres = abs((1. - float(i1)*wca(k))/pkpar)/valf0
                  if (vpmax > vres) then
                     vu = sqrt(vpmax*vpmax - vres*vres)
                  else
                     vu = 0.
                  endif
                  if (vt1 > vres) then
                     vl = sqrt(vt1*vt1 - vres*vres)
                  else
                     vl = vt1
                  endif
                  if (vl < vu) then
                     dv = (vu - vl)/float(nv - 1)
                     do j1 = 1, nv
                        vp(j1) = vl + float(j1 - 1)*dv
                        allam(j1) = pkp*valf0*vp(j1)/wca(k)
                        vtt(j1) = sqrt(vp(j1)*vp(j1)+vres*vres)
                     end do
                     call besselj (i1 + 1, i1 - 1, nv, allam, besjf, 
     1                  0.01, nv, work, mx, wk)
                     th2(:nv) = x1*vp(:nv)*(besjf(:nv,1)+besjf(:nv,3))
     1                   + ((2.*vres)*besjf(:nv,2))*x2
                     work(:nv) = vp(:nv)*((y1 + 1.)*besjf(:nv,1)+(y1-1.)
     1                  *besjf(:nv,3)) + ((2.*vres)*besjf(:nv,2))*y2
                     th2(:nv) = th2(:nv)**2 + work(:nv)**2
                     work(:nv) = vtt(:nv)**3 + vc3
                     fung(:nv) = th2(:nv)*vp(:nv)*vtt(:nv)/work(:nv)/
     1                  work(:nv)
                     palf(i1) = simp(nv,dv,fung)
c-----Add delta function term at max velocity
c                              !+th2(nv)*vp(nv)**3/(3.*vtt(nv)*work(nv))
                     palf(i1) = palf(i1)
                  else
                     palf(i1) = 0.
                  endif
                  gamal(k,i1) = 12.*zpi*wpa02/(abs(pkpar)*valf0)*abs(
     1               cepy)**2*palf(i1)
               end do
               cycle 
 
            case (2) 
               vpmax = 1.0
               pktot = sqrt(pkp2 + pkpar2)
               pnp = pkp/pktot
               pnpar = pkpar/pktot
               const = 24.*zpi*wpa02/(pktot*valf0)
               vres = 1./(pktot*valf0)
               if (vpmax > vres) then
                  vu = sqrt(vpmax*vpmax - vres*vres)
               else
                  vu = 0.
               endif
               if (vt1 > vres) then
                  vl = sqrt(vt1*vt1 - vres*vres)
               else
                  vl = vt1
               endif
               if (vl <= vu) then
                  dv = (vu - vl)/float(nv - 1)
                  do j2 = 1, nv
                     vp(j2) = vl + float(j2 - 1)*dv
                     vtt(j2) = sqrt(vres*vres + vp(j2)*vp(j2))
                     work(j2) = vtt(j2)**3 + vc3
                     work(j2) = work(j2)*work(j2)
                     work(j2) = vtt(j2)/work(j2)
                     fung(j2) = vp(j2)*vres**2*work(j2)
                     fung1(j2) = vp(j2)**3*work(j2)
                  end do
                  xkl = const*simp(nv,dv,fung)
                  xkt = const*simp(nv,dv,fung1)
                  xk11 = xkl*pnp**2 + xkt*pnpar**2
                  xk22 = xkt
                  xk33 = xkl*pnpar**2 + xkt*pnp**2
                  xk13 = pnp*pnpar*(xkl - xkt)
                  gamal(k,1) = abs(cepx)**2*xk11 + abs(cepy)**2*xk22
     1                + abs(cepz)**2*xk33 + 2.*(real(cepx)*real(cepz)
     2                - aimag(cepx)*aimag(cepz))*xk13
               endif
            end select
         endif
      end do
      return 
      end subroutine alfadamp
c
      subroutine alpress
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:03:04   6/14/01  
C...Switches: -p4 -yb
 
c*****Subroutine to calculate the fast alpha particle pressure profile
c     given background thermal dueterium and tritium profiles.
c***** Set kalfa=1, nalfa=1, enkev(1)=3.59e3, azf(1)=1, and atmf(1)=4
c     in input curray_go file.
c     This routine also calculates fast ion density and average energy
c     profile.
c     This subroutine is called from PROFIN.
c
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vsizes
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang, 
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec, 
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3, 
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti, 
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin, 
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril, 
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref, 
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep, 
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr, 
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite, 
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1, 
     1   gamene1, presfr
      use Vcmnew, ONLY: wpi1c, wpi2c, wci1c, wci2c, wpi2, wci2, wci, 
     1   conci, aziomi, rtzom, ay2, ay1, trate, tratte, ttle, concte, 
     2   trati, tratti, ttli, concti, vdrfte, vdrfti, infi, gprm, cxet, 
     3   czt, cztp, czetai, czi, czip, czetat, czti, cztip, cth, npar, 
     4   nper, upar, uper, umax, dsfe, dsfi, fper2, fpar2, fpp2, intg, 
     5   inc, incf, tnmaxe, tnmaxi, idrive, binb, boutb, boutbrd, 
     6   binbrd, epsl, binbd, epsil, dlob, wte, eta0, eta, rprof, 
     7   amprof, cprof, xjop, vloop, kboot, mboot, btbsp, ftbsps, pde, 
     8   pdec, pdi, pdf, pwce, pwcm, pwcf, pwc, pwc1, pwc2, pwct, 
     9   pwct1, pwct2, pwc0, pwcray, pwc1ray, pwc2ray, pweray, pwiray, 
     .   pwfray, currf, currfe, currf1, currf2, curay, curay1, curay2, 
     1   fpwray, fpowe, fpowf, fpowi, pwte0, pwti0, effcd, effcdt, 
     2   ptot, ftpowe, ftpowi, ftpowf, ftpi, ftpf, ftedge, pwedge, 
     3   wfrac, pwxwl, frpowi, frpowf, frpow, pwit, pwft, ptedge, 
     4   ptot0, fpowt, tpowi, tpowf, wfrac0, ebkev, bmpwr, azf, atmf, 
     5   densa, kalfa, nalfa, nharm0, pnfi, pnf, zetab, tnf, ecrit, 
     6   taua0, wca, gamal, gamat, ibeam, abeam, dbeam, aneb, enbeam, 
     7   wbeam, temsa, ptfi, ttf, wpf2c, wpf2, wcf2c, wcf1c, wcf2, wcf, 
     8   cxc, czc, cy, denfa, eav, tausd, tau0, paf, sordt, ecrita, 
     9   betaf
      use Vchpcsd
      use Vcraylh
      use Vceqdsk, ONLY: ntitle, dat, ipestg, nxeqd, nzeqd, xdimeqd, 
     1   zdimeqd, reqd, redeqd, zmideqd, xma, zma, psimag, psilim, 
     2   beqd, toteqd, psimx1, psimx2, xax1, xax2, zax1, zax2, psisep, 
     3   xsep, zsep, feqd, presseqd, ffpeqd, ppeqd, peqd, qeqd, xeqd, 
     4   zeqd, psiadj, dpolflx, psieqd, tpsieqd, tpsifeqd, iounit1, 
     5   inoperm1, nptsdm1, nptsd, torflux, tpsisav, ra, psifra, 
     6   dpsifra, fra, fra1, cspln, pds, wnoperm, xcontr, zcontr, 
     7   bpcontr, btcontr, dstarp, b_fld, jacob, pprime, vprime, 
     8   chipsi, ncontr, dang, bperr, arcl, thet, anglex, csplnx, 
     9   csplnz, pdsx, pdsz, nlim, rlim, zlim, nlimiter, rlimiter, 
     .   zlimiter, lrz, nprim, nimp, nion, nti, zi, zeffz, r, raeqd, 
     1   psifeqd, te, ti, ti1, ene, enp, bmod, rmd, btmd, bpmd, btpmd, 
     2   roa, nxa
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: ij, jj, i, k, j
      real, dimension(nions) :: egami
      real, dimension(nprofm) :: xwork, ywork
      real, dimension(nxa) :: dumm
      real, dimension(nprofm,4) :: fbeam
      real :: sqt3, dlpsi, xpsi, f1, f2, dra, vbeam, eb1, dnot, egame, 
     1   dnot1, eb2, xc2, xc1, arg1, gxc1, arg2
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real , EXTERNAL :: simp, svfuse
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1
 
 
c******      TKM   03/97, 09/99, 04/00, 06/00
c********************
 
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i
 
c
c******     TKM   03/97
c********************
      data sqt3/0.57735/
c
c******     TKM   03/97
c      Calculate beam deposition profile F(rho), given analytic
c     form in F(psi)
      if (ibeam < 0) then
         dlpsi = 1./float(nxeqd - 1)
         do ij = 1, nxeqd
            xpsi = dlpsi*float(ij - 1)
            f1 = dbeam**2/((xpsi - abeam)**2 + dbeam**2)
            f2 = (1. - xpsi**2)**aneb
            if (f2 == 0.) f2 = 1.E-9
            dumm(ij) = f1*f2
         end do
         call intrpp ('zero', 'free', tpsieqd, dumm, nxeqd, ra, fbeam, 
     1      nprofs)
         dra = 1./float(nprofs - 1)
         xwork(:nprofs-1) = volume(:nprofs-1)*fbeam(:nprofs-1,1)/dra
         vbeam = simp(nprofs,dra,xwork)
      endif
c*********************
c
      eb1 = 0.25*ebkev(1)
c
c-----Looping over the plasma cross section
c
c  To avoid divergence, ignore the last two flux surfaces.
c
      do i = 1, nprof - 1
         dnot = 1./pte(i)
         dnot = dnot + sum(azi(:nspec)**2*conc(i,:nspec)/pti(i,:nspec))
         egame = sqrt(2.9E27*pte(i)/(pne(i)*dnot))
c-----Calculate slowing down time (s)
         tau0(i) = 1.998E13*atmf(1)/azf(1)**2*pte(i)**1.5/(pne(i)*alog(
     1      egame))
         dnot1 = 0.
         where (eb1 >= 25.*(azi(:nspec)*azf(1))**2*atmf(1)) 
            egami(:nspec) = sqrt(5.3E30*eb1*atmf(1)/(pne(i)*dnot))*atm(:
     1         nspec)/(atm(:nspec)+atmf(1))
         elsewhere
            egami(:nspec) = sqrt(2.09E29/(pne(i)*dnot))*azi(:nspec)*eb1/
     1         ((azi(:nspec)*azf(1))*(atm(:nspec)+atmf(1)))
         end where
         dnot1 = sum(azi(:nspec)**2*conc(i,:nspec)*alog(egami(:nspec))/
     1      atm(:nspec))
c-----Calculate alpha critical energy (keV)
         ecrita(i) = 14.8*pte(i)*atmf(1)*(dnot1/alog(egame))**0.667
         xc2 = ebkev(1)/ecrita(i)
         xc1 = sqrt(xc2)
         arg1 = (xc2 + 2.*xc1 + 1.)/(xc2 - xc1 + 1.)
         gxc1=0.5*xc2+alog(arg1)/6.-sqt3*atan(sqt3*(2.*xc1-1.))-0.3023
c-----Calculate alpha/beam particle source rate (m**-3/s) and fast alpha
c     pressure (pascals).
c********   TKM    03/97
         if (ibeam < 0) then
            sordt(i) = 6.241E21*bmpwr(1)*fbeam(i,1)/(vbeam*azf(1)*ebkev(
     1         1))
         else
            sordt(i) = 1.E6*pne(i)**2*conc(i,1)*conc(i,2)*svfuse(1.E3*
     1         pti(i,1),3)
         endif
c*************************************
         paf(i) = 1.068E-16*tau0(i)*ecrita(i)*sordt(i)*gxc1
c-----Calculate fast alpha density (cm**-3) and average energy (keV).
         arg2 = (1. + xc1*xc2)/(1. + (pte(i)/ecrita(i))**1.5)
c     tausd(i) = tau0(i)*alog(arg2)
         tausd(i) = tau0(i)
         denfa(i) = sordt(i)*tausd(i)
c**********   TKM    2/97
         if (denfa(i) == 0.) then
            eav(i) = eav(i-1)
         else
            eav(i) = paf(i)/(1.6022E-16*denfa(i))
         endif
c***************************
         denfa(i) = 1.E-6*denfa(i)
      end do
c-----------------------
c  assign a small value at the edge
c
      ecrita(nprof) = ecrita(nprof-1)*pte(nprof)/pte(nprof-1)
      tau0(nprof) = tau0(nprof-1)*pne(nprof-1)*pte(nprof-1)**1.5/pne(
     1   nprof)/pte(nprof-1)**1.5
      sordt(nprof) = 0.01*sordt(nprof-1)
      paf(nprof) = 0.01*paf(nprof-1)
      denfa(nprof) = denfa(nprof-1)*0.01
      eav(nprof) = 1.2*eav(nprof-1)
      tausd(nprof) = tau0(nprof)
      xwork(1) = 0.
      dra = 1./float(nprof - 1)
      xwork(2:nprof) = volume(2:nprof)/dra
      ywork(2:nprof) = paf(2:nprof)*xwork(2:nprof)
      betaf = 2.513E-6*simp(nprof,dra,ywork)/beqd**2/simp(nprof,dra,
     1   xwork)
c $$$$$     TKM   04/00
c   Add energetic alphas as a thermal ion species
c     nspec = nspec+1
c     atm(nspec) = 4.
c     azi(nspec) = 2.
c     do j = 1,nprof
c        pti(j,nspec) = denfa(j)
c        pni(j,nspec) = eav(j)
c     enddo
c $$$$$$$$$$$$
      return 
      end subroutine alpress
c
      subroutine chkpmc(lmcon, kdim, ixz, jmcind)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:03:04   6/14/01  
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vsizes
      use Viorlh
      use Vcmnew
      use Vchpcsd
      use Vcraylh
      use Vceqdsk
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer kdim, ixz, jmcind
      integer, dimension(kdim) :: lmcon
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: j
C-----------------------------------------------
c---------------
c  check if there is mode-conversion in previous five steps, if so
c  set jmcind=1 and lmcon(ixz)=0
c---------------
      jmcind = 0
      if (ixz > 5) then
         do j = 1, 5
            if (lmcon(ixz-j)==1 .or. lmcon(ixz-j)==(-1)) jmcind = 1
         end do
      else
         jmcind = 1
      endif
      if (jmcind == 1) lmcon(ixz) = 0
      return 
      end subroutine chkpmc
      subroutine deriv(x)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:03:04   6/14/01  
C...Switches: -p4 -yb
c
c ************ ************ ************ ************ ************
c
c  rhs of the ray tracing equations
c
c ************ ************ ************ ************ ************
c
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vsizes
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang, 
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec, 
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3, 
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti, 
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin, 
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril, 
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref, 
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep, 
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr, 
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite, 
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1, 
     1   gamene1, presfr
      use Vcmnew
      use Vchpcsd
!                , ONLY: irec, rec0, rec1, rec2, rec3, rec4, rec5, 
!     1   rec6, rec7, rec8, rec9, rec10, rec11, rec12, rec13, rec14, 
!     2   rec15
      use Vcraylh
      use Vceqdsk, ONLY: ntitle, dat, ipestg, nxeqd, nzeqd, xdimeqd, 
     1   zdimeqd, reqd, redeqd, zmideqd, xma, zma, psimag, psilim, 
     2   beqd, toteqd, psimx1, psimx2, xax1, xax2, zax1, zax2, psisep, 
     3   xsep, zsep, feqd, presseqd, ffpeqd, ppeqd, peqd, qeqd, xeqd, 
     4   zeqd, psiadj, dpolflx, psieqd, tpsieqd, tpsifeqd, iounit1, 
     5   inoperm1, nptsdm1, nptsd, torflux, tpsisav, ra, psifra, 
     6   dpsifra, fra, fra1, cspln, pds, wnoperm, xcontr, zcontr, 
     7   bpcontr, btcontr, dstarp, b_fld, jacob, pprime, vprime, 
     8   chipsi, ncontr, dang, bperr, arcl, thet, anglex, csplnx, 
     9   csplnz, pdsx, pdsz, nlim, rlim, zlim, nlimiter, rlimiter, 
     .   zlimiter, lrz, nprim, nimp, nion, nti, zi, zeffz, r, raeqd, 
     1   psifeqd, te, ti, ti1, ene, enp, bmod, rmd, btmd, bpmd, btpmd, 
     2   roa
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real x
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i
      real :: zpi, zdivy
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c
c   Comhpcsd
c
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i
 
c
c ************ ************ ************ ************ ************
c
      data zpi/3.14159265359/
c
c ************ ************ ************ ************ ************
c
c  transfer
c
      psi = y(2)
      theta = y(4)
      phi = y(5)
c
      akpsi = y(1)
      akth = y(3)
c
c  metric elements
c
      call coords
c
c  profile factors
c
      call profix
c
c  components of the wavevector
c
      call wavect
c
c  dispersion relation and power transport
c
      call disper (1)
c
c  derivative of akpsi
c
      dy(1) = -(dhne*derdne + dhte*derte + dhom*dompsi + dkp2p*dhkp2 + 
     1   dkpzp*dhkz)
      dy(1) = dy(1) - sum((dhti(:nspec)*derti(:nspec)+dhni(:nspec)*
     1   derdni(:nspec)))
c
c  derivative of psi
c
      dy(2) = 2.*pkpsi*dhkp2*antau/aj
c
c  derivative of akth
c
      dy(3) = -(dhom*domth + dkp2t*dhkp2 + dkpzt*dhkz)
c
c  derivative of theta
c
      dy(4)=(2.*((-ag*pkpsi/aj)+acostq*pkheta)*dhkp2+asintq*dhkz)/antau
c
c  derivative of phi
c
      dy(5) = ((-2.*pkheta*asintq*dhkp2) + acostq*dhkz)/urhs
c
c  change to the phase as independent variable
c
      if (indvar <= 0) then
c
c  poloidal phase as independent variable
c
         zdivy = y(1)*dy(2) + y(3)*dy(4)
      else
c
c  toroidal (actually, total) phase as independent variable
c
         zdivy = y(1)*dy(2) + y(3)*dy(4) + anphi*dy(5)
c
      endif
      dy(:5) = dy(:5)/zdivy
c
c  logarithmic derivative of the power
c
c**bh  Changes in next two lines  (bh:Oct 12/89)
c        dy(6) = -2.*gamma/poyntn
      dy(6) = -gamma/poyntn
      if (indvar > 0) dy(6) = (y(1)*dy(2)+y(3)*dy(4))*dy(6)
c
      return 
c
      end subroutine deriv
c
      subroutine diel1h(psic, thetac, vp, clite, alphar, alphai, ck0)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:03:04   6/14/01  
C...Switches: -p4 -yb
c---------------------
c   For adj
c    given psic,thetac,vp,clite, calculate alphar,alphai,sxy,dxy
c
c   Note: vp and clite are wave v-phase and light-vel. normalized
c         to vte=sqrt(te/me)
c---------------------
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vsizes
      use Viorlh
      use Vcmnew
      use Vchpcsd
      use Vcraylh
      use Vceqdsk
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real psic, thetac, vp, clite, alphar, alphai, ck0
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i
!      real, dimension(nions) :: cwork, cwwk, cwwk1, deli
      real, dimension(6) :: wrk
      real :: zpi, zdsqpi, zcalf, rt2, zhsi, c1, sxy, dxy, vte, pk2ms, 
     1   wrk5, wrk1, wrk2, wrk3, wrk4, wrk6, a4, a2, a0, a2k, discr, 
     2   disck2, pkpr2
      complex :: cwk
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
C      real , EXTERNAL :: sqrt
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i
 
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
c  New common added for FWCD
c  Storage related to FWCD:
c  Subroutines displh inital use Comnew1
 
 
c******      TKM   03/97, 09/99, 04/00, 06/00
c********************
 
c
c
      data zpi/3.14159265359/
      data zdsqpi/1.772453851/
      data zcalf/3.198E-6/
      data rt2/1.414213562/
c
      psi = amax1(psic,1.E-4_dp)
      theta = thetac
      call coords
      call profix
      zhsi = btot/bzero
      wpe2 = wpe2c*dense
      wce2 = wce2c*zhsi*zhsi
      wce = sqrt(wce2)
      wpi2(:nspec) = wpi2c(:nspec)*densi(:nspec)
      wci(:nspec) = wci1c(:nspec)*zhsi
      wci2(:nspec) = wci2c(:nspec)*zhsi*zhsi
      cwork(:nspec) = 1. - wci2(:nspec)
      vti(:nspec) = 1.459E-3*sqrt(tempi(:nspec)/atm(:nspec))
      do i = 1, nspec
c       awork=abs(cwork(i))
c       if (awork.le.1.e-9) cwork(i)=1.e-9*cwork(i)/awork
c         if (awork.eq.0.) cwork(i)=1.e-9
         c1 = cwork(i)
         if (abs(c1) <= 1.E-20) then
            cwwk(i) = wpi2(i)*1.E20*sign(1.0_dp,c1)
         else
            cwwk(i) = wpi2(i)/(1. - wci2(i))
         endif
         cwwk1(i) = cwwk(i)/wci(i)
      end do
      sxy = 1. + wpe2/wce2
      dxy = 0.
      del0 = 0.
      sxy = sxy - sum(cwwk(:nspec))
      dxy = dxy + sum(cwwk1(:nspec))
      deli(:nspec) = -cwwk(:nspec)*vti(:nspec)**2/(1. - wci2(:nspec))
      del0 = del0 + sum(deli(:nspec))
      xe = vp/rt2
      zxmin = abs(xe)
      zxe2 = xe*xe
c      call zfun(0,xe,cz,czp,zfn,zfc,xzz,nptzf,nptzfa,hzf,iout0)
      call zfun(xe, cz, czp)
      eps3r = 2.*wpe2*zxe2*(1. + xe*real(cz))
      eps3i = 2.*wpe2*zxe2*xe*aimag(cz)
      ceps3 = 2.*wpe2*zxe2*(1. + xe*cz)
      cwk = ceps3
      pkpar = clite/vp
      pkpar2 = pkpar*pkpar
      cwk = -clite*clite*wce*dxy/(sxy - pkpar2)/cwk
      cwk = cwk*(1. + del0)
      alphar = real(cwk)
      alphai = aimag(cwk)
      aeps32 = eps3r*eps3r + eps3i*eps3i
      vte = 0.0625*sqrt(tempe)
      delxp = 0.5*vte**2/wce
      del1 = pkpar*delxp
      delm = wpe2*vte**2*xe*cz/wce2
      pk2ms = pkpar2 - sxy
      wrk5 = real(delm)
      wrk1 = real((1. - wrk5)/ceps3)
      wrk2 = real(1./ceps3)
      wrk3 = 1. + del0
      wrk4 = pkpar2*wrk3*wrk3 - pk2ms
      wrk6 = dxy*dxy - pk2ms*pk2ms + pkpar2*wrk3*wrk3*pk2ms
      a4 = wrk4*wrk1
      a2 = pk2ms*(1. + del1*del1*eps3r - wrk5) - 2.*pkpar*del1*wrk3*dxy
     1    + wrk6*wrk2
      a0 = pk2ms**2 - dxy**2
      a2k = -a2/2./a4
      discr = a2**2 - 4.*a4*a0
      if (discr > 0.) then
         disck2 = sqrt(discr)/2./a4
         wrk(2) = a2k + disck2
         wrk(3) = a2k - disck2
         if (abs(wrk(2)) < abs(wrk(3))) then
            wrk(4) = wrk(2)
            wrk(2) = wrk(3)
            wrk(3) = wrk(4)
         endif
         pkpr2 = wrk(3)
      else
         pkpr2 = a2k
      endif
      pkpr2 = amax1(0.0_dp,pkpr2)
      ck0 = 1. + wrk4*pkpr2/pk2ms*wrk2
      return 
      end subroutine diel1h
c
      subroutine diel1l(psic, thetac, vp, clite, alphar, alphai, ck0)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:03:04   6/14/01  
C...Switches: -p4 -yb
c---------------------
c   For adj
c    given psic,thetac,vp,clite, calculate alphar,alphai,sxy,dxy
c
c   Note: vp and clite are wave v-phase and light-vel. normalized
c         to vte=sqrt(te/me)
c---------------------
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vsizes
      use Viorlh
      use Vcmnew
      use Vchpcsd
      use Vcraylh
      use Vceqdsk
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real psic, thetac, vp, clite, alphar, alphai, ck0
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i
!      real, dimension(nions) :: cwork, cwwk, cwwk1
      real, dimension(6) :: wrk
      real :: zpi, zdsqpi, zcalf, rt2, zhsi, c1, sxy, dxy, vte, pk2ms, 
     1   wrk5, wrk1, wrk2, wrk3, wrk4, wrk6, a4, a2, a0, a2k, discr, 
     2   disck2, pkpr2
      complex :: cwk
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i
 
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1
 
 
c******      TKM   03/97, 09/99, 04/00, 06/00
c********************
 
c
c
 
      data zpi/3.14159265359/
      data zdsqpi/1.772453851/
      data zcalf/3.198E-6/
      data rt2/1.414213562/
c
      psi = amax1(psic,1.E-4_dp)
      theta = thetac
      call coords
      call profix
      zhsi = btot/bzero
      wpe2 = wpe2c*dense
      wce2 = wce2c*zhsi*zhsi
      wce = sqrt(wce2)
      wpi2(:nspec) = wpi2c(:nspec)*densi(:nspec)
      wci(:nspec) = wci1c(:nspec)*zhsi
      wci2(:nspec) = wci2c(:nspec)*zhsi*zhsi
      cwork(:nspec) = 1. - wci2(:nspec)
      do i = 1, nspec
c       awork=abs(cwork(i))
c       if (awork.le.1.e-9) cwork(i)=1.e-9*cwork(i)/awork
c         if (awork.eq.0.) cwork(i)=1.e-9
         c1 = cwork(i)
         if (abs(c1) <= 1.E-20) then
            cwwk(i) = wpi2(i)*1.E20*sign(1.0_dp,c1)
         else
            cwwk(i) = wpi2(i)/(1. - wci2(i))
         endif
         cwwk1(i) = cwwk(i)/wci(i)
      end do
      sxy = 1. + wpe2/wce2
      dxy = 0.
      del0 = 0.
      sxy = sxy - sum(cwwk(:nspec))
      dxy = dxy + sum(cwwk1(:nspec))
      xe = vp/rt2
      zxmin = abs(xe)
      zxe2 = xe*xe
c      call zfun(0,xe,cz,czp,zfn,zfc,xzz,nptzf,nptzfa,hzf,iout0)
      call zfun(xe, cz, czp)
      eps3r = 2.*wpe2*zxe2*(1. + xe*real(cz))
      eps3i = 2.*wpe2*zxe2*xe*aimag(cz)
      ceps3 = 2.*wpe2*zxe2*(1. + xe*cz)
      cwk = ceps3
      pkpar = clite/vp
      pkpar2 = pkpar*pkpar
      cwk = -clite*clite*wce*dxy/(sxy - pkpar2)/cwk
      cwk = cwk*(1. + del0)
      alphar = real(cwk)
      alphai = aimag(cwk)
      aeps32 = eps3r*eps3r + eps3i*eps3i
      vte = 0.0625*sqrt(tempe)
      delxp = 0.5*vte**2/wce
c     del1 = pkpar*delxp
      del1 = 0.
c     delm = wpe2*vte**2*xe*cz/wce2
      delm = 0.
      pk2ms = pkpar2 - sxy
      wrk5 = real(delm)
      wrk1 = real((1. - wrk5)/ceps3)
      wrk2 = real(1./ceps3)
      wrk3 = 1. + del0
      wrk4 = pkpar2*wrk3*wrk3 - pk2ms
      wrk6 = dxy*dxy - pk2ms*pk2ms + pkpar2*wrk3*wrk3*pk2ms
      a4 = wrk4*wrk1
      a2 = pk2ms*(1. + del1*del1*eps3r - wrk5) - 2.*pkpar*del1*wrk3*dxy
     1    + wrk6*wrk2
      a0 = pk2ms**2 - dxy**2
      a2k = -a2/2./a4
      discr = a2**2 - 4.*a4*a0
      if (discr > 0.) then
         disck2 = sqrt(discr)/2./a4
         wrk(2) = a2k + disck2
         wrk(3) = a2k - disck2
         if (abs(wrk(2)) < abs(wrk(3))) then
            wrk(4) = wrk(2)
            wrk(2) = wrk(3)
            wrk(3) = wrk(4)
         endif
         pkpr2 = wrk(3)
      else
         pkpr2 = a2k
      endif
      pkpr2 = amax1(0.0_dp,pkpr2)
      ck0 = 1. + wrk4*pkpr2/pk2ms*wrk2
      return 
      end subroutine diel1l
c
      subroutine disper(ientry)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:03:04   6/14/01  
C...Switches: -p4 -yb
c---------------------------------
c-------June 25,1991.
c---------------------------
c
c ************ ************ ************ ************ ************
c
c     dispersion relation, derivatives and absorption
c     for lower hybrid waves and fast waves
c  This is the standard version of disper
c  (option ichois=1 (forCLHW) is re-written)
c  Changes:  Multispecies; finite-beta for FW; electron damping;
c            collisional damping.
 
c
c ************ ************ ************ ************ ************
c---------------------------------TK'S changes
c---10/31/95   Latest major modification to include finite-beta terms
c               in fast wave dispersin relation, as discussed in M. Ono,
c               PPPL-3091 (1995).
c---06/02/00   Include fast ions (or alphas) as thermal species in
c               damping calculations (idmpsw=3, islofa=-1)
c---------------------------
c
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vsizes
      use Viorlh
      use Vcmnew
      use Vchpcsd
      use Vcraylh
      use Vceqdsk
      USE Vcfdamp, only: inf
      USE Vdissub
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer ientry
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer, dimension(4) :: kbd
      integer :: i, k, ij, j2, ncalc, nu, nl, i2, i3, i1, j1, n, idmpal
!      real, dimension(nions) :: zalfai, cwork, cwwk, cwwk2, cwwk1, deli
!     1   , da4ti, da2ti, da4ni, da2ni, da0ni
      real, dimension(100) :: besr, besi
      real, dimension(1001) :: funp
      real, dimension(100) :: zetai, zetat, wwork, zetaf
      real :: zpi, zdsqpi, zcalf, zhsi, adxyb, ddel0b, c1, zhs, zxpy2, 
     1   zalfae, zalfi, cwork2, pkp6, pkp4, cworkk, cworki, cwke4, cwke3
     2   , cwke1, cwke5, a4ne, a2ne, a0ne, zxh, zep, zes, zmod, thetz, 
     3   zemk, zkpol, xet, alme, epsyyi, epsyzr, almet, dumt, vthe, delu
     4   , ures, upx, alam, dfpar, th2, vthi, dii, zxi2, zexpxi, xif, 
     5   alconc, zxif2, zexpxf, rnue, coln, denomc, vte, pk2ms, wrk5, 
     6   wrk2, wrk3, wrk4, wrk6, aterm, bterm, cterm, dterm, dxez, 
     7   delmzr, ddel1z, wrk7, da4z, wrk8, da2z, da0z, ddel1b, delmbr, 
     8   da4b, da2b, da0b, dxete, delmter, da4te, da2te, ae32, epx2, 
     9   epz2, work2, xi0, yion, dumi, almit, xit0, apkp21, apkp22, epl0
     .   , epl1, eplus2, eminu2, exxic, exyrc, eyyic, eyzrc, ezzic, 
     1   pktot, xkt, xkl, pnp, pnpar, xk11, xk22, xk33, xk13, lwork,
     2   dfper, xf0, almf, yfion, dumf, acyc
      complex :: ddelmz, deps3z, ddelmb, ddelmte, deps3te, cepx0, cepy0
     1   , cepz0, cdd, css, csmnp2, xxtt, yytt, xytt, dd1, ss1, ssmnp21
      complex, dimension(nions) :: xxi1, yyi, xyr, xxti, yyti, xytr
      complex, dimension(nfion) :: xxif1, yyif, xyrf
      complex :: sy1, symnp21, wrk1, cfour, ctwo, czero, cdiscr, crtdcr
     1   , cpkp21, cpkp22, cwrk1, cpkp2c, cpkp1, ceps31, zwrk1, zwrk2, 
     2   zwrk3, zwrk4, zwrk6
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
C      integer , EXTERNAL :: min0
      real , EXTERNAL :: terp2, simp  !  , cabs
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c   7/10 91
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1
 
 
c******      TKM   03/97, 09/99, 04/00, 06/00
c********************
 
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c ************ ************ ************ ************ ************
c
c     complex crot
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c  7/10/91   T.K. Mau
c  Complex and real array declaration for ICRF damping
c
c     complex gprm,cxet,czt,cztp,czetai,czi,czip,czetat,czti,
c    &        cztip,cth
c%%%%%%%%    10/31/95   TK Mau
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c-------------------SCC 12/10/96
c--------------------------------------------
c
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c
c ************ ************ ************ ************ ************
c
      data zpi/3.14159265359/
      data zdsqpi/1.772453851/
      data zcalf/3.198E-6/
c
c ************ ************ ************ ************ ************
c
c---------------------------------
c  7/2/91
c
c  bzero in teslas, freqcy in hertz, denc in 1/cm**3
c
c
      zhsi = btot/bzero
C******************************************** SCC 12/12/95
      wpe2 = wpe2c*dense
C***********************************************************
c---------
c  wpe2=fpe**2/f**2
c----------
C***************************************SCC  12/12/95
C     do 80 i=1,nspec
C80    conci(i)=aconc(i)*azi(i)
C**********************************************************
      apzz = 1. - wpe2
      wce2 = wce2c*zhsi*zhsi
      wce = sqrt(wce2)
      asxye = wpe2/wce2
      asxy = 1. + asxye
      asxy1 = asxy
      adxy1 = 0.
      adxy = 0.
      adxyb = 0.
      del0 = 0.
      ddel0b = 0.
C********************************************** SCC 12/12/95
      wpi2(:nspec) = densi(:nspec)*wpi2c(:nspec)
C****************************************************************
      wci(:nspec) = wci1c(:nspec)*zhsi
      wci2(:nspec) = wci2c(:nspec)*zhsi*zhsi
      vti(:nspec) = 1.459E-3*sqrt(tempi(:nspec)/atm(:nspec))
      if (nalfa > 0) then
         wpf2(:nalfa) = densa(:nalfa)*wpf2c(:nalfa)
         wcf(:nalfa) = wcf1c(:nalfa)*zhsi
         wcf2(:nalfa) = wcf2c(:nalfa)*zhsi*zhsi
      endif
      do i = 1, nspec
         c1 = 1. - wci2(i)
         if (abs(c1) <= 1.E-20) then
            cwwk(i) = wpi2(i)*1.E20*sign(1.0_dp,c1)
         else
            cwwk(i) = wpi2(i)/(1. - wci2(i))
         endif
      end do
      cwwk1(:nspec) = cwwk(:nspec)/wci(:nspec)
c----------------------------
c  nsp1=nspec-nminor
c----------------------------
      a4b = -asxye
      asxy1 = asxy1 - sum(cwwk(:nsp1))
      adxy1 = sum(cwwk1(:nsp1))
      a4b = a4b - sum(cwwk(:nsp1)*wci2(:nsp1)/(1.-wci2(:nsp1)))
      adxyb = sum(cwwk(:nsp1)/wci(:nsp1)*(3.*wci2(:nsp1)-1.)/(1.-wci2(:
     1   nsp1)))
      deli(:nsp1) = -cwwk(:nsp1)*vti(:nsp1)**2/(1. - wci2(:nsp1))
      del0 = sum(deli(:nsp1))
      ddel0b = -sum(4.*cwwk(:nsp1)*vti(:nsp1)**2*wci2(:nsp1)/(1.-wci2(:
     1   nsp1))**2)
      a4b = a4b*2.
      asxy = asxy1
      adxy = adxy1
      if (nminor > 0) then
c*******************************
c  july 9,1991
c--------------------------------
c**************************************
         asxy = asxy - sum(cwwk(nsp1+1:nminor+nsp1))
c$$$$$$ T.K. Mau  8/9/91
c       Define dispersion coefficients for ray initialization
         adxy = adxy + sum(cwwk(nsp1+1:nminor+nsp1)/wci(nsp1+1:nminor+
     1      nsp1))
      endif
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      xe = 15.984/(abs(pkpar)*sqrt(tempe))
c-------------------
c tempe in kev
c---------------------
      zxmin = abs(xe)
c-----------------------------
c  6/25/91
      if (ichois == 1) then
c
C**********************************SCC  12/12/95
c
         xp = xpc*dense
         zp = amime*xp
         zhs = bzero/btot
         y2 = y2c*zhs*zhs
         zxpy2 = xp*y2
c
         zalfae = zcalf*zxpy2*y2*tempe/4.
         zalfi = 0.
         do i = 1, nspec
            c1 = 1. - 4.*wci2(i)
            if (abs(c1) <= 1.E-20) then
               cwwk2(i) = 1.E20*sign(1.0_dp,c1)
            else
               cwwk2(i) = 1./c1
            endif
            zalfai(i) = xxi(i)*cwwk(i)*cwwk2(i)*xp*aconc(i)/wpi2(i)*
     1         tempi(i)*zcalf
            zalfi = zalfi + zalfai(i)
         end do
 
c
c ----------------------------------------------------------------
c  dispersion function
c
         alfa = zalfae + zalfi
         atwo = (asxy + apzz)*(pkpar2 - asxy) + adxy**2
         cwork2 = (asxy - pkpar2)**2 - adxy**2
         azero = apzz*cwork2
         cwork(1) = asxy - pkpar2
         cwork(2) = apzz + cwork(1)
         cwork(3) = alfa*cwork(2)
         cwork(4) = apzz*cwork(1)
         cwork(5) = alfa*cwork(4)
         ha = asxy + cwork(3)
         hb = (-atwo) + cwork(5)
         hc = azero
         disph = (((-alfa*pkp2) + ha)*pkp2 - hb)*pkp2 + hc
c
c-------------------
c  derivatives  of dispersion relation
c-------------------
         pkp6 = pkp2*pkp2*pkp2
         pkp4 = pkp2*pkp2
         dhkp2 = (-3.*alfa*pkp4) + 2.*ha*pkp2 - hb
         cworkk = pkp6 - pkp4*cwork(2) + pkp2*cwork(4)
         dhte = -zalfae*cworkk
         atwoz = 2.*(apzz + asxy)*pkpar
         azeroz = -4.*pkpar*apzz*(asxy - pkpar2)
         dhkz=atwoz*pkp2+azeroz+2.*pkpar*alfa*pkp2*((-pkp2)+apzz)
         a2b = a4b*(pkpar2 - 2.*asxy - apzz) + 2.*adxy*adxyb
         a0b = 2.*apzz*((asxy - pkpar2)*a4b - adxy*adxyb)
         cworki = 0.
         dhti(:nspec) = -zalfai(:nspec)*cworkk
         cworki = cworki + sum(2.*wci2(:nspec)*zalfai(:nspec)*(5.-8.*
     1      wci2(:nspec))*cwwk(:nspec)*cwwk2(:nspec)/wpi2(:nspec))
         dhom = (a4b*pkp2 + a2b)*pkp2 + a0b + 4.*zalfae*cworkk + alfa*
     1      pkp2*a4b*(pkp2 - apzz) - cworki*cworkk
c
         cwke4 = asxye
         cwke3 = asxy - pkpar2
         cwke1 = asxy + apzz
         cwke5 = wpe2 - cwke4
         a4ne = cwke4
         a2ne = cwke5*cwke3 - cwke1*cwke4
         a0ne = (-wpe2*cwork2) + apzz*2.*cwke3*cwke4
         dhne = (a4ne*pkp2 + a2ne)*pkp2 + a0ne - cworkk*zalfae - alfa*
     1      pkp2*(cwke5*pkp2 - wpe2*cwke3 + cwke4*apzz)
         dhni(:nspec) = cwwk(:nspec)*(pkp2*((-pkp2) + cwke3 + cwke1 + 2.
     1      *adxy/wci(:nspec))-2.*apzz*(cwke3+adxy/wci(:nspec)))
         dhni(:nspec) = dhni(:nspec) - zalfai(:nspec)*cworkk - alfa*cwwk
     1      (:nspec)*pkp2*(pkp2 - apzz)
c
         if (ientry == 0) return 
c
         poyntn = 1.
c
         gamma = 0.
         game = 0.
         zxh = 15.984*sqrt(amime)/pkp
         gami(:nspec) = 0.
         xi(:nspec) = zxh*sqrt(atm(:nspec)/tempi(:nspec))
c
c ***bh***    if(zxmin.gt.8.)  return
c
c ----------------------------------------------------------------
c  polarizations
c
         zep = apzz - pkp2
         zes = asxy - pkpar2 - pkp2
         epx = zep*zes
         epy = -adxy*zep
         epz = -pkp*pkpar*zes
         zmod = sqrt(epx*epx + epy*epy + epz*epz)
         epx = epx/zmod
         epy = epy/zmod
         epz = epz/zmod
c
c ********************************************************************
c  polarizations with SC Chiu's corrections:
c ********************************************************************
         cei = cmplx(0.,1.)
         zxe2 = xe*xe
c-----------------
c         call zfun(0,xe,cz,czp,zfn,zfc,xzz,nptzf,nptzfa,hzf,iout0)
         call zfun(xe, cz, czp)
         eps3r = 2.*wpe2*zxe2*(1. + xe*real(cz))
         eps3i = 2.*wpe2*zxe2*xe*aimag(cz)
c-----------------------
         ceps3 = 2.*wpe2*zxe2*(1. + xe*cz)
         aeps32 = eps3r*eps3r + eps3i*eps3i
         dd = adxy
         ss = ha - alfa*pkp2
         ssmnp2 = ss - pkpar2
         gprm = (1. + xe*cz)/(1. + cz*(xe - pkpar*vdrfte/trate))*trate
         cepy = 1. - pkp2*ss*(eps3r - cei*eps3i)/(ssmnp2*aeps32)
         cepz = -cei*pkpar*pkp*(dd*(eps3r - cei*eps3i)/(aeps32*ssmnp2)
     1       + 0.5*gprm/(wce*pkpar2*zxe2))
         cepx = cei/ssmnp2*(dd*cepy + cei*pkpar*pkp*cepz)
         emod = sqrt(abs(cepx)**2 + abs(cepy)**2 + abs(cepz)**2)
c----------------SCC  5/24/95
         thetz = atan2(aimag(cepz),real(cepz))
c----------------------
         crot = cos(thetz) - cei*sin(thetz)
         cepx = cepx*crot/emod
         cepy = cepy*crot/emod
         cepz = cepz*crot/emod
c
 
c
c ----------------------------------------------------------------
c  projection of poynting vector
c
         zemk = epx*pkp + epz*pkpar
         ztx = pkp*(1. + alfa*epx*epx) - zemk*epx
         ztz = pkpar - zemk*epz
c
         ztpsi = pkpsi/pkp*ztx
         zttau = ztx*pkheta/pkp*acostq + ztz*asintq
c
         zkpol = sqrt(pkpsi*pkpsi + pktau*pktau)
c**bh         poyntn = abs((pkpsi*pkpsi+pkheta*pktau*acostq)*ztx/pkp +
c**bh     +               pktau*asintq*ztz)/zkpol
c-------------------------SCC  6/27/95
c        poyntn = abs((pkpsi*pkpsi+pkheta*pktau*acostq)*ztx/pkp +
c    +               pktau*asintq*ztz)
         poyntn = (pkpsi*pkpsi + pkheta*pktau*acostq)*ztx/pkp + pktau*
     1      asintq*ztz
         if (indvar==0 .and. jslofa==1) poyntn = -poyntn
c
c ----------------------------------------------------------------
c  absorption coefficients
c  This version uses corrected polarizations cepx,y,z for game
c   SCC 6/27/95
c
c
c     if(abs(xe).gt.10.)  goto 30
c  Omit electron absorption at this point in the code, if
c  (inf.ne.-1 .and. xe.gt.1.) for the LH wave.
c     if(inf.ne.-1 .and. abs(xe).gt.1. .and. jslofa.eq.1)  go to 30
c       jpe = jpe+1
c        zxe2 = xe*xe
c        zexpxe = 2.*zdsqpi*zxe2*abs(xe)*exp(-zxe2)
c        game = zp*zexpxe*epz*epz
c
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c  7/10/91  Revised by T.K. Mau
c  absorption coefficients
c
c  Electron Landau and TTMP Damping
c
         if (abs(xe)<=10 .or. concte/=0.) then
            xet = xe/sqrt(ttle)
            if (abs(xet) <= 10.) then
               if (inf > (-2)) then
                  jpe = jpe + 1
                  if (inf < 0) then
c
c $$$ Electron damping for anisotropic, bi-Maxwellian distribution.
c
                     alme = 1.951E-3*pkp2/wce2*tempe*trate
                     epsyyi = 2.*wpe2*xe*alme*aimag(cz)*(1. - pkpar*
     1                  vdrfte/trate)*trate
                     epsyzr = wpe2/wce*trate*pkp/pkpar*aimag(cz)*(xe - 
     1                  pkpar*vdrfte/trate)
                     if (concte /= 0.) then
                        almet = alme*ttle*tratte/trate
c     cxet = cmplx(xet,0.)
c                        call zfun (0, xet, czt, cztp, zfn, zfc, xzz, 
c     1                     nptzf, nptzfa, hzf, iout0)
                        call zfun(xet, czt, cztp)
                        dumt = wpe2*concte*aimag(czt)
                        epsyyi = (1. - concte)*epsyyi + 2.*dumt*tratte*
     1                     almet*(1. - pkpar*vdrfte/tratte)
                        epsyzr = (1. - concte)*epsyzr + dumt/wce*tratte*
     1                     pkp/pkpar*(xet - pkpar*vdrfte/tratte)
                        eps3i = (1. - concte)*eps3i + 2.*dumt*xet**3
                     endif
                     game = epsyyi*abs(cepy)**2 + 2.*epsyzr*(real(cepy)
     1                  *aimag(cepz) - aimag(cepy)*real(cepz)) + eps3i*
     2                  abs(cepz)**2
c $$$$$  Crude inclusion of quasilinear flattening of distribution
c        After Bonoli, PFC/RR-84-5 (1984), Eq. (31)
c     game = game/(1.+1.414*xet**3)
c
                  else
c
c $$$ Electron damping for non-Maxwellian distribution
c
                     kbd = 4
                     call fnmax(0,npar,upar,nper,uper,tnmaxe,dsfe)
                     call coeff2 (npar, upar, nper, uper, dsfe, fpar2, 
     1                  fper2, fpp2, npar, kbd, wwork)
                     vthe = 0.06346*sqrt(tnmaxe)
                     delu = (uper(nper)-uper(1))/float(intg - 1)
                     ures = 1./(abs(pkpar)*vthe)
                     do j2 = 1, intg
                        upx = delu*float(j2 - 1)
                        alam = pkp*upx/wce
                        call beslci (alam, 0., 2, 0, besr, besi, ncalc)
                        cth=(-cei*cepy*upx*besr(2))+ures*cepz*besr(1)
                        dfpar = terp2(ures,upx,npar,upar,nper,uper,dsfe,
     1                     fpar2,fper2,fpp2,npar,1,0)
                        th2 = abs(cth)**2
                        funp(j2) = th2*pkpar*upx*vthi*dfpar
                     end do
                     game = -4.*sqrt(zpi)*wpe2/abs(pkpar)*simp(intg,delu
     1                  ,funp)
                  endif
               endif
            endif
         endif
         gamma = game
 
c     dii is the imag contribution to the dispersion relation due
c     to ion damping (Bonoli, IEEE Trans. of Pl. Sc., p. 95(1984)).
 
         dii = 0.0
         gamit = 0.
c
         do i = 1, nspec
            if (abs(xi(i)) <= 10.) then
               jpi = jpi + 1
               zxi2 = xi(i)*xi(i)
               zexpxi = 2.*zdsqpi*zxi2*abs(xi(i))*exp((-zxi2))
               dii = dii + zdsqpi*pkp2*azi(i)*azi(i)*aconc(i)/atm(i)*xp*
     1            (2.9979E10/9.79E5)**2/(1000.*tempi(i)/atm(i))*abs(xi(i
     2            ))*exp((-zxi2))
               gami(i) = xp*atpi(i)*aconc(i)*zexpxi*epx*epx
               gamit = gamit + gami(i)
            endif
            gamma = gamma + gami(i)
         end do
c
c $$$$$$$       TKM    04/00
c  Calculate alpha damping using straight orbit approximation
c
         if (atm(1)==2. .and. atm(2)==3.) then
            if (ioread == 0) then
               gamal(1,1) = 0.
               nharm0 = min(1,nharm0)
               xif = zxh*sqrt(atmf(1)/temsa(1))
               alconc = densa(1)/dense
               zxif2 = xif*xif
               if (abs(xif) <= 10.) then
                  zexpxf = 2.*zdsqpi*zxif2*abs(xif)*exp((-zxif2))
                  gamal(1,1) = xp*azf(1)*azf(1)/atmf(1)*alconc*zexpxf*
     1               epx*epx
                  gamat = gamal(1,1)
               endif
               gamma = gamma + gamat
            endif
         endif
c $$$$$$$$$$$$$$$$$$$$$$
c     Collisional damping:
c     1.47e-9 = (4/3)*sqrt(2*pi)*16*q**4/(sqrt(me)*(1.6e-9 erg/keV)**1.5)
C***********************************SCC  12/13/95
         rnue = 1.47E-9*dense*zeff/tempe**1.5
C*****************************************************
         alphac = abs(rnue/omega*(zxpy2*pkp2 + zp*pkpar2)*pkp2/(dhkp2*
     1      pkp*2.9979E10/omega))
         alphal = abs(dii/(dhkp2*pkp*2.9979E10/omega))
 
c
c ************ ************ ************ ************ ************
c
         return 
      endif
      rnue = 1.47E-9*dense*zeff/tempe**1.5
      coln = fcoll*rnue/omega
      denomc = 1. + coln*coln
      cei = cmplx(0.,1.)
      zxe2 = xe*xe
c      call zfun(0,xe,cz,czp,zfn,zfc,xzz,nptzf,nptzfa,hzf,iout0)
      call zfun(xe, cz, czp)
      eps3r = 2.*wpe2*zxe2*(1. + xe*real(cz))
      eps3i = 2.*wpe2*zxe2*xe*aimag(cz)
      ceps3 = 2.*wpe2*zxe2*(1. + xe*cz)
      aeps32 = eps3r*eps3r + eps3i*eps3i
      vte = 0.0625*sqrt(tempe)
      delxp = 0.5*vte**2/wce
      del1 = pkpar*delxp
      delm = asxye*vte**2*xe*cz
c        atwo=(asxy1+apzz)*(pkpar2-asxy1)+adxy1**2
c        cwork2=(asxy1-pkpar2)**2-adxy1**2
c        azero=apzz*cwork2
c        disph=(asxy1*pkp2+atwo)*pkp2+azero
      pk2ms = pkpar2 - asxy1
      wrk5 = real(delm)
      wrk1 = real((1. - wrk5)/ceps3)
      wrk2 = real(1./ceps3)
      wrk3 = 1. + del0
      wrk4 = pkpar2*wrk3*wrk3 - pk2ms
      wrk6 = adxy1*adxy1 - pk2ms*pk2ms + pkpar2*wrk3*wrk3*pk2ms
      afour = wrk4*wrk1
      atwo = pk2ms*(1. + del1*del1*eps3r - wrk5) - 2.*pkpar*del1*wrk3*
     1   adxy1 + wrk6*wrk2
      azero = pk2ms**2 - adxy1**2
      disph = (afour*pkp2 + atwo)*pkp2 + azero
c     ha = asxy1
      ha = afour
      hb = -atwo
      hc = azero
c---- TKM     9/98
c   Check accuracy of wave dispersion relation
      aterm = abs(afour*pkp2*pkp2)
      bterm = abs(atwo*pkp2)
      cterm = abs(azero)
      dterm = amax1(aterm,bterm,cterm)
      if (dterm <= 1.E-30) then
         dsperr = 0.
      else
         dsperr = disph/dterm
      endif
c-------------------
c  derivatives
c-------------------
c ----- w.r.t. pkp2
c        dhkp2=2.*asxy1*pkp2+atwo
      dhkp2 = 2.*afour*pkp2 + atwo
c        dhte=0.
c        do i=1,nspec
c          dhti(i)=0.
c        enddo
c        atwoz=2.*(apzz+asxy1)*pkpar
c        azeroz=-4.*pkpar*apzz*(asxy1-pkpar2)
c        dhkz=atwoz*pkp2+azeroz
c ----- w.r.t. pkpar
      dxez = -xe/pkpar
      ddelmz = asxye*vte**2*(cz + xe*czp)*dxez
      delmzr = real(ddelmz)
      ddel1z = delxp
      deps3z = 2.*wpe2*xe*(2. + 3.*xe*cz + xe*xe*czp)*dxez
      wrk7 = real(delmzr/ceps3 + (1. - wrk5)*deps3z/ceps3/ceps3)
      da4z = 2.*pkpar*(wrk3**2 - 1.)*wrk1 - wrk4*wrk7
      wrk8 = real(deps3z/ceps3/ceps3)
      da2z = 2.*pkpar*(1. - wrk5 + del1*del1*eps3r) + pk2ms*((-delmzr)
     1    + 2.*del1*delxp*eps3r + del1*del1*real(deps3z)) - 4.*del1*wrk3
     2   *adxy1 - 2.*pkpar*(2.*pk2ms - wrk3*wrk3*(pk2ms + pkpar2))*wrk2
     3    - wrk6*wrk8
      da0z = 4.*pkpar*pk2ms
      dhkz = (da4z*pkp2 + da2z)*pkp2 + da0z
c ----- w.r.t. B : B*d/dB
c     a2b = a4b*(pkpar2-2.*asxy1-apzz)+2.*adxy1*adxyb
c     a0b = 2.*apzz*((asxy1-pkpar2)*a4b-adxy1*adxyb)
c        dhom=(a4b*pkp2+a2b)*pkp2+a0b
c
      ddel1b = -del1
      ddelmb = -2.*delm
      delmbr = real(ddelmb)
      wrk7 = real(delmbr/ceps3)
      wrk8 = real((-ddelmb) + 2.*del1*ddel1b*eps3r)
      da4b = (a4b + 2.*pkpar2*wrk3*ddel0b)*wrk1 - wrk4*wrk7
      da2b = (-a4b*(1. - wrk5 + del1*del1*eps3r)) + pk2ms*wrk8 - 2.*
     1   pkpar*ddel1b*wrk3*adxy1 - 2.*del1*pkpar*ddel0b*adxy1 - 2.*pkpar
     2   *del1*wrk3*adxyb + (2.*adxyb*adxy1 + 2.*pk2ms*a4b - pkpar2*wrk3
     3   *wrk3*a4b + 2.*pkpar2*wrk3*pk2ms*ddel0b)*wrk2
      da0b = -2.*(pk2ms*a4b + adxyb*adxy1)
      dhom = (da4b*pkp2 + da2b)*pkp2 + da0b
c$$$$$   TK Mau    02/00
c  Modified to cold electron approximation - for NSTX runs
c ----- w.r.t. Ti  :  Ti*d/dTi
      dhti(:nspec) = 0.
c     go to 501
      da4ti(:nspec) = (pkpar2*wrk3)*(2.*deli(:nspec))*wrk1
      da2ti(:nspec) = (2.*deli(:nspec))*((pkpar2*wrk3)*pk2ms - del1*
     1   pkpar*adxy1)*wrk2
      dhti(:nspec) = (da4ti(:nspec)*pkp2+da2ti(:nspec))*pkp2
c ----- w.r.t. Te  :  Te*d/dTe
      dhte = 0.
      dxete = -0.5*xe
      ddelmte = ddelmz*dxete/dxez + delm
      delmter = real(ddelmte)
      deps3te = deps3z*dxete/dxez
      wrk7 = real(delmter/ceps3 + (1. - wrk5)*deps3te/ceps3/ceps3)
      da4te = -wrk7*wrk4
      wrk8 = real((-ddelmte) + 2.*del1*del1*ceps3 + del1*del1*deps3te)
      da2te = pk2ms*wrk8 - 2.*pkpar*del1*adxy1*wrk3 - wrk6*real(deps3te/
     1   ceps3/ceps3)
      dhte = (da4te*pkp2 + da2te)*pkp2
c501  dhte = 0.
c$$$$$    02/00
c ----- w.r.t. density  :  n*d/dn
c        cwke3=asxy1-pkpar2
c        cwke1=asxy1+apzz
c        cwke5=wpe2-asxye
      a4ne = asxye*wrk1 - wrk2*wrk4
      a2ne = pk2ms*(del1*del1*eps3r - wrk5) - asxye*(1. - wrk5 + del1*
     1   del1*eps3r) + (2.*pk2ms - pkpar2*wrk3*wrk3)*asxye*wrk2 - wrk2*
     2   wrk6
      a0ne = -2.*asxye*pk2ms
      dhne = (a4ne*pkp2 + a2ne)*pkp2 + a0ne
      da4ni(:nsp1) = ((-cwwk(:nsp1))+(((2.*pkpar2)*wrk3)*deli(:nsp1)))*
     1   wrk1
      da2ni(:nsp1) = cwwk(:nsp1)*(1. - wrk5 + del1*del1*eps3r) - 2.*
     1   pkpar*del1*(wrk3*cwwk(:nsp1)/wci(:nsp1)+deli(:nsp1)*adxy1) + ((
     2   2.*cwwk(:nsp1))*adxy1/wci(:nsp1)-(2.*cwwk(:nsp1))*pk2ms+(((2.*
     3   pkpar2)*wrk3)*deli(:nsp1))*pk2ms-pkpar2*wrk3*wrk3*deli(:nsp1))*
     4   wrk2
      da0ni(:nsp1) = 2.*(cwwk(:nsp1)*pk2ms-cwwk(:nsp1)*adxy1/wci(:nsp1))
      dhni(:nsp1) = (da4ni(:nsp1)*pkp2+da2ni(:nsp1))*pkp2 + da0ni(:nsp1)
      dhni(nsp1+1:nspec) = 0.
c
      if (ientry == 0) return 
c
      poyntn = 1.
c
      gamma = 0.
      game = 0.
c
c ********************************************************************
c  polarizations with SC Chiu's corrections:
c ********************************************************************
      dd = adxy
      ss = asxy
      cdd = dd + cei*2.*wpe2*coln/wce/wce2
      css = ss + cei*wpe2*coln/wce2
      coln = coln/denomc
      delm = delm + asxye*vte**2*cei*coln*0.5
      eps3i = eps3i + wpe2*coln
      ae32 = eps3r*eps3r + eps3i*eps3i
      ssmnp2 = ss - pkpar2
      csmnp2 = css - pkpar2
      cepy0=1.-pkp2*(ssmnp2+pkpar2*wrk3*wrk3)*eps3r/(ssmnp2*aeps32)
      cepz0 = -cei*pkpar*pkp*(dd*eps3r*wrk3/(aeps32*ssmnp2) + 0.5*gprm/(
     1   wce*pkpar2*zxe2))
      cepx0 = cei/ssmnp2*(dd*cepy0 + cei*pkpar*pkp*wrk3*cepz0)
      emod = sqrt(abs(cepx0)**2 + abs(cepy0)**2 + abs(cepz0)**2)
      thetz = atan2(aimag(cepz0),real(cepz0))
      crot = cos(thetz) - cei*sin(thetz)
      cepx0 = cepx0*crot/emod
      cepy0 = cepy0*crot/emod
      cepz0 = cepz0*crot/emod
 
c
c-------------------SCC   6/27/95
c  for Poynting flux, we need to use cold dispersion for polarization
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c  7/10/91   Revised by T.K. Mau
c  projection of poynting vector
c
      zemk = epx*pkp + epz*pkpar
      epx2 = abs(cepx0)**2
      epz2 = abs(cepz0)**2
      work2 = real(cepx0)*real(cepz0) + aimag(cepx0)*aimag(cepz0)
      ztx = pkp*(1. - epx2) - pkpar*work2
      ztz = pkpar*(1. - epz2) - pkp*work2
c
      ztpsi = pkpsi/pkp*ztx
      zttau = ztx*pkheta/pkp*acostq + ztz*asintq
 
      poyntn = abs((pkpsi*pkpsi + pkheta*pktau*acostq)*ztx/pkp + pktau*
     1   asintq*ztz)
c
c       zep=apzz-pkp2
c       zes=asxy1-pkpar2-pkp2
c       epx=zep*zes
c       epy=-adxy1*zep
c       epz=-pkp*pkpar*zes
c       zmod=sqrt(epx*epx+epy*epy+epz*epz)
c       epx=epx/zmod
c       epy=epy/zmod
c       epz=epz/zmod
c
c       zemk = epx*pkp + epz*pkpar
c       ztx=pkp-zemk*epx
c       ztz=pkpar-zemk*epz
c
c        ztpsi = pkpsi/pkp*ztx
c        zttau = ztx*pkheta/pkp*acostq +ztz*asintq
c
c        zkpol = sqrt(pkpsi*pkpsi+pktau*pktau)
c        poyntn = (pkpsi*pkpsi+pkheta*pktau*acostq)*ztx/pkp +
c    +               pktau*asintq*ztz
c
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c
c$$$$ Evaluate complex Kij terms due to thermal ions, and modified
c     Nper to include correction terms in field polarization factors
c
c     if(idmpsw.ge.0) then
      if (idmpsw>=0 .and. idmpsw/=2) then
         xxtt = 0.
         yytt = 0.
         xytt = 0.
c $$$$    TK Mau   6/98
         gamip(:nspec) = 0.
         gamir(:nspec) = 0.
c $$$$
         do k = 1, nspec
            xi0 = 684.91*sqrt(atm(k)/tempi(k))/abs(pkpar)
            almi = 1.0626E-6*pkp2/wci2(k)*tempi(k)*trati(k)/atm(k)
            yion = 1./wci(k)
            nu = yion + inc
            nl = yion - inc
            if (nl <= 0) nl = 1
            if (nu <= 0) nu = 1
            call ibesin (nu + 2, besr, almi)
            xxi1(k) = 0.
            yyi(k) = 0.
            xyr(k) = 0.
            do i2 = nl, nu
               zetai(i2) = xi0*(1. - i2*wci(k))
c               call zfun (0, zetai(i2), czi, czip, zfn, zfc, xzz, nptzf
c     1            , nptzfa, hzf, iout0)
               call zfun( zetai(i2), czi, czip)
               besi(i2) = (1. + i2/almi)*besr(i2+1) - besr(i2)
               dumi = wpi2(k)*xi0*trati(k)*(1. - i2*wci(k)+(i2*wci(k)-
     1            pkpar*vdrfti(k))/trati(k))
               if (almi <= 1.) dumi = exp((-almi))*dumi
               xxi1(k) = xxi1(k) + i2*i2*besr(i2+1)*czi*dumi/almi
               yyi(k) = yyi(k) + 2.*besi(i2)*czi*almi*dumi
               xyr(k) = xyr(k) + i2*besi(i2)*czi*dumi
               if (i2 == 1) then
                  c1 = 1. - wci(k)
                  if (abs(c1) <= 1.E-10) then
                     wwork(k) = 2.*cwwk(k)
                  else
                     wwork(k) = wpi2(k)/c1
                  endif
                  xxi1(k) = xxi1(k) + 0.5*wwork(k)
                  xyr(k) = xyr(k) - 0.5*wwork(k)
               endif
c $$$$    TK Mau    6/98
               gamip(k) = gamip(k) + 0.5*zdsqpi*dumi*exp((-zetai(i2)**2)
     1            )*(i2*besr(i2)+almi*(besr(i2+1)-besr(i2)))
c $$$$
            end do
            yyi(k) = xxi1(k) + yyi(k)
            if (concti(k) /= 0.) then
               almit = almi*ttli(k)*tratti(k)/trati(k)
               call ibesin (nu + 2, besr, almit)
               xxti(k) = 0.
               yyti(k) = 0.
               xytr(k) = 0.
               xit0 = xi0/sqrt(ttli(k))
               do i3 = nl, nu
                  zetat(i3) = xit0*(1. - i3*wci(k))
c                  call zfun (0, zetat(i3), czti, cztip, zfn, zfc, xzz, 
c     1               nptzf, nptzfa, hzf, iout0)
                  call zfun(zetat(i3), czti, cztip)
                  besi(i3) = (1. + i3/almit)*besr(i3+1) - besr(i3)
                  dumt = wpi2(k)*xit0*tratti(k)*(1. - i3*wci(k)+(i3*wci(
     1               k)-pkpar*vdrfti(k))/tratti(k))
                  if (almit <= 1.) dumt = exp((-almit))*dumt
                  xxti(k) = xxti(k) + i3*i3*besr(i3+1)*czti*dumt/almi
                  yyti(k) = yyti(k) + 2.*dumt*almi*besi(i3)*czti
                  xytr(k) = xytr(k) + i3*besi(i3)*czti*dumt
                  if (i3 == 1) then
                     c1 = 1. - wci(k)
                     if (abs(c1) <= 1.E-10) then
                        wwork(k) = 2.*cwwk(k)
                     else
                        wwork(k) = wpi2(k)/c1
                     endif
                     xxti(k) = xxti(k) + 0.5*wwork(k)
                     xytr(k) = xytr(k) - 0.5*wwork(k)
                  endif
               end do
               yyti(k) = xxti(k) + yyti(k)
               xxi1(k) = (1. - concti(k))*xxi1(k) + concti(k)*xxti(k)
               yyi(k) = (1. - concti(k))*yyi(k) + concti(k)*yyti(k)
               xyr(k) = (1. - concti(k))*xyr(k) + concti(k)*xytr(k)
            endif
            xxtt = xxtt + xxi1(k)
            yytt = yytt + yyi(k)
            xytt = xytt + xyr(k)
         end do
         ss1 = css + xxtt
         sy1 = css + yytt
         dd1 = cdd + xytt
         ssmnp21 = css - pkpar2 + xxtt
         symnp21 = css - pkpar2 + yytt
c------------------------------
c
c  calculate modified kperp for damping and polarization
c    SCC   10/8/96
c
c-------------------------------------
         ceps31 = ceps3 + cei*wpe2*coln
         zwrk1 = (1. - delm)/ceps31
         zwrk2 = 1./ceps31
         zwrk3 = 1. + del0
         zwrk4 = pkpar2*zwrk3*zwrk3 + ssmnp21
         zwrk6 = dd1*dd1 - ssmnp21*symnp21 - pkpar2*zwrk3*zwrk3*symnp21
         cfour = zwrk4*zwrk1
         ctwo = (-ssmnp21*(del1*del1*ceps31 + 1. - delm)) - 2.*pkpar*
     1      del1*zwrk3*dd1 + zwrk6*zwrk2
         czero = ssmnp21*symnp21 - dd1**2
         cdiscr = ctwo*ctwo - 4.*cfour*czero
         crtdcr = csqrt(cdiscr)
         cpkp21 = ((-ctwo) + crtdcr)/2./cfour
         cpkp22 = ((-ctwo) - crtdcr)/2./cfour
         apkp21 = abs(cpkp21)
         apkp22 = abs(cpkp22)
         if (apkp21 > apkp22) then
            cwrk1 = cpkp21
            cpkp21 = cpkp22
            cpkp22 = cwrk1
         endif
c$$$$$$$$$$   TKM    11/98
c    Fix jslofa to islofa, i.e., no mode conversion is allowed.
c    Temporary fix due to 'bug' in mode conversion scheme
c    Needs to be fixed.
         if (islofa == (-1)) jslofa = islofa
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
         if (jslofa == (-1)) then
            cpkp2c = cpkp21
         else
            cpkp2c = cpkp22
         endif
         cpkp1 = csqrt(cpkp2c)
      else
         cpkp2c = pkp2
         cpkp1 = pkp
      endif
c--------------------------------------
      gprm = (1. + xe*cz)/(1. + cz*(xe - pkpar*vdrfte/trate))*trate
      cepy = 1. - cpkp2c*(ssmnp21 + pkpar2*wrk3*wrk3)*(eps3r - cei*eps3i
     1   )/(ssmnp21*ae32)
      cepz = -cei*pkpar*cpkp1*(dd1*(eps3r - cei*eps3i)*wrk3/(ae32*
     1   ssmnp21) + 0.5*gprm/(wce*pkpar2*zxe2))
c    1     /(ae32*ssmnp21))
      cepx = cei/ssmnp21*(dd1*cepy + cei*pkpar*cpkp1*wrk3*cepz)
      emod = sqrt(abs(cepx)**2 + abs(cepy)**2 + abs(cepz)**2)
      thetz = atan2(aimag(cepz),real(cepz))
      crot = cos(thetz) - cei*sin(thetz)
      cepx = cepx*crot/emod
      cepy = cepy*crot/emod
      cepz = cepz*crot/emod
c-----------------------------------------
c ****   TKM   8/98
c Calculate left- and right-hand circularly polarized components
c   and their ratio
      epl0 = abs(cepx)**2 + abs(cepy)**2
      epl1 = 2.*(aimag(cepx)*real(cepy) - real(cepx)*aimag(cepy))
      eplus2 = epl0 + epl1
      eminu2 = epl0 - epl1
      eprat = eplus2/eminu2
c ************
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c  7/10/91  Revised by T.K. Mau
c  absorption coefficients
c
c  Electron Landau and TTMP Damping
c
      gamce = 0.
      if (abs(xe)<=10 .or. concte/=0.) then
         xet = xe/sqrt(ttle)
         if (abs(xet) <= 10.) then
            if (inf > (-2)) then
               jpe = jpe + 1
               if (inf < 0) then
c
c $$$ Electron damping for anisotropic, bi-Maxwellian distribution.
c
                  alme = 1.951E-3*pkp2/wce2*tempe*trate
                  epsyyi = 2.*wpe2*xe*alme*aimag(cz)*(1. - pkpar*vdrfte/
     1               trate)*trate
                  epsyzr = wpe2/wce*trate*pkp/pkpar*aimag(cz)*(xe - 
     1               pkpar*vdrfte/trate)
                  if (concte /= 0.) then
                     almet = alme*ttle*tratte/trate
c     cxet = cmplx(xet,0.)
c                    call zfun (0, xet, czt, cztp, zfn, zfc, xzz, nptzf
c    1                  , nptzfa, hzf, iout0)
                     call zfun(xet, czt, cztp)
                     dumt = wpe2*concte*aimag(czt)
                     epsyyi = (1. - concte)*epsyyi + 2.*dumt*tratte*
     1                  almet*(1. - pkpar*vdrfte/tratte)
                     epsyzr = (1. - concte)*epsyzr + dumt/wce*tratte*pkp
     1                  /pkpar*(xet - pkpar*vdrfte/tratte)
                     eps3i = (1. - concte)*eps3i + 2.*dumt*xet**3
                  endif
                  game = epsyyi*abs(cepy)**2 + 2.*epsyzr*(real(cepy)*
     1               aimag(cepz) - aimag(cepy)*real(cepz)) + eps3i*abs(
     2               cepz)**2
c----------------
c  pkp2 and pkp used here; probably not very consistent. But error
c   should be small
c---------------
c-------------------
c  collisional damping
c-------------------
                  exxic = aimag(css)
                  exyrc = aimag(cdd)
                  eyyic = wpe2*alme*coln + exxic
                  eyzrc = 0.5*wpe2*pkp/wce/pkpar*coln/xe/xe
                  ezzic = wpe2*coln
                  gamce = exxic*abs(cepx)**2 + eyyic*abs(cepy)**2 + 
     1               ezzic*abs(cepz)**2 + 2.*eyzrc*(real(cepy)*aimag(
     2               cepz) - aimag(cepy)*real(cepz)) + 2.*exyrc*(real(
     3               cepx)*aimag(cepy) - aimag(cepx)*real(cepy))
               else
c
c $$$ Electron damping for non-Maxwellian distribution
c
                  kbd = 4
                  call fnmax (0, npar, upar, nper, uper, tnmaxe, dsfe)
                  call coeff2 (npar, upar, nper, uper, dsfe, fpar2, 
     1               fper2, fpp2, npar, kbd, wwork)
                  vthe = 0.06346*sqrt(tnmaxe)
                  delu = (uper(nper)-uper(1))/float(intg - 1)
                  ures = 1./(abs(pkpar)*vthe)
                  do j2 = 1, intg
                     upx = delu*float(j2 - 1)
                     alam = pkp*upx/wce
                     call beslci (alam, 0., 2, 0, besr, besi, ncalc)
                     cth = (-cei*cepy*upx*besr(2)) + ures*cepz*besr(1)
                     dfpar = terp2(ures,upx,npar,upar,nper,uper,dsfe,
     1                  fpar2,fper2,fpp2,npar,1,0)
                     th2 = abs(cth)**2
                     funp(j2) = th2*pkpar*upx*vthi*dfpar
                  end do
                  game = -4.*sqrt(zpi)*wpe2/abs(pkpar)*simp(intg,delu,
     1               funp)
               endif
            endif
         endif
      endif
      gamma = game + gamce
c
c$$$$  Harmonic ion cyclotron damping
c
      gamit = 0.
      gami(:nspec) = 0.
      if (idmpsw /= 0) then
         do k = 1, nspec
            jpi = jpi + 1
            if (infi(k) <= 0) then
               if (idmpsw /= 2) then
                  gami(k) = aimag(xxi1(k))*abs(cepx)**2 + 2.*aimag(xyr(
     1               k))*(real(cepx)*aimag(cepy) - aimag(cepx)*real(cepy
     2               )) + aimag(yyi(k))*abs(cepy)**2
c $$$$     TK Mau    8/98
                  gamip(k) = gamip(k)*eplus2
                  gamir(k) = 0.5*eminu2*(0.5*(aimag(xxi1(k))+aimag(yyi(k
     1               )))+aimag(xyr(k))) - 0.5*(aimag(yyi(k))-aimag(xxi1(
     2               k)))*(abs(cepx)**2 - abs(cepy)**2)
c $$$$
c $$$$    TK Mau    7/95
               else
                  pktot = sqrt(pkp2 + pkpar2)
                  xi0 = 684.91*sqrt(atm(k)/tempi(k))/pktot
                  if (xi0 >= 10.) then
                     xkt = 0.
                  else
                     xkt = 2.*zdsqpi*wpi2(k)*xi0*exp((-xi0**2))
                  endif
                  xkl = xi0**2*xkt
                  pnp = pkp/pktot
                  pnpar = pkpar/pktot
                  xk11 = xkl*pnp**2 + xkt*pnpar**2
                  xk22 = xkt
                  xk33 = xkl*pnpar**2 + xkt*pnp**2
                  xk13 = pnp*pnpar*(xkl - xkt)
                  gami(k) = abs(cepx)**2*xk11 + abs(cepy)**2*xk22 + 
     1               abs(cepz)**2*xk33 + 2.*(real(cepx)*real(cepz) - 
     2               aimag(cepx)*aimag(cepz))*xk13
               endif
c $$$$$$$$$$$$$$$$$$$$$
            else
c $$$ Harmonic ion cyclotron damping for a given non-Maxwellian distribution
c     function, which is in a 2D array with respect to uperp and upar,
c     normalized to a characteristic thermal speed with a given temperature.
c
               kbd = 4
               call fnmax (1, npar, upar, nper, uper, tnmaxi, dsfi)
               call coeff2 (npar, upar, nper, uper, dsfi, fpar2, fper2, 
     1            fpp2, npar, kbd, lwork)
               vthi = 1.0327E-3*sqrt(tnmaxi/atm(k))
               delu = (uper(nper)-uper(1))/float(intg - 1)
               acyc = 1./wci(k)
               nu = acyc + inc
               nl = acyc - inc
               if (nl <= 0) nl = 1
               if (nu <= 0) nu = 1
               do i1 = nl, nu
                  ures = (1. - float(i1)*wci(k))/(abs(pkpar)*vthi)
                  do j1 = 1, intg
                     upx = delu*float(j1 - 1)
                     alam = pkp*upx/wci(k)
                     call beslci(alam,0.,i1+1,0,besr,besi,ncalc)
                     cth = cepx*upx*(besr(i1)+besr(i1+2)) + cei*cepx*upx
     1                  *(besr(i1)-besr(i1+2)) + 2.*ures*cepz*besr(i1+1)
                     dfper = terp2(ures,upx,npar,upar,nper,uper,dsfi,
     1                  fpar2,fper2,fpp2,npar,0,1)
                     dfpar = terp2(ures,upx,npar,upar,nper,uper,dsfi,
     1                  fpar2,fper2,fpp2,npar,1,0)
                     th2 = abs(cth)**2
                     funp(j1) = th2*(float(i1)*wci(k)*dfper+pkpar*upx*
     1                  vthi*dfpar)
                  end do
                  gami(k) = gami(k) - sqrt(zpi)*wpi2(k)/pkpar*simp(intg,
     1               delu,funp)
               end do
            endif
            gamma = gamma + gami(k)
            gamit = gamit + gami(k)
         end do
c  $$$$$$
c  $$$$  TK Mau    7/95, 01/00
         if (kalfa > 0) then
            gamal(:nalfa,:nharm0) = 0.
c********    TKM   06/97
c     if(kalfa.ne.0.and.idmpsw.gt.1) then
            if (idmpsw == 2) then
               idmpal = 2
               if (psi < ppsi(nprof-2)) call alfadamp (idmpal)
            else
               if (idmpsw == 1) then
                  call alfadamp (1)              ! To be corrected.
               else
                  nharm0 = 1
                  do k = 1, nalfa
                     xf0 = 684.91*sqrt(atmf(k)/temsa(k))/abs(pkpar)
                     almf = 1.0626E-6*pkp2/wcf2(k)*temsa(k)/atmf(k)
                     yfion = 1./wcf(k)
                     nu = yfion + inc
                     nl = yfion - inc
                     if (nl <= 0) nl = 1
                     if (nu <= 0) nu = 1
                     call ibesin (nu + 2, besr, almf)
                     xxif1(k) = 0.
                     yyif(k) = 0.
                     xyrf(k) = 0.
                     do i2 = nl, nu
                        zetaf(i2) = xf0*(1. - i2*wcf(k))
c                        call zfun (0, zetaf(i2), czi, czip, zfn, zfc, 
c     1                     xzz, nptzf, nptzfa, hzf, iout0)
                        call zfun(zetaf(i2), czi, czip)
                        besi(i2) = (1. + i2/almf)*besr(i2+1) - besr(i2)
                        dumf = wpf2(k)*xf0
                        if (almf <= 1.) dumf = exp((-almf))*dumf
                        xxif1(k) = xxif1(k) + i2*i2*besr(i2+1)*czi*dumf/
     1                     almf
                        yyif(k) = yyif(k) + 2.*besi(i2)*czi*almf*dumf
                        xyrf(k) = xyrf(k) + i2*besi(i2)*czi*dumf
                        if (i2 == 1) then
                           c1 = 1. - wcf(k)
                           if (abs(c1) <= 1.E-10) then
                              wwork(k) = 2.*cwwk(k)
                           else
                              wwork(k) = wpi2(k)/c1
                           endif
                           xxif1(k) = xxif1(k) + 0.5*wwork(k)
                           xyrf(k) = xyrf(k) - 0.5*wwork(k)
                        endif
                     end do
                     yyif(k) = xxif1(k) + yyif(k)
                     gamal(k,1) = aimag(xxif1(k))*abs(cepx)**2 + 2.*
     1                  aimag(xyrf(k))*(real(cepx)*aimag(cepy) - aimag(
     2                  cepx)*real(cepy)) + aimag(yyif(k))*abs(cepy)**2
                  end do
               endif
            endif
            gamat = 0.
            do k = 1, nalfa
               gamma = gamma + sum(gamal(k,:nharm0))
               gamat = gamat + sum(gamal(k,:nharm0))
            end do
         endif
      endif
c  $$$$$$
 
c     Collisional damping:
c
c $$$$$$$$$$$$$$$$$$$$$$$
c   7/16/91   T.K. Mau
c
c     1.47e-9 = (4/3)*sqrt(2*pi)*16*q**4/(sqrt(me)*(1.6e-9 erg/keV)**1.5)
C******************************************* SCC  12/13/95
c  70 rnue = 1.47e-9*dense*zeff/tempe**1.5
C************************************************************
c     rnue2=rnue*rnue
c     eps3ci=wpe2*rnue/(1.+rnue2)
c     gamce = eps3ci*abs(cepz)**2
c     xxci = 0.
c     xyci = 0.
c     do 61 kc = 1,nspec
c     denom = (1.-rnue2-wci2(kc))**2+4.*rnue2
c     xxci = xxci+wpi2(kc)*rnue*(1.+rnue2+wci2(kc))/denom
c     xyci = xyci -2.*wpi2(kc)*wci(kc)*rnue/denom
c  61 continue
c     gamci = xxci*(abs(cepx)**2+abs(cepy)**2)-2.*xyci*
c    &        (real(cepy)*aimag(cepx)-real(cepx)*aimag(cepy))
c
c $$$$$$$$$$$$$$$$$$$$$
 
      return 
      end subroutine disper
      subroutine grill
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:03:04   6/14/01  
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vsizes
      use Viorlh
      use Vcmnew
      use Vchpcsd
      use Vcraylh
      use Vceqdsk
      implicit none
C-----------------------------------------------
c
c  dummy routine for the case in which the raylh code
c     is used alone.
c
c  to use it in conjunction with the grill code, include here instead
c     all the segments of the grill code except the main
c
      return 
      end subroutine grill
 
      subroutine scatperp
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:03:04   6/14/01  
C...Switches: -p4 -yb
c
c  Scatters perp wavenumber by an angel given by a normal random
c  number generator with standard deviation sqrt(2.*scatd)
c
c ************ ************ ************ ************ ************
c
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vsizes
      use Viorlh
      use Vcmnew
      use Vchpcsd
      use Vcraylh
      use Vceqdsk
      use Viogrl
      use Vcgraphs
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      real :: pkpsi1, pkheta1, pktau1, pkphi1, akpsi1, akth1, anphi1
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c------------ --------------
c   common blocks of Comiogrl
c---------------------------
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c
c   Comhpcsd
c
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c
c----------------------------
c   common blocks of Cmgraphs
c
 
c    2   ,sqti(nprofm)
c
      real anum
      call random_number(anum)
      alpha1 = atan2(pkheta,pkpsi)
      alpha2 = alpha1 + sqrt(2.*scatd)*anum
c   Recalculate physical wavenumber components
      pkpsi1 = pkp*cos(alpha2)
      pkheta1 = pkp*sin(alpha2)
      pktau1 = pkpar*asintq + pkheta1*acostq
      pkphi1 = pkpar*acostq - pkheta1*asintq
c   Recalculate covariant wavevector components:
      akpsi1 = (aj*pkpsi1 + ag*pktau1)/antau
      akth1 = antau*pktau1
      anphi1 = urhs*pkphi1
c
c     Skip reset of wave-vector according to conditions:
      if (pkpsi*pkpsi1>0. .or. psi<=1.) then
         if (akpsi*akpsi1>0. .or. psi<=1.) then
            pkpsi = pkpsi1
            pkheta = pkheta1
            pktau = pktau1
            pkphi = pkphi1
            akpsi = akpsi1
            akth = akth1
            anphi = anphi1
         endif
      endif
      return 
      end subroutine scatperp
      subroutine scovte(q)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:03:04   6/14/01  
C...Switches: -p4 -yb
c ************ ************ ************ ************ ************
c  n parallel versus radius giving omega/(kpar*vthe) = q
c  with the electron temperature profiles of raylh & raylh0
c ************ ************ ************ ************ ************
c
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vsizes
      use Viorlh
      use Vcmnew
      use Vchpcsd
      use Vcraylh
      use Vceqdsk
      use Viogrl
      use Vcgraphs
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real q
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n
      real :: c, covte
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c----------------------------
c   common blocks of Cmgraphs
c
 
c    2   ,sqti(nprofm)
c
c ************ ************ ************ ************ ************
c
      data c/15.985/
c
      sqte(:nprof) = c/sqrt(pte(:nprof))/q
c
      return 
      end subroutine scovte
      subroutine subkmc(pkp21, pkp22, pkp23, ind2, kslofa, jchois, kmcon
     1   , pkp20, iermc, disck2, a2k, nslofa, imode)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:03:04   6/14/01  
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vsizes
      use Viorlh
      use Vcmnew
      use Vchpcsd
      use Vcraylh
      use Vceqdsk
      use Viogrl
      use Vcgraphs
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer ind2, kslofa, jchois, kmcon, iermc, nslofa, imode
      real pkp21, pkp22, pkp23, pkp20, disck2, a2k
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      real, dimension(3) :: wrk
      real :: dk2tst
C-----------------------------------------------
c
c  check if close to mode conversion, if so, kmcon=1
c  check if close to evanescence, if so, kmcon=-1
c  otherwise, kmcon=0
c---------------------------
c------------------
      iermc = 0
      dk2tst = amin1(abs(disck2),abs(disck2/a2k))
      if (pkp20<0.1 .or. pkp2<0.1) then
         kmcon = -1
         return 
      endif
      if (abs(disck2)<0.1 .and. abs(a2k)<0.1) then
         kmcon = -1
         return 
      endif
      select case (jchois) 
      case default
         if (iermc == 0) then
            if (dk2tst<=5.E-2 .or. abs((pkp22-pkp23)/pkp22)<=5.E-2) then
               kmcon = 1
               ind2 = 0
               if (kslofa == 1) then
                  pkp20 = pkp23
                  imode = 3
               else
                  pkp20 = pkp22
                  imode = 2
               endif
               nslofa = -kslofa
            else
               kmcon = 0
            endif
         endif
         return 
c-------------
      case (1) 
         wrk(1) = pkp21
         wrk(2) = pkp22
         wrk(3) = pkp23
         if (iermc == 0) then
            if (dk2tst<=5.E-2 .or. abs((pkp22-pkp23)/pkp22)<=5.E-2
     1          .and. imode/=1) then
               kmcon = 1
               if (kslofa == (-1)) then
                  pkp20 = wrk(2)
                  nslofa = -kslofa
                  imode = 2
               else if (kslofa == 2) then
                  pkp20 = wrk(3)
                  nslofa = 1
                  imode = 3
               else if (ind2 == 0) then
                  pkp20 = wrk(3)
                  nslofa = -1
                  imode = 3
               else if (ind2 == 1) then
                  pkp20 = wrk(2)
                  nslofa = 2
                  imode = 2
               endif
            else
               kmcon = 0
            endif
         endif
         return 
      end select
      end subroutine subkmc
 
      function svfuse (tiloc, irate)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:03:04   6/14/01  
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vsizes
      use Viorlh
      use Vcmnew
      use Vchpcsd
      use Vcraylh
      use Vceqdsk
      use Viogrl
      use Vcgraphs
      USE Verrsvf
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real svfuse
      integer irate
      real tiloc
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: ipt, ix
      real, dimension(96,6) :: sv
      real, dimension(96) :: sv1, sv2, sv3, sv4, sv5, sv6
      real :: t, dtx, tx, tl, svl
C-----------------------------------------------
c***********************************************************************
c*****w.a.houlberg ornl 2/79.                                          *
c*****tabulated data provided by j.r.mcnally,jr.                       *
c***********************************************************************
c*****svfuse is <sigma*vel> averaged over two maxwellian distributions *
c*****with temperature ti. units are in cm**3/sec for svfuse.          *
c*****irate=index denoting reaction                                    *
c*****  = 1   d+d => 3he(  817kev) +n( 2450kev)                  ref 1 *
c*****  = 2   d+d =>   t( 1008kev) +p( 3024kev)                  ref 1 *
c*****  = 3   d+t =>   a( 3517kev) +n(14069kev)                  ref 1 *
c*****  = 4   t+t =>   a( 1259kev) +n( 5034kev) +n( 5034kev)     ref 1 *
c*****  = 5 3he+t =>   d( 9546kev) +a( 4773kev)              41% ref 2 *
c*****            =>   p( 5374kev) +a( 1344kev) +n( 5374kev) 55% ref 2 *
c*****            =>   p(10077kev) +a(  403kev) +n( 1612kev)  4% ref 2 *
c*****  = 6 3he+d =>   p(14681kev) +a( 3670kev)                  ref 1 *
c*****the energies for the products are inversely proportional to the  *
c*****mass of each product.                                            *
c*****the branching ratio for reaction 5 is energy sensitive.          *
c*****ref 1: ucrl-70552 (1967)                                         *
c*****ref 2: bnwl-1685  (1975) p. 75                                   *
c*****       sov phys jetp 12 (1961) p. 163                            *
c*****ti=maxwellian temperature in ev.                                 *
c*****cross-sections tabulated in steps of .2 kev for   1.<t< 10. kev  *
c*****                                     2. kev for  10.<t<100. kev  *
c*****                                    20. kev for 100.<t<200. kev  *
c***********************************************************************
      equivalence(sv(1,1),sv1(1)),(sv(1,2),sv2(1)),(sv(1,3),sv3(1))
      equivalence(sv(1,4),sv4(1)),(sv(1,5),sv5(1)),(sv(1,6),sv6(1))
      data sv1/9.65E-23, 2.61E-22, 5.75E-22, 1.10E-21, 1.90E-21, 
     1   3.04E-21, 4.58E-21, 6.57E-21, 9.06E-21, 1.21E-20, 1.57E-20, 
     2   2.00E-20, 2.49E-20, 3.04E-20, 3.67E-20, 4.37E-20, 5.14E-20, 
     3   5.98E-20, 6.90E-20, 7.90E-20, 8.97E-20, 1.01E-19, 1.13E-19, 
     4   1.26E-19, 1.40E-19, 1.55E-19, 1.70E-19, 1.86E-19, 2.03E-19, 
     5   2.21E-19, 2.39E-19, 2.58E-19, 2.78E-19, 2.99E-19, 3.20E-19, 
     6   3.42E-19, 3.64E-19, 3.88E-19, 4.12E-19, 4.37E-19, 4.62E-19, 
     7   4.88E-19, 5.15E-19, 5.42E-19, 5.70E-19, 5.99E-19, 9.18E-19, 
     8   1.29E-18, 1.71E-18, 2.16E-18, 2.65E-18, 3.17E-18, 3.71E-18, 
     9   4.27E-18, 4.85E-18, 5.44E-18, 6.04E-18, 6.66E-18, 7.28E-18, 
     .   7.90E-18, 8.54E-18, 9.18E-18, 9.82E-18, 1.05E-17, 1.11E-17, 
     1   1.18E-17, 1.24E-17, 1.30E-17, 1.37E-17, 1.43E-17, 1.50E-17, 
     2   1.56E-17, 1.63E-17, 1.69E-17, 1.76E-17, 1.82E-17, 1.88E-17, 
     3   1.95E-17, 2.01E-17, 2.07E-17, 2.13E-17, 2.20E-17, 2.26E-17, 
     4   2.32E-17, 2.38E-17, 2.44E-17, 2.50E-17, 2.56E-17, 2.62E-17, 
     5   2.68E-17, 2.74E-17, 3.32E-17, 3.86E-17, 4.37E-17, 4.86E-17, 
     6   5.32E-17/
      data sv2/9.66E-23, 2.61E-22, 5.76E-22, 1.10E-21, 1.91E-21, 
     1   3.05E-21, 4.59E-21, 6.58E-21, 9.07E-21, 1.21E-20, 1.57E-20, 
     2   1.99E-20, 2.48E-20, 3.04E-20, 3.66E-20, 4.35E-20, 5.11E-20, 
     3   5.95E-20, 6.86E-20, 7.84E-20, 8.90E-20, 1.00E-19, 1.12E-19, 
     4   1.25E-19, 1.39E-19, 1.53E-19, 1.68E-19, 1.83E-19, 2.00E-19, 
     5   2.17E-19, 2.35E-19, 2.53E-19, 2.72E-19, 2.92E-19, 3.12E-19, 
     6   3.33E-19, 3.55E-19, 3.77E-19, 4.00E-19, 4.23E-19, 4.48E-19, 
     7   4.72E-19, 4.97E-19, 5.23E-19, 5.49E-19, 5.76E-19, 8.72E-19, 
     8   1.21E-18, 1.58E-18, 1.99E-18, 2.41E-18, 2.85E-18, 3.31E-18, 
     9   3.79E-18, 4.27E-18, 4.76E-18, 5.25E-18, 5.75E-18, 6.26E-18, 
     .   6.77E-18, 7.28E-18, 7.79E-18, 8.30E-18, 8.81E-18, 9.32E-18, 
     1   9.84E-18, 1.03E-17, 1.09E-17, 1.14E-17, 1.19E-17, 1.24E-17, 
     2   1.29E-17, 1.34E-17, 1.39E-17, 1.44E-17, 1.49E-17, 1.54E-17, 
     3   1.59E-17, 1.64E-17, 1.69E-17, 1.73E-17, 1.78E-17, 1.83E-17, 
     4   1.88E-17, 1.93E-17, 1.97E-17, 2.02E-17, 2.07E-17, 2.12E-17, 
     5   2.16E-17, 2.21E-17, 2.66E-17, 3.09E-17, 3.51E-17, 3.90E-17, 
     6   4.29E-17/
      data sv3/6.27E-21, 1.86E-20, 4.44E-20, 9.11E-20, 1.67E-19, 
     1   2.83E-19, 4.47E-19, 6.72E-19, 9.67E-19, 1.34E-18, 1.81E-18, 
     2   2.38E-18, 3.06E-18, 3.86E-18, 4.79E-18, 5.86E-18, 7.07E-18, 
     3   8.43E-18, 9.95E-18, 1.16E-17, 1.35E-17, 1.55E-17, 1.77E-17, 
     4   2.00E-17, 2.26E-17, 2.53E-17, 2.81E-17, 3.12E-17, 3.44E-17, 
     5   3.78E-17, 4.14E-17, 4.52E-17, 4.91E-17, 5.31E-17, 5.74E-17, 
     6   6.17E-17, 6.63E-17, 7.09E-17, 7.57E-17, 8.07E-17, 8.57E-17, 
     7   9.09E-17, 9.62E-17, 1.02E-16, 1.07E-16, 1.13E-16, 1.74E-16, 
     8   2.39E-16, 3.06E-16, 3.70E-16, 4.31E-16, 4.88E-16, 5.39E-16, 
     9   5.86E-16, 6.28E-16, 6.65E-16, 6.98E-16, 7.27E-16, 7.52E-16, 
     .   7.74E-16, 7.93E-16, 8.09E-16, 8.23E-16, 8.35E-16, 8.45E-16, 
     1   8.54E-16, 8.61E-16, 8.66E-16, 8.70E-16, 8.74E-16, 8.76E-16, 
     2   8.77E-16, 8.78E-16, 8.78E-16, 8.77E-16, 8.76E-16, 8.74E-16, 
     3   8.72E-16, 8.70E-16, 8.67E-16, 8.64E-16, 8.61E-16, 8.57E-16, 
     4   8.54E-16, 8.50E-16, 8.46E-16, 8.42E-16, 8.37E-16, 8.33E-16, 
     5   8.29E-16, 8.24E-16, 7.77E-16, 7.31E-16, 6.89E-16, 6.50E-16, 
     6   6.16E-16/
      data sv4/3.28E-23, 1.02E-22, 2.52E-22, 5.29E-22, 9.84E-22, 
     1   1.68E-21, 2.66E-21, 4.00E-21, 5.75E-21, 7.96E-21, 1.07E-20, 
     2   1.40E-20, 1.79E-20, 2.24E-20, 2.76E-20, 3.35E-20, 4.01E-20, 
     3   4.75E-20, 5.56E-20, 6.45E-20, 7.42E-20, 8.47E-20, 9.60E-20, 
     4   1.08E-19, 1.21E-19, 1.35E-19, 1.49E-19, 1.64E-19, 1.80E-19, 
     5   1.97E-19, 2.14E-19, 2.32E-19, 2.51E-19, 2.71E-19, 2.91E-19, 
     6   3.12E-19, 3.34E-19, 3.56E-19, 3.79E-19, 4.03E-19, 4.27E-19, 
     7   4.52E-19, 4.77E-19, 5.03E-19, 5.30E-19, 5.57E-19, 8.54E-19, 
     8   1.19E-18, 1.56E-18, 1.96E-18, 2.37E-18, 2.80E-18, 3.24E-18, 
     9   3.68E-18, 4.13E-18, 4.59E-18, 5.04E-18, 5.50E-18, 5.96E-18, 
     .   6.41E-18, 6.87E-18, 7.33E-18, 7.78E-18, 8.23E-18, 8.68E-18, 
     1   9.12E-18, 9.57E-18, 1.00E-17, 1.04E-17, 1.09E-17, 1.13E-17, 
     2   1.17E-17, 1.22E-17, 1.26E-17, 1.30E-17, 1.34E-17, 1.39E-17, 
     3   1.43E-17, 1.47E-17, 1.51E-17, 1.55E-17, 1.59E-17, 1.63E-17, 
     4   1.67E-17, 1.71E-17, 1.75E-17, 1.79E-17, 1.83E-17, 1.87E-17, 
     5   1.91E-17, 1.95E-17, 2.32E-17, 2.66E-17, 2.97E-17, 3.25E-17, 
     6   3.48E-17/
      data sv5/0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 
     1   0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 
     2   0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 
     3   0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 
     4   0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 
     5   0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 
     6   0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 
     7   0.00E-00, 0.00E-00, 0.00E-00, 0.00E-00, 1.16E-20, 6.17E-20, 
     8   1.12E-19, 1.62E-19, 2.12E-19, 2.62E-19, 4.37E-19, 6.11E-19, 
     9   7.85E-19, 9.60E-19, 1.13E-18, 1.47E-18, 1.80E-18, 2.14E-18, 
     .   2.47E-18, 2.81E-18, 3.30E-18, 3.80E-18, 4.29E-18, 4.79E-18, 
     1   5.29E-18, 5.93E-18, 6.58E-18, 7.22E-18, 7.87E-18, 8.52E-18, 
     2   9.29E-18, 1.01E-17, 1.09E-17, 1.16E-17, 1.24E-17, 1.33E-17, 
     3   1.42E-17, 1.51E-17, 1.60E-17, 1.69E-17, 1.78E-17, 1.88E-17, 
     4   1.98E-17, 2.08E-17, 2.18E-17, 2.29E-17, 2.39E-17, 2.50E-17, 
     5   2.61E-17, 2.71E-17, 4.01E-17, 5.30E-17, 6.59E-17, 7.88E-17, 
     6   9.18E-17/
      data sv6/3.10E-26, 1.80E-25, 7.28E-25, 2.31E-24, 6.11E-24, 
     1   1.41E-23, 2.94E-23, 5.63E-23, 1.01E-22, 1.70E-22, 2.73E-22, 
     2   4.22E-22, 6.29E-22, 9.09E-22, 1.28E-21, 1.75E-21, 2.36E-21, 
     3   3.11E-21, 4.03E-21, 5.14E-21, 6.46E-21, 8.03E-21, 9.87E-21, 
     4   1.20E-20, 1.45E-20, 1.73E-20, 2.05E-20, 2.41E-20, 2.81E-20, 
     5   3.26E-20, 3.76E-20, 4.32E-20, 4.93E-20, 5.61E-20, 6.35E-20, 
     6   7.15E-20, 8.03E-20, 8.98E-20, 1.00E-19, 1.11E-19, 1.23E-19, 
     7   1.36E-19, 1.50E-19, 1.65E-19, 1.81E-19, 1.97E-19, 4.33E-19, 
     8   8.17E-19, 1.39E-18, 2.19E-18, 3.26E-18, 4.61E-18, 6.28E-18, 
     9   8.27E-18, 1.06E-17, 1.32E-17, 1.62E-17, 1.95E-17, 2.30E-17, 
     .   2.68E-17, 3.09E-17, 3.52E-17, 3.96E-17, 4.42E-17, 4.89E-17, 
     1   5.37E-17, 5.87E-17, 6.36E-17, 6.87E-17, 7.37E-17, 7.88E-17, 
     2   8.38E-17, 8.88E-17, 9.38E-17, 9.87E-17, 1.04E-16, 1.08E-16, 
     3   1.13E-16, 1.18E-16, 1.22E-16, 1.27E-16, 1.31E-16, 1.36E-16, 
     4   1.40E-16, 1.44E-16, 1.48E-16, 1.52E-16, 1.56E-16, 1.60E-16, 
     5   1.63E-16, 1.67E-16, 1.97E-16, 2.19E-16, 2.34E-16, 2.45E-16, 
     6   2.52E-16/
      svfuse = 0.
      t = tiloc/1000.
      if (t>=1. .or. irate/=3) then
         if (t < 1.) return 
         if (t > 200.) ierrsv = 1
         t = amin1(200.0_dp,t)
         dtx = .2
         ipt = -4
         if (t >= 10.) then
            dtx = 2.
            ipt = 41
            if (t >= 100.) then
               dtx = 20.
               ipt = 86
            endif
         endif
!         ix = ifix(t/dtx) + ipt
         ix = int(t/dtx) + ipt
         tx = dtx*(ix - ipt)
         svfuse=sv(ix,irate)+(sv(ix+1,irate)-sv(ix,irate))*(t-tx)/dtx
         return 
      endif
      tl = alog10(tiloc)
      svl = (((-1.110333*tl) + 12.26350)*tl - 49.01817)*tl + 86.86500
      if (svl < 37.) svfuse = 10.**(-svl)
c     this fit is good to svl=50. but dec machines can't handle 1.e-50
      return 
      end function svfuse
 
 
      subroutine wavect
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:03:04   6/14/01  
C...Switches: -p4 -yb
c
c   ****************************************************************
c   *                                                              *
c   *      this modulus evaluates the phisical components          *
c   *           of the wavevector in the psi, theta, phi           *
c   *           frame and in the local stix frame.                 *
c   *                                                              *
c   ****************************************************************
c
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vsizes
      use Viorlh
      use Vcmnew
      use Vchpcsd
      use Vcraylh
      use Vceqdsk
      use Viogrl
      use Vcgraphs
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c
c   ****************************************************************
c
      pkpsi = (antau*akpsi - ag*akth/antau)/aj
      pktau = akth/antau
      pkphi = anphi/urhs
      pk = sqrt(pkpsi*pkpsi + pktau*pktau + pkphi*pkphi)
c
c  stix components
c
      pkheta = pktau*acostq - pkphi*asintq
      pkpar = pktau*asintq + pkphi*acostq
      pkpar2 = pkpar*pkpar
      pkp2 = pkpsi*pkpsi + pkheta*pkheta
      pkp = sqrt(pkp2)
c
c  cartesian components
c
      pkx = (akpsi*dzth - akth*dzpsi)/aj
      pkz = ((-akpsi*dxth) + akth*dxpsi)/aj
c
c  derivatives
c
      dkpsip = (dntaup - djp)*pkpsi + (2.*ag*dntaup - dgp)*pktau/aj
      dkpsit = (dntaut - djt)*pkpsi + (2.*ag*dntaut - dgt)*pktau/aj
      dkhep=(-dntaup*acostq*pktau)+pkphi*dxpsi*asintq/urhs-dqpsi*pkpar
      dkhet=(-dntaut*acostq*pktau)+pkphi*dxth*asintq/urhs-dqth*pkpar
      dkp2p = 2.*(pkpsi*dkpsip + pkheta*dkhep)
      dkp2t = 2.*(pkpsi*dkpsit + pkheta*dkhet)
      dkpzp = (-dntaup*asintq*pktau) - pkphi*dxpsi*acostq/urhs + dqpsi*
     1   pkheta
      dkpzt = (-dntaut*asintq*pktau) - pkphi*dxth*acostq/urhs + dqth*
     1   pkheta
c
      return 
c
      end subroutine wavect
c
      subroutine wloss
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:03:04   6/14/01  
C...Switches: -p4 -yb
c
c  routine to calculate ray power degradation due to each wall specular
c   reflection
c  icoll=1   wfrac = wfrac0 specified in curray_go
c       =2   wfrac calculated from SOL collisional damping
c  Input for icoll=2
c    If psi.ge.0.95 edge damping is added to total damping,
c     otherwise, no extra damping is added.
c       fcoll=multiplication factor for collision frequency.
c         fdened=density of SOL as a fraction of that at separatrix
c         fzefed=z-effective of SOL as a fraction of that at separ.
c       fteed=electron temp. of SOL as a fraction of that at separ.
c       ftied=ion temp.      """"""""""""""""""""""""""""""""""""
c       the B-field of the reflection point is assumed
c       wsol=thickness of scrape-off-layer at the outboard equatorial
c             plane in meters.
c
c
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vsizes
      use Viorlh
      use Vcmnew
      use Vchpcsd
      use Vcraylh
      use Vceqdsk
      use Viogrl
      use Vcgraphs
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   C o m m o n   B l o c k s
C-----------------------------------------------
C...  /chpcsd/
!      common /chpcsd/ prmt(6), y(10), dy(10), dy6o, serror, psilast, yin
!     1   (10), dyin(10), hlast, ndim, jhlf, ind, mcnt, h, klim, irecmx
!      integer   ndim, jhlf, ind, mcnt, klim, irecmx
!      real   prmt, y, dy, dy6o, serror, psilast, yin, dyin, hlast, h
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i
      real :: dspsi, dstau, dsphi, dseta, dsp, cosvg, dened, teed, zefed
     1   , zhsied, rnue, c1, coln, denomc, asmnp2, pkp2ed, pkped, betaed
     2   , vte, anpkpi, pki
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1
 
 
c******      TKM   03/97, 09/99, 04/00, 06/00
c********************
 
!      common /chpcsd/ prmt(6),y(10),dy(10),dy6o,hlast,ndim,
!     1                jhlf,ind,serror,psilast,yin(10),dyin(10),
!     2                mcnt, h, klim,irecmx
c
      select case (icoll) 
      case default
         wfrac = wfrac0
         return 
      case (2) 
         dspsi = aj*dy(2)/antau
         dstau = antau*dy(4) + ag*dy(2)/antau
         dsphi = urhs*dy(5)
         dseta = dstau*acostq - dsphi*asintq
         dsp = sqrt(dspsi**2 + dseta**2)
         cosvg = abs(dspsi/dsp)
         dened = fdened*tne(nprof,1)
         teed = fteed*tte(nprof,1)
         zefed = fzefed*tzeff(nprof,1)
         zhsied = btot/bzero
         wpe2 = wpe2c*dened
         apzz = 1. - wpe2
         wce2 = wce2c*zhsied**2
         wce = sqrt(wce2)
         asxye = wpe2/wce2
         asxy = 1. + asxye
         adxy = 0.
         denied(:nspec) = fdened*tni(nprof,1,:nspec)
         tied(:nspec) = ftied*tti(nprof,1,:nspec)
         wpi2(:nspec) = denied(:nspec)*wpi2c(:nspec)
         wci(:nspec) = wci1c(:nspec)*zhsied
         wci2(:nspec) = wci(:nspec)*wci(:nspec)
         vti(:nspec) = 1.459E-3*sqrt(tied(:nspec)/atm(:nspec))
         if (psi >= 0.95) then
            rnue = 1.47E-9*dened*zefed/teed**1.5
         else
            rnue = 0.
         endif
         do i = 1, nspec
            c1 = 1. - wci2(i)
            if (abs(c1) <= 1.E-20) then
               cwwk(i) = wpi2(i)*1.E20*sign(1.0_dp,c1)
            else
               cwwk(i) = wpi2(i)/(1. - wci2(i))
            endif
         end do
         cwwk1(:nspec) = cwwk(:nspec)/wci(:nspec)
         asxy = asxy - sum(cwwk(:nspec))
         adxy = adxy + sum(cwwk1(:nspec))
         xe = 15.984/(abs(pkpar)*sqrt(teed))
c-------------------
c teed in kev
c---------------------
         zxmin = abs(xe)
         coln = fcoll*rnue/omega
         denomc = 1. + coln*coln
         coln = coln/denomc
         asmnp2 = asxy - pkpar2
         pkp2ed = (asmnp2**2 - adxy**2)/asmnp2
         if (pkp2ed > 0.) then
            pkped = sqrt(pkp2ed)
            betaed = 4.03E-16*dened*teed/btot**2
            cei = cmplx(0.,1.)
            zxe2 = xe*xe
c           call zfun(0,xe,cz,czp,zfn,zfc,xzz,nptzf,nptzfa,hzf,iout0)
            call zfun(xe, cz, czp)
            eps3r = 2.*wpe2*zxe2*(1. + xe*real(cz))
            eps3i = 2.*wpe2*zxe2*xe*aimag(cz)
            aeps32 = eps3r*eps3r + eps3i*eps3i
            vte = 0.0625*sqrt(tempe)
            anpkpi = 0.5*betaed*(coln*(1. + (adxy*511.925/teed*wce)**2/
     1         aeps32/asmnp2**2*0.5/zxe2/denomc))
            anpkpi = anpkpi + fcoll*rnue/omega*asxye*(2./pkp2ed - 1./
     1         asmnp2)
            anpkpi = anpkpi*pkped
            pki = anpkpi*ukzero
            wfrac = exp((-2.0_dp*pki*wsol))
            return 
         endif
         wfrac = 1.E0
         return 
      end select
      end subroutine wloss

C
c  this module contains routines for computing magnetic field geometry
c----------------------------------------------------------------------
c
      subroutine bfield(psic, thetac, bfld)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:56:54   6/14/01  
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Viorlh
      use Vcraylh
      use Vceqdsk
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real psic, thetac, bfld
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i
 
c
c
      if (psic > 0.) then
         psi = psic
         theta = thetac
         call coords
         call profix
         bfld = btot
         return 
      endif
      bfld = beqd
      return 
      end subroutine bfield
c
      subroutine coords
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:56:54   6/14/01  
C...Switches: -p4 -yb
c
c   ****************************************************************
c   *                                                              *
c   *      this modulus evaluates x,z, their derivatives           *
c   *           with respect to psi and theta, and the             *
c   *           metric elements for use in the ion cyclotron       *
c   *           ray tracing program                                *
c   *                                                              *
c   ****************************************************************
c
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Viorlh
      use Vcraylh
      use Vceqdsk
      implicit none
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: lmhd, i, id, ier
      real, dimension(3) :: zbx0, zbx1, zbx2, zbz0
      real :: twopi, zh, zph, zcosph, zsinph, zzss, zzcs, zzdcos, zddxpp
     1   , zddxpt, zddxtt, zddzpp, zddzpt, zddztt, theta1, zntau2
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
!      integer , EXTERNAL :: ifix
      real , EXTERNAL :: valspl
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i
 
c
c
      data twopi/6.28318530717959/
c
 
      if (ieqdsk <= 2) then
c   ****************************************************************
c   Evaluation of plasma shape coords and derivatives
c   from Brambilla representation of the flux surfaces:
c   ****************************************************************
 
 
         psi = amax1(accur,psi)
c
         acosth = cos(theta)
         asinth = sin(theta)
c
c   ****************************************************************
c   evaluations of rshift, rho, dtrian, elong and their derivatives
c   ****************************************************************
c
!         lmhd = ifix(psi/dpsimhd) + 1
         lmhd = int(psi/dpsimhd) + 1
         zh = psi - psimhd(lmhd)
         if (lmhd > nmhd) then
            lmhd = nmhd
            zh = 0.0
         endif
c
         do i = 1, 3
            id = i - 1
            zbx0(i) = valspl(zh,bx0,nprofn,lmhd,id)
            zbx1(i) = valspl(zh,bx1,nprofn,lmhd,id)
            zbx2(i) = valspl(zh,bx2,nprofn,lmhd,id)
            zbz0(i) = valspl(zh,bz0,nprofn,lmhd,id)
         end do
c
c   ****************************************************************
c   evaluation of xu(psi,theta), zu(psi,theta), and derivatives
c   ****************************************************************
c
         zph = theta - zbx2(1)*asinth
         zcosph = cos(zph)
         zsinph = sin(zph)
         zzss = zsinph*asinth
         zzcs = zcosph*asinth
         zzdcos = 1. - zbx2(1)*acosth
c
         ux = zbx0(1) + zbx1(1)*zcosph
         uz = zbz0(1)*asinth
c
         urhs = uraxmag + ux
c
         dxpsi = zbx0(2) + zbx1(2)*zcosph + zbx1(1)*zbx2(2)*zzss
         dxth = -zbx1(1)*zsinph*zzdcos
c
         dzpsi = zbz0(2)*asinth
         dzth = zbz0(1)*acosth
c
         zddxpp = zbx0(3) + zbx1(3)*zcosph + (2.*zbx1(2)*zbx2(2)+zbx1(1)
     1      *zbx2(3))*zzss - zbx1(1)*zbx2(2)*zbx2(2)*zzcs*asinth
         zddxpt = ((-zbx1(2)*zsinph)+zbx1(1)*zbx2(2)*zzcs)*zzdcos + zbx1
     1      (1)*zbx2(2)*zsinph*acosth
         zddxtt = -zbx1(1)*(zcosph*zzdcos*zzdcos + zbx2(1)*zzss)
c
         zddzpp = zbz0(3)*asinth
         zddzpt = zbz0(2)*acosth
         zddztt = -uz
 
 
      else
c   ****************************************************************
c   Evaluation of plasma shape coords and derivatives from
c   EQDSK representation of flux surfaces:
c   ****************************************************************
 
 
c        Get a theta1 value corresponding to theta, in [0.,twopi):
         if (theta >= 0.) then
            theta1 = amod(theta,twopi)
         else
            theta1 = amod((-theta),twopi)
            theta1 = twopi - theta1
         endif
 
         call dbcevl1 (thet, nptsd, ra, nprof, csplnx, nptsdm1, theta1, 
     1      psi, pdsx, ier, 6)
         call dbcevl1 (thet, nptsd, ra, nprof, csplnz, nptsdm1, theta1, 
     1      psi, pdsz, ier, 6)
 
c        xu is distance (meters) measured from magnetic axis.
c        zu is from equatorial plane.
         xu = pdsx(1) - raxmag
         zu = pdsz(1)
 
         ux = xu*ukzero
         uz = zu*ukzero
         urhs = pdsx(1)*ukzero
 
         dxpsi = pdsx(3)*ukzero
         dxth = pdsx(2)*ukzero
         dzpsi = pdsz(3)*ukzero
         dzth = pdsz(2)*ukzero
 
         zddxpp = pdsx(6)*ukzero
         zddxpt = pdsx(4)*ukzero
         zddxtt = pdsx(5)*ukzero
         zddzpp = pdsz(6)*ukzero
         zddzpt = pdsz(4)*ukzero
         zddztt = pdsz(5)*ukzero
 
 
      endif
 
 
c
c   ****************************************************************
c
c   evaluation of the jacobian, g, ntau, and derivatives
c
c   ****************************************************************
c
      zntau2 = dxth*dxth + dzth*dzth
      antau = sqrt(zntau2)
      aj = dxpsi*dzth - dzpsi*dxth
      ag = dxpsi*dxth + dzpsi*dzth
c
c  log. deriv. of antau & aj, ord. deriv. of ag
c
      dntaup = (dxth*zddxpt + dzth*zddzpt)/zntau2
      dntaut = (dxth*zddxtt + dzth*zddztt)/zntau2
      djp = (zddxpp*dzth + zddzpt*dxpsi - zddxpt*dzpsi - zddzpp*dxth)/aj
      djt = (zddxpt*dzth + zddztt*dxpsi - zddxtt*dzpsi - zddzpt*dxth)/aj
      dgp = zddxpp*dxth + zddxpt*dxpsi + zddzpp*dzth + zddzpt*dzpsi
      dgt = zddxpt*dxth + zddxtt*dxpsi + zddzpt*dzth + zddztt*dzpsi
c
      return 
      end subroutine coords
c
      subroutine fiteqdsk
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:56:54   6/14/01  
C...Switches: -p4 -yb
 
c     Obtain equilibrium data for ray tracing from EQDSK (ieqdsk.ge.3).
c     For ieqdsk.ge.3, replaces subroutine metrin, and most of profin.
c     For ieqdsk.eq.4, the extended eqdsk is used for plasma profiles.
c     Data is read from a file connected to iounit1.
c     Take   psi  (Brambilla) = normalized ONETWO rho coord,
c                               (sqrt(toroidal flux/bzero)).
c            theta(Brambilla) = ordinary angle on flux surface,
c                               measured about the magnetic axis.
c     Set up splines of X(theta,psi),Z(theta,psi) to be used for
c       the tokamak magnetic geometry.
c     Set other tokamak parameters.
c     If ieqdsk.eq.4, then set up plasma temp and density profiles
c       from data on an extended EQDSK.
c
c     This version corrects for difference in sign convention
c     between Brambilla's phi and EFIT's phi (toroidal angle)
c      Feb. 9,1994. SCC
c------------------------------
 
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Viorlh
      use Vcraylh, only: imax,ukzero, urplas, uraxmag, raxmag, xmin,
     1   xmax, baxis, dpolas, dd, psi, theta, zsurf, volume, pqr, 
     2   ppra, ppra1, tpsif, dpsi, tqr, tzeff
      use Vceqdsk
      use Vcmnew, only: dlob, zetab, enbeam, wbeam, lrza,
     1                  ebkev, bmpwr, azf, atmf, nalfa, pnfi, pnf
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, j, ix, iz, ierr, inset, iounit, iauto, iautoc, ier, 
     1   jj, i1, jmd, jmd1, jmd2, ir, k, kdeu, nbeams, niont
      real, dimension(nxa) :: fpeqd
      real, dimension(nprofm) :: ywork, xwork
      real, dimension(lrza) :: dumf
      real, dimension(nprofm) :: dumf1, dv, ds
      real :: frcpr, gampr, alppr, gampr1, alppr1, zpi, amu0, err, end, 
     1   pres0, delpsi, psin, bisign, delx, delz, dra, xminc, xmaxc, 
     2   zminc, zmaxc, ddx, ddz, xcmin, xcmax, zcmin, zcmax, zxcmin, 
     3   zxcmax, xzcmin, xzcmax, dthet, cost, sint, psiang, cosdd, ddd, 
     4   rminor, dv1, dlp, bp1, rad1, bt1, dlpbp, dl, bpsep, rmina, 
     5   bpedge, hconc, zdecay, enetot, ene00, ratden
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
!      integer , EXTERNAL :: max0
      real , EXTERNAL :: simp
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i
 
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
 
c $$$$  Added by TK Mau on 2/26/92.
c $$$$$$      TKM     04/00
c  $$$$   TK Mau    9/28/94, 06/00
      data frcpr,gampr,alppr,gampr1,alppr1/0.55,2.25,0.0,1.0,2.0/
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      zpi = 4.*atan2(1.,1.)
c $$$$   TK Mau   10/13/92
      amu0 = zpi*4.E-7
c $$$$$$$$$$$$$$$$$
 
 
c     Read the eqdsk:
      read (iounit1, 8190) ntitle, dat, ipestg, nxeqd, nzeqd
      if (nxeqd/=nxa .or. nzeqd/=nza) then
!         call link ('unit59=terminal//')
         write (6, 8180) nxeqd, nzeqd
         stop 40
 8180    format("nxa,nza must be adjusted to eqdsk dimensions:",2i5)
      endif
      read (iounit1, 8200) xdimeqd, zdimeqd, reqd, redeqd, zmideqd
      read (iounit1, 8200) xma, zma, psimag, psilim, beqd
      read (iounit1, 8200) toteqd, psimx1, psimx2, xax1, xax2
      read (iounit1, 8200) zax1, zax2, psisep, xsep, zsep
      read (iounit1, 8200) (feqd(i),i=1,nxeqd)
      read (iounit1, 8200) (presseqd(i),i=1,nxeqd)
      read (iounit1, 8200) (ffpeqd(i),i=1,nxeqd)
      read (iounit1, 8200) (ppeqd(i),i=1,nxeqd)
      read (iounit1, 8200) ((peqd(i,j),i=1,nxeqd),j=1,nzeqd)
      read (iounit1, 8200, err=8280, end=8280) (qeqd(i),i=1,nxeqd)
 
 
c*********************************
c   First change sign of relevant quantities to correct for difference
c   in sign convention between Brambilla's phi and EFIT's phi
c   Definition of vec(B) is
c       vec(B)=f(psi)*grad(phi(Bram)) + grad(phi(Bram)) x grad(psi)
c------------------------------------
c$$$$$$   TKM    06/00
c     Use analytic form for pressure profile
      if (alppr > 0.) then
         pres0 = presseqd(1)
         delpsi = 1./float(nxeqd - 1)
         do i = 1, nxeqd
            psin = delpsi*float(i - 1)
            presseqd(i) = pres0*(frcpr*(1. - psin**gampr)**alppr + (1.
     1          - frcpr)*(1. - psin**gampr1)**alppr1)
            ppeqd(i) = -pres0*(frcpr*alppr*gampr*psin**(gampr - 1.)*(1.
     1          - psin**gampr)**(alppr - 1.) + (1. - frcpr)*alppr1*
     2         gampr1*psin**(gampr1 - 1.)*(1. - psin**gampr1)**(alppr1
     3          - 1.))
            ppeqd(i) = ppeqd(i)/(psilim - psimag)
         end do
      endif
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      psimag = -psimag
      psilim = -psilim
      beqd = -beqd
      toteqd = -toteqd
      psisep = -psisep
      feqd(:nxeqd) = -feqd(:nxeqd)
c*****   TKM   06/97
      ffpeqd(:nxeqd) = -ffpeqd(:nxeqd)
c*********************
      ppeqd(:nxeqd) = -ppeqd(:nxeqd)
      peqd(:nxeqd,:nzeqd) = -peqd(:nxeqd,:nzeqd)
      btsign = sign(1.0_dp,beqd)
      bisign = sign(1.0_dp,toteqd)
c**********     TKM     3/97
c  Adjust plasma pressure for ARIES-ST studies of HHFW heating
      presseqd(:nxeqd) = presfr*presseqd(:nxeqd)
      ppeqd(:nxeqd) = presfr*ppeqd(:nxeqd)
c*******************************
      if (psiadj /= 0.0) then
c     Adjust psi values slighlty (a kluge to cope with eqdsks
c     for which the plasma is a little too close to the grid boundary):
         write (59, 8291) psiadj
 8291    format("adjusting psi-values by fractional amount",f10.3)
         delpsi = psiadj*(psimag - psilim)
         peqd(:nxeqd,:nzeqd) = peqd(:nxeqd,:nzeqd) - delpsi
         psimag = psimag - delpsi
         psimx1 = psimx1 - delpsi
         psimx2 = psimx2 - delpsi
      endif
 
 8190 format(a40,a8,3i4)
 8200 format(5e16.9)
 8210 format(5i5)
      go to 8300
 
 8280 continue
      write (59, 8290)
 8290 format("error or no q-profile in eqdsk file")
      stop 41
 8300 continue
 
c     xeqd,zeqd-grid where xeqd is major radius:
      delx = xdimeqd/(nxeqd - 1.)
      delz = zdimeqd/(nzeqd - 1.)
      do ix = 1, nxeqd
         xeqd(ix) = redeqd + (ix - 1)*delx
      end do
      do iz = 1, nzeqd
         zeqd(iz) = zmideqd - 0.5*zdimeqd + (iz - 1)*delz
      end do
 
c     tpsifeqd: eqdsk poloidal flux function-coordinate,
c     equispaced from psimag to psilim.
      dpolflx = (psilim - psimag)/(nxeqd - 1)
      do ix = 1, nxeqd
         tpsifeqd(ix) = psimag + (ix - 1)*dpolflx
      end do
c*************   TKM    2/97
c     Calculate mod-B values for plotting
c     Useful for low-aspect-ratio and/or high-beta tokamaks
      call modb
c****************************************
c
c     Obtain toroidal flux as a function of the equispaced poloidal flux:
 
      call trap2 (tpsifeqd, qeqd, torflux, nxeqd)
 
c     Holger St. John sign convention of torflux (see subroutine
c     reqdsk in ONETWO).
c****************************
      torflux(:nxeqd) = -2.*zpi*torflux(:nxeqd)
c****************************
 
c     Obtain the tpsieqd grid (ONETWO radial variable on equispaced poloidal
c     flux function grid, from the magnetic axis to the plasma edge).
      tpsieqd(:nxeqd) = sqrt(abs(torflux(:nxeqd)/(zpi*beqd)))
 
      tpsisav = tpsieqd(nxeqd)
 
c     Normalize:
      tpsieqd(:nxeqd) = tpsieqd(:nxeqd)/tpsisav
 
c     Define normalized equispaced radial grid ra (nprof in length,
c     extending past plasma surface at ra(nprofs)=1.).
      dra = 1./(nprofs - 1.)
      do j = 1, nprof
         ra(j) = (j - 1.)*dra
      end do
 
c     Interpolate poloidal flux function onto the ra grid,
c     (ra(1) to ra(nprofs)) to get psifra:
      call intrpp ('free', 'free', tpsieqd, tpsifeqd, nxeqd, ra, psifra
     1   , nprofs)
 
c     Calculate the flux surface contours corresponding to psifra:
 
 
c     First bicubic spline peqd (and since cntour needs max peqd on axis,
c     temporarily invert peqd):
      peqd(:nxeqd,:nzeqd) = -peqd(:nxeqd,:nzeqd)*bisign
 
c     Check adaquate length for wnoperm:
      if (2*nxeqd*nzeqd + 2*max(nxeqd,nzeqd) > inoperm1) stop 42
      call ibcccu(peqd,xeqd,nxeqd,zeqd,nzeqd,cspln,nxeqd,wnoperm,ierr)
 
      peqd(:nxeqd,:nzeqd) = -peqd(:nxeqd,:nzeqd)*bisign
 
c     To get contours at nprofs surfaces:
 
      if (nptsd > nptsdm - 4) stop 43
      xcontr(:nptsd,1) = xma
      zcontr(:nptsd,1) = zma
      ncontr(1) = nptsd
 
c     The contour search area can be restricted by an amount
c     inset, from the grid boundary.  St. John uses inset=1 in some
c     D3D eqdsk cases to avoid difficulties near the coils.
 
      inset = 0
      xminc = xeqd(1+inset)
      xmaxc = xeqd(nxeqd-inset)
      zminc = zeqd(1+inset)
      zmaxc = zeqd(nzeqd-inset)
c      nptsdm1 = 120           Set in var.br
c      bperr = 1.e100         Set in var.br
c      dang = 4.0             Set in var.br
c      arcl = 1.e100          Set in var.br
      iounit = 0
      iauto = 1
      ddx = 0.0
      ddz = 0.0
 
      do j = 2, nprofs
c     As the bndry is neared, specify step size for contour finding:
         if (j >= nprofs - 1) then
            ddx = 0.5*delx
            ddz = 0.5*delz
         endif
         call cntour (xma, zma, (-bisign*psifra(j,1)),xcmin,xcmax,zcmin,
     1      zcmax,zxcmin,zxcmax,xzcmin,xzcmax,dang,arcl,bperr,ddx,ddz,
     2      xminc,xmaxc,zminc,zmaxc,iauto,iautoc,xcontr(1,j), zcontr(1,j
     3      ), ncontr(j), xeqd, nxeqd, zeqd, nzeqd, cspln, 2, 2*nzeqd, 
     4      iounit, nptsdm1, ierr, bpcontr(1,j), 0)
c     To check angles with DDT:
         imax = ncontr(j)
         anglex(:imax) = atan2(zcontr(:imax,j)-zma,xcontr(:imax,j)-xma)*
     1      180./zpi
      end do
c
c     Check that the ncontr(j) = ntpsd:
      do j = 1, nprofs
         if (ncontr(j) /= nptsd) stop 44
      end do
 
 
c     Extend contours beyond plasma edge:
c     (Form additional contours outside the boundary flux surface
c     by extending along each ray which originates at the magnetic
c     axis, by a distance such that the additional flux surfaces are
c     (ra(jj)-1.)*tpsisav beyond the boundary flux surface).
 
c     Theta vector:
      dthet = 2.*zpi/(nptsd - 1.)
      do i = 1, nptsd
         thet(i) = (i - 1)*dthet
      end do
 
      do j = 1, nptsd
         cost = cos(thet(j))
         sint = sin(thet(j))
c     Get dirn. of normal to flux surface
         call dbcevl1 (xeqd, nxeqd, zeqd, nzeqd, cspln, nxeqd, xcontr(j,
     1      nprofs), zcontr(j,nprofs), pds, ier, 3)
         psiang = atan2((-pds(3)),(-pds(2)))
         if (psiang < 0.) psiang = psiang + 2.*zpi
c     The following cosine accounts for the ray from the magnetic
c     axis not being colinear with the normal to the magnetic surface.
         cosdd = cos(thet(j)-psiang)
         do jj = nprofs + 1, nprof
            dd = (ra(jj)-1.)*tpsisav/cosdd
            ddd = sqrt((xcontr(j,nprofs)-xma)**2+(zcontr(j,nprofs)-zma)
     1         **2) + dd
            xcontr(j,jj) = xma + ddd*cost
            zcontr(j,jj) = zma + ddd*sint
         end do
      end do
 
      ncontr(nprofs+1:nprof) = nptsd
 
c
c     Extend the contours 2 points in theta at either end of the
c     theta grid, as a measure to reduce edge effects:
 
      thet(nptsd+3) = thet(nptsd) + dthet
      thet(nptsd+4) = thet(nptsd) + 2.*dthet
      thet(nptsd+2:3:(-1)) = thet(nptsd:1:(-1))
      thet(1) = -2.*dthet
      thet(2) = -dthet
 
      ncontr(:nprof) = ncontr(:nprof) + 4
      xcontr(nptsd+3,:nprof) = xcontr(2,:nprof)
      xcontr(nptsd+4,:nprof) = xcontr(3,:nprof)
      zcontr(nptsd+3,:nprof) = zcontr(2,:nprof)
      zcontr(nptsd+4,:nprof) = zcontr(3,:nprof)
      bpcontr(nptsd+3,:nprof) = bpcontr(2,:nprof)
      bpcontr(nptsd+4,:nprof) = bpcontr(3,:nprof)
      xcontr(nptsd+2:3:(-1),:nprof) = xcontr(nptsd:1:(-1),:nprof)
      zcontr(nptsd+2:3:(-1),:nprof) = zcontr(nptsd:1:(-1),:nprof)
      bpcontr(nptsd+2:3:(-1),:nprof) = bpcontr(nptsd:1:(-1),:nprof)
      xcontr(1,:nprof) = xcontr(nptsd,:nprof)
      xcontr(2,:nprof) = xcontr(nptsd+1,:nprof)
      zcontr(1,:nprof) = zcontr(nptsd,:nprof)
      zcontr(2,:nprof) = zcontr(nptsd+1,:nprof)
      bpcontr(1,:nprof) = bpcontr(nptsd,:nprof)
      bpcontr(2,:nprof) = bpcontr(nptsd+1,:nprof)
 
      nptsd = nptsd + 4
 
c
c
c
c     Spline the xcontr(ra,thet) and zcontr(ra,thet) arrays,
c     thus obtaining X(theta,psi), Z(theta,psi).
c     (Except X is measured from the machine axis, whereas X-Bram
c      is measured from the magnetic axis).
 
      call ibcccu (xcontr, thet, nptsd, ra, nprof, csplnx, nptsdm1, 
     1   wnoperm, ierr)
 
      call ibcccu (zcontr, thet, nptsd, ra, nprof, csplnz, nptsdm1, 
     1   wnoperm, ierr)
 
 
 
c     Set br variables:
c     Plasma shape and magnetic field on axis.
      rzero = reqd
      bzero = abs(beqd)
      tcurr = toteqd
      raxmag = xma
      rshift = raxmag - rzero
      baxis = feqd(1)/raxmag
 
      psi = 1.
      theta = 0.
      call dbcevl1 (thet, nptsd, ra, nprof, csplnx, nptsdm1, theta, psi
     1   , pdsx, ier, 1)
      xmax = pdsx(1)
      psi = 1.
      theta = zpi
      call dbcevl1 (thet, nptsd, ra, nprof, csplnx, nptsdm1, theta, psi
     1   , pdsx, ier, 1)
      xmin = pdsx(1)
      rminor = 0.5*(xmax - xmin)
 
c     Here we define rplasm = ONETWO rho variable at plasma edge,
c     rather than (xma-xmin)/2, as in Brambilla flux surface representation.
      rplasm = tpsisav
 
c     ukzero (free space wavenumber) is set in subroutine inital.
      urplas = rplasm*ukzero
      uraxmag = raxmag*ukzero
 
c     Interpolate feqd onto ra grid giving fra, and set up splines:
      call intrpp ('free', 'free', tpsieqd, feqd, nxeqd, ra, fra, nprofs
     1   )
      fra(nprofs+1:nprof,1) = bzero*rzero*btsign
 
      call cubspl (dra, fra, nprofn, nprofs)
 
c     Form d(poloidal flux function)/d(rho/a) on the ra grid,
c     out to the plasma edge:
      call cubspl (dra, psifra, nprofn, nprofs)
      dpsifra(:nprofs) = psifra(:nprofs,2)
c
c     if(irayio.gt.0) return
      psinm(:nprofs) = 1. - abs((psifra(:nprofs,1)-psilim)/(psimag-
     1   psilim))
c
c     Get volume of flux surfaces at points out to the plasma surface,
c     using volume = 2*pi*integeral{dl_pol/B_p)*dpsifra*dra:
c $$$$$$$$$$$  Modified and added by T.K. Mau on 10/11/91/
c     Using area = integral{dl_pol/(B_p*R0}*dpsifra*dra
c     Define <J.B> and <B> in MKS units, used for current profiles
      call intrpp ('zero', 'free', tpsieqd, presseqd, nxeqd, ra, ppra, 
     1   nprofs)
      call cubspl (dra, ppra, nprofn, nprofs)
c $$$$  Added by TK Mau on 12/2/91
      fpeqd(:nxeqd) = ffpeqd(:nxeqd)/feqd(:nxeqd)
      call intrpp ('free', 'free', tpsieqd, fpeqd, nxeqd, ra, fra1, 
     1   nprofs)
      call cubspl (dra, fra1, nprofn, nprofs)
      call intrpp ('free', 'free', tpsieqd, ppeqd, nxeqd, ra, ppra1, 
     1   nprofs)
      call cubspl (dra, ppra1, nprofn, nprofs)
c $$$$$$$$$$$$$$$$$$
      call intrpp ('free', 'free', tpsieqd, qeqd, nxeqd, ra, pqr, nprofs
     1   )
      zsurf(1) = 0.
      xwork(1) = 0.
      do j = 2, nprofs
         dv(j) = 0.0
         ds(j) = 0.0
         dlob(j) = 0.0
         dv1 = 0.
         do i = 4, nptsd - 2
            dlp = ((xcontr(i,j)-xcontr(i-1,j))**2+(zcontr(i,j)-zcontr(i-
     1         1,j))**2)**0.5
            bp1 = 0.5*(bpcontr(i,j)+bpcontr(i-1,j))
            rad1 = 0.5*(xcontr(i,j)+xcontr(i-1,j))
            bt1 = fra(1,1)/rad1
            dlpbp = dlp/bp1
            dv(j) = dv(j) + dlpbp
            dlob(j) = dlob(j) + dlp/sqrt(bt1**2 + bp1**2)
            ds(j) = ds(j) + dlpbp/rad1
            dv1 = dv1 + dlp*bp1
         end do
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c ---- Calculate incremental volume
         volume(j) = abs(2.*zpi*dv(j)*dra*dpsifra(j))
c ---- Calculate incremental cross section area
         zsurf(j) = ds(j)*dra*abs(dpsifra(j))
         xwork(j) = 2.*zpi*dv1*abs(dpsifra(j))
      end do
      volume(1) = volume(2)/3.
      dlob(1) = 0.25*dlob(2)
      dlob(nprofs) = 0.25*dlob(nprofs-1) + 0.75*dlob(nprofs)
c ---- Calculate incremental volumes and areas at center and edge
c     dv(1) = 1.75*dv(2)-0.75*dv(3)
c     volume(1) = 0.5*zpi*dra*abs(dv(1)*(0.75*dpsifra(1)+0.25*
c    &            dpsifra(2)))
c     ds(1) = 1.75*ds(2)-0.75*ds(3)
c     zsurf(1) = 0.25*dra*abs(ds(1)*(0.75*dpsifra(1)+0.25*
c    &           dpsifra(2)))
c     volume(nprofs) = 0.5*zpi*dra*abs((0.75*dv(nprofs)+0.25*
c    &                 dv(nprofs-1))*(0.75*dpsifra(nprofs)+0.25*
c    &                 dpsifra(nprofs-1)))
c     zsurf(nprofs) = 0.25*dra*abs((0.75*ds(nprofs)+0.25*
c    &                ds(nprofs-1))*(0.75*dpsifra(nprofs)+0.25*
c    &                dpsifra(nprofs-1)))
c ---- Calculate internal plasma inductance
      ali3 = 2.*simp(nprofs,dra,xwork)/(reqd*(amu0*toteqd)**2)
c ---- Calculate total and poloidal (Shafranov) betas.
      dl = 0.
      do i = 4, nptsd - 2
         dlp = ((xcontr(i,nprofs)-xcontr(i-1,nprofs))**2+(zcontr(i,
     1      nprofs)-zcontr(i-1,nprofs))**2)**0.5
         dl = dl + dlp
      end do
      xwork(1) = 0.
      xwork(2:nprofs) = volume(2:nprofs)/dra
      ywork(2:nprofs) = ppra(2:nprofs,1)*xwork(2:nprofs)
      bpsep = amu0*toteqd/dl
      beta = 2.*amu0*simp(nprofs,dra,ywork)/beqd**2/simp(nprofs,dra,
     1   xwork)
      betap = beta*(beqd/bpsep)**2
c $$$$$$$$$$$$$$$$$$
 
      volume(1) = volume(2)/3.
c
c $$$$$$$$    TKM   10/00
c Define array r/a versus rho
      rmd(nprof) = raxmag
      roa(1) = 0.
      do jmd = 1, nprof - 1
         jmd1 = nprof - jmd + 1
         jmd2 = 2*nprof - jmd
         rmd(jmd) = xcontr(48,jmd1)
         rmd(jmd2) = xcontr(3,jmd1)
         roa(jmd1) = rmd(jmd2) - rmd(jmd)
      end do
      rmina = rmd(2*nprof-1) - rmd(1)
      roa(2:nprof) = roa(2:nprof)/rmina
c $$$$$$$$$$$$$$$$$
c     Extend volume and poloidal flux function beyond the plasma
c     edge, from ra(nprofs) to ra(nprof).
c     Simply take volume increments as volumes added by each additional
c     surface, and poloidal flux fctn increments as plasma edge pol field
c     at theta=0, ra=1., times added poloidal directed area / (2*pi):
 
      call dbcevl1 (xeqd, nxeqd, zeqd, nzeqd, cspln, nxeqd, xcontr(1,
     1   nprofs), zcontr(1,nprofs), pds, ier, 3)
      bpedge = (pds(2)**2+pds(3)**2)**.5/xcontr(1,nprofs)
 
      do j = nprofs + 1, nprof
         dv(j) = 0.
         dv(j) = dv(j) + sum(0.5*(xcontr(4:nptsd-2,j)+xcontr(3:nptsd-3,j
     1      ))*((xcontr(4:nptsd-2,j)-xcontr(3:nptsd-3,j))**2+(zcontr(4:
     2      nptsd-2,j)-zcontr(3:nptsd-3,j))**2)**.5)
c $$$$  Modified by T.K. Mau on 1/31/92.
         volume(j) = 2.*zpi*dv(j)*dra*abs(tpsisav)
c $$$$$$$$$$$$$$$$$
         psifra(j,1) = psifra(j-1,1) + bpedge*xcontr(1,j)*dra*tpsisav*
     1      bisign
      end do
 
      call cubspl (dra, psifra, nprofn, nprof)
 
 
c*************************************************************************
c     To obtain equivalence with Brambilla psi-theta representation
c     of the flux surfaces, using the above ra and thet:
c           psi = ra
c           theta = thet
c     Then the Brambilla equilibrium arrays are tpsi = ra
c                                               ppsi = ra
c                                              tpsif = psifra
c                                                tqr = B_p(psi)/B_T(psi)
c*************************************************************************
 
      dpsi = dra
      ppsi(:nprof) = ra(:nprof)
      tpsif(:nprof,:) = psifra(:nprof,:)
 
      tqr(:nprof,1) = tpsif(:nprof,2)/(tpsisav*fra(:nprof,1))
 
      call cubspl (dpsi, tqr, nprofn, nprof)
 
 
 
      if (ieqdsk == 4) then
 
c*************************************************************************
c     Continue reading eqdsk if ieqdsk.eq.4, i.e., an extended eqdsk
c     is being used, such as from cql3d with eqsource="tsc".
c*************************************************************************
!         call link ('unit59=terminal//')
         write (6, 8250)
 8250    format('Reading eqdsk')
         read (iounit1, 8210) nlim, nlimiter
c     if (nlim.ne.0) then
         read (iounit1, 8200) (rlim(i),zlim(i),i=1,nlim)
         read (iounit1, 8200) (rlimiter(i),zlimiter(i),i=1,nlimiter)
c     endif
c..................................................................
c     The following output is not part of the "official" eqdsk.
c..................................................................
         nti = 1
         read (iounit1, 8210) lrz, nprim, nimp, nti
         if (lrz > lrza) stop 60
         nion = nprim + nimp
         read (iounit1, 8200) (atm(k),k=1,nion)
         do k = 1, nion
            read (iounit1, 8200) (zi(j,k),j=1,lrz)
         end do
         read (iounit1, 8200) (zeffz(j),j=1,lrz)
         read (iounit1, 8200) (r(j),j=1,lrz)
         read (iounit1, 8200) (psifeqd(j),j=1,lrz)
         read (iounit1, 8200) (te(j),j=1,lrz)
         do k = 1, nti
            read (iounit1, 8200) (ti(j,k),j=1,lrz)
         end do
         read (iounit1, 8200) (ene(j),j=1,lrz)
         do k = 1, nion
            read (iounit1, 8200) (enp(j,k),j=1,lrz)
         end do
         raeqd(:lrz) = r(:lrz)/r(lrz)
c---- Latest update:   TKM   05/00
c-----Include a small concentration of hydrogen, for DIII-D runs
         hconc = 0.02
         if (hconc > 0.) then
            do k = 1, nion
               if (atm(k)==2 .and. zi(1,k)==1.) kdeu = k
            end do
            nion = nion + 1
            atm(nion) = 1.
            zi(:lrz,nion) = 1.
            enp(:lrz,nion) = hconc*enp(:lrz,kdeu)
            enp(:lrz,kdeu) = (1. - zi(:lrz,nion)*hconc)*enp(:lrz,kdeu)
         endif
c
C*****************************************************
c-----Read beam ion data directly from ONETWO;  TKM  04/00, 05/00
         read (iounit1, 8220) nalfa, nbeams
         if (nalfa /= 0) then
            do k = 1, nalfa
               read (iounit1, 8230) ebkev(k), bmpwr(k), azf(k), atmf(k)
               read (iounit1, 8200) (pnf(j,k),j=1,lrz)
               read (iounit1, 8200) (zetab(j,k),j=1,lrz)
               dumf(:lrz) = pnf(:lrz,k)
               call intrpp ('zero', 'free', raeqd, dumf, lrz, ra, dumf1
     1            , nprofs)
               pnfi(k,:nprofs) = dumf1(:nprofs)
               if (iedge == 1) then
                  do j = nprofs + 1, nprof
                     zdecay = exp((-0.5*float(j + nprofs)))
                     pnfi(k,j) = pnfi(k,nprofs)*zdecay
                  end do
               endif
            end do
c
c $$$$   TKM   09/99, 04/00
c ----Read beam ion density and Maxw. temperature profiles, and
c     assign them after primary and impurity ion species.
            nion = nion + 1
            read (iounit1, 8200) (enbeam(j),j=1,lrz)
            read (iounit1, 8200) (wbeam(j),j=1,lrz)
            zi(:lrz,nion) = azf(1)
            ti(:lrz,nion) = wbeam(:lrz)
            enp(:lrz,nion) = 1.E6*enbeam(:lrz)
            atm(nion) = atmf(1)
c
C**************************
C  profile of density and temperature are generalized  SCC 12/12/95
c  Include possibility of one beam ion species   TKM 04/00, 05/00
C***************************
         endif
         nspec = nion
         enetot = sum(ene(:lrz))
         azi(:nion) = zi(1,:nion)
         do k = 1, nion
            enp(:lrz,k) = enp(:lrz,k)*zi(:lrz,k)/azi(k)
         end do
c----- Adjust electron density to assure neutrality.
         ene00 = ene(1)
         do j = 1, lrz
            ene(j) = 0.
            ene(j) = ene(j) + sum(azi(:nion)*enp(j,:nion))
            ene(j) = 1.E-6*ene(j)
         end do
         niont = nion
         if (nalfa > 0) niont = nion - 1
         do k = 1, nion
            enp(:lrz,k) = 1.E-6*enp(:lrz,k)*ene00/ene(1)
            if (k>1 .and. k<=niont) then
               where (ti(:lrz,k) <= 0.) ti(:lrz,k) = ti(:lrz,1)
            endif
         end do
c----- Adjust back to original peak electron density
         ratden = 1.E-6*ene00/ene(1)
         ene(:lrz) = ratden*ene(:lrz)
         enp(:lrz,:nion) = ratden*enp(:lrz,:nion)
         nalfa = 0
c     Initialize ne, te, ti profiles from plasma center to edge.
 
         call intrpp ('zero', 'free', raeqd, ene, lrz, ra, pne, nprofs)
         call intrpp ('zero', 'free', raeqd, te, lrz, ra, pte, nprofs)
c-------------------SCC  4/23/96
         call intrpp ('zero', 'free', raeqd, zeffz(1), lrz, ra, tzeff(1,
     1      1), nprofs)
c---------------------------
         do k = 1, nion
            call intrpp ('zero', 'free', raeqd, ti(1,k), lrz, ra, pti(1,
     1         k), nprofs)
            call intrpp ('zero', 'free', raeqd, enp(1,k), lrz, ra, pni(1
     1         ,k), nprofs)
         end do
         do k = 1, nion
            conc(:nprofs,k) = pni(:nprofs,k)/pne(:nprofs)
         end do
 
c     Extend beyond plasma surface if iedge=1:
         if (iedge == 1) then
            do j = nprofs + 1, nprof
               zdecay = exp((-float(j - nprofs)/2.))
               pne(j) = pne(nprofs)*zdecay
               pte(j) = pte(nprofs)*zdecay
               pni(j,:nion) = pni(j,:nion)*zdecay
               pti(j,:nion) = pti(j,:nion)*zdecay
               conc(j,:nion) = pni(j,:nion)/pne(j)
            end do
         endif
c $$$$$$$$$$$$$
 8220    format(2i5)
 8230    format(4e16.9)
         write (59, 8240) nspec, (pni(1,k),k=1,nspec), (pti(1,k),k=1,
     1      nspec)
 8240    format('nspec=',i5,/,'deni(0)=',3(e16.4,3x),/,'temi(0)=',3(
     1      e16.4,3x))
c
      endif
      return 
c
      end subroutine fiteqdsk
c
c
      subroutine lsfun1(n, m, xc, fc)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:56:54   6/14/01  
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Viorlh
      use Vcraylh, only: psi, theta, asinth, bx0, bx1, bx2, bz0, ux, uz,
     1                   ukzero, raxmag
      use Vceqdsk
      USE Vclsfun1
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer n, m
      real, dimension(n) :: xc
      real, dimension(m) :: fc
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: lmhd, i, id
      real, dimension(3) :: zbx0, zbx1, zbx2, zbz0
      real :: zh, zph, zcosph, fxxx, fzzz
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
!      integer , EXTERNAL :: ifix
      real , EXTERNAL :: valspl  !  , abs, sin
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
 
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c
c   ****************************************************************
c
c
c   ****************************************************************
c
      psi = xc(1)
      theta = xc(2)
c
      if (abs(psi) < 1.E-10) psi = sign(1.0_dp,psi)*1.E-10
c********************************
c     if(psi.gt.psilimit)  psi=psilimit
c************************** 2/14/92  BH
c
      asinth = sin(theta)
c
c   ****************************************************************
c   evaluations of rshift, rho, dtrian, elong and their derivatives
c   ****************************************************************
c
!      lmhd = ifix(psi/dpsimhd) + 1
      lmhd = int(psi/dpsimhd) + 1
      zh = psi - psimhd(lmhd)
c
      do i = 1, 1
         id = i - 1
         zbx0(i) = valspl(zh,bx0,nprofn,lmhd,id)
         zbx1(i) = valspl(zh,bx1,nprofn,lmhd,id)
         zbx2(i) = valspl(zh,bx2,nprofn,lmhd,id)
         zbz0(i) = valspl(zh,bz0,nprofn,lmhd,id)
      end do
c
c   ****************************************************************
c   evaluation of xu(psi,theta), zu(psi,theta), and derivatives
c   ****************************************************************
c
      zph = theta - zbx2(1)*asinth
      zcosph = cos(zph)
c
      ux = zbx0(1) + zbx1(1)*zcosph
      uz = zbz0(1)*asinth
c
      fxxx = ux/ukzero + (raxmag - rzero)
      fzzz = uz/ukzero
 
      fc(1) = xxx - fxxx
      fc(2) = zzz - fzzz
      if (psi <= 0.) then
         fc(1) = 100.
         fc(2) = 100.
      endif
 
      return 
      end subroutine lsfun1
      subroutine mhdebm
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:56:54   6/14/01  
C...Switches: -p4 -yb
c
c---------------------------
c  This subroutine replaces fiteqdsk. Instead of requiring an eqdsk-file,
c  it reads in MHDE data from Bob-Miller's MHDE-code and processes the
c  required input for coords and profix and profin
c  Calls mhdebm1
c  ieqdsk = 5 to call this routine.
c-----------------------------
c------------------------------
 
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Viorlh
      use Vcraylh, only: baxis, pqr, torflx, ukzero, urplas,
     1        raxmag, xmin, xmax, dpolas, ppra, ppra1, dpsi,
     2        uraxmag, zsurf, volume, tpsif, tqr
      use Vceqdsk
      use Vcmnew, only: dlob
!      USE Vfwcd3
!      USE Vcmalfa, ONLY: lrza
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: nnpsi, nnthet, n, j, jr, i, jj, ierr
      real, dimension(nprofm) :: ywork, xwork, dumf1, dv, ds
      real :: zpi, amu0, qaxis, dthet, dra, pax, bisign, rminor, dv1, 
     1   dlp, bp1, rad1, bt1, dlpbp, dl, bpsep
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real , EXTERNAL :: simp  !  , abs
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i
 
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c    6                modcd
c $$$$$$       TKM    04/00
c
c
c  dimension pprime,chipsi,vprime,b_fld,dstarp,btcontr,jacob,
c  torflx
c  in curray.v
c
 
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      zpi = 4.*atan2(1.,1.)
      amu0 = zpi*4.E-7
c $$$$$$$$$$$$$$$$$
 
      call mhdebm1 (nprofm, nptsdm, nnpsi, nnthet, iounit1, iout, dumf1
     1   , jacob, xcontr, zcontr, b_fld, dstarp, bpcontr, btcontr, ra, 
     2   pprime, chipsi, xwork, ywork, vprime, thet, qaxis, dthet, dra, 
     3   pax, btsign, rzero, bzero, baxis, psimag, psilim, xdimeqd, 
     4   zdimeqd, redeqd, zmideqd, xma, zma, toteqd)
      reqd = rzero
      nprof = nnpsi
      nprofs = nprof
      nptsd = 2*nnthet - 1
      dra = ra(2) - ra(1)
      fra(:nprof,1) = dumf1(:nprof)
      pqr(:nprof,1) = xwork(:nprof)
      psifra(:nprof,1) = ywork(:nprof)
      call cubspl (dra, fra, nprofn, nprofs)
      call cubspl (dra, psifra, nprofn, nprofs)
      call cubspl (dra, pqr, nprofn, nprofs)
c-------------------------
c  get toroidal flux function
c--------------------------
      beqd = bzero*btsign
      bisign = sign(1.0_dp,toteqd)
      torflx(1) = 0.
      do n = 2, nprof
         torflx(n) = torflx(n-1) + 0.5*(xwork(n-1)+xwork(n))*(ywork(n)-
     1      ywork(n-1))
      end do
      torflx(:nprof) = -2.*zpi*torflx(:nprof)
      rrho(:nprof) = sqrt(abs(torflx(:nprof)/(zpi*beqd)))
      tpsisav = rrho(nprof)
 
c*******************************
 
 
      ncontr(:nprof) = nptsd
 
c-----------------
c  implement up-down symmetry
c------------------
      do j = nnthet + 1, nptsd
         jr = 2*nnthet - j
         thet(j) = thet(j-1) + dthet
         jacob(j,:nprof) = jacob(jr,:nprof)
         xcontr(j,:nprof) = xcontr(jr,:nprof)
         zcontr(j,:nprof) = -zcontr(jr,:nprof)
         b_fld(j,:nprof) = b_fld(jr,:nprof)
         dstarp(j,:nprof) = dstarp(jr,:nprof)
         bpcontr(j,:nprof) = bpcontr(jr,:nprof)
         btcontr(j,:nprof) = btcontr(jr,:nprof)
      end do
 
c
c     Extend the contours 2 points in theta at either end of the
c     theta grid, as a measure to reduce edge effects:
 
      thet(nptsd+3) = thet(nptsd) + dthet
      thet(nptsd+4) = thet(nptsd) + 2.*dthet
      thet(nptsd+2:3:(-1)) = thet(nptsd:1:(-1))
      thet(1) = -2.*dthet
      thet(2) = -dthet
 
      ncontr(:nprof) = ncontr(:nprof) + 4
      xcontr(nptsd+3,:nprof) = xcontr(2,:nprof)
      xcontr(nptsd+4,:nprof) = xcontr(3,:nprof)
      zcontr(nptsd+3,:nprof) = zcontr(2,:nprof)
      zcontr(nptsd+4,:nprof) = zcontr(3,:nprof)
      bpcontr(nptsd+3,:nprof) = bpcontr(2,:nprof)
      bpcontr(nptsd+4,:nprof) = bpcontr(3,:nprof)
      xcontr(nptsd+2:3:(-1),:nprof) = xcontr(nptsd:1:(-1),:nprof)
      zcontr(nptsd+2:3:(-1),:nprof) = zcontr(nptsd:1:(-1),:nprof)
      bpcontr(nptsd+2:3:(-1),:nprof) = bpcontr(nptsd:1:(-1),:nprof)
      xcontr(1,:nprof) = xcontr(nptsd,:nprof)
      xcontr(2,:nprof) = xcontr(nptsd+1,:nprof)
      zcontr(1,:nprof) = zcontr(nptsd,:nprof)
      zcontr(2,:nprof) = zcontr(nptsd+1,:nprof)
      bpcontr(1,:nprof) = bpcontr(nptsd,:nprof)
      bpcontr(2,:nprof) = bpcontr(nptsd+1,:nprof)
 
      nptsd = nptsd + 4
 
c
c
c
c     Spline the xcontr(ra,thet) and zcontr(ra,thet) arrays,
c     thus obtaining X(theta,psi), Z(theta,psi).
c     (Except X is measured from the machine axis, whereas X-Bram
c      is measured from the magnetic axis).
 
      call ibcccu (xcontr, thet, nptsd, ra, nprof, csplnx, nptsdm1, 
     1   wnoperm, ierr)
 
      call ibcccu (zcontr, thet, nptsd, ra, nprof, csplnz, nptsdm1, 
     1   wnoperm, ierr)
 
 
 
c     Set br variables:
c     Plasma shape and magnetic field on axis.
      tcurr = toteqd
      raxmag = xma
      rshift = raxmag - rzero
 
      xmax = redeqd + xdimeqd
      xmin = redeqd
      rminor = 0.5*(xmax - xmin)
 
c     Here we define rplasm = ONETWO rho variable at plasma edge,
c     rather than (xma-xmin)/2, as in Brambilla flux surface representation.
      rplasm = tpsisav
 
c     ukzero (free space wavenumber) is set in subroutine inital.
      urplas = rplasm*ukzero
      uraxmag = raxmag*ukzero
 
 
c     Form d(poloidal flux function)/d(rho/a) on the ra grid,
c     out to the plasma edge:
      dpsifra(:nprofs) = psifra(:nprofs,2)
 
c     Get volume of flux surfaces at points out to the plasma surface,
c     using volume = 2*pi*integeral{dl_pol/B_p)*dpsifra*dra:
c $$$$$$$$$$$  Modified and added by T.K. Mau on 10/11/91/
c     Using area = integral{dl_pol/(B_p*R0}*dpsifra*dra
c     Define <J.B> and <B> in MKS units, used for current profiles
      ppra(nprof,1) = 0.
      do n = nprof - 1, 1, -1
         ppra(n,1) = ppra(n+1,1) + 0.5*(pprime(n)+pprime(n+1))*(ywork(n)
     1      -ywork(n+1))
      end do
      call cubspl (dra, ppra, nprofn, nprofs)
c $$$$  Added by TK Mau on 12/2/91
      fra1(:nprof,1) = -(dstarp(1,:nprof)+4*zpi*xcontr(3,:nprof)*pprime(
     1   :nprof))/fra(:nprof,1)
      call cubspl (dra, fra1, nprofn, nprofs)
      ppra1(:nprof,1) = pprime(:nprof)
      call cubspl (dra, ppra1, nprofn, nprofs)
c $$$$$$$$$$$$$$$$$$
      zsurf(1) = 0.
      xwork(1) = 0.
      do j = 2, nprofs
         dv(j) = 0.0
         ds(j) = 0.0
         dlob(j) = 0.0
         dv1 = 0.
         do i = 4, nptsd - 2
            dlp = ((xcontr(i,j)-xcontr(i-1,j))**2+(zcontr(i,j)-zcontr(i-
     1         1,j))**2)**0.5
            bp1 = 0.5*(bpcontr(i,j)+bpcontr(i-1,j))
            rad1 = 0.5*(xcontr(i,j)+xcontr(i-1,j))
            bt1 = fra(1,1)/rad1
            dlpbp = dlp/bp1
            dv(j) = dv(j) + dlpbp
            dlob(j) = dlob(j) + dlp/sqrt(bt1**2 + bp1**2)
            ds(j) = ds(j) + dlpbp/rad1
            dv1 = dv1 + dlp*bp1
         end do
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c ---- Calculate incremental volume
         volume(j) = abs(2.*zpi*dv(j)*dra*dpsifra(j))
c ---- Calculate incremental cross section area
         zsurf(j) = ds(j)*dra*abs(dpsifra(j))
         xwork(j) = 2.*zpi*dv1*abs(dpsifra(j))
      end do
      volume(1) = volume(2)/3.
      dlob(1) = 0.25*dlob(2)
      dlob(nprofs) = 0.25*dlob(nprofs-1) + 0.75*dlob(nprofs)
c ---- Calculate incremental volumes and areas at center and edge
c     dv(1) = 1.75*dv(2)-0.75*dv(3)
c     volume(1) = 0.5*zpi*dra*abs(dv(1)*(0.75*dpsifra(1)+0.25*
c    &            dpsifra(2)))
c     ds(1) = 1.75*ds(2)-0.75*ds(3)
c     zsurf(1) = 0.25*dra*abs(ds(1)*(0.75*dpsifra(1)+0.25*
c    &           dpsifra(2)))
c     volume(nprofs) = 0.5*zpi*dra*abs((0.75*dv(nprofs)+0.25*
c    &                 dv(nprofs-1))*(0.75*dpsifra(nprofs)+0.25*
c    &                 dpsifra(nprofs-1)))
c     zsurf(nprofs) = 0.25*dra*abs((0.75*ds(nprofs)+0.25*
c    &                ds(nprofs-1))*(0.75*dpsifra(nprofs)+0.25*
c    &                dpsifra(nprofs-1)))
c ---- Calculate internal plasma inductance
      ali3 = 2.*simp(nprofs,dra,xwork)/(reqd*(amu0*toteqd)**2)
c ---- Calculate total and poloidal (Shafranov) betas.
      dl = 0.
      do i = 4, nptsd - 2
         dlp = ((xcontr(i,nprofs)-xcontr(i-1,nprofs))**2+(zcontr(i,
     1      nprofs)-zcontr(i-1,nprofs))**2)**0.5
         dl = dl + dlp
      end do
      xwork(1) = 0.
      xwork(2:nprofs) = volume(2:nprofs)/dra
      ywork(2:nprofs) = ppra(2:nprofs,1)*xwork(2:nprofs)
      bpsep = amu0*toteqd/dl
      beta = 2.*amu0*simp(nprofs,dra,ywork)/beqd**2/simp(nprofs,dra,
     1   xwork)
      betap = beta*(beqd/bpsep)**2
c $$$$$$$$$$$$$$$$$$
 
      volume(1) = volume(2)/3.
 
 
c*************************************************************************
c     To obtain equivalence with Brambilla psi-theta representation
c     of the flux surfaces, using the above ra and thet:
c           psi = ra
c           theta = thet
c     Then the Brambilla equilibrium arrays are tpsi = ra
c                                               ppsi = ra
c                                              tpsif = psifra
c                                                tqr = B_p(psi)/B_T(psi)
c*************************************************************************
 
      dpsi = dra
      ppsi(:nprof) = ra(:nprof)
      tpsif(:nprof,:) = psifra(:nprof,:)
 
      tqr(:nprof,1) = tpsif(:nprof,2)/(tpsisav*fra(:nprof,1))
 
      call cubspl (dpsi, tqr, nprofn, nprof)
 
 
 
 
 
      return 
 
      end subroutine mhdebm
      subroutine mhdebm1(kpsi, kthet, npsi, nthet, iounit1, iout, f_bal
     1   , jacob, xcontr, zcontr, b_fld, dstarp, bpcontr, btcontr, ra, 
     2   pprime, chipsi, pqr1, psiv, vprime, thec, qaxis, dthe, dpsi, 
     3   pax, btsign, rzero, bzero, baxis, psimag, psilim, xdimeqd, 
     4   zdimeqd, redeqd, zmideqd, xma, zma, totcur)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:56:54   6/14/01  
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
!      use Viorlh, only: bzero, rzero, btsign
!      use Vcraylh, only: dpsi
!      use Vceqdsk, only: psimag, psilim
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer kpsi, kthet, npsi, nthet, iounit1, iout
      real qaxis, dthe, pax, dpsi, btsign, rzero, bzero, baxis, psimag, 
     1   psilim, xdimeqd, zdimeqd, redeqd, zmideqd, xma, zma, totcur
      real, dimension(kpsi) :: f_bal
      real, dimension(kthet,kpsi) :: jacob, xcontr, zcontr, b_fld, 
     1   dstarp, bpcontr, btcontr
      real, dimension(kpsi) :: ra, pprime, chipsi, pqr1, psiv, vprime
      real, dimension(kthet) :: thec
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, j, n0, n
      real :: alpsi, psibnd
      real, dimension(kpsi,kthet) :: dummy
      real, dimension(kpsi) :: dummee
      real :: zpi, xthe, zthe, xpsi, zpsi, denom, psix, psiz, bval, 
     1   rbpsq, facp, facx, facf, facj, facb, facdsp, amu0, end, gpsi2, 
     2   zmax, reqd, fpi
      character, dimension(10) :: line*8
C-----------------------------------------------
c
c---------------------------
c  This subroutine replaces fiteqdsk. Instead of requiring an eqdsk-file,
c  it reads in MHDE data from Bob-Miller's MHDE-code and processes the
c  required input for coords and profix and profin
c-----------------------------
 
      data facp/1.E-8/
      data facx/1.E-2/
      data facf/1.E-6/
      data facj/1.E-6/
      data facb/1.E-4/
      data facdsp/1.E-4/
 
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      zpi = 4.*atan2(1.,1.)
      amu0 = zpi*4.E-7
c $$$$$$$$$$$$$$$$$
 
 
c-------------------------------
c  read in Bob Miller's dskbal file
c----------------------------
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 100) npsi, nthet
  100 format(2i5)
      if (npsi>kpsi .or. nthet>kthet) then
         write (iout, 400) npsi, kpsi, nthet, kthet
  400    format(2x,'Either npsi or nthet is too large:','npsi=',i6,2x,
     1      'kpsi=',i6,';  nthet=',i6,2x,'kthet=',i6)
         stop 
      endif
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) qaxis, dthe, dpsi, alpsi, psibnd, pax
  200 format(5e16.8)
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (f_bal(i),i=1,npsi)    !f_bal is f
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (ra(i),i=1,npsi)       ! psi coordinate 0-1
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (thec(j),j=1,nthet)    ! theta coordinat 0-pi
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) ((dummy(i,j),i=1,npsi),j=1,nthet)
      jacob(:nthet,:npsi) = transpose(dummy(:npsi,:nthet))
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) ((dummy(i,j),i=1,npsi),j=1,nthet)
      xcontr(:nthet,:npsi) = transpose(dummy(:npsi,:nthet))
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) ((dummy(i,j),i=1,npsi),j=1,nthet)
      zcontr(:nthet,:npsi) = transpose(dummy(:npsi,:nthet))
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) ((dummy(i,j),i=1,npsi),j=1,nthet)
      b_fld(:nthet,:npsi) = transpose(sqrt(dummy(:npsi,:nthet)))
c------------------
c  b_fld is magnitude of local b-field
c-------------------
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) ((dummy(i,j),i=1,npsi),j=1,nthet)
      dstarp(:nthet,:npsi) = transpose(dummy(:npsi,:nthet))
c---------------------
c  dstarp is del(star) of psiv, i.e., 4*pi*R*jphi/c
c---------------------
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (pprime(i),i=1,npsi)   !=pprime
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (dummee(i),i=1,npsi)   !=0
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (dummee(i),i=1,npsi)   !=0
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (dummee(i),i=1,npsi)   !=0
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (dummee(i),i=1,npsi)   !=0
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) ((dummy(i,j),i=1,npsi),j=1,nthet)
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (dummee(i),i=1,npsi)   !=0
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (dummee(i),i=1,npsi)   !=0
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (chipsi(i),i=1,npsi)
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200, end=300) (pqr1(i),i=1,npsi)
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200, end=300) (psiv(i),i=1,npsi)
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200, end=300) (vprime(i),i=1,npsi)
c---------------------------
c  psiv is poloidal flux function (psi in GS eqn.)
c  chipsi is d(psiv)/d(psic)
c  pqr1 is safety factor
c  vprime is dV/d(psiv)
c-----------------------
  300 continue
c---------------------------
c
      thec(nthet) = zpi
c-----------------------------------------------------------------------
c compute (r*bp)^2/b for stambaugh -- omegaE
c-----------------------------------------------------------------------
      do i = 2, npsi - 1
         do j = 1, nthet
            bval = f_bal(i)/xcontr(j,i)
            xpsi = (xcontr(j,i+1)-xcontr(j,i-1))/(2.*dpsi)
            zpsi = (zcontr(j,i+1)-zcontr(j,i-1))/(2.*dpsi)
            if (j/=1 .and. j/=nthet) then
               xthe = (xcontr(j+1,i)-xcontr(j-1,i))/(2.*dthe)
               zthe = (zcontr(j+1,i)-zcontr(j-1,i))/(2.*dthe)
            else
               xthe = 0.
               if (j == 1) zthe = zcontr(2,i)/dthe
               if (j == nthet) zthe = -zcontr(nthet-1,i)/dthe
            endif
            denom = 1./(xpsi*zthe - zpsi*xthe)
            psix = zthe*denom
            psiz = -xthe*denom
            gpsi2 = psix**2 + psiz**2
            rbpsq = gpsi2*chipsi(i)**2
c           omegE(j,i)=rbpsq/bval
            bpcontr(j,i) = sqrt(rbpsq/xcontr(j,i)**2)
            btcontr(j,i) = bval
c           omegE(j,i)=rbpsq/sqrt(bt(j,i)**2+bp(j,i)**2)
         end do
      end do
      i = npsi
c        omegE(i,j)=amax1(2.*omegE(i-1,j)-omegE(i-2,j),0.)
      btcontr(:nthet,i) = amax1(2.*btcontr(:nthet,i-1)-btcontr(:nthet,i-
     1   2),0.0_dp)
      bpcontr(:nthet,i) = amax1(2.*bpcontr(:nthet,i-1)-bpcontr(:nthet,i-
     1   2),0.0_dp)
      i = 1
c        omegE(i,j)=0.
      bpcontr(:nthet,i) = 0.
      btcontr(:nthet,i) = f_bal(i)/xcontr(:nthet,i)
 
c----------------------------
c  calculate quantities needed in raypat,coords and profix
c-----------------------------
      btsign = sign(1.0_dp,btcontr(1,1))
      rzero = 0.5E0*(xcontr(1,npsi)+xcontr(nthet,npsi))
      baxis = btcontr(1,1)
      psimag = psiv(1)
      psilim = psiv(npsi)
      xdimeqd = xcontr(1,npsi) - xcontr(nthet,npsi)
      zmax = zcontr(1,npsi)
      zmax = amax1(maxval(zcontr(:nthet,npsi)),zmax)
      zdimeqd = 2.*zmax
      reqd = rzero
      redeqd = xcontr(nthet,npsi)
      zmideqd = 0.
      xma = xcontr(1,1)
      zma = zcontr(1,1)
c-----------------
c  bzero is nominal b-field at rzero
c-----------------
      if (rzero < xma) then
         n0 = npsi - 1
         do n = npsi - 2, 1, -1
            if (rzero >= xcontr(nthet,n)) n0 = n
         end do
         bzero = b_fld(nthet,n0) + (rzero - xcontr(nthet,n0))*(b_fld(
     1      nthet,n0+1)-b_fld(nthet,n0))/(xcontr(nthet,n0+1)-xcontr(
     2      nthet,n0))
      else if (rzero >= xma) then
         n0 = 1
         do n = 2, npsi - 1
            if (rzero >= xcontr(1,n)) n0 = n
         end do
         bzero = b_fld(1,n0) + (rzero - xcontr(1,n0))*(b_fld(1,n0+1)-
     1      b_fld(1,n0))/(xcontr(1,n0+1)-xcontr(1,n0))
      endif
c-----------------
c  totcur is total current
c------------------
      fpi = 4.E0*zpi
      dummy(:npsi,:nthet) = transpose(dstarp(:nthet,:npsi)*jacob(:nthet,
     1   :npsi)/xcontr(:nthet,:npsi)**2)
      do i = 1, npsi
         dummee(i) = 0.
         dummee(i) = dummee(i) + sum(0.5*(dummy(i,:nthet-1)+dummy(i,2:
     1      nthet)))
      end do
      totcur = sum(0.5*(dummee(:npsi-1)+dummee(2:npsi)))
      totcur = 2.*totcur*10.*dthe*dpsi/fpi
c     totcur in amps.
 
c*******************************
c  change units from cgs to MKS
      f_bal(:npsi) = f_bal(:npsi)*facf
      jacob(:nthet,:npsi) = jacob(:nthet,:npsi)*facj
      xcontr(:nthet,:npsi) = facx*xcontr(:nthet,:npsi)
      zcontr(:nthet,:npsi) = facx*zcontr(:nthet,:npsi)
      b_fld(:nthet,:npsi) = b_fld(:nthet,:npsi)*facb
      dstarp(:nthet,:npsi) = dstarp(:nthet,:npsi)*facdsp
      bpcontr(:nthet,:npsi) = bpcontr(:nthet,:npsi)*facb
      btcontr(:nthet,:npsi) = btcontr(:nthet,:npsi)*facb
      pprime(:npsi) = pprime(:npsi)*1.E7
      chipsi(:npsi) = chipsi(:npsi)*facp
      vprime(:npsi) = vprime(:npsi)*1.E2
      psiv(:npsi) = psiv(:npsi)*facp
      bzero = bzero*facb
      baxis = baxis*facb
      psimag = psimag*facp
      psilim = psilim*facp
      xdimeqd = xdimeqd*facx
      zdimeqd = zdimeqd*facx
      redeqd = redeqd*facx
      rzero = rzero*facx
      zmideqd = zmideqd*facx
      xma = xma*facx
      zma = zma*facx
 
 
 
 
      return 
 
      end subroutine mhdebm1
c
      function qsaf (psi)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:56:54   6/14/01  
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Viorlh
      use Vcraylh, only: tpsi, zlamb, zqfac
      use Vceqdsk
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real qsaf
      real psi
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: left
      real :: dpsi
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c--------SCC  5/23/95
 
      if (psi <= 1.) then
         if (qsafa > 0.) then
            qsaf = qsaf0/(1. - (1. - qsaf0/qsafa)*psi**2)
         else
            qsaf = qsaf0*(1. - (1. - abs(qsafa)/qsaf0)*psi**2)
         endif
      else if (psi > 1.) then
         dpsi = tpsi(2) - tpsi(1)
!         left = ifix(psi/dpsi) + 1
         left = int(psi/dpsi) + 1
         if (left >= nprof) left = nprof - 1
         qsaf = abs(qsafa)*(zqfac(left)*zlamb(left)+(psi-tpsi(left))*(
     1      zqfac(left+1)*zlamb(left+1)-zqfac(left)*zlamb(left))/dpsi)/(
     2      zqfac(nprofs)*zlamb(nprofs))
      endif
      return 
      end function qsaf
 

c
c  This module contains subroutines from adj
c
c----------------------------------------------------------
 
      function current (du, ua, c, nmax, dth0, th0a, imax, imax1, 
     1   fm, chi, cur)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real current
      integer nmax, imax, imax1
      real du, c, dth0
      real, dimension(0:nmax - 1) :: ua
      real, dimension(0:imax - 1) :: th0a
      real, dimension(0:nmax - 1) :: fm
      real, dimension(0:imax1 - 1,0:nmax - 1) :: chi
      real, dimension(0:imax - 1) :: cur
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n, i
      real :: pi
C-----------------------------------------------
 
      pi = 4*atan(1.0E0)
      cur(:imax-1) = 0
 
      do n = 0, nmax - 1
         cur(:imax-1) = cur(:imax-1) + chi(:imax-1,n)*fm(n)*ua(n)**3/
     1      sqrt(1 + (ua(n)/c)**2)
      end do
 
      current = dot_product(sin(th0a(:imax-1))*cos(th0a(:imax-1)),cur(:
     1   imax-1))
 
      current = 4*pi*du*dth0*current
 
      return 
      end function current
 
 
      subroutine decomp(chi, nmax, nmax1, imax, imax1, lmaxa, lmaxa1, 
     1   th0a, dth0, legp, chil)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, nmax1, imax, imax1, lmaxa, lmaxa1
      real dth0
      real, dimension(0:imax1 - 1,0:nmax - 1) :: chi
      real, dimension(0:imax - 1) :: th0a
      real, dimension(0:imax1 - 1,lmaxa1) :: legp
      real, dimension(0:nmax1 - 1,lmaxa1) :: chil
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: la, l, n, i
      real :: sn
C-----------------------------------------------
 
      do la = 1, lmaxa
         l = max(2*la - 1,0)
 
         chil(:nmax-1,la) = 0
 
         do i = 0, imax - 1
            sn = sin(th0a(i))*legp(i,la)
            chil(:nmax-1,la) = chil(:nmax-1,la) + chi(i,:nmax-1)*sn
         end do
 
         chil(:nmax-1,la) = (2*l + 1)*dth0*chil(:nmax-1,la)
 
      end do
 
      return 
      end subroutine decomp
 
 
      function deltab (phi, eps)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real phi, eps
      real deltab
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
C-----------------------------------------------
 
      deltab = 2*eps*sin(phi/2)**2/(1 + eps*cos(phi))
 
      return 
      end function deltab
 
      subroutine error(du, ua, umax, nmax, dth0, th0a, th0max, imax, 
     1   imax1, resid, chi, abserr, relerr, aerr, rerr)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, imax, imax1
      real du, umax, dth0, th0max, abserr, relerr
      real, dimension(0:nmax - 1) :: ua
      real, dimension(0:imax - 1) :: th0a
      real, dimension(0:imax1 - 1,0:nmax - 1) :: resid, chi
      real, dimension(0:imax - 1) :: aerr, rerr
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, n
C-----------------------------------------------
 
      aerr(:imax-1) = 0
      rerr(:imax-1) = 0
 
      do n = 0, nmax - 1
         aerr(:imax-1) = aerr(:imax-1) + resid(:imax-1,n)**2*(ua(n)**2)
         rerr(:imax-1) =rerr(:imax-1)+(resid(:imax-1,n)/max(1.0E-16_dp,
     1      abs(chi(:imax-1,n))))**2*(ua(n)**2)
      end do
 
      abserr = dot_product(sin(th0a(:imax-1)),aerr(:imax-1))
      relerr = dot_product(sin(th0a(:imax-1)),rerr(:imax-1))
 
      abserr = sqrt(abserr*du*dth0/(umax**3/3*(1 - cos(th0max))))
      relerr = sqrt(relerr*du*dth0/(umax**3/3*(1 - cos(th0max))))
 
      return 
      end subroutine error
 
 
      subroutine hinit(eps, kmax, lmaxa1, harr, garr, dthp, dl, bb)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer kmax, lmaxa1
      real eps, dthp
      real, dimension(((lmaxa1 - 1)
     1 *lmaxa1*(2*lmaxa1-1))/6+(lmaxa1- 1)*lmaxa1+lmaxa1):: harr
      real,dimension((((lmaxa1+3)-1)*
     1   (lmaxa1+3))/2+(lmaxa1+1))::garr
      real, dimension(0:kmax - 1) :: dl, bb
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: k, la, la1, la2, l, l1
      real :: b, pi
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real , EXTERNAL :: deltab
C-----------------------------------------------
 
      pi = 4*atan(1.0E0)
 
C
C  Initialize |harr| and set the edge values of |garr| to zero.
C
      do la = 1, lmaxa1
         do la1 = 1, la
            harr((la-1)*la*(2*la-1)/6+(la1-1)*la+1:la*(la*(2*(la-1)-1)+1
     1         )/6+la1*la) = 0
         end do
      end do
 
      do la = -2, lmaxa1 - 1
         garr((((la+3)-1)*(la+3))/2+(0+1)) = 0
      end do
      do la = -1, lmaxa1 - 1
         garr((((la+3)-1)*(la+3))/2+(la+1+1)) = 0
         garr((((la+3)-1)*(la+3))/2+(la+2+1)) = 0
      end do
      garr((((1+3)-1)*(1+3))/2+(1+1)) = 1
 
      do k = 0, kmax - 1
c     phi=2*pi*(k+0.25e0)/kmax
         b = bb(k)
C
C  Use the recursion relation for 'g' to fill garr
C
         do la = 2, lmaxa1
            l = max(2*la - 1,0)
            do la1 = 1, la
               l1 = max(2*la1 - 1,0)
               garr((((la+3)-1)*(la+3))/2+(la1+1)) = (2*(2*l - 3)*(l**2
     1             - 3*l + 1)*garr((((la-1+3)-1)*(la-1+3))/2+(la1+1))-(l
     2            -3)*(l-2)*(2*l-1)*garr((((la-2+3)-1)*(la-2+3))/2+(la1+
     3            1)))/(l*(l - 1)*(2*l - 5)) + (2*l - 3)*(2*l - 1)*b*((
     4            l1 + 1)*(l1 + 2)*garr((((la-1+3)-1)*(la-1+3))/2+(la1+1
     5            +1))/((2*l1+3)*(2*l1+5))-2*(l1**2+l1-1)*garr((((la-1+3
     6            )-1)*(la-1+3))/2+(la1+1))/((2*l1-1)*(2*l1+3))+l1*(l1-1
     7            )*garr((((la-1+3)-1)*(la-1+3))/2+(la1-1+1))/((2*l1-3)*
     8            (2*l1-1)))/(l*(l - 1))
            end do
         end do
 
         do la = 1, lmaxa1
            do la1 = 1, la
               harr((la-1)*la*(2*la-1)/6+(la1-1)*la+1:la*(la*(2*(la-1)-1
     1            )+1)/6+la1*la) = harr((la-1)*la*(2*la-1)/6+(la1-1)*la+
     2            1:la*(la*(2*(la-1)-1)+1)/6+la1*la) + b*garr(((la+3)*(
     3            la+3)-3-la)/2+la1+1)*garr((la*(la+5)+6)/2+2:la+1+(la*(
     4            la+5)+6)/2)*dl(k)
            end do
         end do
      end do
 
      do la = 1, lmaxa1
         do la1 = 1, la
            do la2 = 1, la
               harr(((la-1)*la*(2*la-1))/6+(la1-1)*la+la2) = (2*max(2*la
     1             - 1,0) + 1)/real(2*max(2*la2 - 1,0) + 1)*harr(((la-1)
     2            *la*(2*la-1))/6+(la1-1)*la+la2)
            end do
         end do
      end do
 
      return 
      end subroutine hinit
 
 
      subroutine initjy(ua, c, nmax, nmax1, lmaxa, lmaxa1, legjy, jarray
     1   , djarray, lmax1)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, nmax1, lmaxa, lmaxa1, lmax1
      real c
      real, dimension(0:nmax - 1) :: ua
      real, dimension(0:nmax1 - 1,0:6,0:3,0:lmaxa1) :: legjy
      real, dimension((-lmax1) - 1:lmax1,0:6) :: jarray, djarray
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n, mult, la, l, a
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      EXTERNAL legjn
C-----------------------------------------------
 
      do n = 0, nmax - 1
         call legjn(ua(n),c,max(2*lmaxa-1,0),jarray,djarray,lmax1)
         do la = 0, lmaxa
            l = max(2*la - 1,0,0)
            mult = (-1)**(l + 1)
            legjy(n,:6,0,la) = jarray(l,:6)
            legjy(n,:6,1,la) = mult*jarray((-l)-1,:6)
            legjy(n,:6,2,la) = djarray(l,:6)
            legjy(n,:6,3,la) = mult*djarray((-l)-1,:6)
         end do
      end do
 
      return 
      end subroutine initjy
 
 
      subroutine initp(x, imax, imax1, lmaxa, lmaxa1, legp, leg0)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer imax, imax1, lmaxa, lmaxa1
      real, dimension(0:imax - 1) :: x
      real, dimension(0:imax1 - 1,lmaxa1) :: legp
      real, dimension(0:imax - 1) :: leg0
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, l, la
C-----------------------------------------------
 
      if (lmaxa < 1) return 
 
      la = 1
      leg0(:imax-1) = 1
      legp(:imax-1,la) = x(:imax-1)
 
      do la = 2, lmaxa
         l = max(2*la - 1,0)
         leg0(:imax-1) = (((2*l) - 3)*x(:imax-1)*legp(:imax-1,la-1)-(l-2
     1      )*leg0(:imax-1))/(l - 1)
         legp(:imax-1,la) = (((2*l) - 1)*x(:imax-1)*leg0(:imax-1)-(l-1)*
     1      legp(:imax-1,la-1))/l
      end do
 
      return 
      end subroutine initp
 
 
      subroutine isotrop(ua, du, c, fm, chil, nmax, nmax1, legjy, psid, 
     1   ze, zi, duug, fu, dtt, work)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, nmax1
      real du, c, ze, zi
      real, dimension(0:nmax - 1) :: ua, fm, chil
      real, dimension(0:nmax1 - 1,0:6,0:3) :: legjy
      real, dimension(0:nmax1 - 1,0:4,0:1) :: psid
      real, dimension(0:nmax) :: duug
      real, dimension(0:nmax - 1) :: fu, dtt
      real, dimension(0:nmax + (nmax1 + 1)*7*2 - 1) :: work
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
      integer, parameter :: p0 = 0
      integer, parameter :: p02 = 1
      integer, parameter :: p022 = 2
      integer, parameter :: p1 = 3
      integer, parameter :: p11 = 4
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n
      real :: pi, g, u
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      EXTERNAL pot
C-----------------------------------------------
 
      call pot (ua, du, c, fm, chil, nmax, nmax1, legjy, psid, work(0), 
     1   work(nmax))
 
      pi = 4*atan(1.0E0)
      do n = 0, nmax - 1
         u = ua(n)
         g = sqrt(1 + (u/c)**2)
         duug(n) = ze*4*pi*g/u*(2*g**2*psid(n,p02,1)-u*psid(n,p0,0)-8*g
     1      **2/c**2*psid(n,p022,1)+8*u/c**4*psid(n,p022,0))
         dtt(n) = ze*4*pi/(g*u)*((-g**2*psid(n,p02,1))-u/c**2*psid(n,p02
     1      ,0)+4*g**2/c**2*psid(n,p022,1)-4*u/c**4*psid(n,p022,0)) + zi
     2      *g/(2*u)
         fu(n) = ze*4*pi*g*((-psid(n,p1,1))+2/c**2*psid(n,p11,1))
      end do
 
 
 
      duug(nmax) = (3*duug(nmax-1)-duug(nmax-2))/2
      duug(nmax-1:1:(-1)) = (duug(nmax-1:1:(-1))+duug(nmax-2:0:(-1)))/2
      duug(0) = duug(0)
 
      return 
      end subroutine isotrop
 
 
      function lam1 (eps, th0, kmax, dthp, dl, b)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real lam1
      integer kmax
      real eps, th0, dthp
      real, dimension(0:kmax - 1) :: dl, b
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: k
      real :: deltabv, sum, costh
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real , EXTERNAL :: deltab
C-----------------------------------------------
 
c     pi=4*atan(1.0e0)
      sum = 0
      do k = 0, kmax - 1
c     phi=2*pi*(k+0.25e0)/kmax
         deltabv = b(k) - 1.
         costh = sqrt(1 - min(1.0E0_dp,deltabv*tan(th0)**2))
         sum = sum + 1/costh*dl(k)
      end do
      lam1 = sum
 
      return 
      end function lam1
 
 
      function lam2 (eps, th0, kmax, dthp, dl, b)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real lam2
      integer kmax
      real eps, th0, dthp
      real, dimension(0:kmax - 1) :: dl, b
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: k
      real :: deltabv, sum, costh
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real , EXTERNAL :: deltab
C-----------------------------------------------
 
c     pi=4*atan(1.0e0)
      sum = 0
      do k = 0, kmax - 1
c     phi=2*pi*(k+0.25e0)/kmax
         deltabv = b(k) - 1.
         costh = sqrt(1 - min(1.0E0_dp,deltabv*tan(th0)**2))
         sum = sum + costh/(1 + deltabv)*dl(k)/b(k)
      end do
      lam2 = sum
 
      return 
      end function lam2
 
 
      subroutine legjn(u, c, lmax, jarray, djarray, lmax1)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer lmax, lmax1
      real u, c
      real, dimension((-lmax1) - 1:lmax1,0:6) :: jarray, djarray
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
      integer, parameter :: j0 = 0
      integer, parameter :: j1 = 1
      integer, parameter :: j2 = 2
      integer, parameter :: j02 = 3
      integer, parameter :: j11 = 4
      integer, parameter :: j22 = 5
      integer, parameter :: j022 = 6
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: l, a, amax
      real :: scale, g
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      EXTERNAL legjs
C-----------------------------------------------
 
      amax = 2
      call legjs (u/c, lmax + 2, amax, jarray, lmax1)
 
      scale = 1
      do l = 1, lmax + 2
         scale = scale*u/(2*l + 1)
         jarray(l,:amax) = scale*jarray(l,:amax)
      end do
 
      scale = 1
      do l = -1, (-lmax) - 2, -1
         scale = scale/u*(2*l + 3)
         jarray(l,:amax) = scale*jarray(l,:amax)
      end do
 
      do l = (-lmax) - 2, lmax
         jarray(l,j02) = u/2*jarray(l+1,1)
         jarray(l,j11) = u/2*jarray(l+1,0)
         jarray(l,j22) = u/2*jarray(l+1,1) + (u/c)**2/2*jarray(l+2,0)
         jarray(l,j022) = u**2/8*jarray(l+2,0)
      end do
 
      g = sqrt(1 + (u/c)**2)
      do a = 0, 6
         do l = (-lmax) - 1, lmax
            djarray(l,a) = jarray(l-1,a)/g - (l + 1)/u*jarray(l,a)
         end do
      end do
 
      return 
      end subroutine legjn
 
 
      subroutine legjs(z, lmax, amax, jarray, lmax1)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer lmax, amax, lmax1
      real z
      real, dimension((-lmax1) - 1:lmax1,0:amax) :: jarray
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: l, a, lstart
      real :: z2, g, ja0, ja1, ja2, ratio, sigma
C-----------------------------------------------
 
      if (amax<0 .or. lmax<0) return 
      if (lmax > lmax1) return 
 
      z2 = z**2
      g = sqrt(1 + z2)
 
      do a = 1, amax
C**************a=0 is excluded
         ja2 = 1
C********ja(a-1,a)
         ja1 = g
C**********ja(a-2,a)
         do l = a - 3, lmax - 1, -1
C
C   Get things started by iterating down to $|lmax|-1$ if need be.
C   This is from equation (A29)
C
            ja0=g*ja1-z2*(l-a+2)*(l+a+2)*ja2/((2*l+3)*(2*l+5))
            ja2 = ja1
            ja1 = ja0
         end do
         l = min(lmax,a - 1)
         jarray(l,a) = ja2
         l = l - 1
         jarray(l,a) = ja1
         do l = min(lmax,a - 1) - 2, max((-a),(-lmax) - 1), -1
            jarray(l,a) = g*jarray(l+1,a) - z2*(l - a + 2)*(l + a + 2)*
     1         jarray(l+2,a)/((2*l + 3)*(2*l + 5))
         end do
      end do
 
C
C   Calculate the scaled Legendre functions for the other easy case, namely
C   $l<-a$.
C
      do a = 0, min(amax,lmax)
         l = (-a) - 1
         jarray(l,a) = 1
         l = l - 1
         if (l >= (-lmax) - 1) jarray(l,a) = g
         do l = (-a) - 3, (-lmax) - 1, -1
            jarray(l,a) = g*jarray(l+1,a) - z2*(l - a + 2)*(l + a + 2)*
     1         jarray(l+2,a)/((2*l + 3)*(2*l + 5))
         end do
      end do
 
C
C  Calculate scaled Legendre functions for -a.<= l <=a
C
C
C   Calculate $\ja{l\ge0,0}$.  Depending on the magnitude of the argument we
C  either use backwards recursion (for $z \le |lmax|+1$) or forwards
C  recursion using $\ja{-1,0}=1$ and $\ja{0,0} = (\sinh^{-1} z)/z$.
C
      a = 0
      if (abs(z) <= lmax + 1) then
C
C  Estimate where to start the recursion.  The 10 is a extra guard.
C
         lstart=lmax+log(1.0E-16)/(2*log((1.0E-16+abs(z))/(g+1)))+10
         ratio = 2/(g + 1)
         do l = lstart, lmax - 1, -1
            ratio=1/(g-z2*(l-a+2)*(l+a+2)*ratio/((2*l+3)*(2*l+5)))
C***At this point, |ratio| is approximation for $\ja{l+1,a}/\ja{l,a}$. **
         end do
         jarray(lmax,a) = ratio
         ja0 = 1
         do l = lmax - 2, -1, -1
            jarray(l+1,a) = ja0
            ja0 = g*jarray(l+1,a) - z2*(l - a + 2)*(l + a + 2)*jarray(l+
     1         2,a)/((2*l + 3)*(2*l + 5))
         end do
         ja0 = 1/ja0
         jarray(0:lmax,a) = ja0*jarray(0:lmax,a)
      else
C********** Use forward recurrence for $z>|lmax|+1$. **
         sigma = log(g + abs(z))
C******$\sinh^{-1}(\abs z)$ **
         l = 0
         jarray(l,a) = sigma/abs(z)
C********* Starting value.  We assume
C            that $\ja{-1,0}$ has already been set to $1$. */
 
 
         do l = 1, lmax
C***********Equation (A29)***************
            jarray(l,a) = (g*jarray(l-1,a)-jarray(l-2,a))*(2*l - 1)*(2*l
     1          + 1)/(z2*(l - a)*(l + a))
         end do
      endif
C
C   Do the other cases, i.e., $a>0$, $l\ge a$.
C
C  < Do the other cases, i.e., $a>0$, $l\ge a$ @>=
C
      do a = 1, min(lmax,amax)
         l = lmax
         jarray(l,a) = ((2*l + 1)*jarray(l-1,a-1)-(l+1-a)*g*jarray(l,a-1
     1      ))/(l + a)
         l = lmax - 1
         if (l == 0) then
C
C    implies that a=1. Use ja(-1,0)=1
C
            ja0 = ((2*l + 1) - (l + 1 - a)*g*jarray(l,a-1))/(l + a)
         else
            ja0=((2*l+1)*jarray(l-1,a-1)-(l+1-a)*g*jarray(l,a-1))/(l+a)
         endif
         do l = lmax - 2, a - 1, -1
            jarray(l+1,a) = ja0
            ja0 = g*jarray(l+1,a) - z2*(l - a + 2)*(l + a + 2)*jarray(l+
     1         2,a)/((2*l + 3)*(2*l + 5))
         end do
         ja0 = 1/ja0
         jarray(a:lmax,a) = ja0*jarray(a:lmax,a)
      end do
 
      return 
      end subroutine legjs
 
 
      subroutine matinit(du, ua, ug, nmax, nmax1, dth0, th0a, th0g, imax
     1   , imax1, duug, fu, dtt, lam1a, lam2g, uinv, th0inv, rho)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, nmax1, imax, imax1
      real du, dth0, rho
      real, dimension(0:nmax - 1) :: ua
      real, dimension(0:nmax) :: ug
      real, dimension(0:imax - 1) :: th0a
      real, dimension(0:imax) :: th0g
      real, dimension(0:nmax) :: duug
      real, dimension(0:nmax - 1) :: fu, dtt
      real, dimension(0:imax - 1) :: lam1a
      real, dimension(0:imax) :: lam2g
      real, dimension(0:nmax1 - 1,-1:1) :: uinv
      real, dimension(0:imax1 - 1,-1:1) :: th0inv
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n, i
C-----------------------------------------------
C
C  Define matrices for inversion of diffusion and friction operator.  These
C  are one-dimensional because the operator is independent of $\theta_0$.
C
      uinv(:nmax-1,-1) = ug(:nmax-1)**2*duug(:nmax-1)/((ua(:nmax-1)**2)*
     1   (du**2))
      uinv(:nmax-1,1) = ug(1:nmax)**2*duug(1:nmax)/((ua(:nmax-1)**2)*(du
     1   **2))
      uinv(:nmax-1,0) = (-uinv(:nmax-1,-1)) - uinv(:nmax-1,1)
      uinv(:nmax-1,-1) = uinv(:nmax-1,-1) - fu(:nmax-1)/(2*du)
      uinv(:nmax-1,1) = uinv(:nmax-1,1) + fu(:nmax-1)/(2*du)
      n = 0
      uinv(n,0) = uinv(n,0) - uinv(n,-1)
      uinv(n,-1) = 0
      n = nmax - 1
      uinv(n,-1) = uinv(n,-1) - rho*uinv(n,1)
      uinv(n,0) = uinv(n,0) + (1 + rho)*uinv(n,1)
      uinv(n,1) = 0
 
      uinv(:nmax-1,-1) = uinv(:nmax-1,-1)*(ua(:nmax-1)**2)/dtt(:nmax-1)
      uinv(:nmax-1,0) = uinv(:nmax-1,0)*(ua(:nmax-1)**2)/dtt(:nmax-1)
      uinv(:nmax-1,1) = uinv(:nmax-1,1)*(ua(:nmax-1)**2)/dtt(:nmax-1)
C
C   Define matrices for inversion of pitch-angle scattering operator.  These
C  are one-dimensional because, after divided out $D_{\theta\theta,0}/u^2$,
C  the operator is independent of $u$.
C
      th0inv(:imax-1,-1) = sin(th0g(:imax-1))*lam2g(:imax-1)/((lam1a(:
     1   imax-1)*(sin(th0a(:imax-1))))*(dth0**2))
      th0inv(:imax-1,1) = sin(th0g(1:imax))*lam2g(1:imax)/((lam1a(:imax-
     1   1)*(sin(th0a(:imax-1))))*(dth0**2))
      th0inv(:imax-1,0) = (-th0inv(:imax-1,-1)) - th0inv(:imax-1,1)
      i = 0
      i = imax - 1
      th0inv(i,0) = th0inv(i,0) - th0inv(i,1)
      th0inv(i,1) = 0
 
 
C* :86 *
*line 1805 "adj.web"
 
 
      return 
      end subroutine matinit
 
 
 
      subroutine maxwel(ua, du, c, nmax, fm, t)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax
      real du, c, t
      real, dimension(0:nmax - 1) :: ua, fm
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n
      real :: sum, pi
C-----------------------------------------------
 
      fm(:nmax-1) = exp((-ua(:nmax-1)**2/(sqrt(1+(ua(:nmax-1)/c)**2)+1)/
     1   t))
      sum = dot_product(ua(:nmax-1)**2,fm(:nmax-1))
      pi = 4*atan(1.0E0)
      sum = 4*pi*du*sum
      fm(:nmax-1) = fm(:nmax-1)/sum
 
      return 
      end subroutine maxwel
 
      subroutine operinit
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
C-----------------------------------------------
 
      open(unit=20, file='adjout', form='unformatted', status='unknown')
      open(unit=29, file='adjinp', form='unformatted', status='old')
 
      return 
      end subroutine operinit
 
 
      subroutine pot(ua,du,c,fm,chil,nmax,nmax1,legjy,psid,fla,ijy)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, nmax1
      real du, c
      real, dimension(0:nmax - 1) :: ua, fm, chil
      real, dimension(0:nmax1 - 1,0:6,0:3) :: legjy
      real, dimension(0:nmax1 - 1,0:4,0:1) :: psid
      real, dimension(0:nmax - 1) :: fla
      real, dimension(0:nmax1,0:6,0:1) :: ijy
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
      integer, parameter :: p0 = 0
      integer, parameter :: p02 = 1
      integer, parameter :: p022 = 2
      integer, parameter :: p1 = 3
      integer, parameter :: p11 = 4
      integer, parameter :: j0 = 0
      integer, parameter :: j1 = 1
      integer, parameter :: j2 = 2
      integer, parameter :: j02 = 3
      integer, parameter :: j11 = 4
      integer, parameter :: j22 = 5
      integer, parameter :: j022 = 6
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n, a
C-----------------------------------------------
 
 
C   Define various indefinite integrals needed in the definition of the
C  potentials.  First do the integration to cell edges and then interpolate
C  to the cell centers.
 
      fla(:nmax-1) = fm(:nmax-1)*chil(:nmax-1)*ua(:nmax-1)**2/sqrt(1 + (
     1   ua(:nmax-1)/c)**2)*du/2
 
      do a = 0, 6
         ijy(1:nmax,a,0) = fla(:nmax-1)*legjy(:nmax-1,a,0)
         ijy(:nmax-1,a,1) = fla(:nmax-1)*legjy(:nmax-1,a,1)
         ijy(0,a,0) = 0
         ijy(nmax,a,1) = 0
      end do
 
      do n = 1, nmax
         ijy(n,:6,0) = ijy(n-1,:6,0) + ijy(n,:6,0)
      end do
      do n = nmax - 1, 0, -1
         ijy(n,:6,1) = ijy(n+1,:6,1) + ijy(n,:6,1)
      end do
 
      ijy(:nmax-1,:6,0) = ijy(:nmax-1,:6,0) + ijy(1:nmax,:6,0)
      ijy(:nmax-1,:6,1) = ijy(:nmax-1,:6,1) + ijy(1:nmax,:6,1)
C
C  Define various indefinite integrals needed in the definition of
C   the potentials. First do the integration to cell edges and then
C   interpolate to the cell centers.
C
      psid(:nmax-1,p0,0) = legjy(:nmax-1,j0,1)*ijy(:nmax-1,j0,0) + ijy(:
     1   nmax-1,j0,1)*legjy(:nmax-1,j0,0)
      psid(:nmax-1,p02,0) = legjy(:nmax-1,j0,1)*ijy(:nmax-1,j02,0) + 
     1   legjy(:nmax-1,j02,1)*ijy(:nmax-1,j2,0) + ijy(:nmax-1,j0,1)*
     2   legjy(:nmax-1,j02,0) + ijy(:nmax-1,j02,1)*legjy(:nmax-1,j2,0)
      psid(:nmax-1,p022,0) = legjy(:nmax-1,j0,1)*ijy(:nmax-1,j022,0) + 
     1   legjy(:nmax-1,j02,1)*ijy(:nmax-1,j22,0) + legjy(:nmax-1,j022,1)
     2   *ijy(:nmax-1,j2,0) + ijy(:nmax-1,j0,1)*legjy(:nmax-1,j022,0) + 
     3   ijy(:nmax-1,j02,1)*legjy(:nmax-1,j22,0) + ijy(:nmax-1,j022,1)*
     4   legjy(:nmax-1,j2,0)
      psid(:nmax-1,p1,0) = legjy(:nmax-1,j1,1)*ijy(:nmax-1,j1,0) + ijy(:
     1   nmax-1,j1,1)*legjy(:nmax-1,j1,0)
      psid(:nmax-1,p11,0) = legjy(:nmax-1,j1,1)*ijy(:nmax-1,j11,0) + 
     1   legjy(:nmax-1,j11,1)*ijy(:nmax-1,j1,0) + ijy(:nmax-1,j1,1)*
     2   legjy(:nmax-1,j11,0) + ijy(:nmax-1,j11,1)*legjy(:nmax-1,j1,0)
 
      psid(:nmax-1,p0,1) = legjy(:nmax-1,j0,3)*ijy(:nmax-1,j0,0) + ijy(:
     1   nmax-1,j0,1)*legjy(:nmax-1,j0,2)
      psid(:nmax-1,p02,1) = legjy(:nmax-1,j0,3)*ijy(:nmax-1,j02,0) + 
     1   legjy(:nmax-1,j02,3)*ijy(:nmax-1,j2,0) + ijy(:nmax-1,j0,1)*
     2   legjy(:nmax-1,j02,2) + ijy(:nmax-1,j02,1)*legjy(:nmax-1,j2,2)
      psid(:nmax-1,p022,1) = legjy(:nmax-1,j0,3)*ijy(:nmax-1,j022,0) + 
     1   legjy(:nmax-1,j02,3)*ijy(:nmax-1,j22,0) + legjy(:nmax-1,j022,3)
     2   *ijy(:nmax-1,j2,0) + ijy(:nmax-1,j0,1)*legjy(:nmax-1,j022,2) + 
     3   ijy(:nmax-1,j02,1)*legjy(:nmax-1,j22,2) + ijy(:nmax-1,j022,1)*
     4   legjy(:nmax-1,j2,2)
      psid(:nmax-1,p1,1) = legjy(:nmax-1,j1,3)*ijy(:nmax-1,j1,0) + ijy(:
     1   nmax-1,j1,1)*legjy(:nmax-1,j1,2)
      psid(:nmax-1,p11,1) = legjy(:nmax-1,j1,3)*ijy(:nmax-1,j11,0) + 
     1   legjy(:nmax-1,j11,3)*ijy(:nmax-1,j1,0) + ijy(:nmax-1,j1,1)*
     2   legjy(:nmax-1,j11,2) + ijy(:nmax-1,j11,1)*legjy(:nmax-1,j1,2)
 
      return 
      end subroutine pot
 
 
      subroutine reactall(ua, du, c, fm, t, chil, nmax, nmax1, imax, 
     1   imax1, lam1a, legjy, psid, legp, harr, ze, lmaxa, lmaxa1, react
     2   , reactl, chila, work)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, nmax1, imax, imax1, lmaxa, lmaxa1
      real du, c, t, ze
      real, dimension(0:nmax - 1) :: ua, fm
      real, dimension(0:nmax1 - 1,lmaxa1) :: chil
      real, dimension(0:imax - 1) :: lam1a
      real, dimension(0:nmax1 - 1,0:6,0:3,lmaxa1) :: legjy
      real, dimension(0:nmax1 - 1,0:4,0:1) :: psid
      real, dimension(0:imax1 - 1,lmaxa1) :: legp
      real, dimension(((lmaxa1 - 1)*
     1  lmaxa1*(2*lmaxa1-1))/6+(lmaxa1-1)*lmaxa1+lmaxa1):: harr
      real, dimension(0:imax1 - 1,0:nmax - 1) :: react
      real, dimension(0:nmax - 1) :: reactl, chila
      real, dimension(0:nmax + (nmax1 + 1)*7*2 - 1) :: work
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: la, la1, la2, n, i
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      EXTERNAL reaction
C-----------------------------------------------
 
      react(:imax-1,:nmax-1) = 0
 
      do la1 = 1, lmaxa
         reactl(:nmax-1) = 0
         do la = la1, lmaxa
            chila(:nmax-1) = 0
            do la2 = 1, la
               chila(:nmax-1) = chila(:nmax-1) + harr(((la-1)*la*(2*la-1
     1            ))/6+(la1-1)*la+la2)*chil(:nmax-1,la2)
            end do
            call reaction (ua, du, c, fm, t, chila, nmax, nmax1, legjy(0
     1         ,0,0,la), psid, ze, reactl, max(2*la - 1,0), work)
         end do
 
         do n = 0, nmax - 1
            react(:imax-1,n) = react(:imax-1,n) + reactl(n)*legp(:imax-1
     1         ,la1)
         end do
      end do
 
      do n = 0, nmax - 1
         react(:imax-1,n) = react(:imax-1,n)/lam1a(:imax-1)
      end do
 
      return 
      end subroutine reactall
 
 
      subroutine reaction(ua, du, c, fm, t, chil, nmax, nmax1, legjy, 
     1   psid, ze, reactl, l, work)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, nmax1, l
      real du, c, t, ze
      real, dimension(0:nmax - 1) :: ua, fm, chil
      real, dimension(0:nmax1 - 1,0:6,0:3) :: legjy
      real, dimension(0:nmax1 - 1,0:4,0:1) :: psid
      real, dimension(0:nmax - 1) :: reactl
      real, dimension(0:nmax + (nmax1 + 1)*7*2 - 1) :: work
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
      integer, parameter :: p0 = 0
      integer, parameter :: p02 = 1
      integer, parameter :: p022 = 2
      integer, parameter :: p1 = 3
      integer, parameter :: p11 = 4
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n
      real :: pi, u, g
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      EXTERNAL pot
C-----------------------------------------------
 
      call pot (ua, du, c, fm, chil, nmax, nmax1, legjy, psid, work(0), 
     1   work(nmax))
 
      pi = 4*atan(1.0E0)
      do n = 0, nmax - 1
         u = ua(n)
         g = sqrt(1 + (u/c)**2)
         reactl(n) = reactl(n) + ze*4*pi*(fm(n)*chil(n)/g-u/t*psid(n,p1,
     1      1)-2/(c**2*g)*psid(n,p1,0)+2*u/(c**2*t)*psid(n,p11,1)+u/t*
     2      psid(n,p0,1)-(u**2/(g*t**2)-1/t)*psid(n,p0,0)+(2*g*u/t**2-2*
     3      u/(c**2*t))*psid(n,p02,1)-(l*(l+1)/(g*t**2)-2/(c**2*t))*psid
     4      (n,p02,0)-8*g*u/(c**2*t**2)*psid(n,p022,1)+4*((l+2)*(l-1)/g+
     5      2*g)/(c**2*t**2)*psid(n,p022,0))
      end do
 
      return 
      end subroutine reaction
 
 
      subroutine residue(ua, nmax, nmax1, csth0a, imax, imax1, chi, dtt
     1   , c, lam1a, uinv, th0inv, resid)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, nmax1, imax, imax1
      real c
      real, dimension(0:nmax - 1) :: ua
      real, dimension(0:imax - 1) :: csth0a
      real, dimension(0:imax1 - 1,0:nmax - 1) :: chi
      real, dimension(0:nmax - 1) :: dtt
      real, dimension(0:imax - 1) :: lam1a
      real, dimension(0:nmax1 - 1,-1:1) :: uinv
      real, dimension(0:imax1 - 1,-1:1) :: th0inv
      real, dimension(0:imax1 - 1,0:nmax - 1) :: resid
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n, i
C-----------------------------------------------
C   Add in electric field term
C  $$\frac{v \cos\theta_0}{\lambda_1}. $$
C
      do n = 0, nmax - 1
         resid(:imax-1,n) = resid(:imax-1,n) + csth0a(:imax-1)/lam1a(:
     1      imax-1)*ua(n)/sqrt(1 + (ua(n)/c)**2)
      end do
C
C   Normalize to pitch-angle diffusion coefficient and add in
C   differential terms.
C
      do n = 0, nmax - 1
         resid(:imax-1,n) = resid(:imax-1,n)*ua(n)**2/dtt(n) + chi(:imax
     1      -1,n-1)*uinv(n,-1) + chi(:imax-1,n)*uinv(n,0) + chi(:imax-1,
     2      n+1)*uinv(n,1) + chi(-1:imax-2,n)*th0inv(:imax-1,-1) + chi(:
     3      imax-1,n)*th0inv(:imax-1,0) + chi(1:imax,n)*th0inv(:imax-1,1
     4      )
      end do
 
      return 
      end subroutine residue
 
 
      subroutine runa(t, c2, ze, zi, eps, nmax, umax, imax, kmax, dt, 
     1   tmax, alpha, rho, lmax, tskip, npsi0, dla, ba, alenb, thetps, 
     2   thetpe, psimx, psimn, iout3, iout4, iout5, iout7, iout8, iswchi
     3   , aerrmx, rerrmx)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
C
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, imax, kmax, tmax, lmax, tskip, npsi0, iout3, iout4, 
     1   iout5, iout7, iout8, iswchi
      real t, c2, ze, zi, eps, umax, dt, alpha, rho, psimx, psimn, 
     1   aerrmx, rerrmx
      real, dimension(0:kmax - 1) :: dla, ba
      real, dimension(npsi0) :: alenb
      real, dimension(0:kmax) :: thetps
      real, dimension(0:kmax - 1) :: thetpe
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n, np, nmax1, imax1, lmaxa, lmaxa1, worksize, pwork, 
     1   pua, pug, pth0a, pth0g, pcsth0a, pchi, plegjy, pchil, plegp, 
     2   pduug, pfu, pdtt, pfm, ppsid, plam1a, plam2g, pharr, puinv, 
     3   pth0inv, presid, presida, ierc, memsize
      real, dimension(npsi0) :: bmax, bmin, psis
      real :: dene, teme
      real, allocatable, dimension(:) :: memory
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      EXTERNAL runb
C-----------------------------------------------
c
c   Common block for Comdynray
c
 
C
C
C
C  indices for ua,ug,th0a,th0g,csth0a,chi,legjy,chil,legp,duug,
C               fu,dtt,fm,psid,lam1a,lam2g,harr,uinv,th0inv,resid,
C               resida
 
 
 
 
 
 
 
C
C  allocate memory
C
 
 
      nmax1 = nmax
      imax1 = imax
      if (mod(nmax1,2) == 1) nmax1 = nmax1 + 1
      if (mod(imax1,2) == 0) imax1 = imax1 + 1
 
C  |nmax1| and |imax1| are the allocated dimensions for two-dimensional
C  arrays.These might differ from |nmax| and |imax| on the Crays, where
C   strides are inefficiently handled.
C   To avoid memory conflicts on the Crays
C   Make even for accessing
C              |ijy(0:nmaxa1,0:6,0:1)| by row in |potential|
C    Make odd for accessing
C        |chi(0:imax1-1,0:nmax-1)| by row in |decomp|
 
 
C |lmaxa1| is the allocated dimension for the |la| index.  This is
C  usually |lmaxa| but must be at least $1$ to ensure that dimension
C  specifications such as |1:lmaxa1| are legal.  Also $H_{1,1,1}$ is needed
C        even when |lmaxa=0|.
 
 
C  Round |lmax| down to an odd number
C  |lmaxa1| needs to be at least 1
C
      if (mod(lmax,2) == 0) lmax = lmax - 1
      lmaxa = (lmax + 1)/2
      lmaxa1 = lmaxa
      if (lmaxa1 == 0) lmaxa1 = 1
 
C  count memory size
C
      memsize = 0
      worksize = 0
C
      pua = memsize
      memsize = memsize + nmax
C
      pug = memsize
      memsize = memsize + nmax + 1
C
      pth0a = memsize
      memsize = memsize + imax
C
      pth0g = memsize
      memsize = memsize + imax + 1
C
      pcsth0a = memsize
      memsize = memsize + imax
C
      pchi = memsize
      memsize = memsize + imax1*nmax
C
      plegjy = memsize
      memsize = memsize + nmax1*7*4*(lmaxa1 + 1)
C
C Figure the workspace for |initjy| (|jarray| and |djarray|).
C
      worksize = max(worksize,2*(max(2*lmaxa - 1,0) + 2 + 1)*7*2)
C
C   Workspace for |potential| (|fla| and |ijy|)
C
      worksize = max(worksize,nmax + (nmax1 + 1)*7*2)
C
C  indices for chil, legp
C
      pchil = memsize
      memsize = memsize + nmax1*lmaxa1
 
      plegp = memsize
      memsize = memsize + imax1*lmaxa1
C
C  Workspace for |initp|  (|leg0|).
C
      worksize = max(worksize,imax)
C
C  Indices for duug,fu,dtt,fm,psid
 
      pduug = memsize
      memsize = memsize + nmax + 1
 
      pfu = memsize
      memsize = memsize + nmax
 
      pdtt = memsize
      memsize = memsize + nmax
 
      pfm = memsize
      memsize = memsize + nmax
 
      ppsid = memsize
      memsize = memsize + nmax1*5*2
C
C  Workspace for |reactall| (|reactl| and |chila|) and for |potential|
C  (|fla| and |ijy|).
C
      worksize = max(worksize,nmax*2 + nmax + (nmax1 + 1)*7*2)
C
C  Indices of lam1a,lam2g,harr
C
      plam1a = memsize
      memsize = memsize + imax
 
      plam2g = memsize
      memsize = memsize + imax + 1
 
      pharr = memsize
      memsize = memsize + (((lmaxa1 - 1)*lmaxa1*(2*lmaxa1 - 1))/6 + (
     1   lmaxa1 - 1)*lmaxa1 + lmaxa1)
C
C  Workspace for |hinit| (|garr|).
C
      worksize = max(worksize,(((lmaxa1 + 3) - 1)*(lmaxa1 + 3))/2 + (
     1   lmaxa1 + 1))
C
C  Workspace for |error| (|aerr| and |rerr|).
C
      worksize = max(worksize,2*imax)
C
C  Indices for uinv,th0inv,resid,resida
C
      puinv = memsize
      memsize = memsize + nmax1*3
 
      pth0inv = memsize
      memsize = memsize + imax1*3
 
      presid = memsize
      memsize = memsize + imax1*nmax
 
      presida = memsize
      memsize = memsize + imax1*nmax
C
C  Workspace for |current| (|cur|).
C
      worksize = max(worksize,imax)
C
C  Sum memsize and worksize
C
      pwork = memsize
      memsize = memsize + worksize
C
C  allocate memory
C
c      call hpalloc(memptr,memsize,ierc,1)
      if (.not.allocated(memory)) then
         ALLOCATE(memory(memsize),stat=ierc)
         if (ierc /= 0) then
            print *, 'memory could not be allocated in runa'
            return 
         endif
      endif
c      call bcast (memory, memsize)
      memory = 0
      read (iout3, 2020) thetps
      read (iout3, 2020) thetpe
      do np = 1, npsi0
         read (iout3, 2010) psis(np)
         read (iout3, 2020) dla
         read (iout3, 2020) ba
         read (iout3, 2010) alenb(np), bmax(np), bmin(np)
 
         call subpar (psis(np), dene, teme, zi)
         write (iout5, 3000) psis(np), dene, teme
c
c   teme in Kev
c
         c2 = 511.925/teme
 
 
         call runb (t, c2, ze, zi, eps, nmax, umax, imax, kmax, dt, tmax
     1      , alpha, rho, lmax, tskip, nmax1, imax1, lmaxa, lmaxa1, 
     2      worksize, memory(pua), memory(pug), memory(pth0a), memory(
     3      pth0g), memory(pcsth0a), memory(pchi), memory(plegjy), 
     4      memory(pchil), memory(plegp), memory(pduug), memory(pfu), 
     5      memory(pdtt), memory(pfm), memory(ppsid), memory(plam1a), 
     6      memory(plam2g), memory(pharr), memory(puinv), memory(pth0inv
     7      ), memory(presid), memory(presida), memory(pwork), npsi0, 
     8      dla, ba, alenb, thetps, thetpe, np, bmax, bmin, iout3, iout4
     9      , iout5, iout7, iout8, iswchi, aerrmx, rerrmx)
C
C  Deallocate memory
C
      end do
c      call hpdeallc(memptr,ierc,0)
      DEALLOCATE(memory)
 
c-----------------------------
 2010 format(4(2x,e20.12))
 2020 format(5(2x,e20.12))
 3000 format(4(2x,e20.12))
 
      return 
      end subroutine runa
 
      subroutine runb(t, c2, ze, zi, eps, nmax, umax, imax, kmax, dt, 
     1   tmax, alpha, rho, lmax, tskip, nmax1, imax1, lmaxa, lmaxa1, 
     2   worksize, ua, ug, th0a, th0g, csth0a, chi, legjy, chil, legp, 
     3   duug, fu, dtt, fm, psid, lam1a, lam2g, harr, uinv, th0inv, 
     4   resid, resida, work, npsi0, dla, ba, alenb, thetps, thetpe, np
     5   , bmax, bmin, iout3, iout4, iout5, iout7, iout8, iswchi, aerrmx
     6   , rerrmx)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
C
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, imax, kmax, tmax, lmax, tskip, nmax1, imax1, lmaxa, 
     1   lmaxa1, worksize, npsi0, np, iout3, iout4, iout5, iout7, iout8
     2   , iswchi
      real t, c2, ze, zi, eps, umax, dt, alpha, rho, aerrmx, rerrmx
      real, dimension(0:nmax - 1) :: ua
      real, dimension(0:nmax) :: ug
      real, dimension(0:imax - 1) :: th0a
      real, dimension(0:imax) :: th0g
      real, dimension(0:imax - 1) :: csth0a
      real, dimension(0:imax1 - 1,0:nmax - 1) :: chi
      real, dimension(0:nmax1 - 1,0:6,0:3,0:lmaxa1) :: legjy
      real, dimension(0:nmax1 - 1,lmaxa1) :: chil
      real, dimension(0:imax1 - 1,lmaxa1) :: legp
      real, dimension(0:nmax) :: duug
      real, dimension(0:nmax - 1) :: fu, dtt, fm
      real, dimension(0:nmax1 - 1,0:4,0:1) :: psid
      real, dimension(0:imax - 1) :: lam1a
      real, dimension(0:imax) :: lam2g
      real, dimension(((lmaxa1 - 1)*lmaxa1
     1  *(2*lmaxa1 - 1))/6+(lmaxa1-1)*lmaxa1+lmaxa1):: harr
      real, dimension(0:nmax1 - 1,-1:1) :: uinv
      real, dimension(0:imax1 - 1,-1:1) :: th0inv
      real, dimension(0:imax1 - 1,0:nmax - 1) :: resid, resida
      real, dimension(0:worksize - 1) :: work
      real, dimension(0:kmax - 1) :: dla, ba
      real, dimension(npsi0) :: alenb
      real, dimension(0:kmax) :: thetps
      real, dimension(0:kmax - 1) :: thetpe
      real, dimension(npsi0) :: bmax, bmin
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: itim, n, i, time
      real::dthp,du,dth0,th0max,pi,c,deltb,abserr,relerr,curv,cond,e
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real , EXTERNAL :: deltab, lam1, lam2, current
      EXTERNAL initjy, initp, maxwel, isotrop, hinit, matinit, decomp, 
     1   reactall, residue, error, solve
C-----------------------------------------------
C
C  Velocity space meshes
C
 
C
C   Array holding Legendre functions
C
C
C  Legendre decomposition of chi
C
C
C
 
C
C
C   Arrays to hold various flux averaged quantities.
C
C
C  Matrices for inversion
C
C
C  Time advancement;  residues
C
C
C   Current and conductivity
C  The conductivity is define as $J_{0\parallel}/E_{0\parallel}$ where
C    $$E_{0\parallel} = B_0\frac{\int E_{\parallel} dl}{\int B\,dl}.$$
C    Substituting $E_\parallel = (B_\zeta/B) \Phi/(2\pi R)$ and
C    $\Phi=TQ/L$ gives $E_\parallel = T/\int b \,dl/L$.
C
 
C
C
C  Initialize velocity meshes, chi etc.
C
      du = umax/nmax
      do n = 0, nmax - 1
         ua(n) = (n + 0.5E0)*du
         ug(n) = n*du
      end do
      ug(nmax) = umax
 
      pi = 4*atan(1.0E0)
      deltb = (bmax(np)-bmin(np))/bmin(np)
      th0max = atan2(1.0E0_dp,sqrt(deltb))
      eps = deltb/(2. + deltb)
      dth0 = th0max/imax
      do i = 0, imax - 1
         th0a(i) = (i + 0.5E0)*dth0
         csth0a(i) = cos(th0a(i))
         th0g(i) = i*dth0
      end do
      th0g(imax) = th0max
 
C
C  Set up trial chi-function
C
      if (np == 1) then
         if (iswchi == 0) then
            chi(:imax-1,:nmax-1) = 0
         else
            read (iout7, 3030) ((chi(i,n),i=0,imax - 1),n=0,nmax - 1)
         endif
      endif
C
C   Fill the arrays
C
      c = sqrt(c2)
      lmaxa = (lmax + 1)/2
      call initjy (ua, c, nmax, nmax1, lmaxa, lmaxa1, legjy, work(0), 
     1   work(2*(max(2*lmaxa-1,0)+2+1)*7), max(2*lmaxa - 1,0) + 2)
C
C  Initialize legp
C
      call initp (csth0a, imax, imax1, lmaxa, lmaxa1, legp, work)
C
C  Initialize isotropic terms.
C
      call maxwel (ua, du, c, nmax, fm, t)
 
      chil(:nmax-1,1) = 1
 
      call isotrop (ua, du, c, fm, chil(0,1), nmax, nmax1, legjy(0,0,0,0
     1   ), psid, ze, zi, duug, fu, dtt, work)
C
C  Initialize lam1a,lam2g,harr
C
      dthp = thetpe(1) - thetpe(0)
      do i = 0, imax - 1
         lam1a(i) = lam1(eps,th0a(i),kmax,dthp,dla(0),ba(0))
      end do
 
      do i = 0, imax
         lam2g(i) = lam2(eps,th0g(i),kmax,dthp,dla(0),ba(0))
      end do
 
      call hinit (eps, kmax, lmaxa1, harr, work, dthp, dla(0), ba(0))
C
C  Initialize matrices for inversion.
C
      call matinit (du, ua, ug, nmax, nmax1, dth0, th0a, th0g, imax, 
     1   imax1, duug, fu, dtt, lam1a, lam2g, uinv, th0inv, rho)
C
C  time evolution of solution
C
      itim = 0
      do time = 0, tmax
         if (itim /= 1) then
C
C  Calculate reaction term.
C
            call decomp (chi, nmax, nmax1, imax, imax1, lmaxa, lmaxa1, 
     1         th0a, dth0, legp, chil)
            call reactall (ua, du, c, fm, t, chil, nmax, nmax1, imax, 
     1         imax1, lam1a, legjy(0,0,0,1), psid, legp, harr, ze, lmaxa
     2         , lmaxa1, resid, work(0), work(nmax), work(2*nmax))
C
C  Calculate residue and its norm
C
            call residue (ua, nmax, nmax1, csth0a, imax, imax1, chi, dtt
     1         , c, lam1a, uinv, th0inv, resid)
            if (mod(time,tskip) == 0) call error (du, ua, umax, nmax, 
     1         dth0, th0a, th0max, imax, imax1, resid, chi, abserr, 
     2         relerr, work(0), work(imax))
C
C  Advance chi
C
            call solve (resida, imax1, nmax, 1, imax, uinv(0,-1), uinv(0
     1         ,0), uinv(0,1), resid, dt, alpha)
            call solve (resid, 1, imax, imax1, nmax, th0inv(0,-1), 
     1         th0inv(0,0), th0inv(0,1), resida, dt, alpha)
 
            chi(:imax-1,:nmax-1) = chi(:imax-1,:nmax-1) + dt*resid(:imax
     1         -1,:nmax-1)
C
C  compute current and conductivity.
C
            if (mod(time,tskip) == 0) then
               curv = current(du,ua,c,nmax,dth0,th0a,imax,imax1,fm,chi,
     1            work)
               e = t/harr(((1-1)*1*(2*1-1))/6+(1-1)*1+1)
               cond = curv*zi/(t*sqrt(t)*e)
               write (iout4, 4020) time, cond, abserr, relerr
 4020          format(2x,i5,3x,e20.12,2x,e16.8,2x,e16.8)
            endif
            if (abserr<aerrmx .and. relerr<rerrmx) itim = 1
         endif
      end do
C
C  Write out results.
C
      write (iout5, 3010) nmax, imax, kmax, lmax
      write (iout5, 3020) t, c2, ze, zi, eps
      write(iout5,3020)umax,th0max,du,dth0,rho,deltb,bmin(np),bmax(np)
      write (iout5, 3040) dt, tmax, alpha
      write (iout5, 3020) cond, abserr, relerr
      write (iout5, 3030) ua
      write (iout5, 3030) ug
      write (iout5, 3030) th0a
      write (iout5, 3030) th0g
      write (iout5, 3030) lam1a
      write (iout5, 3030) fm
      write (iout5, 3030) ((chi(i,n),i=0,imax - 1),n=0,nmax - 1)
      if(np==1)write(iout8,3030)((chi(i,n),i=0,imax-1),n=0,nmax-1)
c-----------------------------
c
 3010 format(1x,4i8)
 3020 format(4(1x,e20.12))
 3030 format(5(1x,e20.12))
 3040 format(1x,e20.12,2x,i8,2x,e20.12)
C
      return 
      end subroutine runb
 
 
      subroutine solve(x, ns, n, ms, m, a, b, c, z, dt, alpha)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
C
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer ns, n, ms, m
      real dt, alpha
      real, dimension(0:ms - 1,0:*) :: x
      real, dimension(0:n - 1) :: a, b, c
      real, dimension(0:ms - 1,0:*) :: z
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, k
      real :: dt2, den
C-----------------------------------------------
 
      dt2 = -alpha*dt
 
      i = 0
      den = 1 + dt2*b(i)
      x(ns*i,:m-1) = z(ns*i,:m-1)/den
      z(ns*i,:m-1) = -dt2*c(i)/den
 
      do i = 1, n - 2
         do k = 0, m - 1
            den = 1 + dt2*(b(i)+a(i)*z(ns*(i-1),k))
            x(ns*i,k) = (z(ns*i,k)-dt2*a(i)*x(ns*(i-1),k))/den
            z(ns*i,k) = -dt2*c(i)/den
         end do
      end do
 
      i = n - 1
      do k = 0, m - 1
         den = 1 + dt2*(b(i)+a(i)*z(ns*(i-1),k))
         x(ns*i,k) = (z(ns*i,k)-dt2*a(i)*x(ns*(i-1),k))/den
         z(ns*i,k) = 0
      end do
 
 
 
 
 
      do i = n - 2, 0, -1
         x(ns*i,:m-1) = z(ns*i,:m-1)*x(ns*(i+1),:m-1) + x(ns*i,:m-1)
      end do
 
      return 
      end subroutine solve
      subroutine subadj(zef1, nmax, umax, imax, nthp0, dt, tmax, alpha, 
     1   rho, lmax, iout3, iout5, iout4, iout7, iout8, iswchi, aerrmx, 
     2   rerrmx)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
C
C  calculates the Spitzer function chi(theta,ua) and output to adjout
C
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nmax, imax, nthp0, tmax, lmax, iout3, iout5, iout4, iout7
     1   , iout8, iswchi
      real zef1, umax, dt, alpha, rho, aerrmx, rerrmx
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer::tskip, dlaptr, baptr, alnptr, ndum
      integer::thsptr, theptr, ii, npsi0, iercd
      real :: psimx, psimn, t, c2, ze, zi, eps, cpu, cpu0
      real,allocatable, dimension(:) :: dum
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      EXTERNAL runa
C-----------------------------------------------
c
c   Common block for Comdynray
c
c     pointer(dumptr,dum(1))
C
C
      read (iout3, 2000) nthp0, npsi0
      read (iout3, 2010) psimx, psimn
      ii = 1
      dlaptr = ii
      ii = ii + nthp0
      baptr = ii
      ii = ii + nthp0
      alnptr = ii
      ii = ii + npsi0
      thsptr = ii
      ii = ii + nthp0 + 1
      theptr = ii
      ii = ii + nthp0
      ndum = ii
c      call hpalloc(dumptr,ndum,iercd,1)
      if (.not.allocated(dum)) then
         ALLOCATE(dum(ndum),stat=iercd)
         if (iercd /= 0) then
            print *, 'dum could not be allocated in subadj'
            return 
         endif
      endif
      write (iout5, 2000) nthp0, npsi0
      write (iout5, 2010) psimx, psimn
      t = 1.E0
      ze = 1.E0
      dt = 1
c     tmax=250
      alpha = 0.55
      rho = 1
C     lmax=21
C     nmax=100
C     umax=10
C     imax=200
C
      tskip = 10
!      call second (cpu0)
      call runa (t, c2, ze, zi, eps, nmax, umax, imax, nthp0, dt, tmax, 
     1   alpha, rho, lmax, tskip, npsi0, dum(dlaptr), dum(baptr), dum(
     2   alnptr), dum(thsptr), dum(theptr), psimx, psimn, iout3, iout4, 
     3   iout5, iout7, iout8, iswchi, aerrmx, rerrmx)
!      call second (cpu)
!      write (iout4, 4030) cpu - cpu0
c      call hpdeallc(dumptr,iercd,0)
      DEALLOCATE(dum)
 4030 format(1x,'adj CPU time: ',f8.4,' secs.')
c----------------------
 2000 format(1x,2i8)
 2010 format(4(2x,e20.12))
      return 
      end subroutine subadj
      subroutine xtrema(imx, xmx, ymx, dymx, nwk, wkt, wk, wk1, ier)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  09:55:56   6/14/01  
C...Switches: -p4 -yb
C
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer imx, nwk, ier
      real xmx, ymx, dymx
      real, dimension(nwk) :: wkt, wk
      real, dimension(nwk,3) :: wk1
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: it
      real, dimension(1) :: x0, y0, dy0, x1, y1, dy1
      real :: h, dx
C-----------------------------------------------
      x0(1) = wkt(imx)
      y0(1) = wk(imx)
      h = wkt(2) - wkt(1)
      call mcsevu1 (h, wkt(1), wk, nwk, wk1, nwk, 1, dy0, x0, ier)
      dx = 0.5*h
      it = 0
      ier = 0
   50 continue
      x1(1) = x0(1) + dx
      call mcsevu (h, wkt(1), wk, nwk, wk1, nwk, 1, y1, x1, ier)
      call mcsevu1 (h, wkt(1), wk, nwk, wk1, nwk, 1, dy1, x1, ier)
      dx = (x1(1)-x0(1))*dy1(1)/(dy0(1)-dy1(1))
      x0(1) = x1(1)
      y0(1) = y1(1)
      dy0(1) = dy1(1)
      it = it + 1
      if (it > 50) then
         ier = 19
         return 
      endif
      if (abs(dx)<1.E-8*h .or. abs(dy0(1))<1.E-8) go to 100
      go to 50
  100 continue
      xmx = x0(1)
      ymx = y0(1)
      dymx = dy0(1)
      return 
      end subroutine xtrema

      module Viogrl
      use kind_spec

C...Created by Pacific-Sierra Research VAST-90 2.06G2  12:29:44   5/18/01
      use Vparam, only: nprofm, nbwg
      integer   nwguid, nmod, nphase, isimm, ndim0, ndim1
      integer   joutrf, ireout, jumpw, jtest, ispec, ngra, itrans
      integer, dimension(2) :: nnk
      real(kind=dp)   aksupw
      real(kind=dp)   rtot, trans
      real(kind=dp)   freqcy,width,dwall,heigth,dnedge,dndx,dxpl,
     1   phmin,phmax
      real(kind=dp), dimension(2,1500) :: px, sumpx, bk
      real(kind=dp), dimension(nbwg) :: refl
      real(kind=dp), dimension(2) :: ddk
      real(kind=dp), dimension(nprofm) :: radius
      complex, dimension(nbwg) :: calfa
      end module Viogrl

 
      subroutine tableintrp(xx, n, x, jlo)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer n, jlo
      real(kind=dp) x
      real(kind=dp), dimension(n) :: xx
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: jhi, jmid, inc
C-----------------------------------------------
c
c ----------------------------------------------------------------------
c --- correlated table search routine. use jlo from previous call to
c --- get jlo for current value of x. if jlo from previous call is
c --- no good(jlo=0 or jlo=n) then do a binary search.
c --- this routine returns jlo so that
c   xx(jlo) .le. x .le. xx(jlo+1) if jlo = 1
c   xx(jlo) .lt. x .le. xx(jlo+1) if jlo =2,3...n-1
c   it is assumed that xx(j),j = 1,2..n is monotonically
c   increasing; this is NOT checked for.
c   this is a modified version of the Numerical Recipes subroutine HUNT
c ------------------------------------------------------------------ HSJ
c
c
      if (x < xx(1)) then
         jlo = 0                    ! indicates out of range below xx(1)
      else if (x <= xx(2)) then
         jlo = 1                               ! xx(1) .le. x .le. xx(2)
      else if (x <= xx(n)) then                ! xx(2) .lt. x .le. xx(n)
c
c       check if jlo from previous call is usable:
c
         if (jlo==0 .or. jlo==n) then
            jlo = 2
            jhi = n
            go to 15           ! no correlation go directly to bisection
         else                                    ! 1 .le. jlo .lt. n
c
c         bracket x, then use bisection:
c         start with  jlo  from previous call:
c
            inc = 1
            if (x > xx(jlo)) then                ! search up
    4          continue
               jhi = jlo + inc
               if (jhi >= n) then
                  jhi = n
               else if (x > xx(jhi)) then
                  inc = inc + inc
                  jlo = jhi
                  go to 4
               endif
            else
    5          continue
               jhi = jlo
               jlo = jlo - inc
               if (jlo <= 1) then
                  jlo = 1
               else if (x <= xx(jlo)) then
                  inc = inc + inc
                  go to 5
               endif
            endif
         endif
c
c         bisection:
c
   10    continue
         if (jhi - jlo == 1) return 
   15    continue
         jmid = (jhi + jlo)/2
         if (x > xx(jmid)) then
            jlo = jmid
         else                                    ! x .le. xx(jmid)
            jhi = jmid
         endif
         go to 10
c
      else                                       ! x .gt. xx(n)
         jlo = n
      endif
c
      return 
c
      end subroutine tableintrp

c
c  This module contains routines initializing data
c
c------------------------------------------------------
c
      subroutine bram
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:55:53   6/14/01  
C...Switches: -p4 -yb
 
c ************ ************ ************ ************ ************
c
c   routine to set initial values of many variables
c   BRAM  for 'M. Brambilla' who wrote the original version
c   for lower hybrid waves.
c
c ************ ************ ************ ************ ************
c
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Viogrl
      use Viorlh
      use Vcraylh
!      use Viogrl, ONLY: calfa, px, sumpx, bk, refl, rtot, trans, 
!     1   aksupw, ddk, nnk, joutrf, ireout, jumpw, jtest, ispec, ngra, 
!     2   freqcy, width, dwall, heigth, dnedge, dndx, dxpl, phmin, phmax,
!     3   itrans, radius, nwguid, nmod, nphase, isimm, ndim0, ndim1
!      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang, 
!     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec, 
!     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3, 
!     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti, 
!     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin, 
!     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril, 
!     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref, 
!     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep, 
!     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr, 
!     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite, 
!     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1, 
!     1   epserr, epser1, epspfw, epspsw, epsray, rzero, rplasm, 
!     2   bzero, btsign, tcurr, fbsc, rshift, dtrian, qsaf0, qsafa,
!     3   gamene1, presfr, iout, iout1, iout2, nharm, nequil, isafa,
!     4   polasp
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, jout6, npart, nx, ny, j, ifrang
      real :: anzacc, edgabs, bzedge, aksups, zpsi, zdpsi, zdivne, 
     1   zdivte, zne, zti, zdecay, zdivni, zdivti
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real,EXTERNAL::furmaj,furrho,futria,fuelon,prone,prote,proti
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c------------ --------------
c   common blocks of Comiogrl
c---------------------------
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c
c ************ ************ ************ ************ ************
c
c      call dropfile(0)
c
c  title & date
c
      write (iout, 5000)
 5000 format('***',2x,"FW/SW raytracing code with current drive",/,5x,
     1   "Derived from RAYLH                 ",/,5x,
     2   "By Brambilla:22/11/85, BH:10/4/90, TKM/SCC/BH:11/21/91",/)
c
c ===============================================
c  plasma parameters
c ===============================================
c  toroidal magnetic field on axis (tesla)
      bzero = 2.17
      btsign = 1.
c  main and plasma radius (m)
      rzero = 1.68
      rplasm = 0.39
c  toroidal current (a)
      tcurr = 3.20E5
c  central electron density (cm-3)
c  from parameterization if <= 0
c      ignored if ifrang not equal to 0
      denc = 2.E13
c ------------------------------ (main only)
c  specify central (ifrang=0) or line averaged (ifrang=1) density
c      ifrang = -1 for exponentially parametrized profiles
c      if ifrang>0 specify the density per frange zdnfrg (cm-3)
C        ifrang = 0
C        zdnfrg = 1.4e18
c  simulation of the scrape-off layer (iedge=1)
c        iedge = 0
c ------------------------------ (end)
c  central electron temperature (kev)
c  from parameterization if <= 0
c      ignored if ifrang not equal to 0
      tempec = 1.200
c  n.of ion species  (up to nions species allowed)
      nspec = 1
c  reference species
      mainsp = 1
c  mass and charges (atomic units)
      atm(1) = 2.
      azi(1) = 1.
c        atm(2) = 1.
c        azi(2) = 1.
c  concentrations conc(j,nsp)=n(j,nsp)/conc(j,nsp)=n(e); charge neutrality will be
 
c          implemented by re-evaluating n(j,nsp)
c  central ion temperatures (kev)
c  all ion species will have same temperature;
c  if they are different, one should input from curray_go or eqdskex
      tempic(1) = 0.9
c        tempic(2) = 20.
c  nprof = n. of points in the radial profile
c      accepted if 11 <= nprof <= nprofn
c**bh    nprof = 41
c  specify here if a standard case has to be run:
c        nequil=1 - data entered by the user
c                   (equilibrium code or diagnostic)
c        nequil=0 - circular or elliptic cross-section
c                   (specify the plasma radius (m.), the
c                   poloidal aspect ratio and the relative
c                   shift of the magnetic axis)
      nequil = 0
c  poloidal cross-section dimension and shape
c        rshift - shift of the magnetic axis (m)
c        polasp - poloidal aspect ratio (b/a)
c                 (1): limit on the magnetic axis
c                 (2): of the external magn. surface
c        dtrian - triangularity of the external magn. surf.
c               - ignored if nequil = 1
      rshift = 0.0
      polasp(1) = 1.
      polasp(2) = 1.
      dtrian = 0.
c****************9/15/91   SCC
c    epserr=tolerence of error in dispersion relation in raytracing
c********************
      epserr = 0.01
c
c ===============================================
c  lh heating parameters
c ===============================================
c   frequency (hz)
      freqcy = 2.45E9
      omega = 2.*3.14159265359*freqcy
c  total power coupled (mw)
      power = 1.
      powers(1) = 1.
      powers(2) = 0.
c  thgril - central position of the antenna (deg.)
      thgril(:nspect) = 0.
c  igrill = 1 - grill code called
c  igrill = 0 - grill code not called
c  igrill = -1 - fit to P(n_parallel)
      igrill = 0
c  wave emitted by the antenna
c   islofa = 1 : slow wave
c   islofa = -1 : fast wave (igrill = 0)
      islofa = 1
c
c ===============================================
c  grill parameters  (ignored if igrill = 0)
c ===============================================
c number of waveguides
      nwguid = 8
c waveguide distance, cm.
      width = 2.1
c waveguide separation, cm.
      dwall = 0.80
c heigth of the guides
      heigth = 16.5
c total number of modes
      nmod = 3
c density gradient at the plasma edge, cm-4
      dndx = 1.E11
c density at the plasma edge, cm-3
      dnedge = 1.E11
c effective absorption for nonaccessible waves
c   between npar=1 and npar=anzacc
      anzacc = 0.
      edgabs = 0.1
c magnetic field near the antenna
      bzedge = 1.8
c distance of the plasma from the wall, cm.
      dxpl = 0.00
c------------------------------------------------------------------
c phases for output
c        nphase > 0 - uniform excitation
c        nphase < 0 - excitations specified through subroutine
c                     config(calfa,ncall)
c                     in this case specify wether the config.
c                     is simmetric (isimm=1) or not (isimm=2)
      nphase = 1
      phmin = 180.
      phmax = 180.
c------------------------------------------------------------------
c output control
c       = 1  -  only reflection coefficients
c       = 2  -  also complex coefficients
      jout6 = 1
c  repetition of the waveguides parameters for each case
c     ireout = n. of cases - yes
c     ireout = 0 - no
      ireout = 0
c  max n-parallel for output
c remember: aksups should not be smaller than the largest of anzsup
      aksupw = 7.
      aksups = 7.
c  n. of points and mesh steps
      nnk(1) = 300
      ddk(1) = (aksups - 1.)/float(nnk(1))
      nnk(2) = 200
      ddk(2) = 0.1
c  jumpw = jump for print
      jumpw = 5
c  npart = n. of step in the unaccessible region
      npart = 5
c
c ===============================================
c  discretisation of the power spectre
c      for ray tracing purposes
c ===============================================
c  nnkpar(i) - n of values of nparallel in interval i.
c  anzsup - largest absolute value of k parallel
c  anzinf - smallest absolute value of k parallel
c    if nnkpar=1  anzinf(1) will be taken
c ****** actual
      nnkpar(1) = 40
      anzinf(1) = 1.05
      anzsup(1) = 3.00
c ******
      nnkpar(2) = 0
      anzinf(2) = -2.
      anzsup(2) = -4.
c ******
      nnkpar(3:nspect) = 0
      anzinf(3:nspect) = 0.0
      anzsup(3:nspect) = 0.0
c  nthin - n. of rays in the poloidal cross-section
c    (should not exceed ngr)
      nthin = 1
c  nequip - max. n. of equiphase surfaces with output
c    ignored if igraph not zero
c  deykpr - step of eikon for printing
      nequip = 200
      deykpr = 2.
c ************ ************ ************ ************
c independent variable
c  indvar = 0 - poloidal phase
c  indvar = 1 - toroidal phase
      indvar = 1
c ************ ************ ************ ************
c  maxref = n. of boundary reflections allowed
      maxref = 1
c ************ ************ ************ ************
c details of print
c  iprint = 0 - output suppressed
c  iprint = 1 - normal output
c         = 2 - more detailed output
c         = 3 - det. output at each call of output1(x)
c               for tests (no graphical output)
      iprint = 0
c  iplopr = 1  -  plots of the profiles
      iplopr = 0
c ************ ************ ************ ************
c  igraph = 0  no graphical output
      igraph = 0
      if (igraph /= 0) then
c ************ ************ ************ ************
c  wavefronts to be plotted every jwfr point
c      ignored if nthin=1
         jwfr = 1
c ************ ************ ************ ************
c  list of plots to be made
         iploxy(:,:8) = 0
c ===================================================================
c  npolxy(nxvarb,nyvarb) different from zero produces a plot
c                        according to the following table:
c ====================================================================
c  nxvarb=1  indep. var. seikon  (phase in the poloidal plane)
c         2              psi (magnetic surfaces label)
c ====================================================================
c  nyvarb=1  dep. var.   skp
c         2              skpar
c         3              skr
c         4              skth
c         5              skx
c         6              skz
c         7              spower
c         8              sphi
c ===================================================================
         iploxy(2,1) = 1
         iploxy(2,2) = 1
c        iploxy(2,8) = 1
      endif
c   parameters for spectre
c        iabs(ngra) = n of graphs of spectre per page
c        ngra.gt.0    integral of px also plotted
c        ngra.lt.0    only px plotted
c  ignored if igrill = 0
      ngra = 1
c ===============================================
c  mhd configuration parameters
c ===============================================
c  nmhd = n. of points in the radial profiles
c      of rmaj(psi), rrho(psi), triang(psi), ellipt(psi)
c      accepted if 11 <= nmhd <= nprofn
c
      nmhd = 11
c
      dpsimhd = 1./(nmhd - 1.)
c
      do i = 1, nmhd
         psimhd(i) = (i - 1.)*dpsimhd
         zpsi = psimhd(i)
         rmaj(i) = furmaj(zpsi)
         rrho(i) = furrho(zpsi)
         triang(i) = futria(zpsi)
         elong(i) = fuelon(zpsi)
      end do
c
c ************ ************ ************ ************ ************
c
c  standard case with analytic profiles for density & temperatures
c
c ************ ************ ************ ************ ************
c
      conc(:nprofs,:nspec) = 0.
      pni(:nprofs,:nspec) = 0.
      pti(:nprofs,:nspec) = 0.
      conc(:nprofs,mainsp) = 1.
c
      zdpsi = 1./float(nprofs - 1)
      print *,'nprofs = ',nprofs,' zdpsi = ',zdpsi,' ifrang = ',ifrang
c ======================================================================
c ====== only with the exponential version of the profiles =============
      zdivne = 1.
      zdivte = 1.
      if (ifrang == (-1)) then
         zdivne = 1.E14
         zdivte = 1.E-3
         zne = prone(0.)
         denc = 1.E14*zne
         tempec = 1.E-3*prote(0.)
         zti = amin1(1.0_dp,0.60_dp*zne + 0.40_dp)
         tempic(1) = zti*tempec
      endif
c ======================================================================
      do j = 1, nprofs
         print *,'j = ',j
         psi = float(j - 1)*zdpsi
         print *,'psi = ',psi
         ppsi(j) = psi
         pte(j) = prote(psi)*zdivte
         pne(j) = prone(psi)*zdivne
         pjavg(j) = pte(j)**1.5
         do i = 1, nspec
            pni(j,i) = pne(j)*conc(j,i)
            pti(j,i) = proti(psi)
         end do
      end do
      tempic(:nspec) = pti(1,:nspec)
c
c ************ ************ ************ ************
c  profile averaged density
c
C     if(ifrang.eq.1)  then
C        zsum = pne(1)
C     do 510  n=2,nprofs,2
C 510    zsum = zsum + 4.*pne(n) + pne(n+1)
C        zfact = zdpsi*zsum/(3.*pne(1))
C        zdivne = 0.5*zdnfrg*float(ifrang)/zfact
C     do 520  n=1,nprofs
C 520    pne(n) = zdivne*pne(n)
C        denc = pne(1)
C     end if
c
c ************ ************ ************ ************
c  edge simulation
c
      if (iedge /= 0) then
         do j = nprofs + 1, nprof
            ppsi(j) = float(j - 1)*zdpsi
         end do
         zdivne = pne(nprofs)
         zdivte = pte(nprofs)
         do j = nprofs + 1, nprof
            zdecay = exp((-float(j - nprofs)/2.))
            pne(j) = zdivne*zdecay
            pte(j) = zdivte*zdecay
            pjavg(j) = 0.0
            pti(j,:nspec) = pti(nprofs,:nspec)*zdecay
            pni(j,:nspec) = pni(nprofs,:nspec)*zdecay
         end do
c  extend MHD
         nmhd = 11
         dpsimhd = ppsi(nprof)/(nmhd - 1.)
         do i = 1, nmhd
            psimhd(i) = (i - 1.)*dpsimhd
            zpsi = psimhd(i)
            rmaj(i) = furmaj(zpsi)
            rrho(i) = furrho(zpsi)
            triang(i) = futria(zpsi)
            elong(i) = fuelon(zpsi)
         end do
      endif
c
c ************ ************ ************ ************
 
      return 
      end subroutine bram
      subroutine inital
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:55:53   6/14/01  
C...Switches: -p4 -yb
c
c ************ ************ ************ ************ ************
c     June 25, 1991.
c
c  initialisation of the ray tracing program
c
c ************ ************ ************ ************ ************
c
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
      use Vparam
      use Viogrl, ONLY: calfa, px, sumpx, bk, refl, rtot, trans, 
     1   aksupw, ddk, nnk, joutrf, ireout, jumpw, jtest, ispec, ngra, 
     2   itrans, radius, freqcy, heigth, isimm
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang, 
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec, 
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3, 
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti, 
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin, 
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril, 
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref, 
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep, 
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr, 
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite, 
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1, 
     1   gamene1, presfr, rplasm, iout, bzero, btsign, versid
      use Vcraylh
      use Vchpcsd, ONLY: irec, rec0, rec1, rec2, rec3, rec4, rec5, 
     1   rec6, rec7, rec8, rec9, rec10, rec11, rec12, rec13, rec14, 
     2   rec15, ndim, ind
      use Vcgraphs, ONLY: seikon, spsi, sxu, szu, skp, skpar, spower, 
     1   sdpwri, sphi, stheta, spol, sdkpar, scepx, scepy, scepz, 
     2   sztpol, sbtot, sene, salphac, salphal, sjslofa, serrors, 
     3   spkpsi, sakpsi, sakth, swkve, jjslofa, sne, ste, sqr, spw, 
     4   sxh, sqte, sni, sti, sdeqs, spwer, spwmax, srtor, srplas, 
     5   sdenc, stec, sqc, sqa, sbaxis, scurr, sfreq, satm, sazi, 
     6   sconc, stic, sxpage, sypage, slenx, sleny, sdelx, sfirtx, 
     7   sdely, sfirty, symax, symin, skth, skphi, skpsi, sxx, jslofas, 
     8   nurefls, keiks, jpes, jpis, istarts, iprmt5, jhlfs, isimpl, 
     9   isimpl0, ngr, nps, nspie, kgraph, kprof, newgra, jksym, 
     .   lintyp, nxvarb, nyvarb, kwfr
      use Vceqdsk, ONLY: ntitle, dat, ipestg, nxeqd, nzeqd, xdimeqd, 
     1   zdimeqd, reqd, redeqd, zmideqd, xma, zma, psimag, psilim, 
     2   beqd, toteqd, psimx1, psimx2, xax1, xax2, zax1, zax2, psisep, 
     3   xsep, zsep, feqd, presseqd, ffpeqd, ppeqd, peqd, qeqd, xeqd, 
     4   zeqd, psiadj, dpolflx, psieqd, tpsieqd, tpsifeqd, iounit1, 
     5   inoperm1, nptsdm1, nptsd, torflux, tpsisav, ra, psifra, 
     6   dpsifra, fra, fra1, cspln, pds, wnoperm, xcontr, zcontr, 
     7   bpcontr, btcontr, dstarp, b_fld, jacob, pprime, vprime, 
     8   chipsi, ncontr, dang, bperr, arcl, thet, anglex, csplnx, 
     9   csplnz, pdsx, pdsz, nlim, rlim, zlim, nlimiter, rlimiter, 
     .   zlimiter, lrz, nprim, nimp, nion, nti, zi, zeffz, r, raeqd, 
     1   psifeqd, te, ti, ti1, ene, enp, bmod, rmd, btmd, bpmd, btpmd, 
     2   roa, ieqdsk
      use Vcmnew, ONLY: wpi1c, wpi2c, wci1c, wci2c, wpi2, wci2, wci, 
     1   conci, aziomi, rtzom, ay2, ay1, trate, tratte, ttle, concte, 
     2   trati, tratti, ttli, concti, vdrfte, vdrfti, infi, gprm, cxet, 
     3   czt, cztp, czetai, czi, czip, czetat, czti, cztip, cth, npar, 
     4   nper, upar, uper, umax, dsfe, dsfi, fper2, fpar2, fpp2, intg, 
     5   inc, incf, tnmaxe, tnmaxi, idrive, binb, boutb, boutbrd, 
     6   binbrd, epsl, binbd, epsil, dlob, wte, eta0, eta, rprof, 
     7   amprof, cprof, xjop, vloop, kboot, mboot, btbsp, ftbsps, pde, 
     8   pdec, pdi, pdf, pwce, pwcm, pwcf, pwc, pwc1, pwc2, pwct, 
     9   pwct1, pwct2, pwc0, pwcray, pwc1ray, pwc2ray, pweray, pwiray, 
     .   pwfray, currf, currfe, currf1, currf2, curay, curay1, curay2, 
     1   fpwray, fpowe, fpowf, fpowi, pwte0, pwti0, effcd, effcdt, 
     2   ptot, ftpowe, ftpowi, ftpowf, ftpi, ftpf, ftedge, pwedge, 
     3   wfrac, pwxwl, frpowi, frpowf, frpow, pwit, pwft, ptedge, 
     4   ptot0, fpowt, tpowi, tpowf, wfrac0, ebkev, bmpwr, azf, atmf, 
     5   densa, kalfa, nalfa, nharm0, pnfi, pnf, zetab, tnf, ecrit, 
     6   taua0, wca, gamal, gamat, ibeam, abeam, dbeam, aneb, enbeam, 
     7   wbeam, temsa, ptfi, ttf, wpf2c, wpf2, wcf2c, wcf1c, wcf2, wcf, 
     8   cxc, czc, cy, denfa, eav, tausd, tau0, paf, sordt, ecrita, 
     9   betaf, nminor, y1c, yhc, wpe1c, wpe2c, wce1c, wce2c, rtmime,
     .   nsp1
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: j, k, i, n, l, nuk
      real::zpi,wlengt,ztot,thaper,zdth,zth0,arg10,zcos,znorm,zdk
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c------------ --------------
c   common blocks of Comiogrl
c---------------------------
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c
c   Comhpcsd
c
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c
c----------------------------
c   common blocks of Cmgraphs
c
 
c    2   ,sqti(nprofm)
c
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i
 
c
c------------------------------
c   August 5, 1991.
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1
 
 
c******      TKM   03/97, 09/99, 04/00, 06/00
c********************
 
c------------------------------
c
c ************ ************ ************ ************ ************
c
c
c ************ ************ ************ ************ ************
c
c     data    versid    /'version:052291 '/
c
      zpi = 4.0*atan(1.0E0)
c
c ************ ************ ************ ************ ************
c
      write (iout, 9999) versid
c
c ************ ************ ************ ************ ************
c
      istop = 0
c
      wlengt = 2.997925E8/freqcy
      omega = 2.*zpi*freqcy
c        ukzero is free space wavenumber  (m**-1).
      ukzero = 2.*zpi/wlengt
c
c ************ ************ ************ ************
c   Initialize plasma equilibrium.
c   plasma shape and dimensions
c   magnetic field on the magnetic axis
c ************ ************ ************ ************
c
      if (ieqdsk < 3) then
         ipropt = 0
         call metrin
      else if (ieqdsk<5 .and. ieqdsk>=3) then
         call fiteqdsk
      else
         call mhdebm
      endif
      if (ipropt == 1) call prontp
c-------------------------------------
c
c ************ ************ ************ ************
c  consistency and charge neutrality
c ************ ************ ************ ************
c
      if (nspec <= 5) then
         light = 1
         if (nspec <= 1) then
            mainsp = 1
         else
            if (mainsp > nspec) go to 9000
c*****************SCC 12/12/95
c  impose charge neutrality
c
            do j = 1, nprof
               ztot = sum(conc(j,:nspec)*azi(:nspec))
               conc(j,:nspec) = conc(j,:nspec)/ztot
               pni(j,:nspec) = pni(j,:nspec)/ztot
            end do
c
c        zden = 1.
c        ztmax = tempic(1)/atm(1)
c     do 20 i=1,nspec
c        ztm = tempic(i)/atm(i)
c     if(ztm.lt.ztmax)  goto 15
c        ztmax = ztm
c        light = i
c  15 if(i.eq.mainsp)  go to 20
c        zden = zden - azi(i)*aconc(i)
c  20 continue
c     if(zden.le.0.) go to 9100
c  30    aconc(mainsp) = zden/azi(mainsp)
c
         endif
         amime = 1836.12
c------------------------------
c 6/25/91
         rtmime = sqrt(amime)
c-----------------------------------
c
c        heta = 0.
c        zeff = 0.
c
c-----------------------------
c  7/2/91
         y2c = 2.343E-18*freqcy*freqcy/(bzero*bzero)
c******************************SCC   12/12/95
         xpc = 4.3906E4/(freqcy*freqcy)
c***********************************************
         y1c = sqrt(y2c)
c*********************************
         yhc = 6.5596E-8*freqcy/bzero*btsign
c********************************  SCC  12/12/95
         wpe2c = 8.06162E7/freqcy**2
c*******************************
         wce1c = 2.79927E10*btsign*bzero/freqcy
c******************************
         wce2c = wce1c**2
         atpi(:nspec) = azi(:nspec)*azi(:nspec)/atm(:nspec)
c        heta = heta + atpi(i)
c        zeff = zeff + azi(i)*azi(i)*aconc(i)
         xxi(:nspec) = atpi(:nspec)/atm(:nspec)
         aziomi(:nspec) = azi(:nspec)/atm(:nspec)
         rtzom(:nspec) = sqrt(aziomi(:nspec))
         ay2(:nspec) = aziomi(:nspec)**2*5.446E-4
         ay1(:nspec) = rtzom(:nspec)*2.334E-2
         wpi2c(:nspec) = xpc*azi(:nspec)**2/atm(:nspec)
         wpi1c(:nspec) = sqrt(wpi2c(:nspec))
c**********************************
         wci1c(:nspec)=1.52449E7*azi(:nspec)*bzero/(atm(:nspec)*freqcy)
c******************************
         wci2c(:nspec) = wci1c(:nspec)**2
         nsp1 = nspec - nminor
c$$$$   TK Mau      06/00
         if (nalfa > 0) then
            wpf2c(:nalfa) = xpc*azf(:nalfa)**2/atmf(:nalfa)
            wcf1c(:nalfa) = 1.52449E7*azf(:nalfa)*bzero/(atmf(:nalfa)*
     1         freqcy)
            wcf2c(:nalfa) = wcf1c(:nalfa)**2
         endif
c$$$$$$$$$$$$$$$
c-----------------------------------------------
c
c
c ************ ************ ************ ************
c  normalization and splines for the plasma profiles
c ************ ************ ************ ************
c
         call profin
c
         if (istop /= 0) return 
c
c ************ ************ ************ ************
c  initialization for power deposition profiles
c ************ ************ ************ ************
c
         if (igrill /= (-3)) then
            do i = 1, nspect
               if (nthin <= 1) then
                  thstrt(1,i) = thgril(i)
                  fpwth(1) = 1.
                  go to 250
               endif
               thaper = 180.*heigth/(100.*zpi*rplasm)
               zdth = thaper/float(nthin - 1)
               zth0 = thgril(i) - thaper/2.
               do n = 1, nthin
                  thstrt(n,i) = zth0 + float(n - 1)*zdth
c $$$$ Altered by TK Mau on 11/20/91
                  arg10 = zpi*(thstrt(n,i)-thgril(i))/180.
                  if (igrill /= (-2)) then
                     zcos = cos(arg10)
                  else
                     zcos = cos(ukzero*rplasm*arg10)
                  endif
c $$$$$$$$$$$$$$$$$$$$
                  fpwth(n) = zcos*zcos
               end do
            end do
c
            znorm = sum(fpwth(:nthin))
            fpwth(:nthin) = fpwth(:nthin)/znorm
c
  250       continue
            isimm = nspect
            if (thgril(1)==0. .or. thgril(1)==180.) then
               if (phase==0. .or. phase==180.) isimm = 1
            endif
            if (isimm == 1) nnkpar(2) = 0
            if (nnkpar(2) == 0) isimm = 1
            nnztot = 0
            nnztot = sum(nnkpar(:nspect))
c
c $$$$  Added by TK Mau on 11/22/91
c     if(igrill.eq.-2) go to 421
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
            do i = 1, isimm
               anzin(i,1) = anzinf(i)
               nuk = nnkpar(i)
               if (nuk > 1) then
                  zdk = (anzsup(i)-anzinf(i))/float(nuk - 1)
                  do n = 2, nuk
                     anzin(i,n) = anzinf(i) + float(n - 1)*zdk
                  end do
               endif
            end do
c $$$$  Added by TK Mau on 11/22/91
c 421 continue
c $$$$$$$$$$$$$$$$$$$$$$
c
            do i = 1, isimm
               nuk = nnkpar(i)
               pwtra(i,:nspray) = 0.
            end do
         else
c*************************
c  for igrill=-3; read in toroidal and poloidal spectrum
c   nspect is # kphi's
c   nnkpol(i=1:nspect) is # of kpol's in each kphi
c
c**************************
            do i = 1, nspect
               nnkpar(i) = 1
               if (nthin <= 1) then
                  thstrt(1,i) = thgril(i)
                  fpwth(1) = 1.
                  go to 450
               endif
               thaper = 180.*heigth/(100.*zpi*rplasm)
               zdth = thaper/float(nthin - 1)
               zth0 = thgril(i) - thaper/2.
               do n = 1, nthin
                  thstrt(n,i) = zth0 + float(n - 1)*zdth
                  arg10 = zpi*(thstrt(n,i)-thgril(i))/180.
c          zcos = cos(ukzero*rplasm*arg10)
                  zcos = cos(arg10)
                  fpwth(n) = zcos*zcos
               end do
            end do
            znorm = sum(fpwth(:nthin))
            fpwth(:nthin) = fpwth(:nthin)/znorm
c
  450       continue
            isimm = nspect
            nnztot = 0
            nnztot = sum(nnkpol(:nspect))
            do i = 1, isimm
               anzin(i,:nnkpol(i)) = (anzinf(i)+anzsup(i))/2.
               anplin(i,1) = anpinf(i)
               nuk = nnkpol(i)
               if (nuk > 1) then
                  poldk = (anpsup(i)-anpinf(i))/float(nuk - 1)
                  do j = 2, nuk
                     anplin(i,j) = anpinf(i) + float(j - 1)*poldk
                  end do
               endif
            end do
            pwtra(:isimm,:nspray) = 0.
 
         endif
         power = 0.0
         power = power + sum(powers(:isimm), mask=nnkpar(:isimm)>0)
c
c**bh      if(islofa.eq.-1)  igrill = 0
c
c**bh      if(nnztot.le.2)  igrill = 0
c
c ************ ************ ************ ************
c  initialisation of the output tables
c ************ ************ ************ ************
c
         pwtote = 0.
         pwtoti(:nspec) = 0.
         pwe(:nprof) = 0.
c $$$$$$$$$$$$$$$$$$$
c   8/5/91   T.K. Mau
         pwc(:nprof) = 0.
c $$$$$$$$$$$$$$$$$$$
         pwi(:nprof,:nspec) = 0.
c
c ************ ************ ************ ************
c  parameters for the integration
c ************ ************ ************ ************
c
c        accur = 1.e-5      (default put into var.br).
         ind = 1
c*******************************SCC 10/20/94
         ndim = 5
c********************************************
         precdy(:5) = 0.2
         precdy(6) = 0.
         dsteph = 0.2
c
c ************ ************ ************ ************
c  control of the printed and graphical output
c ************ ************ ************ ************
c
         if (iprint == 3) igraph = 0
         deykpr = 2.*zpi*deykpr
c
         if (nnztot/=1 .or. nthin<=1) then
            igraph = -igraph
            if (nnztot>ngdim .and. igraph/=0) igraph = -2
c
         endif
         return 
c
c ************ ************ ************ ************
c  failure diagnostics
c ************ ************ ************ ************
c
      endif
 9000 continue
      write (iout, 9990)
 9990 format('0',20x,"the plasma composition is inconsistent")
      go to 9900
 9980 format('0',20x,"charge neutrality cannot be satisfied")
 9999 format(1a40)
 
 9900 continue
      istop = 1
c
c ************ ************ ************ ************ ************
c
      return 
      end subroutine inital
c
      subroutine iniwfr
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:55:53   6/14/01  
C...Switches: -p4 -yb
c
c ************ ************ ************ ************ ************
c
c  initial wavefront - evaluation of k
c      the function psiwfr must be provided by the user:
c      psiwfr(theta,zdpsdt) = psi(theta) on the 1st wavefront
c      zdpsdt = d(psi)/d(theta)
c
c ************ ************ ************ ************ ************
c
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
      use Vparam
      use Viogrl
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang, 
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec, 
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3, 
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti, 
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin, 
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril, 
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref, 
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep, 
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr, 
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite, 
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1, 
     1   gamene1, presfr, iout
      use Vcraylh
      use Vchpcsd, ONLY: irec, rec0, rec1, rec2, rec3, rec4, rec5, 
     1   rec6, rec7, rec8, rec9, rec10, rec11, rec12, rec13, rec14, 
     2   rec15, y
      use Vcgraphs
      use Vceqdsk, ONLY: ntitle, dat, ipestg, nxeqd, nzeqd, xdimeqd, 
     1   zdimeqd, reqd, redeqd, zmideqd, xma, zma, psimag, psilim, 
     2   beqd, toteqd, psimx1, psimx2, xax1, xax2, zax1, zax2, psisep, 
     3   xsep, zsep, feqd, presseqd, ffpeqd, ppeqd, peqd, qeqd, xeqd, 
     4   zeqd, psiadj, dpolflx, psieqd, tpsieqd, tpsifeqd, iounit1, 
     5   inoperm1, nptsdm1, nptsd, torflux, tpsisav, ra, psifra, 
     6   dpsifra, fra, fra1, cspln, pds, wnoperm, xcontr, zcontr, 
     7   bpcontr, btcontr, dstarp, b_fld, jacob, pprime, vprime, 
     8   chipsi, ncontr, dang, bperr, arcl, thet, anglex, csplnx, 
     9   csplnz, pdsx, pdsz, nlim, rlim, zlim, nlimiter, rlimiter, 
     .   zlimiter, lrz, nprim, nimp, nion, nti, zi, zeffz, r, raeqd, 
     1   psifeqd, te, ti, ti1, ene, enp, bmod, rmd, btmd, bpmd, btpmd, 
     2   roa
      use Vcmnew, ONLY: wpi1c, wpi2c, wci1c, wci2c, wpi2, wci2, wci, 
     1   conci, aziomi, rtzom, ay2, ay1, trate, tratte, ttle, concte, 
     2   trati, tratti, ttli, concti, vdrfte, vdrfti, infi, gprm, cxet, 
     3   czt, cztp, czetai, czi, czip, czetat, czti, cztip, cth, npar, 
     4   nper, upar, uper, umax, dsfe, dsfi, fper2, fpar2, fpp2, intg, 
     5   inc, incf, tnmaxe, tnmaxi, idrive, binb, boutb, boutbrd, 
     6   binbrd, epsl, binbd, epsil, dlob, wte, eta0, eta, rprof, 
     7   amprof, cprof, xjop, vloop, kboot, mboot, btbsp, ftbsps, pde, 
     8   pdec, pdi, pdf, pwce, pwcm, pwcf, pwc, pwc1, pwc2, pwct, 
     9   pwct1, pwct2, pwc0, pwcray, pwc1ray, pwc2ray, pweray, pwiray, 
     .   pwfray, currf, currfe, currf1, currf2, curay, curay1, curay2, 
     1   fpwray, fpowe, fpowf, fpowi, pwte0, pwti0, effcd, effcdt, 
     2   ptot, ftpowe, ftpowi, ftpowf, ftpi, ftpf, ftedge, pwedge, 
     3   wfrac, pwxwl, frpowi, frpowf, frpow, pwit, pwft, ptedge, 
     4   ptot0, fpowt, tpowi, tpowf, wfrac0, ebkev, bmpwr, azf, atmf, 
     5   densa, kalfa, nalfa, nharm0, pnfi, pnf, zetab, tnf, ecrit, 
     6   taua0, wca, gamal, gamat, ibeam, abeam, dbeam, aneb, enbeam, 
     7   wbeam, temsa, ptfi, ttf, wpf2c, wpf2, wcf2c, wcf1c, wcf2, wcf, 
     8   cxc, czc, cy, denfa, eav, tausd, tau0, paf, sordt, ecrita, 
     9   betaf, psi0
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: itipsi, niter
      real :: zdpsdt, zdiscr, zroot1, zroot2, zpkp2f, zpkp2s, zpkp2, 
     1   zsinz, zcosz, znormz, za, zb, zc, zdiff, zkappa, zdkp2, pkpsi2
     2   , pwinit
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real , EXTERNAL :: psiwfr
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c
c   Comhpcsd
c
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i
 
c
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1
 
 
c******      TKM   03/97, 09/99, 04/00, 06/00
c********************
 
c
c ************ ************ ************ ************ ************
c
      istart = 0
      itipsi = 0
c
c ************ ************ ************ ************ ************
c  initial position along the ray
c ************ ************ ************ ************ ************
c
      psi = psiwfr(theta,zdpsdt)
c
   10 continue
      y(2) = psi
      y(4) = theta
c
      call coords
c
      call profix
c
c $$$$  Altered by TK Mau on 11/20/91   SC Chiu 1/26/94
      if (igrill == (-3)) then
         pkpar = pktau*asintq + pkphi*acostq
         pkheta = pktau*acostq - pkphi*asintq
      else
         if (igrill == (-2)) then
            pkpar = pkphi*acostq
         else
            pkphi = pkpar/acostq
         endif
      endif
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      pkpar2 = pkpar*pkpar
      anphi = pkphi*urhs
c
      call disper (0)
c
      zdiscr = hb*hb - 4.*ha*hc
c
      if (zdiscr > 0.) then
c
         zroot1 = 0.5*(hb + sqrt(zdiscr))/ha
         zroot2 = 0.5*(hb - sqrt(zdiscr))/ha
c
c ************ ************ ************ ************ ************
c  choice of the wave
c ************ ************ ************ ************ ************
c
c     ha is taken to be equal to Stix's s.  ha.lt.0 corresponds to
c     freqcy .gt. the LH frequency.  If ha.gt.0, only the fast wave
c     is possibly propagating.
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c    August 9, 1991   T.K. Mau
         if (ichois /= 1) then
            if (abs(zroot1) < abs(zroot2)) then
               zpkp2f = zroot1
               zpkp2s = zroot2
            else
               zpkp2f = zroot2
               zpkp2s = zroot1
            endif
         else
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
            if (ha >= 0.) then
               zpkp2s = amax1(zroot1,zroot2)
               zpkp2f = amin1(zroot1,zroot2)
            else
               zpkp2s = amin1(zroot1,zroot2)
               zpkp2f = amax1(zroot1,zroot2)
            endif
         endif
c
         if (islofa <= 0) then
            if (islofa == 0) go to 9050
            zpkp2 = zpkp2f
         else
            zpkp2 = zpkp2s
c
         endif
         if (zpkp2>=1 .or. ichois==1) then
            if (zpkp2 >= 5.) then
c
c ************ ************ ************ ************ ************
c  exact evaluation of the initial value of kpsi & ktheta
c ************ ************ ************ ************ ************
c
               zsinz = -aj*zdpsdt
               zcosz = antau*antau + ag*zdpsdt
               znormz = sqrt(zsinz*zsinz + zcosz*zcosz)
               zsinz = zsinz/znormz
               zcosz = zcosz/znormz
               za = zcosz*zcosz + zsinz*zsinz*acostq*acostq
               zb = zsinz*acostq*asintq*pkphi
c
               pkp2 = zpkp2
               if (igrill /= (-3)) then
                  do niter = 1, 100
                     zc = pkphi*pkphi*asintq*asintq - pkp2
                     zdiff = zb*zb - za*zc
c
                     if (zdiff <= 0.) go to 9030
                     zkappa = ((-zb) + sqrt(zdiff))/za
                     pkpsi = float(islofa)*abs(zkappa*zcosz)
                     pktau = zkappa*zsinz
                     akpsi = (aj*pkpsi + ag*pktau)/antau
                     akth = antau*pktau
c
                     call wavect
c
                     call disper (0)
c
                     zdkp2 = disph/dhkp2
                     if (abs(zdkp2/pkp2) < 0.1*accur) go to 60
                     pkp2 = pkp2 - zdkp2
                  end do
c -------------------------------------
c  accuracy not obtained
                  go to 9040
c -------------------------------------
               endif
               pkpsi2 = pkp2 - pkheta*pkheta
               if (pkpsi2 <= 0.) go to 100
c----------------SCC  6/26/95
c     pkpsi=-sqrt(pkpsi2)
               pkpsi = float(islofa)*sqrt(pkpsi2)
c-----------------------
               akpsi = (aj*pkpsi + ag*pktau)/antau
               akth = antau*pktau
   60          continue
               istart = 1
               y(1) = akpsi
               y(3) = akth
               y(5) = phi
               pwinit = pwx
               y(6) = alog(pwinit)
c
c ************ ************ ************ ************ ************
c
               return 
c
c ************ ************ ************ ************ ************
c
            endif
         endif
      endif
  100 continue
      if (itipsi > 6) go to 9000
      itipsi = itipsi + 1
      psi = psi - 0.05
      go to 10
c -------------------------------------
 9000 continue
      if (zdiscr <= 0.) then
c
         write (iout, 9910)
 9910    format('0',5x,"roots of the cold plasma dispersion relation",
     1      " not real",/6x,"starting point beyond confluence")
         return 
c -------------------------------------
      endif
      write (iout, 9920) psi, zpkp2
 9920 format('0',5x,"starting point too close to the p-cutoff",/16x,
     1   "psi =",f10.4," pkp2 =",e13.4)
      return 
c -------------------------------------
 9030 continue
      write (iout, 9930) psi, pkp2, zpkp2
 9930 format('0',5x,"starting point too close to the r-cutoff",/16x,
     1   "psi =",f10.4," pkp2 =",e13.4," qf2 =",e13.4)
      return 
c -------------------------------------
 9040 continue
      write (iout, 9940) pkp2, zdkp2, disph
 9940 format('0',5x,"search for the initial n perp not convergent",/6x,
     1   "last values: kp2 =",e14.4,"  dkp2 =",e14.4,"  disph =",e14.4)
      return 
c -------------------------------------
 9050 continue
      write (iout, 9950)
 9950 format('0',5x,"type of radiated wave not specified")
      return 
c
c ************ ************ ************ ************ ************
c
      end subroutine iniwfr
      function psiwfr (ztheta, dpsdth)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:55:53   6/14/01  
C...Switches: -p4 -yb
c ************ ************ ************ ************
c  shape of the initial wavefront:
c           psiwfr = psi(theta)
c           dpsdth = d(psi)/d(theta)
c ************ ************ ************ ************
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
      use Vparam
      use Viogrl
      use Viorlh
      use Vcraylh
      use Vchpcsd
      use Vcgraphs
      use Vceqdsk
      use Vcmnew, ONLY: wpi1c, wpi2c, wci1c, wci2c, wpi2, wci2, wci, 
     1   conci, aziomi, rtzom, ay2, ay1, trate, tratte, ttle, concte, 
     2   trati, tratti, ttli, concti, vdrfte, vdrfti, infi, gprm, cxet, 
     3   czt, cztp, czetai, czi, czip, czetat, czti, cztip, cth, npar, 
     4   nper, upar, uper, umax, dsfe, dsfi, fper2, fpar2, fpp2, intg, 
     5   inc, incf, tnmaxe, tnmaxi, idrive, binb, boutb, boutbrd, 
     6   binbrd, epsl, binbd, epsil, dlob, wte, eta0, eta, rprof, 
     7   amprof, cprof, xjop, vloop, kboot, mboot, btbsp, ftbsps, pde, 
     8   pdec, pdi, pdf, pwce, pwcm, pwcf, pwc, pwc1, pwc2, pwct, 
     9   pwct1, pwct2, pwc0, pwcray, pwc1ray, pwc2ray, pweray, pwiray, 
     .   pwfray, currf, currfe, currf1, currf2, curay, curay1, curay2, 
     1   fpwray, fpowe, fpowf, fpowi, pwte0, pwti0, effcd, effcdt, 
     2   ptot, ftpowe, ftpowi, ftpowf, ftpi, ftpf, ftedge, pwedge, 
     3   wfrac, pwxwl, frpowi, frpowf, frpow, pwit, pwft, ptedge, 
     4   ptot0, fpowt, tpowi, tpowf, wfrac0, ebkev, bmpwr, azf, atmf, 
     5   densa, kalfa, nalfa, nharm0, pnfi, pnf, zetab, tnf, ecrit, 
     6   taua0, wca, gamal, gamat, ibeam, abeam, dbeam, aneb, enbeam, 
     7   wbeam, temsa, ptfi, ttf, wpf2c, wpf2, wcf2c, wcf1c, wcf2, wcf, 
     8   cxc, czc, cy, denfa, eav, tausd, tau0, paf, sordt, ecrita, 
     9   betaf, psi0
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real psiwfr
      real ztheta, dpsdth
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1
 
 
c******      TKM   03/97, 09/99, 04/00, 06/00
c********************
 
      psiwfr = psi0
      dpsdth = 0.
      return 
      end function psiwfr
      subroutine pwicpl
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:55:53   6/14/01  
C...Switches: -p4 -yb
c
c ************ ************ ************ ************ ************
c
c interface subroutine for coupling the grill code to ray tracing
c
c ************ ************ ************ ************ ************
c
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
      use Vparam
      use Viogrl, ONLY: calfa, px, sumpx, bk, refl, rtot, trans, 
     1   aksupw, ddk, nnk, joutrf, ireout, jumpw, jtest, ispec, ngra, 
     2   itrans, radius, isimm
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang, 
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec, 
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3, 
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti, 
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin, 
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril, 
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref, 
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep, 
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr, 
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite, 
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1, 
     1   gamene1, presfr
      use Vcraylh
      use Vchpcsd
      use Vcgraphs
      use Vceqdsk
      use Vcmnew
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, nk, jk, i1, i2, j
      real::zpi,zfact,zdk,ak,ak1,ak2,anwdth,an0,dan,anorm,anp
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c------------ --------------
c   common blocks of Comiogrl
c---------------------------
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c
      data zpi/3.14159265359/
c ************ ************ ************ ************ ************
c
      if (igrill > 0) then
         igrill = 0
         ispec = 1
         if (igraph == 0) ngra = 0
c
c ********** ********** ********** ********** ********** **********
c
c call to the grill code and transfer of the spectre
c
c ********** ********** ********** ********** ********** **********
c
         call grill
c
c ********** ********** ********** ********** ********** **********
c
         zfact = power
         if (isimm == 1) zfact = 2.*zfact
         do i = 1, isimm
            nk = nnkpar(i)
            if (nk /= 0) then
               zdk = anzin(i,2) - anzin(i,1)
               do jk = 1, nk
                  ak = anzin(i,jk)
                  ak1 = ak - zdk/2.
                  ak2 = ak + zdk/2.
                  i1 = ifix((ak1 - 1.)/ddk(i)) + 1
                  i2 = ifix((ak2 - 1.)/ddk(i)) + 1
                  pwcpl(i,jk) = zfact*(sumpx(i,i2)-sumpx(i,i1))
               end do
            endif
         end do
c
c ********** ********** ********** ********** ********** **********
c
         return 
c
c ********** ********** ********** ********** ********** **********
c
      endif
      if (igrill /= (-3)) then
         if (igrill == 0) then
            do i = 1, isimm
               nk = nnkpar(i)
               if (nk /= 0) then
                  pwcpl(i,:nk) = powers(i)/float(nk)
               endif
            end do
c $$$$  altered by TK Mau on 11/21/91
         else
c     if(igrill.eq.-1) then
c $$$$$$$$$$$$$$$$$$$$$$$$$$$
            do i = 1, isimm
               nk = nnkpar(i)
               if (nk /= 0) then
c$$$$$$$$$$$$$$$   scc 3/19/92
                  anwdth = 2.*zpi/abs(anzsup(i)-anzinf(i))*specfac
                  an0 = 0.5*(anzinf(i)+anzsup(i))
c$$$$$$$$$$$$$$$$$$$$  scc 3/19/92
                  if (nk == 1) then
                     dan = (anzsup(i)-anzinf(i))/nk
                  else
                     dan = (anzsup(i)-anzinf(i))/(nk - 1.)
                  endif
                  anorm = 0.0
                  do j = 1, nk
c$$$$$$$$$$$$$$$  scc  3/19/92
                     anp = anzinf(i) + (j - 1.)*dan
c**            pwcpl(i,j) = sin(anwdth*(anp-an0))**2/
c**       1             anp**2/abs(anp**2-1.)**(2./3.)
                     if (anp /= an0) then
                        pwcpl(i,j) = sin(anwdth*(anp - an0))**2/(anp - 
     1                     an0)**2
                     else
                        if (anwdth /= 0.) then
                           pwcpl(i,j) = anwdth**2
                        else
                           pwcpl(i,j) = 1.0
                        endif
                     endif
                     anorm = anorm + pwcpl(i,j)
                  end do
                  pwcpl(i,:nk) = pwcpl(i,:nk)/anorm*powers(i)
c**            pwcpl(i,j) = sin(anwdth*(anp-an0))**2/
c**       1             anp**2/abs(anp**2-1.)**(2./3.)
               endif
            end do
c $$$$$  Added by TK Mau on 11/21/91
c     else
c     do 521 i=1,isimm
c     nk = nnkpar(i)
c     if(nk.eq.0) go to 521
c     anorm = 0.0
c     do 531 j=1,nk
c     anorm = anorm+pwcpl(i,j)
c 531 continue
c     do 541 j=1,nk
c     pwcpl(i,j)=pwcpl(i,j)/anorm*powers(i)
c 541 continue
c 521 continue
c     endif
c $$$$$$$$$$$$$$$$$$$$$$$
         endif
         return 
c
c
      endif
      do i = 1, isimm
         nk = nnkpol(i)
         if (nk /= 0) then
c$$$$$$$$$$$$$$$   scc 3/19/92
            if (anpinf(i) == anpsup(i)) then
               anwdth = 2.*zpi
               go to 305
            endif
            anwdth = 2.*zpi/abs(anpsup(i)-anpinf(i))*specfac
  305       continue
            an0 = 0.5*(anpinf(i)+anpsup(i))
c$$$$$$$$$$$$$$$$$$$$  scc 3/19/92
            if (nk == 1) then
               dan = (anpsup(i)-anpinf(i))/nk
            else
               dan = (anpsup(i)-anpinf(i))/(nk - 1.)
            endif
            anorm = 0.0
            do j = 1, nk
c$$$$$$$$$$$$$$$  scc  3/19/92
               anp = anpinf(i) + (j - 1.)*dan
c**            pwcpl(i,j) = sin(anwdth*(anp-an0))**2/
c**       1             anp**2/abs(anp**2-1.)**(2./3.)
               if (anp /= an0) then
                  pwcpl(i,j) = sin(anwdth*(anp - an0))**2/(anp - an0)**2
               else
                  if (anwdth /= 0.) then
                     pwcpl(i,j) = anwdth**2
                  else
                     pwcpl(i,j) = 1.0
                  endif
               endif
               anorm = anorm + pwcpl(i,j)
            end do
            pwcpl(i,:nk) = pwcpl(i,:nk)/anorm*powers(i)
c**            pwcpl(i,j) = sin(anwdth*(anp-an0))**2/
c**       1             anp**2/abs(anp**2-1.)**(2./3.)
         endif
      end do
c
c ********** ********** ********** ********** ********** **********
c
      return 
c
c ********** ********** ********** ********** ********** **********
c
      end subroutine pwicpl
      subroutine tmpdata(ientry)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:55:53   6/14/01  
C...Switches: -p4 -yb
c
c ************ ************ ************ ************ ************
c
c Temprarily store the absorption and driven current in 'wkarea'
c
c
c ************ ************ ************ ************ ************
c
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
      use Vparam
      use Viogrl, ONLY: calfa, px, sumpx, bk, refl, rtot, trans, 
     1   aksupw, ddk, nnk, joutrf, ireout, jumpw, jtest, ispec, ngra, 
     2   itrans, radius, isimm
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang, 
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec, 
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3, 
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti, 
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin, 
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril, 
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref, 
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep, 
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr, 
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite, 
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1, 
     1   gamene1, presfr
      use Vcraylh
      use Vchpcsd, ONLY: irec, rec0, rec1, rec2, rec3, rec4, rec5, 
     1   rec6, rec7, rec8, rec9, rec10, rec11, rec12, rec13, rec14, 
     2   rec15
      use Vcgraphs, ONLY: seikon, spsi, sxu, szu, skp, skpar, spower, 
     1   sdpwri, sphi, stheta, spol, sdkpar, scepx, scepy, scepz, 
     2   sztpol, sbtot, sene, salphac, salphal, sjslofa, serrors, 
     3   spkpsi, sakpsi, sakth, swkve, jjslofa, sne, ste, sqr, spw, 
     4   sxh, sqte, sni, sti, sdeqs, spwer, spwmax, srtor, srplas, 
     5   sdenc, stec, sqc, sqa, sbaxis, scurr, sfreq, satm, sazi, 
     6   sconc, stic, sxpage, sypage, slenx, sleny, sdelx, sfirtx, 
     7   sdely, sfirty, symax, symin, skth, skphi, skpsi, sxx, jslofas, 
     8   nurefls, keiks, jpes, jpis, istarts, iprmt5, jhlfs, isimpl, 
     9   isimpl0, ngr, nps, nspie, kgraph, kprof, newgra, jksym, 
     .   lintyp, nxvarb, nyvarb, kwfr
      use Vceqdsk
      use Vcmnew, ONLY: wpi1c, wpi2c, wci1c, wci2c, wpi2, wci2, wci, 
     1   conci, aziomi, rtzom, ay2, ay1, trate, tratte, ttle, concte, 
     2   trati, tratti, ttli, concti, vdrfte, vdrfti, infi, gprm, cxet, 
     3   czt, cztp, czetai, czi, czip, czetat, czti, cztip, cth, npar, 
     4   nper, upar, uper, umax, dsfe, dsfi, fper2, fpar2, fpp2, intg, 
     5   inc, incf, tnmaxe, tnmaxi, idrive, binb, boutb, boutbrd, 
     6   binbrd, epsl, binbd, epsil, dlob, wte, eta0, eta, rprof, 
     7   amprof, cprof, xjop, vloop, kboot, mboot, btbsp, ftbsps, pde, 
     8   pdec, pdi, pdf, pwce, pwcm, pwcf, pwc, pwc1, pwc2, pwct, 
     9   pwct1, pwct2, pwc0, pwcray, pwc1ray, pwc2ray, pweray, pwiray, 
     .   pwfray, currf, currfe, currf1, currf2, curay, curay1, curay2, 
     1   fpwray, fpowe, fpowf, fpowi, pwte0, pwti0, effcd, effcdt, 
     2   ptot, ftpowe, ftpowi, ftpowf, ftpi, ftpf, ftedge, pwedge, 
     3   wfrac, pwxwl, frpowi, frpowf, frpow, pwit, pwft, ptedge, 
     4   ptot0, fpowt, tpowi, tpowf, wfrac0, ebkev, bmpwr, azf, atmf, 
     5   densa, kalfa, nalfa, nharm0, pnfi, pnf, zetab, tnf, ecrit, 
     6   taua0, wca, gamal, gamat, ibeam, abeam, dbeam, aneb, enbeam, 
     7   wbeam, temsa, ptfi, ttf, wpf2c, wpf2, wcf2c, wcf1c, wcf2, wcf, 
     8   cxc, czc, cy, denfa, eav, tausd, tau0, paf, sordt, ecrita, 
     9   betaf
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer ientry
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, j
      real :: tmp1, tmp2
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c------------ --------------
c   common blocks of Comiogrl
c---------------------------
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c
c   Comhpcsd
c
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c
c----------------------------
c   common blocks of Cmgraphs
c
 
c    2   ,sqti(nprofm)
c
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1
 
 
c******      TKM   03/97, 09/99, 04/00, 06/00
c********************
 
c
c ************ ************ ************ ************ ************
c
c
      select case (ientry) 
      case default
c
c   zero out wkarea
c
         wkarea(:nprofm,:nwka) = 0.
         return 
      case (2) 
c
c    Store absorption and j profiles in wkarea
         wkarea(:nprof,1) = pwe(:nprof) + wkarea(:nprof,1)
         wkarea(:nprof,2) = pwev(1:nprof) + wkarea(:nprof,2)
         wkarea(:nprof,3) = pwit(:nprof) + wkarea(:nprof,3)
         wkarea(:nprof,4) = pwc(:nprof) + wkarea(:nprof,4)
         wkarea(:nprof,5) = pwct(:nprof) + wkarea(:nprof,5)
         wkarea(:nprof,6:nspec+5) = pwi(:nprof,:nspec) + wkarea(:nprof,6
     1      :nspec+5)
         wkarea(:nprof,6+nspec:2*nspec+5) = pwiv(1:nprof,:nspec) + 
     1      wkarea(:nprof,6+nspec:2*nspec+5)
         tmp1 = ptot0 + wkarea(1,nwka)
         wkarea(2,nwka) = (fpowt*ptot0 + wkarea(1,nwka)*wkarea(2,nwka))/
     1      tmp1
         wkarea(3,nwka) = (ftpowe*ptot0 + wkarea(1,nwka)*wkarea(3,nwka))
     1      /tmp1
         wkarea(4,nwka) = (ftpi*ptot0 + wkarea(1,nwka)*wkarea(4,nwka))/
     1      tmp1
         wkarea(5,nwka) = (ftedge*ptot0 + wkarea(1,nwka)*wkarea(5,nwka))
     1      /tmp1
         wkarea(6,nwka) = currf + wkarea(6,nwka)
         wkarea(7,nwka) = wkarea(6,nwka)/tmp1
         wkarea(1,nwka) = tmp1
         return 
      case (3) 
c
c   Sum the contribution of all RF sources
c
         pwe(:nprof) = pwe(:nprof) + wkarea(:nprof,1)
         pwev(1:nprof) = pwev(1:nprof) + wkarea(:nprof,2)
         pwit(:nprof) = pwit(:nprof) + wkarea(:nprof,3)
         pwc(:nprof) = pwc(:nprof) + wkarea(:nprof,4)
         pwct(:nprof) = pwct(:nprof) + wkarea(:nprof,5)
         pwi(:nprof,:nspec)=pwi(:nprof,:nspec)+wkarea(:nprof,6:nspec+5)
         pwiv(1:nprof,:nspec) = pwiv(1:nprof,:nspec) + wkarea(:nprof,6+
     1      nspec:2*nspec+5)
         tmp1 = ptot0 + wkarea(1,nwka)
         fpowt = (fpowt*ptot0 + wkarea(1,nwka)*wkarea(2,nwka))/tmp1
         ftpowe = (ftpowe*ptot0 + wkarea(1,nwka)*wkarea(3,nwka))/tmp1
         ftpi = (ftpi*ptot0 + wkarea(1,nwka)*wkarea(4,nwka))/tmp1
         ftedge = (ftedge*ptot0 + wkarea(1,nwka)*wkarea(5,nwka))/tmp1
         currf = currf + wkarea(6,nwka)
         effcdt = currf/tmp1
         ptot0 = tmp1
         return 
c
c
      case (4) 
c
c   ptot0 is total input power in MW
c   here powers(isimm) will be renormalized to ptot0
c
         tmp1 = 0.
         tmp1 = sum(powers(:isimm))
         tmp2 = ptot0/tmp1
         powers(:isimm) = powers(:isimm)*tmp2
         return 
      case (5) 
         call outrun (1)
         return 
c
      case (6) 
         call outrun (4)
c
         return 
      end select
      end subroutine tmpdata

C   IMSL ROUTINE NAME   - ICSEVU
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JANUARY 1, 1978
C
C   PURPOSE             - EVALUATION OF A CUBIC SPLINE
C
C   USAGE               - CALL ICSEVU(X,Y,NX,C,IC,U,S,M,IER)
C
C   ARGUMENTS    X      - VECTOR OF LENGTH NX CONTAINING THE ABSCISSAE
C                           OF THE NX DATA POINTS (X(I),Y(I)) I=1,...,
C                           NX (INPUT). X MUST BE ORDERED SO THAT
C                           X(I) .LT. X(I+1).
C                Y      - VECTOR OF LENGTH NX CONTAINING THE ORDINATES
C                           (OR FUNCTION VALUES) OF THE NX DATA POINTS
C                           (INPUT).
C                NX     - NUMBER OF ELEMENTS IN X AND Y (INPUT).
C                           NX MUST BE .GE. 2.
C                C      - SPLINE COEFFICIENTS (INPUT). C IS AN NX-1 BY
C                           3 MATRIX.
C                IC     - ROW DIMENSION OF MATRIX C EXACTLY AS
C                           SPECIFIED IN THE DIMENSION STATEMENT
C                           IN THE CALLING PROGRAM (INPUT).
C                           IC MUST BE .GE. NX-1.
C                U      - VECTOR OF LENGTH M CONTAINING THE ABSCISSAE
C                           OF THE M POINTS AT WHICH THE CUBIC SPLINE
C                           IS TO BE EVALUATED (INPUT).
C                S      - VECTOR OF LENGTH M (OUTPUT).
C                           THE VALUE OF THE SPLINE APPROXIMATION AT
C                           U(I) IS
C                           S(I) = ((C(J,3)*D+C(J,2))*D+C(J,1))*D+Y(J)
C                           WHERE X(J) .LE. U(I) .LT. X(J+1) AND
C                           D = U(I)-X(J).
C                M      - NUMBER OF ELEMENTS IN U AND S (INPUT).
C                IER    - ERROR PARAMETER (OUTPUT).
C                         WARNING ERROR
C                           IER = 33, U(I) IS LESS THAN X(1).
C                           IER = 34, U(I) IS GREATER THAN X(NX).
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   REMARKS  1.  THE ROUTINE ASSUMES THAT THE ABSCISSAE OF THE NX
C                DATA POINTS ARE ORDERED SUCH THAT X(I) IS LESS THAN
C                X(I+1) FOR I=1,...,NX-1. NO CHECK OF THIS CONDITION
C                IS MADE IN THE ROUTINE. UNORDERED ABSCISSAE WILL CAUSE
C                THE ALGORITHM TO PRODUCE INCORRECT RESULTS.
C            2.  THE ROUTINE GENERATES TWO WARNING ERRORS. ONE ERROR
C                OCCURS IF U(I) IS LESS THAN X(1), FOR SOME I IN THE
C                THE INTERVAL (1,M) INCLUSIVELY. THE OTHER ERROR OCCURS
C                IF U(I) IS GREATER THAN X(NX), FOR SOME I IN THE
C                INTERVAL (1,M) INCLUSIVELY.
C            3.  THE ORDINATE Y(NX) IS NOT USED BY THE ROUTINE. FOR
C                U(K) .GT. X(NX-1), THE VALUE OF THE SPLINE, S(K), IS
C                GIVEN BY
C                 S(K)=((C(NX-1,3)*D+C(NX-1,2))*D+C(NX-1,1))*D+Y(NX-1)
C                WHERE D=U(K)-X(NX-1).
C
C   COPYRIGHT           - 1978 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE ICSEVU  (X,Y,NX,C,IC,U,S,M,IER)
C                                  SPECIFICATIONS FOR ARGUMENTS
      INTEGER            NX,IC,M,IER
      REAL               X(NX),Y(NX),C(IC,3),U(M),S(M)
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      INTEGER            I,JER,KER,NXM1,K
      REAL               D,DD,ZERO
      DATA               I/1/,ZERO/0.0/
C                                  FIRST EXECUTABLE STATEMENT
      JER = 0
      KER = 0
      IF (M .LE. 0) GO TO 9005
      NXM1 = NX-1
      IF (I .GT. NXM1) I = 1
C                                  EVALUATE SPLINE AT M POINTS
      DO 40 K=1,M
C                                  FIND THE PROPER INTERVAL
         D = U(K)-X(I)
         IF (D) 5,25,15
    5    IF (I .EQ. 1) GO TO 30
         I = I-1
         D = U(K)-X(I)
         IF (D) 5,25,20
   10    I = I+1
         D = DD
   15    IF (I .GE. NX) GO TO 35
         DD = U(K)-X(I+1)
         IF (DD .GE. ZERO) GO TO 10
         IF (D .EQ. ZERO) GO TO 25
C                                  PERFORM EVALUATION
   20    S(K) = ((C(I,3)*D+C(I,2))*D+C(I,1))*D+Y(I)
         GO TO 40
   25    S(K) = Y(I)
         GO TO 40
C                                  WARNING - U(I) .LT. X(1)
   30    JER = 33
         GO TO 20
C                                  IF U(I) .GT. X(NX) - WARNING
   35    IF (DD .GT. ZERO) KER = 34
         D = U(K)-X(NXM1)
         I = NXM1
         GO TO 20
   40 CONTINUE
      IER = MAX0(JER,KER)
 9000 CONTINUE
      IF (JER .GT. 0) CALL UERTST(JER,'ICSEVU')
      IF (KER .GT. 0) CALL UERTST(KER,'ICSEVU')
 9005 RETURN
      END

#include "fpreproc/library_names.h"
#include "fpreproc/f77_dcomplx.h"
#include "fpreproc/fp_const.h"
*DECK DBESK1
       FUNCTION DBESK1 (X)
C***BEGIN PROLOGUE  DBESK1
C***PURPOSE  Compute the modified (hyperbolic) Bessel function of the
C            third kind of order one.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C10B1
C***TYPE      REAL*8 (BESK1-S, DBESK1-D)
C***KEYWORDS  FNLIB, HYPERBOLIC BESSEL FUNCTION,
C             MODIFIED BESSEL FUNCTION, ORDER ONE, SPECIAL FUNCTIONS,
C             THIRD KIND
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DBESK1(X) calculates the double precision modified (hyperbolic)
C Bessel function of the third kind of order one for double precision
C argument X.  The argument must be large enough that the result does
C not overflow and small enough that the result does not underflow.
C
C Series for BK1        on the interval  0.          to  4.00000E+00
C                                        with weighted error   9.16E-32
C                                         log weighted error  31.04
C                               significant figures required  30.61
C                                    decimal places required  31.64
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, DBESI1, DBSK1E, DCSEVL, INITDS, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C***END PROLOGUE  DBESK1
C============
C idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER ntk1,initds
C============
      REAL*8 DBESK1
      REAL*8 X, BK1CS(16), XMAX, XMAXT, XMIN, XSML, Y,
     1  D1MACH, DCSEVL, DBESI1, DBSK1E
      LOGICAL FIRST
      SAVE BK1CS, NTK1, XMIN, XSML, XMAX, FIRST
      DATA BK1CS(  1) / +CONST(.25300227338947770532531120868533,-1)/
      DATA BK1CS(  2) / -CONST(.35315596077654487566723831691801,+0)/
      DATA BK1CS(  3) / -CONST(.12261118082265714823479067930042,+0)/
      DATA BK1CS(  4) / -CONST(.69757238596398643501812920296083,-2)/
      DATA BK1CS(  5) / -CONST(.17302889575130520630176507368979,-3)/
      DATA BK1CS(  6) / -CONST(.24334061415659682349600735030164,-5)/
      DATA BK1CS(  7) / -CONST(.22133876307347258558315252545126,-7)/
      DATA BK1CS(  8) / -CONST(.14114883926335277610958330212608,-9)/
      DATA BK1CS(  9) / -CONST(.66669016941993290060853751264373,-12)/
      DATA BK1CS( 10) / -CONST(.24274498505193659339263196864853,-14)/
      DATA BK1CS( 11) / -CONST(.70238634793862875971783797120000,-17)/
      DATA BK1CS( 12) / -CONST(.16543275155100994675491029333333,-19)/
      DATA BK1CS( 13) / -CONST(.32338347459944491991893333333333,-22)/
      DATA BK1CS( 14) / -CONST(.53312750529265274999466666666666,-25)/
      DATA BK1CS( 15) / -CONST(.75130407162157226666666666666666,-28)/
      DATA BK1CS( 16) / -CONST(.91550857176541866666666666666666,-31)/
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DBESK1
      IF (FIRST) THEN
         NTK1 = INITDS (BK1CS, 16, CONST(0.1,0)*AREAL(D1MACH(3)))
         XMIN = EXP(MAX(LOG(D1MACH(1)), -LOG(D1MACH(2))) +
     +      CONST(0.01,0))
         XSML = SQRT(CONST(4.0,0)*D1MACH(3))
         XMAXT = -LOG(D1MACH(1))
         XMAX = XMAXT - CONST(0.5,0)*XMAXT*LOG(XMAXT)/
     +      (XMAXT+CONST(0.5,0))
      ENDIF
      FIRST = .FALSE.
C
      IF (X .LE. CONST(0.,0)) CALL XERMSG ('SLATEC', 'DBESK1',
     +   'X IS ZERO OR NEGATIVE', 2, 2)
      IF (X.GT.CONST(2.0,0)) GO TO 20
C
      IF (X .LT. XMIN) CALL XERMSG ('SLATEC', 'DBESK1',
     +   'X SO SMALL K1 OVERFLOWS', 3, 2)
      Y = CONST(0.,0)
      IF (X.GT.XSML) Y = X*X
      DBESK1 = LOG(CONST(0.5,0)*X)*DBESI1(X) +
     1   (CONST(0.75,0)+ DCSEVL (CONST(.5,0)*Y-CONST(1.,0),
     1   BK1CS, NTK1))/X
      RETURN
C
 20   DBESK1 = CONST(0.,0)
      IF (X .GT. XMAX) CALL XERMSG ('SLATEC', 'DBESK1',
     +   'X SO BIG K1 UNDERFLOWS', 1, 1)
      IF (X.GT.XMAX) RETURN
C
      DBESK1 = EXP(-X) * DBSK1E(X)
C
      RETURN
      END
! 22Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 22Jun2000 fgtok
! 22Jun2000 fgtok
! 22Jun2000 fgtok

      module Vceqdsk
      use kind_spec

C...Created by Pacific-Sierra Research VAST-90 2.06G2  12:29:44   5/18/01
      use Vparam, only: nxa, nza, nptsdm, nprofm, nza2,
     1                  inoperm, nprofm2, lrza, nions
      character(8) :: codeid, dat
      character(40) :: ntitle
      integer   nlim, nlimiter, lrz, nprim, nimp, nion, nti
      integer   iounit1, inoperm1, nptsdm1, nptsd
      integer   ieqdsk
      integer   ipestg, nxeqd, nzeqd
      integer   imodeq, liw, lw, ifail
      integer, dimension(nprofm) :: ncontr
      integer, dimension(4) :: iw
      real(kind=dp)   psiadj
      real(kind=dp)   funcmin
      real(kind=dp)   xxx, zzz
      real(kind=dp)   dpolflx, psieqd
      real(kind=dp)   tpsisav, dang, bperr, arcl
      real(kind=dp)   xdimeqd, zdimeqd, reqd, redeqd, zmideqd, xma,
     1    zma, psimag,
     1   psilim, beqd, toteqd, psimx1, psimx2, xax1, xax2, zax1, zax2,
     2   psisep, xsep, zsep
      real(kind=dp), dimension(nxa) :: feqd, presseqd, ffpeqd, ppeqd
      real(kind=dp), dimension(nxa,nza) :: peqd
      real(kind=dp), dimension(nxa) :: qeqd
      real(kind=dp), dimension(nxa) :: xeqd
      real(kind=dp), dimension(nza) :: zeqd
      real(kind=dp), dimension(2) :: bl, bu, psith
      real(kind=dp), dimension(40) :: work
      real(kind=dp), dimension(nxa) :: tpsieqd, tpsifeqd
      real(kind=dp), dimension(nxa) :: torflux
      real(kind=dp), dimension(nprofm) :: ra
      real(kind=dp), dimension(nprofm,4) :: psifra
      real(kind=dp), dimension(nprofm) :: dpsifra
      real(kind=dp), dimension(nprofm,4) :: fra, fra1
      real(kind=dp), dimension(2,nxa,nza2) :: cspln
      real(kind=dp), dimension(6) :: pds
      real(kind=dp), dimension(inoperm) :: wnoperm
      real(kind=dp), dimension(nprofm) :: pprime, vprime, chipsi
      real(kind=dp), dimension(nptsdm) :: thet, anglex
      real(kind=dp), dimension(2,nptsdm,nprofm2) :: csplnx, csplnz
      real(kind=dp), dimension(6) :: pdsx, pdsz
      real(kind=dp), dimension(nptsdm) :: rlim, zlim,
     1    rlimiter, zlimiter
      real(kind=dp), dimension(lrza,nions) :: zi
      real(kind=dp), dimension(lrza) :: zeffz, r, raeqd, psifeqd, te
      real(kind=dp), dimension(lrza,nions) :: ti
      real(kind=dp), dimension(lrza) :: ti1, ene
      real(kind=dp), dimension(lrza,nions) :: enp
      real(kind=dp), dimension(nxa,nza) :: bmod
      real(kind=dp), dimension(2*nprofm - 1) :: rmd, btmd, bpmd, btpmd
      real(kind=dp), dimension(nprofm) :: roa
      real(kind=dp), dimension(nptsdm,nprofm) :: xcontr, zcontr,
     1    bpcontr, btcontr
     1   , dstarp, b_fld, jacob
      end module Vceqdsk

c
c cubspl     from nssl                version   8          05/19/77
c
c package cubspl
c
c
c latest revision        september 1976
c
c purpose                to perform one and two-dimensional cubic spline
c                        interpolation with choice of boundary
c                        conditions.  the function and selected
c                        derivatives may be evaluated at any point where
c                        interpolation is required.  in the
c                        two-dimensional case, the given data points
c                        must be on a rectangular grid, which need not
c                        be equally spaced.  the package cubspl contains
c                        seven routines.
c
c                        subroutine coeff1
c                          computes the coefficients for one-dimensional
c                          cubic spline interpolation using one of two
c                          boundary conditions at each end of the range.
c                            . second derivative given at boundary.
c                            . first derivative given at boundary.
c                            . periodic boundary condition.
c                            . first derivative determined by fitting a
c                              cubic to the four points nearest to the
c                              boundary.
c
c                        subroutine terp1
c                          using the coefficients computed by coeff1,
c                          this routine evaluates the function and/or
c                          first and second derivatives at any point
c                          where interpolation is required.
c
c                        subroutine coeff2
c                          computes the coefficients for two-dimensional
c                          bicubic spline interpolation with the same
c                          choice of boundary conditions as for coeff1.
c
c                        function terp2
c                          using the coefficients produced by coeff2,
c                          this subroutine evaluates the function or a
c                          selected derivative at any point where
c                          two-dimensional interpolation is required.
c
c                        subroutine trip
c                          a simple periodic, tridiagonal linear
c                          equation solver used by coeff1.
c
c                        subroutine search
c                          performs a binary search in a one-dimensional
c                          floating point table arranged in ascending
c                          order.  this routine is called by terp1 and
c                          terp2.
c
c                        subroutine intrp
c                          given coefficients provided by coeff1 and the
c                          position of the interpolation point in the
c                          independent variable table, this routine
c                          performs one-dimensional interpolation for
c                          the function value, first and second
c                          derivative, as desired.  this routine is
c                          called by terp1 and terp2.
c
c access cards           *fortran,s=ulib,n=cubspl
c                        *cosy
c                          these cards access all seven routines of the
c                          package, cubspl.
c
c space required         total space for all seven routines is
c                        2243 (octal) = 1187 (decimal).
c
c entry points           coeff1, terp1, coeff2, terp2, trip, search,
c                        intrp
c
c special conditions     tables of independent variables must be
c                        arranged in ascending order.  for
c                        two-dimensional interpolation, the data points
c                        must lie on a rectangular mesh.
c
c common blocks          none
c
c i/o                    none
c
c precision              single
c
c required ulib          none
c routines
c
c specialist             cicely ridley, ncar, boulder, colorado  80303
c
c language               fortran
c
c history                this package is based on the routines
c                            la e 102a, spl1d1
c                            la e 103a, spl1d2
c                            la e 104a, spl2d1
c                            la e 105a, spl2d2
c                        of the los alamos cubic spline package written
c                        by thomas j. jordan and bertha fagan, 1968.
c                        the routines have been streamlined and
c                        standardized.  the algorithm for
c                        two-dimensional interpolation is considerably
c                        modified.
c
c
      subroutine coeff1(n, x, f, w, iop, int, wk)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56   6/14/01  
C...Switches: -p4 -yb
      use Vterppars
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer n, int
      integer, dimension(2) :: iop
      real, dimension(n) :: x
      real, dimension(int*(n-1) +1):: w, f
      real, dimension(n,*) :: wk
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer::index,j0,i,jm,nn,mk,ml,i1,j1,j2,j3,j4,i2,in
      real::xxx,y2,b2,xxy
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      integer ii
      real terp
C-----------------------------------------------
c
c
c dimension of           x(n),f(int*(n-1)+1),w(int*(n-1)+1),iop(2),
c arguments              wk(3*n+1)
c
c latest revision        february 1974
c
c usage                  call coeff1(n,x,f,w,iop,int,wk)
c
c arguments
c
c on input               n
c                          the number of data points.  n must be at
c                          least 4.
c
c                        x
c                          table of n independent variable values in
c                          ascending order.  dimension of x in calling
c                          program must be at least n.
c
c                        f
c                          table of n corresponding dependent variable
c                          values.  the values are separated by interval
c                          int.  this is usually unity for
c                          one-dimensional interpolation.  other values
c                          are useful when coeff1 is incorporated in a
c                          two-dimensional interpolation scheme (see
c                          coeff2).  dimension of f in the calling
c                          program must be at least (int*(n-1)+1).
c
c                        iop
c                          two element integer array defining boundary
c                          conditions at x(1) and x(n) according to the
c                          following code.
c
c                          for iop(1)
c                          = 1  second derivative given at x(1).  place
c                               value of second derivative in w(1)
c                               before call to coeff1.
c                          = 2  first derivative given at x(1).  place
c                               value of first derivative in w(1) before
c                               call.
c                          = 3  periodic boundary condition.  x(1) and
c                               x(n) are equivalent points.  f(1) and
c                               f(int*(n-1)+1) are equal.
c                          = 4  the first derivative at x(1) is
c                               calculated by fitting a cubic to points
c                               x(1) through x(4).
c                          similarly, iop(2) defines the boundary
c                          condition at x(n).  when iop(2) = 1 (or 2),
c                          the value of the second (or first) derivative
c                          must be placed in w(int*(n-1)+1).  note that
c                          if iop(1) = 3, consistency demands that
c                          iop(2) = 3 also.
c
c                        int
c                          spacing in f and w tables.  for
c                          one-dimensional interpolation this will
c                          usually be unity.
c
c                        wk
c                          work area of dimension at least (3*n+1).
c
c on output              w
c                          table of second derivatives corresponding to
c                          given x and f values.  the separation of
c                          tabular entries is int (see above).
c                          dimension of w in the calling program must be
c                          at least (int*(n-1)+1).
c
c                          the arrays x, f, w are used as input for the
c                          routine terp1, which performs interpolation
c                          at a given value of the independent variable.
c
c space required         654 (octal) = 428 (decimal)
c
c timing                 the timing is linearly proportional to n, the
c                        number of data points.  for 21 data points, the
c                        time on the ncar cdc 7600 was approximately
c                        .24 milliseconds.
c
c
c
c arithmetic statement function for interpolation
c
c the following call is for gathering statistics on library use at ncar
c
c start to set up tridiagonal system
c
      j0 = 1
      do i = 2, n
         jm = j0
         j0 = j0 + int
         wk(i,1) = x(i) - x(i-1)
         wk(i,2) = (f(j0)-f(jm))/wk(i,1)
         wk(i,3) = wk(i,1)/6.
         wk(i,1) = wk(i,1)/3.
      end do
      nn = n
      mk = iop(1)
      ml = iop(2)
c
c apply boundary conditions at boundary 1
c
      go to (102,103,104,105) mk
c
c second derivative given at boundary 1
c
  102 continue
      wk(2,2) = wk(3,2) - wk(2,2) - wk(2,3)*w(1)
      wk(2,3) = 0.
      wk(2,1) = wk(2,1) + wk(3,1)
      i1 = 2
      nn = nn - 1
      go to 106
c
c first derivative given at boundary 1
c
  103 continue
      xxx = w(1)
      wk(1,2) = wk(2,2) - w(1)
      wk(2,2) = wk(3,2) - wk(2,2)
      wk(1,3) = 0.
      wk(1,1) = wk(2,1)
      wk(2,1) = wk(2,1) + wk(3,1)
      i1 = 1
      go to 106
c
c periodic boundary condition
c
  104 continue
      y2 = wk(2,2)
      b2 = wk(2,1)
      wk(2,2) = wk(3,2) - wk(2,2)
      wk(2,1) = wk(3,1) + wk(2,1)
      i1 = 2
      nn = nn - 1
      go to 106
c
c first derivative at boundary 1 from 4 point interpolation.
c
  105 continue
      a12 = x(1) - x(2)
      a13 = x(1) - x(3)
      a14 = x(1) - x(4)
      a23 = x(2) - x(3)
      a24 = x(2) - x(4)
      a34 = x(3) - x(4)
      j1 = 1
      j2 = j1 + int
      j3 = j2 + int
      j4 = j3 + int
      w(1) = terp(f(j1),f(j2),f(j3),f(j4))
      go to 103
c
c compute tridiagonal arrays
c
  106 continue
      i2 = n - 2
      wk(3:i2,2) = wk(4:i2+1,2) - wk(3:i2,2)
      wk(3:i2,1) = wk(4:i2+1,1) + wk(3:i2,1)
c
c apply boundary conditions at boundary 2.
c
      in = ii(n,int)
      go to (108,109,110,111) ml
c
c second derivative given at boundary 2.
c
  108 continue
      wk(n-1,2) = wk(n,2) - wk(n-1,2) - wk(n,3)*w(in)
      wk(n,3) = 0.
      wk(n-1,1) = wk(n-1,1) + wk(n,1)
      nn = nn - 1
      go to 112
c
c first derivative given at boundary 2.
c
  109 continue
      xxy = w(in)
      wk(n-1,2) = wk(n,2) - wk(n-1,2)
      wk(n,2) = (-wk(n,2)) + w(in)
      wk(n-1,1) = wk(n-1,1) + wk(n,1)
      wk(1,4) = 0.
      go to 112
c
c periodic boundary condition
c
  110 continue
      wk(n-1,2) = wk(n,2) - wk(n-1,2)
      wk(n,2) = y2 - wk(n,2)
      wk(n-1,1) = wk(n-1,1) + wk(n,1)
      wk(n,1) = wk(n,1) + b2
      wk(1,4) = wk(2,3)
      go to 112
c
c first derivative at boundary 2 from 4 point interpolation.
c
  111 continue
      a12 = x(n) - x(n-1)
      a13 = x(n) - x(n-2)
      a14 = x(n) - x(n-3)
      a23 = x(n-1) - x(n-2)
      a24 = x(n-1) - x(n-3)
      a34 = x(n-2) - x(n-3)
      j1 = in
      j2 = j1 - int
      j3 = j2 - int
      j4 = j3 - int
      w(in) = terp(f(j1),f(j2),f(j3),f(j4))
      go to 109
  112 continue
c
c solve tridiagonal system
c
      call trip(nn,wk(i1,3),wk(i1,1),wk(i1+1,3),wk(i1,2),
     1          w(ii(i1,int)),int)
      go to (114,114,113,114) mk
  113 continue
      w(1) = w(in)
  114 continue
      return 
      end subroutine coeff1
c
c
      subroutine coeff2(nx, x, ny, y, f, fxx, fyy, fxxyy, idm, ibd,
     1                  wk)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nx, ny, idm
      integer, dimension(4) :: ibd
      real, dimension(nx) :: x
      real, dimension(ny) :: y
      real, dimension(idm,ny) :: f, fxx, fyy, fxxyy
      real, dimension(3*max(nx,ny)+1) :: wk
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer, dimension(2) :: iloc, jloc
      integer :: i,j
C-----------------------------------------------
      data iloc(1), iloc(2), jloc(1), jloc(2)/1, 1, 4, 4/
c
c
c dimension of           x(nx),y(ny),f(idm,ny),fxx(idm,ny),fyy(idm,ny),
c arguments              fxxyy(idm,ny),ibd(4),wk(3*max0(nx,ny)+1)
c                        (idm must be .ge. nx)
c
c latest revision        february 1974
c
c usage                  call coeff2 (nx,x,ny,y,f,fxx,fyy,fxxyy,idm,ibd,wk)
c
c arguments
c
c on input               nx
c                          number of grid points in the x-direction.  nx
c                          must be at least 4.
c
c                        x
c                          table of nx values of the first independent
c                          variable arranged in ascending order.
c                          dimension of x in the calling program must be
c                          at least nx.
c
c                        ny
c                          number of grid points in the y-direction. ny
c                          must be at least 4.
c
c                        y
c                          table of ny values of the second independent
c                          variable arranged in ascending order.
c                          dimension of y in the calling program must be
c                          at least ny.
c
c                        f
c                          two dimensional array of function values at
c                          the grid points defined by the arrays x and
c                          y.  dimension of f in the calling program is
c                          (idm, nyy) where
c                              idm .ge. nx
c                              nyy .ge. ny
c
c                        idm
c                          first dimension in the calling program of
c                          arrays f, fxx, fyy, fxxyy.  idm must be at
c                          least nx.
c
c                        ibd
c                          four element integer array defining boundary
c                          conditions according to the following code.
c                          for ibd(1)
c                          = 1  the second derivative of f with respect
c                               to x is given at (x(1),y(j)) for
c                               j = 1,ny,1.  values of this second
c                               derivative must be placed in fxx(1,j)
c                               for j = 1,ny,1, before calling coeff2.
c                          = 2  the first derivative of f with respect
c                               to x is given at (x(1),y(j)) for
c                               j = 1,ny,1.  values of the derivative
c                               must be placed in fxx(1,j) for
c                               j = 1,ny,1 before calling coeff2.
c                          = 3  periodic boundary condition in the
c                               x-direction.  (x(1),y(j)) and
c                               and (x(nx),y(j)) are equivalent points
c                               for j = 1,ny,1.  f(1,j) and f(nx,j) are
c                               equal.
c                          = 4  the first derivative of f with respect
c                               to x at (x(1),y(j)) is computed by
c                               fitting a cubic to f(1,j) through f(4,j)
c                               for j = 1,ny,1.
c
c                          similarly, ibd(2) defines the boundary
c                          condition at (x(nx),y(j)) for j = 1,ny,1.
c                          when ibd(2) = 1 (or 2) the values of the
c                          second (or first) derivative of f with
c                          respect to x are placed in fxx(nx,j) for
c                          j = 1,ny,1.
c                            note that if ibd(1) = 3, consistency
c                            requires that ibd(2) = 3 also.
c                          for ibd(3)
c                          = 1  the second derivative of f with respect
c                               to y is given at (x(i),y(1)).  place
c                               values of the derivative in fyy(i,1) for
c                               i = 1,nx,1 before calling coeff2.
c                          = 2  the first derivative of f with respect
c                               to y is given at (x(i),y(1)).  values of
c                               this derivative must be placed in
c                               fyy(i,1) for i = 1,nx,1 before calling
c                               coeff2.
c                          = 3  periodic boundary condition in the
c                               y-direction.  (x(i),y(1)) and
c                               (x(i),y(ny)) are equivalent points.
c                               f(i,1) and f(i,ny) are equal.
c                          = 4  the first derivative of f with respect
c                               to y at (x(i),y(1)) is computed by
c                               fitting a cubic to f(i,1) through f(i,4)
c                               for i = 1,nx,1.
c
c                          similary, ibd(4) defines the boundary
c                          condition at (x(i),y(ny)) for i = 1,nx,1 and
c                          given derivative values are placed in
c                          fyy(i,ny).
c                            note that consistency demands that if
c                            ibd(3) = 3, then ibd(4) = 3 also.
c
c                        wk
c                          work area of dimension at least
c                          (3*max0(nx,ny)+1)
c
c on output              fxx
c                          array of second derivatives of f with respect
c                          to x computed by coeff2.  fxx(i,j) is
c                          derivative at (x(i),y(j)).  as for f,
c                          dimension of fxx in the calling program is
c                          (idm,nyy).
c
c                        fyy
c                          array of second derivatives of f with respect
c                          to y computed by coeff2.  dimension of fyy in
c                          the calling program is (idm,nyy).
c
c                        fxxyy
c                          array of fourth derivatives
c                          (d/dx)**2*(d/dy)**2*f, computed by coeff2.
c                          dimension of fxxyy in the calling program is
c                          (idm,nyy).
c
c                        the arrays x, y, f, fxx, fyy, fxxyy are used as
c                        input for the routine terp2 which performs
c                        interpolation at required values of the two
c                        independent variables.
c
c space required         370 (octal) = 248 (decimal)
c
c timing                 the timing is proportional to nx*ny.  for a
c                        21 x 21 grid of data points, the time taken on
c                        the ncar 7600 was 19.5 milliseconds.
c
c
c the following call is for gathering statistics on library use at ncar
c
c compute fxx
c
      do j = 1, ny
         call coeff1(nx, x, f(1,j), fxx(1,j), ibd(1), 1, wk)
      end do
c
c compute fyy
c
      do i = 1, nx
         call coeff1(ny, y, f(i,1), fyy(i,1), ibd(3), idm, wk)
      end do
c
c check for periodic boundary condition in both directions
c
      if (ibd(1) /= 3) then
         if (ibd(3) == 3) go to 105
c
c calculate fxxyy along left and right boundaries
c
         call coeff1(ny, y, fxx(1,1), fxxyy(1,1), jloc, idm, wk)
         call coeff1(ny, y, fxx(nx,1), fxxyy(nx,1), jloc, idm, wk)
         go to 106
      endif
c
c periodic in x direction . calculate fxxyy along lower and upper
c boundaries.
c
      call coeff1(nx, x, fyy(1,1), fxxyy(1,1), ibd(1), 1, wk)
      call coeff1(nx, x, fyy(1,ny), fxxyy(1,ny), ibd(1), 1, wk)
c
c calculate remaining fxxyy
c
      do i = 1, nx
         call coeff1(ny, y, fxx(i,1), fxxyy(i,1), iloc, idm, wk)
      end do
      go to 108
  105 continue
c
c periodic in y direction. calculate fxxyy along left and right
c boundaries.
c
      call coeff1(ny, y, fxx(1,1), fxxyy(1,1), ibd(3), idm, wk)
      call coeff1(ny, y, fxx(nx,1), fxxyy(nx,1), ibd(3), idm, wk)
  106 continue
c
c calculate remaining fxxyy
c
      do j = 1, ny
         call coeff1(nx, x, fyy(1,j), fxxyy(1,j), iloc, 1, wk)
      end do
  108 continue
      return 
      end subroutine coeff2
      subroutine cubspl(h, c, nprofn, nprof)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nprofn, nprof
      real h
      real, dimension(nprofn,4) :: c
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n1, n, k
      real :: d2, ch4
C-----------------------------------------------
c ********** ********** ********** ********** ********** **********
c                                                                 *
c  this subroutine evaluates the coefficients for                 *
c        the cubic spline interpolation of the profiles.          *
c        derivatives in r = 0 and r = rplasm                      *
c        evaluated from divided differences                       *
c                                                                 *
c ********** ********** ********** ********** ********** **********
c ---------- ---------- ---------- ---------- ---------- ----------
      n1 = nprof - 1
c ---------- ---------- ---------- ---------- ---------- ----------
c  evaluate finite differences and store in c(j,4)
      c(:n1,4) = (c(2:n1+1,1)-c(:n1,1))/h
c ---------- ---------- ---------- ---------- ---------- ----------
c  forward evaluation of e(j) (=c(j,2)) and f(j) (=c(j,3))
      c(1,2) = 0.
      d2 = c(2,4) - c(1,4)
      c(1,3) = c(1,4) - d2/2.E0
      do n = 2, n1
         c(n,2) = -1./(4. + c(n-1,2))
         c(n,3) = (c(n-1,3)-3.*(c(n-1,4)+c(n,4)))*c(n,2)
      end do
c ---------- ---------- ---------- ---------- ---------- ----------
c   backward evaluation of the derivatives s(j) (=c(2,j))
c      and of higher coefficients
      c(nprof,2) = c(n1,4)
      c(nprof,3) = 0.
      c(nprof,4) = 0.
      do k = 1, n1
         n = nprof - k
         c(n,2) = c(n,2)*c(n+1,2) + c(n,3)
         ch4 = (c(n,2)+c(n+1,2)-2.*c(n,4))/h
         c(n,3) = 2.*((c(n,4)-c(n,2))/h-ch4)
         c(n,4) = 6.*ch4/h
      end do
      return 
      end subroutine cubspl
      subroutine dbcevl1(x, nx, y, ny, c, ic, xl, yl, pds, ier, icalc)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nx, ny, ic, ier, icalc
      real xl, yl
      real, dimension(*) :: x, y
      real, dimension(2,ic,1) :: c
      real, dimension(6) :: pds
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, j, k, km1, kp1, kp2, lxpl, lx, ly, l, lxp1
      real :: hx, hy
      real, dimension(2) :: sux, suy, su, svx, sv, sxy
      real :: u, v, s0, sh, sp0, sph, h, d
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real spln0, spln1, spln2
C-----------------------------------------------
c---this is a special version of dbcevl,used by the onetwo suite
c---of subroutines. It differs form the imsl version in the calling
c---arguments and the calculations below are reordered for efficiency
c---That  is,many times we dont need all of the pds array. This
c---version returns only those values of pds specifically requested
c---using the argument icalc. This leads to about at 50% improvent
c---in execution time.    HSJ
c                                  specifications for local variables
c                                  first executable statement
      ier = 0
      hx = x(2) - x(1)
      hy = y(2) - y(1)
c     The following computation of lx,ly is a speed-up modification
c     for equispaced grids (Bob H. 10/22/90):
      lx = (xl - x(1))/hx + 1
      ly = (yl - y(1))/hy + 1
      if (lx < 1) then
         lx = 1
         ier = 33
      else if (lx > nx) then
         lx = nx
         ier = 35
      endif
      if (ly < 1) then
         ly = 1
         ier = 34
      else if (ly > ny) then
         ly = ny
         ier = 36
      endif
      lxp1 = lx + 1
      u = (xl - x(lx))/hx
      v = (yl - y(ly))/hy
      k = 2*ly
      kp1 = k + 1
      kp2 = k + 2
      km1 = k - 1
      do l = 1, 2
         lxpl = lx - 1 + l
         i = 2*(ly - 1 + l)
         j = i - 1
         sv(l) = spln0(c(1,lxpl,km1),c(1,lxpl,kp1),c(1,lxpl,k),
     1      c(1,lxpl,kp2),hy,v)
         svx(l) = spln0(c(2,lxpl,km1),c(2,lxpl,kp1),c(2,lxpl,k),
     1      c(2,lxpl,kp2),hy,v)
         if (icalc >= 3) then
            su(l) = spln0(c(1,lx,j),c(1,lxp1,j),c(2,lx,j),
     1         c(2,lxp1,j),hx,u)
            suy(l) = spln0(c(1,lx,i),c(1,lxp1,i),c(2,lx,i),
     1         c(2,lxp1,i),hx,u)
            if (icalc >= 4) then
               sux(l) = spln1(c(1,lx,j),c(1,lxp1,j),c(2,lx,j),
     1            c(2,lxp1,j),hx,u)
               sxy(l) = spln1(c(1,lx,i),c(1,lxp1,i),c(2,lx,i),
     1            c(2,lxp1,i),hx,u)
            endif
         endif
      end do
      pds(1) = spln0(sv(1),sv(2),svx(1),svx(2),hx,u)
      if (icalc == 1) return 
      pds(2) = spln1(sv(1),sv(2),svx(1),svx(2),hx,u)
      if (icalc == 2) return 
      pds(3) = spln1(su(1),su(2),suy(1),suy(2),hy,v)
      if (icalc == 3) return 
      pds(4) = spln1(sux(1),sux(2),sxy(1),sxy(2),hy,v)
      if (icalc == 4) return 
      pds(5) = spln2(sv(1),sv(2),svx(1),svx(2),hx,u)
      if (icalc == 5) return 
      pds(6) = spln2(su(1),su(2),suy(1),suy(2),hy,v)
      if (ier > 0) call uertst (ier, 6Hdbcevl)
      return 
      end subroutine dbcevl1
      subroutine der4v(n, h, y, z, nz, ndim)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer n, nz, ndim
      real h
      real, dimension(ndim,5) :: y
      real, dimension(ndim) :: z
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i
      real :: d
C-----------------------------------------------
c----------------
c  given y(1:nz,j) at x(j),j=1..5 eqdistant separated at h,
c   find derivative z(1:ndim) at x(n),n=1..5
c------------------------------
      d = 12.E0*h
      select case (n) 
      case default
         z(:nz) = ((-25.*y(:nz,1))+48.*y(:nz,2)-36.*y(:nz,3)
     1      +16.*y(:nz,4)-3.*y(:nz,5))/d
         return 
      case (2) 
         z(:nz) = ((-3.*y(:nz,1))-10.*y(:nz,2)+18.*y(:nz,3)
     1      -6.*y(:nz,4)+y(:nz,5))/d
         return 
      case (3) 
         z(:nz) = (y(:nz,1)-8.*y(:nz,2)+8.*y(:nz,4)-y(:nz,5))/d
         return 
      case (4) 
         z(:nz) = ((-y(:nz,1))+6.*y(:nz,2)-18.*y(:nz,3)
     1      +10.*y(:nz,4)+3.*y(:nz,5))/d
         return 
      case (5) 
         z(:nz) = (25.*y(:nz,5)-48.*y(:nz,4)+36.*y(:nz,3)
     1      -16.*y(:nz,2)+3.*y(:nz,1))/d
         return 
      end select
      end subroutine der4v
      subroutine deriv4(n, h, y, z)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer n
      real h, z
      real, dimension(5) :: y
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      real :: d
C-----------------------------------------------
      d = 12.*h
      select case (n) 
      case default
         z = ((-25.*y(1))+48.*y(2)-36.*y(3)+16.*y(4)-3.*y(5))/d
         return 
      case (2) 
         z = ((-3.*y(1))-10.*y(2)+18.*y(3)-6.*y(4)+y(5))/d
         return 
      case (3) 
         z = (y(1)-y(5)+8.*(y(4)-y(2)))/d
         return 
      case (4) 
         z = ((-y(1))+6.*y(2)-18.*y(3)+10.*y(4)+3.*y(5))/d
         return 
      case (5) 
         z = (3.*y(1)-16.*y(2)+36.*y(3)-48.*y(4)+25.*y(5))/d
         return 
      end select
      end subroutine deriv4
c
      subroutine fterp1(f, fxx, fyy, nua, nta, us, thets, tempx,
     1                  tempy)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nua, nta
      real, dimension(nua,nta) :: f, fxx, fyy
      real, dimension(nua) :: us
      real, dimension(nta) :: thets
      real, dimension(nua,nta) :: tempx, tempy
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, nuam, j, ntam, ii, jj
      real :: qx, qy, dthets, dthetsp, thets12, thets12p, dusp, us12, 
     1   us12p, dus, fx12, fx12p, fy12, fy12p, us1, usnu, thets1, 
     2   thetsnt, dudthets, u, thet
C-----------------------------------------------
c
c  Set up for bilinear interpolation of derivatives of f off
c  a uniform mesh in u and theta:
c
 
c  Calculate derivatives at mesh pts (error of order delta-v**3
c  or delta-theta**3).
c
c  Interior mesh pts:
      do i = 2, nuam - 1
         do j = 2, ntam - 1
            qx = ((us(i-1)-us(i))/(us(i+1)-us(i)))**2
            fxx(i,j) = (qx*f(i+1,j)+(1.-qx)*f(i,j)-f(i-1,j))/(qx
     1         *(us(i+1)-us(i))-(us(i-1)-us(i)))
            qy = ((thets(j-1)-thets(j))/(thets(j+1)-thets(j)))**2
            fyy(i,j) = (qy*f(i,j+1)+(1.-qy)*f(i,j)-f(i,j-1))/(qy
     1         *(thets(j+1)-thets(j))-(thets(j-1)-thets(j)))
         end do
      end do
 
c  Now do the edges of the mesh:
      dthets = thets(2) - thets(1)
      dthetsp = thets(ntam) - thets(ntam-1)
      thets12 = 0.5*(thets(1)+thets(2))
      thets12p = 0.5*(thets(ntam-1)+thets(ntam))
      dusp = us(nuam) - us(nuam-1)
      us12 = 0.5*(us(1)+us(2))
      us12p = 0.5*(us(nuam-1)+us(nuam))
      dus = us(2) - us(1)
 
      do i = 2, nuam - 1
         qx = ((us(i-1)-us(i))/(us(i+1)-us(i)))**2
         fxx(i,1) = (qx*f(i+1,1)+(1.-qx)*f(i,1)-f(i-1,1))/
     1              (qx*(us(i+1)-us(i))-(us(i-1)-us(i)))
         fxx(i,ntam) = (qx*f(i+1,ntam)+(1.-qx)*f(i,ntam)-f(i-1,ntam))
     1      /(qx*(us(i+1)-us(i))-(us(i-1)-us(i)))
      end do
 
      do j = 1, ntam
         fx12 = (f(2,j)-f(1,j))/dus
         fxx(1,j) = fx12 + (fxx(2,j)-fx12)/(us(2)-us12)*(us(1)-us12)
         fx12p = (f(nuam,j)-f(nuam-1,j))/dusp
         fxx(nuam,j) = fx12p + (fx12p - fxx(nuam-1,j))/(us12p-
     1      us(nuam-1))*(us(nuam)-us12p)
      end do
 
      do j = 2, ntam - 1
         fyy(1,j) = 0.0
         qy = ((thets(j-1)-thets(j))/(thets(j+1)-thets(j)))**2
         fyy(nuam,j) = (qy*f(nuam,j+1)+(1.-qy)*f(nuam,j)-f(nuam,j-1))
     1      /(qy*(thets(j+1)-thets(j))-(thets(j-1)-thets(j)))
      end do
 
      do i = 1, nuam
         fy12 = (f(i,2)-f(i,1))/dthets
         fyy(i,1) = fy12 + (fyy(i,2)-fy12)/(thets(2)-thets12)
     1      *(thets(1)-thets12)
         fy12p = (f(i,ntam)-f(i,ntam-1))/dthetsp
         fyy(i,ntam) = fy12p + (fy12p - fyy(i,ntam-1))/(thets12p-
     1      thets(ntam-1))*(thets(ntam)-thets12p)
      end do
 
c  Now interpolate these derivatives onto a uniform mesh in
c  the u and theta directions:
 
      us1 = us(1)
      usnu = us(nuam)
      thets1 = thets(1)
      thetsnt = thets(ntam)
      dus = (usnu - us1)/(nuam - 1)
      dthets = (thetsnt - thets1)/(ntam - 1)
      dudthets = dus*dthets
 
      do i = 1, nuam
         u = us1 + (i - 1)*dus
         call search (u, us, nuam, ii)
         do j = 1, ntam
            thet = thets1 + (j - 1)*dthets
            call search (thet, thets, ntam, jj)
            tempx(i,j) = (fxx(ii,jj)*(u-us(ii+1))*(thet-thets(jj+1))
     1      -fxx(ii+1,jj)*(u-us(ii))*(thet-thets(jj+1))-fxx(ii,jj+1)
     2      *(u-us(ii+1))*(thet-thets(jj))+fxx(ii+1,jj+1)*(u-us(ii))
     3         *(thet-thets(jj)))/dudthets
            tempy(i,j) = (fyy(ii,jj)*(u-us(ii+1))*(thet-thets(jj+1))
     1      -fyy(ii+1,jj)*(u-us(ii))*(thet-thets(jj+1))-fyy(ii,jj+1)
     2      *(u-us(ii+1))*(thet-thets(jj))+fyy(ii+1,jj+1)*(u-us(ii))
     3         *(thet-thets(jj)))/dudthets
         end do
      end do
 
c
      fxx(:nuam,:ntam) = tempx(:nuam,:ntam)
      fyy(:nuam,:ntam) = tempy(:nuam,:ntam)
 
      return 
      end subroutine fterp1
c
      subroutine fterp2(u0, thet0, i, j, usp, thetsp, dudthets, fxx,
     1                  fyy, nua, nta, dfdx, dfdy)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer i, j, nua, nta
      real u0, thet0, dudthets, dfdx, dfdy
      real, dimension(nua) :: usp
      real, dimension(nta) :: thetsp
      real, dimension(nua,nta) :: fxx, fyy
C-----------------------------------------------
      dfdx = (fxx(i,j)*(u0-usp(i+1))*(thet0-thetsp(j+1))-fxx(i+1,j)
     1   *(u0-usp(i))*(thet0-thetsp(j+1))-fxx(i,j+1)*(u0-usp(i+1))
     2   *(thet0-thetsp(j))+fxx(i+1,j+1)*(u0-usp(i))
     3   *(thet0-thetsp(j)))/dudthets
      dfdy = (fyy(i,j)*(u0-usp(i+1))*(thet0-thetsp(j+1))-fyy(i+1,j)
     1   *(u0-usp(i))*(thet0-thetsp(j+1))-fyy(i,j+1)*(u0-usp(i+1))
     2   *(thet0-thetsp(j))+fyy(i+1,j+1)*(u0-usp(i))
     3   *(thet0-thetsp(j)))/dudthets
      return 
      end subroutine fterp2
      subroutine inter3(f, z, y, x1, h)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real f, z, x1, h
      real, dimension(3) :: y
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      real :: a1, a2, a3, h2
C-----------------------------------------------
c---inter interpolates between 3-pts. xi=x1+(i-1)*h and find f at z
c-------------------------
      a1 = z - x1
      a2 = a1 - h
      a3 = a2 - h
      h2 = h*h
      f = a1*a2*y(3)/2./h2
      f = f - a1*a3*y(2)/h2
      f = f + a2*a3*y(1)/2./h2
      return 
      end subroutine inter3
      subroutine intern(f, z, y1, y2, y3, x1, x2, x3, n)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer n
      real z, x1, x2, x3
      real, dimension(n) :: f, y1, y2, y3
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i
      real :: a1, a2, a3, b1, b2, b3
C-----------------------------------------------
c---inter interpolates between 3-pts. xi and find f at z
c   f is an array of dimension n
c-------------------------
      a1 = z - x1
      a2 = z - x2
      a3 = z - x3
      b1 = x1 - x2
      b2 = x1 - x3
      b3 = x2 - x3
      f = a1*a2*y3/(b2*b3)
      f = f - a1*a3*y2/(b1*b3)
      f = f + a2*a3*y1/(b1*b2)
      return 
      end subroutine intern
      subroutine intrp(n, x, f, w, y, i, int, tab, itab)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer n, i, int
      real y
      integer, dimension(3) :: itab
      real, dimension(1) :: x, f, w
      real, dimension(3) :: tab
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: index, i0, ip
      real :: flk, flp, fl0, a, b, c
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      integer ii
C-----------------------------------------------
c     logical         itab(3)
c
c arithmetic statement function used to locate entries in f and w arrays
c
c
c perform interpolation or extrapolation
c
      flk = x(i+1) - x(i)
      flp = x(i+1) - y
      fl0 = y - x(i)
      i0 = ii(i,int)
      ip = i0 + int
      if (itab(1) == 1) then
c
c calculate f(y)
c
         a = (w(i0)*flp**3+w(ip)*fl0**3)/(6.*flk)
         b = (f(ip)/flk-w(ip)*flk/6.)*fl0
         c = (f(i0)/flk-w(i0)*flk/6.)*flp
         tab(1) = a + b + c
      endif
      if (itab(2) == 1) then
c
c calculate first derivative at y
c
         a = (w(ip)*fl0**2-w(i0)*flp**2)/(2.*flk)
         b = (f(ip)-f(i0))/flk
         c = (w(i0)-w(ip))*flk/6.
         tab(2) = a + b + c
      endif
c
c calculate second derivative at y
c
      if (itab(3) == 1) tab(3) = (w(i0)*flp+w(ip)*fl0)/flk
      return 
      end subroutine intrp
 
 
c===================================================================
c===================================================================
 
 
c      The following subroutine intrpp,copya,icsicu,icsevu,uertst
c          are taken from onetwo, and are for purposes of creating
c          spline profiles of density, etc.
 
      subroutine intrpp(ilow, iup, x, y, nold, xnew, ynew, nnew)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nold, nnew
      character ilow*4, iup*4
      real, dimension(nold) :: x, y
      real, dimension(nnew) :: xnew, ynew
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
      integer, parameter :: kjx = 151
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: iord, i, ier
      real, dimension(4) :: bpar
      real, dimension(kjx,3) :: c
      real, dimension(kjx) :: xt, yt
C-----------------------------------------------
c     ynew as a function of xnew given y as a function of x.  The
c     boundary conditions are specified as follows:
c       ilow : 'zero', set derivative at lower x value to zero
c             #'free', let derivative at lower x value be free
c       iup  : 'zero', set derivative at upper x value to zero
c             #'free', let derivative at upper x value be free
c------------------------------------------------------------------
c
c       must assure that x(1).le.x(2)....
c
      if (x(2) <= x(1)) go to 10
      iord = 0
c
   60 continue
      bpar = 0.
      if (ilow == 'zero') then
         bpar(1) = 1.
         bpar(2) = 6.*(y(2)-y(1))/(x(2)-x(1))**2
      endif
      if (iup == 'zero') then
         bpar(3) = 1.
         bpar(4) = -6.*(y(nold)-y(nold-1))/(x(nold)-x(nold-1))**2
      endif
c
      call icsicu (x, y, nold, bpar, c, kjx, ier)
c
      if (ier /= 0) go to 20
c
      call icsevu (x, y, nold, c, kjx, xnew, ynew, nnew, ier)
c
      if (iord == 0) return 
c
      x(:nold) = xt(:nold)
      y(:nold) = yt(:nold)
c
      return 
c
   10 continue
      iord = 1
c
      xt(:nold) = x(:nold)
      yt(:nold) = y(:nold)
c
      x(:nold) = xt(nold:1:(-1))
      y(:nold) = yt(nold:1:(-1))
c
      go to 60
c
c
   20 continue
      write (6, 40) ier, iord, nold
   40 format('1intrp    ier=',i3,'   iord=',i1,'   nold=',i3,/,
     1    '  i','     x      ','     y      ')
      write (6, 80) (i,x(i),y(i),i=1,nold)
   80 format(i5,2e12.4)
c
      call exit (1)
c
      end subroutine intrpp
      subroutine intrv(y, x, ytab, h, x1, nn, ndim)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nn, ndim
      real x, h, x1
      real, dimension(ndim) :: y
      real, dimension(ndim,4) :: ytab
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: j
      real :: a1, a2, a3, a4, h3
C-----------------------------------------------
c------------------------
c  given ytab(1:nn,xx(i)),i=1,..4, xx(i)=x1+(i-1)*h, find
c     y(1:nn) at x
c  ndim=dimension of y as in calling routine
c----------------------
      a1 = x - x1
      a2 = a1 - h
      a3 = a2 - h
      a4 = a3 - h
      h3 = h*h*h
      y(:nn) = -(a3*a4)*a2*ytab(:nn,1)/(6.*h3)
      y(:nn) = y(:nn) + (a3*a4)*a1*ytab(:nn,2)/2./h3
      y(:nn) = y(:nn) - (a1*a2)*a4*ytab(:nn,3)/2./h3
      y(:nn) = y(:nn) + (a1*a2)*a3*ytab(:nn,4)/6./h3
      return 
      end subroutine intrv
      subroutine intrv1(y, x, ytab, h, x1, nn, ndim, a1, a2, a3, a4)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nn, ndim
      real h
      real, dimension(ndim) :: y, x
      real, dimension(ndim,4) :: ytab
      real, dimension(ndim) :: x1, a1, a2, a3, a4
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: j
      real :: h3
C-----------------------------------------------
c------------------------
c  given ytab(1:nn,4),i=1,..4, at xx(1:nn,i)=x1(1:nn)+(i-1)*h, find
c     y(1:nn) at x(1:nn)
c  ndim=dimension of y as in calling routine
c----------------------
      h3 = h*h*h
      a1(:nn) = x(:nn) - x1(:nn)
      a2(:nn) = a1(:nn) - h
      a3(:nn) = a2(:nn) - h
      a4(:nn) = a3(:nn) - h
      y(:nn) = -(a3(:nn)*a4(:nn))*a2(:nn)*ytab(:nn,1)/(6.*h3)
      y(:nn) = y(:nn) + (a3(:nn)*a4(:nn))*a1(:nn)*ytab(:nn,2)/2./h3
      y(:nn) = y(:nn) - (a1(:nn)*a2(:nn))*a4(:nn)*ytab(:nn,3)/2./h3
      y(:nn) = y(:nn) + (a1(:nn)*a2(:nn))*a3(:nn)*ytab(:nn,4)/6./h3
      return 
      end subroutine intrv1
      subroutine mcsevu(h, x1, y, ny, yc, ic, ns, s, xs, ier)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer ny, ic, ns, ier
      real h, x1
      real, dimension(ny) :: y
      real, dimension(ic,3) :: yc
      real, dimension(ns) :: s, xs
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer, dimension(1) :: is
      integer :: i
      real, dimension(ns) :: d
      real :: zero
C-----------------------------------------------
c--------------------
c  evaluation of cubic spline
c   given y(ny),yc(ny,3) at x(j)=x1+(j-1)*h   j=1...ny
c   evaluate s(1:ns) at xs(1:ns)
c    xs(1:ns) should be less than x(ny)
c----------------------------------
      data zero/0.0/
      is(:ns) = (xs - x1)/h
      is(:ns) = min0(ny - 2,is(:ns))
      d = xs - is(:ns)*h - x1
      is(:ns) = is(:ns) + 1
 
c     do i=1,ns
c       wk(i)=yc(is(i),3)
c     enddo
c     do i=1,ns
c       s(i)=wk(i)*d(i)
c     enddo
c     do i=1,ns
c       wk(i)=yc(is(i),2)
c     enddo
c     do i=1,ns
c       s(i)=(s(i)+wk(i))*d(i)
c     enddo
c     do i=1,ns
c       wk(i)=yc(is(i),1)
c     enddo
c     do i=1,ns
c       s(i)=(s(i)+wk(i))*d(i)
c     enddo
c     do i=1,ns
c       wk(i)=y(is(i))
c     enddo
c     do i=1,ns
c       s(i)=s(i)+wk(i)
c     enddo
      s = ((yc(is(:ns),3)*d+yc(is(:ns),2))*d+yc(is(:ns),1))*d+
     1   y(is(:ns))
      return 
      end subroutine mcsevu
      subroutine mcsevu1(h, x1, y, ny, yc, ic, ns, s, xs, ier)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer ny, ic, ns, ier
      real h, x1
      real, dimension(ny) :: y
      real, dimension(ic,3) :: yc
      real, dimension(ns) :: s, xs
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer, dimension(ns) :: is
      integer :: i
      real, dimension(ns) :: d, wk
C-----------------------------------------------
c---------------------------
c   given y(1:ny),yc(1:ny,1:3) at x(i)=x1+(i-1)*h
c   find s(1:ns)=first derivative of function at xs(1:ns)
c-----------------------------
      is = (xs - x1)/h
      is = min0(ny - 2,is)
      d = xs - (is*h + x1)
      is = is + 1
      wk = yc(is,3)
      s = 3.*wk*d
      wk = yc(is,2)
      s = (s + 2.*wk)*d
      wk = yc(is,1)
      s = s + wk
      return 
      end subroutine mcsevu1
c
      function simp (m, dx, fx)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
      real simp
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer m
      real dx
      real, dimension(1) :: fx
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i
C-----------------------------------------------
c
c $$$ Function to integrate using Simpson's rule.
c     Arguments:
c       m  : number of points
c       dx : uniform increment of independent variable
c       fx : function to be integrated
c
      simp = fx(1) + fx(m)
      simp = simp + sum(2.*fx(2:m-1))
      simp = simp + sum(2.*fx(2:m-1:2))
      simp = dx/3.*simp
      return 
      end function simp

      subroutine terp1(n, x, f, w, y, int, tab, itab)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer n, int
      real y
      integer, dimension(3) :: itab
      real, dimension(1) :: x, f, w
      real, dimension(3) :: tab
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i
C-----------------------------------------------
c
c
c dimension of           x(n),f(int*(n-1)+1),w(int*(n-1)+1),tab(3),
c arguments              itab(3)
c
c latest revision        february 1974
c
c usage                  call terp1 (n,x,f,w,y,int,tab,itab)
c
c arguments
c
c on input               n
c                          the number of data points.  n must be at
c                          least 4.
c
c                        x
c                          table of n independent variable values in
c                          ascending order.  dimension of x in the
c                          calling program must be at least n.
c
c                        f
c                          table of n corresponding dependent variable
c                          values separated by interval int, usually
c                          unity for one-dimensional interpolation.
c                          dimension of f in the calling program must be
c                          at least (int*(n-1)+1).
c
c                        w
c                          table of second derivatives computed by
c                          coeff1.  the separation of tabular entries is
c                          int.  dimension of w in the calling program
c                          must be at least (int*(n-1)+1).
c
c                        y
c                          value of the independent variable at which
c                          interpolation is required.  if y lies outside
c                          the range of the table, extrapolation takes
c                          place.
c
c                        int
c                          spacing of tabular entries in f and w arrays.
c                          this is usually unity for one-dimensional
c                          interpolation.
c
c                        itab
c                          three element integer array defining
c                          interpolation to be performed at y.
c                            if itab(1) = 1, the function value is
c                                            returned in tab(1).
c                            if itab(2) = 1, the first derivative is
c                                            returned in tab(2).
c                            if itab(3) = 1, the second derivative is
c                                            returned in tab(3).
c                          if itab(i) = 0 for i = 1, 2 or 3, the
c                          corresponding function value or derivative is
c                          not computed and tab(i) is not referenced.
c
c on output              tab
c                          three element array in which interpolated
c                          function value, first and second derivatives
c                          are returned as dictated by itab (see above).
c
c space required         47 (octal) = 39 (decimal)
c
c timing                 this procedure is fast.  the maximum time for
c                        the binary search is proportional to alog(n).
c                        the time for function and derivative evaluation
c                        is independent of n.  for 21 data points the
c                        time taken on the ncar 7600 is about
c                        80 microseconds.
c
c
c the following call is for gathering statistics on library use at ncar
c
c perform search
c
      call search (y, x, n, i)
c
c carry out interpolation (or extrapolation)
c
      call intrp (n, x, f, w, y, i, int, tab, itab)
      return 
      end subroutine terp1
      function terp2 (xb, yb, nx, x, ny, y, f, fxx, fyy, fxxyy,
     1                     idm, ixd, iyd)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real terp2
      integer nx, ny, idm, ixd, iyd
      real xb, yb
      real, dimension(1) :: x, y
      real, dimension(idm,1) :: f, fxx, fyy, fxxyy
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer, dimension(3) :: itab
      integer :: i, j, i1, j1, jj, n
      real, dimension(2) :: ff, ww
      real, dimension(3) :: tab
C-----------------------------------------------
c
c
c dimension of           x(nx),y(ny),f(idm,ny),fxx(idm,ny),fyy(idm,ny),
c arguments              fxxyy(idm,ny))
c                        (idm must be .ge. nx)
c
c latest revision        february 1974
c
c usage                  r = terp2 (xb,yb,nx,x,ny,y,f,fxx,fyy,fxxyy,idm,
c                                   ixd,iyd)
c
c arguments
c
c on input               xb, yb
c                          values of the independent variables, x and y,
c                          at which interpolation is required.
c
c                        nx
c                          number of grid points in the x-direction. nx
c                          must be at least 4.
c
c                        x
c                          table of nx values of the independent
c                          variable, x, arranged in ascending order.
c                          dimension of x in the calling program must be
c                          at least nx.
c
c                        ny
c                          number of grid points in the y-direction. ny
c                          must be at least 4.
c
c                        y
c                          table of ny values of the independent
c                          variable, y, arranged in ascending order.
c                          dimension of y in the calling program must be
c                          at least ny.
c
c                        f
c                          two-dimensional array of function values at
c                          grid points defined by the arrays x and y.
c                          dimension of f in the calling program is
c                          (idm,nyy), where
c                              idm .ge. nx
c                              nyy .ge. ny
c
c                        fxx
c                          array of second derivatives of f with respect
c                          to x computed by coeff2.  dimension of fxx in
c                          the calling program is (idm,nyy).  see under
c                          f above.
c
c                        fyy
c                          array of second derivatives of f with respect
c                          to y computed by coeff2.  dimension of fyy in
c                          the calling program is (idm,nyy).
c
c                        fxxyy
c                          array of fourth derivatives,
c                          (d/dx)**2*(d/dy)**2*f, computed by coeff2.
c                          dimension of fxxyy in the calling program is
c                          (idm,nyy).
c
c                        idm
c                          first dimension in the calling program of
c                          arrays f, fxx, fyy and fxxyy,
c                              idm .ge. nx
c
c                        ixd, iyd
c                          define derivative to be returned by the
c                          function terp2.  ixd, iyd may each take the
c                          the values 0, 1, 2.  the derivative returned
c                          is (d/dx)**ixd*(d/dy)**iyd*f.
c                            note that if ixd = iyd = 0, the function
c                            value itself is returned.
c
c space required         220 (octal) = 144 (decimal)
c
c timing                 this procedure is fast.  the maximum time for
c                        the binary search is proportional to
c                        alog(nx*ny).  the time for function evaluation
c                        is independent of n.  for a 21 x 21 grid of
c                        data points, an average time for an
c                        interpolation on the ncar cdc 7600 is about
c                        .29 milliseconds.
c
c
c
c
c the following call is for gathering statistics on library use at ncar
c
c search in x and y arrays.
c
      call search (xb, x, nx, i)
      call search (yb, y, ny, j)
c
c interpolate in x direction
c
      itab = 0
      i1 = ixd + 1
      itab(i1) = 1
      do j1 = 1, 2
         jj = j + j1 - 1
         call intrp (n, x, f(1,jj), fxx(1,jj), xb, i, 1, tab, itab)
         ff(j1) = tab(i1)
         call intrp (n, x, fyy(1,jj), fxxyy(1,jj), xb, i, 1, tab,
     1               itab)
         ww(j1) = tab(i1)
      end do
c
c interpolate in y direction
c
      itab = 0
      j1 = iyd + 1
      itab(j1) = 1
      call intrp (2, y(j), ff, ww, yb, 1, 1, tab, itab)
      terp2 = tab(j1)
      return 
      end function terp2

      function terp2p (xb, yb, nx, x, ny, y, f, fxx, fyy, fxxyy, 
     1   idm, ixd, iyd, isrch)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real terp2p
      integer nx, ny, idm, ixd, iyd, isrch
      real xb, yb
      real, dimension(1) :: x, y
      real, dimension(idm,1) :: f, fxx, fyy, fxxyy
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer, dimension(3) :: itab
      integer :: i, j, isav, jsav, i1, j1, jj, n
      real, dimension(2) :: ff, ww
      real, dimension(3) :: tab

      save ff, ww, tab, itab, i, j, isav, jsav, i1, j1, jj, n
C-----------------------------------------------
c
c Modified terp2 by adding isrch:  Binary search of grid for
c                    interpolation point is carried out only if
c                    isrch=1.  Otherwise, it is assumed that values
c                    have been generated by a previous call.
c
c
c dimension of           x(nx),y(ny),f(idm,ny),fxx(idm,ny),fyy(idm,ny),
c arguments              fxxyy(idm,ny))
c                        (idm must be .ge. nx)
c
c latest revision        february 1974
c
c usage                  r = terp2 (xb,yb,nx,x,ny,y,f,fxx,fyy,fxxyy,idm,
c                                   ixd,iyd)
c
c arguments
c
c on input               xb, yb
c                          values of the independent variables, x and y,
c                          at which interpolation is required.
c
c                        nx
c                          number of grid points in the x-direction. nx
c                          must be at least 4.
c
c                        x
c                          table of nx values of the independent
c                          variable, x, arranged in ascending order.
c                          dimension of x in the calling program must be
c                          at least nx.
c
c                        ny
c                          number of grid points in the y-direction. ny
c                          must be at least 4.
c
c                        y
c                          table of ny values of the independent
c                          variable, y, arranged in ascending order.
c                          dimension of y in the calling program must be
c                          at least ny.
c
c                        f
c                          two-dimensional array of function values at
c                          grid points defined by the arrays x and y.
c                          dimension of f in the calling program is
c                          (idm,nyy), where
c                              idm .ge. nx
c                              nyy .ge. ny
c
c                        fxx
c                          array of second derivatives of f with respect
c                          to x computed by coeff2.  dimension of fxx in
c                          the calling program is (idm,nyy).  see under
c                          f above.
c
c                        fyy
c                          array of second derivatives of f with respect
c                          to y computed by coeff2.  dimension of fyy in
c                          the calling program is (idm,nyy).
c
c                        fxxyy
c                          array of fourth derivatives,
c                          (d/dx)**2*(d/dy)**2*f, computed by coeff2.
c                          dimension of fxxyy in the calling program is
c                          (idm,nyy).
c
c                        idm
c                          first dimension in the calling program of
c                          arrays f, fxx, fyy and fxxyy,
c                              idm .ge. nx
c
c                        ixd, iyd
c                          define derivative to be returned by the
c                          function terp2.  ixd, iyd may each take the
c                          the values 0, 1, 2.  the derivative returned
c                          is (d/dx)**ixd*(d/dy)**iyd*f.
c                            note that if ixd = iyd = 0, the function
c                            value itself is returned.
c
c space required         220 (octal) = 144 (decimal)
c
c timing                 this procedure is fast.  the maximum time for
c                        the binary search is proportional to
c                        alog(nx*ny).  the time for function evaluation
c                        is independent of n.  for a 21 x 21 grid of
c                        data points, an average time for an
c                        interpolation on the ncar cdc 7600 is about
c                        .29 milliseconds.
c
c
c
c
c the following call is for gathering statistics on library use at ncar
c
c search in x and y arrays.
c
      if (isrch == 1) then
         call search (xb, x, nx, i)
         call search (yb, y, ny, j)
         isav = i
         jsav = j
      endif
c
c interpolate in x direction
c
      itab = 0
      i1 = ixd + 1
      itab(i1) = 1
      do j1 = 1, 2
         jj = jsav + j1 - 1
         call intrp (n, x, f(1,jj), fxx(1,jj), xb, isav, 1, tab, itab)
         ff(j1) = tab(i1)
         call intrp (n, x, fyy(1,jj), fxxyy(1,jj), xb, isav, 1, tab, 
     1      itab)
         ww(j1) = tab(i1)
      end do
c
c interpolate in y direction
c
      itab = 0
      j1 = iyd + 1
      itab(j1) = 1
      call intrp (2, y(jsav), ff, ww, yb, 1, 1, tab, itab)
      terp2p = tab(j1)
      return 
      end function terp2p
 
      subroutine trap2(x, y, yint, npts)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer npts
      real, dimension(1) :: x, y, yint
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i
C-----------------------------------------------
c-------------------------------------------
c   calculates integral y*dx using trapezoidal
c       rule
c--------------------------------------------
      yint(1) = 0.
      do i = 2, npts
         yint(i) = (y(i)+y(i-1))*(x(i)-x(i-1))*0.5 + yint(i-1)
      end do
      return 
      end subroutine trap2
      subroutine trapl(r, y, nj, xint)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nj
      real xint
      real, dimension(1) :: r, y
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: j
C-----------------------------------------------
c
c this subroutine integrates y(r) with respect to r from
c   zero to rminor.  the trapezoidal rule is used.
c
      xint = dot_product(.5*(y(2:nj)+y(:nj-1)),r(2:nj)-r(:nj-1))
      return 
      end subroutine trapl

      function valspl (h, c, nprofn, i, jderiv)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:56 6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real valspl
      integer nprofn, i, jderiv
      real h
      real, dimension(nprofn,4) :: c
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
C-----------------------------------------------
c ********** ********** ********** ********** ********** **********
c                                                                 *
c  this subroutine evaluates the cubic spline value               *
c        the function stored in the table c(j,1)                  *
c                                                                 *
c ********** ********** ********** ********** ********** **********
c ---------- ---------- ---------- ---------- ---------- ----------
      select case (jderiv) 
      case (0) 
         valspl = c(i,1) + h*(c(i,2)+0.5*h*(c(i,3)+0.333333333333*h
     1      *c(i,4)))
      case (1) 
         valspl = c(i,2) + h*(c(i,3)+0.5*h*c(i,4))
      case (2) 
         valspl = c(i,3) + h*c(i,4)
      case (3) 
         valspl = c(i,4)
      end select
c ---------- ---------- ---------- ---------- ---------- ----------
      return 
      end function valspl
c
      function spln0 (s0, sh, sp0, sph, h, d)
      implicit none
      real spln0
      real s0
      real sh
      real sp0
      real sph
      real h
      real d
      spln0 = s0 + d*(h*sp0 + d*(3.*(sh - s0) - (sph + 2.*sp0)*h + d*(2.
     1   *(s0 - sh) + (sph + sp0)*h)))
      return 
      end function spln0

      function spln1 (s0, sh, sp0, sph, h, d)
      implicit none
      real spln1
      real s0
      real sh
      real sp0
      real sph
      real h
      real d
      spln1 = sp0 + d*(6.*(sh - s0)/h - 2.*(sph + 2.*sp0) + 3.*d*(2.*(s0
     1    - sh)/h + (sph + sp0)))
      return 
      end function spln1

      function spln2 (s0, sh, sp0, sph, h, d)
      implicit none
      real spln2
      real s0
      real sh
      real sp0
      real sph
      real h
      real d
      spln2 = 6.*(sh - s0)/h**2 - 2.*(sph + 2.*sp0)/h + d*(2.*(s0 - sh)/
     1   h**2 + (sph + sp0)/h)*6.
      return 
      end function spln2
c
      function terp (g1, g2, g3, g4)
      use Vterppars, only: a12, a13, a14, a23, a24, a34
      implicit none
      real terp
      real :: g1,g2,g3,g4
      terp = (1./a12 + 1./a13 + 1./a14)*g1 - a13*a14/(a12*a23*a24)*g2 + 
     1   a12*a14/(a13*a23*a34)*g3 - a12*a13/(a14*a24*a34)*g4
      return 
      end function terp
c
      integer function ii (index,int)
      integer index, int
      ii = (index - 1)*int + 1
      return 
      end function ii         

      subroutine trip(n, a, b, c, y, z, int)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:58:46   6/14/01
C...Switches: -p4 -yb
C
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer n, int
      real, dimension(n) :: a, b, c, y
      real, dimension(*) :: z
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: index, nm2, j, nm1, in, k, ik
      real :: bn, yn, v, den
C-----------------------------------------------
C   I n t e r n a l   F u n c t i o n s
C-----------------------------------------------
c      integer ii
C-----------------------------------------------
c                             
c arithmetic statement function used to locate entries in array z.
c
c
c gaussian elimination
c
      bn = b(n)
      yn = y(n)
      v = c(n)
      y(1) = y(1)/b(1)
      a(1) = a(1)/b(1)
      b(1) = c(1)/b(1)
      nm2 = n - 2
      do j = 2, nm2
         den = b(j) - a(j)*b(j-1)
         b(j) = c(j)/den
         y(j) = (y(j)-a(j)*y(j-1))/den
         a(j) = -a(j)*a(j-1)/den
         bn = bn - v*a(j-1)
         yn = yn - v*y(j-1)
         v = -v*b(j-1)
      end do
      den = b(n-1) - a(n-1)*b(n-2)
      b(n-1) = (c(n-1)-a(n-1)*a(n-2))/den
      y(n-1) = (y(n-1)-a(n-1)*y(n-2))/den
      bn = bn - v*a(n-2)
      yn = yn - v*y(n-2)
      v = a(n) - v*b(n-2)
c
c back substitution
c
      z(ii(n)) = (yn - v*y(n-1))/(bn - v*b(n-1))
      z(ii(n-1)) = y(n-1) - b(n-1)*z(ii(n))
      nm1 = n - 1
      in = ii(n)
      do j = 2, nm1
         k = n - j
         ik = ii(k)
         z(ik) = y(k) - b(k)*z(ik+int) - a(k)*z(in)
      end do
      return
      contains
         integer function ii(k)
         integer :: k
         ii = (k-1)*int+1
         return
         end function ii
      end subroutine trip


      subroutine search(xbar, x, n, i)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:58:46   6/14/01
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer n, i
      real xbar
      real, dimension(*) :: x
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: m, k, nm1
      real :: b
C-----------------------------------------------
      data b/.69314718/
c
c if xbar is outside range of x table extrapolate
c
      if (xbar <= x(2)) then
         i = 1
         return
      endif
      if (xbar >= x(n-1)) then
         i = n - 1
         return
      endif
c
c find maximum power of two less than n
c
      m = int(alog(real(n))/b)
      i = 2**m
      if (i >= n) i = i/2
      k = i
      nm1 = n - 1
c
c conduct binary search.       
c
  103 continue
      k = k/2
 1002 continue
      if (xbar >= x(i)) go to 104
      i = i - k
      k = k/2
      if (xbar >= x(i)) go to 104
      i = i - k
      k = k/2
      if (xbar >= x(i)) go to 104
      i = i - k
      k = k/2
      if (xbar >= x(i)) go to 104
      i = i - k
      k = k/2
      go to 1002
  104 continue
      if (xbar <= x(i+1)) return
      i = min0(i + k,nm1)
      go to 103
      end subroutine search             

C   IMSL ROUTINE NAME   - ICSICU
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JANUARY 1, 1978
C
C   PURPOSE             - INTERPOLATORY APPROXIMATION BY CUBIC SPLINES
C                           WITH ARBITRARY SECOND DERIVATIVE END
C                           CONDITIONS.
C
C   USAGE               - CALL ICSICU (X,Y,NX,BPAR,C,IC,IER)
C
C   ARGUMENTS    X      - VECTOR OF LENGTH NX CONTAINING THE ABSCISSAE
C                           OF THE NX DATA POINTS (X(I),Y(I)) I=1,...,
C                           NX. (INPUT) X MUST BE ORDERED SO THAT
C                           X(I) .LT. X(I+1).
C                Y      - VECTOR OF LENGTH NX CONTAINING THE ORDINATES
C                           (OR FUNCTION VALUES) OF THE NX DATA POINTS.
C                           (INPUT)
C                NX     - NUMBER OF ELEMENTS IN X AND Y. (INPUT) NX
C                           MUST BE .GE. 2.
C                BPAR   - VECTOR OF LENGTH 4 CONTAINING THE END
C                           CONDITION PARAMETERS. (INPUT)
C                           2.0*SPP(1)+BPAR(1)*SPP(2) = BPAR(2),
C                           BPAR(3)*SPP(NX-1)+2.0*SPP(NX) = BPAR(4),
C                           WHERE SPP(I) = SECOND DERIVATIVE OF THE
C                           CUBIC SPLINE FUNCTION S EVALUATED AT X(I).
C                C      - SPLINE COEFFICIENTS. (OUTPUT) C IS AN NX-1 BY
C                           3 MATRIX. THE VALUE OF THE SPLINE
C                           APPROXIMATION AT T IS
C                           S(T) = ((C(I,3)*D+C(I,2))*D+C(I,1))*D+Y(I)
C                           WHERE X(I) .LE. T .LT. X(I+1) AND
C                           D = T-X(I).
C                IC     - ROW DIMENSION OF MATRIX C EXACTLY AS
C                           SPECIFIED IN THE DIMENSION STATEMENT IN
C                           THE CALLING PROGRAM. (INPUT)
C                IER    - ERROR PARAMETER. (OUTPUT)
C                         TERMINAL ERROR
C                           IER = 129, IC IS LESS THAN NX-1.
C                           IER = 130, NX IS LESS THAN 2.
C                           IER = 131, INPUT ABSCISSA ARE NOT ORDERED
C                             SO THAT X(1) .LT. X(2) ... .LT. X(NX).
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1978 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE ICSICU (X,Y,NX,BPAR,C,IC,IER)
C                                  SPECIFICATIONS FOR ARGUMENTS
      INTEGER            NX,IC,IER
      REAL               X(NX),Y(NX),BPAR(4),C(IC,3)
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      INTEGER            I,J,NXM1
      REAL               DX,DXJ,DXJP1,DXP,DYJ,DYJP1,HALF,ONE,PJ,
     1                   SIX,SIXI,TWO,YPPA,YPPB,ZERO
      EQUIVALENCE        (DXJ,YPPB),(PJ,SIXI),(DXJP1,YPPA)
      DATA               ZERO/0.0/,HALF/0.5/,ONE/1.0/,
     1                   TWO/2.0/,SIX/6.0/
C                                  FIRST EXECUTABLE STATEMENT
      IER = 0
C                                  CHECK ERROR CONDITIONS
      NXM1 = NX-1
      IF (IC .LT. NXM1) GO TO 30
      IF (NX .LT. 2) GO TO 35
      IF (NX .EQ. 2) GO TO 10
C                                  COMPUTE COEFFICIENTS AND RIGHT
C                                  HAND SIDE OF THE TRIDIAGONAL
C                                  SYSTEM DEFINING THE SECOND
C                                  DERIVATIVES OF THE SPLINE
C                                  INTERPOLANT FOR (X,Y)
C                                  C(J,1) = LAMBDA(J)
C                                  C(J,2) = MU(J)
C                                  C(J,3) = D(J)
      DXJ = X(2)-X(1)
      J = 1
      IF (DXJ .LE. ZERO) GO TO 40
      DYJ = Y(2)-Y(1)
      DO 5 J=2,NXM1
         DXJP1 = X(J+1)-X(J)
         IF (DXJP1 .LE. ZERO) GO TO 40
         DYJP1 = Y(J+1)-Y(J)
         DXP = DXJ+DXJP1
         C(J,1) = DXJP1/DXP
         C(J,2) = ONE-C(J,1)
         C(J,3) = SIX*(DYJP1/DXJP1-DYJ/DXJ)/DXP
         DXJ = DXJP1
         DYJ = DYJP1
    5 CONTINUE
C                                  FACTOR THE TRIDIAGONAL MATRIX
C                                  AND SOLVE FOR U
C                                  C(J,2) = U(J)
C                                  C(J,1) = Q(J)
C                                  BPAR(1) = LAMBDA(1)
C                                  BPAR(2) = D(1)
C                                  BPAR(3) = MU(NX)
C                                  BPAR(4) = D(NX)
   10 C(1,1) = -BPAR(1)*HALF
      C(1,2) = BPAR(2)*HALF
      IF (NX .EQ. 2) GO TO 20
      DO 15 J=2,NXM1
         PJ = C(J,2)*C(J-1,1)+TWO
         C(J,1) = -C(J,1)/PJ
         C(J,2) = (C(J,3)-C(J,2)*C(J-1,2))/PJ
   15 CONTINUE
C                                  SOLVE FOR CUBIC COEFFICIENTS
C                                  OF SPLINE INTERPOLANT
C                                  C(J,1), C(J,2), AND C(J,3)
   20 YPPB = (BPAR(4)-BPAR(3)*C(NXM1,2))/(BPAR(3)*C(NXM1,1)+TWO)
      SIXI = ONE/SIX
      DO 25 I=1,NXM1
         J = NX-I
         YPPA = C(J,1)*YPPB+C(J,2)
         DX = X(J+1)-X(J)
         C(J,3) = SIXI*(YPPB-YPPA)/DX
         C(J,2) = HALF*YPPA
         C(J,1) = (Y(J+1)-Y(J))/DX-(C(J,2)+C(J,3)*DX)*DX
         YPPB = YPPA
   25 CONTINUE
      GO TO 9005
   30 IER = 129
      GO TO 9000
   35 IER = 130
      GO TO 9000
   40 IER = 131
 9000 CONTINUE
      CALL UERTST(IER,'ICSICU')
 9005 RETURN
      END

      module Vctransp
      use kind_spec

C...Created by Pacific-Sierra Research VAST-90 2.06G2  12:29:44   5/18/01
      use Vparam, only : nprofm, nions
      integer :: nrho_tr
      real(kind=dp),dimension(nprofm) :: xrho_tr, ne_tr, te_tr, elp_tr
      real(kind=dp),dimension(nprofm,nions) :: ni_tr, ti_tr
      end module Vctransp

c---------------------------------------
c-
c- file: icsicu.f
c-
c- purpose: replaces imsl routine icsicu
c-
c----------------------------------------
       subroutine icsicu(x, y, nx, bpar, c, ic, ier)
c
c-- x(nx) x values for data points, must satisfy x(i) < x(i+1)
c-- y(nx) y values
c-- nx - number of points
c-- bpar(4) end condition parameters
c       2*s''(1) + bpar(1) == bpar(2)
c       bpar(3)*s''(nx-1) + 2*s''(nx) = bpar(4)
c-- c(ic, 3) - spline coefficients c(nx-1,3)
c--     s(t) = ((c(i,3)*d+c(i,2)*d)+c(i,1)*d + y(i)
c---        d = t - x(i)
c-- ic - row dim of c
c-- ier - error codes:
c
c      ier = 129 for ic < nx-1
c      ier = 130 for nx < 2
c      ier = 131 for unorder x's
c----------------------------------------------
      implicit none
      integer nx, ic, ier
      real*8 x(nx), y(nx), bpar(4), c(ic,3)
      real*8 dxj, dyj, dxjp1, dyjp1, dxp, dx
      real*8 yppa, yppb, pj
      integer j, i
      integer nxm1
      ier = 0
      nxm1 = nx-1
c--- test that x values are ordered and input sane
      do j=2, nxm1
        if(x(j+1).le.x(j)) then
           ier = 133
        endif
      end do
      if( nx .lt. 2) then
        ier = 130
      end if
      if( ic < nxm1) then
        ier = 129
      endif
      if( ier .ne. 0) then
        call uertst(ier, 6hicsicu)
        return
      endif
c--- if nx bigger than 2, setup tridiagonal matrix
      if( nx .gt. 2 ) then
        dxj = x(2) - x(1)
        dyj = y(2) - y(1)
        do j=2, nxm1
          dxjp1 = x(j+1)-x(j)
          dyjp1 = y(j+1)-y(j)
          dxp = dxj+ dxjp1
          c(j,1) = dxjp1/dxp
          c(j,2) = 1.0-c(j,1)
          c(j,3) = 6.0*(dyjp1/dxjp1 - dyj/dxj)/dxp
          dxj = dxjp1
          dyj = dyjp1
        end do
      end if
c--- solve
      c(1,1) = -bpar(1)*0.5
      c(1,2) =  bpar(2)*0.5
      if(nx .gt. 2) then
        do j=2, nxm1
          pj = c(j,2)*c(j-1,1) + 2.0
          c(j,1)= -c(j,1)/pj
          c(j,2) = (c(j,3) - c(j,2)*c(j-1,2))/pj
        end do
      end if
c--- back substitution
      yppb = (bpar(4)-bpar(3)*c(nxm1,2))/(bpar(3)*c(nxm1,1)+2.0)
      do i=1, nxm1
        j= nx - i
        yppa = c(j,1)*yppb+c(j,2)
        dx = x(j+1)-x(j)
        c(j,3) = (yppb-yppa)/(6.0*dx)
        c(j,2) = 0.5*yppa
        c(j,1) = (y(j+1)-y(j))/dx-(c(j,2)+c(j,3)*dx)*dx
        yppb = yppa
      end do
      return
      end

c---
c   file: bescheck.f
c   purpose:   to test r8slatec bessel routines as replacements for imsl routines.
c   author: J. C. Wiley 6/20/01
c---
      use kind_spec
      implicit none
      integer k, j
      real(kind=dp) work(101), work2(101)
      real(kind=dp) ix(10)
      integer ik(5)
      integer iier, ier
      integer nli
      real(kind=dp) diff
      integer jj, jjj
c--- rsla library constants
      print*,'d1mach1 ',d1mach1
      print*,'d1mach2 ',d1mach2
      print*,'d1mach3 ',d1mach3
      print*,'d1mach4 ',d1mach4
      print*,'d1mach5 ',d1mach5
c---
c    Sample values for mmbsir called from mlibfn.f
c    Typical value nli = 101, x from 0.01 to 100
c---
      nli = 101
      ix(1) = 0.01
      ix(2) = 0.05
      ix(3) = 1.0
      ix(4) = 5.0
      ix(5) = 10.0
      ix(6) = 20.0
      ix(7) = 40.0
      ix(8) = 60.0
      ix(9) = 90.0
      ix(10)= 100.0
      ik(1) = 1
      ik(2) = 5
      ik(3) = 50
      ik(4) = 90
      ik(5) = 100
      print *,' compare mmbsir and dbesi '
      print *,'   x, nu, e_imsl, e_r8, imsl, slatec, delta'
      do k=1,10
        call mmbsir(ix(k), 0.0, nli, 2, work, iier)
        if(iier .gt. 129) then
        jj = iier -129
        do jjj= jj, nli
          work(jjj) = 0
        end do
        end if
        call dbesi(ix(k), 0.0, 2, nli, work2, ier)
        if(ier .gt. 0) then
          do jjj = ier, nli
            work2(jjj) = 0
          end do
        end if
c-------------------------------------------------------------------------
        do j = 1, 5
          diff= work(ik(j))-work2(ik(j))
          print 600,ix(k),ik(j),iier,ier,work(ik(j)),work2(ik(j)),diff
        end do
      enddo
  600 format(f8.2, i4 ,i4, i4, e21.13, e21.13, e21.13)
c---
c    Sample value for mmbskr called from orbit.f
c    Typical values for x are from 861 to 950
c---
      print *, 'compare mmbskr and dbesk '
      ix(1) = 700
      ix(2) = 800
      ix(3) = 850
      ix(4) = 900
      ix(5) = 950
      do k=1,5
        call mmbskr(ix(k), 0.0, 3, work, ier)
        call dbesk(ix(k), 0.0, 2, 3, work2, iier)
        do j = 1, 3
          diff = work(j)-work2(j)
          print 600,ix(k),j,iier,ier,work(j), work2(j),diff
        end do
      end do
      end

      SUBROUTINE IBCCCU (F,X,NX,Y,NY,C,IC,WK,IER)
C                                  SPECIFICATIONS FOR ARGUMENTS
      INTEGER            NX,NY,IC,IER
      REAL               F(IC,1),X(1),Y(1),C(2,IC,1),WK(1)
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      INTEGER            IWK
C                                  FIRST EXECUTABLE STATEMENT
      IER = 129
      IF (IC .LT. NX) GO TO 9000
      IER = 130
      IF (NX .LT. 4) GO TO 9000
      IER = 131
      IF (NY .LT. 4) GO TO 9000
      IWK = 2*NY*NX
      CALL IBCDCU(X,F,NX,NY,WK(IWK+1),WK,IC,NY,IER)
      IF (IER .GT. 0) GO TO 9000
      CALL IBCDCU(Y,WK,NY,2*NX,WK(IWK+1),C,NY,2*IC,IER)
      IF (IER .EQ. 0) GO TO 9005
 9000 CONTINUE
      CALL UERTST(IER,'IBCCCU')
 9005 RETURN
      END

! 07Jun1999 fgtok -impno -s r8_precision.sub r8_names.table "r8con.csh conversion"
      subroutine r8splinck(x, inx, ilinx, ztol, ier)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer inx, ilinx, ier
      real*8 ztol
      real*8, dimension(inx) :: x
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: ix
      real*8 :: dxavg, zeps, zdiffx, zdiff
C-----------------------------------------------
C============
C idecl:  explicitize implicit INTEGER declarations:
C============
C idecl:  explicitize implicit REAL declarations:
C============
C
C
C
C
C  ier=1 is returned if x(1...inx) is NOT STRICTLY ASCENDING...
C
C-------------------------------
C
      ier = 0
      ilinx = 1
      if (inx <= 1) return 
c
      dxavg = (x(inx)-x(1))/(inx - 1)
      zeps = abs(ztol*dxavg)
c
      do ix = 2, inx
         zdiffx = x(ix) - x(ix-1)
         if (zdiffx <= 0.0D0) ier = 2
         zdiff = zdiffx - dxavg
         if (abs(zdiff) > zeps) ilinx = 2
      end do
c
      return 
      end subroutine r8splinck

C   IMSL ROUTINE NAME   - IBCCCU
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JUNE 1, 1982
C
C   PURPOSE             - BICUBIC SPLINE TWO-DIMENSIONAL COEFFICIENT
C                           CALCULATOR
C
C   USAGE               - CALL IBCCCU (F,X,NX,Y,NY,C,IC,WK,IER)
C
C   ARGUMENTS    F      - NX BY NY MATRIX CONTAINING THE FUNCTION
C                           VALUES. (INPUT) F(I,J) IS THE FUNCTION VALUE
C                           AT THE POINT (X(I),Y(J)) FOR I=1,...,NX AND
C                           J=1,...,NY.
C                X      - VECTOR OF LENGTH NX. (INPUT) X MUST BE
C                           ORDERED SO THAT X(I) .LT. X(I+1) FOR
C                           I=1,...,NX-1.
C                NX     - NUMBER OF ELEMENTS IN X. (INPUT) NX MUST BE
C                           .GE. 4.
C                Y      - VECTOR OF LENGTH NY. (INPUT) Y MUST BE
C                           ORDERED SO THAT Y(J) .LT. Y(J+1) FOR
C                           J=1,...,NY-1.
C                NY     - NUMBER OF ELEMENTS IN Y. (INPUT) NY MUST BE
C                           .GE. 4.
C                         NOTE - THE COORDINATE PAIRS (X(I),Y(J)), FOR
C                           I=1,...,NX AND J=1,...,NY, GIVE THE POINTS
C                           WHERE THE FUNCTION VALUES F(I,J) ARE
C                           DEFINED.
C                C      - ARRAY OF SPLINE COEFFICIENTS. (OUTPUT)
C                           C IS OF DIMENSION 2 BY NX BY 2 BY NY.
C                           AT THE POINT (X(I),Y(J))
C                             C(1,I,1,J) = S
C                             C(2,I,1,J) = DS/DX
C                             C(1,I,2,J) = DS/DY
C                             C(2,I,2,J) = D(DS/DX)/DY
C                           WHERE S(X,Y) IS THE SPLINE APPROXIMATION.
C                           (NOTE - C IS TREATED INTERNALLY AS A
C                             2 BY NX BY 2*NY ARRAY BECAUSE CERTAIN
C                             ENVIRONMENTS DO NOT PERMIT QUADRUPLY-
C                             DIMENSIONED ARRAYS.  IN THESE
C                             ENVIRONMENTS THE CALLING PROGRAM MAY
C                             DIMENSION C IN THE SAME MANNER.)
C                IC     - ROW DIMENSION OF MATRIX F AND SECOND
C                           DIMENSION OF ARRAY C EXACTLY AS
C                           SPECIFIED IN THE DIMENSION STATEMENT.
C                           (INPUT). IC MUST BE .GE. NX.
C                WK     - WORK VECTOR OF LENGTH
C                           2*NX*NY+2*MAX(NX,NY)
C                IER    - ERROR PARAMETER. (OUTPUT)
C                         TERMINAL ERROR
C                           IER = 129, IC IS LESS THAN NX
C                           IER = 130, NX IS LESS THAN 4
C                           IER = 131, NY IS LESS THAN 4
C                           IER = 132, X OR Y ARE NOT ORDERED SO THAT
C                             X(I) .LT. X(I+1) AND
C                             Y(I) .LT. Y(I+1)
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - IBCDCU,UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE IBCCCU (F,X,NX,Y,NY,C,IC,WK,IER)
C                                  SPECIFICATIONS FOR ARGUMENTS
      INTEGER            NX,NY,IC,IER
      REAL               F(IC,1),X(1),Y(1),C(2,IC,1),WK(1)
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      INTEGER            IWK
C                                  FIRST EXECUTABLE STATEMENT
      IER = 129
      IF (IC .LT. NX) GO TO 9000
      IER = 130
      IF (NX .LT. 4) GO TO 9000
      IER = 131
      IF (NY .LT. 4) GO TO 9000
      IWK = 2*NY*NX
      CALL IBCDCU(X,F,NX,NY,WK(IWK+1),WK,IC,NY,IER)
      IF (IER .GT. 0) GO TO 9000
      CALL IBCDCU(Y,WK,NY,2*NX,WK(IWK+1),C,NY,2*IC,IER)
      IF (IER .EQ. 0) GO TO 9005
 9000 CONTINUE
      CALL UERTST(IER,'IBCCCU')
 9005 RETURN
      END

C   IMSL ROUTINE NAME   - MMBSKR
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/DOUBLE
C
C   LATEST REVISION     - JUNE 1, 1982
C
C   PURPOSE             - MODIFIED BESSEL FUNCTION OF THE SECOND KIND
C                           OF NONNEGATIVE REAL FRACTIONAL ORDER
C                           FOR REAL POSITIVE ARGUMENTS SCALED BY
C                           EXP(ARG)
C
C   USAGE               - CALL MMBSKR (ARG,ORDER,N,BK,IER)
C
C   ARGUMENTS    ARG    - INPUT ARGUMENT. ARG MUST BE TYPED APPRO-
C                           PRIATELY IN THE CALLING PROGRAM. (SEE THE
C                           PRECISION/HARDWARE SECTION.) ARG MUST BE
C                           GREATER THAN ZERO.
C                ORDER  - INPUT VALUE SPECIFYING THE DESIRED ORDER OF
C                           THE BESSEL FUNCTION. ORDER MUST BE TYPED
C                           APPROPRIATELY IN THE CALLING PROGRAM. (SEE
C                           THE PRECISION/HARDWARE SECTION.) ORDER MUST
C                           BE GREATER THAN OR EQUAL TO ZERO.
C                N       - INPUT VALUE SPECIFYING THE NUMBER OF
C                           FUNCTION VALUES TO BE COMPUTED.
C                BK     - OUTPUT VECTOR OF LENGTH N CONTAINING THE
C                           COMPUTED FUNCTION VALUES. BK MUST BE TYPED
C                           APPROPRIATELY IN THE CALLING PROGRAM. (SEE
C                           THE PRECISION/HARDWARE SECTION.) BK(1) WILL
C                           CONTAIN THE COMPUTED VALUE FOR THE INPUT
C                           ORDER, BK(2) WILL CONTAIN THE COMPUTED
C                           FUNCTION VALUE FOR ORDER + 1, BK(3) FOR
C                           ORDER + 2, ETC.
C                IER    - ERROR PARAMETER. (OUTPUT)
C                         TERMINAL ERROR
C                           IER = 129 INDICATES THAT ONE OR MORE OF
C                             THE INPUT ARGUMENTS, ARG, ORDER, OR N IS
C                             OUT OF RANGE. BK(I), I=1,N, IS SET TO
C                             MACHINE INFINITY.
C                           IER = 130 INDICATES THAT BK(1) IS GREATER
C                             THAN MACHINE INFINITY. BK(I), I=1,N, IS
C                             SET TO MACHINE INFINITY.
C                           IER = 131 INDICATES THAT BK(N)/BK(N-1) IS
C                             GREATER THAN MACHINE INFINITY, BUT THAT
C                             BK(1) IS COMPUTED CORRECTLY.  BK(I),
C                             I=2,N, IS SET TO MACHINE INFINITY.
C                           IER = 131+J INDICATES THAT BK(J) WOULD HAVE
C                             BEEN GREATER THAN MACHINE INFINITY.
C                             BK(L), L=J,N, IS SET TO MACHINE INFINITY.
C                             BK(L), L=1,J-1, IS COMPUTED CORRECTLY.
C
C   PRECISION/HARDWARE  - DOUBLE/H32,H36
C                       - SINGLE/H48,H60
C
C   REQD. IMSL ROUTINES - UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MMBSKR (ARG,ORDER,N,BK,IER)
C                                  SPECIFICATIONS FOR ARGUMENTS
      INTEGER            N,IER
      DOUBLE PRECISION   ARG,ORDER,BK(1)
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      DOUBLE PRECISION   DMINF,DNTEN,EX,TEMP,TEMP2
      DOUBLE PRECISION   A,ALPHA,BK1,BK2,C,D,DM,DMAX,DMIN,D1,D2,D3,ENU,
     *                   F0,F1,F2,P(8),P0,Q(7),Q0,R(4),RATIO,S(4),T(7),
     *                   TOL,TWONU,TWOX,T1,T2,X2BY4,XINF
      DATA               A/.1159315156584124D0/
      DATA               D/.7978845608028654D0/
      DATA               DNTEN/38.D0/
      DATA               DMIN/2.938735878D-39/
      DATA               XINF/1.700000000D+38/
      DATA               P(1) /.8056298755690433D0/
      DATA               P(2) /.2040455002053652D02/
      DATA               P(3) /.1577056051066762D03/
      DATA               P(4) /.5366711164692075D03/
      DATA               P(5) /.9003827592912888D03/
      DATA               P(6) /.7309238866506604D03/
      DATA               P(7) /.2292993015094251D03/
      DATA               P(8) /.8224670334241132D00/
      DATA               Q(1) /.2946019862478505D02/
      DATA               Q(2) /.2775778685102212D03/
      DATA               Q(3) /.1206703255910274D04/
      DATA               Q(4) /.2762914441597915D04/
      DATA               Q(5) /.3443740505065646D04/
      DATA               Q(6) /.2210631901133786D04/
      DATA               Q(7) /.5722673383598922D03/
      DATA               R(1) /-.1363145832225935D-02/
      DATA               R(2) /.3314384097399805D-01/
      DATA               R(3) /-.2506099471699884D0/
      DATA               R(4) /.8224670334241132D0/
      DATA               S(1) /.2755746186513600D-02/
      DATA               S(2) /-.6530826876446539D-01/
      DATA               S(3) / .5187115283864121D0/
      DATA               S(4) /-.1456159004551443D01/
      DATA               T(1) /.0779373862881377D-12/
      DATA               T(2) /.1605596120426673D-09/
      DATA               T(3) /.2505214205064134D-07/
      DATA               T(4) /.2755731902076135D-05/
      DATA               T(5) /.1984126984193444D-03/
      DATA               T(6) /.8333333333332269D-02/
      DATA               T(7) /.1666666666666667D0/
      DATA               TOL  /2.775557562D-17/
C                                  A = DLOG(2.D0) - EULER S CONSTANT
C                                  D = DSQRT(2.D0/PI)
C                                  P, Q - APPROXIMATION FOR
C                                    DLOG(DGAMMA(1+ENU))/ENU + EULER S
C                                    CONSTANT
C                                  R, S - APPROXIMATION FOR
C                                    (1-ENU*PI/DSIN(ENU*PI))/(2.D0*ENU)
C                                  T - APPROXIMATION FOR DSINH(Y)/Y
C
C                                  FIRST EXECUTABLE STATEMENT
      EX = ARG
      DMAX = 10.D0**DNTEN
      IER = 0
      IF (ORDER.GE.0.D0.AND.N.GE.1 .AND. EX.GT.0.D0) GO TO 10
      IER = 129
      BK(1) = XINF
      IF (N.LT.2) GO TO 9000
      DO 5 K=2,N
         BK(K) = XINF
    5 CONTINUE
      GO TO 9000
   10 K = ORDER+0.5D0
      ENU = ORDER-FLOAT(K)
      IF (DABS(ENU).LT.1.D-30) ENU = 0.D0
      TWONU = ENU+ENU
      IEND = N+K-1
      C = ENU*ENU
      D3 = -C
      IF (EX.GT.1.D0) GO TO 85
C                                  CALCULATION OF P0, Q0 AND F0
      D1 = 0.D0
      D2 = P(1)
      T1 = 1.D0
      T2 = Q(1)
      DO 15 I=2,7,2
         D1 = C*D1+P(I)
         D2 = C*D2+P(I+1)
         T1 = C*T1+Q(I)
         T2 = C*T2+Q(I+1)
   15 CONTINUE
      D1 = ENU*D1
      T1 = ENU*T1
      F1 = LOG(ARG)
      F0 = A+ENU*(P(8)-ENU*(D1+D2)/(T1+T2))-F1
      P0 = EXP(ENU*F0)
      Q0 = EXP(-ENU*(A-ENU*(P(8)+ENU*(D1-D2)/(T1-T2))-F1))
      D1 = 0.D0
      T1 = 0.D0
      DO 20 I=1,4
         D1 = C*D1+R(I)
         T1 = C*T1+S(I)
   20 CONTINUE
      F1 = ENU*F0
      F1 = F1*F1
      IF (F1.GT.1.3D0) GO TO 30
      D2 = 0.D0
      DO 25 I=1,7
         D2 = F1*D2+T(I)
   25 CONTINUE
      D2 = F0+F0*F1*D2
      GO TO 35
   30 D2 = (EXP(ENU*F0)-EXP(-ENU*F0))*.5D0
      D2 = D2/ENU
   35 F0 = D2-ENU*D1/((1.D0+C*T1)*P0)
      IF (EX.GT.1.D-10) GO TO 75
C                                  X.LE.1.0E-10
C                                    CALCULATION OF K(ENU,X) AND
C                                    X*K(ENU+1,X)/K(ENU,X)
      BK(1) = F0+ARG*F0
      RATIO = P0/F0
      C = ARG*DMAX
      IF (K.EQ.0) GO TO 55
C                                  CALCULATION OF K(ORDER,X) AND
C                                    X*K(ORDER+1,X)/K(ORDER,X)
C                                    FOR ORDER .GE. 1/2
      DO 40 I=1,K
         TEMP = C/RATIO
         IF (BK(1).GE.TEMP) GO TO 45
         BK(1) = RATIO*BK(1)/ARG
         TWONU = TWONU+2.D0
         RATIO = TWONU
   40 CONTINUE
      GO TO 55
   45 IER = 130
      DO 50 I=1,N
         BK(I) = XINF
   50 CONTINUE
      GO TO 9000
   55 IF (N.EQ.1) GO TO 9005
C                                  CALCULATION OF
C                                    K(ORDER+L,X)/K(ORDER+L-1,X)
C                                    FOR L = 1, 2,. . ., N
      DO 60 I=2,N
         IF (RATIO.GE.C) GO TO 65
         BK(I) = RATIO/ARG
         TWONU = TWONU+2.D0
         RATIO = TWONU
   60 CONTINUE
      JER = 1
      GO TO 140
   65 DO 70 I=2,N
         BK(I) = XINF
   70 CONTINUE
      IER = 131
      GO TO 9000
C                                  1.0E-10 .LT. X .LE. 1.0
   75 C = 1.D0
      X2BY4 = 0.25D0*ARG*ARG
      P0 = 0.5D0*P0
      Q0 = 0.5D0*Q0
      D1 = -1.D0
      D2 = 0.D0
      BK1 = 0.D0
      BK2 = 0.D0
      F1 = F0
      F2 = P0
   80 D1 = D1+2.D0
      D2 = D2+1.D0
      D3 = D1+D3
      C = X2BY4*C/D2
      F0 = (D2*F0+P0+Q0)/D3
      P0 = P0/(D2-ENU)
      Q0 = Q0/(D2+ENU)
      T1 = C*F0
      T2 = C*(P0-D2*F0)
      BK1 = BK1+T1
      BK2 = BK2+T2
      TEMP = DABS(T1/(F1+BK1))
      TEMP2 = DABS(T2/(F2+BK2))
      IF (TEMP.GT.TOL .OR. TEMP2.GT.TOL) GO TO 80
      D1 = EXP(-ARG)
      BK1 = (F1+BK1)/D1
      BK2 = 2.D0*(F2+BK2)/(ARG*D1)
      DMINF = 24.67D0*EX+3.57D0
      GO TO 120
C                                  X .GT. 1.0
   85 TWOX = ARG+ARG
      ALPHA = 0.D0
      RATIO = 0.D0
      IF (EX.GT.4.D0) GO TO 105
C                                  1.0 .LT. X .LE. 4.0
C                                    CALCULATION OF K(ENU+1,X)/K(ENU,X)
      M = 52.0583D0/EX+5.7607D0
      D2 = M
      D1 = D2+D2
      D2 = D2-0.5D0
      D2 = D2*D2
      DO 90 I=2,M
         D1 = D1-2.D0
         D2 = D2-D1
         RATIO = (D3+D2)/(TWOX+D1-RATIO)
   90 CONTINUE
C                                  CALCULATION OF I(ABS(ENU),X) AND
C                                    I(ABS(ENU)+1,X) BY BACKWARD
C                                    RECURRENCE AND K(ENU,X) FROM THE
C                                    WRONSKIAN
      M = 2.7782D0*EX+14.4303D0
      C = DABS(ENU)
      D3 = C+C
      D1 = D3-1.D0
      D2 = M
      F1 = DMIN
      F0 = (2.D0*(C+D2)/ARG+0.5D0*ARG/(C+D2+1.D0))*DMIN
      DO 95 I=3,M
         D2 = D2-1.D0
         F2 = (D3+D2+D2)*F0
         ALPHA = (1.D0+D1/D2)*(F2+ALPHA)
         F2 = F2/ARG+F1
         F1 = F0
         F0 = F2
   95 CONTINUE
      F1 = (D3+2.D0)*F0/ARG+F1
      D1 = 0.D0
      T1 = 1.D0
      DO 100 I=1,7
         D1 = C*D1+P(I)
         T1 = C*T1+Q(I)
  100 CONTINUE
      P0 = EXP(C*(A+C*(P(8)-C*D1/T1)-LOG(ARG)))/ARG
      F2 = (C+0.5D0-RATIO)*F1/ARG
      BK1 = P0+(D3*F0-F2+F0+ALPHA)/(F2+F1+F0)*P0
      DMINF = 4.263D0*EX+23.977D0
      GO TO 115
C                                  X .GT. 4.0
C                                    CALCULATION OF K(ENU,X) AND
C                                    K(ENU+1,X)/K(ENU,X) BY BACKWARD
C                                    RECURRENCE
  105 M = 185.3004D0/EX+9.3715D0
      DM = M
      D2 = DM-0.5D0
      D2 = D2*D2
      D1 = DM+DM
      DO 110 I=2,M
         DM = DM-1.D0
         D1 = D1-2.D0
         D2 = D2-D1
         RATIO = (D3+D2)/(TWOX+D1-RATIO)
         ALPHA = (RATIO+RATIO*ALPHA)/DM
  110 CONTINUE
      BK1 = 1.D0/((D+D*ALPHA)*DSQRT(ARG))
      DMINF = 0.94219D0*(EX-DABS(EX-20.D0))+52.3363D0
C
C                                  CALCULATION OF K(ENU+1,X) FROM
C                                    K(ENU,X) AND K(ENU+1,X)/K(ENU,X)
  115 BK2 = BK1+BK1*(ENU+0.5D0-RATIO)/ARG
C
C                                  CALCULATION OF  IER , K(ORDER+I,X),
C                                    I = 0, 1, . . ., IER-1, ..
C                                    K(ORDER+I,X)/K(ORDER+I-1,X),
C                                    I = IER, IER+1, . . ., N
  120 BK(1) = BK1
      IF (IEND.EQ.0) GO TO 9005
      J = 2-K
      IF (J.GT.0) BK(J) = BK2
      IF (IEND.EQ.1) GO TO 9005
      M = DMINF-ENU
      IF (M.GT.IEND) M = IEND
      DO 125 I=2,M
         T1 = BK1
         BK1 = BK2
         TWONU = TWONU+2.D0
         BK2 = TWONU/ARG*BK1+T1
         J = J+1
         IF (J.GT.0) BK(J) = BK2
  125 CONTINUE
      IF (M.EQ.IEND) GO TO 9005
      RATIO = BK2/BK1
      MPLUS1 = M+1
      IER = 130
      KK = 1
      DO 135 I=MPLUS1,IEND
         TWONU = TWONU+2.D0
         RATIO = TWONU/ARG+1.D0/RATIO
         J = J+1
         IF (J.LE.1) GO TO 130
         BK(J) = RATIO
         GO TO 135
  130    TEMP = DMAX/RATIO
         IF (BK2.GE.TEMP) GO TO 155
         BK2 = RATIO*BK2
  135 CONTINUE
      JER = MPLUS1-K
      IF (JER.LE.0) JER = 1
      IF (JER.EQ.1) BK(1) = BK2
      IF (N.EQ.1) GO TO 9005
  140 J = JER+1
      DO 145 I=J,N
         IER = 131+I
         TEMP = DMAX/BK(I)
         IF (BK(I-1).GE.TEMP) GO TO 150
         BK(I) = BK(I-1)*BK(I)
  145 CONTINUE
      IER = 0
      GO TO 9005
  150 KK = IER-131
  155 DO 160 I=KK,N
         BK(I) = XINF
  160 CONTINUE
 9000 CONTINUE
      CALL UERTST(IER,'MMBSKR')
 9005 RETURN
      END

#include "fpreproc/library_names.h"
#include "fpreproc/f77_dcomplx.h"
#include "fpreproc/fp_const.h"
*DECK DGAMMA
       FUNCTION DGAMMA (X)
C***BEGIN PROLOGUE  DGAMMA
C***PURPOSE  Compute the complete Gamma function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A
C***TYPE      REAL*8 (GAMMA-S, DGAMMA-D, CGAMMA-C)
C***KEYWORDS  COMPLETE GAMMA FUNCTION, FNLIB, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DGAMMA(X) calculates the double precision complete Gamma function
C for double precision argument X.
C
C Series for GAM        on the interval  0.          to  1.00000E+00
C                                        with weighted error   5.79E-32
C                                         log weighted error  31.24
C                               significant figures required  30.00
C                                    decimal places required  32.05
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, D9LGMC, DCSEVL, DGAMLM, INITDS, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   920618  Removed space from variable name.  (RWC, WRB)
C***END PROLOGUE  DGAMMA
C============
C idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER ngam,initds,n,i
C============
      REAL*8 DGAMMA
      REAL*8 X, GAMCS(42), DXREL, PI, SINPIY, SQ2PIL, XMAX,
     1  XMIN, Y, D9LGMC, DCSEVL, D1MACH
      LOGICAL FIRST
C
      SAVE GAMCS, PI, SQ2PIL, NGAM, XMIN, XMAX, DXREL, FIRST
      DATA GAMCS(  1) / +CONST(.8571195590989331421920062399942,-2)/
      DATA GAMCS(  2) / +CONST(.4415381324841006757191315771652,-2)/
      DATA GAMCS(  3) / +CONST(.5685043681599363378632664588789,-1)/
      DATA GAMCS(  4) / -CONST(.4219835396418560501012500186624,-2)/
      DATA GAMCS(  5) / +CONST(.1326808181212460220584006796352,-2)/
      DATA GAMCS(  6) / -CONST(.1893024529798880432523947023886,-3)/
      DATA GAMCS(  7) / +CONST(.3606925327441245256578082217225,-4)/
      DATA GAMCS(  8) / -CONST(.6056761904460864218485548290365,-5)/
      DATA GAMCS(  9) / +CONST(.1055829546302283344731823509093,-5)/
      DATA GAMCS( 10) / -CONST(.1811967365542384048291855891166,-6)/
      DATA GAMCS( 11) / +CONST(.3117724964715322277790254593169,-7)/
      DATA GAMCS( 12) / -CONST(.5354219639019687140874081024347,-8)/
      DATA GAMCS( 13) / +CONST(.9193275519859588946887786825940,-9)/
      DATA GAMCS( 14) / -CONST(.1577941280288339761767423273953,-9)/
      DATA GAMCS( 15) / +CONST(.2707980622934954543266540433089,-10)/
      DATA GAMCS( 16) / -CONST(.4646818653825730144081661058933,-11)/
      DATA GAMCS( 17) / +CONST(.7973350192007419656460767175359,-12)/
      DATA GAMCS( 18) / -CONST(.1368078209830916025799499172309,-12)/
      DATA GAMCS( 19) / +CONST(.2347319486563800657233471771688,-13)/
      DATA GAMCS( 20) / -CONST(.4027432614949066932766570534699,-14)/
      DATA GAMCS( 21) / +CONST(.6910051747372100912138336975257,-15)/
      DATA GAMCS( 22) / -CONST(.1185584500221992907052387126192,-15)/
      DATA GAMCS( 23) / +CONST(.2034148542496373955201026051932,-16)/
      DATA GAMCS( 24) / -CONST(.3490054341717405849274012949108,-17)/
      DATA GAMCS( 25) / +CONST(.5987993856485305567135051066026,-18)/
      DATA GAMCS( 26) / -CONST(.1027378057872228074490069778431,-18)/
      DATA GAMCS( 27) / +CONST(.1762702816060529824942759660748,-19)/
      DATA GAMCS( 28) / -CONST(.3024320653735306260958772112042,-20)/
      DATA GAMCS( 29) / +CONST(.5188914660218397839717833550506,-21)/
      DATA GAMCS( 30) / -CONST(.8902770842456576692449251601066,-22)/
      DATA GAMCS( 31) / +CONST(.1527474068493342602274596891306,-22)/
      DATA GAMCS( 32) / -CONST(.2620731256187362900257328332799,-23)/
      DATA GAMCS( 33) / +CONST(.4496464047830538670331046570666,-24)/
      DATA GAMCS( 34) / -CONST(.7714712731336877911703901525333,-25)/
      DATA GAMCS( 35) / +CONST(.1323635453126044036486572714666,-25)/
      DATA GAMCS( 36) / -CONST(.2270999412942928816702313813333,-26)/
      DATA GAMCS( 37) / +CONST(.3896418998003991449320816639999,-27)/
      DATA GAMCS( 38) / -CONST(.6685198115125953327792127999999,-28)/
      DATA GAMCS( 39) / +CONST(.1146998663140024384347613866666,-28)/
      DATA GAMCS( 40) / -CONST(.1967938586345134677295103999999,-29)/
      DATA GAMCS( 41) / +CONST(.3376448816585338090334890666666,-30)/
      DATA GAMCS( 42) / -CONST(.5793070335782135784625493333333,-31)/
      DATA PI / CONST(3.14159265358979323846264338327950,0)/
      DATA SQ2PIL / CONST(0.91893853320467274178032973640562,0)/
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DGAMMA
      IF (FIRST) THEN
         NGAM = INITDS (GAMCS, 42, CONST(0.1,0)*AREAL(D1MACH(3)) )
C
         CALL DGAMLM (XMIN, XMAX)
         DXREL = SQRT(D1MACH(4))
      ENDIF
      FIRST = .FALSE.
C
      Y = ABS(X)
      IF (Y.GT.CONST(10.,0)) GO TO 50
C
C COMPUTE GAMMA(X) FOR -XBND .LE. X .LE. XBND.  REDUCE INTERVAL AND FIND
C GAMMA(1+Y) FOR 0.0 .LE. Y .LT. 1.0 FIRST OF ALL.
C
      N = X
      IF (X.LT.CONST(0.,0)) N = N - 1
      Y = X - N
      N = N - 1
      DGAMMA = CONST(0.9375,0)+
     >   DCSEVL (CONST(2.,0)*Y-CONST(1.,0), GAMCS, NGAM)
      IF (N.EQ.0) RETURN
C
      IF (N.GT.0) GO TO 30
C
C COMPUTE GAMMA(X) FOR X .LT. 1.0
C
      N = -N
      IF (X .EQ. CONST(0.,0))
     +   CALL XERMSG ('SLATEC', 'DGAMMA', 'X IS 0', 4, 2)
      IF (X .LT. CONST(0.0,0).AND. X+N-2 .EQ. CONST(0.,0))
     +   CALL XERMSG ('SLATEC',
     +   'DGAMMA', 'X IS A NEGATIVE INTEGER', 4, 2)
      IF (X .LT. (-CONST(0.5,0)) .AND.
     +   ABS((X-AINT(X-CONST(0.5,0)))/X) .LT. DXREL)
     +   CALL XERMSG ('SLATEC', 'DGAMMA',
     +   'ANSWER LT HALF PRECISION BECAUSE X TOO NEAR NEGATIVE INTEGER',
     +   1, 1)
C
      DO 20 I=1,N
        DGAMMA = DGAMMA/(X+I-1 )
 20   CONTINUE
      RETURN
C
C GAMMA(X) FOR X .GE. 2.0 AND X .LE. 10.0
C
 30   DO 40 I=1,N
        DGAMMA = (Y+I) * DGAMMA
 40   CONTINUE
      RETURN
C
C GAMMA(X) FOR ABS(X) .GT. 10.0.  RECALL Y = ABS(X).
C
 50   IF (X .GT. XMAX) CALL XERMSG ('SLATEC', 'DGAMMA',
     +   'X SO BIG GAMMA OVERFLOWS', 3, 2)
C
      DGAMMA = CONST(0.,0)
      IF (X .LT. XMIN) CALL XERMSG ('SLATEC', 'DGAMMA',
     +   'X SO SMALL GAMMA UNDERFLOWS', 2, 1)
      IF (X.LT.XMIN) RETURN
C
      DGAMMA = EXP ((Y-CONST(0.5,0))*LOG(Y) - Y + SQ2PIL + D9LGMC(Y) )
      IF (X.GT.CONST(0.,0)) RETURN
C
      IF (ABS((X-AINT(X-CONST(0.5,0)))/X) .LT. DXREL)
     +   CALL XERMSG ('SLATEC', 'DGAMMA',
     +   'ANSWER LT HALF PRECISION, X TOO NEAR NEGATIVE INTEGER', 1, 1)
C
      SINPIY = SIN (PI*Y)
      IF (SINPIY .EQ. CONST(0.,0)) CALL XERMSG ('SLATEC', 'DGAMMA',
     +   'X IS A NEGATIVE INTEGER', 4, 2)
C
      DGAMMA = -PI/(Y*SINPIY*DGAMMA)
C
      RETURN
      END
! 22Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 22Jun2000 fgtok
! 22Jun2000 fgtok
! 22Jun2000 fgtok

#include "fpreproc/library_names.h"
#include "fpreproc/fp_const.h"
*DECK DLNGAM
       FUNCTION DLNGAM (X)
C***BEGIN PROLOGUE  DLNGAM
C***PURPOSE  Compute the logarithm of the absolute value of the Gamma
C            function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A
C***TYPE      REAL*8 (ALNGAM-S, DLNGAM-D, CLNGAM-C)
C***KEYWORDS  ABSOLUTE VALUE, COMPLETE GAMMA FUNCTION, FNLIB, LOGARITHM,
C             SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DLNGAM(X) calculates the double precision logarithm of the
C absolute value of the Gamma function for double precision
C argument X.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, D9LGMC, DGAMMA, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900727  Added EXTERNAL statement.  (WRB)
C***END PROLOGUE  DLNGAM
      IMPLICIT NONE
      REAL*8 DLNGAM
      REAL*8 X, DXREL, PI, SINPIY, SQPI2L, SQ2PIL, XMAX,
     1  Y, DGAMMA, D9LGMC, D1MACH, TEMP
      LOGICAL FIRST
      EXTERNAL DGAMMA
      SAVE SQ2PIL, SQPI2L, PI, XMAX, DXREL, FIRST
      DATA SQ2PIL / CONST(0.91893853320467274178032973640562,0)/
      DATA SQPI2L / +CONST(.225791352644727432363097614947441,+0)/
      DATA PI / CONST(3.14159265358979323846264338327950,0)/
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DLNGAM
      IF (FIRST) THEN
         TEMP = CONST(1.,0)/LOG(D1MACH(2))
         XMAX = TEMP*D1MACH(2)
         DXREL = SQRT(D1MACH(4))
      ENDIF
      FIRST = .FALSE.
C
      Y = ABS (X)
      IF (Y.GT.CONST(10.,0)) GO TO 20
C
C LOG (ABS (DGAMMA(X)) ) FOR ABS(X) .LE. 10.0
C
      DLNGAM = LOG (ABS (DGAMMA(X)) )
      RETURN
C
C LOG ( ABS (DGAMMA(X)) ) FOR ABS(X) .GT. 10.0
C
 20   IF (Y .GT. XMAX) CALL XERMSG ('SLATEC', 'DLNGAM',
     +   'ABS(X) SO BIG DLNGAM OVERFLOWS', 2, 2)
C
      IF (X.GT.CONST(0.,0)) DLNGAM = SQ2PIL +
     >   (X-CONST(0.5,0))*LOG(X) - X + D9LGMC(Y)
      IF (X.GT.CONST(0.,0)) RETURN
C
      SINPIY = ABS (SIN(PI*Y))
      IF (SINPIY .EQ. CONST(0.,0)) CALL XERMSG ('SLATEC', 'DLNGAM',
     +   'X IS A NEGATIVE INTEGER', 3, 2)
C
      IF (ABS((X-AINT(X-CONST(0.5,0)))/X) .LT. DXREL)
     +   CALL XERMSG ('SLATEC', 'DLNGAM',
     +   'ANSWER LT HALF PRECISION BECAUSE X TOO NEAR NEGATIVE INTEGER',
     +   1, 1)
C
      DLNGAM = SQPI2L + (X-CONST(0.5,0))*LOG(Y) - X -
     >   LOG(SINPIY) - D9LGMC(Y)
      RETURN
C
      END
! 22Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 22Jun2000 fgtok
! 22Jun2000 fgtok

! 07Jun1999 fgtok -impno -s r8_precision.sub r8_names.table "r8con.csh conversion"
c  cspline -- dmc 15 Feb 1999
c
c  a standard interface to various 1d spline setup routines
c
      subroutine r8cspline(x,nx,fspl,ibcxmin,bcxmin,ibcxmax,bcxmax,
     >   wk,iwk,ilinx,ier)
c
      IMPLICIT NONE
C============
C idecl:  explicitize implicit INTEGER declarations:
      INTEGER nx,iwk,ierx,inum,ix
C============
C idecl:  explicitize implicit REAL declarations:
      REAL*8 xo2,xo6
C============
      REAL*8 x(nx)                        ! x axis (in)
      REAL*8 fspl(4,nx)                   ! spline data (in/out)
      integer ibcxmin                   ! x(1) BC flag (in, see comments)
      REAL*8 bcxmin                       ! x(1) BC data (in, see comments)
      integer ibcxmax                   ! x(nx) BC flag (in, see comments)
      REAL*8 bcxmax                       ! x(nx) BC data (in, see comments)
      REAL*8 wk(iwk)                      ! workspace of size at least 5*nx
      integer ilinx                     ! even spacing flag (out)
      integer ier                       ! output, =0 means OK
c
c  ** note wk(...) array is not used unless ibcxmin=-1 (periodic spline
c  evaluation)
c
c  this routine computes spline coefficients for a 1d spline --
c  evaluation of the spline can be done by cspeval.for subroutines
c  or directly by inline code.
c
c  the input x axis x(1...nx) must be strictly ascending, i.e.
c  x(i+1).gt.x(i) is required for i=1 to nx-1.  This is checked and
c  ier=1 is set and the routine exits if the test is not satisfied.
c
c  on output, ilinx=1 is set if, to a reasonably close tolerance,
c  all grid spacings x(i+1)-x(i) are equal.  This allows a speedier
c  grid lookup algorithm on evaluation of the spline.  If on output
c  ilinx=2, this means the spline x axis is not evenly spaced.
c
c  the input data for the spline are given in f[j] = fspl(1,j).  The
c  output data are the spline coefficients fspl(2,j),fspl(3,j), and
c  fspl(4,j), j=1 to nx.  The result is a spline s(x) satisfying the
c  boundary conditions and with the properties
c
c     s(x(j)) = f(1,j)
c     s'(x) is continuous even at the grid points x(j)
c     s''(x) is continuous even at the grid points x(j)
c
c  the formula for evaluation of s(x) is:
c
c     let dx = x-x(i), where x(i).le.x.le.x(i+1).  Then,
c     s(x)=f(1,i) + dx*(f(2,i) +dx*(f(3,i) + dx*f(4,i)))
c
c  ==>boundary conditions.  Complete specification of a 1d spline
c  requires specification of boundary conditions at x(1) and x(nx).
c
c  this routine provides 4 options:
c
c  ibcxmin=-1  --  periodic boundary condition.  This means the
c    boundary conditions s'(x(1))=s'(x(nx)) and s''(x(1))=s''(x(nx))
c    are imposed.  Note that s(x(1))=s(x(nx)) (i.e. f(1,1)=f(1,nx))
c    is not required -- that is determined by the f array input data.
c    The periodic boundary condition is to be preferred for periodic
c    data.  When splining periodic data f(x) with period P, the relation
c    x(nx)=x(1)+n*P, n = the number of periods (usually 1), should hold.
c    (ibcxmax, bcxmin, bcxmax are ignored).
c
c  if a periodic boundary condition is set, this covers both boundaries.
c  for the other types of boundary conditions, the type of condition
c  chosen for the x(1) boundary need not be the same as the type chosen
c  for the x(nx) boundary.
c
c  ibcxmin=0 | ibcxmax=0 -- this specifies a "not a knot" boundary
c    condition -- see cubsplb.for.  This is a common way for inferring
c    a "good" spline boundary condition automatically from data in the
c    vicinity of the boundary.  (bcxmin | bcxmax are ignored).
c
c  ibcxmin=1 | ibcxmax=1 -- boundary condition is to have s'(x(1)) |
c    s'(x(nx)) match the passed value (bcxmin | bcxmax).
c
c  ibcxmin=2 | ibcxmax=2 -- boundary condition is to have s''(x(1)) |
c    s''(x(nx)) match the passed value (bcxmin | bcxmax).
c
c---------------------------------------------------------------------
c  error checks
c
      ier = 0
      if(nx.lt.4) then
         write(6,'('' ?cspline:  at least 4 x points required.'')')
         ier=1
      endif
      call ibc_ck(ibcxmin,'cspline','xmin',-1,2,ier)
      if(ibcxmin.ge.0) call ibc_ck(ibcxmax,'cspline','xmax',0,2,ier)
c
c  x axis check
c
      call r8splinck(x,nx,ilinx,1.0D-3,ierx)
      if(ierx.ne.0) ier=2
c
      if(ier.eq.2) then
         write(6,'('' ?cspline:  x axis not strict ascending'')')
      endif
c
      if(ibcxmin.eq.-1) then
         inum=5*nx
         if(iwk.lt.inum) then
            write(6,1009) inum,iwk,nx
 1009       format(
     >      ' ?cspline:  workspace too small.  need:  ',i6,' got:  ',i6/
     >      '  (need = 5*nx, nx=',i6)
            ier=3
         endif
      endif
c
      if(ier.ne.0) return
c
c  OK -- evaluate spline
c
      if(ibcxmin.eq.-1) then
         call r8cpspline(x,nx,fspl,wk) ! periodic spline
      else
         xo2=0.5D0
         xo6=1.0D0/6.0D0
c  use cubsplb, then fix coefficients as
         fspl(2,1)=bcxmin
         fspl(2,nx)=bcxmax
         call r8cubsplb(x,fspl,nx,ibcxmin,ibcxmax)
         do ix=1,nx
            fspl(3,ix)=fspl(3,ix)*xo2
            fspl(4,ix)=fspl(4,ix)*xo6
         enddo
      endif
C
      return
      end
c--------------------------
c  interface to pspline -- periodic spline
c
      subroutine r8cpspline(x,nx,fspl,wk)
c
      IMPLICIT NONE
C============
C idecl:  explicitize implicit INTEGER declarations:
      INTEGER nx,ix
C============
      REAL*8 x(nx),fspl(4,nx),wk(nx,5)
c
c  the coding is tricky, because the caller wants the spline coefficients
c  contigously packed, but pspline wants the data contiguously packed.
c
      do ix=1,nx
         wk(ix,1)=fspl(1,ix)
      enddo
c
      call r8pspline(nx,x,wk(1,1),wk(1,2),wk(1,3),wk(1,4),wk(1,5))
c
c  ok move stuff back into place
c
      do ix=1,nx
         fspl(2,ix)=wk(ix,2)
         fspl(3,ix)=wk(ix,3)
         fspl(4,ix)=wk(ix,4)
      enddo
c
      return
      end

      module Vprotab
C...Created by Pacific-Sierra Research VAST-90 2.06G2  15:08:34   5/18/01  
      integer, parameter :: nions = 10
      integer, parameter :: nprofm = 131
      real, dimension(nprofm,4) :: tne, tte, tqr
      real, dimension(nprofm) :: tpsi, zsurf, zlamb, zqfac, zcurr
      real, dimension(nprofm,4) :: tpsif, tqfac
      real, dimension(nprofm,4,nions) :: tti, tni
      real, dimension(nprofm,4) :: tzeff
      real, dimension(nprofm,4,nions) :: tconc
      real, dimension(nprofm) :: torflx
      real, dimension(nprofm,4) :: ttani
      end module Vprotab

       FUNCTION DBESK1 (X)
C***BEGIN PROLOGUE  DBESK1
C***PURPOSE  Compute the modified (hyperbolic) Bessel function of the
C            third kind of order one.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C10B1
C***TYPE      real(kind=dp) (BESK1-S, DBESK1-D)
C***KEYWORDS  FNLIB, HYPERBOLIC BESSEL FUNCTION,
C             MODIFIED BESSEL FUNCTION, ORDER ONE, SPECIAL FUNCTIONS,
C             THIRD KIND
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DBESK1(X) calculates the double precision modified (hyperbolic)
C Bessel function of the third kind of order one for double precision
C argument X.  The argument must be large enough that the result does
C not overflow and small enough that the result does not underflow.
C
C Series for BK1        on the interval  0.          to  4.00000E+00
C                                        with weighted error   9.16E-32
C                                         log weighted error  31.04
C                               significant figures required  30.61
C                                    decimal places required  31.64
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, DBESI1, DBSK1E, DCSEVL, INITDS, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C***END PROLOGUE  DBESK1
C============
C idecl:  explicitize implicit INTEGER declarations:
      use kind_spec

      IMPLICIT NONE
      INTEGER ntk1,initds
C============
      real(kind=dp) DBESK1
      real(kind=dp) X, BK1CS(16), XMAX, XMAXT, XMIN, XSML, Y,
     1  D1MACH, DCSEVL, DBESI1, DBSK1E
      LOGICAL FIRST
      SAVE BK1CS, NTK1, XMIN, XSML, XMAX, FIRST
      DATA BK1CS(  1) / +.25300227338947770532531120868533E-1_dp/

      DATA BK1CS(  2) / -.35315596077654487566723831691801E+0_dp/

      DATA BK1CS(  3) / -.12261118082265714823479067930042E+0_dp/

      DATA BK1CS(  4) / -.69757238596398643501812920296083E-2_dp/

      DATA BK1CS(  5) / -.17302889575130520630176507368979E-3_dp/

      DATA BK1CS(  6) / -.24334061415659682349600735030164E-5_dp/

      DATA BK1CS(  7) / -.22133876307347258558315252545126E-7_dp/

      DATA BK1CS(  8) / -.14114883926335277610958330212608E-9_dp/

      DATA BK1CS(  9) / -.66669016941993290060853751264373E-12_dp/

      DATA BK1CS( 10) / -.24274498505193659339263196864853E-14_dp/

      DATA BK1CS( 11) / -.70238634793862875971783797120000E-17_dp/

      DATA BK1CS( 12) / -.16543275155100994675491029333333E-19_dp/

      DATA BK1CS( 13) / -.32338347459944491991893333333333E-22_dp/

      DATA BK1CS( 14) / -.53312750529265274999466666666666E-25_dp/

      DATA BK1CS( 15) / -.75130407162157226666666666666666E-28_dp/

      DATA BK1CS( 16) / -.91550857176541866666666666666666E-31_dp/

      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DBESK1
      IF (FIRST) THEN
         NTK1 = INITDS (BK1CS, 16, 0.1E0_dp*(d1mach3))

         XMIN = EXP(MAX(LOG(d1mach1), -LOG(d1mach2)) +
     +      0.01E0_dp)

         XSML = SQRT(4.0E0_dp*d1mach3)

         XMAXT = -LOG(d1mach1)
         XMAX = XMAXT - 0.5E0_dp*XMAXT*LOG(XMAXT)/

     +      (XMAXT+0.5E0_dp)

      ENDIF
      FIRST = .FALSE.
C
      IF (X .LE. 0.E0_dp) CALL XERMSG ('SLATEC', 'DBESK1',

     +   'X IS ZERO OR NEGATIVE', 2, 2)
      IF (X.GT.2.0E0_dp) GO TO 20

C
      IF (X .LT. XMIN) CALL XERMSG ('SLATEC', 'DBESK1',
     +   'X SO SMALL K1 OVERFLOWS', 3, 2)
      Y = 0.E0_dp

      IF (X.GT.XSML) Y = X*X
      DBESK1 = LOG(0.5E0_dp*X)*DBESI1(X) +

     1   (0.75E0_dp+ DCSEVL (.5E0_dp*Y-1.E0_dp,

     1   BK1CS, NTK1))/X
      RETURN
C
 20   DBESK1 = 0.E0_dp

      IF (X .GT. XMAX) CALL XERMSG ('SLATEC', 'DBESK1',
     +   'X SO BIG K1 UNDERFLOWS', 1, 1)
      IF (X.GT.XMAX) RETURN
C
      DBESK1 = EXP(-X) * DBSK1E(X)
C
      RETURN
      END
! 22Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 22Jun2000 fgtok
! 22Jun2000 fgtok
! 22Jun2000 fgtok

c
c  this module contains routines for computing magnetic field geometry
c----------------------------------------------------------------------
c
      subroutine bfield(psic, thetac, bfld)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:56:54   6/14/01
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh
      use Vcraylh
      use Vceqdsk
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real(kind=dp) psic, thetac, bfld
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95

c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i

c
c
      if (psic > 0.) then
         psi = psic
         theta = thetac
         call coords
         call profix
         bfld = btot
         return
      endif
      bfld = beqd
      return
      end subroutine bfield
c
      subroutine coords
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:56:54   6/14/01
C...Switches: -p4 -yb
c
c   ****************************************************************
c   *                                                              *
c   *      this modulus evaluates x,z, their derivatives           *
c   *           with respect to psi and theta, and the             *
c   *           metric elements for use in the ion cyclotron       *
c   *           ray tracing program                                *
c   *                                                              *
c   ****************************************************************
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh
      use Vcraylh
      use Vceqdsk
      use kind_spec

      implicit none
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: lmhd, i, id, ier
      real(kind=dp), dimension(3) :: zbx0, zbx1, zbx2, zbz0
      real(kind=dp) :: twopi, zh, zph, zcosph, zsinph, zzss, zzcs,
     1    zzdcos, zddxpp
     1   , zddxpt, zddxtt, zddzpp, zddzpt, zddztt, theta1, zntau2
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
!      integer , EXTERNAL :: ifix
      real(kind=dp) , EXTERNAL :: valspl
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95

c
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i

c
c
      data twopi/6.28318530717959/
c

      if (ieqdsk <= 2) then
c   ****************************************************************
c   Evaluation of plasma shape coords and derivatives
c   from Brambilla representation of the flux surfaces:
c   ****************************************************************


         psi = max(accur,psi)
c
         acosth = cos(theta)
         asinth = sin(theta)
c
c   ****************************************************************
c   evaluations of rshift, rho, dtrian, elong and their derivatives
c   ****************************************************************
c
!         lmhd = ifix(psi/dpsimhd) + 1
         lmhd = int(psi/dpsimhd) + 1
         zh = psi - psimhd(lmhd)
         if (lmhd > nmhd) then
            lmhd = nmhd
            zh = 0.0
         endif
c
         do i = 1, 3
            id = i - 1
            zbx0(i) = valspl(zh,bx0,nprofn,lmhd,id)
            zbx1(i) = valspl(zh,bx1,nprofn,lmhd,id)
            zbx2(i) = valspl(zh,bx2,nprofn,lmhd,id)
            zbz0(i) = valspl(zh,bz0,nprofn,lmhd,id)
         end do
c
c   ****************************************************************
c   evaluation of xu(psi,theta), zu(psi,theta), and derivatives
c   ****************************************************************
c
         zph = theta - zbx2(1)*asinth
         zcosph = cos(zph)
         zsinph = sin(zph)
         zzss = zsinph*asinth
         zzcs = zcosph*asinth
         zzdcos = 1. - zbx2(1)*acosth
c
         ux = zbx0(1) + zbx1(1)*zcosph
         uz = zbz0(1)*asinth
c
         urhs = uraxmag + ux
c
         dxpsi = zbx0(2) + zbx1(2)*zcosph + zbx1(1)*zbx2(2)*zzss
         dxth = -zbx1(1)*zsinph*zzdcos
c
         dzpsi = zbz0(2)*asinth
         dzth = zbz0(1)*acosth
c
         zddxpp = zbx0(3) + zbx1(3)*zcosph + (2.*zbx1(2)*zbx2(2)+zbx1(1)
     1      *zbx2(3))*zzss - zbx1(1)*zbx2(2)*zbx2(2)*zzcs*asinth
         zddxpt = ((-zbx1(2)*zsinph)+zbx1(1)*zbx2(2)*zzcs)*zzdcos + zbx1
     1      (1)*zbx2(2)*zsinph*acosth
         zddxtt = -zbx1(1)*(zcosph*zzdcos*zzdcos + zbx2(1)*zzss)
c
         zddzpp = zbz0(3)*asinth
         zddzpt = zbz0(2)*acosth
         zddztt = -uz


      else
c   ****************************************************************
c   Evaluation of plasma shape coords and derivatives from
c   EQDSK representation of flux surfaces:
c   ****************************************************************


c        Get a theta1 value corresponding to theta, in [0.,twopi):
         if (theta >= 0.) then
            theta1 = mod(theta,twopi)
         else
            theta1 = mod((-theta),twopi)
            theta1 = twopi - theta1
         endif

         call dbcevl1 (thet, nptsd, ra, nprof, csplnx, nptsdm1, theta1,
     1      psi, pdsx, ier, 6)
         call dbcevl1 (thet, nptsd, ra, nprof, csplnz, nptsdm1, theta1,
     1      psi, pdsz, ier, 6)

c        xu is distance (meters) measured from magnetic axis.
c        zu is from equatorial plane.
         xu = pdsx(1) - raxmag
         zu = pdsz(1)

         ux = xu*ukzero
         uz = zu*ukzero
         urhs = pdsx(1)*ukzero

         dxpsi = pdsx(3)*ukzero
         dxth = pdsx(2)*ukzero
         dzpsi = pdsz(3)*ukzero
         dzth = pdsz(2)*ukzero

         zddxpp = pdsx(6)*ukzero
         zddxpt = pdsx(4)*ukzero
         zddxtt = pdsx(5)*ukzero
         zddzpp = pdsz(6)*ukzero
         zddzpt = pdsz(4)*ukzero
         zddztt = pdsz(5)*ukzero


      endif


c
c   ****************************************************************
c
c   evaluation of the jacobian, g, ntau, and derivatives
c
c   ****************************************************************
c
      zntau2 = dxth*dxth + dzth*dzth
      antau = sqrt(zntau2)
      aj = dxpsi*dzth - dzpsi*dxth
      ag = dxpsi*dxth + dzpsi*dzth
c
c  log. deriv. of antau & aj, ord. deriv. of ag
c
      dntaup = (dxth*zddxpt + dzth*zddzpt)/zntau2
      dntaut = (dxth*zddxtt + dzth*zddztt)/zntau2
      djp = (zddxpp*dzth + zddzpt*dxpsi - zddxpt*dzpsi - zddzpp*dxth)/aj
      djt = (zddxpt*dzth + zddztt*dxpsi - zddxtt*dzpsi - zddzpt*dxth)/aj
      dgp = zddxpp*dxth + zddxpt*dxpsi + zddzpp*dzth + zddzpt*dzpsi
      dgt = zddxpt*dxth + zddxtt*dxpsi + zddzpt*dzth + zddztt*dzpsi
c
      return
      end subroutine coords
c
      subroutine fiteqdsk
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:56:54   6/14/01
C...Switches: -p4 -yb

c     Obtain equilibrium data for ray tracing from EQDSK (ieqdsk.ge.3).
c     For ieqdsk.ge.3, replaces subroutine metrin, and most of profin.
c     For ieqdsk.eq.4, the extended eqdsk is used for plasma profiles.
c     Data is read from a file connected to iounit1.
c     Take   psi  (Brambilla) = normalized ONETWO rho coord,
c                               (sqrt(toroidal flux/bzero)).
c            theta(Brambilla) = ordinary angle on flux surface,
c                               measured about the magnetic axis.
c     Set up splines of X(theta,psi),Z(theta,psi) to be used for
c       the tokamak magnetic geometry.
c     Set other tokamak parameters.
c     If ieqdsk.eq.4, then set up plasma temp and density profiles
c       from data on an extended EQDSK.
c
c     This version corrects for difference in sign convention
c     between Brambilla's phi and EFIT's phi (toroidal angle)
c      Feb. 9,1994. SCC
c------------------------------

C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh
      use Vcraylh, only: imax,ukzero, urplas, uraxmag, raxmag, xmin,
     1   xmax, baxis, dpolas, dd, psi, theta, zsurf, volume, pqr,
     2   ppra, ppra1, tpsif, dpsi, tqr, tzeff
      use Vceqdsk
      use Vcmnew, only: dlob, zetab, enbeam, wbeam, lrza,
     1                  ebkev, bmpwr, azf, atmf, nalfa, pnfi, pnf
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, j, ix, iz, ierr, inset, iounitx, iauto, iautoc, ier,
     1   jj, i1, jmd, jmd1, jmd2, ir, k, kdeu, nbeams, niont
      real(kind=dp), dimension(nxa) :: fpeqd
      real(kind=dp), dimension(nprofm) :: ywork, xwork
      real(kind=dp), dimension(lrza) :: dumf
      real(kind=dp), dimension(nprofm) :: dumf1, dv, ds
      real(kind=dp) :: frcpr, gampr, alppr, gampr1, alppr1, zpi, amu0,
     1    err, end,
     1   pres0, delpsi, psin, bisign, delx, delz, dra, xminc, xmaxc,
     2   zminc, zmaxc, ddx, ddz, xcmin, xcmax, zcmin, zcmax, zxcmin,
     3   zxcmax, xzcmin, xzcmax, dthet, cost, sint, psiang, cosdd, ddd,
     4   rminor, dv1, dlp, bp1, rad1, bt1, dlpbp, dl, bpsep, rmina,
     5   bpedge, hconc, zdecay, enetot, ene00, ratden
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
!      integer , EXTERNAL :: max0
      real(kind=dp) , EXTERNAL :: simp
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i

c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95


c $$$$  Added by TK Mau on 2/26/92.
c $$$$$$      TKM     04/00
c  $$$$   TK Mau    9/28/94, 06/00
      data frcpr,gampr,alppr,gampr1,alppr1/0.55,2.25,0.0,1.0,2.0/
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      zpi = 4.*atan2(1.,1.)
c $$$$   TK Mau   10/13/92
      amu0 = zpi*4.E-7
c $$$$$$$$$$$$$$$$$
c
c   First change sign of relevant quantities to correct for difference
c   in sign convention between Brambilla's phi and EFIT's phi
c   Definition of vec(B) is
c       vec(B)=f(psi)*grad(phi(Bram)) + grad(phi(Bram)) x grad(psi)
c------------------------------------
c$$$$$$   TKM    06/00
c     Use analytic form for pressure profile
      if (alppr > 0.) then
         pres0 = presseqd(1)
         delpsi = 1./float(nxeqd - 1)
         do i = 1, nxeqd
            psin = delpsi*float(i - 1)
            presseqd(i) = pres0*(frcpr*(1. - psin**gampr)**alppr + (1.
     1          - frcpr)*(1. - psin**gampr1)**alppr1)
            ppeqd(i) = -pres0*(frcpr*alppr*gampr*psin**(gampr - 1.)*(1.
     1          - psin**gampr)**(alppr - 1.) + (1. - frcpr)*alppr1*
     2         gampr1*psin**(gampr1 - 1.)*(1. - psin**gampr1)**(alppr1
     3          - 1.))
            ppeqd(i) = ppeqd(i)/(psilim - psimag)
         end do
      endif
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c     psimag = -psimag
c     psilim = -psilim
      beqd = -beqd
      toteqd = -toteqd
c     psisep = -psisep
      feqd(:nxeqd) = -feqd(:nxeqd)
c*****   TKM   06/97
c     ffpeqd(:nxeqd) = -ffpeqd(:nxeqd)
c*********************
c     ppeqd(:nxeqd) = -ppeqd(:nxeqd)
c     peqd(:nxeqd,:nzeqd) = -peqd(:nxeqd,:nzeqd)
      btsign = sign(1.0_dp,beqd)
      bisign = sign(1.0_dp,toteqd)
c**********     TKM     3/97
c  Adjust plasma pressure for ARIES-ST studies of HHFW heating
      presseqd(:nxeqd) = presfr*presseqd(:nxeqd)
      ppeqd(:nxeqd) = presfr*ppeqd(:nxeqd)
c*******************************
      if (psiadj /= 0.0) then
c     Adjust psi values slighlty (a kluge to cope with eqdsks
c     for which the plasma is a little too close to the grid boundary):
         write (59, 8291) psiadj
 8291    format("adjusting psi-values by fractional amount",f10.3)
         delpsi = psiadj*(psimag - psilim)
         peqd(:nxeqd,:nzeqd) = peqd(:nxeqd,:nzeqd) - delpsi
         psimag = psimag - delpsi
         psimx1 = psimx1 - delpsi
         psimx2 = psimx2 - delpsi
      endif
c
c     xeqd,zeqd-grid where xeqd is major radius:
      delx = xdimeqd/(nxeqd - 1.)
      delz = zdimeqd/(nzeqd - 1.)
      do ix = 1, nxeqd
         xeqd(ix) = redeqd + (ix - 1)*delx
      end do
      do iz = 1, nzeqd
         zeqd(iz) = zmideqd - 0.5*zdimeqd + (iz - 1)*delz
      end do

c     tpsifeqd: eqdsk poloidal flux function-coordinate,
c     equispaced from psimag to psilim.
      dpolflx = (psilim - psimag)/(nxeqd - 1)
      do ix = 1, nxeqd
         tpsifeqd(ix) = psimag + (ix - 1)*dpolflx
      end do
c*************   TKM    2/97
c     Calculate mod-B values for plotting
c     Useful for low-aspect-ratio and/or high-beta tokamaks
      call modb
c****************************************
c
c     Obtain toroidal flux as a function of the equispaced poloidal flux:
c
      call trap2 (tpsifeqd, qeqd, torflux, nxeqd)
c
c     Holger St. John sign convention of torflux (see subroutine
c     reqdsk in ONETWO).
c****************************
      torflux(:nxeqd) = -2.*zpi*torflux(:nxeqd)
c****************************
c     Obtain the tpsieqd grid (ONETWO radial variable on equispaced poloidal
c     flux function grid, from the magnetic axis to the plasma edge).
      tpsieqd(:nxeqd) = sqrt(abs(torflux(:nxeqd)/(zpi*beqd)))

      tpsisav = tpsieqd(nxeqd)

c     Normalize:
      tpsieqd(:nxeqd) = tpsieqd(:nxeqd)/tpsisav

c     Define normalized equispaced radial grid ra (nprof in length,
c     extending past plasma surface at ra(nprofs)=1.).

      dra = 1./(nprofs - 1.)
      do j = 1, nprofs
         ra(j) = (j - 1.)*dra
      end do

c     Interpolate poloidal flux function onto the ra grid,
c     (ra(1) to ra(nprofs)) to get psifra:

      call intrpp ('free', 'free', tpsieqd, tpsifeqd, nxeqd, ra, psifra
     1   , nprofs)

c     Calculate the flux surface contours corresponding to psifra:


c     First bicubic spline peqd (and since cntour needs max peqd on axis,
c     temporarily invert peqd):
      peqd(:nxeqd,:nzeqd) = -peqd(:nxeqd,:nzeqd)*bisign

c     Check adaquate length for wnoperm:
      if (2*nxeqd*nzeqd + 2*max(nxeqd,nzeqd) > inoperm1) stop 42
      call ibcccu(peqd,xeqd,nxeqd,zeqd,nzeqd,cspln,nxeqd,wnoperm,ierr)

      peqd(:nxeqd,:nzeqd) = -peqd(:nxeqd,:nzeqd)*bisign

c     To get contours at nprofs surfaces:

      if (nptsd > nptsdm - 4) stop 43
      xcontr(:nptsd,1) = xma
      zcontr(:nptsd,1) = zma
      ncontr(1) = nptsd

c     The contour search area can be restricted by an amount
c     inset, from the grid boundary.  St. John uses inset=1 in some
c     D3D eqdsk cases to avoid difficulties near the coils.

      inset = 0
      xminc = xeqd(1+inset)
      xmaxc = xeqd(nxeqd-inset)
      zminc = zeqd(1+inset)
      zmaxc = zeqd(nzeqd-inset)
c      nptsdm1 = 120           Set in var.br
c      bperr = 1.e100         Set in var.br
c      dang = 4.0             Set in var.br
c      arcl = 1.e100          Set in var.br
      iounitx = 0
      iauto = 1
      ddx = 0.0
      ddz = 0.0

      do j = 2, nprofs
c     As the bndry is neared, specify step size for contour finding:
         if (j >= nprofs - 1) then
            ddx = 0.5*delx
            ddz = 0.5*delz
         endif
         call cntour (xma, zma, (-bisign*psifra(j,1)),xcmin,xcmax,zcmin,
     1      zcmax,zxcmin,zxcmax,xzcmin,xzcmax,dang,arcl,bperr,ddx,ddz,
     2      xminc,xmaxc,zminc,zmaxc,iauto,iautoc,xcontr(1,j), zcontr(1,j
     3      ), ncontr(j), xeqd, nxeqd, zeqd, nzeqd, cspln, 2, 2*nzeqd,
     4      iounitx, nptsdm1, ierr, bpcontr(1,j), 0)
c     To check angles with DDT:
         imax = ncontr(j)
         anglex(:imax) = atan2(zcontr(:imax,j)-zma,xcontr(:imax,j)-xma)*
     1      180./zpi
      end do
c
c     Check that the ncontr(j) = ntpsd:
      do j = 1, nprofs
         if (ncontr(j) /= nptsd) stop 44
      end do


c     Extend contours beyond plasma edge:
c     (Form additional contours outside the boundary flux surface
c     by extending along each ray which originates at the magnetic
c     axis, by a distance such that the additional flux surfaces are
c     (ra(jj)-1.)*tpsisav beyond the boundary flux surface).

c     Theta vector:
      dthet = 2.*zpi/(nptsd - 1.)
      do i = 1, nptsd
         thet(i) = (i - 1)*dthet
      end do

      do j = 1, nptsd
         cost = cos(thet(j))
         sint = sin(thet(j))
c     Get dirn. of normal to flux surface
         call dbcevl1 (xeqd, nxeqd, zeqd, nzeqd, cspln, nxeqd, xcontr(j,
     1      nprofs), zcontr(j,nprofs), pds, ier, 3)
         psiang = atan2((-pds(3)),(-pds(2)))
         if (psiang < 0.) psiang = psiang + 2.*zpi
c     The following cosine accounts for the ray from the magnetic
c     axis not being colinear with the normal to the magnetic surface.
         cosdd = cos(thet(j)-psiang)
         do jj = nprofs + 1, nprof
            dd = (ra(jj)-1.)*tpsisav/cosdd
            ddd = sqrt((xcontr(j,nprofs)-xma)**2+(zcontr(j,nprofs)-zma)
     1         **2) + dd
            xcontr(j,jj) = xma + ddd*cost
            zcontr(j,jj) = zma + ddd*sint
         end do
      end do

      ncontr(nprofs+1:nprof) = nptsd

c
c     Extend the contours 2 points in theta at either end of the
c     theta grid, as a measure to reduce edge effects:

      thet(nptsd+3) = thet(nptsd) + dthet
      thet(nptsd+4) = thet(nptsd) + 2.*dthet
      thet(nptsd+2:3:(-1)) = thet(nptsd:1:(-1))
      thet(1) = -2.*dthet
      thet(2) = -dthet

      ncontr(:nprof) = ncontr(:nprof) + 4
      xcontr(nptsd+3,:nprof) = xcontr(2,:nprof)
      xcontr(nptsd+4,:nprof) = xcontr(3,:nprof)
      zcontr(nptsd+3,:nprof) = zcontr(2,:nprof)
      zcontr(nptsd+4,:nprof) = zcontr(3,:nprof)
      bpcontr(nptsd+3,:nprof) = bpcontr(2,:nprof)
      bpcontr(nptsd+4,:nprof) = bpcontr(3,:nprof)
      xcontr(nptsd+2:3:(-1),:nprof) = xcontr(nptsd:1:(-1),:nprof)
      zcontr(nptsd+2:3:(-1),:nprof) = zcontr(nptsd:1:(-1),:nprof)
      bpcontr(nptsd+2:3:(-1),:nprof) = bpcontr(nptsd:1:(-1),:nprof)
      xcontr(1,:nprof) = xcontr(nptsd,:nprof)
      xcontr(2,:nprof) = xcontr(nptsd+1,:nprof)
      zcontr(1,:nprof) = zcontr(nptsd,:nprof)
      zcontr(2,:nprof) = zcontr(nptsd+1,:nprof)
      bpcontr(1,:nprof) = bpcontr(nptsd,:nprof)
      bpcontr(2,:nprof) = bpcontr(nptsd+1,:nprof)

      nptsd = nptsd + 4

c
c
c
c     Spline the xcontr(ra,thet) and zcontr(ra,thet) arrays,
c     thus obtaining X(theta,psi), Z(theta,psi).
c     (Except X is measured from the machine axis, whereas X-Bram
c      is measured from the magnetic axis).

      call ibcccu (xcontr, thet, nptsd, ra, nprof, csplnx, nptsdm1,
     1   wnoperm, ierr)

      call ibcccu (zcontr, thet, nptsd, ra, nprof, csplnz, nptsdm1,
     1   wnoperm, ierr)



c     Set br variables:
c     Plasma shape and magnetic field on axis.
      rzero = reqd
      bzero = abs(beqd)
      tcurr = toteqd
      raxmag = xma
      rshift = raxmag - rzero
      baxis = feqd(1)/raxmag

      psi = 1.
      theta = 0.
      call dbcevl1 (thet, nptsd, ra, nprof, csplnx, nptsdm1, theta, psi
     1   , pdsx, ier, 1)
      xmax = pdsx(1)
      psi = 1.
      theta = zpi
      call dbcevl1 (thet, nptsd, ra, nprof, csplnx, nptsdm1, theta, psi
     1   , pdsx, ier, 1)
      xmin = pdsx(1)
      rminor = 0.5*(xmax - xmin)

c     Here we define rplasm = ONETWO rho variable at plasma edge,
c     rather than (xma-xmin)/2, as in Brambilla flux surface representation.
      rplasm = tpsisav

c     ukzero (free space wavenumber) is set in subroutine inital.
      urplas = rplasm*ukzero
      uraxmag = raxmag*ukzero

c     Interpolate feqd onto ra grid giving fra, and set up splines:

      call intrpp ('free', 'free', tpsieqd, feqd, nxeqd, ra, fra, nprofs
     1   )
      fra(nprofs+1:nprof,1) = bzero*rzero*btsign

      call cubspl (dra, fra, nprofn, nprofs)

c     Form d(poloidal flux function)/d(rho/a) on the ra grid,
c     out to the plasma edge:
      call cubspl (dra, psifra, nprofn, nprofs)
      dpsifra(:nprofs) = psifra(:nprofs,2)
c
c     if(irayio.gt.0) return
      psinm(:nprofs) = 1. - abs((psifra(:nprofs,1)-psilim)/(psimag-
     1   psilim))
c
c     Get volume of flux surfaces at points out to the plasma surface,
c     using volume = 2*pi*integeral{dl_pol/B_p)*dpsifra*dra:
c $$$$$$$$$$$  Modified and added by T.K. Mau on 10/11/91/
c     Using area = integral{dl_pol/(B_p*R0}*dpsifra*dra
c     Define <J.B> and <B> in MKS units, used for current profiles

      call intrpp ('zero', 'free', tpsieqd, presseqd, nxeqd, ra, ppra,
     1   nprofs)
      call cubspl (dra, ppra, nprofn, nprofs)
c $$$$  Added by TK Mau on 12/2/91,  05/02/02
c     fpeqd(:nxeqd) = ffpeqd(:nxeqd)/feqd(:nxeqd)
      fpeqd(1) = (-3.*feqd(1)+4.*feqd(2)-feqd(3))/(2.*dpolflx)
      do i = 2,nxeqd-1
         fpeqd(i) = (feqd(i+1)-feqd(i-1))/(2.*dpolflx)
      enddo
      if(ffpeqd(nxeqd) == 0.) then
         fpeqd(nxeqd) = 0.
      else
         fpeqd(nxeqd) = (3.*feqd(nxeqd)-4.*feqd(nxeqd-1)+
     &                  feqd(nxeqd-2))/(2.*dpolflx)
      endif

      call intrpp ('free', 'free', tpsieqd, fpeqd, nxeqd, ra, fra1,
     1   nprofs)
      call cubspl (dra, fra1, nprofn, nprofs)
      call intrpp ('free', 'free', tpsieqd, ppeqd, nxeqd, ra, ppra1,
     1   nprofs)
      call cubspl (dra, ppra1, nprofn, nprofs)
c $$$$$$$$$$$$$$$$$$
      call intrpp ('free', 'free', tpsieqd, qeqd, nxeqd, ra, pqr, nprofs
     1   )
      zsurf(1) = 0.
      xwork(1) = 0.
      do j = 2, nprofs
         dv(j) = 0.0
         ds(j) = 0.0
         dlob(j) = 0.0
         dv1 = 0.
         do i = 4, nptsd - 2
            dlp = ((xcontr(i,j)-xcontr(i-1,j))**2+(zcontr(i,j)-zcontr(i-
     1         1,j))**2)**0.5
            bp1 = 0.5*(bpcontr(i,j)+bpcontr(i-1,j))
            rad1 = 0.5*(xcontr(i,j)+xcontr(i-1,j))
            bt1 = fra(1,1)/rad1
            dlpbp = dlp/bp1
            dv(j) = dv(j) + dlpbp
            dlob(j) = dlob(j) + dlp/sqrt(bt1**2 + bp1**2)
            ds(j) = ds(j) + dlpbp/rad1
            dv1 = dv1 + dlp*bp1
         end do
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c ---- Calculate incremental volume
         volume(j) = abs(2.*zpi*dv(j)*dra*dpsifra(j))
c ---- Calculate incremental cross section area
         zsurf(j) = ds(j)*dra*abs(dpsifra(j))
         xwork(j) = 2.*zpi*dv1*abs(dpsifra(j))
      end do
      volume(1) = volume(2)/3.
      dlob(1) = 0.25*dlob(2)
      dlob(nprofs) = 0.25*dlob(nprofs-1) + 0.75*dlob(nprofs)
c ---- Calculate incremental volumes and areas at center and edge
c     dv(1) = 1.75*dv(2)-0.75*dv(3)
c     volume(1) = 0.5*zpi*dra*abs(dv(1)*(0.75*dpsifra(1)+0.25*
c    &            dpsifra(2)))
c     ds(1) = 1.75*ds(2)-0.75*ds(3)
c     zsurf(1) = 0.25*dra*abs(ds(1)*(0.75*dpsifra(1)+0.25*
c    &           dpsifra(2)))
c     volume(nprofs) = 0.5*zpi*dra*abs((0.75*dv(nprofs)+0.25*
c    &                 dv(nprofs-1))*(0.75*dpsifra(nprofs)+0.25*
c    &                 dpsifra(nprofs-1)))
c     zsurf(nprofs) = 0.25*dra*abs((0.75*ds(nprofs)+0.25*
c    &                ds(nprofs-1))*(0.75*dpsifra(nprofs)+0.25*
c    &                dpsifra(nprofs-1)))
c ---- Calculate internal plasma inductance
      ali3 = 2.*simp(nprofs,dra,xwork)/(reqd*(amu0*toteqd)**2)
c ---- Calculate total and poloidal (Shafranov) betas.
      dl = 0.
      do i = 4, nptsd - 2
         dlp = ((xcontr(i,nprofs)-xcontr(i-1,nprofs))**2+(zcontr(i,
     1      nprofs)-zcontr(i-1,nprofs))**2)**0.5
         dl = dl + dlp
      end do
      xwork(1) = 0.
      xwork(2:nprofs) = volume(2:nprofs)/dra
      ywork(2:nprofs) = ppra(2:nprofs,1)*xwork(2:nprofs)
      bpsep = amu0*toteqd/dl
      beta = 2.*amu0*simp(nprofs,dra,ywork)/beqd**2/simp(nprofs,dra,
     1   xwork)
      betap = beta*(beqd/bpsep)**2
c $$$$$$$$$$$$$$$$$$

      volume(1) = volume(2)/3.
c
c $$$$$$$$    TKM   10/00
c Define array r/a versus rho
      rmd(nprof) = raxmag
      roa(1) = 0.
      do jmd = 1, nprof - 1
         jmd1 = nprof - jmd + 1
         jmd2 = 2*nprof - jmd
         rmd(jmd) = xcontr(48,jmd1)
         rmd(jmd2) = xcontr(3,jmd1)
         roa(jmd1) = rmd(jmd2) - rmd(jmd)
      end do
      rmina = rmd(2*nprof-1) - rmd(1)
      roa(2:nprof) = roa(2:nprof)/rmina
c $$$$$$$$$$$$$$$$$
c     Extend volume and poloidal flux function beyond the plasma
c     edge, from ra(nprofs) to ra(nprof).
c     Simply take volume increments as volumes added by each additional
c     surface, and poloidal flux fctn increments as plasma edge pol field
c     at theta=0, ra=1., times added poloidal directed area / (2*pi):

      call dbcevl1 (xeqd, nxeqd, zeqd, nzeqd, cspln, nxeqd, xcontr(1,
     1   nprofs), zcontr(1,nprofs), pds, ier, 3)
      bpedge = (pds(2)**2+pds(3)**2)**.5/xcontr(1,nprofs)

      do j = nprofs + 1, nprof
         dv(j) = 0.
         dv(j) = dv(j) + sum(0.5*(xcontr(4:nptsd-2,j)+xcontr(3:nptsd-3,j
     1      ))*((xcontr(4:nptsd-2,j)-xcontr(3:nptsd-3,j))**2+(zcontr(4:
     2      nptsd-2,j)-zcontr(3:nptsd-3,j))**2)**.5)
c $$$$  Modified by T.K. Mau on 1/31/92.
         volume(j) = 2.*zpi*dv(j)*dra*abs(tpsisav)
c $$$$$$$$$$$$$$$$$
         psifra(j,1) = psifra(j-1,1) + bpedge*xcontr(1,j)*dra*tpsisav*
     1      bisign
      end do

      call cubspl (dra, psifra, nprofn, nprof)


c*************************************************************************
c     To obtain equivalence with Brambilla psi-theta representation
c     of the flux surfaces, using the above ra and thet:
c           psi = ra
c           theta = thet
c     Then the Brambilla equilibrium arrays are tpsi = ra
c                                               ppsi = ra
c                                              tpsif = psifra
c                                                tqr = B_p(psi)/B_T(psi)
c*************************************************************************

      dpsi = dra
      ppsi(:nprof) = ra(:nprof)
      tpsif(:nprof,:) = psifra(:nprof,:)

      tqr(:nprof,1) = tpsif(:nprof,2)/(tpsisav*fra(:nprof,1))

      call cubspl (dpsi, tqr, nprofn, nprof)



      if (ieqdsk == 4) then

c*************************************************************************
c     Continue reading eqdsk if ieqdsk.eq.4, i.e., an extended eqdsk
c     is being used, such as from cql3d with eqsource="tsc".
c*************************************************************************
!         call link ('unit59=terminal//')
         write (6, 8250)
 8250    format('Reading eqdsk')
         read (iounit1, 8210) nlim, nlimiter
 8210 format(5i5)

c     if (nlim.ne.0) then
         read (iounit1, 8200) (rlim(i),zlim(i),i=1,nlim)
         read (iounit1, 8200) (rlimiter(i),zlimiter(i),i=1,nlimiter)
c     endif
c..................................................................
c     The following output is not part of the "official" eqdsk.
c..................................................................
 8200 format(5e16.9)
         nti = 1
         read (iounit1, 8210) lrz, nprim, nimp, nti
         if (lrz > lrza) stop 60
         nion = nprim + nimp
         read (iounit1, 8200) (atm(k),k=1,nion)
         do k = 1, nion
            read (iounit1, 8200) (zi(j,k),j=1,lrz)
         end do
         read (iounit1, 8200) (zeffz(j),j=1,lrz)
         read (iounit1, 8200) (r(j),j=1,lrz)
         read (iounit1, 8200) (psifeqd(j),j=1,lrz)
         read (iounit1, 8200) (te(j),j=1,lrz)
         do k = 1, nti
            read (iounit1, 8200) (ti(j,k),j=1,lrz)
         end do
         read (iounit1, 8200) (ene(j),j=1,lrz)
         do k = 1, nion
            read (iounit1, 8200) (enp(j,k),j=1,lrz)
         end do
         raeqd(:lrz) = r(:lrz)/r(lrz)
c---- Latest update:   TKM   05/00
c-----Include a small concentration of hydrogen, for DIII-D runs
         hconc = 0.02
         if (hconc > 0.) then
            do k = 1, nion
               if (atm(k)==2 .and. zi(1,k)==1.) kdeu = k
            end do
            nion = nion + 1
            atm(nion) = 1.
            zi(:lrz,nion) = 1.
            enp(:lrz,nion) = hconc*enp(:lrz,kdeu)
            enp(:lrz,kdeu) = (1. - zi(:lrz,nion)*hconc)*enp(:lrz,kdeu)
         endif
c
C*****************************************************
c-----Read beam ion data directly from ONETWO;  TKM  04/00, 05/00
         read (iounit1, 8220) nalfa, nbeams
         if (nalfa /= 0) then
            do k = 1, nalfa
               read (iounit1, 8230) ebkev(k), bmpwr(k), azf(k), atmf(k)
               read (iounit1, 8200) (pnf(j,k),j=1,lrz)
               read (iounit1, 8200) (zetab(j,k),j=1,lrz)
               dumf(:lrz) = pnf(:lrz,k)
               call intrpp ('zero', 'free', raeqd, dumf, lrz, ra, dumf1
     1            , nprofs)
               pnfi(k,:nprofs) = dumf1(:nprofs)
               if (iedge == 1) then
                  do j = nprofs + 1, nprof
                     zdecay = exp((-0.5*float(j + nprofs)))
                     pnfi(k,j) = pnfi(k,nprofs)*zdecay
                  end do
               endif
            end do
c
c $$$$   TKM   09/99, 04/00
c ----Read beam ion density and Maxw. temperature profiles, and
c     assign them after primary and impurity ion species.
            nion = nion + 1
            read (iounit1, 8200) (enbeam(j),j=1,lrz)
            read (iounit1, 8200) (wbeam(j),j=1,lrz)
            zi(:lrz,nion) = azf(1)
            ti(:lrz,nion) = wbeam(:lrz)
            enp(:lrz,nion) = 1.E6*enbeam(:lrz)
            atm(nion) = atmf(1)
c
C**************************
C  profile of density and temperature are generalized  SCC 12/12/95
c  Include possibility of one beam ion species   TKM 04/00, 05/00
C***************************
         endif
         nspec = nion
         enetot = sum(ene(:lrz))
         azi(:nion) = zi(1,:nion)
         do k = 1, nion
            enp(:lrz,k) = enp(:lrz,k)*zi(:lrz,k)/azi(k)
         end do
c----- Adjust electron density to assure neutrality.
         ene00 = ene(1)
         do j = 1, lrz
            ene(j) = 0.
            ene(j) = ene(j) + sum(azi(:nion)*enp(j,:nion))
            ene(j) = 1.E-6*ene(j)
         end do
         niont = nion
         if (nalfa > 0) niont = nion - 1
         do k = 1, nion
            enp(:lrz,k) = 1.E-6*enp(:lrz,k)*ene00/ene(1)
            if (k>1 .and. k<=niont) then
               where (ti(:lrz,k) <= 0.) ti(:lrz,k) = ti(:lrz,1)
            endif
         end do
c----- Adjust back to original peak electron density
         ratden = 1.E-6*ene00/ene(1)
         ene(:lrz) = ratden*ene(:lrz)
         enp(:lrz,:nion) = ratden*enp(:lrz,:nion)
         nalfa = 0
c     Initialize ne, te, ti profiles from plasma center to edge.

         call intrpp ('zero', 'free', raeqd, ene, lrz, ra, pne, nprofs)
         call intrpp ('zero', 'free', raeqd, te, lrz, ra, pte, nprofs)
c-------------------SCC  4/23/96
         call intrpp ('zero', 'free', raeqd, zeffz(1), lrz, ra, tzeff(1,
     1      1), nprofs)
c---------------------------
         do k = 1, nion
            call intrpp ('zero', 'free', raeqd, ti(1,k), lrz, ra, pti(1,
     1         k), nprofs)
            call intrpp ('zero', 'free', raeqd, enp(1,k), lrz, ra, pni(1
     1         ,k), nprofs)
         end do
         do k = 1, nion
            conc(:nprofs,k) = pni(:nprofs,k)/pne(:nprofs)
         end do

c     Extend beyond plasma surface if iedge=1:
         if (iedge == 1) then
            do j = nprofs + 1, nprof
               zdecay = exp((-float(j - nprofs)/2.))
               pne(j) = pne(nprofs)*zdecay
               pte(j) = pte(nprofs)*zdecay
               pni(j,:nion) = pni(j,:nion)*zdecay
               pti(j,:nion) = pti(j,:nion)*zdecay
               conc(j,:nion) = pni(j,:nion)/pne(j)
            end do
         endif
c $$$$$$$$$$$$$
 8220    format(2i5)
 8230    format(4e16.9)
         write (59, 8240) nspec, (pni(1,k),k=1,nspec), (pti(1,k),k=1,
     1      nspec)
 8240    format('nspec=',i5,/,'deni(0)=',3(e16.4,3x),/,'temi(0)=',3(
     1      e16.4,3x))
c
      endif
      return
c
      end subroutine fiteqdsk
c
c
      subroutine lsfun1(n, m, xc, fc)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:56:54   6/14/01
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh
      use Vcraylh, only: psi, theta, asinth, bx0, bx1, bx2, bz0, ux, uz,
     1                   ukzero, raxmag
      use Vceqdsk
      USE Vclsfun1
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer n, m
      real(kind=dp), dimension(n) :: xc
      real(kind=dp), dimension(m) :: fc
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: lmhd, i, id
      real(kind=dp), dimension(3) :: zbx0, zbx1, zbx2, zbz0
      real(kind=dp) :: zh, zph, zcosph, fxxx, fzzz
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
!      integer , EXTERNAL :: ifix
      real(kind=dp) , EXTERNAL :: valspl  !  , abs, sin
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c

c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95

c
c   ****************************************************************
c
c
c   ****************************************************************
c
      psi = xc(1)
      theta = xc(2)
c
      if (abs(psi) < 1.E-10) psi = sign(1.0_dp,psi)*1.E-10
c********************************
c     if(psi.gt.psilimit)  psi=psilimit
c************************** 2/14/92  BH
c
      asinth = sin(theta)
c
c   ****************************************************************
c   evaluations of rshift, rho, dtrian, elong and their derivatives
c   ****************************************************************
c
!      lmhd = ifix(psi/dpsimhd) + 1
      lmhd = int(psi/dpsimhd) + 1
      zh = psi - psimhd(lmhd)
c
      do i = 1, 1
         id = i - 1
         zbx0(i) = valspl(zh,bx0,nprofn,lmhd,id)
         zbx1(i) = valspl(zh,bx1,nprofn,lmhd,id)
         zbx2(i) = valspl(zh,bx2,nprofn,lmhd,id)
         zbz0(i) = valspl(zh,bz0,nprofn,lmhd,id)
      end do
c
c   ****************************************************************
c   evaluation of xu(psi,theta), zu(psi,theta), and derivatives
c   ****************************************************************
c
      zph = theta - zbx2(1)*asinth
      zcosph = cos(zph)
c
      ux = zbx0(1) + zbx1(1)*zcosph
      uz = zbz0(1)*asinth
c
      fxxx = ux/ukzero + (raxmag - rzero)
      fzzz = uz/ukzero

      fc(1) = xxx - fxxx
      fc(2) = zzz - fzzz
      if (psi <= 0.) then
         fc(1) = 100.
         fc(2) = 100.
      endif

      return
      end subroutine lsfun1
      subroutine mhdebm
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:56:54   6/14/01
C...Switches: -p4 -yb
c
c---------------------------
c  This subroutine replaces fiteqdsk. Instead of requiring an eqdsk-file,
c  it reads in MHDE data from Bob-Miller's MHDE-code and processes the
c  required input for coords and profix and profin
c  Calls mhdebm1
c  ieqdsk = 5 to call this routine.
c-----------------------------
c------------------------------

C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh
      use Vcraylh, only: baxis, pqr, torflx, ukzero, urplas,
     1        raxmag, xmin, xmax, dpolas, ppra, ppra1, dpsi,
     2        uraxmag, zsurf, volume, tpsif, tqr
      use Vceqdsk
      use Vcmnew, only: dlob
!      USE Vfwcd3
!      USE Vcmalfa, ONLY: lrza
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: nnpsi, nnthet, n, j, jr, i, jj, ierr
      real(kind=dp), dimension(nprofm) :: ywork, xwork, dumf1, dv, ds
      real(kind=dp) :: zpi, amu0, qaxis, dthet, dra, pax, bisign,
     1    rminor, dv1,
     1   dlp, bp1, rad1, bt1, dlpbp, dl, bpsep
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real(kind=dp) , EXTERNAL :: simp  !  , abs
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i

c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95

c    6                modcd
c $$$$$$       TKM    04/00
c
c
c  dimension pprime,chipsi,vprime,b_fld,dstarp,btcontr,jacob,
c  torflx
c  in curray.v
c

c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      zpi = 4.*atan2(1.,1.)
      amu0 = zpi*4.E-7
c $$$$$$$$$$$$$$$$$

      call mhdebm1 (nprofm, nptsdm, nnpsi, nnthet, iounit1, iout, dumf1
     1   , jacob, xcontr, zcontr, b_fld, dstarp, bpcontr, btcontr, ra,
     2   pprime, chipsi, xwork, ywork, vprime, thet, qaxis, dthet, dra,
     3   pax, btsign, rzero, bzero, baxis, psimag, psilim, xdimeqd,
     4   zdimeqd, redeqd, zmideqd, xma, zma, toteqd)
      reqd = rzero
      nprof = nnpsi
      nprofs = nprof
      nptsd = 2*nnthet - 1
      dra = ra(2) - ra(1)
      fra(:nprof,1) = dumf1(:nprof)
      pqr(:nprof,1) = xwork(:nprof)
      psifra(:nprof,1) = ywork(:nprof)
      call cubspl (dra, fra, nprofn, nprofs)
      call cubspl (dra, psifra, nprofn, nprofs)
      call cubspl (dra, pqr, nprofn, nprofs)
c-------------------------
c  get toroidal flux function
c--------------------------
      beqd = bzero*btsign
      bisign = sign(1.0_dp,toteqd)
      torflx(1) = 0.
      do n = 2, nprof
         torflx(n) = torflx(n-1) + 0.5*(xwork(n-1)+xwork(n))*(ywork(n)-
     1      ywork(n-1))
      end do
      torflx(:nprof) = -2.*zpi*torflx(:nprof)
      rrho(:nprof) = sqrt(abs(torflx(:nprof)/(zpi*beqd)))
      tpsisav = rrho(nprof)

c*******************************


      ncontr(:nprof) = nptsd

c-----------------
c  implement up-down symmetry
c------------------
      do j = nnthet + 1, nptsd
         jr = 2*nnthet - j
         thet(j) = thet(j-1) + dthet
         jacob(j,:nprof) = jacob(jr,:nprof)
         xcontr(j,:nprof) = xcontr(jr,:nprof)
         zcontr(j,:nprof) = -zcontr(jr,:nprof)
         b_fld(j,:nprof) = b_fld(jr,:nprof)
         dstarp(j,:nprof) = dstarp(jr,:nprof)
         bpcontr(j,:nprof) = bpcontr(jr,:nprof)
         btcontr(j,:nprof) = btcontr(jr,:nprof)
      end do

c
c     Extend the contours 2 points in theta at either end of the
c     theta grid, as a measure to reduce edge effects:

      thet(nptsd+3) = thet(nptsd) + dthet
      thet(nptsd+4) = thet(nptsd) + 2.*dthet
      thet(nptsd+2:3:(-1)) = thet(nptsd:1:(-1))
      thet(1) = -2.*dthet
      thet(2) = -dthet

      ncontr(:nprof) = ncontr(:nprof) + 4
      xcontr(nptsd+3,:nprof) = xcontr(2,:nprof)
      xcontr(nptsd+4,:nprof) = xcontr(3,:nprof)
      zcontr(nptsd+3,:nprof) = zcontr(2,:nprof)
      zcontr(nptsd+4,:nprof) = zcontr(3,:nprof)
      bpcontr(nptsd+3,:nprof) = bpcontr(2,:nprof)
      bpcontr(nptsd+4,:nprof) = bpcontr(3,:nprof)
      xcontr(nptsd+2:3:(-1),:nprof) = xcontr(nptsd:1:(-1),:nprof)
      zcontr(nptsd+2:3:(-1),:nprof) = zcontr(nptsd:1:(-1),:nprof)
      bpcontr(nptsd+2:3:(-1),:nprof) = bpcontr(nptsd:1:(-1),:nprof)
      xcontr(1,:nprof) = xcontr(nptsd,:nprof)
      xcontr(2,:nprof) = xcontr(nptsd+1,:nprof)
      zcontr(1,:nprof) = zcontr(nptsd,:nprof)
      zcontr(2,:nprof) = zcontr(nptsd+1,:nprof)
      bpcontr(1,:nprof) = bpcontr(nptsd,:nprof)
      bpcontr(2,:nprof) = bpcontr(nptsd+1,:nprof)

      nptsd = nptsd + 4

c
c
c
c     Spline the xcontr(ra,thet) and zcontr(ra,thet) arrays,
c     thus obtaining X(theta,psi), Z(theta,psi).
c     (Except X is measured from the machine axis, whereas X-Bram
c      is measured from the magnetic axis).

      call ibcccu (xcontr, thet, nptsd, ra, nprof, csplnx, nptsdm1,
     1   wnoperm, ierr)

      call ibcccu (zcontr, thet, nptsd, ra, nprof, csplnz, nptsdm1,
     1   wnoperm, ierr)



c     Set br variables:
c     Plasma shape and magnetic field on axis.
      tcurr = toteqd
      raxmag = xma
      rshift = raxmag - rzero

      xmax = redeqd + xdimeqd
      xmin = redeqd
      rminor = 0.5*(xmax - xmin)

c     Here we define rplasm = ONETWO rho variable at plasma edge,
c     rather than (xma-xmin)/2, as in Brambilla flux surface representation.
      rplasm = tpsisav

c     ukzero (free space wavenumber) is set in subroutine inital.
      urplas = rplasm*ukzero
      uraxmag = raxmag*ukzero


c     Form d(poloidal flux function)/d(rho/a) on the ra grid,
c     out to the plasma edge:
      dpsifra(:nprofs) = psifra(:nprofs,2)

c     Get volume of flux surfaces at points out to the plasma surface,
c     using volume = 2*pi*integeral{dl_pol/B_p)*dpsifra*dra:
c $$$$$$$$$$$  Modified and added by T.K. Mau on 10/11/91/
c     Using area = integral{dl_pol/(B_p*R0}*dpsifra*dra
c     Define <J.B> and <B> in MKS units, used for current profiles
      ppra(nprof,1) = 0.
      do n = nprof - 1, 1, -1
         ppra(n,1) = ppra(n+1,1) + 0.5*(pprime(n)+pprime(n+1))*(ywork(n)
     1      -ywork(n+1))
      end do
      call cubspl (dra, ppra, nprofn, nprofs)
c $$$$  Added by TK Mau on 12/2/91
      fra1(:nprof,1) = -(dstarp(1,:nprof)+4*zpi*xcontr(3,:nprof)*pprime(
     1   :nprof))/fra(:nprof,1)
      call cubspl (dra, fra1, nprofn, nprofs)
      ppra1(:nprof,1) = pprime(:nprof)
      call cubspl (dra, ppra1, nprofn, nprofs)
c $$$$$$$$$$$$$$$$$$
      zsurf(1) = 0.
      xwork(1) = 0.
      do j = 2, nprofs
         dv(j) = 0.0
         ds(j) = 0.0
         dlob(j) = 0.0
         dv1 = 0.
         do i = 4, nptsd - 2
            dlp = ((xcontr(i,j)-xcontr(i-1,j))**2+(zcontr(i,j)-zcontr(i-
     1         1,j))**2)**0.5
            bp1 = 0.5*(bpcontr(i,j)+bpcontr(i-1,j))
            rad1 = 0.5*(xcontr(i,j)+xcontr(i-1,j))
            bt1 = fra(1,1)/rad1
            dlpbp = dlp/bp1
            dv(j) = dv(j) + dlpbp
            dlob(j) = dlob(j) + dlp/sqrt(bt1**2 + bp1**2)
            ds(j) = ds(j) + dlpbp/rad1
            dv1 = dv1 + dlp*bp1
         end do
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c ---- Calculate incremental volume
         volume(j) = abs(2.*zpi*dv(j)*dra*dpsifra(j))
c ---- Calculate incremental cross section area
         zsurf(j) = ds(j)*dra*abs(dpsifra(j))
         xwork(j) = 2.*zpi*dv1*abs(dpsifra(j))
      end do
      volume(1) = volume(2)/3.
      dlob(1) = 0.25*dlob(2)
      dlob(nprofs) = 0.25*dlob(nprofs-1) + 0.75*dlob(nprofs)
c ---- Calculate incremental volumes and areas at center and edge
c     dv(1) = 1.75*dv(2)-0.75*dv(3)
c     volume(1) = 0.5*zpi*dra*abs(dv(1)*(0.75*dpsifra(1)+0.25*
c    &            dpsifra(2)))
c     ds(1) = 1.75*ds(2)-0.75*ds(3)
c     zsurf(1) = 0.25*dra*abs(ds(1)*(0.75*dpsifra(1)+0.25*
c    &           dpsifra(2)))
c     volume(nprofs) = 0.5*zpi*dra*abs((0.75*dv(nprofs)+0.25*
c    &                 dv(nprofs-1))*(0.75*dpsifra(nprofs)+0.25*
c    &                 dpsifra(nprofs-1)))
c     zsurf(nprofs) = 0.25*dra*abs((0.75*ds(nprofs)+0.25*
c    &                ds(nprofs-1))*(0.75*dpsifra(nprofs)+0.25*
c    &                dpsifra(nprofs-1)))
c ---- Calculate internal plasma inductance
      ali3 = 2.*simp(nprofs,dra,xwork)/(reqd*(amu0*toteqd)**2)
c ---- Calculate total and poloidal (Shafranov) betas.
      dl = 0.
      do i = 4, nptsd - 2
         dlp = ((xcontr(i,nprofs)-xcontr(i-1,nprofs))**2+(zcontr(i,
     1      nprofs)-zcontr(i-1,nprofs))**2)**0.5
         dl = dl + dlp
      end do
      xwork(1) = 0.
      xwork(2:nprofs) = volume(2:nprofs)/dra
      ywork(2:nprofs) = ppra(2:nprofs,1)*xwork(2:nprofs)
      bpsep = amu0*toteqd/dl
      beta = 2.*amu0*simp(nprofs,dra,ywork)/beqd**2/simp(nprofs,dra,
     1   xwork)
      betap = beta*(beqd/bpsep)**2
c $$$$$$$$$$$$$$$$$$

      volume(1) = volume(2)/3.


c*************************************************************************
c     To obtain equivalence with Brambilla psi-theta representation
c     of the flux surfaces, using the above ra and thet:
c           psi = ra
c           theta = thet
c     Then the Brambilla equilibrium arrays are tpsi = ra
c                                               ppsi = ra
c                                              tpsif = psifra
c                                                tqr = B_p(psi)/B_T(psi)
c*************************************************************************

      dpsi = dra
      ppsi(:nprof) = ra(:nprof)
      tpsif(:nprof,:) = psifra(:nprof,:)

      tqr(:nprof,1) = tpsif(:nprof,2)/(tpsisav*fra(:nprof,1))

      call cubspl (dpsi, tqr, nprofn, nprof)





      return

      end subroutine mhdebm
      subroutine mhdebm1(kpsi, kthet, npsi, nthet, iounit1, iout, f_bal
     1   , jacob, xcontr, zcontr, b_fld, dstarp, bpcontr, btcontr, ra,
     2   pprime, chipsi, pqr1, psiv, vprime, thec, qaxis, dthe, dpsi,
     3   pax, btsign, rzero, bzero, baxis, psimag, psilim, xdimeqd,
     4   zdimeqd, redeqd, zmideqd, xma, zma, totcur)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:56:54   6/14/01
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
!      use Viorlh, only: bzero, rzero, btsign
!      use Vcraylh, only: dpsi
!      use Vceqdsk, only: psimag, psilim
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer kpsi, kthet, npsi, nthet, iounit1, iout
      real(kind=dp) qaxis, dthe, pax, dpsi, btsign, rzero, bzero,
     1    baxis, psimag,
     1   psilim, xdimeqd, zdimeqd, redeqd, zmideqd, xma, zma, totcur
      real(kind=dp), dimension(kpsi) :: f_bal
      real(kind=dp), dimension(kthet,kpsi) :: jacob, xcontr, zcontr,
     1    b_fld,
     1   dstarp, bpcontr, btcontr
      real(kind=dp), dimension(kpsi) :: ra, pprime, chipsi, pqr1,
     1    psiv, vprime
      real(kind=dp), dimension(kthet) :: thec
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, j, n0, n
      real(kind=dp) :: alpsi, psibnd
      real(kind=dp), dimension(kpsi,kthet) :: dummy
      real(kind=dp), dimension(kpsi) :: dummee
      real(kind=dp) :: zpi, xthe, zthe, xpsi, zpsi, denom, psix, psiz,
     1    bval,
     1   rbpsq, facp, facx, facf, facj, facb, facdsp, amu0, end, gpsi2,
     2   zmax, reqd, fpi
      character, dimension(10) :: line*8
C-----------------------------------------------
c
c---------------------------
c  This subroutine replaces fiteqdsk. Instead of requiring an eqdsk-file,
c  it reads in MHDE data from Bob-Miller's MHDE-code and processes the
c  required input for coords and profix and profin
c-----------------------------

      data facp/1.E-8/
      data facx/1.E-2/
      data facf/1.E-6/
      data facj/1.E-6/
      data facb/1.E-4/
      data facdsp/1.E-4/

c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      zpi = 4.*atan2(1.,1.)
      amu0 = zpi*4.E-7
c $$$$$$$$$$$$$$$$$


c-------------------------------
c  read in Bob Miller's dskbal file
c----------------------------
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 100) npsi, nthet
  100 format(2i5)
      if (npsi>kpsi .or. nthet>kthet) then
         write (iout, 400) npsi, kpsi, nthet, kthet
  400    format(2x,'Either npsi or nthet is too large:','npsi=',i6,2x,
     1      'kpsi=',i6,';  nthet=',i6,2x,'kthet=',i6)
         stop
      endif
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) qaxis, dthe, dpsi, alpsi, psibnd, pax
  200 format(5e16.8)
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (f_bal(i),i=1,npsi)    !f_bal is f
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (ra(i),i=1,npsi)       ! psi coordinate 0-1
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (thec(j),j=1,nthet)    ! theta coordinat 0-pi
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) ((dummy(i,j),i=1,npsi),j=1,nthet)
      jacob(:nthet,:npsi) = transpose(dummy(:npsi,:nthet))
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) ((dummy(i,j),i=1,npsi),j=1,nthet)
      xcontr(:nthet,:npsi) = transpose(dummy(:npsi,:nthet))
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) ((dummy(i,j),i=1,npsi),j=1,nthet)
      zcontr(:nthet,:npsi) = transpose(dummy(:npsi,:nthet))
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) ((dummy(i,j),i=1,npsi),j=1,nthet)
      b_fld(:nthet,:npsi) = transpose(sqrt(dummy(:npsi,:nthet)))
c------------------
c  b_fld is magnitude of local b-field
c-------------------
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) ((dummy(i,j),i=1,npsi),j=1,nthet)
      dstarp(:nthet,:npsi) = transpose(dummy(:npsi,:nthet))
c---------------------
c  dstarp is del(star) of psiv, i.e., 4*pi*R*jphi/c
c---------------------
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (pprime(i),i=1,npsi)   !=pprime
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (dummee(i),i=1,npsi)   !=0
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (dummee(i),i=1,npsi)   !=0
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (dummee(i),i=1,npsi)   !=0
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (dummee(i),i=1,npsi)   !=0
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) ((dummy(i,j),i=1,npsi),j=1,nthet)
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (dummee(i),i=1,npsi)   !=0
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (dummee(i),i=1,npsi)   !=0
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200) (chipsi(i),i=1,npsi)
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200, end=300) (pqr1(i),i=1,npsi)
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200, end=300) (psiv(i),i=1,npsi)
      read (iounit1, '(10a8)') (line(i),i=1,10)
      read (iounit1, 200, end=300) (vprime(i),i=1,npsi)
c---------------------------
c  psiv is poloidal flux function (psi in GS eqn.)
c  chipsi is d(psiv)/d(psic)
c  pqr1 is safety factor
c  vprime is dV/d(psiv)
c-----------------------
  300 continue
c---------------------------
c
      thec(nthet) = zpi
c-----------------------------------------------------------------------
c compute (r*bp)^2/b for stambaugh -- omegaE
c-----------------------------------------------------------------------
      do i = 2, npsi - 1
         do j = 1, nthet
            bval = f_bal(i)/xcontr(j,i)
            xpsi = (xcontr(j,i+1)-xcontr(j,i-1))/(2.*dpsi)
            zpsi = (zcontr(j,i+1)-zcontr(j,i-1))/(2.*dpsi)
            if (j/=1 .and. j/=nthet) then
               xthe = (xcontr(j+1,i)-xcontr(j-1,i))/(2.*dthe)
               zthe = (zcontr(j+1,i)-zcontr(j-1,i))/(2.*dthe)
            else
               xthe = 0.
               if (j == 1) zthe = zcontr(2,i)/dthe
               if (j == nthet) zthe = -zcontr(nthet-1,i)/dthe
            endif
            denom = 1./(xpsi*zthe - zpsi*xthe)
            psix = zthe*denom
            psiz = -xthe*denom
            gpsi2 = psix**2 + psiz**2
            rbpsq = gpsi2*chipsi(i)**2
c           omegE(j,i)=rbpsq/bval
            bpcontr(j,i) = sqrt(rbpsq/xcontr(j,i)**2)
            btcontr(j,i) = bval
c           omegE(j,i)=rbpsq/sqrt(bt(j,i)**2+bp(j,i)**2)
         end do
      end do
      i = npsi
c        omegE(i,j)=amax1(2.*omegE(i-1,j)-omegE(i-2,j),0.)
      btcontr(:nthet,i) = max(2.*btcontr(:nthet,i-1)-btcontr(:nthet,i-
     1   2),0.0_dp)
      bpcontr(:nthet,i) = max(2.*bpcontr(:nthet,i-1)-bpcontr(:nthet,i-
     1   2),0.0_dp)
      i = 1
c        omegE(i,j)=0.
      bpcontr(:nthet,i) = 0.
      btcontr(:nthet,i) = f_bal(i)/xcontr(:nthet,i)

c----------------------------
c  calculate quantities needed in raypat,coords and profix
c-----------------------------
      btsign = sign(1.0_dp,btcontr(1,1))
      rzero = 0.5E0*(xcontr(1,npsi)+xcontr(nthet,npsi))
      baxis = btcontr(1,1)
      psimag = psiv(1)
      psilim = psiv(npsi)
      xdimeqd = xcontr(1,npsi) - xcontr(nthet,npsi)
      zmax = zcontr(1,npsi)
      zmax = max(maxval(zcontr(:nthet,npsi)),zmax)
      zdimeqd = 2.*zmax
      reqd = rzero
      redeqd = xcontr(nthet,npsi)
      zmideqd = 0.
      xma = xcontr(1,1)
      zma = zcontr(1,1)
c-----------------
c  bzero is nominal b-field at rzero
c-----------------
      if (rzero < xma) then
         n0 = npsi - 1
         do n = npsi - 2, 1, -1
            if (rzero >= xcontr(nthet,n)) n0 = n
         end do
         bzero = b_fld(nthet,n0) + (rzero - xcontr(nthet,n0))*(b_fld(
     1      nthet,n0+1)-b_fld(nthet,n0))/(xcontr(nthet,n0+1)-xcontr(
     2      nthet,n0))
      else if (rzero >= xma) then
         n0 = 1
         do n = 2, npsi - 1
            if (rzero >= xcontr(1,n)) n0 = n
         end do
         bzero = b_fld(1,n0) + (rzero - xcontr(1,n0))*(b_fld(1,n0+1)-
     1      b_fld(1,n0))/(xcontr(1,n0+1)-xcontr(1,n0))
      endif
c-----------------
c  totcur is total current
c------------------
      fpi = 4.E0*zpi
      dummy(:npsi,:nthet) = transpose(dstarp(:nthet,:npsi)*jacob(:nthet,
     1   :npsi)/xcontr(:nthet,:npsi)**2)
      do i = 1, npsi
         dummee(i) = 0.
         dummee(i) = dummee(i) + sum(0.5*(dummy(i,:nthet-1)+dummy(i,2:
     1      nthet)))
      end do
      totcur = sum(0.5*(dummee(:npsi-1)+dummee(2:npsi)))
      totcur = 2.*totcur*10.*dthe*dpsi/fpi
c     totcur in amps.

c*******************************
c  change units from cgs to MKS
      f_bal(:npsi) = f_bal(:npsi)*facf
      jacob(:nthet,:npsi) = jacob(:nthet,:npsi)*facj
      xcontr(:nthet,:npsi) = facx*xcontr(:nthet,:npsi)
      zcontr(:nthet,:npsi) = facx*zcontr(:nthet,:npsi)
      b_fld(:nthet,:npsi) = b_fld(:nthet,:npsi)*facb
      dstarp(:nthet,:npsi) = dstarp(:nthet,:npsi)*facdsp
      bpcontr(:nthet,:npsi) = bpcontr(:nthet,:npsi)*facb
      btcontr(:nthet,:npsi) = btcontr(:nthet,:npsi)*facb
      pprime(:npsi) = pprime(:npsi)*1.E7
      chipsi(:npsi) = chipsi(:npsi)*facp
      vprime(:npsi) = vprime(:npsi)*1.E2
      psiv(:npsi) = psiv(:npsi)*facp
      bzero = bzero*facb
      baxis = baxis*facb
      psimag = psimag*facp
      psilim = psilim*facp
      xdimeqd = xdimeqd*facx
      zdimeqd = zdimeqd*facx
      redeqd = redeqd*facx
      rzero = rzero*facx
      zmideqd = zmideqd*facx
      xma = xma*facx
      zma = zma*facx




      return

      end subroutine mhdebm1
c
      function qsaf (psi)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:56:54   6/14/01
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh
      use Vcraylh, only: tpsi, zlamb, zqfac
      use Vceqdsk
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real(kind=dp) qsaf
      real(kind=dp) psi
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: left
      real(kind=dp) :: dpsi
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c--------SCC  5/23/95

      if (psi <= 1.) then
         if (qsafa > 0.) then
            qsaf = qsaf0/(1. - (1. - qsaf0/qsafa)*psi**2)
         else
            qsaf = qsaf0*(1. - (1. - abs(qsafa)/qsaf0)*psi**2)
         endif
      else if (psi > 1.) then
         dpsi = tpsi(2) - tpsi(1)
!         left = ifix(psi/dpsi) + 1
         left = int(psi/dpsi) + 1
         if (left >= nprof) left = nprof - 1
         qsaf = abs(qsafa)*(zqfac(left)*zlamb(left)+(psi-tpsi(left))*(
     1      zqfac(left+1)*zlamb(left+1)-zqfac(left)*zlamb(left))/dpsi)/(
     2      zqfac(nprofs)*zlamb(nprofs))
      endif
      return
      end function qsaf

c
c  This module contains interfacing subroutines for CQL
c
c--------------------------------------------------------------
 
 
      subroutine delp(dpwre, i, j, freqcy)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:52:01   6/14/01  
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
      use Vparam
      use Vcfdamp, ONLY: ifbilin, us, thets, coss, sinn, f, fxx, fyy, 
     1   fxxyy, ftemp, ibd, wk, sint, tempx, tempy, dus, dthets, 
     2   dudthets, usp, thetsp, bes0, bes1, dbes, ifirstb, nbes, cnstb, 
     3   besdel, bmax, nint, unorm
      use Vcgraphs, ONLY: seikon, spsi, sxu, szu, skp, skpar, spower, 
     1   sdpwri, sphi, stheta, spol, sdkpar, scepx, scepy, scepz, 
     2   sztpol, sbtot, sene, salphac, salphal, sjslofa, serrors, 
     3   spkpsi, sakpsi, sakth, swkve, jjslofa, sne, ste, sqr, spw, 
     4   sxh, sqte, sni, sti, sdeqs, spwer, spwmax, srtor, srplas, 
     5   sdenc, stec, sqc, sqa, sbaxis, scurr, sfreq, satm, sazi, 
     6   sconc, stic, sxpage, sypage, slenx, sleny, sdelx, sfirtx, 
     7   sdely, sfirty, symax, symin, skth, skphi, skpsi, sxx, jslofas, 
     8   nurefls, keiks, jpes, jpis, istarts, iprmt5, jhlfs, isimpl, 
     9   isimpl0, ngr, nps, nspie, kgraph, kprof, newgra, jksym, 
     .   lintyp, nxvarb, nyvarb, kwfr
      use Vcraylh
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang, 
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec, 
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3, 
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti, 
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin, 
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril, 
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref, 
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep, 
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr, 
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite, 
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1, 
     1   gamene1, presfr, rzero
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer i, j
      real dpwre, freqcy
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: k, ier, lmhd, ir, kmax, ii
      real :: kpar, kperdom, pi, clight, clight2, x, zh, zbx01, zbx11, 
     1   bdb0, rootbdb0, dcapfdu, vpar, vpar2, fomce, deluprp, uprp, 
     2   uprp2, gammar2, gammar, upar, upar2, u2, u, arg, besj0, besj1, 
     3   uprp0, upar0, t0, ff, dfdx, dfdy, ct, st, dfdupar, delspol
      save kpar, kperdom, pi, clight, clight2, k, x, ier, lmhd, zh, 
     1   zbx01, zbx11, bdb0, rootbdb0, ir, dcapfdu, vpar, vpar2, fomce, 
     2   deluprp, kmax, uprp, uprp2, gammar2, gammar, upar, upar2, u2, u
     3   , arg, ii, besj0, besj1, uprp0, upar0, t0, ff, dfdx, dfdy, ct, 
     4   st, dfdupar, delspol
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
!      integer , EXTERNAL :: ifix
      real , EXTERNAL :: valspl
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c
c  Comfdamp
c
c
c----------------------------
c   common blocks of Cmgraphs
c
 
c    2   ,sqti(nprofm)
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.
 
 
c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c
      data pi/3.141592654/
      data clight/2.9979E10/
      data clight2/8.9874E20/
c
c     Calculate damping within a ray element specified by
c           i = ray element
c           j = ray number
c
c     If ifirst.eq.1 set up the bessel functions:
c      (also cnstb = 2*pi**2*e**2/m_e)
      if (ifirstb == 1) then
         cnstb = 4.99915E9
         nbes = nbesa
         dbes = bmax/(nbes - 1)
         do k = 1, nbes
            x = (k - 1)*dbes
            call besj (x, 0, bes0(k), besdel, ier)
            call besj (x, 1, bes1(k), besdel, ier)
         end do
         ifirstb = 0
      endif
c
c     Need B_mag/B_o-mag.  (Ref. subroutine coords and p.20 of IPP 4/210)
      psi = spsi(i)
      theta = 0.0
!      lmhd = ifix(psi/dpsimhd) + 1
      lmhd = int(psi/dpsimhd) + 1
      zh = psi - psimhd(lmhd)
      zbx01 = valspl(zh,bx0,nprofn,lmhd,0)
      zbx11 = valspl(zh,bx1,nprofn,lmhd,0)
      ux = zbx01 + zbx11
      bdb0 = (ux/ukzero + rzero)/(sxu(i)+rzero)
      rootbdb0 = sqrt(bdb0)
c
c     Radial bin identifier
      do k = 1, nprof
         ir = k
         if (psi < ppsi(k)) exit 
      end do
c
c
      dpwre = 0.0
c  The following variable is added for diagnostic purposes, and
c  is the u_parallel derivative of the reduced distn function.
      dcapfdu = 0.0
      vpar = clight/skpar(i)
      vpar2 = vpar*vpar
      kpar = 2.*pi*freqcy/vpar
      fomce = 28.E9*sbtot(i)
      kperdom = freqcy*skp(i)/(clight*fomce)
      if (kperdom*us(imaxu) > bmax - dbes) stop 20
      deluprp = us(imaxu)/(nint - 1)
      kmax = us(imaxu)/deluprp
      if (kmax < 2) return 
      uprp = -0.5*deluprp
      do k = 1, kmax
         uprp = uprp + deluprp
         uprp2 = uprp*uprp
         gammar2 = (clight2 + uprp2)/(clight2 - vpar2)
         gammar = sqrt(gammar2)
         upar = gammar*vpar
         upar2 = upar*upar
         u2 = uprp2 + upar2
         u = sqrt(u2)
         if (u > unorm) exit 
         arg = kperdom*uprp
         ii = arg/dbes + 1
         besj0=bes0(ii)+(arg-(ii-1)*dbes)*(bes0(ii+1)-bes0(ii))/dbes
         besj1=bes1(ii)+(arg-(ii-1)*dbes)*(bes1(ii+1)-bes1(ii))/dbes
c
         uprp0 = uprp/rootbdb0
         upar0 = sign(1.0_dp,upar)*sqrt(u2 - uprp0*uprp0)
         t0 = atan2(uprp0,upar0)
         call distn(nuam,ntam,u,t0,ff,dfdx,dfdy,sene(i),pne,nprof,ir)
c
c     Transform derivatives to the local poloidal angle
         dfdy = upar/upar0/rootbdb0*dfdy
         ct = upar/u
         st = uprp/u
         dfdupar = ct*dfdx - st*dfdy/u
         dpwre = dpwre + uprp/gammar*(upar*besj0*real(scepz(i))-uprp*
     1      besj1*aimag(scepy(i)))**2*dfdupar
         dcapfdu = dcapfdu + uprp*dfdupar
      end do
c
      if (i/=1 .and. i/=isimpl(j)) then
         delspol = 0.5*(spol(i+1)-spol(i-1))*1.E2
      else if (i == 1) then
         delspol = 0.5*spol(2)*1.E2
      else if (i == isimpl(j)) then
         delspol = 0.5*(spol(i)-spol(i-1))*1.E2
      endif
 
c
      dpwre = -dpwre*cnstb*delspol*spower(i)/((sztpol(i)*clight/(8.*pi))
     1   *omega*(1.-vpar2/clight2))*deluprp*sign(1.0_dp,kpar)
      dcapfdu = 2.*pi*deluprp*dcapfdu
      if (2 > 1) then
         go to 25
      else
         go to 26
      endif
   25 continue
   26 continue
      return 
      end subroutine delp
c
c
c
      subroutine distn(nu,nt,u0,thet0,ff,dfdx,dfdy,denn,den,ird,ir)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:52:01   6/14/01  
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vcfdamp
      use Vcgraphs
      use Vcraylh
      use Viorlh
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nu, nt, ird, ir
      real u0, thet0, ff, dfdx, dfdy, denn
      real, dimension(ird) :: den
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: idm, im, ii, jj
      real :: ffm, dfdxm, dfdym, ddm, ddp, ddl ! was dd
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real , EXTERNAL :: terp2p
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c
c     ird = length of density vector den
c     ir  = index of adjacent radial point exterior to the
c           location at which the distribution function is evaluated.
c           (1.le.ir.le.ird).
c
c
c Interpolate (using density) to get distribution functions
c  It is assumed that density is a
c  nonincreasing function of radius at the last two radial points.
c
      if (ifbilin == 0) then
c
         idm = nuam
c
c
         ff = (denn/den(ir))*terp2p(u0,thet0,nu,us,nt,thets,f(1,1,ir),
     1      fxx(1,1,ir),fyy(1,1,ir),fxxyy(1,1,ir),idm,0,0,1)
         dfdx = (denn/den(ir))*terp2p(u0,thet0,nu,us,nt,thets,f(1,1,ir),
     1      fxx(1,1,ir),fyy(1,1,ir),fxxyy(1,1,ir),idm,1,0,0)
         dfdy = (denn/den(ir))*terp2p(u0,thet0,nu,us,nt,thets,f(1,1,ir),
     1      fxx(1,1,ir),fyy(1,1,ir),fxxyy(1,1,ir),idm,0,1,0)
c
         if (ir==1 .or. ir==ird .and. denn<=den(ird)) return 
         im = ir - 1
 
c  No further interpolation if at a radial interpolation pt,
c  or density profile is flat:
         if (denn==den(im) .or. denn==den(ir)) return 
 
         ffm = (denn/den(im))*terp2p(u0,thet0,nu,us,nt,thets,f(1,1,im),
     1      fxx(1,1,im),fyy(1,1,im),fxxyy(1,1,im),idm,0,0,0)
         dfdxm = (denn/den(im))*terp2p(u0,thet0,nu,us,nt,thets,f(1,1,im)
     1      ,fxx(1,1,im),fyy(1,1,im),fxxyy(1,1,im),idm,1,0,0)
         dfdym = (denn/den(im))*terp2p(u0,thet0,nu,us,nt,thets,f(1,1,im)
     1      ,fxx(1,1,im),fyy(1,1,im),fxxyy(1,1,im),idm,0,1,0)
c
      else
c
         ii = u0/dus + 1
         jj = thet0/dthets + 1
         if (ii >= nuam) ii = nuam - 1
         if (jj >= ntam) jj = ntam - 1
         ff = 0.0
         call fterp2 (u0, thet0, ii, jj, usp, thetsp, dudthets, fxx(1,1,
     1      ir), fyy(1,1,ir), nuam, ntam, dfdx, dfdy)
         dfdx = denn/den(ir)*dfdx
         dfdy = denn/den(ir)*dfdy
c
         if (ir==1 .or. ir==ird .and. denn<=den(ird)) return 
         im = ir - 1
 
c  No further interpolation if at a radial interpolation pt,
c  or density profile is flat:
         if (denn==den(im) .or. denn==den(ir)) return 
 
         ffm = 0.0
         call fterp2 (u0, thet0, ii, jj, usp, thetsp, dudthets, fxx(1,1,
     1      im), fyy(1,1,im), nuam, ntam, dfdxm, dfdym)
         dfdxm = denn/den(im)*dfdxm
         dfdym = denn/den(im)*dfdym
c
      endif
c
      ddm = denn - den(im)
      ddp = den(ir) - denn
      ddl = ddm + ddp
      ff = (ffm*ddp + ff*ddm)/dd
      dfdx = (dfdxm*ddp + dfdx*ddm)/ddl
      dfdy = (dfdym*ddp + dfdy*ddm)/ddl
c
      return 
      end subroutine distn
 
      subroutine dodamp
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:52:01   6/14/01  
C...Switches: -p4 -yb
 
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vcfdamp
      use Vcgraphs, ONLY: seikon, spsi, sxu, szu, skp, skpar, spower, 
     1   sdpwri, sphi, stheta, spol, sdkpar, scepx, scepy, scepz, 
     2   sztpol, sbtot, sene, salphac, salphal, sjslofa, serrors, 
     3   spkpsi, sakpsi, sakth, swkve, jjslofa, sne, ste, sqr, spw, 
     4   sxh, sqte, sni, sti, sdeqs, spwer, spwmax, srtor, srplas, 
     5   sdenc, stec, sqc, sqa, sbaxis, scurr, sfreq, satm, sazi, 
     6   sconc, stic, sxpage, sypage, slenx, sleny, sdelx, sfirtx, 
     7   sdely, sfirty, symax, symin, skth, skphi, skpsi, sxx, jslofas, 
     8   nurefls, keiks, jpes, jpis, istarts, iprmt5, jhlfs, isimpl, 
     9   isimpl0, ngr, nps, nspie, kgraph, kprof, newgra, jksym, 
     .   lintyp, nxvarb, nyvarb, kwfr
      use Vcraylh
      use Viorlh
      use Vsizes
      use Viogrl, ONLY: calfa, px, sumpx, bk, refl, rtot, trans, 
     1   aksupw, ddk, nnk, joutrf, ireout, jumpw, jtest, ispec, ngra, 
     2   itrans, radius, freqcy
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: j, i
      real :: dpwre
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c   common blocks of Cmgraphs
c
 
c    2   ,sqti(nprofm)
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95
 
c------------ --------------
c   common blocks of Comiogrl
c---------------------------
c******************SCC  01/17/95
c        This is not working right now; we can't loop over rays
c          like that here. We need to output rays in rayop, then
c          do it ray by ray by reading in from rayop
c*********************************
c
c     Calculation of power in ray using numerical calc. of electron damping.
c
c     istarts() gives ray status:
c       -1,  ray damped completely
c        0,  ray failed to start, of stopped other than because of damping
c       +1,  integrate further along the ray
c
      do j = 1, indgr
         if (isimpl(j)>isimpl0(j) .and. istarts(j)/=0) then
            if (istarts(j) == (-1)) istarts(j) = 1
            do i = isimpl0(j), isimpl(j)
               if (istarts(j) == 1) then
                  call delp (dpwre, i, j, freqcy)
                  spower(i) = spower(i-1) - dpwre - sdpwri(i)
                  if (spower(i) <= 0.0) then
                     spower(i) = smallest        ! was 1.e-50
                     istarts(j) = -1
                  endif
               else
                  spower(i) = smallest           ! was 1.e-50
               endif
            end do
         endif
      end do
 
      return 
      end subroutine dodamp
c
c ************ ************ ************ ************ ************
c
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c
      subroutine fnmax(kspec, npar, upar, nper, uper, umax, tnmax, dsf)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:52:01   6/14/01  
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vcfdamp
      use Vcgraphs
      use Vcraylh
      use Viorlh
      use Vsizes
      use Viogrl
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer kspec, npar, nper
      real umax, tnmax
      real, dimension(1) :: upar, uper
      real, dimension(1,1) :: dsf
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, j
      real :: dpar, dper
C-----------------------------------------------
c $$$ Subroutine to calculate analytically non-Maxwellian distribution
c      for use in wave damping
c
c Input: kspec : <=0 : electrons     >0 : ions
c        npar  : number of grid points in v-parallel space
c        upar  : array of normalized v-parallel
c        nper  : number of grid points in v-perp space
c        uper  : array of normalized v-perp
c        umax  : maximum normalized u [=(upar**2+uper**2)**(1/2)]
c        tnmax : characteristic temperature (keV)
cOutput: dsf   : (npar,nper) array of distribution which integrates to
c                 unity in velocity space
c
      dpar = umax/float(npar - 1)
      dper = umax/float(nper - 1)
      do i = 1, npar
         upar(i) = dpar*float(i - 1)
         do j = 1, nper
            uper(j) = dper*float(j - 1)
            dsf(i,j) = 0.
         end do
      end do
      return 
      end subroutine fnmax
 
c
      subroutine fokker(inf, enorm, den, tem, rdf, ir0, inname, rtail, 
     1   r1t, r2t, ttail, rhot, r1h, r2h, thotpar, thotper, hotexp, 
     2   hotmnpar, hotmxpar, hotmnper, hotmxper, rbeam, r1b, r2b, tbeam
     3   , ebeam, thbeam)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:52:01   6/14/01  
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      use Vcfdamp, ONLY: ifbilin, us, thets, coss, sinn, f, fxx, fyy, 
     1   fxxyy, ftemp, ibd, wk, sint, tempx, tempy, dus, dthets, 
     2   dudthets, usp, thetsp, bes0, bes1, dbes, ifirstb, nbes, cnstb, 
     3   besdel, bmax, nint, irmax, nuam, ntam, imaxu, jmax
      use Vcgraphs
!      use Vcraylh
      use Viorlh
      use Vsizes
      use Viogrl
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer inf, ir0
      real enorm, rtail, r1t, r2t, ttail, rhot, r1h, r2h, thotpar, 
     1   thotper, hotexp, hotmnpar, hotmxpar, hotmnper, hotmxper, rbeam
     2   , r1b, r2b, tbeam, ebeam, thbeam
      character inname*10
      real, dimension(irmax) :: den, tem, rdf
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, j, ir, itail, ihot, ibeam, ilen, nu, nt, l, ll, iy, 
     1   jx, lrz, idm, irr
      real, dimension(irmax) :: dnorm
      real, dimension(5) :: dumm
      real :: pi, clight, clight2, unorm, rmu, dnormt, rmutail, gamma, 
     1   fmax, ftail, du, vvol, dnormh, rmuhpar, rmuhper, upar2, uper2, 
     2   fact, gampar, gamper, epar, eper, dnormb, rmubeam, gammab, 
     3   ubovc, uparb, uperb, upar, uper, umax, renormf, renormv

      save dnorm, dumm, pi, clight, clight2, unorm, i, j, ir, rmu, itail
     1   , dnormt, rmutail, ihot, ibeam, gamma, fmax, ftail, du, vvol, 
     2   dnormh, rmuhpar, rmuhper, upar2, uper2, fact, gampar, gamper, 
     3   epar, eper, dnormb, rmubeam, gammab, ubovc, uparb, uperb, upar
     4   , uper, ilen, nu, nt, l, ll, iy, jx, lrz, umax, renormf, 
     5   renormv, idm, irr
C-----------------------------------------------
c     optimize level a
c
c    There are two modes given by inf:
c    inf=0, Electron dirstributions are calculated from analytic functions,
c           according io input values of
c             den(1:ir0)  density (/cc)
c             tem(1:ir0)  temperature (keV)
c             rdf(1:ir0)  normalized raii (0. to 1.)
c             the tail distribution specs.
c           Output is the distribution function, spline coeffs., and
c           arrays in Comfdamp_3
c    inf=1, Distributions read in from file inname.
c           Output is the distribution function, spline coeffs. and arrays in
c           Comfdamp_3, plot enorm, den, tem, rdf, ir0,
c           plus ion density specs. (ion specs later).
 
c
c    Output distributions are in cgs.
c
c
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c
c  Comiorlh_1
c
c     character*1 line(132)
c
c
      pi = 3.141592654
      clight = 2.9979E10
      clight2 = clight*clight
c
      if (inf /= 1) then
c
c set up distribution functions
c
         unorm = clight*sqrt((1. + enorm/511.)**2 - 1.)
         do i = 1, imaxu
            us(i) = float(i - 1)*unorm/float(imaxu - 1)
         end do
         do j = 1, jmax
            thets(j) = pi*(j - 1.0)/(jmax - 1.0)
            coss(j) = cos(thets(j))
            sinn(j) = sin(thets(j))
         end do
c
c
c
         do ir = 1, ir0
            dnorm(ir) = 0.0
            rmu = 511./tem(ir)
            if (rdf(ir)>=r1t .and. rdf(ir)<=r2t .and. rtail/=0.) then
               itail = 1
               dnormt = 0.0
               rmutail = 511./ttail
            else
               itail = 0
               dnormt = 1.0
            endif
            if (rdf(ir)>=r1h .and. rdf(ir)<=r2h .and. rhot/=0.0) then
               ihot = 1
            else
               ihot = 0
            endif
            if (rdf(ir)>=r1b .and. rdf(ir)<=r2b .and. rbeam/=0.0) then
               ibeam = 1
            else
               ibeam = 0
            endif
            do i = 1, imaxu
               gamma = sqrt(1.0 + us(i)*us(i)/clight2)
               fmax = exp((-rmu*(gamma - 1.0)))
               if (itail /= 0) ftail = exp((-rmutail*(gamma - 1.)))
               du = 0.0
               if (i == 1) du = (0.5*(us(2)+us(1)))**3/3.
               if (i>1 .and. i<imaxu) du = 0.5*(us(i+1)-us(i-1))
               vvol = 4.0*pi*us(i)*us(i)*du
               dnorm(ir) = dnorm(ir) + vvol*fmax
               f(i,:jmax,ir) = fmax
               if (itail /= 0) then
                  dnormt = dnormt + vvol*ftail
                  ftemp(i,:jmax) = ftail
               endif
            end do
c
            f(:imaxu,:jmax,ir) = den(ir)*((1. - (itail*rtail) - ihot*
     1         rhot - ibeam*rbeam)*f(:imaxu,:jmax,ir)/dnorm(ir)+(itail*
     2         rtail)*ftemp(:imaxu,:jmax)/dnormt)
            j = jmax + 1
c
c     Add in hot component
            if (ihot == 1) then
               dnormh = 0.0
               rmuhpar = 511./thotpar
               rmuhper = 511./thotper
               do i = 1, imaxu
                  du = 0.0
                  if (i == 1) du = (0.5*(us(2)+us(1)))**3/3.
                  if (i>1 .and. i<imaxu) du = 0.5*(us(i+1)-us(i-1))
                  do j = 1, jmax
                     upar2 = 0.5*(coss(j)*us(i))**2/clight2
                     uper2 = 0.5*(sinn(j)*us(i))**2/clight2
                     if (hotexp == 0.) then
                        fact = 1.0
                     else
                        fact = uper2**(hotexp/2.)
                     endif
                     ftemp(i,j) = fact*exp((-rmuhpar*upar2) - rmuhper*
     1                  uper2)
                     gampar = sqrt(1. + 2.*upar2)
                     gamper = sqrt(1. + 2.*uper2)
                     epar = (gampar - 1.)*511.
                     eper = (gamper - 1.)*511.
                     if(epar<hotmnpar.or.epar>hotmxpar)ftemp(i,j)=0.0
                     if(eper<hotmnper.or.eper>hotmxper)ftemp(i,j)=0.0
                  end do
                  dnormh = dnormh + sum(2.*pi*us(i)**2*du*0.5*(ftemp(i,:
     1               jmax-1)+ftemp(i,2:jmax))*sin(0.5*(thets(:jmax-1)+
     2               thets(2:jmax)))*(thets(2:jmax)-thets(:jmax-1)))
               end do
               f(:imaxu,:jmax,ir) = f(:imaxu,:jmax,ir) + rhot*den(ir)*
     1            ftemp(:imaxu,:jmax)/dnormh
               j = jmax + 1
            endif
c
c
c     Add in beam component
            if (ibeam == 1) then
               dnormb = 0.0
               rmubeam = 511./tbeam
               gammab = ebeam/511. + 1.
               ubovc = sqrt(gammab**2 - 1.)
               uparb = ubovc*cos(thbeam*pi/180.)
               uperb = ubovc*sin(thbeam*pi/180.)
               do i = 1, imaxu
                  du = 0.0
                  if (i == 1) du = (0.5*(us(2)+us(1)))**3/3.
                  if (i>1 .and. i<imaxu) du = 0.5*(us(i+1)-us(i-1))
                  do j = 1, jmax
                     upar = coss(j)*us(i)/clight
                     uper = sinn(j)*us(i)/clight
                     ftemp(i,j) = exp((-0.5*rmubeam*((upar - uparb)**2
     1                   + (uper - uperb)**2)))
                  end do
                  dnormb = dnormb + sum(2.0*pi*us(i)**2*du*0.5*(ftemp(i,
     1               :jmax-1)+ftemp(i,2:jmax))*sin(0.5*(thets(:jmax-1)+
     2               thets(2:jmax)))*(thets(2:jmax)-thets(:jmax-1)))
               end do
               f(:imaxu,:jmax,ir) = f(:imaxu,:jmax,ir) + rbeam*den(ir)*
     1            ftemp(:imaxu,:jmax)/dnormb
               j = jmax + 1
            endif
c
         end do
c
c
      else
c     Here we read ir0 distn fctns from inname
c
         ilen = 0
c**bh iout1=fopen("feulh4","read")
c     Skip past c3d namelist data.
c  400 call rdline(10,line,clen)
c      if(line(1).eq. "*" .and. line(2) .eq. "*" .and.
c     1  line(3) .eq. "_" .and. line(4) .eq. "e" .and.
c     1  line(5) .eq. "_" .and. line(6) .eq. "z" .and.
c     1  line(7) .eq. "d" .and. line(8) .eq. "a" .and.
c     1  line(9) .eq. "t" .and. line(10).eq. "a") go to 500
c      if(clen .lt. 0)  go to 500
c      go to 400
c  500 continue
         nu = imaxu
         nt = jmax
  100    format(5e16.8)
  101    format(5i16)
         do l = 1, ir0
            read (iout1, 101) ll, iy, jx, lrz
            if (iy/=nt .or. jx/=nu .or. ir0/=lrz) stop 10
            read (iout1, 100) (thets(j),j=1,nt)
            read (iout1, 100) (us(i),i=1,nu)
            read (iout1, 100) dumm
            rdf(l) = dumm(1)
            unorm = dumm(2)
            den(l) = dumm(5)
            read (iout1, 100) dumm
            tem(l) = dumm(1)
            if (l == 1) then
c     umax = unorm (from cql3d)  /sqrt(2. * Te0 / me)
               umax = dumm(3)
               renormf = 1./unorm**3
               renormv = unorm
            endif
            read (iout1, 100) ((fxx(j,i,l),i=1,nt),j=1,nu)
            i = 1
            if (nu > 0) then
               j = 1
               if (nt > 0) then
                  f(:nu,:nt,l) = fxx(:nu,:nt,l)*renormf
                  j = nt + 1
               endif
               i = nu + 1
            endif
         end do
         us(:nu) = renormv*us(:nu)
c**bh call fclose(iout1)
      endif
c
c  Set up to do interpolation of dist functn:
c
      if (ifbilin == 0) then
c
c
c now set up the splines used to interpolate for the distn
c function in the calculation of emissivity and absorptivity
c
         idm = nuam
         ibd(1) = 4
         ibd(2) = 4
         ibd(3) = 2
         ibd(4) = 2
         do irr = 1, ir0
            fyy(:imaxu,1,irr) = 0.0
            fyy(:imaxu,ntam,irr) = 0.0
            i = imaxu + 1
            call coeff2 (nuam, us, ntam, thets, f(1,1,irr), fxx(1,1,irr)
     1         , fyy(1,1,irr), fxxyy(1,1,irr), idm, ibd, wk)
         end do
c
      else
c
c
c  Set up for bilinear interpolation:
c
c  Loop over radial mesh
         do irr = 1, ir0
            call fterp1 (f(1,1,irr), fxx(1,1,irr), fyy(1,1,irr), nuam, 
     1         ntam, us, thets, tempx, tempy)
         end do
c
         dus = (us(nuam)-us(1))/(nuam - 1)
         dthets = (thets(ntam)-thets(1))/(ntam - 1)
         dudthets = dus*dthets
         do i = 1, nuam
            usp(i) = (i - 1)*dus
         end do
         do j = 1, ntam
            thetsp(j) = (j - 1)*dthets
         end do
c
      endif
c
      return 
      end subroutine fokker

      SUBROUTINE XERMSG (LIBRAR, SUBROU, MESSG, NERR, LEVEL) 
C***BEGIN PROLOGUE  XERMSG
C***PURPOSE  Process error messages for SLATEC and other libraries.
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3C
C***TYPE      ALL (XERMSG-A)
C***KEYWORDS  ERROR MESSAGE, XERROR
C***AUTHOR  Fong, Kirby, (NMFECC at LLNL)
C***DESCRIPTION
C
C   XERMSG processes a diagnostic message in a manner determined by the
C   value of LEVEL and the current value of the library error control
C   flag, KONTRL.  See subroutine XSETF for details.
C
C    LIBRAR   A character constant (or character variable) with the name
C             of the library.  This will be 'SLATEC' for the SLATEC
C             Common Math Library.  The error handling package is
C             general enough to be used by many libraries
C             simultaneously, so it is desirable for the routine that
C             detects and reports an error to identify the library name
C             as well as the routine name.
C
C    SUBROU   A character constant (or character variable) with the name
C             of the routine that detected the error.  Usually it is the
C             name of the routine that is calling XERMSG.  There are
C             some instances where a user callable library routine calls
C             lower level subsidiary routines where the error is
C             detected.  In such cases it may be more informative to
C             supply the name of the routine the user called rather than
C             the name of the subsidiary routine that detected the
C             error.
C
C    MESSG    A character constant (or character variable) with the text
C             of the error or warning message.  In the example below,
C             the message is a character constant that contains a
C             generic message.
C
C                   CALL XERMSG ('SLATEC', 'MMPY',
C                  *'THE ORDER OF THE MATRIX EXCEEDS THE ROW DIMENSION',
C                  *3, 1)
C
C             It is possible (and is sometimes desirable) to generate a
C             specific message--e.g., one that contains actual numeric
C             values.  Specific numeric values can be converted into
C             character strings using formatted WRITE statements into
C             character variables.  This is called standard Fortran
C             internal file I/O and is exemplified in the first three
C             lines of the following example.  You can also catenate
C             substrings of characters to construct the error message.
C             Here is an example showing the use of both writing to
C             an internal file and catenating character strings.
C
C                   CHARACTER*5 CHARN, CHARL
C                   WRITE (CHARN,10) N
C                   WRITE (CHARL,10) LDA
C                10 FORMAT(I5)
C                   CALL XERMSG ('SLATEC', 'MMPY', 'THE ORDER'//CHARN//
C                  *   ' OF THE MATRIX EXCEEDS ITS ROW DIMENSION OF'//
C                  *   CHARL, 3, 1)
C
C             There are two subtleties worth mentioning.  One is that
C             the // for character catenation is used to construct the
C             error message so that no single character constant is
C             continued to the next line.  This avoids confusion as to
C             whether there are trailing blanks at the end of the line.
C             The second is that by catenating the parts of the message
C             as an actual argument rather than encoding the entire
C             message into one large character variable, we avoid
C             having to know how long the message will be in order to
C             declare an adequate length for that large character
C             variable.  XERMSG calls XERPRN to print the message using
C             multiple lines if necessary.  If the message is very long,
C             XERPRN will break it into pieces of 72 characters (as
C             requested by XERMSG) for printing on multiple lines.
C             Also, XERMSG asks XERPRN to prefix each line with ' *  '
C             so that the total line length could be 76 characters.
C             Note also that XERPRN scans the error message backwards
C             to ignore trailing blanks.  Another feature is that
C             the substring '$$' is treated as a new line sentinel
C             by XERPRN.  If you want to construct a multiline
C             message without having to count out multiples of 72
C             characters, just use '$$' as a separator.  '$$'
C             obviously must occur within 72 characters of the
C             start of each line to have its intended effect since
C             XERPRN is asked to wrap around at 72 characters in
C             addition to looking for '$$'.
C
C    NERR     An integer value that is chosen by the library routine's
C             author.  It must be in the range -99 to 999 (three
C             printable digits).  Each distinct error should have its
C             own error number.  These error numbers should be described
C             in the machine readable documentation for the routine.
C             The error numbers need be unique only within each routine,
C             so it is reasonable for each routine to start enumerating
C             errors from 1 and proceeding to the next integer.
C
C    LEVEL    An integer value in the range 0 to 2 that indicates the
C             level (severity) of the error.  Their meanings are
C
C            -1  A warning message.  This is used if it is not clear
C                that there really is an error, but the user's attention
C                may be needed.  An attempt is made to only print this
C                message once.
C
C             0  A warning message.  This is used if it is not clear
C                that there really is an error, but the user's attention
C                may be needed.
C
C             1  A recoverable error.  This is used even if the error is
C                so serious that the routine cannot return any useful
C                answer.  If the user has told the error package to
C                return after recoverable errors, then XERMSG will
C                return to the Library routine which can then return to
C                the user's routine.  The user may also permit the error
C                package to terminate the program upon encountering a
C                recoverable error.
C
C             2  A fatal error.  XERMSG will not return to its caller
C                after it receives a fatal error.  This level should
C                hardly ever be used; it is much better to allow the
C                user a chance to recover.  An example of one of the few
C                cases in which it is permissible to declare a level 2
C                error is a reverse communication Library routine that
C                is likely to be called repeatedly until it integrates
C                across some interval.  If there is a serious error in
C                the input such that another step cannot be taken and
C                the Library routine is called again without the input
C                error having been corrected by the caller, the Library
C                routine will probably be called forever with improper
C                input.  In this case, it is reasonable to declare the
C                error to be fatal.
C
C    Each of the arguments to XERMSG is input; none will be modified by
C    XERMSG.  A routine may make multiple calls to XERMSG with warning
C    level messages; however, after a call to XERMSG with a recoverable
C    error, the routine should return to the user.  Do not try to call
C    XERMSG with a second recoverable error after the first recoverable
C    error because the error package saves the error number.  The user
C    can retrieve this error number by calling another entry point in
C    the error handling package and then clear the error number when
C    recovering from the error.  Calling XERMSG in succession causes the
C    old error number to be overwritten by the latest error number.
C    This is considered harmless for error numbers associated with
C    warning messages but must not be done for error numbers of serious
C    errors.  After a call to XERMSG with a recoverable error, the user
C    must be given a chance to call NUMXER or XERCLR to retrieve or
C    clear the error number.
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  FDUMP, J4SAVE, XERCNT, XERHLT, XERPRN, XERSVE
C***REVISION HISTORY  (YYMMDD)
C   880101  DATE WRITTEN
C   880621  REVISED AS DIRECTED AT SLATEC CML MEETING OF FEBRUARY 1988.
C           THERE ARE TWO BASIC CHANGES.
C           1.  A NEW ROUTINE, XERPRN, IS USED INSTEAD OF XERPRT TO
C               PRINT MESSAGES.  THIS ROUTINE WILL BREAK LONG MESSAGES
C               INTO PIECES FOR PRINTING ON MULTIPLE LINES.  '$$' IS
C               ACCEPTED AS A NEW LINE SENTINEL.  A PREFIX CAN BE
C               ADDED TO EACH LINE TO BE PRINTED.  XERMSG USES EITHER
C               ' ***' OR ' *  ' AND LONG MESSAGES ARE BROKEN EVERY
C               72 CHARACTERS (AT MOST) SO THAT THE MAXIMUM LINE
C               LENGTH OUTPUT CAN NOW BE AS GREAT AS 76.
C           2.  THE TEXT OF ALL MESSAGES IS NOW IN UPPER CASE SINCE THE
C               FORTRAN STANDARD DOCUMENT DOES NOT ADMIT THE EXISTENCE
C               OF LOWER CASE.
C   880708  REVISED AFTER THE SLATEC CML MEETING OF JUNE 29 AND 30.
C           THE PRINCIPAL CHANGES ARE
C           1.  CLARIFY COMMENTS IN THE PROLOGUES
C           2.  RENAME XRPRNT TO XERPRN
C           3.  REWORK HANDLING OF '$$' IN XERPRN TO HANDLE BLANK LINES
C               SIMILAR TO THE WAY FORMAT STATEMENTS HANDLE THE /
C               CHARACTER FOR NEW RECORDS.
C   890706  REVISED WITH THE HELP OF FRED FRITSCH AND REG CLEMENS TO
C           CLEAN UP THE CODING.
C   890721  REVISED TO USE NEW FEATURE IN XERPRN TO COUNT CHARACTERS IN
C           PREFIX.
C   891013  REVISED TO CORRECT COMMENTS.
C   891214  Prologue converted to Version 4.0 format.  (WRB)
C   900510  Changed test on NERR to be -9999999 < NERR < 99999999, but
C           NERR .ne. 0, and on LEVEL to be -2 < LEVEL < 3.  Added
C           LEVEL=-1 logic, changed calls to XERSAV to XERSVE, and
C           XERCTL to XERCNT.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  XERMSG
C============
C idecl:  explicitize implicit INTEGER declarations:
      use kind_spec

      use kind_spec

      IMPLICIT NONE
      INTEGER level,nerr,lkntrl,j4save,maxmes,kdummy,i,kount,lerr,
     > llevel,mkntrl,ltemp
C============
      CHARACTER(len = *):: LIBRAR, SUBROU, MESSG
      CHARACTER*8 XLIBR, XSUBR
      CHARACTER*72  TEMP
      CHARACTER*20  LFIRST
C***FIRST EXECUTABLE STATEMENT  XERMSG
      print *, librar,subrou, messg
      end

c $$$$$  Added by TK Mau on 11/20/91
      subroutine anread
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:56:19   6/14/01
C...Switches: -p4 -yb
c
c     This routine, called from BR_GO when IGRILL=-2, reads in calculated
c     antenna n_par power spectra.
c     Number of spectra = isimm
c     Number of n_par components = nnkpar(i), i=1,isimm; specified in BR_GO
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang,
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec,
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3,
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti,
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin,
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril,
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref,
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep,
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr,
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite,
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1,
     1   epserr, epser1, epspfw, epspsw, epsray, rzero, rplasm,
     2   bzero, btsign, tcurr, fbsc, rshift, dtrian, qsaf0, qsafa,
     3   gamene1, presfr, iout1, polasp
      use Viogrl, ONLY: calfa, px, sumpx, bk, refl, rtot, trans,
     1   aksupw, ddk, nnk, joutrf, ireout, jumpw, jtest, ispec, ngra,
     2   itrans, radius, freqcy, isimm, heigth
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: j, i
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c------------ --------------
c   common blocks of Comiogrl
c---------------------------
c
      read (iout1, 1003) isimm, islofa, freqcy, heigth
      do j = 1, isimm
         read (iout1, 1001) nnkpar(j)
         read (iout1, 1002) (anzin(j,i),i=1,nnkpar(j))
         read (iout1, 1002) (pwcpl(j,i),i=1,nnkpar(j))
      end do
 1002 format(5e16.9)
 1001 format(i4)
 1003 format(2i4,2e16.9)
      return
      end subroutine anread
      subroutine outrun(ientry)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:56:19   6/14/01
C...Switches: -p4 -yb
c
c ************ ************ ************ ************ ************
c
c  output of the run parameters
c   Normal output
c
c ************ ************ ************ ************ ************
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang,
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec,
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3,
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti,
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin,
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril,
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref,
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep,
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr,
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite,
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1,
     1   gamene1, presfr, rzero, bzero, rplasm, tcurr, denlav, fbsc,
     2   aiseed, fdia, powrq, iout, iout1, iout2, nharm
      use Viogrl, ONLY: calfa, px, sumpx, bk, refl, rtot, trans,
     1   aksupw, ddk, nnk, joutrf, ireout, jumpw, jtest, ispec, ngra,
     2   itrans, radius, freqcy, isimm, heigth
      use Vcraylh
      use Vcmnew, ONLY: wpi1c, wpi2c, wci1c, wci2c, wpi2, wci2, wci,
     1   conci, aziomi, rtzom, ay2, ay1, trate, tratte, ttle, concte,
     2   trati, tratti, ttli, concti, vdrfte, vdrfti, infi, gprm, cxet,
     3   czt, cztp, czetai, czi, czip, czetat, czti, cztip, cth, npar,
     4   nper, upar, uper, umax, dsfe, dsfi, fper2, fpar2, fpp2, intg,
     5   inc, incf, tnmaxe, tnmaxi, idrive, binb, boutb, boutbrd,
     6   binbrd, epsl, binbd, epsil, dlob, wte, eta0, eta, rprof,
     7   amprof, cprof, xjop, vloop, kboot, mboot, btbsp, ftbsps, pde,
     8   pdec, pdi, pdf, pwce, pwcm, pwcf, pwc, pwc1, pwc2, pwct,
     9   pwct1, pwct2, pwc0, pwcray, pwc1ray, pwc2ray, pweray, pwiray,
     .   pwfray, currf, currfe, currf1, currf2, curay, curay1, curay2,
     1   fpwray, fpowe, fpowf, fpowi, pwte0, pwti0, effcd, effcdt,
     2   ptot, ftpowe, ftpowi, ftpowf, ftpi, ftpf, ftedge, pwedge,
     3   wfrac, pwxwl, frpowi, frpowf, frpow, pwit, pwft, ptedge,
     4   ptot0, fpowt, tpowi, tpowf, wfrac0, ebkev, bmpwr, azf, atmf,
     5   densa, kalfa, nalfa, nharm0, pnfi, pnf, zetab, tnf, ecrit,
     6   taua0, wca, gamal, gamat, ibeam, abeam, dbeam, aneb, enbeam,
     7   wbeam, temsa, ptfi, ttf, wpf2c, wpf2, wcf2c, wcf1c, wcf2, wcf,
     8   cxc, czc, cy, denfa, eav, tausd, tau0, paf, sordt, ecrita,
     9   betaf
      use Vcgraphs, ONLY: seikon, spsi, sxu, szu, skp, skpar, spower,
     1   sdpwri, sphi, stheta, spol, sdkpar, scepx, scepy, scepz,
     2   sztpol, sbtot, sene, salphac, salphal, sjslofa, serrors,
     3   spkpsi, sakpsi, sakth, swkve, jjslofa, sne, ste, sqr, spw,
     4   sxh, sqte, sni, sti, sdeqs, spwer, spwmax, srtor, srplas,
     5   sdenc, stec, sqc, sqa, sbaxis, scurr, sfreq, satm, sazi,
     6   sconc, stic, sxpage, sypage, slenx, sleny, sdelx, sfirtx,
     7   sdely, sfirty, symax, symin, skth, skphi, skpsi, sxx, jslofas,
     8   nurefls, keiks, jpes, jpis, istarts, iprmt5, jhlfs, isimpl,
     9   isimpl0, ngr, nps, nspie, kgraph, kprof, newgra, jksym,
     .   lintyp, nxvarb, nyvarb, kwfr
      use Vchpcsd, ONLY: irec, rec0, rec1, rec2, rec3, rec4, rec5,
     1   rec6, rec7, rec8, rec9, rec10, rec11, rec12, rec13, rec14,
     2   rec15
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer ientry
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: j, l, i, k, n, iy, ip, is, nuk, jprt, ir
      real(kind=dp) :: zpi, zconc, zfremh, wlengt, zpwin, zpwyes,
     1    zpwab, zpwnab
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c------------ --------------
c   common blocks of Comiogrl
c---------------------------
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95

c
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1


c******      TKM   03/97, 09/99, 04/00, 06/00
c********************

c
c $$$$$ Added by TK Mau on 11/19/91
c----------------------------
c   common blocks of Cmgraphs
c

c    2   ,sqti(nprofm)
c
c   Comhpcsd
c
c $$$$$$$$$$$$$$$$$$$$$$$$
c ************ ************ ************ ************ ************
c
      data zpi/3.14159265359/
c
c ************ ************ ************ ************ ************
c
c     go to (100,200), ientry
c $$$$$  Altered by TK Mau on 11/19/91
      select case (ientry)
c
c ************ ************ ************ ************ ************
c
      case default
         write (iout, 1500)
         write (iout, 1510) rzero, raxmag, rplasm, xmin, xmax, bzero,
     1      baxis, tcurr, pqr(nprof,1), pqr(1,1)
c      write(iout,1520)  denc,tempec
c$$$$$     TKM   2/00
         write (iout, 1520) denc, denlav, tempec, pavtne, pavtte, pavtti
     1      , pavpp, betap, beta, betaf, ali3, zeff
c$$$$$$$$$$$$
         do j = 1, nspec
            zconc = azi(j)*tconc(1,1,j)
            tempic(j) = tti(1,1,j)
            write (iout, 1530) j, atm(j), azi(j), zconc, tempic(j)
         end do
         zfremh = 1.E-9*freqcy
         wlengt = 2.*zpi/ukzero
         write (iout, 1540) zfremh, wlengt
         if (islofa <= 0) then
            write (iout, 1610)
 1610       format('0',24x,"fast wave coupled")
         else
            write (iout, 1620)
 1620       format('0',24x,"slow wave coupled")
c ************ ************ ************ ************ ************
c 140 if(iprint.le.1)  return
c $$$$$$  Altered by TK Mau on 11/19/91
         endif
         write (iout, 1550)
         do l = 1, nprof
            write (iout, 1560) tpsi(l), tqr(l,1), pqr(l,1), pne(l), pte(
     1         l), pti(l,1)
         end do
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c
c ************ ************ ************ ************ ************
c
 1500    format('0',"========plasmas parameters=======,"//)
 1510    format('0',9x,"major radius =",f8.3," m",/10x,
     1      "radius of the magnetic axis =",f8.3," m",/10x,
     2      "minor radius =",f8.3," m",/10x,"inner plasma edge at x =",
     3      f8.3," m",/10x,"outer plasma edge at x =",f8.3," m",/10x,
     4      "toroidal magnetic field on the centre =",f7.2," tesla",/10x
     5      ,"toroidal magnetic field on the axis =",f7.2," tesla",/10x,
     6      "toroidal current =",1pe12.3," MA"/,10x,
     7      "safety factor at the edge =",0pf6.2/10x,
     8      "safety factor at centre =",f6.2/)
 1520    format('0',4x,"central density =",1pe13.3," cm-3",/,5x,
     1      "line-ave. density =",1pe13.3," cm-3",/,5x,
     2      "central electron temperature =",0pf8.3," kev",/,5x,
     3      "density peaking factor =",f8.3,/,5x,
     4      "volume temperature peaking factor =",f8.3,/,5x,
     5      "density-weighted temp. peaking factor =",f8.3,/,5x,
     6      "pressure peaking factor =",f8.3,/,5x,"poloidal beta =",f8.4
     7      ,/,5x,"total beta =",f8.4,/,5x,"fast ion beta =",f8.4,/,5x,
     8      "plasma internal inductance =",f8.3,/,5x,
     9      "Effective charge =",f8.3)
 1530    format(' ',24x,"species ",i2,5x,"a =",f5.1,5x,"z =",f5.1,5x,
     1      "z*n(j)/n(e) =",f9.3,5x,"ti(0) =",f10.3," kev")
 1540    format('0',24x,"applied frequency =",f12.3," ghz",/25x,
     1      "wavelength =",f12.3," m")
c $$$$$$$  Altered by TK Mau on 11/19/91
 1550    format('0',2/,20x,"density and temperature profiles",2/,4x,
     1      "psi",9x,"bp/bt",9x,"q",11x,"ne",11x,"Te",11x,"Ti",/)
 1560    format(6(1x,e12.5))
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c ****   1570 format(1h ,5x,"psi =",e15.4,2x,"ni  =",e15.4,2x,"ti  =",
c ****       +   e15.4,2x,"ni  =",e15.4,2x,"ti  =",e15.4)
c ****   1580 format(1h ,5x,"psi =",e15.4,2x,"ni  =",e15.4,2x,"ti  =",
c ****       +   e15.4)
c ****   1590 format(1h0)
c
c ************ ************ ************ ************ ************
c
         return
c
c ************ ************ ************ ************ ************
c
      case (2)
c
c ************ ************ ************ ************ ************
c
c   print-out of the power deposition profiles
c
c ************ ************ ************ ************ ************
c
         zpwin = 0.
         zpwabs = pwtote
         zpwabs = zpwabs + sum(pwtoti(:nspec))
         zpwabs = zpwabs + sum(pwtotf(:nalfa))
c--------------Deleted 7/29/95  SCC
c     if((zpwabs/power).lt.1.e-6)   return
c
c  Peak electron and ion species densities and temperatures:
c
         write (iout, 2511) nspec, pne(1), (pni(1,k),k=1,nspec), pte(1)
     1      , (pti(1,k),k=1,nspec)
 2511    format("nspec=",i5,/,"den(0)=",4(2x,e16.4),/,"tem(0)=",4(2x,
     1      e16.4))
c
c  psi power deposition profiles
c
         write (iout, 2510)
         do n = 1, nprof
            write (iout, 2520) tpsi(n), pwe(n), (pwi(n,i),i=1,nspec), (
     1         pwal(n,j),j=1,nalfa)
         end do
c
c $$$$$$ Added by T.K. Mau on 10/17/91.
c
c     Output for ray tracing after RAYLH is modified.
c
         write (iout, 2521)
         do iy = 1, indgr
            write (iout, 2522) iy, fpwray(iy), fpowe(iy), frpowi(iy),
     1         frpowf(iy), curay(iy), effcd(iy)
         end do
         write (iout, 2523)
         do ip = 1, nprof
            write (iout, 2524) tpsi(ip), pwe(ip), pwit(ip), pwft(ip),
     1         pwct(ip)                          !,ajtrt(ip)
         end do
         write (iout, 2525) fpowt, ptot0, ftpowe, ftpi, ftpf, ftedge,
     1      currfe, currf1, currf2, currf, effcdt
c ---- Added by TK Mau on 10/28/91.
         write (iout, 2526) tcurr, fbsc, fdia, aiseed, powrq
c ----    TKM   09/99
         write (iout, 2529)
 2529    format("Total toroidal seed current at radial grids (MA)")
         write (iout, 2528) (aisdt(i),i=1,nprof)
c     write(iout,2527)
c2527 format("Bootstrap current, <J.B>_bs (A*T*m-2)")
c     write(iout,2528) (ajbsb(i),i=1,nprof)
 2528    format(5(e12.6,2x))
c
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c
c  spectral distribution
c
         write (iout, 2530)
         zpwyes = 0.
         do is = 1, isimm
            write (iout, 2500)
            nuk = nnkpar(is)
            do n = 1, nuk
               zpwyes = zpwyes + pwcpl(is,n)
               zpwab = pwcpl(is,n) - pwtra(is,n)
               if (zpwab<0. .and. abs(zpwab)<1.E-9) zpwab = 0.
               write (iout, 2540) anzin(is,n), pwcpl(is,n), zpwab, pwtra
     1            (is,n)
            end do
         end do
         zpwnab = zpwyes - zpwabs
c
c  global balance
c
         write (iout, 2550) power, zpwyes, zpwnab, zpwabs
         write (iout, 2560) pwtote
         write (iout, 2570) (i,pwtoti(i),i=1,nspec)
         write (iout, 2571) (k,pwtotf(k),k=1,nalfa)
c
c ************ ************ ************ ************ ************
c
 2510    format('0',20x,"power deposition profiles",2/,3x,"rho",6x,
     1      "electrons",8x,"ions",6x,"fast ions",/)
 2520    format(' ',f8.4,5(2x,e10.3))
c$$$$$$$$$$$$$$$$$$$$$$$$
c $$$$$$$$$$  Added by T.K. Mau on 10/17/91.
c
 2521    format('0',15x,"SUMMARY OF RAY TRACING RESULTS",2/,3x,"ray",5x,
     1      "P_ab/P_0",5x,"P_e/P_0",5x,"P_i/P_0",5x,"P_f/P_0",5x,
     2      "I_e(MA)",3x,"I/P(A/W)",/)
 2522    format(3x,i3,6(2x,e10.3))
 2523    format(//,'0',20x,"OVERALL RESULTS",2/,'0',30x,
     1      "Power Deposition & Current Profiles",2/,2x,"rho",2x,
     2      "P_e (W/cm**3)",2x,"P_i (W/cm**3)",2x,"P_f (W/cm**3)",2x,
     3      "j_rf (A/cm**2)",2x,"j_tar (A/cm**2)",/)
c2524 format(1x,f5.3,5(2x,e10.3))
 2524    format(1x,f5.3,4(2x,e10.3))
 2525    format(//,2x,"Fraction of power absorbed =",e10.3,/,2x,
     1      "Total incident power (MW) =",e10.3,/,2x,
     2      "Fraction of power to electrons =",e10.3,/,2x,
     3      "Fraction of power to ions      =",e10.3,/,2x,
     4      "Fraction of power to fast ions =",e10.3,/,2x,
     5      "Fraction of power to edge      =",e10.3,/,2x,
     6      "Driven electron current (MA)   =",e10.3,/,2x,
     7      "Driven minority current (MA)   =",e10.3,/,2x,
     8      "Driven fast ion current (MA)   =",e10.3,/,2x,
     9      "Total driven RF current (MA)   =",e10.3,/,2x,
     .      "Total current-drive efficiency (A/W) =",e10.3)
c ---- Added by TK Mau on 10/28/91.
 2526    format(//,2x,"Total plasma current (MA)    =",e13.3,/,2x,
     1      "Bootstrap current fraction   =",e13.3,/,2x,
     2      "Diamagnetic current fraction =",e13.3,/,2x,
     3      "Seed currents (MA)",/,2x,5(e10.4,2x),/,2x,5(e10.4,2x),/,2x,
     4      "Current drive power (MW)     =",e13.3)
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
 2530    format('0',2/,40x,"spectre of the non-absorbed power",/)
 2500    format('0')
 2540    format(' ',5x,"n par =",1pe13.3,5x,"coup. power  =",e13.3,5x,
     1      "absorbed =",e13.3,5x,"non absorbed =",e13.3,5x,"mw")
 2550    format('0',/40x,"total power balance",/,21x,
     1      "launched power          =",1pe13.3," MW",/21x,
     2      "within n par. range     =",e13.3," MW",/21x,
     3      "non-absorbed            =",e13.3," MW",/21x,
     4      "absorbed by the plasma   ",e13.3," MW")
 2560    format(' ',20x,"total power to the electrons =",e14.4," MW.")
 2570    format(' ',20x,"            to species",i6," =",e14.4," MW.")
 2571    format(' ',20x,"       to fast species",i6," =",e14.4," MW")
c
c ************ ************ ************ ************ ************
c
         return
c $$$$$ Added by TK Mau on 11/19/91
c
      case (3)
         jprt = iabs(iprint)
         write (iout, 2580) indgr, jprt
c     do 240 ir = 1,isimpl(indgr),jprt
         do ir = 1, irec, jprt
            write (iout, 2581) rec13(ir), rec4(ir), rec5(ir), rec14(ir)
     1         , rec12(ir), rec7(ir), rec8(ir)
c     write(iout,2581) sene(ir),skpar(ir),skp(ir),swkve(ir),sbtot(ir),
c    &                 salphac(ir),salphal(ir)
         end do
 2580    format("*** Condensed info on ray ",i3," every ",i3,
     1      " time-steps",2/,3x,"dene",6x,"N_par",6x,"Nper2",6x," Te ",
     2      6x,"w/wci",6x,"game",6x,"gami",/)
 2581    format(2(1x,f9.5),1x,e12.4,2(1x,f9.5),2(1x,e10.3))
         return
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c**************SCC  5/3/95
c
      case (4)
         write (iout, 2590)
 2590    format(//
     1      'The following sums up contribution of all FW sources:'//)
         write (iout, 2510)
         do n = 1, nprof
            write (iout, 2520) tpsi(n), pwe(n), (pwi(n,i),i=1,nspec)
         end do
         write (iout, 2523)
         do ip = 1, nprof
            write (iout, 2524) tpsi(ip), pwe(ip), pwit(ip), pwc(ip)
         end do
         write(iout,2525)fpowt,ptot0,ftpowe,ftpi,ftedge,currf,effcdt
         write (iout, 2526) tcurr, fbsc
         return
      end select
      end subroutine outrun
c
      subroutine rayinout(inout)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:56:19   6/14/01
C...Switches: -p4 -yb
c
c ************ ************ ************ ************ ************
c
c Inputs or outputs ray data using file rayop.
c   inout = 1, input data
c           2, output data.
c  from R.Harvey for interface with CQL
c
c ************ ************ ************ ************ ************
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang,
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec,
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3,
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti,
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin,
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril,
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref,
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep,
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr,
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite,
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1,
     1   gamene1, presfr, iout2, nharm, tcurr, fbsc
      use Viogrl, ONLY: calfa, px, sumpx, bk, refl, rtot, trans,
     1   aksupw, ddk, nnk, joutrf, ireout, jumpw, jtest, ispec, ngra,
     2   itrans, radius, freqcy, heigth
      use Vcraylh
      use Vcmnew, ONLY: wpi1c, wpi2c, wci1c, wci2c, wpi2, wci2, wci,
     1   conci, aziomi, rtzom, ay2, ay1, trate, tratte, ttle, concte,
     2   trati, tratti, ttli, concti, vdrfte, vdrfti, infi, gprm, cxet,
     3   czt, cztp, czetai, czi, czip, czetat, czti, cztip, cth, npar,
     4   nper, upar, uper, umax, dsfe, dsfi, fper2, fpar2, fpp2, intg,
     5   inc, incf, tnmaxe, tnmaxi, idrive, binb, boutb, boutbrd,
     6   binbrd, epsl, binbd, epsil, dlob, wte, eta0, eta, rprof,
     7   amprof, cprof, xjop, vloop, kboot, mboot, btbsp, ftbsps, pde,
     8   pdec, pdi, pdf, pwce, pwcm, pwcf, pwc, pwc1, pwc2, pwct,
     9   pwct1, pwct2, pwc0, pwcray, pwc1ray, pwc2ray, pweray, pwiray,
     .   pwfray, currf, currfe, currf1, currf2, curay, curay1, curay2,
     1   fpwray, fpowe, fpowf, fpowi, pwte0, pwti0, effcd, effcdt,
     2   ptot, ftpowe, ftpowi, ftpowf, ftpi, ftpf, ftedge, pwedge,
     3   wfrac, pwxwl, frpowi, frpowf, frpow, pwit, pwft, ptedge,
     4   ptot0, fpowt, tpowi, tpowf, wfrac0, ebkev, bmpwr, azf, atmf,
     5   densa, kalfa, nalfa, nharm0, pnfi, pnf, zetab, tnf, ecrit,
     6   taua0, wca, gamal, gamat, ibeam, abeam, dbeam, aneb, enbeam,
     7   wbeam, temsa, ptfi, ttf, wpf2c, wpf2, wcf2c, wcf1c, wcf2, wcf,
     8   cxc, czc, cy, denfa, eav, tausd, tau0, paf, sordt, ecrita,
     9   betaf, nminor
      use Vcgraphs, ONLY: seikon, spsi, sxu, szu, skp, skpar, spower,
     1   sdpwri, sphi, stheta, spol, sdkpar, scepx, scepy, scepz,
     2   sztpol, sbtot, sene, salphac, salphal, sjslofa, serrors,
     3   spkpsi, sakpsi, sakth, swkve, jjslofa, sne, ste, sqr, spw,
     4   sxh, sqte, sni, sti, sdeqs, spwer, spwmax, srtor, srplas,
     5   sdenc, stec, sqc, sqa, sbaxis, scurr, sfreq, satm, sazi,
     6   sconc, stic, sxpage, sypage, slenx, sleny, sdelx, sfirtx,
     7   sdely, sfirty, symax, symin, skth, skphi, skpsi, sxx, jslofas,
     8   nurefls, keiks, jpes, jpis, istarts, iprmt5, jhlfs, isimpl,
     9   isimpl0, ngr, nps, nspie, kgraph, kprof, newgra, jksym,
     .   lintyp, nxvarb, nyvarb, kwfr
      use Vchpcsd, ONLY: irec, rec0, rec1, rec2, rec3, rec4, rec5,
     1   rec6, rec7, rec8, rec9, rec10, rec11, rec12, rec13, rec14,
     2   rec15
      use Vceqdsk, ONLY: ntitle, dat, ipestg, nxeqd, nzeqd, xdimeqd,
     1   zdimeqd, reqd, redeqd, zmideqd, xma, zma, psimag, psilim,
     2   beqd, toteqd, psimx1, psimx2, xax1, xax2, zax1, zax2, psisep,
     3   xsep, zsep, feqd, presseqd, ffpeqd, ppeqd, peqd, qeqd, xeqd,
     4   zeqd, psiadj, dpolflx, psieqd, tpsieqd, tpsifeqd, iounit1,
     5   inoperm1, nptsdm1, nptsd, torflux, tpsisav, ra, psifra,
     6   dpsifra, fra, fra1, cspln, pds, wnoperm, xcontr, zcontr,
     7   bpcontr, btcontr, dstarp, b_fld, jacob, pprime, vprime,
     8   chipsi, ncontr, dang, bperr, arcl, thet, anglex, csplnx,
     9   csplnz, pdsx, pdsz, nlim, rlim, zlim, nlimiter, rlimiter,
     .   zlimiter, lrz, nprim, nimp, nion, nti, zi, zeffz, r, raeqd,
     1   psifeqd, te, ti, ti1, ene, enp, bmod, rmd, btmd, bpmd, btpmd,
     2   roa
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer inout
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: j, i, k, m, m1
      real(kind=dp), dimension(npdim) :: scratch
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i

c------------ --------------
c   common blocks of Comiogrl
c---------------------------
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c
c   Comhpcsd
c
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95

c
c----------------------------
c   common blocks of Cmgraphs
c

c    2   ,sqti(nprofm)
c
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1


c******      TKM   03/97, 09/99, 04/00, 06/00
c********************

c
c ************ ************ ************ ************ ************
c
c
      select case (inout)
c
c Open rayop using Basis sub.  This will destroy an existing rayop file.
c**bh iout2=fopen("rayop","write")
c
c     Write header lines
c
c
c
c     Write out ray data:
c
c $$$$$$$$$  Added by T.K. Mau on 10/10/91.
      case default
 1001    format(2i5,1pe16.9,i5)
c $$$$$$$$$$$$$$$$$$$$$
 1002    format(5(1pe16.9))
 1003    format(9i6)
c
c $$$$$$$$$$  Modified by T.K. Mau, 10/10/91.
         if (irayio /= 0) then
            write (iout2, 1001) indgr, nharm, freqcy
         else
            write (iout2, 1001) indgr, nharm, freqcy, nprof
c       write(iout2,1003)  nminor,kalfa,nalfa
            write (iout2, 1001) nminor, kalfa, raxmag, nalfa
            write (iout2, 1003) kboot, ncontr(nprof)
         endif
         return
c $$$$$$$$$$$$$$
c
      case (2)
c
         j = indgr
         write (iout2, 1003) isimpl(j), jslofas(j), nurefls(j), keiks(j)
     1      , jpes(j), jpis(j), istarts(j), iprmt5(j), jhlfs(j)
         write (iout2, 1002) sxx(j), skpsi(j), skth(j), skphi(j)
         scratch(:isimpl(j)) = 1.E2*spol(:isimpl(j))
         write (iout2, 1002) (scratch(i),i=1,isimpl(j))
         write (iout2, 1002) (seikon(i),i=1,isimpl(j))
         write (iout2, 1002) (spsi(i),i=1,isimpl(j))
         scratch(:isimpl(j)) = 1.E2*(raxmag + sxu(:isimpl(j)))
         write (iout2, 1002) (scratch(i),i=1,isimpl(j))
         scratch(:isimpl(j)) = 2.*3.141592654*sphi(:isimpl(j))
         write (iout2, 1002) (scratch(i),i=1,isimpl(j))
         scratch(:isimpl(j)) = 1.E2*szu(:isimpl(j))
         write (iout2, 1002) (scratch(i),i=1,isimpl(j))
         write (iout2, 1002) (skpar(i),i=1,isimpl(j))
         write (iout2, 1002) (skp(i),i=1,isimpl(j))
         scratch(:isimpl(j)) = 1.E13*spower(:isimpl(j))
         write (iout2, 1002) (scratch(i),i=1,isimpl(j))
         scratch(:isimpl(j)) = 1.E13*sdpwri(:isimpl(j))
         write (iout2, 1002) (scratch(i),i=1,isimpl(j))
c     do 1051 i = 1,isimpl(j)
c1051 scratch(i) = 1.e13*sdpwrf(i,j)
c     write(iout2,1002)  (scratch(i),i=1,isimpl(j))
         write (iout2, 1002) (sdkpar(i),i=1,isimpl(j))
         write (iout2, 1002) (scepx(i),i=1,isimpl(j))
         write (iout2, 1002) (scepy(i),i=1,isimpl(j))
         write (iout2, 1002) (scepz(i),i=1,isimpl(j))
         write (iout2, 1002) (sztpol(i),i=1,isimpl(j))
         scratch(:isimpl(j)) = 1.E4*sbtot(:isimpl(j))
         write (iout2, 1002) (scratch(i),i=1,isimpl(j))
c $$$$  TK Mau   10/3/94
c     do 107  i=1,isimpl(j)
c107  scratch(i)=1.e4*sbout(i,j)
c     write(iout2,1002)  (scratch(i),i=1,isimpl(j))
c     write(iout2,1002)  (srpsi(i,j),i=1,isimpl(j))
         if (irayio == 0) write (iout2, 1002) (swkve(i),i=1,isimpl(j))
         write (iout2, 1002) (sene(i),i=1,isimpl(j))
         write (iout2, 1002) (salphac(i),i=1,isimpl(j))
         write (iout2, 1002) (salphal(i),i=1,isimpl(j))
c     write(iout2,1002)  (spoyntn(i,j),i=1,isimpl(j))
         if (irayio == 0) then
c $$$$$$$  Added by T.K. Mau on 10/10/91.
            write (iout2, 1002) (pweray(i,indgr),i=1,nprof)
            write (iout2, 1002) (pwcray(i,indgr),i=1,nprof)
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$
         endif
         return
c
c
      case (3)
         if (irayio == 0) then
c $$$$$$$$$ Added by T.K. Mau on 10/10/91.
            write (iout2, 1002) (ppsi(i),i=1,nprof)
            write (iout2, 1002) (psinm(i),i=1,nprof)
            write (iout2, 1002) (volume(i),i=1,nprof)
            write (iout2, 1002) (pwe(i),i=1,nprof)
            write (iout2, 1003) nspec
c******************SCC  4/13,95
            do k = 1, nspec
               write (iout2, 1002) (pwi(i,k),i=1,nprof)
               write (iout2, 1002) (pwiv(i,k),i=1,nprof)
            end do
            if (kalfa > 0) then
               do k = 1, nalfa
                  write (iout2, 1002) (pwal(i,k),i=1,nprof)
               end do
            endif
            write (iout2, 1002) (pwev(i),i=1,nprof)
c*****************************
            write (iout2, 1002) (pwit(i),i=1,nprof)
            write (iout2, 1002) (pwft(i),i=1,nprof)
            write (iout2, 1002) (pwc(i),i=1,nprof)
            write (iout2, 1002) (pwct(i),i=1,nprof)
            if (nminor > 0) write (iout2, 1002) (pwct1(i),i=1,nprof)
            if (kalfa > 0) write (iout2, 1002) (pwct2(i),i=1,nprof)
c ----- Added by TK Mau on 10/25/91
            if (kboot /= 0) then
c     write(iout2,1002) (pni(i,1),i=1,nprof)
c     write(iout2,1002) (pni(i,nspec),i=1,nprof)
c     write(iout2,1002) (pti(i,1),i=1,nprof)
c     write(iout2,1002) (pti(i,nspec),i=1,nprof)
c     write(iout2,1002) (tani(i),i=1,nprof)
               write (iout2, 1002) (ajtb(i),i=1,nprof)
               write (iout2, 1002) (ajbsb(i),i=1,nprof)
               write (iout2, 1002) (ajbst(i),i=1,nprof)
               write (iout2, 1002) (ajtrb(i),i=1,nprof)
               write (iout2, 1002) (ftrp(i),i=1,nprof)
               write (iout2, 1002) (ajtar(i),i=1,nprof)
               write (iout2, 1002) (ajdit(i),i=1,nprof)
               write (iout2, 1002) (ajtor(i),i=1,nprof)
            endif
            write (iout2, 1002) (pne(i),i=1,nprof)
            write (iout2, 1002) (pte(i),i=1,nprof)
c*****************SCC  5/3/95
            write (iout2, 1002) fpowt, ptot0, ftpowe, ftpi, ftedge,
     1         currf, effcdt, tcurr, fbsc
c $$$$$$$$$$$$$$$$$$$$$$
c $$$$$    TK Mau   12/6/94
            write (iout2, 1002) (rmd(i),i=1,2*nprof - 1)
            write (iout2, 1002) (btmd(i),i=1,2*nprof - 1)
            write (iout2, 1002) (bpmd(i),i=1,2*nprof - 1)
c     endif
c $$$$    TK Mau    7/95
c     if(irayio.eq.0.and.kalfa.gt.0) then
            if (kalfa > 0) then
               write (iout2, 1002) (paf(i),i=1,nprof)
               write (iout2, 1002) (ppra(i,1),i=1,nprof)
               write (iout2, 1002) (denfa(i),i=1,nprof)
               write (iout2, 1002) (eav(i),i=1,nprof)
               write (iout2, 1002) (ecrita(i),i=1,nprof)
            endif
c
c $$$$$$    TK Mau   10/27/98
c Read information about plasma shape
            write (iout2, 1002) (xcontr(i,nprof),i=1,ncontr(nprof))
            write (iout2, 1002) (zcontr(i,nprof),i=1,ncontr(nprof))
            write (iout2, 1002) xeqd(1), xeqd(nxeqd), zeqd(1), zeqd(
     1         nzeqd)
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c $$$$$$    TK Mau   1/3/00
c  Mod(B) in (R,Z) space for cyclotron resonance surface plot
            write (iout2, 1003) nxeqd, nzeqd
            write (iout2, 1002) ((bmod(i,j),i=1,nxeqd),j=1,nzeqd)
            do m = 1, 5
               m1 = int((nprof - 1)*float(m - 1)/float(m)) + 1
               if (m1 == 1) m1 = m1 + 1
               write (iout2, 1003) ncontr(m1)
               write (iout2, 1002) (xcontr(i,m1),i=1,ncontr(m1))
               write (iout2, 1002) (zcontr(i,m1),i=1,ncontr(m1))
            end do
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c
         endif
c
         return
c
c
c     Read data from file rayop
      case (4)
c**bh iout2=fopen("rayop","read")
c
c     Skip over header
c**bh read(iout2,1000)
c     Read and restore data
c $$$$$$$$  Modified by T.K. Mau on 10/10/91.
         if (irayio /= 0) then
            read (iout2, 1001) indgr, nharm, freqcy
         else
            read (iout2, 1001) indgr, nharm, freqcy, nprof
            read (iout2, 1003) nminor, kalfa, nalfa
c       read(iout2,1001)  nminor,kalfa,raxmag,nalfa
         endif
         return
c $$$$$$$$$$$$$$$$$$$$$
      case (5)
c
         j = nrayno
         read (iout2, 1003) isimpl(j), jslofas(j), nurefls(j), keiks(j)
     1      , jpes(j), jpis(j), istarts(j), iprmt5(j), jhlfs(j)
         read (iout2, 1002) sxx(j), skpsi(j), skth(j), skphi(j)
         read (iout2, 1002) (scratch(i),i=1,isimpl(j))
         spol(:isimpl(j)) = 1.E-2*scratch(:isimpl(j))
         read (iout2, 1002) (seikon(i),i=1,isimpl(j))
         read (iout2, 1002) (spsi(i),i=1,isimpl(j))
         read (iout2, 1002) (scratch(i),i=1,isimpl(j))
         sxu(:isimpl(j)) = 1.E-2*scratch(:isimpl(j)) - raxmag
         read (iout2, 1002) (scratch(i),i=1,isimpl(j))
         sphi(:isimpl(j)) = scratch(:isimpl(j))/(2.*3.141592654)
         read (iout2, 1002) (scratch(i),i=1,isimpl(j))
         szu(:isimpl(j)) = 1.E-2*scratch(:isimpl(j))
         read (iout2, 1002) (skpar(i),i=1,isimpl(j))
         read (iout2, 1002) (skp(i),i=1,isimpl(j))
         read (iout2, 1002) (scratch(i),i=1,isimpl(j))
         spower(:isimpl(j)) = 1.E-13*scratch(:isimpl(j))
         read (iout2, 1002) (scratch(i),i=1,isimpl(j))
         sdpwri(:isimpl(j)) = 1.E-13*scratch(:isimpl(j))
c     read(iout2,1002)  (scratch(i),i=1,isimpl(j))
c     do 2051  i=1,isimpl(j)
c2051 sdpwrf(i,j) = 1.e-13*scratch(i)
         read (iout2, 1002) (sdkpar(i),i=1,isimpl(j))
         read (iout2, 1002) (scepx(i),i=1,isimpl(j))
         read (iout2, 1002) (scepy(i),i=1,isimpl(j))
         read (iout2, 1002) (scepz(i),i=1,isimpl(j))
         read (iout2, 1002) (sztpol(i),i=1,isimpl(j))
         read (iout2, 1002) (scratch(i),i=1,isimpl(j))
         sbtot(:isimpl(j)) = 1.E-4*scratch(:isimpl(j))
c     read(iout2,1002)  (scratch(i),i=1,isimpl(j))
c $$$$  TK Mau   10/3/94
c     do 207  i=1,isimpl(j)
c207  sbout(i,j)=1.e-4*scratch(i)
c     read(iout2,1002) (srpsi(i,j),i=1,isimpl(j))
         read (iout2, 1002) (swkve(i),i=1,isimpl(j))
         read (iout2, 1002) (sene(i),i=1,isimpl(j))
         read (iout2, 1002) (salphac(i),i=1,isimpl(j))
         read (iout2, 1002) (salphal(i),i=1,isimpl(j))
c     read(iout2,1002)  (spoyntn(i,j),i=1,isimpl(j))
         if (irayio == 0) then
c $$$$$$$$$$  Added by T.K. Mau on 10/10/91.
            read (iout2, 1002) (pweray(i,j),i=1,nprof)
            read (iout2, 1002) (pwcray(i,j),i=1,nprof)
c $$$$$$$$$$$$$$$$$$$$$
         endif
         return
c**bh call fclose(iout2)
c
      case (6)
         if (irayio == 0) then
c $$$$$$$$$$ Added by T.K. Mau on 10/10/91.
            read (iout2, 1002) (ppsi(i),i=1,nprof)
            read (iout2, 1002) (psinm(i),i=1,nprof)
            read (iout2, 1002) (volume(i),i=1,nprof)
            read (iout2, 1002) (pwe(i),i=1,nprof)
            read (iout2, 1003) nspec
c******************SCC  4/13,95
            do k = 1, nspec
               read (iout2, 1002) (pwi(i,k),i=1,nprof)
               read (iout2, 1002) (pwiv(i,k),i=1,nprof)
            end do
            if (kalfa > 0) then
               do k = 1, nalfa
                  read (iout2, 1002) (pwal(i,k),i=1,nprof)
               end do
            endif
            read (iout2, 1002) (pwev(i),i=1,nprof)
c*****************************
            read (iout2, 1002) (pwit(i),i=1,nprof)
            read (iout2, 1002) (pwft(i),i=1,nprof)
            read (iout2, 1002) (pwc(i),i=1,nprof)
            read (iout2, 1002) (pwct(i),i=1,nprof)
            if (nminor > 0) read (iout2, 1002) (pwct1(i),i=1,nprof)
            if (kalfa > 0) read (iout2, 1002) (pwct2(i),i=1,nprof)
c ----- Added by TK Mau on 10/25/91
            if (kboot /= 0) then
               read (iout2, 1002) (ajtb(i),i=1,nprof)
               read (iout2, 1002) (ajbsb(i),i=1,nprof)
               read (iout2, 1002) (ajbst(i),i=1,nprof)
               read (iout2, 1002) (ajtrb(i),i=1,nprof)
               read (iout2, 1002) (ftrp(i),i=1,nprof)
               read (iout2, 1002) (ajtar(i),i=1,nprof)
               read (iout2, 1002) (ajdit(i),i=1,nprof)
               read (iout2, 1002) (ajtor(i),i=1,nprof)
            endif
            read (iout2, 1002) (pne(i),i=1,nprof)
            read (iout2, 1002) (pte(i),i=1,nprof)
c******************SCC  5/3/95
            read (iout2, 1002) fpowt, ptot0, ftpowe, ftpi, ftedge, currf
     1         , effcdt, tcurr, fbsc
            read (iout2, 1002) (rmd(i),i=1,2*nprof - 1)
            read (iout2, 1002) (btmd(i),i=1,2*nprof - 1)
            read (iout2, 1002) (bpmd(i),i=1,2*nprof - 1)
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
         endif
c $$$$    TK Mau    7/95
         if (irayio==0 .and. kalfa>0) then
            read (iout2, 1002) (paf(i),i=1,nprof)
            read (iout2, 1002) (ppra(i,1),i=1,nprof)
            read (iout2, 1002) (denfa(i),i=1,nprof)
            read (iout2, 1002) (eav(i),i=1,nprof)
            read (iout2, 1002) (ecrita(i),i=1,nprof)
         endif
c
         return
      end select
      end subroutine rayinout
      subroutine rtinout(inout)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:56:19   6/14/01
C...Switches: -p4 -yb
c
c ************ ************ ************ ************ ************
c
c Inputs or outputs data for coupling to ONETWO transport code.
c (But may be useful for stand alone operation).
c   inout = 1, input data
c           2, output data.
c         3,  read spectrum from spectrm.dat
c
c ************ ************ ************ ************ ************
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang,
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec,
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3,
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti,
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin,
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril,
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref,
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep,
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr,
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite,
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1,
     1   gamene1, presfr, iout1, iout2, nharm, tcurr, fbsc, rzero,
     2   rplasm,  bzero, qsaf0, qsafa, polasp
      use Viogrl, ONLY: calfa, px, sumpx, bk, refl, rtot, trans,
     1   aksupw, ddk, nnk, joutrf, ireout, jumpw, jtest, ispec, ngra,
     2   itrans, radius, freqcy, isimm, heigth
      use Vcraylh
      use Vcmnew, ONLY: wpi1c, wpi2c, wci1c, wci2c, wpi2, wci2, wci,
     1   conci, aziomi, rtzom, ay2, ay1, trate, tratte, ttle, concte,
     2   trati, tratti, ttli, concti, vdrfte, vdrfti, infi, gprm, cxet,
     3   czt, cztp, czetai, czi, czip, czetat, czti, cztip, cth, npar,
     4   nper, upar, uper, umax, dsfe, dsfi, fper2, fpar2, fpp2, intg,
     5   inc, incf, tnmaxe, tnmaxi, idrive, binb, boutb, boutbrd,
     6   binbrd, epsl, binbd, epsil, dlob, wte, eta0, eta, rprof,
     7   amprof, cprof, xjop, vloop, kboot, mboot, btbsp, ftbsps, pde,
     8   pdec, pdi, pdf, pwce, pwcm, pwcf, pwc, pwc1, pwc2, pwct,
     9   pwct1, pwct2, pwc0, pwcray, pwc1ray, pwc2ray, pweray, pwiray,
     .   pwfray, currf, currfe, currf1, currf2, curay, curay1, curay2,
     1   fpwray, fpowe, fpowf, fpowi, pwte0, pwti0, effcd, effcdt,
     2   ptot, ftpowe, ftpowi, ftpowf, ftpi, ftpf, ftedge, pwedge,
     3   wfrac, pwxwl, frpowi, frpowf, frpow, pwit, pwft, ptedge,
     4   ptot0, fpowt, tpowi, tpowf, wfrac0, ebkev, bmpwr, azf, atmf,
     5   densa, kalfa, nalfa, nharm0, pnfi, pnf, zetab, tnf, ecrit,
     6   taua0, wca, gamal, gamat, ibeam, abeam, dbeam, aneb, enbeam,
     7   wbeam, temsa, ptfi, ttf, wpf2c, wpf2, wcf2c, wcf1c, wcf2, wcf,
     8   cxc, czc, cy, denfa, eav, tausd, tau0, paf, sordt, ecrita,
     9   betaf
      use Vcgraphs, ONLY: seikon, spsi, sxu, szu, skp, skpar, spower,
     1   sdpwri, sphi, stheta, spol, sdkpar, scepx, scepy, scepz,
     2   sztpol, sbtot, sene, salphac, salphal, sjslofa, serrors,
     3   spkpsi, sakpsi, sakth, swkve, jjslofa, sne, ste, sqr, spw,
     4   sxh, sqte, sni, sti, sdeqs, spwer, spwmax, srtor, srplas,
     5   sdenc, stec, sqc, sqa, sbaxis, scurr, sfreq, satm, sazi,
     6   sconc, stic, sxpage, sypage, slenx, sleny, sdelx, sfirtx,
     7   sdely, sfirty, symax, symin, skth, skphi, skpsi, sxx, jslofas,
     8   nurefls, keiks, jpes, jpis, istarts, iprmt5, jhlfs, isimpl,
     9   isimpl0, ngr, nps, nspie, kgraph, kprof, newgra, jksym,
     .   lintyp, nxvarb, nyvarb, kwfr, nraypts
      use Vchpcsd, ONLY: irec, rec0, rec1, rec2, rec3, rec4, rec5,
     1   rec6, rec7, rec8, rec9, rec10, rec11, rec12, rec13, rec14,
     2   rec15
      use Vceqdsk, ONLY: ntitle, dat, ipestg, nxeqd, nzeqd, xdimeqd,
     1   zdimeqd, reqd, redeqd, zmideqd, xma, zma, psimag, psilim,
     2   beqd, toteqd, psimx1, psimx2, xax1, xax2, zax1, zax2, psisep,
     3   xsep, zsep, feqd, presseqd, ffpeqd, ppeqd, peqd, qeqd, xeqd,
     4   zeqd, psiadj, dpolflx, psieqd, tpsieqd, tpsifeqd, iounit1,
     5   inoperm1, nptsdm1, nptsd, torflux, tpsisav, ra, psifra,
     6   dpsifra, fra, fra1, cspln, pds, wnoperm, xcontr, zcontr,
     7   bpcontr, btcontr, dstarp, b_fld, jacob, pprime, vprime,
     8   chipsi, ncontr, dang, bperr, arcl, thet, anglex, csplnx,
     9   csplnz, pdsx, pdsz, nlim, rlim, zlim, nlimiter, rlimiter,
     .   zlimiter, lrz, nprim, nimp, nion, nti, zi, zeffz, r, raeqd,
     1   psifeqd, te, ti, ti1, ene, enp, bmod, rmd, btmd, bpmd, btpmd,
     2   roa, codeid, ieqdsk, lrza
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer inout
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: nrt, j, i, k, n, l
      real(kind=dp) :: kappa, dra, zdecay
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c------------ --------------
c   common blocks of Comiogrl
c---------------------------
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c
c   Comhpcsd
c
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95

c
c----------------------------
c   common blocks of Cmgraphs
c

c    2   ,sqti(nprofm)
c
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i

c
c $$$$$$$$$  Added b y T.K. Mau on 10/10/91.
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1


c******      TKM   03/97, 09/99, 04/00, 06/00
c********************

c $$$$$$$$$$$$$$$$$$$$$$$$
c
c ************ ************ ************ ************ ************
c
c
      select case (inout)


c  Read wave input data pertaining to ray initial conditions,
c  and plasma equilibria (relevant for analytic equilibria):
      case default
         read (iout1, 1000) freqcy, nraypts, nrt, codeid
         read (iout1, 1001) (powers(j),j=1,nrt)
         read (iout1, 1003) (nnkpar(j),j=1,nrt)
         read (iout1, 1001) (anzinf(j),j=1,nrt)
         read (iout1, 1001) (anzsup(j),j=1,nrt)
         read (iout1, 1003) (nnkpol(j),j=1,nrt)
         read (iout1, 1001) (anpinf(j),j=1,nrt)
         read (iout1, 1001) (anpsup(j),j=1,nrt)
         read (iout1, 1002) nthin, maxref, islofa, heigth, thgril(1),
     1      tcurr, bzero
         read (iout1, 1001) rzero, rplasm, kappa, qsaf0, qsafa
c ********  Added by SCC on 11/1/91
         read (iout1, 1003) nprofs, itrans
         nprof = nprofs
         read (iout1, 1001) (radius(j),j=1,nprofs)
c **************************
 1000    format(1pe16.9,2i5,a8)
 1001    format(5(1pe16.9))
 1002    format(3i5,4(1pe16.9))
 1003    format(10i5)

         if (nrt > nspectm) nrt = isimm

c  Change units for some variables
         bzero = bzero/1.E4
         rzero = rzero/1.E2
         rplasm = rplasm/1.E2
         polasp(1) = kappa
         polasp(2) = kappa
c-----   TKM   05/00
         igrill = -1
         if (nnkpol(1) > 0) igrill = -3
c-------------
c
c  Use Brambilla analytic equibrium if codeid='onedee', else use
c  extended eqdsk.
         if (codeid == '  onedee') then
            ieqdsk = 0
         else
            ieqdsk = 4
         endif


c*************************************************************************
c     Continue reading if ieqdsk.eq.0, i.e., the eqdsk extension
c    has been written onto raytracing input file.
c*************************************************************************


         if (ieqdsk == 0) then
            read (iout1, 8210) nlim, nlimiter
c    if (nlim.ne.0) then
            read (iout1, 8200) (rlim(i),zlim(i),i=1,nlim)
            read (iout1, 8200) (rlimiter(i),zlimiter(i),i=1,nlimiter)
c     endif
c..................................................................
c     The following output is not part of the "official" eqdsk.
c..................................................................

            nti = 1
            read (iout1, 8210) lrz, nprim, nimp, nti
            if (lrz > lrza) stop 60
            nion = nprim + nimp
            read (iout1, 8200) (atm(k),k=1,nion)
            do k = 1, nion
               read (iout1, 8200) (zi(j,k),j=1,lrz)
            end do
            read (iout1, 8200) (zeffz(j),j=1,lrz)
            read (iout1, 8200) (r(j),j=1,lrz)
            read (iout1, 8200) (psifeqd(j),j=1,lrz)
            read (iout1, 8200) (te(j),j=1,lrz)
            do k = 1, nti
               read (iout1, 8200) (ti(j,k),j=1,lrz)
            end do
            read (iout1, 8200) (ene(j),j=1,lrz)
            do k = 1, nion
               read (iout1, 8200) (enp(j,k),j=1,lrz)
            end do

 8210       format(5i5)
 8200       format(5e16.9)


c     Put these variables into the ray tracing code format:
            nspec = nion
C
C*************************************  SCC   12/12/95
            azi(:nion) = zi(1,:nion)

            raeqd(:lrz) = r(:lrz)/r(lrz)
            ene(:lrz) = 1.E-6*ene(:lrz)
            enp(:lrz,:nion) = 1.E-6*enp(:lrz,:nion)

C
C
c--------SCC 8/18/94
            dra = 1./(nprofs - 1.)
            do j = 1, nprofs
               ra(j) = (j - 1.)*dra
            end do
c-----------------------

c     Initialize ne, te, ti profiles from plasma center to edge.

C
            call intrpp ('zero', 'free', raeqd, ene, lrz, ra, pne,
     1         nprofs)
            call intrpp ('zero', 'free', raeqd, te, lrz, ra, pte, nprofs
     1         )
c-------------------SCC  4/23/96
            call intrpp ('zero', 'free', raeqd, zeffz(1), lrz, ra, tzeff
     1         (1,1), nprofs)
c---------------------------
            do k = 1, nion
               call intrpp ('zero', 'free', raeqd, ti(1,k), lrz, ra, pti
     1            (1,k), nprofs)
               call intrpp ('zero', 'free', raeqd, enp(1,k), lrz, ra,
     1            pni(1,k), nprofs)
            end do
            do k = 1, nion
               conc(:nprofs,k) = pni(:nprofs,k)/pne(:nprofs)
            end do

c     Extend beyond plasma surface if iedge=1:
            if (iedge == 1) then
               do j = nprofs + 1, nprof
                  zdecay = exp((-float(j - nprofs)/2.))
                  pne(j) = pne(nprofs)*zdecay
                  pte(j) = pte(nprofs)*zdecay
                  pni(j,:nion) = pni(j,:nion)*zdecay
                  pti(j,:nion) = pti(j,:nion)*zdecay
                  conc(j,:nion) = pni(j,:nion)/pne(j)
               end do
            endif
C*****************************************************
C
C


         endif
         return



c   Non-circular case.
c   Write heating and current drive data produced by ray tracing code.

      case (2)
         write (iout1, 3000) nprofs, nspec
c ******  Altered by SCC on 11/1/91
c****  changed back to original by SCC  2/19/92
c------------------------- SCC  change to ra  2/20/92
c     write(iout1,3010) (ppsi(j),j=1,nprofs)
         write (iout1, 3010) (ra(j),j=1,nprofs)
         write (iout1, 3010) (pwe(j),j=1,nprofs)
         do n = 1, nspec
            write (iout1, 3010) (pwi(j,n),j=1,nprofs)
         end do
c *******************************************
         pwc(:nprofs) = -pwc(:nprofs)
         write (iout1, 3010) (pwc(j),j=1,nprofs)
 3000    format(2i5)
 3010    format(5(1pe19.6))

         return
c
c
      case (3)
         read (iout1, 2001) nspect
 2001    format(1x,i5)
         read (iout1, 2002) (nnkpar(j),j=1,nspect)
 2002    format(2x,4(1x,i4))
         do k = 1, nspect
            read (iout1, 2003) (anzin(k,l),l=1,nnkpar(k))
         end do
         do k = 1, nspect
            read (iout1, 2003) (pwcpl(k,l),l=1,nnkpar(k))
         end do
 2003    format(5(1x,e14.5))

         return
      end select
      end subroutine rtinout

c
      subroutine outgra(ientry)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:56:19   6/14/01
C...Switches: -p4 -yb
c
c ************ ************ ************ ************ ************
c
c interface for the output of graphs
c
c ************ ************ ************ ************ ************
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh, ONLY: nprofn, psimhd, dpsimhd, rmaj, rrho, triang,
     1   elong, nmhd, denc, tempec, atm, azi, conc, tempic, nspec,
     2   mainsp, pavtne, pavtte, pavtti, pavpp, beta, betap, ali3,
     3   ppsi, pjavg, pne, pte, nprofs, nprof, iedge, ipropt, pni, pti,
     4   psinm, tani, nspect, omega, anzin, anzsup, anzinf, anplin,
     5   anpsup, anpinf, pwcpl, pwtra, specfac, power, powers, thgril,
     6   delthe, phase, rgrill, nnkpar, nnkpol, poldk, nthin, maxref,
     7   igrill, islofa, irayio, ioread, nraypic, deykpr, psistep,
     8   pkexpnt, nequip, iprint, indvar, iploxy, igraph, iplopr, jwfr,
     9   pwe, pwe0, pwi, pwii0, pwev, pwiv, wkarea, pwal, ffast, tite,
     .   alpene1, alpte1, frcte, frcne, frcti, gamte1, gamti1, alpti1,
     1   gamene1, presfr, tcurr, rzero, rplasm
      use Viogrl, ONLY: calfa, px, sumpx, bk, refl, rtot, trans,
     1   aksupw, ddk, nnk, joutrf, ireout, jumpw, jtest, ispec, ngra,
     2   itrans, radius, freqcy
      use Vcraylh
      use Vcmnew, ONLY: wpi1c, wpi2c, wci1c, wci2c, wpi2, wci2, wci,
     1   conci, aziomi, rtzom, ay2, ay1, trate, tratte, ttle, concte,
     2   trati, tratti, ttli, concti, vdrfte, vdrfti, infi, gprm, cxet,
     3   czt, cztp, czetai, czi, czip, czetat, czti, cztip, cth, npar,
     4   nper, upar, uper, umax, dsfe, dsfi, fper2, fpar2, fpp2, intg,
     5   inc, incf, tnmaxe, tnmaxi, idrive, binb, boutb, boutbrd,
     6   binbrd, epsl, binbd, epsil, dlob, wte, eta0, eta, rprof,
     7   amprof, cprof, xjop, vloop, kboot, mboot, btbsp, ftbsps, pde,
     8   pdec, pdi, pdf, pwce, pwcm, pwcf, pwc, pwc1, pwc2, pwct,
     9   pwct1, pwct2, pwc0, pwcray, pwc1ray, pwc2ray, pweray, pwiray,
     .   pwfray, currf, currfe, currf1, currf2, curay, curay1, curay2,
     1   fpwray, fpowe, fpowf, fpowi, pwte0, pwti0, effcd, effcdt,
     2   ptot, ftpowe, ftpowi, ftpowf, ftpi, ftpf, ftedge, pwedge,
     3   wfrac, pwxwl, frpowi, frpowf, frpow, pwit, pwft, ptedge,
     4   ptot0, fpowt, tpowi, tpowf, wfrac0, ebkev, bmpwr, azf, atmf,
     5   densa, kalfa, nalfa, nharm0, pnfi, pnf, zetab, tnf, ecrit,
     6   taua0, wca, gamal, gamat, ibeam, abeam, dbeam, aneb, enbeam,
     7   wbeam, temsa, ptfi, ttf, wpf2c, wpf2, wcf2c, wcf1c, wcf2, wcf,
     8   cxc, czc, cy, denfa, eav, tausd, tau0, paf, sordt, ecrita,
     9   betaf
      use Vcgraphs, ONLY: seikon, spsi, sxu, szu, skp, skpar, spower,
     1   sdpwri, sphi, stheta, spol, sdkpar, scepx, scepy, scepz,
     2   sztpol, sbtot, sene, salphac, salphal, sjslofa, serrors,
     3   spkpsi, sakpsi, sakth, swkve, jjslofa, sne, ste, sqr, spw,
     4   sxh, sqte, sni, sti, sdeqs, spwer, spwmax, srtor, srplas,
     5   sdenc, stec, sqc, sqa, sbaxis, scurr, sfreq, satm, sazi,
     6   sconc, stic, sxpage, sypage, slenx, sleny, sdelx, sfirtx,
     7   sdely, sfirty, symax, symin, skth, skphi, skpsi, sxx, jslofas,
     8   nurefls, keiks, jpes, jpis, istarts, iprmt5, jhlfs, isimpl,
     9   isimpl0, ngr, nps, nspie, kgraph, kprof, newgra, jksym,
     .   lintyp, nxvarb, nyvarb, kwfr, ngdim, initlh
      use Vchpcsd, ONLY: irec, rec0, rec1, rec2, rec3, rec4, rec5,
     1   rec6, rec7, rec8, rec9, rec10, rec11, rec12, rec13, rec14,
     2   rec15, prmt, jhlf, y, serror
      use Vceqdsk
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer ientry
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
      integer, parameter :: ngd16 = 1
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: nmsp, k, j, i, l, n
      real(kind=dp) :: zpi, ztwpi
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
!      integer , EXTERNAL :: min0
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c------------ --------------
c   common blocks of Comiogrl
c---------------------------
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c
c   Comhpcsd
c
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95

c
c----------------------------
c   common blocks of Cmgraphs
c

c    2   ,sqti(nprofm)
c $$$$$    TKM   03/00
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1


c******      TKM   03/97, 09/99, 04/00, 06/00
c********************

c
c ************ ************ ************ ************ ************
c
c     parameter (ngd16 = 16*ngdim)
c********SCC  01/17/95    graphics to be done differently
c ************ ************ ************ ************ ************
c
      data zpi/3.14159265359/
      data ztwpi/6.28318530718/
c
c $$$$$      TKM    03/00
      data nmsp/2/
c $$$$$$$$$$$
c ********** ********** ********** ********** ********** **********
c
      select case (ientry)
c
c ********** ********** ********** ********** ********** **********
c
      case default
c
c ************ ************ ************ ************
c maximal dimension of the plot storage
c ************ ************ ************ ************
c
         nequip = min(npdim,nequip)
         nps = nequip
         if (igraph > 1) then
            ngr = min(ngdim,nthin)
         else
            ngr = min(ngdim,nnztot)
         endif
c ************ ************ ************ ************
c initialization of the plot storage
c ************ ************ ************ ************
         sdeqs = deykpr/(2.*zpi)
         if (initlh /= 1) then
            isimpl0(:ngdim) = 2
            isimpl(:ngdim) = 0
            seikon(:npdim) = 0.0
         endif
c
         kgraph = igraph
         kprof = nprof
         kwfr = jwfr
c  Initializing of power to ions between calls to outgra
         dpwri = 0.0
c
c ************ ************ ************ ************
c   storage for graphical output of the profiles
c ************ ************ ************ ************
c
         srtor = rzero
         srplas = rplasm
         sbaxis = baxis
         scurr = 1.E-6*tcurr
         sfreq = 1.E-9*freqcy
         spwer = power
         sdenc = denc*1.E-14
         stec = tempec
         satm(:nspec) = atm(:nspec)
         sazi(:nspec) = azi(:nspec)
         stic(:nspec) = pti(1,:nspec)
         sconc(:nspec) = conc(1,:nspec)
         sqc = pqr(1,1)
         sqa = pqr(nprof,1)
         if (iplopr == 0) return
         do l = 1, nprof
            sxh(l) = ppsi(l)
            sne(l) = pne(l)/denc
            ste(l) = pte(l)/tempec
            sti(l,:nspec) = pti(l,:nspec)/stic(:nspec)
            sni(l,:nspec) = pni(l,:nspec)/denc
            sqr(l) = pqr(l,1)/sqa
         end do
         return
c
c ************ ************ ************ ************ ************
c
      case (2)
c
c ************ ************ ************ ************
c   storage for graphical output of the results
c ************ ************ ************ ************
         isimpl(indgr) = isxz
c  plot tables complete
         if (isxz >= nps) prmt(5) = 1.
         seikon(isxz) = eikon
         spsi(isxz) = psi
         sxu(isxz) = xu
         szu(isxz) = zu
         skp(isxz) = pkp
         skpar(isxz) = pkpar
c*****     TKM    2/97
         swkve(isxz) = xe
c******************************
c---------------SCC  7/9/95
         spkpsi(isxz) = pkpsi
         sakpsi(isxz) = y(1)
         sakth(isxz) = y(3)
c---------------------------
c
         stheta(isxz) = y(4)
         sphi(isxz) = y(5)/ztwpi
         spower(isxz) = pwx

c***********************************************************
c  Added for coupling to cql3d
c***********************************************************
         jslofas(indgr) = jslofa
         nurefls(indgr) = nurefl
         keiks(indgr) = keik
         jpes(indgr) = jpe
         jpis(indgr) = jpi
         istarts(indgr) = istart
         iprmt5(indgr) = prmt(5)
         jhlfs(indgr) = jhlf
         skpsi(indgr) = y(1)
         skth(indgr) = y(3)
         skphi(indgr) = anphi
         sxx(indgr) = xx
         sbtot(isxz) = btot
         sene(isxz) = dense
c $$$$$     TKM    03/00
         salphac(isxz) = game
         salphal(isxz) = gami(nmsp)
c     salphac(isxz)=alphac
c     salphal(isxz)=alphal
c $$$$$$$$$$$$$$$
         sdpwri(isxz) = dpwri
c  Resetting dpwri to zero, hence accumulating power deposition to the
c    ions in the subsequent ray element:
         dpwri = 0.0
         if (isxz == 1) then
            spol(isxz) = 0.0
         else
            spol(isxz) = sqrt((sxu(isxz-1)-xu)**2+(szu(isxz-1)-zu)**2)
     1          + spol(isxz-1)
         endif
         if (nnkpar(isign) == 0) then
            sdkpar(isxz) = 0.0
         else
            sdkpar(isxz) = (anzsup(isign)-anzinf(isign))/nnkpar(isign)/(
     1         acostq - pkheta/pkpar*asintq)*(sxu(1)+rzero)/(xu + rzero)
            sdkpar(isxz) = abs(sdkpar(isxz))
         endif
         scepx(isxz) = cepx
         scepy(isxz) = cepy
         scepz(isxz) = cepz
c $$$$$      TKM    03/00
c  To display kperp*rhoi for resonant species for NSTX runs
         sztpol(isxz) = 0.707*pkp*vti(nmsp)/wci(nmsp)
c     sztpol(isxz) = sqrt(ztpsi*ztpsi + zttau*zttau)
c $$$$$$$$$$$$$$
         sjslofa(isxz) = jslofa
         serrors(isxz) = serror
c***********************************************************************

         return
c
c ************ ************ ************ ************ ************
c
      case (3)
c
c ************ ************ ************ ************
c   storage for graphical output of the power
c           deposition profiles
c ************ ************ ************ ************
c
         nspie = nspec + 1
         spwmax = 0.
         do n = 1, nprof
            sxh(n) = ppsi(n)
            spw(n,nspie) = pwe(n)
            spwmax = max(spwmax,pwe(n))
            spw(n,:nspec) = pwi(n,:nspec)
            spwmax = max(spwmax,maxval(spw(n,:nspec)))
         end do
c
c ************ ************ ************ ************

         return

c output of graphs
c ************ ************ ************ ************
c
c            call gtitle
c      if(iplopr.eq.0)  go to 50
c            call grprof
c   50 continue
c            call gcross
c      if(kgraph.eq.-999) go to 9990
c      do 60  nxvarb=1,2
c            call gscale
c      do 60  nyvarb=1,8
c      if(iploxy(nxvarb,nyvarb).eq.0) go to 60
c            call gkappa
c   60 continue
c   70       call grapow
c      return
 9980    format('0',20x,"further plots aborted for lack of points")
         return
      end select
      end subroutine outgra
c
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c
      subroutine op_file(i_unit)
      use Vparam
      use Vcraylh
      use Viorlh
      use Vceqdsk
      use kind_spec
      
      implicit none 

      integer :: i_unit
c
      select case (i_unit)
      case default
      iout = 6
      iounit1 = 7
      iout0 = 9
      iout2 = 12
      iout3 = 13
      iout4 = 14
      iout5 = 15
      iout6 = 16
      iout7 = 17
      iout8 = 18
      iout1 = 21
     
      case(1)
         iout = iounit(i_unit)
         open(iout, file='currayout', status='unknown')

      case(2)
         iout2 = iounit(i_unit)            
         open(iout2, file='rayop', status='unknown')

      case(3)
         iout3 = iounit(i_unit)
         if (icurdr == 1) then
            open(iout3, file='adjinp', status='unknown')
         else
            open(iout3, file='adjinp', status='old')
         endif

      case(4)
         iout4 = iounit(i_unit)
         open(iout4, file='scrach', status='unknown')

      case(5)
         iout5 = iounit(i_unit)
         if (icurdr == 1) then
            open(iout5, file='adjout', status='unknown')
         else
            open(iout5, file='adjout', status='old')
         endif

      case(6)
         iout6 = iounit(i_unit)
         open(iout6, file='joptab', status='unknown')

      end select
      return
      end subroutine op_file

C   IMSL ROUTINE NAME   - LUDATN
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JUNE 1, 1982
C
C   PURPOSE             - NUCLEUS CALLED ONLY BY IMSL SUBROUTINE LEQT2F
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE LUDATN (A,IA,N,LU,ILU,IDGT,D1,D2,APVT,EQUIL,WA,IER)
C
      DIMENSION          A(IA,1),LU(ILU,1),APVT(1),EQUIL(1)
      REAL               LU
      DATA               ZERO,ONE,FOUR,SIXTN,SIXTH/0.0,1.,4.,16.,.0625/
C                                  FIRST EXECUTABLE STATEMENT
C                                  INITIALIZATION
      IER = 0
      RN = N
      WREL = ZERO
      D1 = ONE
      D2 = ZERO
      BIGA = ZERO
      DO 10 I=1,N
         BIG = ZERO
         DO 5 J=1,N
            P = A(I,J)
            LU(I,J) = P
            P = ABS(P)
            IF (P .GT. BIG) BIG = P
    5    CONTINUE
         IF (BIG .GT. BIGA) BIGA = BIG
         IF (BIG .EQ. ZERO) GO TO 110
         EQUIL(I) = ONE/BIG
   10 CONTINUE
      DO 105 J=1,N
         JM1 = J-1
         IF (JM1 .LT. 1) GO TO 40
C                                  COMPUTE U(I,J), I=1,...,J-1
         DO 35 I=1,JM1
            SUM = LU(I,J)
            IM1 = I-1
            IF (IDGT .EQ. 0) GO TO 25
C                                  WITH ACCURACY TEST
            AI = ABS(SUM)
            WI = ZERO
            IF (IM1 .LT. 1) GO TO 20
            DO 15 K=1,IM1
               T = LU(I,K)*LU(K,J)
               SUM = SUM-T
               WI = WI+ABS(T)
   15       CONTINUE
            LU(I,J) = SUM
   20       WI = WI+ABS(SUM)
            IF (AI .EQ. ZERO) AI = BIGA
            TEST = WI/AI
            IF (TEST .GT. WREL) WREL = TEST
            GO TO 35
C                                  WITHOUT ACCURACY
   25       IF (IM1 .LT. 1) GO TO 35
            DO 30 K=1,IM1
               SUM = SUM-LU(I,K)*LU(K,J)
   30       CONTINUE
            LU(I,J) = SUM
   35    CONTINUE
   40    P = ZERO
C                                  COMPUTE U(J,J) AND L(I,J), I=J+1,...,
         DO 70 I=J,N
            SUM = LU(I,J)
            IF (IDGT .EQ. 0) GO TO 55
C                                  WITH ACCURACY TEST
            AI = ABS(SUM)
            WI = ZERO
            IF (JM1 .LT. 1) GO TO 50
            DO 45 K=1,JM1
               T = LU(I,K)*LU(K,J)
               SUM = SUM-T
               WI = WI+ABS(T)
   45       CONTINUE
            LU(I,J) = SUM
   50       WI = WI+ABS(SUM)
            IF (AI .EQ. ZERO) AI = BIGA
            TEST = WI/AI
            IF (TEST .GT. WREL) WREL = TEST
            GO TO 65
C                                  WITHOUT ACCURACY TEST
   55       IF (JM1 .LT. 1) GO TO 65
            DO 60 K=1,JM1
               SUM = SUM-LU(I,K)*LU(K,J)
   60       CONTINUE
            LU(I,J) = SUM
   65       Q = EQUIL(I)*ABS(SUM)
            IF (P .GE. Q) GO TO 70
            P = Q
            IMAX = I
   70    CONTINUE
C                                  TEST FOR ALGORITHMIC SINGULARITY
         IF (RN+P .EQ. RN) GO TO 110
         IF (J .EQ. IMAX) GO TO 80
C                                  INTERCHANGE ROWS J AND IMAX
         D1 = -D1
         DO 75 K=1,N
            P = LU(IMAX,K)
            LU(IMAX,K) = LU(J,K)
            LU(J,K) = P
   75    CONTINUE
         EQUIL(IMAX) = EQUIL(J)
   80    APVT(J) = IMAX
         D1 = D1*LU(J,J)
   85    IF (ABS(D1) .LE. ONE) GO TO 90
         D1 = D1*SIXTH
         D2 = D2+FOUR
         GO TO 85
   90    IF (ABS(D1) .GE. SIXTH) GO TO 95
         D1 = D1*SIXTN
         D2 = D2-FOUR
         GO TO 90
   95    CONTINUE
         JP1 = J+1
         IF (JP1 .GT. N) GO TO 105
C                                  DIVIDE BY PIVOT ELEMENT U(J,J)
         P = LU(J,J)
         DO 100 I=JP1,N
            LU(I,J) = LU(I,J)/P
  100    CONTINUE
  105 CONTINUE
C                                  PERFORM ACCURACY TEST
      IF (IDGT .EQ. 0) GO TO 9005
      P = 3*N+3
      WA = P*WREL
      IF (WA+10.0**(-IDGT) .NE. WA) GO TO 9005
      IER = 34
      GO TO 9000
C                                  ALGORITHMIC SINGULARITY
  110 IER = 129
      D1 = ZERO
      D2 = ZERO
 9000 CONTINUE
C                                  PRINT ERROR
      CALL UERTST(IER,'LUDATN')
 9005 RETURN
      END

      subroutine ibc_ck(ibc, slbl, xlbl, imin, imax, ier)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:50:51  10/ 1/01  
C...Switches: -p4 -yb
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer ibc, imin, imax, ier
      character slbl*(*), xlbl*(*)
C-----------------------------------------------
c
c  check that spline routine ibc flag is in range
c
c
c
c
c----------------------
c
      if (ibc<imin .or. ibc>imax) then
         ier = 1
         write (6, 1001) slbl, xlbl, ibc, imin, imax
 1001    format(' ?',a,' -- ibc',a,' = ',i9,' out of range ',i2,' to ',
     1      i2)
      endif
c
      return 
      end subroutine ibc_ck

      module kind_spec
      integer, parameter :: rprec = selected_real_kind(12,100)
      integer, parameter :: iprec = selected_int_kind(8)
      integer, parameter :: dp = rprec
      real(kind=dp), parameter :: d1mach1 = epsilon(1.0_dp)
      real(kind=dp), parameter :: d1mach2 = huge(1.0_dp)
      real(kind=dp),parameter::d1mach3=epsilon(1.0_dp)/radix(1.0_dp)
      real(kind=dp), parameter :: d1mach4 = epsilon(1.0_dp)
      real(kind=dp), parameter :: d1machx = radix(1.0_dp)
C --- Note d1mach5 should be log10( FLT_RADIX) but we can not
C---  call the log function in an initialization
      real(kind=dp) :: d1mach5 =  0.301029995663981
      integer :: j1mach15 = minexponent(1.0_dp)
      integer :: j1mach14 = digits(1.0_dp)
      end module kind_spec

c
c  This file contains the bessel function routines needed by
c   curray
c----------------------------------------------------------------
c



       subroutine cbesin
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:13   6/14/01  
C...Switches: -p4 -yb
c--------------------------
c  this tabulates bessel I functions from order zero to nli-1=nli-1
c  in intervals of hin
c--------------------------
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      USE Vcombes
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n, np, iier
      real, dimension(nli) :: work
      real :: hin, x
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
      data hin/0.01/
      bsir(1,:nli-1) = 0.
      bsir(1,0) = 1.
      xin(1) = 0.
      do np = 2, nbitab
         x = (np - 1.)*hin
         xin(np) = x
c         call mmbsir (x, 0., nli, 2, work, iier)
         call dbesi(x, 0., 2, nli, work, iier)
c     call bsies(0.,x,nli,work)
c-----------------------
c  mmbsir:imsl subroutine for Bessel function of first kind
c         of nonnegative integer order for real arguments
c      x=argument of i; nli=number of function values to be computed;
c      work(ni)=array containing bessel-function values from order
c               zero to order nli-1; ier=error indicater.
c           scaling option=2 scaled by exp(-x).
c------------------------
         bsir(np,:nli-1) = work(:nli)
      end do
      return 
      end subroutine cbesin


      subroutine ibesin(n, bsi, x)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:13   6/14/01  
C...Switches: -p4 -yb
c
c   find bessel I's of order 0 to n-1 at x
c   by interpolation or asymptotic formula
c
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
!      use Vparam
      USE Vcombes
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer n
      real x
      real, dimension(n) :: bsi
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: nnx, j, j1
      real, dimension(nli) :: sum, wk1, wk2, wk3
      real :: hin, pi, xn, y1, y
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
      data hin/0.01/
      data pi/3.14159265/
      xn = x/hin
      nnx = xn - 1
      if (nnx <= nbitab - 2) then
         if (nnx <= 100) go to 200
         wk1(:n) = bsir(nnx,:n-1)
         wk2(:n) = bsir(nnx+1,:n-1)
         wk3(:n) = bsir(nnx+2,:n-1)
         call intern (bsi, x, wk1, wk2, wk3, xin(nnx), xin(nnx+1), xin(
     1      nnx+2), n)
         return 
      endif
      y1 = sqrt(0.5/x/pi)
      bsi(:n) = y1
      return 
  200 continue
      sum(:n) = 1.
      do j = 2, n
         j1 = j - 1
         sum(j) = sum(j1)*0.5*x/j1
      end do
      y = 0.25*x**2
      do j = 1, n
         bsi(j) = sum(j)*(1. + y/j*(1. + y/2./(j + 2.)*(1. + y/3./(j + 
     1      3.)*(1. + y/4./(j + 4.)))))
      end do
      return 
      end subroutine ibesin

 
      subroutine besfun(l1, nx, nx1, x, bes, h, mx, wk)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:13   6/14/01  
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s 
C-----------------------------------------------
      USE Vbesblk
      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer l1, nx, nx1
      real h
      integer, dimension(nx1) :: mx
      real, dimension(nx1) :: x, bes
      real, dimension(nx1,2) :: wk
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: l2, i
      real :: one, two, zero
C-----------------------------------------------
c--------------------------------
c  Input:
c  bessel function subroutine
c  l1=order of bessel function
c  nx is number of points evaluated (.le.nx1)
c  nx1 is exact dimension of bes,mx.
c  x(nx) are argument values
c  Output:
c  bes(nx) are values of bessel functions at x(nx)
c
c
c  it is assumed that the bessel function table bestb(nbsx,lbes)
c  already exists from order lmn to lmx in the array bestb(nbsx,1:lmx-lmn+1)
c   h=grid size of table
c      usually 0.005
c-------------------------------
      data one/1.E0/
      data two/2.E0/
      data zero/0./
 
      l2 = l1 - lmn + 1
      mx(:nx) = (x(:nx)/h) + 1
      wk(:nx,1) = bestb(mx(:nx),l2)
      wk(:nx,2) = bestb(mx(:nx)+1,l2)
      bes(:nx)=wk(:nx,1)+((x(:nx)/h)-mx(:nx)+one)*(wk(:nx,2)-wk(:nx,1))
      return 
      end subroutine besfun
 
 
      subroutine besj(x, n, bj, d, ier)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:13   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer n, ier
      real x, bj, d
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: ntest, n1, ma, mb, mzero, mmax, m, jt, m2, k, mk
      real :: bprev, fm1, fm, alpha, bmk, s
C-----------------------------------------------
c-----------------------------------------------------------------------
c     i.b.m. bessel function j
c     x  - argument
c     n  - order (integer .ge. 0)
c     bj - j(x)
c     d  - relative allowable error (input)
c     ier- error switch, if ier=0 all is ok
c-----------------------------------------------------------------------
      bj = 0.
      if (n < 0) then
         ier = 1
         return 
      endif
      if (x <= 0.) then
         ier = 2
         bj = 0.
         if (n == 0) bj = 1.
         return 
      endif
      if (x - 15. <= 0.) then
         ntest = 20. + 10.*x - x*x/3
      else
         ntest = 90. + x/2.
      endif
      if (n - ntest >= 0) then
         ier = 4
         return 
      endif
      ier = 0
      n1 = n + 1
      bprev = 0.
      if (x - 5. < 0.) then
         ma = x + 6.
      else
         ma = 1.4*x + 60./x
      endif
      mb = n + ifix(x)/4 + 2
      mzero = max0(ma,mb)
      mmax = ntest
      do m = mzero, mmax, 3
         fm1 = 1.E-28
         fm = 0.
         alpha = 0.
         if (m - (m/2)*2 == 0) then
            jt = -1
         else
            jt = 1
         endif
         m2 = m - 2
         do k = 1, m2
            mk = m - k
            bmk = 2.*float(mk)*fm1/x - fm
            fm = fm1
            fm1 = bmk
            if (mk - n - 1 == 0) then
               bj = bmk
            endif
            jt = -jt
            s = 1 + jt
            alpha = alpha + bmk*s
         end do
         bmk = 2.*fm1/x - fm
         if (n == 0) then
            bj = bmk
         endif
         alpha = alpha + bmk
         bj = bj/alpha
         if (abs(bj - bprev) - abs(d*bj) <= 0.) go to 200
         bprev = bj
      end do
      ier = 3
  200 continue
      return 
      end subroutine besj
c
ctk--calculation of Bessel function with a complex argument (x,y)
      subroutine beslci(x, y, nb, ize, br, bi, ncalc)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:13   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer nb, ize, ncalc
      real x, y
      real, dimension(*) :: br, bi
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: nsig, nten, largez, magz, nbmz, n, m, nstart, nend, 
     1   ipos, mrecur, k, l, mlast, imrecr, imag
      real :: exparg, tempar, sign1, zinvr, zinvi, plastr, plasti, pr, 
     1   pi, test, tover, poldr, poldi, tempbi, tempbr, psaver, psavei, 
     2   tempcr, tempci, tempai, sumr, sumi
C-----------------------------------------------
c
c*****     *****     *****     *****     *****     *****     *****
c
c     journal of research  national bureau of standards
c     b-mathematical sciences   vol.77-b  nos.3-4  july-dec. 1973  p118
c     routine to calculate bessel functions j and i
c     of complex argument and integer order
c                  input variables
c     x real part of complex argument
c     y imaginary part of complex argument
c     nb a positive integer designating highest order to be calculated
c     ize     zero for j*s    one for i*s
c     br  for normal exit,br contains real part of solution vector
c     bi  for normal exit,bi contains imaginary part of solution vector
c     normal exit if  ncalc=nb
c     br-bi-ncalc need not be initialized
c                  machine dependent constants
c     nsig  decimal significance desired. set to ifix(alog10(2)*nbit+1)
c     nbit  number of bits in the mantissa
c     the relative truncation error is limited to t=.5*10**-nsig for
c     order greater than abs(z).
c     for order less than abs(z) (general test),the relative error is
c     limited to t for function values of magnitude at least 1.
c     the absolute error is limited to t for smaller values.
c     nten  largest integer k such that 10**k is machine representable.
c     largez  upper limit on the magnitude of z. if abs(z)=n, at least
c     n iterations of the backward recursion will be executed.
c     exparg  largest argument that the library exp routine can handle.
c                  error returns
c     let g denote either i or j.
c     in case of an error, ncalc.ne.nb and not all g*s are calculated
c     to the desired accuracy.
c     if ncalc.lt.0, an argument is out of range. nb.le.0 or ize is
c     neither 0 nor 1 or ize=0 and abs(y).gt.exparg, or ize=1 and
c     abs(x).gt.exparg. in this case,the vectors br and bi are not
c     calculated, and ncalc is set to min0(nb,0)-1 so ncalc.ne.nb.
c     nb.gt.ncalc.gt.0 will occur if nb.gt.magz and abs(g-sub-nb-of-z/g
c     -sub-magx-of-z).lt.10.**(nten/2), i.e. nb is much greater than
c     magz. in this case, br(n) and bi(n) are calculated to the desired
c     accuracy for n.le.ncalc, but for ncalc.lt.n.le.nb, precision  is
c     lost. if n.gt.ncalc and abs(g(ncalc-1)/g(n-1)).eq.10**-k, then
c     the last k significant figures of g(n-1) (=br(n)+i*bi(n)) are
c     erroneous. if the user wishes to calculate g(n-1) to higher
c     accuracy, he should use an asymptotic formula for large order.
c
c*****     *****     *****     *****     *****     *****     *****
c
      data nsig, nten, largez, exparg/15, 307, 10000, 700./
      tempar = sqrt(x*x + y*y)
      magz = ifix(tempar)
      if (.not.(nb>0 .and. magz<=largez .and. (ize==0 .and. abs(y)<=
     1   exparg .or. ize==1 .and. abs(x)<=exparg))) then
c     error return    z,nb,or ize is out of range
         ncalc = min0(nb,0) - 1
         return 
      endif
      sign1 = 1 - 2*ize
      ncalc = nb
c     use 2-term ascending series for small z
      if (tempar**4 >= 0.1**nsig) then
c     initialize the calculation of the p*s
         nbmz = nb - magz
         n = magz + 1
         if (abs(x) >= abs(y)) then
            zinvr = 1.0/(x + y*y/x)
            zinvi = -y*zinvr/x
         else
            zinvi = -1.0/(y + x*x/y)
            zinvr = -x*zinvi/y
         endif
         plastr = 1.0
         plasti = 0.0
         pr = sign1*(n + n)*zinvr
         pi = sign1*(n + n)*zinvi
         test = 2.0*10.0**nsig
         m = 0
         if (nbmz >= 3) then
c     calculate p*s until n=nb-1.  check for possible overflow.
            tover = 10.0**(nten - nsig)
            nstart = magz + 2
            nend = nb - 1
            do n = nstart, nend
               poldr = plastr
               poldi = plasti
               plastr = pr
               plasti = pi
               pr=sign1*((n+n)*(plastr*zinvr-plasti*zinvi)-poldr)
               pi=sign1*((n+n)*(plasti*zinvr+plastr*zinvi)-poldi)
               if ((pr/tover)**2 + (pi/tover)**2 - 1.0 > 0.) go to 7
            end do
            n = nend
c     calculate special significance test for nbmz.gt.2.
            tempbi = amax1(abs(pr),abs(pi))
            tempbi = tempbi*sqrt(2.0*10.0**nsig*sqrt(((pr/tempbi)**2 + (
     1         pi/tempbi)**2)*((plastr/tempbi)**2 + (plasti/tempbi)**2))
     2         )
            test = amax1(test,tempbi)
c     calculate p*s until significance test is passed
         endif
    6    continue
         n = n + 1
         poldr = plastr
         poldi = plasti
         plastr = pr
         plasti = pi
         pr = sign1*((n + n)*(plastr*zinvr - plasti*zinvi) - poldr)
         pi = sign1*((n + n)*(plasti*zinvr + plastr*zinvi) - poldi)
         do while((pr/test)**2 + (pi/test)**2 < 1.0)
            n = n + 1
            poldr = plastr
            poldi = plasti
            plastr = pr
            plasti = pi
            pr = sign1*((n + n)*(plastr*zinvr - plasti*zinvi) - poldr)
            pi = sign1*((n + n)*(plasti*zinvr + plastr*zinvi) - poldi)
         end do
         if (m == 1) go to 12
c     calculate strict variant of significance test,and
c     calculate p*s until this test is passed.
         m = 1
         tempbi = amax1(abs(pr),abs(pi))
         tempbr = sqrt(((pr/tempbi)**2 + (pi/tempbi)**2)/((plastr/tempbi
     1      )**2 + (plasti/tempbi)**2))
         tempbi = (n + 1)/tempar
         if (tempbr + 1.0/tempbr > 2.0*tempbi) tempbr = tempbi + sqrt(
     1      tempbi**2 - 1.0)
         test = test/sqrt(tempbr - 1.0/tempbr)
         if ((pr/test)**2 + (pi/test)**2 - 1.0 < 0.) go to 6
         go to 12
    7    continue
         nstart = n + 1
c     to avoid overflow, normalize p*s by dividing by tover.
c     calculate p*s until unnormalized p would overflow.
         pr = pr/tover
         pi = pi/tover
         plastr = plastr/tover
         plasti = plasti/tover
         psaver = pr
         psavei = pi
         tempcr = plastr
         tempci = plasti
         test = 10.0**(2*nsig)
         n = n + 1
         poldr = plastr
         poldi = plasti
         plastr = pr
         plasti = pi
         pr = sign1*((n + n)*(plastr*zinvr - plasti*zinvi) - poldr)
         pi = sign1*((n + n)*(plasti*zinvr + plastr*zinvi) - poldi)
         do while(pr**2 + pi**2 <= test)
            n = n + 1
            poldr = plastr
            poldi = plasti
            plastr = pr
            plasti = pi
            pr = sign1*((n + n)*(plastr*zinvr - plasti*zinvi) - poldr)
            pi = sign1*((n + n)*(plasti*zinvr + plastr*zinvi) - poldi)
         end do
c     calculate backward test,and find ncalc,the highest n
c     such that the test is passed.
         tempbr = sqrt((plastr**2 + plasti**2)/(poldr**2 + poldi**2))
         tempbi = n/tempar
         if (tempbr + 1.0/tempbr > 2.0*tempbi) tempbr = tempbi + sqrt(
     1      tempbi**2 - 1.0)
         test = 0.5*(1.0 - 1.0/tempbr**2)/10.0**nsig
         test=((plastr**2+plasti**2)*test)*((poldr**2+poldi**2)*test)
         pr = plastr*tover
         pi = plasti*tover
         n = n - 1
         nend = min0(nb,n)
         do ncalc = nstart, nend
            poldr = tempcr
            poldi = tempci
            tempcr = psaver
            tempci = psavei
            psaver=sign1*((n+n)*(tempcr*zinvr-tempci*zinvi)-poldr)
            psavei=sign1*((n+n)*(tempci*zinvr+tempcr*zinvi)-poldi)
            if ((psaver**2 + psavei**2)*(tempcr**2 + tempci**2) - test
     1          > 0.) go to 10
         end do
         ncalc = nend + 1
   10    continue
         ncalc = ncalc - 1
c     the coefficient of b(n) in the normalized sum is
c     m*sqrt(-1)**imag,where m=-2,0,or2,and imag is 0 or 1.
c     calculate recursion rules for m and imag,and initialize them.
   12    continue
         n = n + 1
         tempbr = ize*x + (1 - ize)*y
         ipos = 0
         if (tempbr /= 0.) then
            ipos = ifix(1.1*tempbr/abs(tempbr))
         endif
         mrecur = 4*((2 + ize + ipos)/2) - 3 - 2*(ize + ipos)
         k = 2 + ipos + 2*ize*ipos**2 - ize
         l = n - 4*(n/4)
         mlast = 2 + 8*((k*l)/4) - 4*((k*l)/2)
         if (ipos==0 .and. (l==1 .or. l==3)) mlast = 0
         l = l + 3 - 4*((l + 3)/4)
         m = 2 + 8*((k*l)/4) - 4*((k*l)/2)
         if (ipos==0 .and. (l==1 .or. l==3)) m = 0
         imrecr = (1 - ize)*ipos**2
         imag = imrecr*(l - 2*(l/2))
c     initialize the backward recursion and the normalization sum
         tempbr = 0.0
         tempbi = 0.0
         if (abs(pi) <= abs(pr)) then
            tempar = 1.0/(pr + pi*(pi/pr))
            tempai = -(pi*tempar)/pr
         else
            tempai = -1.0/(pi + pr*(pr/pi))
            tempar = -(pr*tempai)/pi
         endif
         if (imag == 0) then
            sumr = m*tempar
            sumi = m*tempai
         else
            sumr = -m*tempai
            sumi = m*tempar
         endif
         nend = n - nb
         if (nend >= 0) then
            if (nend /= 0) then
               do l = 1, nend
                  n = n - 1
                  tempcr = tempbr
                  tempci = tempbi
                  tempbr = tempar
                  tempbi = tempai
                  pr = (n + n)*zinvr
                  pi = (n + n)*zinvi
                  tempar = pr*tempbr - pi*tempbi - sign1*tempcr
                  tempai = pr*tempbi + pi*tempbr - sign1*tempci
                  imag = (1 - imag)*imrecr
                  k = mlast
                  mlast = m
                  m = k*mrecur
                  if (imag == 0) then
                     sumr = sumr + m*tempar
                     sumi = sumi + m*tempai
                  else
                     sumr = sumr - m*tempai
                     sumi = sumi + m*tempar
                  endif
               end do
c     store  br(nb),bi(nb)
            endif
            br(n) = tempar
            bi(n) = tempai
            if (n <= 1) then
c     nb=1.  since 2*tempar and 2*tempai were added to sumr and sumi
c     respectively,we must subaxis(i)ract tempar and tempai
               sumr = sumr - tempar
               sumi = sumi - tempai
               go to 35
c     calculate and store br(nb-1),bi(nb-1)
            endif
            n = n - 1
            pr = (n + n)*zinvr
            pi = (n + n)*zinvi
            br(n) = pr*tempar - pi*tempai - sign1*tempbr
            bi(n) = pr*tempai + pi*tempar - sign1*tempbi
            if (n == 1) go to 34
            imag = (1 - imag)*imrecr
            k = mlast
            mlast = m
            m = k*mrecur
            if (imag == 0) then
               sumr = sumr + m*br(n)
               sumi = sumi + m*bi(n)
               go to 30
            endif
            sumr = sumr - m*bi(n)
            sumi = sumi + m*br(n)
            go to 30
c     n.lt.nb,so store br(n),bi(n) and set higher orders zero
         endif
         br(n) = tempar
         bi(n) = tempai
         nend = -nend
         br(n+1:nend+n) = 0.0
         bi(n+1:nend+n) = 0.0
   30    continue
         nend = n - 2
         if (nend /= 0) then
c     calculate via difference equation and store br(n),bi(n)
c     until n=2
            do l = 1, nend
               n = n - 1
               pr = (n + n)*zinvr
               pi = (n + n)*zinvi
               br(n) = pr*br(n+1) - pi*bi(n+1) - sign1*br(n+2)
               bi(n) = pr*bi(n+1) + pi*br(n+1) - sign1*bi(n+2)
               imag = (1 - imag)*imrecr
               k = mlast
               mlast = m
               m = k*mrecur
               if (imag == 0) then
                  sumr = sumr + m*br(n)
                  sumi = sumi + m*bi(n)
               else
                  sumr = sumr - m*bi(n)
                  sumi = sumi + m*br(n)
               endif
            end do
c     calculate and store br(1),bi(1)
         endif
         br(1) = 2.0*(br(2)*zinvr-bi(2)*zinvi) - sign1*br(3)
         bi(1) = 2.0*(br(2)*zinvi+bi(2)*zinvr) - sign1*bi(3)
   34    continue
         sumr = sumr + br(1)
         sumi = sumi + bi(1)
c     calculate normalization factor. tempar+i*tempai
   35    continue
         if (ize /= 1) then
            tempcr = ipos*y
            tempci = -ipos*x
         else
            tempcr = ipos*x
            tempci = ipos*y
         endif
         tempcr = exp(tempcr)
         tempbr = cos(tempci)
         tempbi = sin(tempci)
         if (abs(sumr) >= abs(sumi)) then
            tempci = sumi/sumr
            tempcr = (tempcr/sumr)/(1.0 + tempci*tempci)
            tempar = tempcr*(tempbr + tempbi*tempci)
            tempai = tempcr*(tempbi - tempbr*tempci)
         else
            tempci = sumr/sumi
            tempcr = (tempcr/sumi)/(1.0 + tempci*tempci)
            tempar = tempcr*(tempbr*tempci + tempbi)
            tempai = tempcr*(tempbi*tempci - tempbr)
c     normalize
         endif
         do n = 1, nb
            tempbr = br(n)*tempar - bi(n)*tempai
            bi(n) = br(n)*tempai + bi(n)*tempar
            br(n) = tempbr
         end do
         return 
c     two-term ascending series for small z
      endif
      tempar = 1.0
      tempai = 0.0
      tempcr = 0.25*(x*x - y*y)
      tempci = 0.5*x*y
      br(1) = 1.0 - sign1*tempcr
      bi(1) = -sign1*tempci
      if (nb /= 1) then
         do n = 2, nb
            tempbr = (tempar*x - tempai*y)/(n + n - 2)
            tempai = (tempar*y + tempai*x)/(n + n - 2)
            tempar = tempbr
            tempbr = n
            br(n) = tempar*(1.0 - sign1*tempcr/tempbr) + tempai*tempci/
     1         tempbr
            bi(n) = tempai*(1.0 - sign1*tempcr/tempbr) - tempar*tempci/
     1         tempbr
         end do
      endif
      return 
      end subroutine beslci


c
      subroutine besselj(lmax, lmin, nx, x, besj, h, nx1, work, mx, wk)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:13   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer lmax, lmin, nx, nx1
      real h
      integer, dimension(nx1) :: mx
      real, dimension(nx1) :: x
      real, dimension(nx1,lmax - lmin + 1) :: besj
      real, dimension(nx1) :: work
      real, dimension(nx1,2) :: wk
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: l, i
C-----------------------------------------------
c---------------------
c  This version uses linear interpolation on Bessel function table.
c  It should be faster, but probably less accurate than the older version
c----------------------
c---------------
c   bessel functions of first kind at x(nx) stored in
c   besj(nx,lmax-lmin+1); order from lmin to lmax
c        i.e., besj(nx,1) is besj(x) of order lmin
c              besj(nx,lmax-lmin+1) is besj(x) of order lmax
c   lmin and lmax must be positive; lmax.ge.lmin
c  x(nx) are assumed ge.0.
c  nx1 is dimension of x,work,mx and first dimension of besj and wk exactly as
c    specified in the calling program
c  h is interval width of Bessel function table.
c  work,mx,wk are working areas; mx is integer
c------------------
 
      do l = lmin, lmax
         call besfun (l, nx, nx1, x, work, h, mx, wk)
         besj(:nx,l-lmin+1) = work(:nx)
      end do
      return 
      end subroutine besselj



c
      subroutine bestab(lmx, lmn, narg, darg, arg0, bestb, wk1, wk2)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:00:13   6/14/01  
C...Switches: -p4 -yb
      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer lmx, lmn, narg
      real darg, arg0
      real, dimension(narg,lmx - lmn + 1) :: bestb
      real, dimension(lmx + 1) :: wk1, wk2
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, ncalc, j
      real :: x, y
C-----------------------------------------------
c--------------------------
c   Bessel [J(x)] function table generator
c   lmx is maximum order
c   lmn is minimum order
c   narg is dimension of argument of bessel functions
c   darg is increment of each argument
c   arg0 is the value of first argument
c   bestb(narg,nl) contains the bessel function table of narg
c    arguments from order lmn to lmx
c-------------------------
      do i = 1, narg
         x = arg0 + (i - 1)*darg
         y = 0.
         call beslci (x, y, lmx + 1, 0, wk1, wk2, ncalc)
         bestb(i,:) = wk1(lmn+1:lmx+1)
      end do
      return 
      end subroutine bestab

      subroutine setdflt
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:02:43   6/14/01
C...Switches: -p4 -yb
c--------------------------
c  set default values of variables
c----------------------------
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
      use Vparam
      use Vsizes
      use Vceqdsk
      use Vcfdamp
      use Vchpcsd
      use Vcmnew
      use Vcraylh
      use Vcgraphs
      use Viogrl
      use Viorlh
      use Vctransp
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: nspi0
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i

c
c  Comfdamp
c
c
c
c   Comhpcsd
c
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1


c******      TKM   03/97, 09/99, 04/00, 06/00
c********************

c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95

c----------------------------
c   common blocks of Cmgraphs
c

c    2   ,sqti(nprofm)
c------------ --------------
c   common blocks of Comiogrl
c---------------------------
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
      integer j1
c
c Comeqdsk
      psiadj = 0.
      imodeq = 1
      liw = 4
      lw = 40
      ifail = 1
      bperr = largest  ! was 1.e100 See notes at beginning of miscl.f
      arcl = largest   ! was 1.e100 See notes at beginning of miscl.f
      nti = 1
      inoperm1 = inoperm
      nptsdm1 = nptsdm
c
c  Comfdamp
      enorm = 300.
      nint = 100
      nmax1 = 0
      rtail = 0.
      r1t = 0.1
      r2t = 0.2
      ttail = 20.
      rhot = 0.
      r1h = 0.1
      r2h = 0.2
      thotpar = 5.
      thotper = 5.
      hotexp = 5.
      hotmnpar = 0.
      hotmxpar = largest                         ! was 1.e100
      hotmnper = 0.
      hotmxper = largest                         ! was 1.e100
      rbeam = 0.
      r1b = 0.1
      r2b = 0.2
      tbeam = 0.06
      ebeam = 1.
      thbeam = 30.
      inname = 'dskout'
      ifbilin = 1
      ifirstb = 1
      besdel = 1.E-4
c
c  Comhpcsd
c
      klim = 1000
      irecmx = 100000
c
c  Comnew
c
      npar = 101
      nper = 101
      intg = 501
      tnmaxe = 20.
      tnmaxi = 20.
      vloop = 0.

c
c   Comraylh
c
      phi0 = 0.
      dpwri = 0.
      dpwrf = 0.
      alpha1 = 0.
      alpha2 = 0.
      solrfl = 0.5
      accur = 1.E-5
c
c   Cmgraphs
c
c
c   Comiogrl
c
      ndim0 = 1000
      ndim1 = 999
      itrans = 0
c
c   Comiorlh
c
      versid = '120996'
      epspfw = 1.E-6
      epspsw = 1.E-6
      nharm = 0
      isafa = 0
      qsaf0 = 1.05
      qsafa = 5.5
!      nprofn = nprofm
      nequip = 50
c************    TKM   2/97
      gamti1 = 1.
      alpti1 = 1.
c*************************************
c
c   cmnew
c
      npar = 101
      nper = 101
      intg = 501
      incf = 1
      tnmaxe = 20.
      tnmaxi = 20.
      vloop = 0.
      elp_tr(:nprofm) = 0.
      btbsp = 1.0
      ftbsps = 1.0
c
c-----Set less frequently changed CURRAY.IN input
c
      ieqdsk = 3
      initlh = 0
      dang = 4.
      nptsd = 91
      specfac = 0.5
      delthe = 0.05
      wfrac0 = 0.999
      deykpr = 1.
      scatd = 0.
      iscat0 = 0
      solrfl = 0.02
      accur = 1.e-5
      trate = 1.
      tratte = 1.
      ttle = 5.
      concte = 0.
      trati = 1.
      tratti = 1.
      ttli = 5.
      concti = 0.
      vdrfte = 0.
      vdrfti = 0.
      infi = 0.
      inf = -1
!     print *, 'inf=', inf
      precdy = 1./float(nions)
      dsteph = 0.02
      icoll = 1
      fcoll = 1.
      fdened = 1.
      fzefed = 1.
      fteed = 5.
      ftied = 5.
      wsol = 0.075
      phase = 90.
      presfr = 1.0
      ffast = 0.
      ibeam = 0
      bmpwr(1) = 5.
      abeam = 0.
      dbeam = 0.35
      aneb = 1.
      nharm0 = 5
      nraypic = 0
      psimn = 0.0001
      psimx = 0.901
      npsi0 = 26
      nthp0 = 1000
      nmax = 100
      imax = 100
      lmax = 5
      nwp = 51
      umax1 = 10.
      tmax = 700.
      wpmx = 5.05e0
      wpmn = 5.e-2
      nthp1 = 61
      iswchi = 0
      aerrmx = 1.e-5
      rerrmx = 2.e-6
c
c-----Set less frequently changed SPECFL.IN input
c
      npsig = 1
      nthpg = 1
      numg = 4
      npnt = 101
      mpnt = 26
c
      return
      end subroutine setdflt

! 07Jun1999 fgtok -impno -s r8_precision.sub r8_names.table "r8con.csh conversion"
      subroutine r8bcspefnd(x,nx,zxget,i)
c
      IMPLICIT NONE
C============
C idecl:  explicitize implicit INTEGER declarations:
      INTEGER nx,nxm,i1,i2,ij,ii
C============
C idecl:  explicitize implicit REAL declarations:
      REAL*8 dx
C============
      REAL*8 x(nx),zxget
      integer i
c
c  find index i such that x(i).le.zxget.le.x(i+1)
c
c  x(1...nx) is strict increasing and x(1).le.zxget.le.x(nx)
c  (this is assumed to already have been checked -- no check here!)
c
      nxm=nx-1
      if((i.lt.1).or.(i.gt.nxm)) then
         i1=1
         i2=nx-1
         go to 10
      endif
c
      if(x(i).gt.zxget) then
c  look down
         dx=x(i+1)-x(i)
         if((x(i)-zxget).gt.4*dx) then
            i1=1
            i2=i-1
            go to 10
         else
            i2=i-1
            do ij=i2,1,-1
               if((x(ij).le.zxget).and.(zxget.le.x(ij+1))) then
                  i=ij
                  return
               endif
            enddo
            i=1
            return
         endif
      else if(x(i+1).lt.zxget) then
c  look up
         dx=x(i+1)-x(i)
         if((zxget-x(i+1)).gt.4*dx) then
            i1=i+1
            i2=nxm
            go to 10
         else
            i2=i+1
            do ij=i2,nxm
               if((x(ij).le.zxget).and.(zxget.le.x(ij+1))) then
                  i=ij
                  return
               endif
            enddo
            ij=nxm
            return
         endif
      else
c  already there...
         return
      endif
c
c---------------------------
c  binary search
c
 10   continue
c
      if(i1.eq.i2) then
c found by proc. of elimination
         i=i1
         return
      endif
c
      ii=(i1+i2)/2
c
      if(zxget.lt.x(ii)) then
         i2=ii-1
      else if(zxget.gt.x(ii+1)) then
         i1=ii+1
      else
c found
         i=ii
         return
      endif
c
      go to 10
c
      end

c  This module contains profile routines
c
c-------------------------------------------
c
c
      function fuelon(psi)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:40   6/14/01
C...Switches: -p4 -yb
c
c ************ ************ ************ ************
c analytic fit to the elongation
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh, only: polasp
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real(kind=dp) fuelon
      real(kind=dp) psi
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   # option for n-T profile calculation: 1 if
c                           # calculated from prontp; else = 0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c ************ ************ ************ ************
c
      fuelon = polasp(1) + (polasp(2)-polasp(1))*psi*psi
c
      return
      end function fuelon


      subroutine funct1(n, xc, fc)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:40   6/14/01
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh
      use Vcraylh
      USE Vclsfun1
      USE Vceqdsk, only: xxx, zzz
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer n
      real(kind=dp) fc
      real(kind=dp), dimension(n) :: xc
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: lmhd, i, id
      real(kind=dp), dimension(3) :: zbx0, zbx1, zbx2, zbz0
      real(kind=dp) :: zh, zph, zcosph, fxxx, fzzz
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
!      integer , EXTERNAL :: ifix
C-----------------------------------------------
      real(kind=dp) , EXTERNAL :: valspl
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c

c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95

c
c   ****************************************************************
c
c
c   ****************************************************************
c
      psi = xc(1)
      theta = xc(2)
c
      if (abs(psi) < 1.E-10) psi = sign(1._dp,psi)*1.E-10
      psi = min(psilimit,psi)
c
      asinth = sin(theta)
c
c   ****************************************************************
c   evaluations of rshift, rho, dtrian, elong and their derivatives
c   ****************************************************************
c
!      lmhd = ifix(psi/dpsimhd) + 1
      lmhd = int(psi/dpsimhd) + 1
      zh = psi - psimhd(lmhd)
c
      do i = 1, 1
         id = i - 1
         zbx0(i) = valspl(zh,bx0,nprofn,lmhd,id)
         zbx1(i) = valspl(zh,bx1,nprofn,lmhd,id)
         zbx2(i) = valspl(zh,bx2,nprofn,lmhd,id)
         zbz0(i) = valspl(zh,bz0,nprofn,lmhd,id)
      end do
c
c   ****************************************************************
c   evaluation of xu(psi,theta), zu(psi,theta), and derivatives
c   ****************************************************************
c
      zph = theta - zbx2(1)*asinth
      zcosph = cos(zph)
c
      ux = zbx0(1) + zbx1(1)*zcosph
      uz = zbz0(1)*asinth
c
      fxxx = ux/ukzero
      fzzz = uz/ukzero

      fc = (xxx - fxxx)**2 + (zzz - fzzz)**2
      if (psi <= 0.) fc = 100.

      return
      end subroutine funct1

      function furmaj(psi)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:40   6/14/01
C...Switches: -p4 -yb
c
c ************ ************ ************ ************
c analytic fit to the major radius position
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh, only: rzero, rshift
!      use Vcraylh
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real(kind=dp) furmaj
      real(kind=dp) psi
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   # option for n-T profile calculation: 1 if
c                           # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c ************ ************ ************ ************
c
      furmaj = rzero + rshift*(1. - psi)
c
      return
      end function furmaj

      function furrho (psi)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:40   6/14/01
C...Switches: -p4 -yb
c
c ************ ************ ************ ************
c analytic fit to the minor radius
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh, only: rplasm
!      use Vcraylh
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real(kind=dp) furrho
      real(kind=dp) psi
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c ************ ************ ************ ************
c
      furrho = rplasm*psi
c
      return
      end function furrho
      function futria (psi)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:40   6/14/01
C...Switches: -p4 -yb
c
c ************ ************ ************ ************
c analytic fit to the triangularity
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh, only:  dtrian
!      use Vcraylh
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real(kind=dp) futria
      real(kind=dp) psi
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   # option for n-T profile calculation: 1 if
c                           # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c ************ ************ ************ ************
c
      futria = dtrian*psi*psi
c
      return
      end function futria
c
c  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c

      subroutine metrin
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:40   6/14/01
C...Switches: -p4 -yb
c
c   ****************************************************************
c   *                                                              *
c   *      This modulus initializes the parametric repre-          *
c   *           sentation of  the plasma equilibrium con-          *
c   *           figuration, and plasma profiles.                   *
c   *      It is called from inital, if ieqdsk.lt.3                *
c   *                                                              *
c   ****************************************************************
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh
      use Vcraylh
      use Vchpcsd
      use Vceqdsk
      use Vcmnew, only: conci
!      USE Vfwcd1
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: n, ijk, j, i
      real(kind=dp) :: zpi, sum
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real(kind=dp) , EXTERNAL :: prone, prote, proti
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c
c   Comhpcsd
c
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95

c
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i

c
c
c
c ************ ************ ************ ************ ************
c
      data zpi/3.14159265359/
c
c ************ ************ ************ ************ ************
c
c   mhd equilibrium expansion parameters
c
      bx0(:nmhd,1) = ukzero*(rmaj(:nmhd)-rmaj(1))
      bx1(:nmhd,1) = ukzero*rrho(:nmhd)
      bx2(:nmhd,1) = triang(:nmhd)
      bz0(:nmhd,1) = elong(:nmhd)*bx1(:nmhd,1)
c
      call cubspl (dpsimhd, bx0, nprofn, nmhd)
c
      call cubspl (dpsimhd, bx1, nprofn, nmhd)
c
      call cubspl (dpsimhd, bx2, nprofn, nmhd)
c
      call cubspl (dpsimhd, bz0, nprofn, nmhd)
c
c ************ ************ ************ ************
c   plasma shape and dimensions
c   magnetic field on the magnetic axis
c ************ ************ ************ ************
c
      psi = 1.
      theta = 0.
c
      call coords
c
      xmax = ux/ukzero
      theta = zpi
c
      call coords
c
      xmin = ux/ukzero
      urplas = rplasm*ukzero
      raxmag = rmaj(1)
      rshift = raxmag - rzero
      uraxmag = ukzero*raxmag
      baxis = bzero*rzero/raxmag
c
c ************ ************ ************ ************ ************
c  density,temperature,zeff profiles
c
c
      print *,'Executed code with improper indexing.'
      nion = nspec
      do ijk = 1, nprofs
         psi = float(ijk - 1)/float(nprofs - 1)
         ppsi(ijk) = psi
         pne(ijk) = prone(psi)
         pte(ijk) = prote(psi)
         pjavg(ijk) = pte(ijk)**1.5
         pti(ijk,1) = proti(psi)
      end do
      conci(:nion) = aconc(:nion)*azi(:nion)
      sum = 0.
      do i = 1, nion
         sum = sum + conci(i)
      end do
      do i = 1, nion
         conci(i) = conci(i)/sum
         aconc(i) = conci(i)/azi(i)
         pni(:nprofs,i) = pne(:nprofs)*aconc(i)
         conc(:nprofs,i) = pni(:nprofs,i)/pne(:nprofs)
      end do
      do i = 2, nion
         pti(:nprofs,i) = pti(:nprofs,1)
      end do
      zeff = 0.
      zeff = dot_product(aconc(:nion),azi(:nion)**2)
      tzeff(:nprofs,1) = zeff
      return
c
c ************ ************ ************ ************ ************
c
      end subroutine metrin


       function pro(psi, rplasm, acoef)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:40   6/14/01
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
!      use Viorlh
!      use Vcraylh
!      use Vchpcsd
!      use Vceqdsk
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real(kind=dp) pro
      real(kind=dp) psi, rplasm
      real(kind=dp), dimension(4) :: acoef
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i
      real(kind=dp) :: x, x2, arg
C-----------------------------------------------

c     Calculate ASDEX YAG1 type profiles.
c     acoef(i),i=1,4  must be specified.

      x = rplasm*psi
      x2 = x*x
      arg = acoef(4)
      do i = 1, 3
         arg = arg*x2 + acoef(4-i)
      end do
      pro = exp(arg)
      return
      end function pro
c
c
      subroutine modb
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:40   6/14/01
C...Switches: -p4 -yb
c*****A subroutine to calculate mod-B on the rectangular grids of EQDSK.
c     This is for use mainly in plotting the mod-B surface for a low-A
c     tokamak.
c$$$$$$   TK Mau   01/95
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
!      use Viorlh
!      use Vcraylh
!      use Vchpcsd
      use Vceqdsk
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer, dimension(4) :: jbd
      integer :: i, j, igrd
      real(kind=dp), dimension(nxa,4) :: feqdsp
      real(kind=dp), dimension(nxa,nza) :: pxx, pzz, pxxzz
      real(kind=dp), dimension(6*nza + 1) :: wkm
      real(kind=dp) :: dpflx, psim, hh, btor, dpdx, dpdz, bpol
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
!      integer , EXTERNAL :: ifix
      real(kind=dp) , EXTERNAL :: valspl, terp2  ! , sqrt
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i

c
c
      jbd = 4
c
      call coeff2 (nxeqd, xeqd, nzeqd, zeqd, peqd, pxx, pzz, pxxzz,
     1   nxeqd, jbd, wkm)
c
      dpflx = 1./float(nxeqd - 1)
      feqdsp(:nxeqd,1) = feqd(:nxeqd)
      call cubspl (dpflx, feqdsp, nxa, nxeqd)
c
      do i = 1, nxeqd
         do j = 1, nzeqd
            psim = abs(peqd(i,j)/(psimag-psilim))
!            igrd = ifix(psim/dpflx) + 1
            igrd = int(psim/dpflx) + 1
            if (igrd <= nxeqd) then
               hh = psim - float(igrd - 1)*dpflx
               btor = valspl(hh,feqdsp,nxa,igrd,0)/xeqd(i)
            else
               btor = beqd*reqd/xeqd(i)
            endif
            dpdx = terp2(xeqd(i),zeqd(j),nxeqd,xeqd,nzeqd,zeqd,peqd,pxx,
     1         pzz,pxxzz,nxeqd,1,0)
            dpdz = terp2(xeqd(i),zeqd(j),nxeqd,xeqd,nzeqd,zeqd,peqd,pxx,
     1         pzz,pxxzz,nxeqd,0,1)
            bpol = sqrt(dpdx**2 + dpdz**2)/xeqd(i)
            bmod(i,j) = sqrt(btor**2 + bpol**2)
         end do
      end do
c
      return
      end subroutine modb
c
c
      subroutine profaxis(rn, expn1, expm1, dratio, rova)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:40   6/14/01
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh
      use Vcraylh
      use Vchpcsd
      use Vceqdsk
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real(kind=dp) rn, expn1, expm1, dratio, rova
C-----------------------------------------------
c---------------------------------------------------------------------
c    This subroutine rescales the density and temperature of the max-
c    wellian species from the input values to the profile-specified
c    values at rovera.  The input values are thus interpreted to be
c    axis values (rovera=0) and runs done sweeping through various
c    values of rovera are automatically synchronized with respect to
c    radial variations of background quantities.
c---------------------------------------------------------------------
      if (abs(dratio - 1.) < 1.E-12) then
         rn = 1.0
      else
         rn = dratio + (1.0 - dratio)*(1. - rova**expn1)**expm1
      endif
      return
      end subroutine profaxis
c
      subroutine profin
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:40   6/14/01
C...Switches: -p4 -yb
c
c ************ ************ ************ ************ ************
c
c      this subroutine initializes the density, temperature,
c      and poloidal/toroidal magnetic field tables, and
c      evaluates the coefficient for spline interpolation.
c      it is called once before proceeding to the integra-
c      tion of the ray equations for a given plasma.
c
c      independent variable for the profiles is the flux
c      variable psi, normalized so 0.le.psi.le.1.+(nprof-nprofs)*zdpsi
c      Also find poloidal flux function vs. psi (bh:032090)
c
c ************ ************ ************ ************ ************
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh
      use Vcraylh
      use Vchpcsd
      use Vceqdsk
      use Vcmnew
c     USE Vgrnout
      use Viogrl
      use Vctransp
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
      integer, parameter :: lamin0 = 101
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: lamin, j, k, j1, k1, n, l, i1, i2, j2, jj, jj1, jj2,
     1   jj3, i5, jmd, jmd1, jmd2, ij, i, nbmax, l1, ik, il, k2, k3, i3
     2   , i4
c ----   TKM    07/02
      integer :: nrho1, nrho2
      real(kind=dp) :: delr
      real(kind=dp), dimension(101) :: wwork1, wwork2, xrho
c -------------  07/02
      real(kind=dp), dimension(lamin0) :: flam
      real(kind=dp), dimension(2) :: bscur
      real(kind=dp), dimension(nions + 1) :: den1, dden1, tem1, ttem1,
     1    azi1, atm1
      real(kind=dp), dimension(nprofm) :: dbt1r, xwork, ywork
      real(kind=dp), dimension(nprofm,4) :: dumf
      real(kind=dp), dimension(nprofm) :: ajjtr, dcurr, pptot,
     1    ajdia, ajbsr
      real(kind=dp), dimension(nprofm) :: rnustar
      real(kind=dp), dimension(nprofm) :: drr, drt1, drt2, dbtp2, dbt3r
      real(kind=dp), dimension(2*nprofm - 1) :: denln
      real(kind=dp), dimension(3) :: zv, zl, zq, zs
      real(kind=dp) :: zpi, zflux, zdth, zdthx, zk3, zsint, zvint,
     1    zlint, zqint,
     1   zfacq, zfluxq, ztanq, ru, dpsifdra, dra, tneint, tteint, ttiint
     2   , ppint, btold, amu0, denlt, rbeta, abmax, bp1, dabm, alm1,
     3   dbtt, dlp, bt1, btt1, dlpbp, dbtp1, dv, dparb2, xrad1, bjtor,
     4   dbtdl, dbpdl, bdb1, fcir, fmks, rmajx, epsll, rstar, ratsgn,
     5   aibs, abjold, abjnew, pscur, fpfs, ratioj
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
!      integer , EXTERNAL :: ifix
      real(kind=dp) , EXTERNAL :: qsaf, valspl, simp
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95

c
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i

c
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c  7/30/91    T.K. Mau
c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1


c******      TKM   03/97, 09/99, 04/00, 06/00
c********************

c
c ************ ************ ************ ************ ************
c
c $$$$$$  TKM 10/91; 6/99; 2/00
!      parameter(lamin0=101)
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c
c ************ ************ ************ ************ ************
c
      data zpi/3.14159265359/
c $$$$$$$$$$$ Added by TK Mau on 10/26/91; 07/02
      data lamin/61/
      data nrho1/41/
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c
c ************ ************ ************ ************ ************
c
      istop = 0
c
c ************ ************ ************ ************
c  check the number of points in the profile
c ************ ************ ************ ************
c
      if (nprof < 11) then
         write (iout, 9999) nprof
         istop = 1
         return
      endif
      if (nprof > nprofn) then
c
         write (iout, 9999) nprof
 9999    format('0',5x,"n. of points in the profile =",i4,
     1      " too large or too small for proper use")
         istop = 1
         return
c
      endif
c
c ************ ************ ************ ************ ************
c  transfer of the profiles for density & temperatures
c     to the tables for cubic interpolation
c ************ ************ ************ ************ ************
c
c**bh**      dpsi = 1./float(nprof-1)
      dpsi = ppsi(nprof)/float(nprof - 1)
      zflux = ppsi(nprof)
c***********************             SCC  12/12/95
      denc = pne(1)
      tempec = pte(1)
c        ztmpic = pti(1)
      if (nprof > nprofn) stop
c**bh**  tpsi(j) = ppsi(j)/zflux
      tpsi(:nprof) = ppsi(:nprof)
      tne(:nprof,1) = pne(:nprof)
      tte(:nprof,1) = pte(:nprof)
      tti(:nprof,1,:nspec) = pti(:nprof,:nspec)
      tni(:nprof,1,:nspec) = pni(:nprof,:nspec)
      tconc(:nprof,1,:nspec) = conc(:nprof,:nspec)
      tvlp(:nprof,1) = elp_tr(:nprof)
c$$$$$$    TKM   11/98
      ttani(:nprof,1) = tani(:nprof)
C******************************
c $$$$$$  Added by TK Mau on 10/30/91.
      if (ieqdsk == 0) then
         do j1 = 1, nprof
            ppra(j1,1) = 1.0
            ppra(j1,1) = ppra(j1,1) + sum(conc(j1,:nspec)*pti(j1,:nspec)
     1         /pte(j1))
            ppra(j1,1) = 1.6022E-10*pne(j1)*pte(j1)*ppra(j1,1)
         end do
      endif
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

c*****************************************************************
c  cubic spline interpolation of the profiles
c*****************************************************************
c
      call cubspl (dpsi, tne, nprofn, nprof)
      call cubspl (dpsi, tte, nprofn, nprof)
c------------------------SCC   4/23/96
      call cubspl (dpsi, tzeff, nprofn, nprof)
c--------------------------
c$$$$$$     TKM   11/98
      call cubspl (dpsi, ttani, nprofn, nprof)
      do k = 1, nspec
         call cubspl (dpsi, tti(1,1,k), nprofn, nprof)
         call cubspl (dpsi, tni(1,1,k), nprofn, nprof)
         call cubspl (dpsi, tconc(1,1,k), nprofn, nprof)
      end do

c***************************************************************
c  Required magnetic geometry is calculated in subroutine fiteqdsk
c  when ieqdsk.ge.3
c*****************************************************************
c
      if (ieqdsk < 3) then

c***************************************************************

c  specific volume of the magnetic surfaces
c  poloidal magnetic field and safety factor
c  volume(j) = volume element associated with tpsi(j)  (m**3)
c  zsurf(j)  = cross-sectional area element assoc]ated with tpsi(j) (m**2)
c  zlamb(j) = Eq 5.22 of IPP4/210
c  zqfac(j) = q(tpsi(j))/(B_T/B_p(tpsi(j)),  Eq 5.26
c***************************************************************
         zdth = zpi/200.
         zdthx = 2.*zdth/3.
c     ukzero is 2*pi/(free space wavenumber)  (m**-1)
         zk3 = ukzero**3
c     Loop over radial flux surfaces:
         do j = 2, nprof
            psi = tpsi(j)
            zsint = 0.
            zvint = 0.
            zlint = 0.
            zqint = 0.
            theta = 0.
            call coords
c     aj= J*ukzero**2; urhs=R*ukzero;  antau=N_tau*ukzero
            zs(3) = aj
            zv(3) = urhs*aj
            zl(3) = antau*antau/(aj*urhs)
            zq(3) = aj/urhs
c     Integrate over poloidal angle:
            do n = 1, 100
               zs(1) = zs(3)
               zv(1) = zv(3)
               zl(1) = zl(3)
               zq(1) = zq(3)
               do l = 2, 3
                  theta = theta + zdth
                  call coords
                  zs(l) = aj
                  zv(l) = urhs*aj
                  zl(l) = antau*antau/(aj*urhs)
                  zq(l) = aj/urhs
               end do
               zsint = zsint + zs(1) + 4.*zs(2) + zs(3)
               zvint = zvint + zv(1) + 4.*zv(2) + zv(3)
               zlint = zlint + zl(1) + 4.*zl(2) + zl(3)
               zqint = zqint + zq(1) + 4.*zq(2) + zq(3)
            end do
            volume(j) = 2.*zpi*zvint*dpsi*zdthx/zk3
            zsurf(j) = zsint*dpsi*zdthx/ukzero**2
            zlamb(j) = zlint*uraxmag*zdthx/(2.*zpi)
            zqfac(j) = zqint*zdthx/(2.*zpi*urplas)
         end do
         volume(1) = volume(2)/3.
c
c     zcurr(j) = I(tpsi(j))  Eq 5.20 of IPP4/210
c     pjavg(j) = current density at tspi(j)  (amps/m**2)
c     tqr(j,1)   = B_p(tpsi(j))/B_T   Eq 5.21
c     pqr(j,1)   = q(tpsi(j))    Eq 5.26
         zcurr(1) = 0.
         do j = 2, nprof
            zcurr(j) = zcurr(j-1) + 0.5*(zsurf(j-1)*pjavg(j-1)+zsurf(j)*
     1         pjavg(j))
         end do
         zcurr(2:nprof) = tcurr*zcurr(2:nprof)/zcurr(nprof)
         tqr(2:nprof,1) = 2.E-7*zcurr(2:nprof)/(rplasm*baxis*zlamb(2:
     1      nprof))
         pqr(2:nprof,1) = abs(zqfac(2:nprof)/tqr(2:nprof,1))
         tqr(1,1) = 0.
         pqr(1,1) = pqr(2,1)

c***********************************************************************
c   If isafa.ne.0., then using a q-profile input thru function qsaf,
c   reset pqr, tqr, zcurr, pjavg, and tcurr
c***********************************************************************
c--------SCC 8/18/94  add isafa in curray.v
c     if (qsafa.ne.0.0)  then
         if (isafa /= 0) then
            do j = 1, nprof
               pqr(j,1) = qsaf(tpsi(j))
               tqr(j,1) = btsign*zqfac(j)/pqr(j,1)
               zcurr(j) = 0.5E7*(urplas/ukzero)*zlamb(j)*tqr(j,1)*baxis
            end do
            tcurr = zcurr(nprofs)
            pjavg(2:nprofs) = (zcurr(2:nprofs)-zcurr(:nprofs-1))/dpsi/(
     1         0.5*(zsurf(2:nprofs)+zsurf(:nprofs-1)))
            pjavg(1) = 1.5*pjavg(2) - 0.5*pjavg(3)
            do j = nprofs, 2
               pjavg(j) = 0.5*(pjavg(j-1)+pjavg(j))
            end do
            if (nprof > nprofs) then
               pjavg(nprofs+1:nprof) = 0.0
            endif
         endif

c*****************************************************************
c  cubic spline interpolation of the profiles
c*****************************************************************
c
         call cubspl (dpsi, tqr, nprofn, nprof)
         call cubspl (dpsi, pqr, nprofn, nprof)
c

c****************************************************************
c  (Poloidal magnetic flux)/(2*pi) as a function of psi
c  (Formula derived from Brambilla notes for integral(B.dS_theta))
c****************************************************************
         tpsif(1,1) = 0.0
         do j = 2, nprof
            theta = zpi
            psi = 0.5*(tpsi(j-1)+tpsi(j))
            call coords
!            left = ifix(psi/dpsi) + 1
            left = int(psi/dpsi) + 1
            hh = psi - tpsi(left)
            tpsif(j,1) = tpsif(j-1,1) + valspl(hh,tqr,nprofn,left,0)*
     1         baxis*uraxmag*urplas/ukzero**2*dpsi
         end do

c     Renormalize tpsif to be neg. (max. abs value) at the
c     magnetic axis, and zero at the plasma boundary.
         tpsisav = tpsif(nprofs,1)
         tpsif(:nprof,1) = tpsif(:nprof,1) - tpsisav

         call cubspl (dpsi, tpsif, nprofn, nprof)
c
      endif
c
c  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c   Modified by T.K. Mau on July 30, 1991.
c   To set up spline fit for equivalent inverse aspect ratio, epsilon,
c    as a function of psi, or flux surface half-diameter at midplane.
c   This is used to account for neoclassical degradation of current
c    drive efficiency.
c
c     if(idrive.eq.0) return
      if (idrive /= 0) then
         epsl(1,1) = 0.
         binbd(1,1) = abs(baxis)
         if (ieqdsk <= 2) then
            do i1 = 2, nprof
               psi = ppsi(i1)
               do j1 = 1, 2
                  if (j1 == 1) then
                     theta = 0.
                  else
                     theta = zpi
                  endif
                  call coords
                  zfacq = urplas*antau/aj
                  zfluxq = valspl(0.,tqr,nprofn,i1,0)
                  ztanq = zfacq*zfluxq
                  acostq = btsign/sqrt(1. + ztanq*ztanq)
                  btor = baxis*uraxmag/urhs
                  btot = btor/acostq
                  if (j1 == 1) then
                     boutb = btot
                  else
                     binb = btot
                     binbd(i1,1) = binb
                  endif
               end do
               epsl(i1,1) = (binb - boutb)/(binb + boutb)
            end do
         else
            do i2 = 2, nprof
               psi = ppsi(i2)
c     binb = -1.0e12
c     boutb = 1.0e12
c     delan = zpi/float(lamin-1)
c     do 123 j2 = 1,lamin
c        theta = delan*float(j2-1)
               do j2 = 1, 2
                  if (j2 == 1) then
                     theta = 0.
                  else
                     theta = zpi
                  endif
                  call coords
                  ru = xu + raxmag
                  btor = fra(i2,1)/ru
                  dpsifdra = valspl(0.,tpsif,nprofn,i2,1)
                  bpol = dpsifdra*antau/(aj*ru)*ukzero
                  btot = sqrt(btor**2 + bpol**2)
c     if(btot.gt.binb) binb = btot
c     if(btot.lt.boutb) boutb = btot
                  if (j2 == 1) then
                     boutb = btot
                  else
                     binb = btot
                     binbd(i2,1) = binb
                  endif
               end do
               binbd(i2,1) = binb
               epsl(i2,1) = (binb - boutb)/(binb + boutb)
            end do
         endif
         call cubspl (dpsi, epsl, nprofn, nprof)
         call cubspl (dpsi, binbd, nprofn, nprof)
      endif
c     $$$$  Added by TK Mau on 10/13/92 for ARIES studies
c ---- Calculate n_e0/<n_e>, T_e0/<T_e>, T_e0/<T_e0>n, and p_0/<p>.
      dra = 1./float(nprofs - 1)
      volpla(1) = 0.
      do jj = 1, nprofs
         xwork(jj) = volume(jj)/dra
         ywork(jj) = tne(jj,1)*xwork(jj)
         if(jj>1)volpla(jj)=volpla(jj-1)+0.5*(volume(jj)+volume(jj-1))
      end do
      volpla(nprofs) = simp(nprofs,dra,xwork)
      tneint = simp(nprofs,dra,ywork)/denc
      ywork(:nprofs) = tte(:nprofs,1)*xwork(:nprofs)
      tteint = simp(nprofs,dra,ywork)/tempec
      ywork(:nprofs) = tte(:nprofs,1)*tne(:nprofs,1)*xwork(:nprofs)
      ttiint = simp(nprofs,dra,ywork)/(tempec*denc)
      ywork(:nprofs) = ppra(:nprofs,1)*xwork(:nprofs)
      ppint = simp(nprofs,dra,ywork)
      pavtne = volpla(nprofs)/tneint
      pavtte = volpla(nprofs)/tteint
      pavtti = tneint/ttiint
      pavpp = ppra(1,1)*volpla(nprofs)/ppint
c$$$$$      TKM   2/00
c  Recalculate plasma beta based on assumed n and T profiles
      if (alpte>0. .and. alpene>0.) then
         do k1 = 1, nprofs
            pptot(k1) = tne(k1,1)*tte(k1,1)
            pptot(k1)=pptot(k1)+sum(tni(k1,1,:nspec)*tti(k1,1,:nspec))
            pptot(k1) = 1.6022E-16*pptot(k1)
         end do
         xwork(1) = 0.
         ywork(1) = 0.
         xwork(2:nprofs) = volume(2:nprofs)/dra
         ywork(2:nprofs) = pptot(2:nprofs)*xwork(2:nprofs)
         btold = beta
         amu0 = zpi*4.E-7
         beta = 2.E6*amu0*simp(nprofs,dra,ywork)/beqd**2/simp(nprofs,dra
     1      ,xwork)
         betap = betap*beta/btold
      endif
c  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c**************    TKM   2/97, 2/00
c     Calculate |B_tor| and |B_p| along equatorial plane.
c     Also calculate line-averaged density along equatorial plane
      rmd(nprof) = raxmag
      btmd(nprof) = abs(baxis)
      bpmd(nprof) = 0.
      btpmd(nprof) = btmd(nprof)
      denln(nprof) = tne(nprof,1)
      do jmd = 1, nprof - 1
         jmd1 = nprof - jmd + 1
         jmd2 = 2*nprof - jmd
         rmd(jmd) = xcontr(48,jmd1)
         btmd(jmd) = abs(fra(jmd1,1))/rmd(jmd)
         bpmd(jmd) = bpcontr(48,jmd1)
         rmd(jmd2) = xcontr(3,jmd1)
         btmd(jmd2) = abs(fra(jmd1,1))/rmd(jmd2)
         bpmd(jmd2) = bpcontr(3,jmd1)
         btpmd(jmd) = sqrt(btmd(jmd)**2+bpmd(jmd)**2)
         btpmd(jmd2) = sqrt(btmd(jmd2)**2+bpmd(jmd2)**2)
         denln(jmd) = tne(jmd1,1)
         denln(jmd2) = tne(jmd1,1)
      end do
      denlt = 0.
      denlt = dot_product(0.5*(denln(:2*(nprof-1))+denln(2:2*nprof-1)),
     1   rmd(2:2*nprof-1)-rmd(:2*(nprof-1)))
      denlav = denlt/(rmd(2*nprof-1)-rmd(1))
c*************************
c $$$$    TK Mau 4/13/94; 7/95, 04/00
      rbeta = 1.
      if (kalfa > 0) then
         if (irayio == 0) then
c     if(irayio.gt.0) then
c     do 385 k = 1,nalfa
c$$$$$Source rate given in /cm**3/s for bmpwr(MW), ebkev(kV), and
c     volpla(m**3).
c     consbm = 6.241e15*bmpwr(k)/(ebkev(k)*azf(k)*volpla(nprofs))
c     do 386 j = 1,nprofs
c 386 pnfi(k,j) = consbm*pnfi(k,j)
c 385 continue
c     else
c ----    TKM    07/02
            if(idmpsw > 3) then
            open(8, file='snowmass.in', status='old')
            nrho2 = nrho1-1
c----- Read in normalized toroidal flux coordinates
            read(8,*) xrho(:nrho2)
            do i = nrho1,2,-1
               xrho(i) = xrho(i-1)
            enddo
            xrho(1) = 0.
c----- Read in fast alpha density and energy, 
c      and convert energies to isotropic Maxwellian temperatures
               read(8,*) wwork1(:nrho2)
               wwork1(nrho1) = 2.*wwork1(nrho2)-wwork1(nrho2-1)
               delr = 1./float(nprofs-1)
               do i = 1,nprofs
                  ra(i) = float(i-1)*delr
               enddo
               call intrpp('zero','free',xrho,wwork1,nrho1,ra,denfa,
     &                     nprofs)
               read(8,*) wwork1(:nrho2)
               read(8,*) wwork2(:nrho2)
               wwork1(:nrho2) = wwork1(:nrho2)+wwork2(:nrho2)
               wwork1(nrho1) = 2.*wwork1(nrho2)-wwork1(nrho2-1)
               call intrpp('zero','free',xrho,wwork1,nrho1,ra,wwork2,
     &                     nprofs)
               eav(:nprofs) = 4.160945e15*wwork2(:nprofs)/
     &                          denfa(:nprofs)
            else
               call alpress
            endif
c--------------- 07/02
            rbeta = 1./(1 - betaf/beta)
c     rbeta = 1.0
            do i = 1, nprof
               pnfi(:nalfa,i) = denfa(i)
               ptfi(:nalfa,i) = eav(i)
            end do
         endif
         do k = 1, nalfa
            dumf(:nprof,1) = pnfi(k,:nprof)/pnfi(k,1)
            call cubspl (dpsi, dumf, nprofn, nprof)
            tnf(k,:nprof,:) = dumf(:nprof,:)
            dumf(:nprof,1) = ptfi(k,:nprof)/ptfi(k,1)
            call cubspl (dpsi, dumf, nprofn, nprof)
            ttf(k,:nprof,:) = dumf(:nprof,:)
         end do
      endif
c
c  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c
c $$$$$$   Added by TK Mau on 10/25/91.
c      Calculate bootstrap current profile based on Hirshman-Sigmar
c       model
c
      if (ieqdsk < 3) return
      if (kboot == 0) return
      ajbsb(1) = 0.
      ajbst(1) = 0.
      ftrp(1) = 0.
      ajjtr(1) = 0.
      bttra(1) = baxis
c     ajtb(1) = -fra(1,1)*ppra(1,2)-7.958e5*fra(1,2)*
      ajtb(1)=(-fra(1,1)*ppra1(1,1)/presfr)-7.958E5*fra1(1,1)*baxis**2
c     ajtb(1) = ajtb(1)/dpsifra(1)
c  $$$$   TK Mau 9/3/92
      dbt1(1) = abs(baxis)
      dbt1r(1) = baxis**2/fra(1,1)
      dbt2(1) = baxis*baxis
      ajtrb(1) = ajtb(1)
c $$$$$$  TK Mau  12/6/94
      ajdit(1) = 0.
      ajdia(1) = 0.
      pptot(1) = ppeqd(1)
c----    TK Mau    5/02
      ajtor(1) = (-ppra1(1,1)/presfr*raxmag) - 7.958E5*fra(1,1)*
     &   fra(1,2)/dpsifra(1)/raxmag
c------------
c     ajtor(1) = -ppra(1,2)/presfr*raxmag-7.958e5*fra(1,1)*
c    &     fra(1,2)/raxmag
c     ajtor(1) = ajtor(1)/dpsifra(1)
c $$$$$$$$$$$$$
c  $$$$$$$$$
c ---- First calculate the ratio of trapped to circulating particles
c       for each flux surface
      do k1 = 2, nprofs
         nbmax = (nptsd - 1)/2 + 1
         abmax = fra(k1,1)/xcontr(nbmax,k1)
c $$$$  Added by TK Mau on 12/2/91
         bp1 = bpcontr(nbmax,k1)
         abmax = 1./sqrt(abmax**2 + bp1**2)
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
         dabm = abmax/float(lamin - 1)
         do l1 = 1, lamin
            alm1 = float(l1 - 1)*dabm
c     if(l1.eq.1) alm1 = 1.e-4*dabm
            dbtt = 0.
            do ij = 4, nptsd - 2
               dlp = ((xcontr(ij,k1)-xcontr(ij-1,k1))**2+(zcontr(ij,k1)-
     1            zcontr(ij-1,k1))**2)**0.5
               bp1 = 0.5*(bpcontr(ij,k1)+bpcontr(ij-1,k1))
               bt1 = 2.*fra(k1,1)/(xcontr(ij,k1)+xcontr(ij-1,k1))
               btt1 = sqrt(bp1*bp1 + bt1*bt1)
               btt1 = abs(btt1)
               dlpbp = dlp/bp1
               if(1.-alm1*btt1>0.)dbtt=dbtt+sqrt(1.-alm1*btt1)*dlpbp
            end do
            flam(l1) = alm1/dbtt
         end do
         dbt1(k1) = 0.
         dbt1r(k1) = 0.
c $$$$$  TK Mau  12/6/94
c     ajdit(k1) = 0.
c $$$$$$$$$$$$$$$
         dbt2(k1) = 0.
c     dbor(k1) = 0.
         dbtp1 = 0.
         dv = 0.
c  $$$$  TK Mau  9/92;  6/99,  05/02
         ajtor(k1) =0.              ! 05/02
         dparb2 = 0.
         dbtp2(k1) = 0.
         drr(k1) = 0.
         drt1(k1) = 0.
         drt2(k1) = 0.
         ajjtr(k1) = 0.
         do ik = 4, nptsd - 2
            dlp = ((xcontr(ik,k1)-xcontr(ik-1,k1))**2+(zcontr(ik,k1)-
     1         zcontr(ik-1,k1))**2)**0.5
            xrad1 = 0.5*(xcontr(ik,k1)+xcontr(ik-1,k1))
            bt1 = fra(k1,1)/xrad1
            bp1 = 0.5*(bpcontr(ik,k1)+bpcontr(ik-1,k1))
            btt1 = sqrt(bp1*bp1 + bt1*bt1)
            dlpbp = dlp/bp1
            dbt1(k1) = dbt1(k1) + btt1*dlpbp
            dbt1r(k1) = dbt1r(k1) + bt1/xrad1*dlpbp
            drr(k1) = drr(k1) + xrad1*dlpbp
            drt1(k1) = drt1(k1) + dlpbp/xrad1
            drt2(k1) = drt2(k1) + dlpbp/xrad1**2
            dbtp2(k1) = dbtp2(k1) + bt1**2*dlpbp
            dbt3r(k1) = dbt3r(k1) + (bp1/btt1)**2*dlpbp
            dbt2(k1) = dbt2(k1) + btt1**2*dlpbp
c     dbor(k1) = dbor(k1)+bt1/xrad1*dlpbp
            dbtp1 = dbtp1 + bt1*dlpbp
c           bjtor = (-ppra1(k1,1)/presfr) - 
c    &              7.957747E5*fra(k1,1)*fra1(k1,1)/xrad1**2
            bjtor = (-ppra1(k1,1)/presfr) 
     &              - 7.957747E5*fra(k1,1)*fra(k1,2)/dpsifra(k1)
     1              /xrad1**2                         !  j_tor/R
c     bjtor = -ppra(k1,2)-7.958e5*fra(k1,1)*fra(k1,2)/xrad1**2
            ajjtr(k1) = ajjtr(k1) + bjtor*dlpbp  ! <j_tor/R>*dv
c                                                ! <j_tor>*dv
            ajtor(k1) = ajtor(k1) + bjtor*xrad1*dlpbp
            dv = dv + dlpbp
c ---- Calculate <b.grad B>/<B**2>  --  dparb2
            dbtdl = fra(k1,1)*(1./xcontr(ik,k1)-1./xcontr(ik-1,k1))/dlp
            dbpdl = (bpcontr(ik,k1)-bpcontr(ik-1,k1))/dlp
            bdb1 = bp1/btt1*2*(bp1*dbpdl + bt1*dbtdl)
            dparb2 = dparb2 + bdb1**2*dlpbp
c ------
         end do
c ---- Calculate <j.B>, <B>, <B**2>, <B_tor>
c     ajtb(k1) = -fra(k1,1)*ppra(k1,2)-7.958e5*fra(k1,2)*
         ajtb(k1) = (-fra(k1,1)*ppra1(k1,1)/presfr) - 7.958E5*fra1(k1,1)
     1      *dbt2(k1)/dv
c     ajtb(k1) = ajtb(k1)/dpsifra(k1)
         dparb2 = dparb2/dbt2(k1)
         dbt1(k1) = dbt1(k1)/dv                  ! <B>
         dbt1r(k1) = dbt1r(k1)/dv                ! <B_tor/R>
         dbt2(k1) = dbt2(k1)/dv                  ! <B**2>
c     dbor(k1) = dbor(k1)/dv
         bttra(k1) = dbtp1/dv                    ! <B_tor>
         drr(k1) = drr(k1)/dv                    ! <R>
         drt1(k1) = drt1(k1)/dv                  ! <1/R>
         drt2(k1) = drt2(k1)/dv                  ! <1/R**2>
         dbtp2(k1) = dbtp2(k1)/dv                ! <B_tor**2>
         ajtor(k1) = ajtor(k1)/dv                ! <j_tor>
         ajdit(k1) = (-drr(k1)) + drt1(k1)/drt2(k1)*dbtp2(k1)/dbt2(k1)
c     ajjtr(k1) = ajjtr(k1)*dpsifra(k1)
         fcir = 0.75*dbt2(k1)*dv*simp(lamin,dabm,flam)
c $$$$$$$$$$
         ftrp(k1) = (1. - fcir)/fcir
c ---- This part is related to computing the bootstrap current density
c      Preparing input parameters for CKBOOT
         den1(:nspec) = (1.E6*aconc(:nspec))*tne(k1,1)*rbeta
         tem1(:nspec) = 1.E3*tti(k1,1,:nspec)
         dden1(:nspec) = (1.E6*aconc(:nspec))*tne(k1,2)/dpsifra(k1)*
     1      rbeta
         ttem1(:nspec) = 1.E3*tti(k1,2,:nspec)/dpsifra(k1)
         azi1(:nspec) = azi(:nspec)
         atm1(:nspec) = 1.6726E-27*atm(:nspec)
c     if(irayio.eq.0.and.nspec.gt.1) then
c     tem1(nspec) = 1.e3*ttif(k1,1)*tempic(nspec)
c     ttem1(nspec) = 1.e3*ttif(k1,2)*tempic(nspec)/dpsifra(k1)
c     endif
         den1(nspec+1) = 1.E6*tne(k1,1)*rbeta
         tem1(nspec+1) = 1.E3*tte(k1,1)
         dden1(nspec+1) = 1.E6*tne(k1,2)/dpsifra(k1)*rbeta
         ttem1(nspec+1) = 1.E3*tte(k1,2)/dpsifra(k1)
         azi1(nspec+1) = -1.0
         atm1(nspec+1) = 9.1095E-31
         fmks = fra(k1,1)
         rmajx = 0.5*(xcontr(3,k1)+xcontr(48,k1))
         epsll = 0.5*abs(xcontr(3,k1)-xcontr(48,k1))/rmajx
c     call ckboot(nspec+1,atm1,azi1,tem1,den1,ttem1,dden1,epsl(k1,1),
         call ckboot (nspec + 1, atm1, azi1, tem1, den1, ttem1, dden1,
     1      epsll, ftrp(k1), rmajx, pqr(k1,1), fra(k1,1), rstar, bscur(1
     2      ))
         rnustar(k1) = rstar
         ajbsb(k1) = -bscur(1)
         ratsgn = ajbsb(k1)/ajtb(1)
         if (ratsgn < 0.) ajbsb(k1) = -ajbsb(k1)
c ---- Calculate <j.B>_target.
         if (k1 == nprofs) ajbsb(k1) = 0.
         ajtrb(k1) = ajtb(k1) - ajbsb(k1)        !  A-T/m**2
         ajbsr(k1) = ajbsb(k1)/dbt1r(k1)
c $$$$$  TK Mau  12/6/94
c      Calculate plasma diamagnetic current density (A/m**2)
c                                                ! <j_dia,tor/R>*dv
         ajdia(k1) = -ppra1(k1,1)*(1. - dbtp2(k1)/dbt2(k1))*dv
         ajdit(k1) = ppra1(k1,1)*ajdit(k1)       ! <j_dia,tor>
         ywork(k1) = -ppra1(k1,1)*dbt3r(k1)
c $$$$$$$$$$$$$$$$$$$$$$$
      end do
c $$$$  Added by TK Mau on 4/14/92
      rnustar(1) = rnustar(2)
c $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c
c ---- Calculate total plasma and bootstrap currents, and the bootstrap
c      current fraction.
c
      aibs = 0.
      zcurr(1) = 0.
c$$$$$   TK Mau  12/6/94
      dcurr(1) = 0.
c$$$$$$$$$$$$$
c $$$$  TK Mau 9/3/92 ; 6/99
      abjold = 0.
      dra = 1./float(nprofs - 1)
      do i2 = 2, nprofs
         zcurr(i2) = zcurr(i2-1) + 0.5E-6*(ajjtr(i2)*dpsifra(i2)+ajjtr(
     1      i2-1)*dpsifra(i2-1))*dra
c     zcurr(i2) = zcurr(i2-1)+0.5e-6*(ajbsb(i2)/dbt1(i2)*zsurf(i2)
c    &            +ajbsb(i2-1)/dbt1(i2-1)*zsurf(i2-1))
c$$$$$    TK Mau   12/6/94
         dcurr(i2) = dcurr(i2-1) + 0.5E-6*(ajdia(i2)*dpsifra(i2)+ajdia(
     1      i2-1)*dpsifra(i2-1))*dra
c$$$$$$$$$$$$$$$$$$$
         abjnew = 2.*zpi*pqr(i2,1)*ajbsb(i2)*dpsifra(i2)/dbt2(i2)
c     abjnew = pqr(i2,1)*ajbsb(i2)/dbt2(i2)
         aibs = aibs + 0.5E-6*(abjnew + abjold)*dra
         abjold = abjnew
      end do
      ywork(1) = 0.
      xwork(:nprofs) = ajdia(:nprofs)*dpsifra(:nprofs)
      ywork(:nprofs) = ywork(:nprofs)*dpsifra(:nprofs)
      dcurr(nprofs) = 1.E-6*simp(nprofs,dra,xwork)
      pscur = 1.E-6*simp(nprofs,dra,ywork)
      ywork(:nprofs) = pqr(:nprofs,1)*ajbsb(:nprofs)*dpsifra(:nprofs)/
     1   dbt2(:nprofs)
      aibs = 2.*zpi*1.E-6*simp(nprofs,dra,ywork)
      tcurr = zcurr(nprofs)                      ! Equlibrium current
      fbsc = abs(aibs/tcurr)                     ! bootstrap fraction
c $$$$$  TK Mau  12/6/94
      fdia = dcurr(nprofs)/tcurr          ! diamagnetic current fraction
      fpfs = pscur/tcurr
c $$$$$$$$$$$
c ---- Define toroidal current density profile
c     call cubspl(dra,zcurr,nprofm,nprofs)
c     ajtor(1) = ajtb(1)/baxis
c     ajtrt(1) = ajtor(1)
      ajbst(1) = 0.
      ajtar(1) = ajtor(1)
c     ajtor(i3) = zcurr(i3,2)/zsurf(i3)*dra*1.e6
c     ajtor(i3) = ajtb(i3)*bttra(i3)/dbt2(i3)
c     ajtrt(i3) = ajtrb(i3)*bttra(i3)/dbt2(i3)   ! A/m**2
c     ajbst(i3) = ajbsb(i3)*bttra(i3)/dbt2(i3)    ! A/m**2
      ajbst(2:nprofs) = ajbsb(2:nprofs)*drt1(2:nprofs)*dbtp2(2:nprofs)/
     1   dbt2(2:nprofs)/dbt1r(2:nprofs)          ! <j_bs,tor>
      ajtar(2:nprofs) = ajtor(2:nprofs) - ajbst(2:nprofs) - ajdit(2:
     1   nprofs)                                 ! <j_tar,tor>
c ----   TKM   09/99
c ---- Calculate total seed current as function of radius
      aisdt(1) = 0.
      do j1 = 2, nprof
         aisdt(j1) = aisdt(j1-1) + 0.5E-6*(ajtar(j1)*zsurf(j1)+ajtar(j1-
     1      1)*zsurf(j1-1))
      end do
c -------------------------
c ---- Calculate seed and reverse current components
      j1 = 1
      i4 = 2
  190 continue
      aiseed(j1) = 0.
  191 continue
      aiseed(j1) = aiseed(j1) + 0.5E-6*(ajtar(i4)*zsurf(i4)+ajtar(i4-1)*
     1   zsurf(i4-1))
      i4 = i4 + 1
      if (i4 > nprofs) return
      ratioj = ajtar(i4)/ajtar(i4-1)
      if (ratioj < 0.) then
         j1 = j1 + 1
c ---- TKM   6/99
         if (j1 > 10) return
c -------------------
         go to 190
      else
         go to 191
      endif
c
      return
      end subroutine profin
c
c
      subroutine profix
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:40   6/14/01
C...Switches: -p4 -yb
c
c ************ ************ ************ ************ ************
c
c      this subroutine evaluates the local values of the
c      density, temperature, rotational transform, etc.,
c      required for integration of the ray equations,
c      using the spline interpolation initialized in profin.
c
c ************ ************ ************ ************ ************
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh
      use Vcraylh
      use Vchpcsd
      use Vceqdsk
      use Vcmnew
!      USE Vcmalfa
!      USE Vfwcd2
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i, k, j
      real(kind=dp), dimension(nprofm,4) :: dumf
      real(kind=dp) :: zfacq, zfluxq, ztanq, zcosq2, zdq, ff, dffp,
     1    dpsifdra,
     1   ddpsifra, ru, zfacb, dbpsi, dbth
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
!      integer , EXTERNAL :: ifix
      real(kind=dp) , EXTERNAL :: valspl
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95

c
c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i

c $$$$$$      TKM    04/00
c$$$$$$$     TKM    11/98
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c
c ************ ************ ************ ************ ************
c
!      left = ifix(psi/dpsi) + 1
      left = int(psi/dpsi) + 1
      hh = psi - tpsi(left)
      if (left > nprof) then
         left = nprof
         hh = 0.0
      endif
c
      dense = valspl(hh,tne,nprofn,left,0)
      derdne = valspl(hh,tne,nprofn,left,1)/max(dense,1.E-20_dp)
      tempe = valspl(hh,tte,nprofn,left,0)
      derte = valspl(hh,tte,nprofn,left,1)/max(tempe,1.E-20_dp)
      vloop = valspl(hh,tvlp,nprofn,left,0)
c------------------------SCC   4/23/96
      zeff = valspl(hh,tzeff,nprofn,left,0)
      if (alpene<0 .and. alpte<=0) trati(nion) = valspl(hh,ttani,nprofn,
     1   left,0)
c
      do i = 1, nspec
         densi(i) = valspl(hh,tni(1,1,i),nprofn,left,0)
         tempi(i) = valspl(hh,tti(1,1,i),nprofn,left,0)
         derdni(i) = valspl(hh,tni(1,1,i),nprofn,left,1)/max(densi(i),
     1      1.E-20_dp)
         derti(i) = valspl(hh,tti(1,1,i),nprofn,left,1)/max(tempi(i),
     1      1.E-20_dp)
         aconc(i) = valspl(hh,tconc(1,1,i),nprofn,left,0)
c          zeff=zeff+aconc(i)*azi(i)*azi(i)
      end do
      if (kalfa /= 0) then
         do k = 1, nalfa
            dumf(:nprof,:) = tnf(k,:nprof,:)
            densa(k) = pnfi(k,1)*valspl(hh,dumf,nprofn,left,0)
            densa(k) = max(0.0_dp,densa(k))
            dumf(:nprof,:) = ttf(k,:nprof,:)
            temsa(k) = ptfi(k,1)*valspl(hh,dumf,nprofn,left,0)
            if (temsa(k) < 0.) temsa(k) = 1.
         end do
      endif

c  ztanq = tan(cap_theta) * B_tau/B_phi (Eq. 5.24 of IPP 4/210).
      zfacq = urplas*antau/aj
      zfluxq = valspl(hh,tqr,nprofn,left,0)
      ztanq = zfacq*zfluxq
      zcosq2 = 1./(1. + ztanq*ztanq)
      acostq = btsign*sqrt(zcosq2)
      asintq = ztanq*acostq
c
c  dqpsi = d(cap_theta)/d(psi)
c  dqth  = d(cap_theta)/d(psi)

      zdq = ztanq*zcosq2
      dqpsi = zdq*(valspl(hh,tqr,nprofn,left,1)/zfluxq + dntaup - djp)
      dqth = zdq*(dntaut - djt)
c
      if (ieqdsk <= 2) then
c
         dompsi = (-dxpsi/urhs) + ztanq*dqpsi
         domth = (-dxth/urhs) + ztanq*dqth
c
         btor = baxis*uraxmag/urhs
         bpol = ztanq*btor
         btot = btor/acostq
c
      else
c
         ff = valspl(hh,fra,nprofn,left,0)
         dffp = valspl(hh,fra,nprofn,left,1)
         dpsifdra = valspl(hh,tpsif,nprofn,left,1)
         ddpsifra = valspl(hh,tpsif,nprofn,left,2)

         ru = xu + raxmag
         btor = ff/ru
         bpol = dpsifdra*antau/(aj*ru)*ukzero
         btot = sqrt(btor**2 + bpol**2)

         zfacb = ukzero**2*antau/(urhs*aj)

c  dbpsi = 1/btot * d(btot)/d(psi)
         dbpsi = 1./btot**2*(btor/ru*(dffp - ff*dxpsi/urhs) + zfacb**2*
     1      dpsifdra*ddpsifra + zfacb**2*((-dxpsi/urhs) + dntaup - djp)*
     2      dpsifdra**2)
         dbth = 1./btot**2*((-btor**2/urhs*dxth) + zfacb**2*((-dxth/urhs
     1      ) + dntaut - djt)*dpsifdra**2)

         dompsi = dbpsi + ztanq*dqpsi
         domth = dbth + ztanq*dqth

      endif
c
      return
      end subroutine profix

      function prone (psi)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:40   6/14/01
C...Switches: -p4 -yb
c--------------------- ----------------------------------
c analytic fit to the electron density profile
c--------------------- ----------------------------------
c  ******  c ---old---  data       pint  /3.0/,       pext /2.3/
c  ******               data       pint  /2.0/,       pext /1./
c  ******  c--------------------- ----------------------------------
c  ******           prone = 0.1 + 0.9*((1.-psi**pint)**pext)
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh
!      use Vcraylh
!      use Vchpcsd
!      use Vceqdsk
!      use Vcmnew
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real(kind=dp) prone
      real(kind=dp) psi
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c     dimension acoef(4)
c
c--------------------------------------------------------------------
c shot 26468
c     data acoef /-1.87, -0.57, -24.78, -181.38/
c--------------------------------------------------------------------
c     x=rplasm*psi
c     x2=x*x
c     arg = acoef(4)
c     do 10  i=1,3
c10   arg=arg*x2 + acoef(4-i)
c     prone = exp(arg)
c     prone = denedg + (denc-denedg)*(1.-psi**gamene)**alpene
c**************    TKM    2/97
c     print *, 'In function prone'
c     print *, 'In psi     = ',psi
c     print *, 'In denc    = ',denc
c     print *, 'In denedg  = ',denedg
c     print *, 'In frcne   = ',frcne
c     print *, 'In alpene  = ',alpene
c     print *, 'In alpene1 = ',alpene1
c     print *, 'In gamene  = ',gamene
c     print *, 'In gamene1 = ',gamene1
      prone = denc*(denedg + (1. - denedg)*(frcne*(1. - psi**gamene)**
     1   alpene + (1. - frcne)*(1. - psi**gamene1)**alpene1))
c*********************************
      return
      end function prone
c
      subroutine prontp
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:40   6/14/01
C...Switches: -p4 -yb
c
c-------------------
c   From pressure profile ppra(1:nprofs) calculate
c   electron density profile pne(1:nprofs)
c   electron temperature profile pte(1:nprofs)
c   ion temperature profile  pti(1:nprofs)
c  Also input:
c       atomic wts  atm(1:nion)
c       charges     azi(1:nion)
c       concentration aconc(1:nion)
c       (Note:  conci(1:nion)=aconc(1:nion)*azi(1:nion))
c       central electron density    denc
c       z-effective        zeff
c     nprim   No. primary ion species
c     nimp    No. impurity species
c-------------------------------------
c*************  TKM  2/97, 8/98, 2/00
c Add input: ffast=fast pressure fraction
c            tite=ratio of Ti to Te
c All species have same n and T profiles, but n.ne.T
c     Seven options for profile specifications:
c     1. input: alpte = 0, alpene = 0, denc
c        profile: n=T=sqrt(p)
c        Given ne0 and Te0=0, calculate Te0 from p0,
c        and vice versa.
c     2. input: alpte > 0, alpene = 0
c        Given Te and Ti/Te, calculate n from p
c     3. input: alpene > 0, alpte = 0
c        Given n, Ti/Te, calculate Te from p
c     4. input: alpte < 0, alpene = 0,  gamene .ne. 0
c        Thermal plasma and beam profiles are separately given as
c        functions of rho in ONETWO output file.
c     5. input: alpte = 0, alpene < 0
c        Thermal plasma and beam profiles are given in TRANSP output
c        file given by Petty (GA). Input file : transp_ga.out
c     6. input: alpte < 0, and alpene < 0
c        Thermal plasma profiles and loop voltages are transfered from
c        TRANSP as functions of rho.
c     7. input: alpte > 0, alpene > 0
c        n and T profiles not necessarily consistent with p profile
c        Used for exploring initial HHFW results on NSTX
c     8. input: alpte > 0, alpene > 0, gamene < 0
c        Same as 7, except profile is given as function of r/a,
c        where r is half-radius, with gamene = |gamene|.
c     9. input: alpte < 0, alpene = 0,  gamene = 0
c        Electron temperature and density profiles are separately
c        given as functions of psi in output file, nstx.out.
c        For NSTX analysis (2001 Research Forum)
c**************************************
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
      use Vparam
      use Viorlh
      use Vcraylh
      use Vchpcsd
      use Vceqdsk
      use Vcmnew
      use Vctransp
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
      integer, parameter :: ngd0 = 101
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer::nrho1,i,j,iu,ir,ii,l,nrho,ji,ij,ix,nai,nzi,ihm,iy,k
      integer::nrho2
      real(kind=dp), dimension(201) :: pwork
      real(kind=dp), dimension(nxa) :: qeqd1
      real(kind=dp), dimension(nprofm) :: qeqd2
      real(kind=dp), dimension(nxa) :: raa
      real(kind=dp), dimension(ngd0) :: xrho, yne, yte
      real(kind=dp), dimension(ngd0,nions) :: yni, yti
      real(kind=dp), dimension(ngd0) :: wwork1, wwork2, wwork3
      real(kind=dp) :: hconc, sum, sumx, draa, dra, file, status
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      real(kind=dp) , EXTERNAL :: prote, prone
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95

c  Storage related to EQDSK:
c  Units used in the EQDSK are entirely MKSA.
c  Comeqdsk-->ceqdsk.i

c********************************************
c  6/26/91,  Latest update: 06/02/00
c     Comnew
cNew common added for FWCD
c  Storage related to FWCD:
cSubroutines displh inital use Comnew1


c******      TKM   03/97, 09/99, 04/00, 06/00
c********************

c
c----------------------
c************    TKM     06/97, 11/98
c ************ ************ ************ ************ ************
c
c$$$$$$    TKM    11/98
      data nrho1/41/
      data hconc/0.02/
c
c     Set default value of thermal anisotropy  to unity.
      ppra(:nprofs,1) = max(1.E-6_dp,ppra(:nprofs,1))
      tani(:nprofs) = 1.0
      pwork(:nprofs) = ppra(:nprofs,1)/ppra(1,1)
c
c     Set default value of thermal anisotropy  to unity.
      nion = nprim + nimp
c     do i=1,nprofs
c       tne(i,1)=sqrt(pwork(i))
c       tte(i,1)=tne(i,1)
c       do j=1,nion
c         tti(i,1,j)=tne(i,1)
c       enddo
c     end do
c-------------
c    from denc and ppra(1) find
c   tempec,tempic(1:nion)
c--------------------
      conci(:nion) = aconc(:nion)*azi(:nion)
      sum = 0.
      do i = 1, nion
         sum = sum + conci(i)
      end do
      conci(:nion) = conci(:nion)/sum
      aconc(:nion) = conci(:nion)/azi(:nion)
c       do j=1,nprofs
c         tni(j,1,i)=tne(j,1)*aconc(i)
c       enddo
c------------------
c  total number density
c-------------------
c$$$$    TK Mau   6/98
      sum = 0.
      sumx = 0.
      do i = 1, nion
         sum = sum + aconc(i)
         sumx = sumx + aconc(i)*tite(i)*(1. + 2.*trati(i))/3.
      end do
c     dentot=denc*(1.+sum)
c*******    TKM    8/98
      if (alpte<0. .or. alpene<0.) go to 100
c****************  TKM   2/97
      if (alpte==0. .and. alpene==0.) then
         do i = 1, nprofs
            tne(i,1) = sqrt(pwork(i))
            tte(i,1) = (1. - temedg)*tne(i,1) + temedg
            tne(i,1) = (1. - denedg)*tne(i,1) + denedg
            tti(i,1,:nion) = tne(i,1)
            tni(i,1,:nion) = tne(i,1)*aconc(:nion)
         end do
         if (tempec < 1.E-10) then
            tempec = (1. - ffast)*ppra(1,1)/(1.6022E-10*denc*(1. + sum))
         else
            denc=(1.-ffast)*ppra(1,1)/(1.6022E-10*tempec*(1.+sumx))
         endif
      else
         if (alpte>0. .and. alpene==0.) then
            do i = 1, nprofs
               psi = float(i - 1)/float(nprofs - 1)
               tte(i,1) = prote(psi)/tempec
            end do
            if (kboot == 2) then
               draa = 1./float(nxeqd - 1)
               do iu = 1, nxeqd
                  raa(iu) = float(iu - 1)*draa
                  qeqd1(iu) = prote(raa(iu))/tempec
               end do
               dra = 1./float(nprofs - 1)
               do ir = 1, nprofs
                  ra(ir) = float(ir - 1)*dra
               end do
               call intrpp ('zero', 'zero', tpsieqd, qeqd1, nxeqd, ra,
     1            qeqd2, nprofs)
               tte(:nprofs,1) = qeqd2(:nprofs)
            endif
            do i = 1, nprofs
               tne(i,1) = (1. - denedg)*pwork(i)/tte(i,1) + denedg
c              tti(i,1,j)=proti(psi)/tempic(j)
c********    TKM    06/97
c    For now, only allow same Te and Ti, and same ne and ni profiles
               tti(i,1,:nion) = tte(i,1)
c***************************
               tni(i,1,:nion) = tne(i,1)*aconc(:nion)
            end do
            denc=(1.-ffast)*ppra(1,1)/(1.6022E-10*tempec*(1.+sumx))
         endif
         if (alpte==0. .and. alpene>0.) then
c           denc = denc*(1. - ffast)
            do i = 1, nprofs
               psi = float(i - 1)/float(nprofs - 1)
               tne(i,1) = prone(psi)/denc
            end do
            if (kboot == 2) then
               draa = 1./float(nxeqd-1)            !   TKM 05/02
               do iu = 1, nxeqd
                  raa(iu) = float(iu - 1)*draa
                  qeqd1(iu) = prone(raa(iu))/denc
               end do
               dra = 1./float(nprofs - 1)
               do ir = 1, nprofs
                  ra(ir) = float(ir - 1)*dra
               end do
               call intrpp ('zero', 'zero', tpsieqd, qeqd1, nxeqd, ra,
     1            qeqd2, nprofs)
               tne(:nprofs,1) = qeqd2(:nprofs)
            endif
            do i = 1, nprofs
               tte(i,1) = (1. - temedg)*pwork(i)/tne(i,1) + temedg
c*****    (Te,Ti) and (ne,ni) have same profiles
               tti(i,1,:nion) = tte(i,1)
               tni(i,1,:nion) = tne(i,1)*aconc(:nion)
            end do
            tempec=(1.-ffast)*ppra(1,1)/(1.6022E-10*denc*(1.+sumx))
         endif
c$$$$$     TKM    2/00, 10/00
c  For testing initial HHFW experiments on NSTX
c
         if (alpte>0. .and. alpene>0.) then
            if (gamene > 0.) then
               do i = 1, nprofs
                  psi = float(i - 1)/float(nprofs - 1)
                  tne(i,1) = prone(psi)/denc
                  tte(i,1) = prote(psi)/tempec
               end do
               if (kboot == 2) then
                  draa = 1./float(nxeqd)
                  do iu = 1, nxeqd
                     raa(iu) = float(iu - 1)*draa
                     qeqd1(iu) = prone(raa(iu))/denc
                  end do
                  dra = 1./float(nprofs - 1)
                  do ir = 1, nprofs
                     ra(ir) = float(ir - 1)*dra
                  end do
                  call intrpp ('free', 'free', tpsieqd, qeqd1, nxeqd, ra
     1               , qeqd2, nprofs)
                  tne(:nprofs,1) = qeqd2(:nprofs)
                  do iu = 1, nxeqd
                     qeqd1(iu) = prote(raa(iu))/tempec
                  end do
                  call intrpp ('free', 'free', tpsieqd, qeqd1, nxeqd, ra
     1               , qeqd2, nprofs)
                  tte(:nprofs,1) = qeqd2(:nprofs)
               endif
            else
               gamene = -gamene
               do ii = 1, nprofs
                  tte(ii,1) = prote(roa(ii))/tempec
                  tne(ii,1) = prone(roa(ii))/denc
               end do
            endif
            do i = 1, nprofs
               tti(i,1,:nion) = tte(i,1)
               tni(i,1,:nion) = tne(i,1)*aconc(:nion)
            end do
         endif
c$$$$$$$$$$$       2/00, 10/00
      endif
c***********************
c$$$$$$$$$$       01/01
  105 continue
      tempic(:nion) = tite(:nion)*tempec
c
      do l = 1, nprofs
         tzeff(l,1) = 0.
         pne(l) = denc*tne(l,1)
         pte(l) = tempec*tte(l,1)
         do j = 1, nion
            pti(l,j) = tempic(j)*tti(l,1,j)
            pni(l,j) = pne(l)*aconc(j)
            conc(l,j) = aconc(j)
            tzeff(l,1) = tzeff(l,1) + aconc(j)*azi(j)**2
         end do
      end do
      return
c
c***********   TK Mau   11/98
  100 continue
      if (alpene == 0.) then
         if (gamene /= 0) then
c   Open file 'onetwo.out' and read in data
            open(8, file='onetwo.out', status='old')
            read (8, *) nrho, hconc
            read (8, *) (xrho(i),i=1,nrho)
            read (8, *) (yne(i),i=1,nrho)
            do ji = 1, 3
               read (8, *) (yni(i,ji),i=1,nrho)
            end do
            read (8, *) (yte(i),i=1,nrho)
            do ij = 1, 3, 2
               read (8, *) (yti(i,ij),i=1,nrho)
            end do
            close(8)
            yti(:nrho,2) = yti(:nrho,1)
c   Interpolate Ne, Te, and Ti profiles onto uniform rho grids.
            dra = 1./float(nprofs - 1)
            do ir = 1, nprofs
               ra(ir) = float(ir - 1)*dra
            end do
            denc = yne(1)
            qeqd1(:nrho) = yne(:nrho)/denc
            call intrpp ('zero', 'free', xrho, qeqd1, nrho, ra, tne(1,1)
     1         , nprofs)
            tempec = yte(1)
            qeqd1(:nrho) = yte(:nrho)/tempec
            call intrpp ('zero', 'free', xrho, qeqd1, nrho, ra, tte(1,1)
     1         , nprofs)
            if (nion > 3) then
               yni(:nrho,nion) = yni(:nrho,nion-1)
               yni(:nrho,nion-1) = hconc*yni(:nrho,1)
               yni(:nrho,1) = (1. - hconc)*yni(:nrho,1)
               yti(:nrho,nion) = yti(:nrho,nion-1)
               yti(:nrho,nion-1) = yti(:nrho,1)
            endif
            do j = 1, nion
               tempic(j) = yti(1,j)
               qeqd1(:nrho) = yti(:nrho,j)
               call intrpp ('zero', 'free', xrho, qeqd1, nrho, ra, pti(1
     1            ,j), nprofs)
               qeqd1(:nrho) = yni(:nrho,j)
               call intrpp ('zero', 'free', xrho, qeqd1, nrho, ra, pni(1
     1            ,j), nprofs)
            end do
            do l = 1, nprofs
               tzeff(l,1) = 0.
               pne(l) = denc*tne(l,1)
               pte(l) = tempec*tte(l,1)
               do j = 1, nion
                  conc(l,j) = pni(l,j)/pne(l)
                  tzeff(l,1) = tzeff(l,1) + conc(l,j)*azi(j)**2
               end do
            end do
            return
c
c$$$$$$$   TKM   01/01
         else
            open(8, file='nstx.out', status='old')
            do ir = 1, 101
               read (8, *) xrho(ir), yne(ir), yte(ir)
            end do
            close(8)
            tempec = yte(1)
            denc = yne(1)
            yte = yte/tempec
            yne = yne/denc
            denc = 1.E-6*denc
            tempec = 1.E-3*tempec
            draa = 1./float(nxeqd - 1)
            do iu = 1, nxeqd
               raa(iu) = float(iu - 1)*draa
            end do
            call intrpp ('zero', 'free', raa, tpsieqd, nxeqd, xrho,
     1         wwork1, 101)
            dra = 1./float(nprofs - 1)
            do ir = 1, nprofs
               ra(ir) = float(ir - 1)*dra
            end do
            call intrpp ('zero', 'free', wwork1, yne, 101, ra, qeqd2,
     1         nprofs)
            tne(:nprofs,1) = qeqd2(:nprofs)*(0.9*(1. - ra(:nprofs)**8)+
     1         0.1)
c           tne(ir,1) = qeqd2(ir)
            call intrpp ('zero', 'free', wwork1, yte, 101, ra, qeqd2,
     1         nprofs)
            do ir = 1, nprofs
               tte(ir,1) = qeqd2(ir)
               tti(ir,1,:nion) = tte(ir,1)
               tni(ir,1,:nion) = tne(ir,1)*aconc(:nion)
            end do
            go to 105
         endif
c$$$$$$$$$$        01/01
      else
         if (alpte < 0.) go to 110
c   Open file 'transp_ga.out' and read in data
         open(8, file='transp_ga.out', status='old')
         read (8, *) nrho, nai, nzi, ihm
         read (8, *) (xrho(i),i=1,nrho)
         do j = 1, 3
            read (8, *) (yni(i,j),i=1,nrho)
         end do
         read (8, *) (yti(i,1),i=1,nrho)
         read (8, *) (yte(i),i=1,nrho)
         read (8, *) (wwork1(i),i=1,nrho)
         read (8, *) (wwork2(i),i=1,nrho)
         read (8, *) (wwork3(i),i=1,nrho)
         close(8)
c
c   Interpolate Te, Ni and Ti profiles onto uniform rho grids.
         dra = 1./float(nprofs - 1)
         do ir = 1, nprofs
            ra(ir) = float(ir - 1)*dra
         end do
         qeqd1(:nrho) = 1.E-3*yte(:nrho)
         call intrpp ('zero', 'free', xrho, qeqd1, nrho, ra, tte(1,1),
     1      nprofs)
         tempec = tte(1,1)
         pte(:nprofs) = tte(:nprofs,1)
         if (nion > 3) then
            yni(:nrho,nion) = yni(:nrho,nion-1)
            yni(:nrho,nion-1) = hconc*yni(:nrho,1)
            yni(:nrho,1) = (1. - azi(nion-1)*hconc)*yni(:nrho,1)
            yti(:nrho,nion) = yti(:nrho,nion-1)
            yti(:nrho,nion-1) = yti(:nrho,1)
         endif
c
         do j = 1, nion
            qeqd1(:nrho) = yni(:nrho,j)
            call intrpp ('zero', 'free', xrho, qeqd1, nrho, ra, pni(1,j)
     1         , nprofs)
            if (j < nion) then
               qeqd1(:nrho) = 1.E-3*yti(:nrho,1)
               call intrpp ('zero', 'free', xrho, qeqd1, nrho, ra, pti(1
     1            ,j), nprofs)
               tempic(j) = pti(1,j)
            endif
         end do
c   Construct electron density profile from charge neutrality
         do iy = 1, nprofs
            pne(iy) = 0.
            do j = 1, nion
               pne(iy) = pne(iy) + azi(j)*pni(iy,j)
            end do
         end do
         denc = pne(1)
c   Define parallel temperature and thermal anisotropy of energetic
c   ion species (j=nion)
         qeqd1(:nrho) = 2.*wwork2(:nrho)/(1.6022E-16*yni(:nrho,nion))
         qeqd2(:nrho) = 0.5*wwork1(:nrho)/wwork2(:nrho)
         call intrpp ('zero', 'free', xrho, qeqd1, nrho, ra, pti(1,nion)
     1      , nprofs)
         call intrpp ('zero', 'free', xrho, qeqd2, nrho, ra, tani,
     1      nprofs)
c
c**** Read in data from TRANSP runs: profiles as functions of rho
c
 110  continue
         if (alpte < 0.) then
c           open(8, file='transp.out', status='old')
c           nrho2 = nrho_tr-1
c----- Read in normalized toroidal flux coordinates
c           do i = nrho_tr,2,-1
c              xrho_tr(i) = xrho_tr(i-1)
c           enddo
c           xrho_tr(1) = 0.
c----- Interpolate ion and electron densities from TRANSP to 
c       CURRAY radial coordinates
            do k = 1,nion
c              wwork1(:nrho2) = ni_tr(:nrho2,k)
               wwork1(:nrho_tr) = ni_tr(:nrho_tr,k)
c              call grid_value(wwork1,nrho_tr)
               call intrpp('zero','free',xrho_tr,wwork1,nrho_tr,ra,
     &            wwork2,nprofs)
               pni(:nprofs,k) = wwork2(:nprofs)
            enddo
            wwork1(:nrho_tr) = ne_tr(:nrho_tr)
c           call grid_value(wwork1,nrho_tr)
            call intrpp('zero','free',xrho_tr,wwork1,nrho_tr,ra,
     &            pne,nprofs)
            denc = pne(1)
c----- Interpolate electron and ion temperatures from TRANSP onto
c       CURRAY radial coordinates
            wwork1(:nrho_tr) = te_tr(:nrho_tr)
c           call grid_value(wwork1,nrho_tr)
            call intrpp('zero','free',xrho_tr,wwork1,nrho_tr,ra,pte,
     &                  nprofs)
            pte(:nprofs) = pte(:nprofs)
            tempec = pte(1)
c----- Interpolate thermal ion temperature profile
            do k = 1,nion
               wwork1(:nrho_tr) = ti_tr(:nrho_tr,k)
c              call grid_value(wwork1,nrho_tr)
               call intrpp('zero','free',xrho_tr,wwork1,nrho_tr,
     &            ra,wwork2,nprofs)
               pti(:nprofs,k) = wwork2(:nprofs)
               tempic(k) = pti(1,k)
            enddo
c
c----- Interpolate loop voltage profile
c
            wwork1(:nrho_tr) = elp_tr(:nrho_tr)
            elp_tr(:nrho_tr) = 0.
            call intrpp('zero','free',xrho_tr,wwork1,nrho_tr,ra,
     &         elp_tr,nprofs)
c
c----- Read in fast alpha and IC resonant densities and energies, 
c      and convert energies to isotropic Maxwellian temperatures
c           do k = 6,nion
c              read(8,*) wwork1(:nrho2)
c              read(8,*) wwork2(:nrho2)
c              wwork1(:nrho2) = wwork1(:nrho2)+wwork2(:nrho2)
c              call grid_value(wwork1,nrho1)
c              call intrpp('zero','free',xrho,wwork1,nrho1,ra,wwork2,
c    &                     nprofs)
c              pti(:nprofs,k) = 4.160945e15*wwork2(:nprofs)/
c    &                          pni(:nprofs,k)
c           enddo
c           tempic(:nion) = pti(1,:nion)
c            if (nion /= 4) then
c               call link ('unit59=terminal//')
c              write (6, 881) nion
c 881          format("nion must be 4.")
c              stop 88
c           endif
c           open(8, file='neprof', status='old')
c           do i = 1, nrho1
c              read (8, *) xrho(i), wwork1(i)
c           end do
c           close(8)
c           call intrpp ('zero', 'free', xrho, wwork1, nrho1, ra, pne,
c    1         nprofs)
c           pne(:nprofs) = 1.E13*pne(:nprofs)
c           denc = pne(1)
c           open(8, file='teprof', status='old')
c           do i = 1, nrho1
c              read (8, *) xrho(i), wwork1(i)
c           end do
c           close(8)
c           call intrpp ('zero', 'free', xrho, wwork1, nrho1, ra, pte,
c    1         nprofs)
c           tempec = pte(1)
c           open(8, file='ncprof', status='old')
c           do i = 1, nrho1
c              read (8, *) xrho(i), wwork1(i)
c           end do
c           close(8)
c           call intrpp ('zero', 'free', xrho, wwork1, nrho1, ra, wwork2
c    1         , nprofs)
c           pni(:nprofs,2) = 1.E-2*wwork2(:nprofs)*pne(:nprofs)
c           wwork3(:nprofs) = pne(:nprofs) - azi(2)*pni(:nprofs,2) - azi
c    1         (nion)*pni(:nprofs,nion)
c           pni(:nprofs,1) = (1. - hconc)*wwork3(:nprofs)
c           pni(:nprofs,nion-1) = hconc*wwork3(:nprofs)
c           open(8, file='tiprof', status='old')
c           do i = 1, nrho1
c              read (8, *) xrho(i), wwork1(i)
c           end do
c           close(8)
c           call intrpp ('zero', 'free', xrho, wwork1, nrho1, ra, pti(1,
c    1         1), nprofs)
c           tempic(1) = pti(1,1)
c           do k = 2, nion - 1
c              pti(:nprofs,k) = pti(:nprofs,1)
c              tempic(k) = pti(1,k)
c           end do
         endif
c
c*********************************
c
         do l = 1, nprofs
            tzeff(l,1) = 0.
            do j = 1, nion
               conc(l,j) = pni(l,j)/pne(l)
               tzeff(l,1) = tzeff(l,1) + conc(l,j)*azi(j)**2
            end do
         end do
      endif
      return
      end subroutine prontp
c
      subroutine grid_value(x,n)
c
      use kind_spec
      implicit none
      integer n,n1,i
      real(kind=dp), dimension(101) :: x, y
c
      n1 = n-1
      y(:n1) = x(:n1)
      x(2) = 0.5*(y(1)+y(2))
      x(1) = 2.*y(1)-x(2)
      do i = 3,n
         x(i) = 2.*Y(i-1)-x(i-1)
      enddo
      return
      end subroutine grid_value
c
      function prote(psi)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:40   6/14/01
C...Switches: -p4 -yb
c--------------------- ----------------------------------
c analytic fit to the electron temperature profile
c--------------------- ----------------------------------
c  ******        data       pint  /2.0/,       pext /2.0/
c  ******        data       edge  /0.1/
c  ******  c--------------------- ----------------------------------
c  ******           prote = edge + (1.-edge)*(1.-psi**pint)**pext
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh
!      use Vcraylh
!      use Vchpcsd
!      use Vceqdsk
!      use Vcmnew
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real(kind=dp) prote
      real(kind=dp) psi
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c     dimension acoef(4)
c
c--------------------------------------------------------------------
c shot 26471
c     data acoef /7.51, -13.45, 6.21, -125.64/
c--------------------------------------------------------------------
c     x=rplasm*psi
c     x2=x*x
c     arg = acoef(4)
c     do 10  i=1,3
c10   arg=arg*x2 + acoef(4-i)
c     prote = exp(arg)
c     prote=temedg + (tempec-temedg)*(1.-psi**gamte)**alpte
c**********   TKM   2/97
      prote = tempec*(temedg + (1. - temedg)*(frcte*(1. - psi**gamte)**
     1   alpte + (1. - frcte)*(1. - psi**gamte1)**alpte1))
c***************************
      return
      end function prote

      function proti (psi)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:40   6/14/01
C...Switches: -p4 -yb
c--------------------- ----------------------------------
c analytic fit to the ion temperature profile
c--------------------- ----------------------------------
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh
!      use Vcraylh
!      use Vchpcsd
!      use Vceqdsk
!      use Vcmnew
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real(kind=dp) psi
      real(kind=dp) proti
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c     data       pint  /2.0/,       pext /1.0/
c     data       edge  /0.1/
c--------------------- ----------------------------------
c     proti = tiedg +(tempic(1)-tiedg)*(1.-psi**gamti)**alpti
c************  TKM   2/97
      proti = tempic(1)*(tiedg + (1. - tiedg)*(frcti*(1. - psi**gamti)**
     1   alpti + (1. - frcti)*(1. - psi**gamti1)**alpti1))
c****************************
      return
      end function proti
c
      subroutine subpar(psival, dene, teme, zef)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:40   6/14/01
C...Switches: -p4 -yb
c
c   given psi-value, evaluate densities and temperatures,and zeffective
c
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
      use Viorlh
      use Vcraylh
      use Vchpcsd
      use Vceqdsk
      use Vcmnew
      use kind_spec

      implicit none
C-----------------------------------------------
C   G l o b a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      real(kind=dp) psival, dene, teme, zef
C-----------------------------------------------
C   L o c a l   P a r a m e t e r s
C-----------------------------------------------
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: i
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
!      integer , EXTERNAL :: ifix
      real(kind=dp) , EXTERNAL :: valspl
C-----------------------------------------------
c
c  parameters
c  Nspect-->nspectm, Nion-->nions,  Nua-->nuam,  Nta-->ntam, Lrz-->lrza,
c  Nthp11-->nthp11a,  Npnt-->npnta,   Mpnt-->mpnta
c
c----------------------------
c       common block Comiorlh(1-8)
c
c  ipropt         integer   #option for n-T profile calculation: 1 if
c                        # calculated from prontp; else =0.


c--------SCC  5/23/95
c*******  TKM  06/97, 2/00
c*************************
c********    TKM    11/98
c*******************************
c  #   SCC 3/27/92   SCC 4/13/95
c
c---------------------------
c   common block for Comraylh
c-------------------------
c
c
c$$$$$$$$     TKM    11/98
c*********    TKM   2/97, 6/99, 9/99
c*********    TKM   2/97
c*******   TK Mau   8/98
c*************************
c  SCC  3/7/95

c
c     dimension temi(nspi),deni(nspi)
c
c ************ ************ ************ ************ ************
c
      psi = psival
!      left = ifix(psi/dpsi) + 1
      left = int(psi/dpsi) + 1
      hh = psi - tpsi(left)
      if (left > nprof) then
         left = nprof
         hh = 0.0
      endif
c
      dene = valspl(hh,tne,nprofn,left,0)
      teme = valspl(hh,tte,nprofn,left,0)
c
      zef = 0.
      do i = 1, nspec
c          deni(i) = valspl(hh,tni(1,1,i),nprofn,left,0)
c          temi(i) = valspl(hh,tti(1,1,i),nprofn,left,0)
         aconc(i) = valspl(hh,tconc(1,1,i),nprofn,left,0)
c          zef=zef+aconc(i)*azi(i)*azi(i)
      end do
      zef = valspl(hh,tzeff,nprofn,left,0)
      return
      end subroutine subpar


c     The following subroutines tdxin13d, profaxis are from cql,
c        and can be used to produce parabolic profiles.
c
c
c
      subroutine tdxin13d(a, rya, rs, lrz, m, k, expn1, expm1)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  11:01:40   6/14/01
C...Switches: -p4 -yb
C-----------------------------------------------
C   M o d u l e s
C-----------------------------------------------
!      use Vparam
!      use Viorlh
!      use Vcraylh
!      use Vchpcsd
!      use Vceqdsk
!      use Vcmnew
      use Vsizes
      use kind_spec

      implicit none
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      integer lrz, m, k
      real(kind=dp) rs, expn1, expm1
      real(kind=dp), dimension(m,0:lrz) :: a
      real(kind=dp), dimension(0:lrz) :: rya
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      integer :: ll
      real(kind=dp) :: dratio, rn

      save dratio, ll, rn
c
c
c     this is a utility parabloic "fill in" routine
c
c                                                ! was 1.e-90
      if (abs(a(k,0)) <= smallest) a(k,0) = smallest
      dratio = a(k,1)/a(k,0)
      do ll = 1, lrz
         call profaxis (rn, expn1, expm1, dratio, rya(ll))
         a(k,ll) = a(k,0)*rn
      end do
      return
      end subroutine tdxin13d

C   IMSL ROUTINE NAME   - UERTST
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JUNE 1, 1982
C
C   PURPOSE             - PRINT A MESSAGE REFLECTING AN ERROR CONDITION
C
C   USAGE               - CALL UERTST (IER,NAME)
C
C   ARGUMENTS    IER    - ERROR PARAMETER. (INPUT)
C                           IER = I+J WHERE
C                             I = 128 IMPLIES TERMINAL ERROR MESSAGE,
C                             I =  64 IMPLIES WARNING WITH FIX MESSAGE,
C                             I =  32 IMPLIES WARNING MESSAGE.
C                             J = ERROR CODE RELEVANT TO CALLING
C                                 ROUTINE.
C                NAME   - A CHARACTER STRING OF LENGTH SIX PROVIDING
C                           THE NAME OF THE CALLING ROUTINE. (INPUT)
C
C   PRECISION/HARDWARE  - SINGLE/ALL
C
C   REQD. IMSL ROUTINES - UGETIO,USPKD
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   REMARKS      THE ERROR MESSAGE PRODUCED BY UERTST IS WRITTEN
C                TO THE STANDARD OUTPUT UNIT. THE OUTPUT UNIT
C                NUMBER CAN BE DETERMINED BY CALLING UGETIO AS
C                FOLLOWS..   CALL UGETIO(1,NIN,NOUT).
C                THE OUTPUT UNIT NUMBER CAN BE CHANGED BY CALLING
C                UGETIO AS FOLLOWS..
C                                NIN = 0
C                                NOUT = NEW OUTPUT UNIT NUMBER
C                                CALL UGETIO(3,NIN,NOUT)
C                SEE THE UGETIO DOCUMENT FOR MORE DETAILS.
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE UERTST (IER,NAME)
C                                  SPECIFICATIONS FOR ARGUMENTS
      INTEGER            IER
      CHARACTER(LEN=*)   NAME
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      INTEGER            I,IEQ,IEQDF,IOUNIT,LEVEL,LEVOLD,NAMEQ(6),
     *                   NAMSET(6),NAMUPK(6),NIN,NMTB
      DATA               NAMSET/1HU,1HE,1HR,1HS,1HE,1HT/
      DATA               NAMEQ/6*1H /
      DATA               LEVEL/4/,IEQDF/0/,IEQ/1H=/
C                                  UNPACK NAME INTO NAMUPK
C                                  FIRST EXECUTABLE STATEMENT
      CALL USPKD (NAME,6,NAMUPK,NMTB)
C                                  GET OUTPUT UNIT NUMBER
      CALL UGETIO(1,NIN,IOUNIT)
C                                  CHECK IER
      IF (IER.GT.999) GO TO 25
      IF (IER.LT.-32) GO TO 55
      IF (IER.LE.128) GO TO 5
      IF (LEVEL.LT.1) GO TO 30
C                                  PRINT TERMINAL MESSAGE
      IF (IEQDF.EQ.1) WRITE(IOUNIT,35) IER,NAMEQ,IEQ,NAMUPK
      IF (IEQDF.EQ.0) WRITE(IOUNIT,35) IER,NAMUPK
      GO TO 30
    5 IF (IER.LE.64) GO TO 10
      IF (LEVEL.LT.2) GO TO 30
C                                  PRINT WARNING WITH FIX MESSAGE
      IF (IEQDF.EQ.1) WRITE(IOUNIT,40) IER,NAMEQ,IEQ,NAMUPK
      IF (IEQDF.EQ.0) WRITE(IOUNIT,40) IER,NAMUPK
      GO TO 30
   10 IF (IER.LE.32) GO TO 15
C                                  PRINT WARNING MESSAGE
      IF (LEVEL.LT.3) GO TO 30
      IF (IEQDF.EQ.1) WRITE(IOUNIT,45) IER,NAMEQ,IEQ,NAMUPK
      IF (IEQDF.EQ.0) WRITE(IOUNIT,45) IER,NAMUPK
      GO TO 30
   15 CONTINUE
C                                  CHECK FOR UERSET CALL
      DO 20 I=1,6
         IF (NAMUPK(I).NE.NAMSET(I)) GO TO 25
   20 CONTINUE
      LEVOLD = LEVEL
      LEVEL = IER
      IER = LEVOLD
      IF (LEVEL.LT.0) LEVEL = 4
      IF (LEVEL.GT.4) LEVEL = 4
      GO TO 30
   25 CONTINUE
      IF (LEVEL.LT.4) GO TO 30
C                                  PRINT NON-DEFINED MESSAGE
      IF (IEQDF.EQ.1) WRITE(IOUNIT,50) IER,NAMEQ,IEQ,NAMUPK
      IF (IEQDF.EQ.0) WRITE(IOUNIT,50) IER,NAMUPK
   30 IEQDF = 0
      RETURN
!   35 FORMAT(19H *** TERMINAL ERROR,10X,7H(IER = ,I3,
!     1       20H) FROM IMSL ROUTINE ,6A1,A1,6A1)
!   40 FORMAT(27H *** WARNING WITH FIX ERROR,2X,7H(IER = ,I3,
!     1       20H) FROM IMSL ROUTINE ,6A1,A1,6A1)
!   45 FORMAT(18H *** WARNING ERROR,11X,7H(IER = ,I3,
!     1       20H) FROM IMSL ROUTINE ,6A1,A1,6A1)
!   50 FORMAT(20H *** UNDEFINED ERROR,9X,7H(IER = ,I5,
!     1       20H) FROM IMSL ROUTINE ,6A1,A1,6A1)
   35 FORMAT(' *** TERMINAL ERROR',10X,'(IER = ',I3,
     1       ') FROM IMSL ROUTINE ',6A1,A1,6A1)
   40 FORMAT(' *** WARNING WITH FIX ERROR',2X,'(IER = ',I3,
     1       ') FROM IMSL ROUTINE ',6A1,A1,6A1)
   45 FORMAT(' *** WARNING ERROR',11X,'(IER = ',I3,
     1       ') FROM IMSL ROUTINE ',6A1,A1,6A1)
   50 FORMAT(' *** UNDEFINED ERROR ',9X,'(IER = ',I5,
     1       ') FROM IMSL ROUTINE ',6A1,A1,6A1)
C
C                                  SAVE P FOR P = R CASE
C                                    P IS THE PAGE NAMUPK
C                                    R IS THE ROUTINE NAMUPK
   55 IEQDF = 1
      DO 60 I=1,6
   60 NAMEQ(I) = NAMUPK(I)
   65 RETURN
      END

C   IMSL ROUTINE NAME   - MGAMAD=DGAMMA
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/DOUBLE
C
C   LATEST REVISION     - NOVEMBER 1, 1984
C
C   PURPOSE             - EVALUATE THE GAMMA FUNCTION OF A DOUBLE
C                           PRECISION ARGUMENT
C
C   USAGE               - RESULT = DGAMMA(X)
C
C   ARGUMENTS    X      - INPUT DOUBLE PRECISION ARGUMENT.
C                           DGAMMA IS SET TO MACHINE INFINITY, WITH THE
C                           PROPER SIGN, WHENEVER
C                             X IS ZERO,
C                             X IS A NEGATIVE INTEGER,
C                             ABS(X) .LE. XMIN, OR
C                             ABS(X) .GE. XMAX.
C                             XMIN IS OF THE ORDER OF 10**(-39) AND
C                             XMAX IS AT LEAST 34.8. THE EXACT VALUES
C                             OF XMIN AND XMAX MAY ALLOW LARGER RANGES
C                             FOR X ON SOME COMPUTERS.
C                             SEE THE PROGRAMMING NOTES IN THE MANUAL
C                             FOR THE EXACT VALUES.
C                DGAMMA - OUTPUT DOUBLE PRECISION VALUE OF THE GAMMA
C                           FUNCTION. DGAMMA MUST BE TYPED DOUBLE
C                           PRECISION IN THE CALLING PROGRAM.
C
C   PRECISION/HARDWARE  - DOUBLE/H32,H36
C                       - NOT AVAILABLE/H48,H60
C                         NOTE - DGAMMA MAY NOT BE SUPPLIED BY IMSL IF
C                           IT RESIDES IN THE MATHEMATICAL SUBPROGRAM
C                           LIBRARY SUPPLIED BY THE MANUFACTURER.
C
C   REQD. IMSL ROUTINES - UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   REMARKS      AN ERROR MESSAGE PRINTED BY UERTST FROM DGAMMA SHOULD
C                BE INTERPRETED AS FOLLOWS
C                IER    - ERROR INDICATOR
C                         TERMINAL ERROR
C                           IER = 129 INDICATES THAT THE ABSOLUTE VALUE
C                             OF THE INPUT ARGUMENT X IS SPECIFIED
C                             GREATER THAN OR EQUAL TO XMAX. DGAMMA
C                             IS SET TO MACHINE INFINITY.
C                           IER = 130 INDICATES THAT THE INPUT ARGUMENT
C                             X IS SPECIFIED AS ZERO OR A NEGATIVE
C                             INTEGER OR THAT THE ABSOLUTE VALUE OF THE
C                             INPUT ARGUMENT IS LESS THAN OR EQUAL TO
C                             XMIN. DGAMMA IS SET TO MACHINE INFINITY
C                             WITH THE PROPER SIGN FOR THE DGAMMA
C                             FUNCTION. IF X IS ZERO OR AN EVEN
C                             NEGATIVE INTEGER, GAMMA HAS A NEGATIVE
C                             SIGN. OTHERWISE IT HAS A POSITIVE SIGN.
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      DOUBLE PRECISION FUNCTION DGAMMA (X)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:53:12   6/14/01  
C...Switches: -p4 -yb
      IMPLICIT NONE
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      DOUBLE PRECISION X
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      INTEGER :: I, IER, J
      DOUBLE PRECISION, DIMENSION(9) :: P
      DOUBLE PRECISION, DIMENSION(8) :: Q
      DOUBLE PRECISION, DIMENSION(7) :: P4
      DOUBLE PRECISION::A,B,DEN,PI,T,TOP,BIG1,XINF,XMIN,Y,SIGN,R
      LOGICAL :: MFLAG
C-----------------------------------------------
C                                  SPECIFICATIONS FOR ARGUMENTS
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
C                                  COEFFICIENTS FOR MINIMAX
C                                  APPROXIMATION TO GAMMA(X),
C                                  2.0 .LE. X .LE. 3.0
      DATA P(1)/ - 5.966047488753637D01/
      DATA P(2)/5.864023793062003D01/
      DATA P(3)/ - 1.364106217165365D03/
      DATA P(4)/ - 8.117569271425580D02/
      DATA P(5)/ - 1.569414683149179D04/
      DATA P(6)/ - 1.525979925758372D04/
      DATA P(7)/ - 7.264059615964330D04/
      DATA P(8)/ - 8.972275718101010D-01/
      DATA P(9)/3.349618189847578D00/
      DATA Q(1)/4.103991474182904D02/
      DATA Q(2)/ - 2.262590291514875D03/
      DATA Q(3)/2.494325576714903D03/
      DATA Q(4)/2.362106244383048D04/
      DATA Q(5)/ - 5.741873227396418D04/
      DATA Q(6)/ - 7.257239715408240D04/
      DATA Q(7)/ - 9.491399521686949D00/
      DATA Q(8)/ - 3.255006939455704D01/
C                                  COEFFICIENTS FOR MINIMAX
C                                  APPROXIMATION TO LN(GAMMA(X)),
C                                  12.0 .LE. X
      DATA P4(1)/8.40596949829D-04/
      DATA P4(2)/ - 5.9523334141881D-04/
      DATA P4(3)/7.9365078409227D-04/
      DATA P4(4)/ - 2.777777777769526D-03/
      DATA P4(5)/8.333333333333333D-02/
      DATA P4(6)/9.189385332046727D-01/
      DATA P4(7)/ - 1.7816839846D-03/
      DATA PI/3.141592653589793D0/
      DATA XINF/1.7D+38/
C                                  DGAMMA(XMIN) .APPROX. XINF
C                                  DGAMMA(BIG1) .APPROX. XINF
      DATA XMIN/5.8775D-39/
      DATA BIG1/34.844D0/
C                                  FIRST EXECUTABLE STATEMENT
      IER = 0
      MFLAG = .FALSE.
      T = X
      IF (DABS(T) <= XMIN) THEN
         IER = 130
         DGAMMA = XINF
         IF (T <= 0.0D0) DGAMMA = -XINF
      ELSE
         IF (DABS(T) >= BIG1) THEN
            IER = 129
            DGAMMA = XINF
         ELSE
            IF (T <= 0.0D0) THEN
C                                  ARGUMENT IS NEGATIVE
               MFLAG = .TRUE.
               T = -T
               R = DINT(T)
               SIGN = 1.0D0
               IF (DMOD(R,2.0D0) == 0.0D0) SIGN = -1.0D0
               R = T - R
               IF (R == 0.0D0) THEN
                  IER = 130
                  DGAMMA = XINF
                  IF (SIGN == (-1.0D0)) DGAMMA = -XINF
                  GO TO 9000
C                                  ARGUMENT IS NOT A NEGATIVE INTEGER
               ENDIF
               R = PI/DSIN(R*PI)*SIGN
               T = T + 1.0D0
C                                  EVALUATE APPROXIMATION FOR DGAMMA(T)
C                                    T .GT. XMIN
            ENDIF
            IF (T <= 12.0D0) THEN
               I = T
               A = 1.0D0
               IF (I <= 2) THEN
                  I = I + 1
                  GO TO (25,30,45) I
C                                  0.0 .LT. T .LT. 1.0
   25             CONTINUE
                  A = A/(T*(T + 1.0D0))
                  T = T + 2.0D0
                  GO TO 45
C                                  1.0 .LE. T .LT. 2.0
   30             CONTINUE
                  A = A/T
                  T = T + 1.0D0
                  GO TO 45
C                                  3.0 .LE. T .LE. 12.0
               ENDIF
               DO J = 3, I
                  T = T - 1.0D0
                  A = A*T
               END DO
C                                  2.0 .LE. T .LE. 3.0
   45          CONTINUE
               TOP = P(8)*T + P(9)
               DEN = T + Q(8)
               DO J = 1, 7
                  TOP = TOP*T + P(J)
               END DO
               DO J = 1, 7
                  DEN = DEN*T + Q(J)
               END DO
               Y = (TOP/DEN)*A
               IF (MFLAG) Y = R/Y
               DGAMMA = Y
               GO TO 9005
C                                  T .GT. 12.0
            ENDIF
            TOP = DLOG(T)
            TOP = T*(TOP - 1.0D0) - .5D0*TOP
            T = 1.0D0/T
            B = T*T
            A = P4(7)
            DO J = 1, 5
               A = A*B + P4(J)
            END DO
            Y = A*T + P4(6) + TOP
            Y = DEXP(Y)
            IF (MFLAG) Y = R/Y
            DGAMMA = Y
            GO TO 9005
         ENDIF
      ENDIF
 9000 CONTINUE
      CALL UERTST ((-IER), 6HMGAMAD)
      CALL UERTST (IER, 6HDGAMMA)
 9005 CONTINUE
      RETURN 
      END FUNCTION DGAMMA
C   IMSL ROUTINE NAME   - IBCCCU
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JUNE 1, 1982
C
C   PURPOSE             - BICUBIC SPLINE TWO-DIMENSIONAL COEFFICIENT
C                           CALCULATOR
C
C   USAGE               - CALL IBCCCU (F,X,NX,Y,NY,C,IC,WK,IER)
C
C   ARGUMENTS    F      - NX BY NY MATRIX CONTAINING THE FUNCTION
C                           VALUES. (INPUT) F(I,J) IS THE FUNCTION VALUE
C                           AT THE POINT (X(I),Y(J)) FOR I=1,...,NX AND
C                           J=1,...,NY.
C                X      - VECTOR OF LENGTH NX. (INPUT) X MUST BE
C                           ORDERED SO THAT X(I) .LT. X(I+1) FOR
C                           I=1,...,NX-1.
C                NX     - NUMBER OF ELEMENTS IN X. (INPUT) NX MUST BE
C                           .GE. 4.
C                Y      - VECTOR OF LENGTH NY. (INPUT) Y MUST BE
C                           ORDERED SO THAT Y(J) .LT. Y(J+1) FOR
C                           J=1,...,NY-1.
C                NY     - NUMBER OF ELEMENTS IN Y. (INPUT) NY MUST BE
C                           .GE. 4.
C                         NOTE - THE COORDINATE PAIRS (X(I),Y(J)), FOR
C                           I=1,...,NX AND J=1,...,NY, GIVE THE POINTS
C                           WHERE THE FUNCTION VALUES F(I,J) ARE
C                           DEFINED.
C                C      - ARRAY OF SPLINE COEFFICIENTS. (OUTPUT)
C                           C IS OF DIMENSION 2 BY NX BY 2 BY NY.
C                           AT THE POINT (X(I),Y(J))
C                             C(1,I,1,J) = S
C                             C(2,I,1,J) = DS/DX
C                             C(1,I,2,J) = DS/DY
C                             C(2,I,2,J) = D(DS/DX)/DY
C                           WHERE S(X,Y) IS THE SPLINE APPROXIMATION.
C                           (NOTE - C IS TREATED INTERNALLY AS A
C                             2 BY NX BY 2*NY ARRAY BECAUSE CERTAIN
C                             ENVIRONMENTS DO NOT PERMIT QUADRUPLY-
C                             DIMENSIONED ARRAYS.  IN THESE
C                             ENVIRONMENTS THE CALLING PROGRAM MAY
C                             DIMENSION C IN THE SAME MANNER.)
C                IC     - ROW DIMENSION OF MATRIX F AND SECOND
C                           DIMENSION OF ARRAY C EXACTLY AS
C                           SPECIFIED IN THE DIMENSION STATEMENT.
C                           (INPUT). IC MUST BE .GE. NX.
C                WK     - WORK VECTOR OF LENGTH
C                           2*NX*NY+2*MAX(NX,NY)
C                IER    - ERROR PARAMETER. (OUTPUT)
C                         TERMINAL ERROR
C                           IER = 129, IC IS LESS THAN NX
C                           IER = 130, NX IS LESS THAN 4
C                           IER = 131, NY IS LESS THAN 4
C                           IER = 132, X OR Y ARE NOT ORDERED SO THAT
C                             X(I) .LT. X(I+1) AND
C                             Y(I) .LT. Y(I+1)
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - IBCDCU,UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE IBCCCU(F, X, NX, Y, NY, C, IC, WK, IER)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:53:12   6/14/01  
C...Switches: -p4 -yb
      IMPLICIT NONE
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      INTEGER NX, NY, IC, IER
      REAL, DIMENSION(IC,1) :: F
      REAL, DIMENSION(1) :: X, Y
      REAL, DIMENSION(2,IC,1) :: C
      REAL, DIMENSION(1) :: WK
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      INTEGER :: IWK
C-----------------------------------------------
C                                  SPECIFICATIONS FOR ARGUMENTS
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
C                                  FIRST EXECUTABLE STATEMENT
      IER = 129
      IF (IC < NX) GO TO 9000
      IER = 130
      IF (NX < 4) GO TO 9000
      IER = 131
      IF (NY < 4) GO TO 9000
      IWK = 2*NY*NX
      CALL IBCDCU (X, F, NX, NY, WK(IWK+1), WK, IC, NY, IER)
      IF (IER > 0) GO TO 9000
      CALL IBCDCU (Y, WK, NY, 2*NX, WK(IWK+1), C, NY, 2*IC, IER)
      IF (IER == 0) GO TO 9005
 9000 CONTINUE
      CALL UERTST (IER, 6HIBCCCU)
 9005 CONTINUE
      RETURN 
      END SUBROUTINE IBCCCU
C   IMSL ROUTINE NAME   - IBCDCU
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JUNE 1, 1982
C
C   PURPOSE             - NUCLEUS CALLED ONLY BY IMSL SUBROUTINE IBCCCU
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - NONE REQUIRED
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE IBCDCU(TAU, GTAU, N, M, W, VS, IC1, IC2, IER)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:53:12   6/14/01  
C...Switches: -p4 -yb
      IMPLICIT NONE
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      INTEGER N, M, IC1, IC2, IER
      REAL, DIMENSION(N) :: TAU
      REAL, DIMENSION(IC1,1) :: GTAU
      REAL, DIMENSION(N,2) :: W
      REAL, DIMENSION(IC2,2,1) :: VS
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      INTEGER :: J1, J2, I, JJ, JM1, JP1, J, K, LIM, LL, LP1, NM1
      REAL :: AA, BB, C1, C2, CC, DD, DTAU, G, H, RATIO, U, XILIM
C-----------------------------------------------
C                                  SPECIFICATIONS FOR ARGUMENTS
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
C                                  FIRST EXECUTABLE STATEMENT
      LIM = N - 3
      NM1 = N - 1
      LP1 = LIM + 1
      IER = 132
      W(2,1) = TAU(3) - TAU(1)
      IF (W(2,1) <= 0.0) RETURN 
      VS(:M,1,1) = GTAU(1,:M)
      XILIM = TAU(1)
      IF (LIM >= 2) THEN
         XILIM = TAU(N-2)
         DO I = 2, LIM
            J = I + 1
            W(J,1) = TAU(I+2) - TAU(J)
            IF (W(J,1) <= 0.0) RETURN 
            VS(:M,1,I) = GTAU(J,:M)
         END DO
      ENDIF
      W(LP1,1) = TAU(N) - XILIM
      IF (W(LP1,1) <= 0.0) RETURN 
      VS(:M,1,LP1) = GTAU(N,:M)
      DO I = 2, LP1
         VS(:M,2,I) = (VS(:M,1,I)-VS(:M,1,I-1))/W(I,1)
      END DO
      DTAU = TAU(2) - TAU(1)
      RATIO = DTAU/W(2,1)
      W(1,2) = (RATIO - 1.)**2
      W(1,1) = RATIO*(RATIO - 1.)
      C1 = RATIO*(2.*RATIO - 3.)
      VS(:M,2,1) = (GTAU(2,:M)-GTAU(1,:M))/DTAU + VS(:M,2,2)*C1
      IF (LIM >= 2) THEN
         DO I = 2, LIM
            J = I + 1
            JJ = I - 1
            G = -W(J,1)/W(JJ,2)
            C1 = 3.*W(I,1)
            C2 = 3.*W(J,1)
            VS(:M,2,I) = G*VS(:M,2,JJ) + C1*VS(:M,2,J) + C2*VS(:M,2,I)
            W(I,2) = G*W(JJ,1) + 2.*(W(I,1)+W(J,1))
         END DO
      ENDIF
      DTAU = TAU(N-1) - XILIM
      RATIO = DTAU/W(LP1,1)
      G = -(RATIO - 1.)**2/W(LIM,2)
      W(LP1,2) = RATIO*(RATIO - 1.)
      C1 = RATIO*(2.*RATIO - 3.)
      VS(:M,2,LP1) = (GTAU(N-1,:M)-VS(:M,1,LIM))/DTAU + VS(:M,2,LP1)*C1
      W(LP1,2) = G*W(LIM,1) + W(LP1,2)
      VS(:M,2,LP1) = (G*VS(:M,2,LIM)+VS(:M,2,LP1))/W(LP1,2)
      J = LIM
      J1 = J
      J2 = MIN0(1,J1)
      DO J = J1, J2, -1
         VS(:M,2,J) = (VS(:M,2,J)-W(J,1)*VS(:M,2,J+1))/W(J,2)
      END DO
      DO K = 1, M
         DO JJ = 1, N
            J = N + 1 - JJ
            JM1 = J - 1
            IF (J == N) JM1 = J - 2
            IF (J == 1) JM1 = J
            VS(K,:,J) = VS(K,:,JM1)
         END DO
         DO J = 2, NM1, LIM
            JM1 = J - 1
            JP1 = J + 1
            IF (JM1 == 2) JM1 = 1
            IF (JP1 == NM1) JP1 = N
            H = TAU(JP1) - TAU(JM1)
            U = TAU(J) - TAU(JM1)
            AA = VS(K,1,JM1)
            BB = VS(K,2,JM1)
            CC = (3.*(VS(K,1,JP1)-VS(K,1,JM1))/H-(VS(K,2,JP1)+2.*VS(K,2,
     1         JM1)))/H
            DD = (2.*(VS(K,1,JM1)-VS(K,1,JP1))/H+(VS(K,2,JP1)+VS(K,2,JM1
     1         )))/H**2
            VS(K,1,J) = AA + U*(BB + U*(CC + DD*U))
            VS(K,2,J) = BB + U*(2.*CC + 3.*DD*U)
         END DO
      END DO
      IER = 0
      RETURN 
      END SUBROUTINE IBCDCU
C   IMSL ROUTINE NAME   - ICSCCU
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JUNE 1, 1980
C
C   PURPOSE             - CUBIC SPLINE INTERPOLATION
C                           (EASY-TO-USE VERSION)
C
C   USAGE               - CALL ICSCCU (X,Y,NX,C,IC,IER)
C
C   ARGUMENTS    X      - VECTOR OF LENGTH NX CONTAINING THE ABSCISSAE
C                           OF THE NX DATA POINTS (X(I),Y(I)) I=1,...,
C                           NX. (INPUT) X MUST BE ORDERED SO THAT
C                           X(I) .LT. X(I+1).
C                Y      - VECTOR OF LENGTH NX CONTAINING THE ORDINATES
C                           (OR FUNCTION VALUES) OF THE NX DATA POINTS.
C                           (INPUT)
C                NX     - NUMBER OF ELEMENTS IN X AND Y. (INPUT) NX
C                           MUST BE .GE. 2.
C                C      - SPLINE COEFFICIENTS. (OUTPUT) C IS AN NX-1 BY
C                           3 MATRIX. THE VALUE OF THE SPLINE
C                           APPROXIMATION AT T IS
C                           S(T) = ((C(I,3)*D+C(I,2))*D+C(I,1))*D+Y(I)
C                           WHERE X(I) .LE. T .LT. X(I+1) AND
C                           D = T-X(I).
C                IC     - ROW DIMENSION OF MATRIX C EXACTLY AS
C                           SPECIFIED IN THE DIMENSION STATEMENT IN
C                           THE CALLING PROGRAM. (INPUT)
C                IER    - ERROR PARAMETER. (OUTPUT)
C                         TERMINAL ERROR
C                           IER = 129, IC IS LESS THAN NX-1.
C                           IER = 130, NX IS LESS THAN 2.
C                           IER = 131, INPUT ABSCISSA ARE NOT ORDERED
C                             SO THAT X(1) .LT. X(2) ... .LT. X(NX).
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1980 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE ICSCCU(X, Y, NX, C, IC, IER)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:53:12   6/14/01  
C...Switches: -p4 -yb
      IMPLICIT NONE
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      INTEGER NX, IC, IER
      REAL, DIMENSION(NX) :: X, Y
      REAL, DIMENSION(IC,3) :: C
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      INTEGER :: IM1, I, JJ, J, MM1, MP1, M, NM1, NM2
      REAL :: DIVDF1, DIVDF3, DTAU, G
      REAL, DIMENSION(3) :: CNX
C-----------------------------------------------
C                                  SPECIFICATIONS FOR ARGUMENTS
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
C                                  FIRST EXECUTABLE STATEMENT
      NM1 = NX - 1
      IER = 129
      IF (IC < NM1) GO TO 9000
      IER = 130
      IF (NX < 2) GO TO 9000
      IER = 131
      IF (NX /= 2) THEN
C                                  COMPUTE NOT-A-KNOT SPLINE
         DO M = 2, NM1
            MM1 = M - 1
            C(M,2) = X(M) - X(MM1)
            IF (C(M,2) <= 0.0) GO TO 9000
            C(M,3) = (Y(M)-Y(MM1))/C(M,2)
         END DO
         CNX(2) = X(NX) - X(NM1)
         IF (CNX(2) <= 0.0) GO TO 9000
         CNX(3) = (Y(NX)-Y(NM1))/CNX(2)
         IER = 0
         NM2 = NX - 2
         IF (NX <= 3) THEN
            C(1,3) = CNX(2)
            C(1,2) = C(2,2) + CNX(2)
            C(1,1) = ((C(2,2)+2.*C(1,2))*C(2,3)*CNX(2)+C(2,2)**2*CNX(3))
     1         /C(1,2)
         ELSE
            C(1,3) = C(3,2)
            C(1,2) = C(2,2) + C(3,2)
            C(1,1) = ((C(2,2)+2.*C(1,2))*C(2,3)*C(3,2)+C(2,2)**2*C(3,3))
     1         /C(1,2)
            DO M = 2, NM2
               MP1 = M + 1
               MM1 = M - 1
               G = -C(MP1,2)/C(MM1,3)
               C(M,1) = G*C(MM1,1) + 3.*C(M,2)*C(MP1,3) + 3.*C(MP1,2)*C(
     1            M,3)
               C(M,3) = G*C(MM1,2) + 2.*C(M,2) + 2.*C(MP1,2)
            END DO
         ENDIF
         G = -CNX(2)/C(NM2,3)
         C(NM1,1) = G*C(NM2,1) + 3.*C(NM1,2)*CNX(3) + 3.*CNX(2)*C(NM1,3)
         C(NM1,3) = G*C(NM2,2) + 2.*C(NM1,2) + 2.*CNX(2)
         IF (NX <= 3) THEN
            CNX(1) = 2.*CNX(3)
            CNX(3) = 1.
            G = -1./C(NM1,3)
         ELSE
            G = C(NM1,2) + CNX(2)
            CNX(1) = ((CNX(2)+2.*G)*CNX(3)*C(NM1,2)+CNX(2)**2*(Y(NM1)-Y(
     1         NX-2))/C(NM1,2))/G
            G = -G/C(NM1,3)
            CNX(3) = C(NM1,2)
         ENDIF
         CNX(3) = G*C(NM1,2) + CNX(3)
         CNX(1) = (G*C(NM1,1)+CNX(1))/CNX(3)
         C(NM1,1) = (C(NM1,1)-C(NM1,2)*CNX(1))/C(NM1,3)
         DO JJ = 1, NM2
            J = NM1 - JJ
            C(J,1) = (C(J,1)-C(J,2)*C(J+1,1))/C(J,3)
         END DO
         DO I = 2, NM1
            IM1 = I - 1
            DTAU = C(I,2)
            DIVDF1 = (Y(I)-Y(IM1))/DTAU
            DIVDF3 = C(IM1,1) + C(I,1) - 2.*DIVDF1
            C(IM1,2) = (DIVDF1 - C(IM1,1)-DIVDF3)/DTAU
            C(IM1,3) = DIVDF3/DTAU**2
         END DO
         DTAU = CNX(2)
         DIVDF1 = (Y(NX)-Y(NM1))/DTAU
         DIVDF3 = C(NM1,1) + CNX(1) - 2.*DIVDF1
         C(NM1,2) = (DIVDF1 - C(NM1,1)-DIVDF3)/DTAU
         C(NM1,3) = DIVDF3/DTAU**2
         GO TO 9005
      ENDIF
      IF (X(1) >= X(2)) GO TO 9000
      IER = 0
      C(1,1) = (Y(2)-Y(1))/(X(2)-X(1))
      C(1,2) = 0.0
      C(1,3) = 0.0
      GO TO 9005
 9000 CONTINUE
      CALL UERTST (IER, 6HICSCCU)
 9005 CONTINUE
      RETURN 
      END SUBROUTINE ICSCCU
C   IMSL ROUTINE NAME   - ICSEVU
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JANUARY 1, 1978
C
C   PURPOSE             - EVALUATION OF A CUBIC SPLINE
C
C   USAGE               - CALL ICSEVU(X,Y,NX,C,IC,U,S,M,IER)
C
C   ARGUMENTS    X      - VECTOR OF LENGTH NX CONTAINING THE ABSCISSAE
C                           OF THE NX DATA POINTS (X(I),Y(I)) I=1,...,
C                           NX (INPUT). X MUST BE ORDERED SO THAT
C                           X(I) .LT. X(I+1).
C                Y      - VECTOR OF LENGTH NX CONTAINING THE ORDINATES
C                           (OR FUNCTION VALUES) OF THE NX DATA POINTS
C                           (INPUT).
C                NX     - NUMBER OF ELEMENTS IN X AND Y (INPUT).
C                           NX MUST BE .GE. 2.
C                C      - SPLINE COEFFICIENTS (INPUT). C IS AN NX-1 BY
C                           3 MATRIX.
C                IC     - ROW DIMENSION OF MATRIX C EXACTLY AS
C                           SPECIFIED IN THE DIMENSION STATEMENT
C                           IN THE CALLING PROGRAM (INPUT).
C                           IC MUST BE .GE. NX-1.
C                U      - VECTOR OF LENGTH M CONTAINING THE ABSCISSAE
C                           OF THE M POINTS AT WHICH THE CUBIC SPLINE
C                           IS TO BE EVALUATED (INPUT).
C                S      - VECTOR OF LENGTH M (OUTPUT).
C                           THE VALUE OF THE SPLINE APPROXIMATION AT
C                           U(I) IS
C                           S(I) = ((C(J,3)*D+C(J,2))*D+C(J,1))*D+Y(J)
C                           WHERE X(J) .LE. U(I) .LT. X(J+1) AND
C                           D = U(I)-X(J).
C                M      - NUMBER OF ELEMENTS IN U AND S (INPUT).
C                IER    - ERROR PARAMETER (OUTPUT).
C                         WARNING ERROR
C                           IER = 33, U(I) IS LESS THAN X(1).
C                           IER = 34, U(I) IS GREATER THAN X(NX).
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   REMARKS  1.  THE ROUTINE ASSUMES THAT THE ABSCISSAE OF THE NX
C                DATA POINTS ARE ORDERED SUCH THAT X(I) IS LESS THAN
C                X(I+1) FOR I=1,...,NX-1. NO CHECK OF THIS CONDITION
C                IS MADE IN THE ROUTINE. UNORDERED ABSCISSAE WILL CAUSE
C                THE ALGORITHM TO PRODUCE INCORRECT RESULTS.
C            2.  THE ROUTINE GENERATES TWO WARNING ERRORS. ONE ERROR
C                OCCURS IF U(I) IS LESS THAN X(1), FOR SOME I IN THE
C                THE INTERVAL (1,M) INCLUSIVELY. THE OTHER ERROR OCCURS
C                IF U(I) IS GREATER THAN X(NX), FOR SOME I IN THE
C                INTERVAL (1,M) INCLUSIVELY.
C            3.  THE ORDINATE Y(NX) IS NOT USED BY THE ROUTINE. FOR
C                U(K) .GT. X(NX-1), THE VALUE OF THE SPLINE, S(K), IS
C                GIVEN BY
C                 S(K)=((C(NX-1,3)*D+C(NX-1,2))*D+C(NX-1,1))*D+Y(NX-1)
C                WHERE D=U(K)-X(NX-1).
C
C   COPYRIGHT           - 1978 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE ICSEVU(X, Y, NX, C, IC, U, S, M, IER)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:53:12   6/14/01  
C...Switches: -p4 -yb
      IMPLICIT NONE
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      INTEGER NX, IC, M, IER
      REAL, DIMENSION(NX) :: X, Y
      REAL, DIMENSION(IC,3) :: C
      REAL, DIMENSION(M) :: U, S
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      INTEGER :: I, JER, KER, NXM1, K
      REAL :: D, DD, ZERO
C-----------------------------------------------
C                                  SPECIFICATIONS FOR ARGUMENTS
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      DATA I/1/
      DATA ZERO/0.0/
C                                  FIRST EXECUTABLE STATEMENT
      JER = 0
      KER = 0
      IF (M > 0) THEN
         NXM1 = NX - 1
         IF (I > NXM1) I = 1
C                                  EVALUATE SPLINE AT M POINTS
         DO K = 1, M
C                                  FIND THE PROPER INTERVAL
            D = U(K) - X(I)
            IF (D > 0.) GO TO 15
            IF (D == 0.) GO TO 25
            IF (I == 1) GO TO 30
            I = I - 1
            D = U(K) - X(I)
            DO WHILE(D < 0.)
               IF (I == 1) GO TO 30
               I = I - 1
               D = U(K) - X(I)
            END DO
            IF (D == 0.) GO TO 25
            GO TO 20
   10       CONTINUE
            I = I + 1
            D = DD
   15       CONTINUE
            IF (I >= NX) GO TO 35
            DD = U(K) - X(I+1)
            IF (DD >= ZERO) GO TO 10
            IF (D == ZERO) GO TO 25
C                                  PERFORM EVALUATION
   20       CONTINUE
            S(K) = ((C(I,3)*D+C(I,2))*D+C(I,1))*D + Y(I)
            CYCLE 
   25       CONTINUE
            S(K) = Y(I)
            CYCLE 
C                                  WARNING - U(I) .LT. X(1)
   30       CONTINUE
            JER = 33
            GO TO 20
C                                  IF U(I) .GT. X(NX) - WARNING
   35       CONTINUE
            IF (DD > ZERO) KER = 34
            D = U(K) - X(NXM1)
            I = NXM1
            GO TO 20
         END DO
         IER = MAX0(JER,KER)
         IF (JER > 0) CALL UERTST (JER, 6HICSEVU)
         IF (KER > 0) CALL UERTST (KER, 6HICSEVU)
      ENDIF
      RETURN 
      END SUBROUTINE ICSEVU
C   IMSL ROUTINE NAME   - ICSICU
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JANUARY 1, 1978
C
C   PURPOSE             - INTERPOLATORY APPROXIMATION BY CUBIC SPLINES
C                           WITH ARBITRARY SECOND DERIVATIVE END
C                           CONDITIONS.
C
C   USAGE               - CALL ICSICU (X,Y,NX,BPAR,C,IC,IER)
C
C   ARGUMENTS    X      - VECTOR OF LENGTH NX CONTAINING THE ABSCISSAE
C                           OF THE NX DATA POINTS (X(I),Y(I)) I=1,...,
C                           NX. (INPUT) X MUST BE ORDERED SO THAT
C                           X(I) .LT. X(I+1).
C                Y      - VECTOR OF LENGTH NX CONTAINING THE ORDINATES
C                           (OR FUNCTION VALUES) OF THE NX DATA POINTS.
C                           (INPUT)
C                NX     - NUMBER OF ELEMENTS IN X AND Y. (INPUT) NX
C                           MUST BE .GE. 2.
C                BPAR   - VECTOR OF LENGTH 4 CONTAINING THE END
C                           CONDITION PARAMETERS. (INPUT)
C                           2.0*SPP(1)+BPAR(1)*SPP(2) = BPAR(2),
C                           BPAR(3)*SPP(NX-1)+2.0*SPP(NX) = BPAR(4),
C                           WHERE SPP(I) = SECOND DERIVATIVE OF THE
C                           CUBIC SPLINE FUNCTION S EVALUATED AT X(I).
C                C      - SPLINE COEFFICIENTS. (OUTPUT) C IS AN NX-1 BY
C                           3 MATRIX. THE VALUE OF THE SPLINE
C                           APPROXIMATION AT T IS
C                           S(T) = ((C(I,3)*D+C(I,2))*D+C(I,1))*D+Y(I)
C                           WHERE X(I) .LE. T .LT. X(I+1) AND
C                           D = T-X(I).
C                IC     - ROW DIMENSION OF MATRIX C EXACTLY AS
C                           SPECIFIED IN THE DIMENSION STATEMENT IN
C                           THE CALLING PROGRAM. (INPUT)
C                IER    - ERROR PARAMETER. (OUTPUT)
C                         TERMINAL ERROR
C                           IER = 129, IC IS LESS THAN NX-1.
C                           IER = 130, NX IS LESS THAN 2.
C                           IER = 131, INPUT ABSCISSA ARE NOT ORDERED
C                             SO THAT X(1) .LT. X(2) ... .LT. X(NX).
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1978 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE ICSICU(X, Y, NX, BPAR, C, IC, IER)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:53:12   6/14/01  
C...Switches: -p4 -yb
      IMPLICIT NONE
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      INTEGER NX, IC, IER
      REAL, DIMENSION(NX) :: X, Y
      REAL, DIMENSION(4) :: BPAR
      REAL, DIMENSION(IC,3) :: C
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      INTEGER :: I, J, NXM1
      REAL :: DX, DXJ, DXJP1, DXP, DYJ, DYJP1, HALF, ONE, PJ, SIX, SIXI
     1   , TWO, YPPA, YPPB, ZERO
C-----------------------------------------------
C                                  SPECIFICATIONS FOR ARGUMENTS
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      EQUIVALENCE (DXJ, YPPB), (PJ, SIXI), (DXJP1, YPPA)
      DATA ZERO/0.0/
      DATA HALF/0.5/
      DATA ONE/1.0/
      DATA TWO/2.0/
      DATA SIX/6.0/
C                                  FIRST EXECUTABLE STATEMENT
      IER = 0
C                                  CHECK ERROR CONDITIONS
      NXM1 = NX - 1
      IF (IC >= NXM1) THEN
         IF (NX < 2) GO TO 35
         IF (NX /= 2) THEN
C                                  COMPUTE COEFFICIENTS AND RIGHT
C                                  HAND SIDE OF THE TRIDIAGONAL
C                                  SYSTEM DEFINING THE SECOND
C                                  DERIVATIVES OF THE SPLINE
C                                  INTERPOLANT FOR (X,Y)
C                                  C(J,1) = LAMBDA(J)
C                                  C(J,2) = MU(J)
C                                  C(J,3) = D(J)
            DXJ = X(2) - X(1)
            J = 1
            IF (DXJ <= ZERO) GO TO 40
            DYJ = Y(2) - Y(1)
            DO J = 2, NXM1
               DXJP1 = X(J+1) - X(J)
               IF (DXJP1 <= ZERO) GO TO 40
               DYJP1 = Y(J+1) - Y(J)
               DXP = DXJ + DXJP1
               C(J,1) = DXJP1/DXP
               C(J,2) = ONE - C(J,1)
               C(J,3) = SIX*(DYJP1/DXJP1 - DYJ/DXJ)/DXP
               DXJ = DXJP1
               DYJ = DYJP1
            END DO
C                                  FACTOR THE TRIDIAGONAL MATRIX
C                                  AND SOLVE FOR U
C                                  C(J,2) = U(J)
C                                  C(J,1) = Q(J)
C                                  BPAR(1) = LAMBDA(1)
C                                  BPAR(2) = D(1)
C                                  BPAR(3) = MU(NX)
C                                  BPAR(4) = D(NX)
         ENDIF
         C(1,1) = -BPAR(1)*HALF
         C(1,2) = BPAR(2)*HALF
         IF (NX /= 2) THEN
            DO J = 2, NXM1
               PJ = C(J,2)*C(J-1,1) + TWO
               C(J,1) = -C(J,1)/PJ
               C(J,2) = (C(J,3)-C(J,2)*C(J-1,2))/PJ
            END DO
C                                  SOLVE FOR CUBIC COEFFICIENTS
C                                  OF SPLINE INTERPOLANT
C                                  C(J,1), C(J,2), AND C(J,3)
         ENDIF
         YPPB = (BPAR(4)-BPAR(3)*C(NXM1,2))/(BPAR(3)*C(NXM1,1)+TWO)
         SIXI = ONE/SIX
         DO I = 1, NXM1
            J = NX - I
            YPPA = C(J,1)*YPPB + C(J,2)
            DX = X(J+1) - X(J)
            C(J,3) = SIXI*(YPPB - YPPA)/DX
            C(J,2) = HALF*YPPA
            C(J,1) = (Y(J+1)-Y(J))/DX - (C(J,2)+C(J,3)*DX)*DX
            YPPB = YPPA
         END DO
         GO TO 9005
      ENDIF
      IER = 129
      GO TO 9000
   35 CONTINUE
      IER = 130
      GO TO 9000
   40 CONTINUE
      IER = 131
 9000 CONTINUE
      CALL UERTST (IER, 6HICSICU)
 9005 CONTINUE
      RETURN 
      END SUBROUTINE ICSICU
C   IMSL ROUTINE NAME   - LEQT2F
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JUNE 1, 1982
C
C   PURPOSE             - LINEAR EQUATION SOLUTION - FULL STORAGE
C                           MODE - HIGH ACCURACY SOLUTION
C
C   USAGE               - CALL LEQT2F (A,M,N,IA,B,IDGT,WKAREA,IER)
C
C   ARGUMENTS    A      - INPUT MATRIX OF DIMENSION N BY N CONTAINING
C                           THE COEFFICIENT MATRIX OF THE EQUATION
C                           AX = B.
C                M      - NUMBER OF RIGHT-HAND SIDES. (INPUT)
C                N      - ORDER OF A AND NUMBER OF ROWS IN B. (INPUT)
C                IA     - ROW DIMENSION OF A AND B EXACTLY AS SPECIFIED
C                           IN THE DIMENSION STATEMENT IN THE CALLING
C                           PROGRAM. (INPUT)
C                B      - INPUT MATRIX OF DIMENSION N BY M CONTAINING
C                           THE RIGHT-HAND SIDES OF THE EQUATION AX = B.
C                           ON OUTPUT, THE N BY M MATRIX OF SOLUTIONS
C                           REPLACES B.
C                IDGT   - INPUT OPTION.
C                         IF IDGT IS GREATER THAN 0, THE ELEMENTS OF
C                           A AND B ARE ASSUMED TO BE CORRECT TO IDGT
C                           DECIMAL DIGITS AND THE ROUTINE PERFORMS
C                           AN ACCURACY TEST.
C                         IF IDGT EQUALS 0, THE ACCURACY TEST IS
C                           BYPASSED.
C                         ON OUTPUT, IDGT CONTAINS THE APPROXIMATE
C                           NUMBER OF DIGITS IN THE ANSWER WHICH
C                           WERE UNCHANGED AFTER IMPROVEMENT.
C                WKAREA - WORK AREA OF DIMENSION GREATER THAN OR EQUAL
C                           TO N**2+3N.
C                IER    - ERROR PARAMETER. (OUTPUT)
C                         WARNING ERROR
C                           IER = 34 INDICATES THAT THE ACCURACY TEST
C                             FAILED. THE COMPUTED SOLUTION MAY BE IN
C                             ERROR BY MORE THAN CAN BE ACCOUNTED FOR
C                             BY THE UNCERTAINTY OF THE DATA. THIS
C                             WARNING CAN BE PRODUCED ONLY IF IDGT IS
C                             GREATER THAN 0 ON INPUT. (SEE THE
C                             CHAPTER L PRELUDE FOR FURTHER DISCUSSION.)
C                         TERMINAL ERROR
C                           IER = 129 INDICATES THAT THE MATRIX IS
C                             ALGORITHMICALLY SINGULAR. (SEE THE
C                             CHAPTER L PRELUDE).
C                           IER = 131 INDICATES THAT THE MATRIX IS TOO
C                             ILL-CONDITIONED FOR ITERATIVE IMPROVEMENT
C                             TO BE EFFECTIVE.
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - SINGLE/LUDATN,LUELMN,LUREFN,UERTST,UGETIO
C                       - DOUBLE/LUDATN,LUELMN,LUREFN,UERTST,UGETIO,
C                           VXADD,VXMUL,VXSTO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE LEQT2F(A, M, N, IA, B, IDGT, WKAREA, IER)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:53:12   6/14/01  
C...Switches: -p4 -yb
      IMPLICIT NONE
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      INTEGER M, N, IA, IDGT, IER
      REAL, DIMENSION(IA,1) :: A, B
      REAL, DIMENSION(1) :: WKAREA
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      INTEGER :: JER, J, K, MM, KK, MM1, JJ, L, I, II
      REAL :: D1, D2, WA
C-----------------------------------------------
C
C                                  FIRST EXECUTABLE STATEMENT
C                                  INITIALIZE IER
      IER = 0
      JER = 0
      J = N*N + 1
      K = J + N
      MM = K + N
      KK = 0
      MM1 = MM - 1
      JJ = 1
      DO L = 1, N
         WKAREA(JJ:N-1+JJ) = A(:N,L)
         JJ = N + JJ
      END DO
C                                  DECOMPOSE A
      CALL LUDATN (WKAREA, N, N, A, IA, IDGT, D1, D2, WKAREA(J), WKAREA(
     1   K), WA, IER)
      IF (IER <= 128) THEN
         IF (IDGT==0 .OR. IER/=0) KK = 1
         DO I = 1, M
C                                  PERFORMS THE ELIMINATION PART OF
C                                  AX = B
            CALL LUELMN (A, IA, N, B(1,I), WKAREA(J), WKAREA(MM))
C                                  REFINEMENT OF SOLUTION TO AX = B
            IF (KK /= 0) CALL LUREFN (WKAREA, N, N, A, IA, B(1,I), IDGT
     1         , WKAREA(J), WKAREA(MM), WKAREA(K), WKAREA(K), JER)
            B(:N,I) = WKAREA(MM1+1:N+MM1)
            IF (JER /= 0) GO TO 20
         END DO
         GO TO 25
   20    CONTINUE
         IER = 131
      ENDIF
   25 CONTINUE
      JJ = 1
      DO J = 1, N
         A(:N,J) = WKAREA(JJ:N-1+JJ)
         JJ = N + JJ
      END DO
      IF (IER /= 0) CALL UERTST (IER, 6HLEQT2F)
      RETURN 
      END SUBROUTINE LEQT2F
C   IMSL ROUTINE NAME   - LUDATN
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JUNE 1, 1982
C
C   PURPOSE             - NUCLEUS CALLED ONLY BY IMSL SUBROUTINE LEQT2F
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE LUDATN(A, IA, N, LU, ILU, IDGT, D1, D2, APVT, EQUIL, WA
     1   , IER)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:53:12   6/14/01  
C...Switches: -p4 -yb
      IMPLICIT NONE
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      INTEGER IA, N, ILU, IDGT, IER
      REAL D1, D2, WA
      REAL, DIMENSION(IA,1) :: A
      REAL, DIMENSION(ILU,1) :: LU
      REAL, DIMENSION(1) :: APVT, EQUIL
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      INTEGER :: I, J, JM1, IM1, K, IMAX, JP1
      REAL :: ZERO, ONE, FOUR, SIXTN, SIXTH, RN, WREL, BIGA, BIG, P, SUM
     1   , AI, WI, T, TEST, Q
C-----------------------------------------------
C
      DATA ZERO, ONE, FOUR, SIXTN, SIXTH/0.0, 1., 4., 16., .0625/
C                                  FIRST EXECUTABLE STATEMENT
C                                  INITIALIZATION
      IER = 0
      RN = N
      WREL = ZERO
      D1 = ONE
      D2 = ZERO
      BIGA = ZERO
      DO I = 1, N
         BIG = ZERO
         LU(I,:N) = A(I,:N)
         BIG = AMAX1(MAXVAL(ABS(A(I,:N))),BIG)
         BIGA = AMAX1(BIG,BIGA)
         IF (BIG == ZERO) GO TO 110
         EQUIL(I) = ONE/BIG
      END DO
      DO J = 1, N
         JM1 = J - 1
         IF (JM1 >= 1) THEN
C                                  COMPUTE U(I,J), I=1,...,J-1
            DO I = 1, JM1
               SUM = LU(I,J)
               IM1 = I - 1
               IF (IDGT /= 0) THEN
C                                  WITH ACCURACY TEST
                  AI = ABS(SUM)
                  WI = ZERO
                  IF (IM1 >= 1) THEN
                     DO K = 1, IM1
                        T = LU(I,K)*LU(K,J)
                        SUM = SUM - T
                        WI = WI + ABS(T)
                     END DO
                     LU(I,J) = SUM
                  ENDIF
                  WI = WI + ABS(SUM)
                  IF (AI == ZERO) AI = BIGA
                  TEST = WI/AI
                  WREL = AMAX1(TEST,WREL)
               ELSE
C                                  WITHOUT ACCURACY
                  IF (IM1 >= 1) THEN
                     DO K = 1, IM1
                        SUM = SUM - LU(I,K)*LU(K,J)
                     END DO
                     LU(I,J) = SUM
                  ENDIF
               ENDIF
            END DO
         ENDIF
         P = ZERO
C                                  COMPUTE U(J,J) AND L(I,J), I=J+1,...,
         DO I = J, N
            SUM = LU(I,J)
            IF (IDGT /= 0) THEN
C                                  WITH ACCURACY TEST
               AI = ABS(SUM)
               WI = ZERO
               IF (JM1 >= 1) THEN
                  DO K = 1, JM1
                     T = LU(I,K)*LU(K,J)
                     SUM = SUM - T
                     WI = WI + ABS(T)
                  END DO
                  LU(I,J) = SUM
               ENDIF
               WI = WI + ABS(SUM)
               IF (AI == ZERO) AI = BIGA
               TEST = WI/AI
               WREL = AMAX1(TEST,WREL)
            ELSE
C                                  WITHOUT ACCURACY TEST
               IF (JM1 >= 1) THEN
                  DO K = 1, JM1
                     SUM = SUM - LU(I,K)*LU(K,J)
                  END DO
                  LU(I,J) = SUM
               ENDIF
            ENDIF
            Q = EQUIL(I)*ABS(SUM)
            IF (P < Q) THEN
               P = Q
               IMAX = I
            ENDIF
         END DO
C                                  TEST FOR ALGORITHMIC SINGULARITY
         IF (RN + P == RN) GO TO 110
         IF (J /= IMAX) THEN
C                                  INTERCHANGE ROWS J AND IMAX
            D1 = -D1
            DO K = 1, N
               P = LU(IMAX,K)
               LU(IMAX,K) = LU(J,K)
               LU(J,K) = P
            END DO
            EQUIL(IMAX) = EQUIL(J)
         ENDIF
         APVT(J) = IMAX
         D1 = D1*LU(J,J)
   85    CONTINUE
         IF (ABS(D1) <= ONE) GO TO 90
         D1 = D1*SIXTH
         D2 = D2 + FOUR
         GO TO 85
   90    CONTINUE
         IF (ABS(D1) >= SIXTH) GO TO 95
         D1 = D1*SIXTN
         D2 = D2 - FOUR
         GO TO 90
   95    CONTINUE
         JP1 = J + 1
         IF (JP1 <= N) THEN
C                                  DIVIDE BY PIVOT ELEMENT U(J,J)
            P = LU(J,J)
            LU(JP1:N,J) = LU(JP1:N,J)/P
         ENDIF
      END DO
C                                  PERFORM ACCURACY TEST
      IF (IDGT == 0) GO TO 9005
      P = 3*N + 3
      WA = P*WREL
      IF (WA + 10.0**(-IDGT) /= WA) GO TO 9005
      IER = 34
      GO TO 9000
C                                  ALGORITHMIC SINGULARITY
  110 CONTINUE
      IER = 129
      D1 = ZERO
      D2 = ZERO
 9000 CONTINUE
C                                  PRINT ERROR
      CALL UERTST (IER, 6HLUDATN)
 9005 CONTINUE
      RETURN 
      END SUBROUTINE LUDATN
C   IMSL ROUTINE NAME   - LUELMN
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JUNE 1, 1982
C
C   PURPOSE             - NUCLEUS CALLED ONLY BY IMSL SUBROUTINE LEQT2F
C
C   REQD. IMSL ROUTINES - NONE REQUIRED
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE LUELMN(A, IA, N, B, APVT, X)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:53:12   6/14/01  
C...Switches: -p4 -yb
      IMPLICIT NONE
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      INTEGER IA, N
      REAL, DIMENSION(IA,1) :: A
      REAL, DIMENSION(1) :: B, APVT, X
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      INTEGER :: I, IW, IP, IM1, J, IB, IP1
      REAL :: SUM
C-----------------------------------------------
C
C                                  FIRST EXECUTABLE STATEMENT
C                                  SOLVE LY = B FOR Y
      X(:N) = B(:N)
      IW = 0
      DO I = 1, N
         IP = APVT(I)
         SUM = X(IP)
         X(IP) = X(I)
         IF (IW /= 0) THEN
            IM1 = I - 1
            DO J = IW, IM1
               SUM = SUM - A(I,J)*X(J)
            END DO
         ELSE
            IF (SUM /= 0.) IW = I
         ENDIF
         X(I) = SUM
      END DO
C                                  SOLVE UX = Y FOR X
      DO IB = 1, N
         I = N + 1 - IB
         IP1 = I + 1
         SUM = X(I)
         IF (IP1 <= N) THEN
            DO J = IP1, N
               SUM = SUM - A(I,J)*X(J)
            END DO
         ENDIF
         X(I) = SUM/A(I,I)
      END DO
      RETURN 
      END SUBROUTINE LUELMN
C   IMSL ROUTINE NAME   - LUREFN
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JUNE 1, 1982
C
C   PURPOSE             - NUCLEUS CALLED ONLY BY IMSL SUBROUTINE LEQT2F
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - SINGLE/LUELMN,UERTST,UGETIO
C                       - DOUBLE/LUELMN,UERTST,UGETIO,VXADD,VXMUL,
C                           VXSTO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE LUREFN(A, IA, N, UL, IUL, B, IDGT, APVT, X, RES, DX, 
     1   IER)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:53:12   6/14/01  
C...Switches: -p4 -yb
      IMPLICIT NONE
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      INTEGER IA, N, IUL, IDGT, IER
      REAL, DIMENSION(IA,1) :: A
      REAL, DIMENSION(IUL,1) :: UL
      REAL, DIMENSION(1) :: B, APVT, X, RES, DX
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      INTEGER :: ITMAX, I, ITER, J
      REAL :: ZERO, XNORM, DXNORM
      DOUBLE PRECISION :: SUM
C-----------------------------------------------
C
      DATA ITMAX/50/
      DATA ZERO/0.0/
C                                  FIRST EXECUTABLE STATEMENT
      IER = 0
      XNORM = ZERO
      XNORM = AMAX1(XNORM,MAXVAL(ABS(X(:N))))
      IF (XNORM == ZERO) THEN
         IDGT = 50
      ELSE
         DO ITER = 1, ITMAX
            DO I = 1, N
               SUM = DBLE(B(I))
               DO J = 1, N
                  SUM = SUM - DBLE(A(I,J))*DBLE(X(J))
               END DO
               RES(I) = SUM
            END DO
            CALL LUELMN (UL, IUL, N, RES, APVT, DX)
            DXNORM = ZERO
            XNORM = ZERO
            X(:N) = X(:N) + DX(:N)
            DXNORM = AMAX1(DXNORM,MAXVAL(ABS(DX(:N))))
            XNORM = AMAX1(XNORM,MAXVAL(ABS(X(:N))))
            IF (ITER == 1) THEN
               IDGT = 50
               IF (DXNORM /= ZERO) IDGT = -ALOG10(DXNORM/XNORM)
            ENDIF
            IF (XNORM + DXNORM == XNORM) GO TO 9005
         END DO
C                                  ITERATION DID NOT CONVERGE
         IER = 129
         CALL UERTST (IER, 6HLUREFN)
      ENDIF
 9005 CONTINUE
      RETURN 
      END SUBROUTINE LUREFN
C   IMSL ROUTINE NAME   - MMBSIR
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/DOUBLE
C
C   LATEST REVISION     - JULY 1, 1983
C
C   PURPOSE             - MODIFIED BESSEL FUNCTION OF THE FIRST KIND
C                           OF NONNEGATIVE REAL ORDER FOR REAL POSITIVE
C                           ARGUMENTS WITH EXPONENTIAL SCALING OPTION
C
C   USAGE               - CALL MMBSIR (ARG,ORDER,N,IOPT,B,IER)
C
C   ARGUMENTS    ARG    - INPUT ARGUMENT. ARG MUST BE TYPED APPRO-
C                           PRIATELY IN THE CALLING PROGRAM. (SEE THE
C                           PRECISION/HARDWARE SECTION.) ARG MUST BE
C                           GREATER THAN OR EQUAL TO ZERO. IF SCALING
C                           IS NOT DESIRED (IOPT = 1), THEN ARG MUST BE
C                           LESS THAN EXPARG. EXPARG IS APPROXIMATELY
C                           THE LARGEST ACCEPTABLE ARGUMENT FOR THE
C                           FORTRAN EXP FUNCTION. SEE THE PROGRAMMING
C                           NOTES IN THE MANUAL FOR THE EXACT VALUE OF
C                           EXPARG.
C                ORDER  - INPUT VALUE SPECIFYING THE DESIRED ORDER OF
C                           THE BESSEL FUNCTION. ORDER MUST BE TYPED
C                           APPROPRIATELY IN THE CALLING PROGRAM. (SEE
C                           THE PRECISION/HARDWARE SECTION.) ORDER MUST
C                           BE GREATER THAN OR EQUAL TO ZERO AND LESS
C                           THAN ONE.
C                N      - INPUT PARAMETER SPECIFYING THE NUMBER OF
C                           FUNCTION VALUES TO BE COMPUTED.
C                IOPT   - INPUT SCALING OPTION SWITCH.
C                           IF IOPT = 1 THEN THE BESSEL FUNCTIONS
C                           CALCULATED ARE UNSCALED.
C                           IF IOPT = 2 THEN THE BESSEL FUNCTIONS
C                           CALCULATED ARE SCALED BY EXP(-ARG).
C                B      - OUTPUT VECTOR OF LENGTH N CONTAINING THE
C                           COMPUTED FUNCTION VALUES. B MUST BE TYPED
C                           APPROPRIATELY IN THE CALLING PROGRAM. (SEE
C                           THE PRECISION/HARDWARE SECTION.) B(1) WILL
C                           CONTAIN THE COMPUTED VALUE FOR THE INPUT
C                           ORDER, B(2) WILL CONTAIN THE COMPUTED
C                           FUNCTION VALUE FOR ORDER + 1, B(3) FOR
C                           ORDER + 2, ETC.
C                IER    - ERROR PARAMETER. (OUTPUT)
C                         TERMINAL ERROR
C                           IER = 129 INDICATES THAT ONE OR MORE OF
C                             THE INPUT ARGUMENTS, ARG, ORDER, N,
C                             OR IOPT, IS OUT OF RANGE. B(I), (I=1,N)
C                             IS SET TO MACHINE INFINITY.
C                           IER = 129+J INDICATES THAT N WAS SO MUCH
C                             GREATER THAN THE LARGEST INTEGER IN ARG
C                             THAT ONLY B(I), (I=1,J) WAS CALCULATED
C                             CORRECTLY. SEE THE PROGRAMMING NOTES
C                             FOR THE ACCURACY OF THE REMAINING B(I).
C
C   PRECISION/HARDWARE  - DOUBLE/H32,H36
C                       - SINGLE/H48,H60
C
C   REQD. IMSL ROUTINES - H32,H36/MGAMAD=DGAMMA,UERTST,UGETIO
C                         H48,H60/MGAMA=GAMMA,UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MMBSIR(ARG, ORDER, N, IOPT, B, IER)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:53:12   6/14/01  
C...Switches: -p4 -yb
      IMPLICIT NONE
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      INTEGER N, IOPT, IER
      DOUBLE PRECISION ARG, ORDER
      DOUBLE PRECISION, DIMENSION(1) :: B
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      INTEGER :: IDUM, NSIG, ISUM, MAGX, NCALC, NBMX, ISTEP, NEND, 
     1   NSTART, NN, L, I, INTEN
      DOUBLE PRECISION :: P, TEST, TEMPA, TEMPB, TEMPC, EXPARG, SUM, 
     1   TOVER, PLAST, POLD, PSAVE, PSAVEL, ENTEN, ENSIG, RTNSIG, EN, EM
     2   , EMPAL, EMP2AL, ENMTEN, STEP, STEP2, XLARGE, HALFX, ZSIG, 
     3   SMALL, XINF, XNTEN
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      DOUBLE PRECISION , EXTERNAL :: DGAMMA
C-----------------------------------------------
C                                  SPECIFICATIONS FOR ARGUMENTS
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      DATA SMALL/2.938735878D-39/
      DATA XLARGE/1.D+04/
      DATA XINF/1.700000000D+38/
      DATA ZSIG/16.8D0/
      DATA EXPARG/88.0/
      DATA XNTEN/38.D0/
C                                  FIRST EXECUTABLE STATEMENT
      NSIG = IFIX(SNGL(ZSIG))
      ISUM = -NSIG/4
      RTNSIG = 10.D0**ISUM
      IER = 0
      INTEN = XNTEN
      ENTEN = 10.D0**INTEN
      ENSIG = 10.0D0**NSIG
      ENMTEN = 4.D0*SMALL
      TEMPA = ARG
C                                  CHECK ARGUMENT RANGE
      IF (.NOT.(N>0 .AND. ARG>=0.D0 .AND. (IOPT==1 .AND. ARG<=EXPARG
     1    .OR. IOPT==2 .AND. ARG<=XLARGE) .AND. ORDER>=0.D0 .AND. ORDER<
     2   1.D0)) THEN
         IER = 129
         NN = N
         IF (N <= 0) NN = 1
         B(:NN) = XINF
      ELSE
C                                  USE 2-TERM ASCENDING SERIES FOR
C                                    SMALL ARG
         MAGX = IFIX(SNGL(TEMPA))
         NCALC = N
         IF (TEMPA >= RTNSIG) THEN
C                                  INITIALIZE THE CALCULATION OF P*S
            NBMX = N - MAGX
            NN = MAGX + 1
            ISTEP = NN + NN
            STEP = ORDER + ORDER
            EN = DBLE(FLOAT(ISTEP)) + STEP
            PLAST = 1.D0
            P = EN/TEMPA
C                                  CALCULATE GENERAL SIGNIFICANCE TEST
            TEST = ENSIG + ENSIG
            STEP = TEST*P
            IF (2*MAGX > 5*NSIG) THEN
               TEST = DSQRT(STEP)
            ELSE
               TEST = TEST/1.585D0**MAGX
            ENDIF
            IF (NBMX >= 3) THEN
C                                  CALCULATE P*S UNTIL NN = N-1.
C                                    CHECK FOR POSSIBLE OVERFLOW.
               TOVER = ENTEN/ENSIG
               NSTART = MAGX + 2
               NEND = N - 1
               ISTEP = NSTART + NSTART
               STEP = ORDER + ORDER
               EN = DBLE(FLOAT(ISTEP)) - 2.D0 + STEP
               DO NN = NSTART, NEND
                  EN = EN + 2.D0
                  POLD = PLAST
                  PLAST = P
                  P = EN*PLAST/TEMPA + POLD
                  IF (P > TOVER) GO TO 25
               END DO
               NN = NEND
               ISTEP = NN + NN
               STEP = ORDER + ORDER
               EN = DBLE(FLOAT(ISTEP)) + STEP
C                                  CALCULATE SPECIAL SIGNIFICANCE
C                                    TEST FOR NBMX .GT. 2.
               STEP = PLAST*ENSIG
               STEP2 = P + P
               STEP = DSQRT(STEP)*DSQRT(STEP2)
               TEST = DMAX1(TEST,STEP)
C                                  CALCULATE P*S UNTIL SIGNIFICANCE
C                                    TEST PASSES
            ENDIF
            NN = NN + 1
            EN = EN + 2.D0
            POLD = PLAST
            PLAST = P
            P = EN*PLAST/TEMPA + POLD
            DO WHILE(P < TEST)
               NN = NN + 1
               EN = EN + 2.D0
               POLD = PLAST
               PLAST = P
               P = EN*PLAST/TEMPA + POLD
            END DO
            GO TO 45
C                                  TO AVOID OVERFLOW, DIVIDE P*S BY
C                                    TOVER. CALCULATE P*S UNTIL
C                                    ABS(P).GT.1.
   25       CONTINUE
            TOVER = ENTEN
            P = P/TOVER
            PLAST = PLAST/TOVER
            PSAVE = P
            PSAVEL = PLAST
            NSTART = NN + 1
            NN = NN + 1
            EN = EN + 2.D0
            POLD = PLAST
            PLAST = P
            P = EN*PLAST/TEMPA + POLD
            DO WHILE(P <= 1.D0)
               NN = NN + 1
               EN = EN + 2.D0
               POLD = PLAST
               PLAST = P
               P = EN*PLAST/TEMPA + POLD
            END DO
            TEMPB = EN/TEMPA
C                                  CALCULATE BACKWARD TEST, AND FIND
C                                    NCALC, THE HIGHEST N SUCH THAT
C                                    THE TEST IS PASSED.
            TEST = POLD*PLAST*(.5D0 - .5D0/(TEMPB*TEMPB))/ENSIG
            P = PLAST*TOVER
            NN = NN - 1
            EN = EN - 2.D0
            NEND = MIN0(N,NN)
            DO NCALC = NSTART, NEND
               POLD = PSAVEL
               PSAVEL = PSAVE
               PSAVE = EN*PSAVEL/TEMPA + POLD
               IF (PSAVE*PSAVEL > TEST) GO TO 40
            END DO
            NCALC = NEND + 1
   40       CONTINUE
            NCALC = NCALC - 1
C                                  INITIALIZE THE BACKWARD RECURSION
C                                    AND THE NORMALIZATION SUM
   45       CONTINUE
            NN = NN + 1
            EN = EN + 2.D0
            TEMPB = 0.D0
            TEMPA = 1.D0/P
            EM = DBLE(FLOAT(NN)) - 1.D0
            EMPAL = EM + ORDER
            EMP2AL = (EM - 1.D0) + (ORDER + ORDER)
            SUM = TEMPA*EMPAL*EMP2AL/EM
            NEND = NN - N
            IF (NEND >= 0) THEN
               IF (NEND /= 0) THEN
                  DO L = 1, NEND
                     NN = NN - 1
                     EN = EN - 2.D0
                     TEMPC = TEMPB
                     TEMPB = TEMPA
                     TEMPA = (EN*TEMPB)/ARG + TEMPC
                     EM = EM - 1.D0
                     EMP2AL = EMP2AL - 1.D0
                     IF (NN == 1) GO TO 60
                     IF (NN == 2) EMP2AL = 1.D0
                     EMPAL = EMPAL - 1.D0
                     SUM = (SUM + TEMPA*EMPAL)*EMP2AL/EM
                  END DO
C                                  STORE B(N)
               ENDIF
   60          CONTINUE
               B(NN) = TEMPA
               IF (N <= 1) THEN
                  SUM = (SUM + SUM) + TEMPA
                  GO TO 100
C                                  CALCULATE AND STORE B(N-1)
               ENDIF
               NN = NN - 1
               EN = EN - 2.D0
               B(NN) = (EN*TEMPA)/ARG + TEMPB
               IF (NN == 1) GO TO 95
               EM = EM - 1.D0
               EMP2AL = EMP2AL - 1.D0
               IF (NN == 2) EMP2AL = 1.D0
               EMPAL = EMPAL - 1.D0
               SUM = (SUM + B(NN)*EMPAL)*EMP2AL/EM
            ELSE
C                                  NN.LT.N, SO STORE B(NN) AND SET
C                                    HIGHER ORDERS TO ZERO
               B(NN) = TEMPA
               NEND = -NEND
               B(NN+1:NEND+NN) = 0.D0
            ENDIF
            NEND = NN - 2
            IF (NEND /= 0) THEN
C                                  CALCULATE VIA DIFFERENCE EQUATION
C                                    AND STORE B(NN), UNTIL NN = 2
               DO L = 1, NEND
                  NN = NN - 1
                  EN = EN - 2.D0
                  B(NN) = (EN*B(NN+1))/ARG + B(NN+2)
                  EM = EM - 1.D0
                  EMP2AL = EMP2AL - 1.D0
                  IF (NN == 2) EMP2AL = 1.D0
                  EMPAL = EMPAL - 1.D0
                  SUM = (SUM + B(NN)*EMPAL)*EMP2AL/EM
               END DO
C                                  CALCULATE B(1)
            ENDIF
            B(1) = 2.D0*EMPAL*B(2)/ARG + B(3)
   95       CONTINUE
            SUM = (SUM + SUM) + B(1)
C                                  NORMALIZE. DIVIDE ALL B(NN) BY SUM
  100       CONTINUE
            IF (ORDER /= 0.D0) THEN
               STEP = 1.D0 + ORDER
               SUM = SUM*DGAMMA(STEP)*(ARG*.5D0)**(-ORDER)
            ENDIF
            STEP = -ARG
            IF (IOPT == 1) SUM = SUM*DEXP(STEP)
            TEMPA = ENMTEN
            IF (SUM > 1.D0) TEMPA = TEMPA*SUM
            WHERE (B(:N) < TEMPA) B(:N) = 0.D0
            B(:N) = B(:N)/SUM
         ELSE
C                                  TWO-TERM ASCENDING SERIES FOR SMALL A
            TEMPA = 1.D0
            EMPAL = 1.D0 + ORDER
            HALFX = 0.D0
            IF (ARG > ENMTEN) HALFX = .5D0*ARG
            IF (ORDER /= 0.D0) TEMPA = HALFX**ORDER/DGAMMA(EMPAL)
            STEP = -ARG
            IF (IOPT == 2) TEMPA = TEMPA*DEXP(STEP)
            TEMPB = 0.D0
            IF (ARG + 1.D0 > 1.D0) TEMPB = HALFX*HALFX
            B(1) = TEMPA + TEMPA*TEMPB/EMPAL
            IF (ARG/=0.D0 .AND. B(1)==0.D0) NCALC = 0
            IF (N /= 1) THEN
               IF (ARG <= 0.D0) THEN
                  B(2:N) = 0.D0
                  GO TO 9005
               ENDIF
               TEMPC = HALFX
               TOVER = (ENMTEN + ENMTEN)/ARG
               IF (TEMPB /= 0.D0) TOVER = ENMTEN/TEMPB
               DO NN = 2, N
                  TEMPA = TEMPA/EMPAL
                  EMPAL = EMPAL + 1.D0
                  TEMPA = TEMPA*TEMPC
                  IF (TEMPA <= TOVER*EMPAL) TEMPA = 0.D0
                  B(NN) = TEMPA + TEMPA*TEMPB/EMPAL
                  IF (B(NN)==0.D0 .AND. NCALC>NN) NCALC = NN - 1
               END DO
            ENDIF
         ENDIF
         IF (NCALC == N) GO TO 9005
         IER = 129 + NCALC
      ENDIF
      CALL UERTST (IER, 6HMMBSIR)
 9005 CONTINUE
      RETURN 
      END SUBROUTINE MMBSIR
C   IMSL ROUTINE NAME   - MMBSKR
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/DOUBLE
C
C   LATEST REVISION     - JUNE 1, 1982
C
C   PURPOSE             - MODIFIED BESSEL FUNCTION OF THE SECOND KIND
C                           OF NONNEGATIVE REAL FRACTIONAL ORDER
C                           FOR REAL POSITIVE ARGUMENTS SCALED BY
C                           EXP(ARG)
C
C   USAGE               - CALL MMBSKR (ARG,ORDER,N,BK,IER)
C
C   ARGUMENTS    ARG    - INPUT ARGUMENT. ARG MUST BE TYPED APPRO-
C                           PRIATELY IN THE CALLING PROGRAM. (SEE THE
C                           PRECISION/HARDWARE SECTION.) ARG MUST BE
C                           GREATER THAN ZERO.
C                ORDER  - INPUT VALUE SPECIFYING THE DESIRED ORDER OF
C                           THE BESSEL FUNCTION. ORDER MUST BE TYPED
C                           APPROPRIATELY IN THE CALLING PROGRAM. (SEE
C                           THE PRECISION/HARDWARE SECTION.) ORDER MUST
C                           BE GREATER THAN OR EQUAL TO ZERO.
C                N       - INPUT VALUE SPECIFYING THE NUMBER OF
C                           FUNCTION VALUES TO BE COMPUTED.
C                BK     - OUTPUT VECTOR OF LENGTH N CONTAINING THE
C                           COMPUTED FUNCTION VALUES. BK MUST BE TYPED
C                           APPROPRIATELY IN THE CALLING PROGRAM. (SEE
C                           THE PRECISION/HARDWARE SECTION.) BK(1) WILL
C                           CONTAIN THE COMPUTED VALUE FOR THE INPUT
C                           ORDER, BK(2) WILL CONTAIN THE COMPUTED
C                           FUNCTION VALUE FOR ORDER + 1, BK(3) FOR
C                           ORDER + 2, ETC.
C                IER    - ERROR PARAMETER. (OUTPUT)
C                         TERMINAL ERROR
C                           IER = 129 INDICATES THAT ONE OR MORE OF
C                             THE INPUT ARGUMENTS, ARG, ORDER, OR N IS
C                             OUT OF RANGE. BK(I), I=1,N, IS SET TO
C                             MACHINE INFINITY.
C                           IER = 130 INDICATES THAT BK(1) IS GREATER
C                             THAN MACHINE INFINITY. BK(I), I=1,N, IS
C                             SET TO MACHINE INFINITY.
C                           IER = 131 INDICATES THAT BK(N)/BK(N-1) IS
C                             GREATER THAN MACHINE INFINITY, BUT THAT
C                             BK(1) IS COMPUTED CORRECTLY.  BK(I),
C                             I=2,N, IS SET TO MACHINE INFINITY.
C                           IER = 131+J INDICATES THAT BK(J) WOULD HAVE
C                             BEEN GREATER THAN MACHINE INFINITY.
C                             BK(L), L=J,N, IS SET TO MACHINE INFINITY.
C                             BK(L), L=1,J-1, IS COMPUTED CORRECTLY.
C
C   PRECISION/HARDWARE  - DOUBLE/H32,H36
C                       - SINGLE/H48,H60
C
C   REQD. IMSL ROUTINES - UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MMBSKR(ARG, ORDER, N, BK, IER)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:53:12   6/14/01  
C...Switches: -p4 -yb
      IMPLICIT NONE
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      INTEGER N, IER
      DOUBLE PRECISION ARG, ORDER
      DOUBLE PRECISION, DIMENSION(1) :: BK
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      INTEGER :: K, IEND, I, JER, M, J, MPLUS1, KK
      DOUBLE PRECISION :: DMINF, DNTEN, EX, TEMP, TEMP2, A, ALPHA, BK1, 
     1   BK2, C, D, DM, DMAX, DMIN, D1, D2, D3, ENU, F0, F1, F2
      DOUBLE PRECISION, DIMENSION(8) :: P
      DOUBLE PRECISION :: P0
      DOUBLE PRECISION, DIMENSION(7) :: Q
      DOUBLE PRECISION :: Q0
      DOUBLE PRECISION, DIMENSION(4) :: R
      DOUBLE PRECISION :: RATIO
      DOUBLE PRECISION, DIMENSION(4) :: S
      DOUBLE PRECISION, DIMENSION(7) :: T
      DOUBLE PRECISION :: TOL, TWONU, TWOX, T1, T2, X2BY4, XINF
C-----------------------------------------------
C                                  SPECIFICATIONS FOR ARGUMENTS
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      DATA A/.1159315156584124D0/
      DATA D/.7978845608028654D0/
      DATA DNTEN/38.D0/
      DATA DMIN/2.938735878D-39/
      DATA XINF/1.700000000D+38/
      DATA P(1)/.8056298755690433D0/
      DATA P(2)/.2040455002053652D02/
      DATA P(3)/.1577056051066762D03/
      DATA P(4)/.5366711164692075D03/
      DATA P(5)/.9003827592912888D03/
      DATA P(6)/.7309238866506604D03/
      DATA P(7)/.2292993015094251D03/
      DATA P(8)/.8224670334241132D00/
      DATA Q(1)/.2946019862478505D02/
      DATA Q(2)/.2775778685102212D03/
      DATA Q(3)/.1206703255910274D04/
      DATA Q(4)/.2762914441597915D04/
      DATA Q(5)/.3443740505065646D04/
      DATA Q(6)/.2210631901133786D04/
      DATA Q(7)/.5722673383598922D03/
      DATA R(1)/ - .1363145832225935D-02/
      DATA R(2)/.3314384097399805D-01/
      DATA R(3)/ - .2506099471699884D0/
      DATA R(4)/.8224670334241132D0/
      DATA S(1)/.2755746186513600D-02/
      DATA S(2)/ - .6530826876446539D-01/
      DATA S(3)/.5187115283864121D0/
      DATA S(4)/ - .1456159004551443D01/
      DATA T(1)/.0779373862881377D-12/
      DATA T(2)/.1605596120426673D-09/
      DATA T(3)/.2505214205064134D-07/
      DATA T(4)/.2755731902076135D-05/
      DATA T(5)/.1984126984193444D-03/
      DATA T(6)/.8333333333332269D-02/
      DATA T(7)/.1666666666666667D0/
      DATA TOL/2.775557562D-17/
C                                  A = DLOG(2.D0) - EULER S CONSTANT
C                                  D = DSQRT(2.D0/PI)
C                                  P, Q - APPROXIMATION FOR
C                                    DLOG(DGAMMA(1+ENU))/ENU + EULER S
C                                    CONSTANT
C                                  R, S - APPROXIMATION FOR
C                                    (1-ENU*PI/DSIN(ENU*PI))/(2.D0*ENU)
C                                  T - APPROXIMATION FOR DSINH(Y)/Y
C
C                                  FIRST EXECUTABLE STATEMENT
      EX = ARG
      DMAX = 10.D0**DNTEN
      IER = 0
      IF (.NOT.(ORDER>=0.D0 .AND. N>=1 .AND. EX>0.D0)) THEN
         IER = 129
         BK(1) = XINF
         IF (N < 2) GO TO 9000
         BK(2:N) = XINF
         GO TO 9000
      ENDIF
      K = ORDER + 0.5D0
      ENU = ORDER - FLOAT(K)
      IF (DABS(ENU) < 1.D-30) ENU = 0.D0
      TWONU = ENU + ENU
      IEND = N + K - 1
      C = ENU*ENU
      D3 = -C
      IF (EX <= 1.D0) THEN
C                                  CALCULATION OF P0, Q0 AND F0
         D1 = 0.D0
         D2 = P(1)
         T1 = 1.D0
         T2 = Q(1)
         DO I = 1, 3
            D1 = C*D1 + P(I*2)
         END DO
         DO I = 1, 3
            D2 = C*D2 + P(1+I*2)
         END DO
         DO I = 1, 3
            T1 = C*T1 + Q(I*2)
         END DO
         DO I = 1, 3
            T2 = C*T2 + Q(1+I*2)
         END DO
         D1 = ENU*D1
         T1 = ENU*T1
         F1 = DLOG(ARG)
         F0 = A + ENU*(P(8)-ENU*(D1+D2)/(T1+T2)) - F1
         P0 = DEXP(ENU*F0)
         Q0 = DEXP((-ENU*(A - ENU*(P(8)+ENU*(D1-D2)/(T1-T2))-F1)))
         D1 = 0.D0
         T1 = 0.D0
         DO I = 1, 4
            D1 = C*D1 + R(I)
         END DO
         DO I = 1, 4
            T1 = C*T1 + S(I)
         END DO
         F1 = ENU*F0
         F1 = F1*F1
         IF (F1 <= 1.3D0) THEN
            D2 = 0.D0
            DO I = 1, 7
               D2 = F1*D2 + T(I)
            END DO
            D2 = F0 + F0*F1*D2
         ELSE
            D2 = (DEXP(ENU*F0) - DEXP((-ENU*F0)))*.5D0
            D2 = D2/ENU
         ENDIF
         F0 = D2 - ENU*D1/((1.D0 + C*T1)*P0)
         IF (EX <= 1.D-10) THEN
C                                  X.LE.1.0E-10
C                                    CALCULATION OF K(ENU,X) AND
C                                    X*K(ENU+1,X)/K(ENU,X)
            BK(1) = F0 + ARG*F0
            RATIO = P0/F0
            C = ARG*DMAX
            IF (K == 0) GO TO 55
C                                  CALCULATION OF K(ORDER,X) AND
C                                    X*K(ORDER+1,X)/K(ORDER,X)
C                                    FOR ORDER .GE. 1/2
            DO I = 1, K
               TEMP = C/RATIO
               IF (BK(1) >= TEMP) GO TO 45
               BK(1) = RATIO*BK(1)/ARG
               TWONU = TWONU + 2.D0
               RATIO = TWONU
            END DO
            GO TO 55
   45       CONTINUE
            IER = 130
            BK(:N) = XINF
            GO TO 9000
   55       CONTINUE
            IF (N == 1) GO TO 9005
C                                  CALCULATION OF
C                                    K(ORDER+L,X)/K(ORDER+L-1,X)
C                                    FOR L = 1, 2,. . ., N
            DO I = 2, N
               IF (RATIO >= C) GO TO 65
               BK(I) = RATIO/ARG
               TWONU = TWONU + 2.D0
               RATIO = TWONU
            END DO
            JER = 1
            GO TO 140
   65       CONTINUE
            BK(2:N) = XINF
            IER = 131
            GO TO 9000
C                                  1.0E-10 .LT. X .LE. 1.0
         ENDIF
         C = 1.D0
         X2BY4 = 0.25D0*ARG*ARG
         P0 = 0.5D0*P0
         Q0 = 0.5D0*Q0
         D1 = -1.D0
         D2 = 0.D0
         BK1 = 0.D0
         BK2 = 0.D0
         F1 = F0
         F2 = P0
         D1 = D1 + 2.D0
         D2 = D2 + 1.D0
         D3 = D1 + D3
         C = X2BY4*C/D2
         F0 = (D2*F0 + P0 + Q0)/D3
         P0 = P0/(D2 - ENU)
         Q0 = Q0/(D2 + ENU)
         T1 = C*F0
         T2 = C*(P0 - D2*F0)
         BK1 = BK1 + T1
         BK2 = BK2 + T2
         TEMP = DABS(T1/(F1 + BK1))
         TEMP2 = DABS(T2/(F2 + BK2))
         DO WHILE(TEMP>TOL .OR. TEMP2>TOL)
            D1 = D1 + 2.D0
            D2 = D2 + 1.D0
            D3 = D1 + D3
            C = X2BY4*C/D2
            F0 = (D2*F0 + P0 + Q0)/D3
            P0 = P0/(D2 - ENU)
            Q0 = Q0/(D2 + ENU)
            T1 = C*F0
            T2 = C*(P0 - D2*F0)
            BK1 = BK1 + T1
            BK2 = BK2 + T2
            TEMP = DABS(T1/(F1 + BK1))
            TEMP2 = DABS(T2/(F2 + BK2))
         END DO
         D1 = DEXP((-ARG))
         BK1 = (F1 + BK1)/D1
         BK2 = 2.D0*(F2 + BK2)/(ARG*D1)
         DMINF = 24.67D0*EX + 3.57D0
      ELSE
C                                  X .GT. 1.0
         TWOX = ARG + ARG
         ALPHA = 0.D0
         RATIO = 0.D0
         IF (EX <= 4.D0) THEN
C                                  1.0 .LT. X .LE. 4.0
C                                    CALCULATION OF K(ENU+1,X)/K(ENU,X)
            M = 52.0583D0/EX + 5.7607D0
            D2 = M
            D1 = D2 + D2
            D2 = D2 - 0.5D0
            D2 = D2*D2
            DO I = 2, M
               D1 = D1 - 2.D0
               D2 = D2 - D1
               RATIO = (D3 + D2)/(TWOX + D1 - RATIO)
            END DO
C                                  CALCULATION OF I(ABS(ENU),X) AND
C                                    I(ABS(ENU)+1,X) BY BACKWARD
C                                    RECURRENCE AND K(ENU,X) FROM THE
C                                    WRONSKIAN
            M = 2.7782D0*EX + 14.4303D0
            C = DABS(ENU)
            D3 = C + C
            D1 = D3 - 1.D0
            D2 = M
            F1 = DMIN
            F0 = (2.D0*(C + D2)/ARG + 0.5D0*ARG/(C + D2 + 1.D0))*DMIN
            DO I = 3, M
               D2 = D2 - 1.D0
               F2 = (D3 + D2 + D2)*F0
               ALPHA = (1.D0 + D1/D2)*(F2 + ALPHA)
               F2 = F2/ARG + F1
               F1 = F0
               F0 = F2
            END DO
            F1 = (D3 + 2.D0)*F0/ARG + F1
            D1 = 0.D0
            T1 = 1.D0
            DO I = 1, 7
               D1 = C*D1 + P(I)
            END DO
            DO I = 1, 7
               T1 = C*T1 + Q(I)
            END DO
            P0 = DEXP(C*(A + C*(P(8)-C*D1/T1)-DLOG(ARG)))/ARG
            F2 = (C + 0.5D0 - RATIO)*F1/ARG
            BK1 = P0 + (D3*F0 - F2 + F0 + ALPHA)/(F2 + F1 + F0)*P0
            DMINF = 4.263D0*EX + 23.977D0
         ELSE
C                                  X .GT. 4.0
C                                    CALCULATION OF K(ENU,X) AND
C                                    K(ENU+1,X)/K(ENU,X) BY BACKWARD
C                                    RECURRENCE
            M = 185.3004D0/EX + 9.3715D0
            DM = M
            D2 = DM - 0.5D0
            D2 = D2*D2
            D1 = DM + DM
            DO I = 2, M
               DM = DM - 1.D0
               D1 = D1 - 2.D0
               D2 = D2 - D1
               RATIO = (D3 + D2)/(TWOX + D1 - RATIO)
               ALPHA = (RATIO + RATIO*ALPHA)/DM
            END DO
            BK1 = 1.D0/((D + D*ALPHA)*DSQRT(ARG))
            DMINF = 0.94219D0*(EX - DABS(EX - 20.D0)) + 52.3363D0
C
C                                  CALCULATION OF K(ENU+1,X) FROM
C                                    K(ENU,X) AND K(ENU+1,X)/K(ENU,X)
         ENDIF
         BK2 = BK1 + BK1*(ENU + 0.5D0 - RATIO)/ARG
C
C                                  CALCULATION OF  IER , K(ORDER+I,X),
C                                    I = 0, 1, . . ., IER-1, ..
C                                    K(ORDER+I,X)/K(ORDER+I-1,X),
C                                    I = IER, IER+1, . . ., N
      ENDIF
      BK(1) = BK1
      IF (IEND == 0) GO TO 9005
      J = 2 - K
      IF (J > 0) BK(J) = BK2
      IF (IEND == 1) GO TO 9005
      M = DMINF - ENU
      M = MIN0(IEND,M)
      DO I = 2, M
         T1 = BK1
         BK1 = BK2
         TWONU = TWONU + 2.D0
         BK2 = TWONU/ARG*BK1 + T1
         J = J + 1
         IF (J > 0) BK(J) = BK2
      END DO
      IF (M == IEND) GO TO 9005
      RATIO = BK2/BK1
      MPLUS1 = M + 1
      IER = 130
      KK = 1
      DO I = MPLUS1, IEND
         TWONU = TWONU + 2.D0
         RATIO = TWONU/ARG + 1.D0/RATIO
         J = J + 1
         IF (J > 1) THEN
            BK(J) = RATIO
         ELSE
            TEMP = DMAX/RATIO
            IF (BK2 >= TEMP) GO TO 155
            BK2 = RATIO*BK2
         ENDIF
      END DO
      JER = MPLUS1 - K
      IF (JER <= 0) JER = 1
      IF (JER == 1) BK(1) = BK2
      IF (N == 1) GO TO 9005
  140 CONTINUE
      J = JER + 1
      DO I = J, N
         IER = 131 + I
         TEMP = DMAX/BK(I)
         IF (BK(I-1) >= TEMP) GO TO 150
         BK(I) = BK(I-1)*BK(I)
      END DO
      IER = 0
      GO TO 9005
  150 CONTINUE
      KK = IER - 131
  155 CONTINUE
      BK(KK:N) = XINF
 9000 CONTINUE
      CALL UERTST (IER, 6HMMBSKR)
 9005 CONTINUE
      RETURN 
      END SUBROUTINE MMBSKR
C   IMSL ROUTINE NAME   - UERTST
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JUNE 1, 1982
C
C   PURPOSE             - PRINT A MESSAGE REFLECTING AN ERROR CONDITION
C
C   USAGE               - CALL UERTST (IER,NAME)
C
C   ARGUMENTS    IER    - ERROR PARAMETER. (INPUT)
C                           IER = I+J WHERE
C                             I = 128 IMPLIES TERMINAL ERROR MESSAGE,
C                             I =  64 IMPLIES WARNING WITH FIX MESSAGE,
C                             I =  32 IMPLIES WARNING MESSAGE.
C                             J = ERROR CODE RELEVANT TO CALLING
C                                 ROUTINE.
C                NAME   - A CHARACTER STRING OF LENGTH SIX PROVIDING
C                           THE NAME OF THE CALLING ROUTINE. (INPUT)
C
C   PRECISION/HARDWARE  - SINGLE/ALL
C
C   REQD. IMSL ROUTINES - UGETIO,USPKD
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   REMARKS      THE ERROR MESSAGE PRODUCED BY UERTST IS WRITTEN
C                TO THE STANDARD OUTPUT UNIT. THE OUTPUT UNIT
C                NUMBER CAN BE DETERMINED BY CALLING UGETIO AS
C                FOLLOWS..   CALL UGETIO(1,NIN,NOUT).
C                THE OUTPUT UNIT NUMBER CAN BE CHANGED BY CALLING
C                UGETIO AS FOLLOWS..
C                                NIN = 0
C                                NOUT = NEW OUTPUT UNIT NUMBER
C                                CALL UGETIO(3,NIN,NOUT)
C                SEE THE UGETIO DOCUMENT FOR MORE DETAILS.
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE UERTST(IER, NAME)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:53:12   6/14/01  
C...Switches: -p4 -yb
      IMPLICIT NONE
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      INTEGER IER
      INTEGER, DIMENSION(1) :: NAME
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      INTEGER :: I, IEQ, IEQDF, IOUNIT, LEVEL, LEVOLD
      INTEGER, DIMENSION(6) :: NAMEQ, NAMSET, NAMUPK
      INTEGER :: NIN, NMTB
C-----------------------------------------------
C   E x t e r n a l   F u n c t i o n s
C-----------------------------------------------
      REAL , EXTERNAL :: WRITE
C-----------------------------------------------
C                                  SPECIFICATIONS FOR ARGUMENTS
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      DATA NAMSET/1HU, 1HE, 1HR, 1HS, 1HE, 1HT/
      DATA NAMEQ/6*1H /
      DATA LEVEL/4/
      DATA IEQDF/0/
      DATA IEQ/1H=/
C                                  UNPACK NAME INTO NAMUPK
C                                  FIRST EXECUTABLE STATEMENT
      CALL USPKD (NAME, 6, NAMUPK, NMTB)
C                                  GET OUTPUT UNIT NUMBER
      CALL UGETIO (1, NIN, IOUNIT)
C                                  CHECK IER
      IF (IER > 999) GO TO 25
      IF (IER < (-32)) GO TO 55
      IF (IER > 128) THEN
         IF (LEVEL < 1) GO TO 30
C                                  PRINT TERMINAL MESSAGE
         IF (IEQDF == 1) WRITE (IOUNIT, 35) IER, NAMEQ, IEQ, NAMUPK
         IF (IEQDF == 0) WRITE (IOUNIT, 35) IER, NAMUPK
         GO TO 30
      ENDIF
      IF (IER > 64) THEN
         IF (LEVEL < 2) GO TO 30
C                                  PRINT WARNING WITH FIX MESSAGE
         IF (IEQDF == 1) WRITE (IOUNIT, 40) IER, NAMEQ, IEQ, NAMUPK
         IF (IEQDF == 0) WRITE (IOUNIT, 40) IER, NAMUPK
         GO TO 30
      ENDIF
      IF (IER > 32) THEN
C                                  PRINT WARNING MESSAGE
         IF (LEVEL < 3) GO TO 30
         IF (IEQDF == 1) WRITE (IOUNIT, 45) IER, NAMEQ, IEQ, NAMUPK
         IF (IEQDF == 0) WRITE (IOUNIT, 45) IER, NAMUPK
         GO TO 30
      ENDIF
C                                  CHECK FOR UERSET CALL
      DO I = 1, 6
         IF (NAMUPK(I) /= NAMSET(I)) GO TO 25
      END DO
      LEVOLD = LEVEL
      LEVEL = IER
      IER = LEVOLD
      IF (LEVEL < 0) LEVEL = 4
      LEVEL = MIN0(4,LEVEL)
      GO TO 30
   25 CONTINUE
      IF (LEVEL >= 4) THEN
C                                  PRINT NON-DEFINED MESSAGE
         IF (IEQDF == 1) WRITE (IOUNIT, 50) IER, NAMEQ, IEQ, NAMUPK
         IF (IEQDF == 0) WRITE (IOUNIT, 50) IER, NAMUPK
      ENDIF
   30 CONTINUE
      IEQDF = 0
      RETURN 
   35 FORMAT(' *** TERMINAL ERROR',10X,'(IER = ',I3,
     1   ') FROM IMSL ROUTINE ',6A1,A1,6A1)
   40 FORMAT(' *** WARNING WITH FIX ERROR',2X,'(IER = ',I3,
     1   ') FROM IMSL ROUTINE ',6A1,A1,6A1)
   45 FORMAT(' *** WARNING ERROR',11X,'(IER = ',I3,
     1   ') FROM IMSL ROUTINE ',6A1,A1,6A1)
   50 FORMAT(' *** UNDEFINED ERROR',9X,'(IER = ',I5,
     1   ') FROM IMSL ROUTINE ',6A1,A1,6A1)
C
C                                  SAVE P FOR P = R CASE
C                                    P IS THE PAGE NAMUPK
C                                    R IS THE ROUTINE NAMUPK
   55 CONTINUE
      IEQDF = 1
      NAMEQ = NAMUPK
      RETURN 
      END SUBROUTINE UERTST
C   IMSL ROUTINE NAME   - UGETIO
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JUNE 1, 1981
C
C   PURPOSE             - TO RETRIEVE CURRENT VALUES AND TO SET NEW
C                           VALUES FOR INPUT AND OUTPUT UNIT
C                           IDENTIFIERS.
C
C   USAGE               - CALL UGETIO(IOPT,NIN,NOUT)
C
C   ARGUMENTS    IOPT   - OPTION PARAMETER. (INPUT)
C                           IF IOPT=1, THE CURRENT INPUT AND OUTPUT
C                           UNIT IDENTIFIER VALUES ARE RETURNED IN NIN
C                           AND NOUT, RESPECTIVELY.
C                           IF IOPT=2, THE INTERNAL VALUE OF NIN IS
C                           RESET FOR SUBSEQUENT USE.
C                           IF IOPT=3, THE INTERNAL VALUE OF NOUT IS
C                           RESET FOR SUBSEQUENT USE.
C                NIN    - INPUT UNIT IDENTIFIER.
C                           OUTPUT IF IOPT=1, INPUT IF IOPT=2.
C                NOUT   - OUTPUT UNIT IDENTIFIER.
C                           OUTPUT IF IOPT=1, INPUT IF IOPT=3.
C
C   PRECISION/HARDWARE  - SINGLE/ALL
C
C   REQD. IMSL ROUTINES - NONE REQUIRED
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   REMARKS      EACH IMSL ROUTINE THAT PERFORMS INPUT AND/OR OUTPUT
C                OPERATIONS CALLS UGETIO TO OBTAIN THE CURRENT UNIT
C                IDENTIFIER VALUES. IF UGETIO IS CALLED WITH IOPT=2 OR
C                IOPT=3, NEW UNIT IDENTIFIER VALUES ARE ESTABLISHED.
C                SUBSEQUENT INPUT/OUTPUT IS PERFORMED ON THE NEW UNITS.
C
C   COPYRIGHT           - 1978 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE UGETIO(IOPT, NIN, NOUT)
C...Translated by Pacific-Sierra Research VAST-90 2.06G2  10:53:12   6/14/01  
C...Switches: -p4 -yb
      IMPLICIT NONE
C-----------------------------------------------
C   D u m m y   A r g u m e n t s
C-----------------------------------------------
      INTEGER IOPT, NIN, NOUT
C-----------------------------------------------
C   L o c a l   V a r i a b l e s
C-----------------------------------------------
      INTEGER :: NIND, NOUTD
C-----------------------------------------------
C                                  SPECIFICATIONS FOR ARGUMENTS
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      DATA NIND/1/
      DATA NOUTD/2/
C                                  FIRST EXECUTABLE STATEMENT
      IF (IOPT /= 3) THEN
         IF (IOPT /= 2) THEN
            IF (IOPT /= 1) GO TO 9005
            NIN = NIND
            NOUT = NOUTD
            GO TO 9005
         ENDIF
         NIND = NIN
         GO TO 9005
      ENDIF
      NOUTD = NOUT
 9005 CONTINUE
      RETURN 
      END SUBROUTINE UGETIO
C   IMSL ROUTINE NAME   - USPKD
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - NOVEMBER 1, 1984
C
C   PURPOSE             - NUCLEUS CALLED BY IMSL ROUTINES THAT HAVE
C                           CHARACTER STRING ARGUMENTS
C
C   USAGE               - CALL USPKD  (PACKED,NCHARS,UNPAKD,NCHMTB)
C
C   ARGUMENTS    PACKED - CHARACTER STRING TO BE UNPACKED.(INPUT)
C                NCHARS - LENGTH OF PACKED. (INPUT)  SEE REMARKS.
C                UNPAKD - INTEGER ARRAY TO RECEIVE THE UNPACKED
C                         REPRESENTATION OF THE STRING. (OUTPUT)
C                NCHMTB - NCHARS MINUS TRAILING BLANKS. (OUTPUT)
C
C   PRECISION/HARDWARE  - SINGLE/ALL
C
C   REQD. IMSL ROUTINES - NONE
C
C   REMARKS  1.  USPKD UNPACKS A CHARACTER STRING INTO AN INTEGER ARRAY
C                IN (A1) FORMAT.
C            2.  UP TO 129 CHARACTERS MAY BE USED.  ANY IN EXCESS OF
C                THAT ARE IGNORED.
C
C   COPYRIGHT           - 1984 BY IMSL, INC.  ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE.  NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
      SUBROUTINE USPKD  (PACKED,NCHARS,UNPAKD,NCHMTB)
C                                  SPECIFICATIONS FOR ARGUMENTS
      INTEGER            NC,NCHARS,NCHMTB
C
      INTEGER            UNPAKD(1),IBLANK
      INTEGER            PACKED(1)
      DATA               IBLANK /1H /
C                                  INITIALIZE NCHMTB
      NCHMTB = 0
C                                  RETURN IF NCHARS IS LE ZERO
      IF(NCHARS.LE.0) RETURN
C                                  SET NC=NUMBER OF CHARS TO BE DECODED
      NC = MIN0 (129,NCHARS)
      DECODE (NC,150,PACKED) (UNPAKD(I),I=1,NC)
  150 FORMAT (129A1)
C                                  CHECK UNPAKD ARRAY AND SET NCHMTB
C                                  BASED ON TRAILING BLANKS FOUND
      DO 200 N = 1,NC
         NN = NC - N + 1
         IF(UNPAKD(NN) .NE. IBLANK) GO TO 210
  200 CONTINUE
      NN = 0
  210 NCHMTB = NN
      RETURN
      END

#include "fpreproc/library_names.h"
#include "fpreproc/f77_dcomplx.h"
#include "fpreproc/fp_const.h"
*DECK DBESI1
      FUNCTION DBESI1 (X)
C***BEGIN PROLOGUE  DBESI1
C***PURPOSE  Compute the modified (hyperbolic) Bessel function of the
C            first kind of order one.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C10B1
C***TYPE      REAL*8 (BESI1-S, DBESI1-D)
C***KEYWORDS  FIRST KIND, FNLIB, HYPERBOLIC BESSEL FUNCTION,
C             MODIFIED BESSEL FUNCTION, ORDER ONE, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DBESI1(X) calculates the double precision modified (hyperbolic)
C Bessel function of the first kind of order one and double precision
C argument X.
C
C Series for BI1        on the interval  0.          to  9.00000E+00
C                                        with weighted error   1.44E-32
C                                         log weighted error  31.84
C                               significant figures required  31.45
C                                    decimal places required  32.46
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, DBSI1E, DCSEVL, INITDS, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C***END PROLOGUE  DBESI1
C============
C idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER nti1,initds
C============
      REAL*8 DBESI1
      REAL*8 X, BI1CS(17), XMAX, XMIN, XSML, Y, D1MACH,
     1  DCSEVL, DBSI1E
      LOGICAL FIRST
      SAVE BI1CS, NTI1, XMIN, XSML, XMAX, FIRST
      DATA BI1CS(  1) / -CONST(.19717132610998597316138503218149,-2)/
      DATA BI1CS(  2) / +CONST(.40734887667546480608155393652014,+0)/
      DATA BI1CS(  3) / +CONST(.34838994299959455866245037783787,-1)/
      DATA BI1CS(  4) / +CONST(.15453945563001236038598401058489,-2)/
      DATA BI1CS(  5) / +CONST(.41888521098377784129458832004120,-4)/
      DATA BI1CS(  6) / +CONST(.76490267648362114741959703966069,-6)/
      DATA BI1CS(  7) / +CONST(.10042493924741178689179808037238,-7)/
      DATA BI1CS(  8) / +CONST(.99322077919238106481371298054863,-10)/
      DATA BI1CS(  9) / +CONST(.76638017918447637275200171681349,-12)/
      DATA BI1CS( 10) / +CONST(.47414189238167394980388091948160,-14)/
      DATA BI1CS( 11) / +CONST(.24041144040745181799863172032000,-16)/
      DATA BI1CS( 12) / +CONST(.10171505007093713649121100799999,-18)/
      DATA BI1CS( 13) / +CONST(.36450935657866949458491733333333,-21)/
      DATA BI1CS( 14) / +CONST(.11205749502562039344810666666666,-23)/
      DATA BI1CS( 15) / +CONST(.29875441934468088832000000000000,-26)/
      DATA BI1CS( 16) / +CONST(.69732310939194709333333333333333,-29)/
      DATA BI1CS( 17) / +CONST(.14367948220620800000000000000000,-31)/
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DBESI1
      IF (FIRST) THEN
         NTI1 = INITDS (BI1CS, 17, CONST(0.1,0)*AREAL(D1MACH(3)))
         XMIN = CONST(2.0,0)*D1MACH(1)
         XSML = SQRT(CONST(4.5,0)*D1MACH(3))
         XMAX = LOG (D1MACH(2))
      ENDIF
      FIRST = .FALSE.
C
      Y = ABS(X)
      IF (Y.GT.CONST(3.0,0)) GO TO 20
C
      DBESI1 = CONST(0.,0)
      IF (Y.EQ.CONST(0.,0))  RETURN
C
      IF (Y .LE. XMIN) CALL XERMSG ('SLATEC', 'DBESI1',
     +   'ABS(X) SO SMALL I1 UNDERFLOWS', 1, 1)
      IF (Y.GT.XMIN) DBESI1 = CONST(0.5,0)*X
      IF (Y.GT.XSML) DBESI1 = X*(CONST(0.875,0)+
     1   DCSEVL (Y*Y/CONST(4.5,0)-CONST(1.,0),
     1   BI1CS, NTI1))
      RETURN
C
 20   IF (Y .GT. XMAX) CALL XERMSG ('SLATEC', 'DBESI1',
     +   'ABS(X) SO BIG I1 OVERFLOWS', 2, 2)
C
      DBESI1 = EXP(Y) * DBSI1E(X)
C
      RETURN
      END
! 22Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 22Jun2000 fgtok
! 22Jun2000 fgtok
! 22Jun2000 fgtok

      FUNCTION DBESI1 (X)
C***BEGIN PROLOGUE  DBESI1
C***PURPOSE  Compute the modified (hyperbolic) Bessel function of the
C            first kind of order one.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C10B1
C***TYPE      real(kind=dp) (BESI1-S, DBESI1-D)
C***KEYWORDS  FIRST KIND, FNLIB, HYPERBOLIC BESSEL FUNCTION,
C             MODIFIED BESSEL FUNCTION, ORDER ONE, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DBESI1(X) calculates the double precision modified (hyperbolic)
C Bessel function of the first kind of order one and double precision
C argument X.
C
C Series for BI1        on the interval  0.          to  9.00000E+00
C                                        with weighted error   1.44E-32
C                                         log weighted error  31.84
C                               significant figures required  31.45
C                                    decimal places required  32.46
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, DBSI1E, DCSEVL, INITDS, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C***END PROLOGUE  DBESI1
C============
C idecl:  explicitize implicit INTEGER declarations:
      use kind_spec

      IMPLICIT NONE
      INTEGER nti1,initds
C============
      real(kind=dp) DBESI1
      real(kind=dp) X, BI1CS(17), XMAX, XMIN, XSML, Y, D1MACH,
     1  DCSEVL, DBSI1E
      LOGICAL FIRST
      SAVE BI1CS, NTI1, XMIN, XSML, XMAX, FIRST
      DATA BI1CS(  1) / -.19717132610998597316138503218149E-2_dp/

      DATA BI1CS(  2) / +.40734887667546480608155393652014E+0_dp/

      DATA BI1CS(  3) / +.34838994299959455866245037783787E-1_dp/

      DATA BI1CS(  4) / +.15453945563001236038598401058489E-2_dp/

      DATA BI1CS(  5) / +.41888521098377784129458832004120E-4_dp/

      DATA BI1CS(  6) / +.76490267648362114741959703966069E-6_dp/

      DATA BI1CS(  7) / +.10042493924741178689179808037238E-7_dp/

      DATA BI1CS(  8) / +.99322077919238106481371298054863E-10_dp/

      DATA BI1CS(  9) / +.76638017918447637275200171681349E-12_dp/

      DATA BI1CS( 10) / +.47414189238167394980388091948160E-14_dp/

      DATA BI1CS( 11) / +.24041144040745181799863172032000E-16_dp/

      DATA BI1CS( 12) / +.10171505007093713649121100799999E-18_dp/

      DATA BI1CS( 13) / +.36450935657866949458491733333333E-21_dp/

      DATA BI1CS( 14) / +.11205749502562039344810666666666E-23_dp/

      DATA BI1CS( 15) / +.29875441934468088832000000000000E-26_dp/

      DATA BI1CS( 16) / +.69732310939194709333333333333333E-29_dp/

      DATA BI1CS( 17) / +.14367948220620800000000000000000E-31_dp/

      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DBESI1
      IF (FIRST) THEN
         NTI1 = INITDS (BI1CS, 17, 0.1E0_dp*(d1mach3))

         XMIN = 2.0E0_dp*d1mach1

         XSML = SQRT(4.5E0_dp*d1mach3)

         XMAX = LOG (d1mach2)
      ENDIF
      FIRST = .FALSE.
C
      Y = ABS(X)
      IF (Y.GT.3.0E0_dp) GO TO 20

C
      DBESI1 = 0.E0_dp

      IF (Y.EQ.0.E0_dp)  RETURN

C
      IF (Y .LE. XMIN) CALL XERMSG ('SLATEC', 'DBESI1',
     +   'ABS(X) SO SMALL I1 UNDERFLOWS', 1, 1)
      IF (Y.GT.XMIN) DBESI1 = 0.5E0_dp*X

      IF (Y.GT.XSML) DBESI1 = X*(0.875E0_dp+

     1   DCSEVL (Y*Y/4.5E0_dp-1.E0_dp,

     1   BI1CS, NTI1))
      RETURN
C
 20   IF (Y .GT. XMAX) CALL XERMSG ('SLATEC', 'DBESI1',
     +   'ABS(X) SO BIG I1 OVERFLOWS', 2, 2)
C
      DBESI1 = EXP(Y) * DBSI1E(X)
C
      RETURN
      END
! 22Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 22Jun2000 fgtok
! 22Jun2000 fgtok
! 22Jun2000 fgtok

C   IMSL ROUTINE NAME   - LEQT2F
C
C-----------------------------------------------------------------------
C
C   COMPUTER            - VAX/SINGLE
C
C   LATEST REVISION     - JUNE 1, 1982
C
C   PURPOSE             - LINEAR EQUATION SOLUTION - FULL STORAGE
C                           MODE - HIGH ACCURACY SOLUTION
C
C   USAGE               - CALL LEQT2F (A,M,N,IA,B,IDGT,WKAREA,IER)
C
C   ARGUMENTS    A      - INPUT MATRIX OF DIMENSION N BY N CONTAINING
C                           THE COEFFICIENT MATRIX OF THE EQUATION
C                           AX = B.
C                M      - NUMBER OF RIGHT-HAND SIDES. (INPUT)
C                N      - ORDER OF A AND NUMBER OF ROWS IN B. (INPUT)
C                IA     - ROW DIMENSION OF A AND B EXACTLY AS SPECIFIED
C                           IN THE DIMENSION STATEMENT IN THE CALLING
C                           PROGRAM. (INPUT)
C                B      - INPUT MATRIX OF DIMENSION N BY M CONTAINING
C                           THE RIGHT-HAND SIDES OF THE EQUATION AX = B.
C                           ON OUTPUT, THE N BY M MATRIX OF SOLUTIONS
C                           REPLACES B.
C                IDGT   - INPUT OPTION.
C                         IF IDGT IS GREATER THAN 0, THE ELEMENTS OF
C                           A AND B ARE ASSUMED TO BE CORRECT TO IDGT
C                           DECIMAL DIGITS AND THE ROUTINE PERFORMS
C                           AN ACCURACY TEST.
C                         IF IDGT EQUALS 0, THE ACCURACY TEST IS
C                           BYPASSED.
C                         ON OUTPUT, IDGT CONTAINS THE APPROXIMATE
C                           NUMBER OF DIGITS IN THE ANSWER WHICH
C                           WERE UNCHANGED AFTER IMPROVEMENT.
C                WKAREA - WORK AREA OF DIMENSION GREATER THAN OR EQUAL
C                           TO N**2+3N.
C                IER    - ERROR PARAMETER. (OUTPUT)
C                         WARNING ERROR
C                           IER = 34 INDICATES THAT THE ACCURACY TEST
C                             FAILED. THE COMPUTED SOLUTION MAY BE IN
C                             ERROR BY MORE THAN CAN BE ACCOUNTED FOR
C                             BY THE UNCERTAINTY OF THE DATA. THIS
C                             WARNING CAN BE PRODUCED ONLY IF IDGT IS
C                             GREATER THAN 0 ON INPUT. (SEE THE
C                             CHAPTER L PRELUDE FOR FURTHER DISCUSSION.)
C                         TERMINAL ERROR
C                           IER = 129 INDICATES THAT THE MATRIX IS
C                             ALGORITHMICALLY SINGULAR. (SEE THE
C                             CHAPTER L PRELUDE).
C                           IER = 131 INDICATES THAT THE MATRIX IS TOO
C                             ILL-CONDITIONED FOR ITERATIVE IMPROVEMENT
C                             TO BE EFFECTIVE.
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - SINGLE/LUDATN,LUELMN,LUREFN,UERTST,UGETIO
C                       - DOUBLE/LUDATN,LUELMN,LUREFN,UERTST,UGETIO,
C                           VXADD,VXMUL,VXSTO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1982 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE LEQT2F (A,M,N,IA,B,IDGT,WKAREA,IER)
C
      DIMENSION          A(IA,1),B(IA,1),WKAREA(1)
C                                  FIRST EXECUTABLE STATEMENT
C                                  INITIALIZE IER
      IER=0
      JER=0
      J = N*N+1
      K = J+N
      MM = K+N
      KK = 0
      MM1 = MM-1
      JJ=1
      DO 5 L=1,N
         DO 5 I=1,N
            WKAREA(JJ)=A(I,L)
            JJ=JJ+1
    5 CONTINUE
C                                  DECOMPOSE A
      CALL LUDATN (WKAREA,N,N,A,IA,IDGT,D1,D2,WKAREA(J),WKAREA(K),
     *             WA,IER)
      IF (IER.GT.128) GO TO 25
      IF (IDGT .EQ. 0 .OR. IER .NE. 0) KK = 1
      DO 15 I = 1,M
C                                  PERFORMS THE ELIMINATION PART OF
C                                  AX = B
         CALL LUELMN (A,IA,N,B(1,I),WKAREA(J),WKAREA(MM))
C                                  REFINEMENT OF SOLUTION TO AX = B
         IF (KK .NE. 0)
     *   CALL LUREFN (WKAREA,N,N,A,IA,B(1,I),IDGT,WKAREA(J),WKAREA(MM),
     *                WKAREA(K),WKAREA(K),JER)
         DO 10 II=1,N
            B(II,I) = WKAREA(MM1+II)
   10    CONTINUE
         IF (JER.NE.0) GO TO 20
   15 CONTINUE
      GO TO 25
   20 IER = 131
   25 JJ=1
      DO 30 J = 1,N
         DO 30 I = 1,N
            A(I,J)=WKAREA(JJ)
            JJ=JJ+1
   30 CONTINUE
      IF (IER .EQ. 0) GO TO 9005
 9000 CONTINUE
      CALL UERTST (IER,'LEQT2F')
 9005 RETURN
      END
